""" Cisco_IOS_XR_mpls_lsd_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR mpls\-lsd package operational data.

This module contains definitions
for the following management objects\:
  mpls\-lsd\-nodes\: Location MPLS LSD operational data
  mpls\-lsd\: mpls lsd

Copyright (c) 2013\-2016 by Cisco Systems, Inc.
All rights reserved.

"""
from ydk.entity_utils import get_relative_entity_path as _get_relative_entity_path
from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YPYError, YPYModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error


class MgmtLsdApp(Enum):
    """
    MgmtLsdApp

    Mgmt lsd app

    .. data:: mgmt_lsd_app_type_none = 0

    	None

    .. data:: mgmt_lsd_app_type_int = 1

    	LSD

    .. data:: mgmt_lsd_app_type_test = 2

    	Test

    .. data:: mgmt_lsd_app_type_static = 3

    	Static

    .. data:: mgmt_lsd_app_type_ldp = 4

    	LDP

    .. data:: mgmt_lsd_app_type_te = 5

    	TE Control

    .. data:: mgmt_lsd_app_type_app_controller = 6

    	App Controller

    .. data:: mgmt_lsd_app_type_bgp_ipv4 = 7

    	BGP v4

    .. data:: mgmt_lsd_app_type_bgp_vpn_ipv4 = 8

    	BGP VPNv4

    .. data:: mgmt_lsd_app_type_l2vpn = 9

    	L2VPN

    .. data:: mgmt_lsd_app_type_bgp_spkr = 10

    	BGP Spkr

    .. data:: mgmt_lsd_app_type_bfd = 11

    	BFD

    .. data:: mgmt_lsd_app_type_pim = 12

    	PIM

    .. data:: mgmt_lsd_app_type_v2_lsd = 13

    	V2 LSD

    .. data:: mgmt_lsd_app_type_pim6 = 14

    	PIM6

    .. data:: mgmt_lsd_app_type_isis = 15

    	ISIS

    .. data:: mgmt_lsd_app_type_ospf = 16

    	OSPF

    .. data:: mgmt_lsd_app_type_cgn = 17

    	CGN

    .. data:: mgmt_lsd_app_type_dmtc = 18

    	Traffic Collector

    .. data:: mgmt_lsd_app_type_any = 19

    	Any

    """

    mgmt_lsd_app_type_none = Enum.YLeaf(0, "mgmt-lsd-app-type-none")

    mgmt_lsd_app_type_int = Enum.YLeaf(1, "mgmt-lsd-app-type-int")

    mgmt_lsd_app_type_test = Enum.YLeaf(2, "mgmt-lsd-app-type-test")

    mgmt_lsd_app_type_static = Enum.YLeaf(3, "mgmt-lsd-app-type-static")

    mgmt_lsd_app_type_ldp = Enum.YLeaf(4, "mgmt-lsd-app-type-ldp")

    mgmt_lsd_app_type_te = Enum.YLeaf(5, "mgmt-lsd-app-type-te")

    mgmt_lsd_app_type_app_controller = Enum.YLeaf(6, "mgmt-lsd-app-type-app-controller")

    mgmt_lsd_app_type_bgp_ipv4 = Enum.YLeaf(7, "mgmt-lsd-app-type-bgp-ipv4")

    mgmt_lsd_app_type_bgp_vpn_ipv4 = Enum.YLeaf(8, "mgmt-lsd-app-type-bgp-vpn-ipv4")

    mgmt_lsd_app_type_l2vpn = Enum.YLeaf(9, "mgmt-lsd-app-type-l2vpn")

    mgmt_lsd_app_type_bgp_spkr = Enum.YLeaf(10, "mgmt-lsd-app-type-bgp-spkr")

    mgmt_lsd_app_type_bfd = Enum.YLeaf(11, "mgmt-lsd-app-type-bfd")

    mgmt_lsd_app_type_pim = Enum.YLeaf(12, "mgmt-lsd-app-type-pim")

    mgmt_lsd_app_type_v2_lsd = Enum.YLeaf(13, "mgmt-lsd-app-type-v2-lsd")

    mgmt_lsd_app_type_pim6 = Enum.YLeaf(14, "mgmt-lsd-app-type-pim6")

    mgmt_lsd_app_type_isis = Enum.YLeaf(15, "mgmt-lsd-app-type-isis")

    mgmt_lsd_app_type_ospf = Enum.YLeaf(16, "mgmt-lsd-app-type-ospf")

    mgmt_lsd_app_type_cgn = Enum.YLeaf(17, "mgmt-lsd-app-type-cgn")

    mgmt_lsd_app_type_dmtc = Enum.YLeaf(18, "mgmt-lsd-app-type-dmtc")

    mgmt_lsd_app_type_any = Enum.YLeaf(19, "mgmt-lsd-app-type-any")


class MgmtLsdAppRsrcState(Enum):
    """
    MgmtLsdAppRsrcState

    Mgmt lsd app rsrc state

    .. data:: mgmt_lsd_app_rsrc_state_active = 0

    	Active

    .. data:: mgmt_lsd_app_rsrc_state_pnd = 1

    	Pending

    .. data:: mgmt_lsd_app_rsrc_state_pnd_svr = 2

    	Pending Server

    """

    mgmt_lsd_app_rsrc_state_active = Enum.YLeaf(0, "mgmt-lsd-app-rsrc-state-active")

    mgmt_lsd_app_rsrc_state_pnd = Enum.YLeaf(1, "mgmt-lsd-app-rsrc-state-pnd")

    mgmt_lsd_app_rsrc_state_pnd_svr = Enum.YLeaf(2, "mgmt-lsd-app-rsrc-state-pnd-svr")


class MgmtLsdAppState(Enum):
    """
    MgmtLsdAppState

    Mgmt lsd app state

    .. data:: mgmt_lsd_app_state_active = 0

    	Active

    .. data:: mgmt_lsd_app_state_zombie = 1

    	Zombie

    .. data:: mgmt_lsd_app_state_recover = 2

    	Recover

    """

    mgmt_lsd_app_state_active = Enum.YLeaf(0, "mgmt-lsd-app-state-active")

    mgmt_lsd_app_state_zombie = Enum.YLeaf(1, "mgmt-lsd-app-state-zombie")

    mgmt_lsd_app_state_recover = Enum.YLeaf(2, "mgmt-lsd-app-state-recover")


class MgmtLsdClient(Enum):
    """
    MgmtLsdClient

    Mgmt lsd client

    .. data:: mgmt_lsd_client_type_app = 0

    	Application

    .. data:: mgmt_lsd_client_type_ba = 1

    	BCDL Agent

    """

    mgmt_lsd_client_type_app = Enum.YLeaf(0, "mgmt-lsd-client-type-app")

    mgmt_lsd_client_type_ba = Enum.YLeaf(1, "mgmt-lsd-client-type-ba")


class MgmtLsdFpi(Enum):
    """
    MgmtLsdFpi

    Mgmt lsd fpi

    .. data:: mgmt_lsd_fpi_type_label = 0

    	Label

    .. data:: mgmt_lsd_fpi_type_te = 1

    	TE

    .. data:: mgmt_lsd_fpi_type_ipv4 = 2

    	IPv4

    .. data:: mgmt_lsd_fpi_type_ipv6 = 3

    	IPv6

    .. data:: mgmt_lsd_fpi_type_pw_list = 4

    	PW List

    .. data:: mgmt_lsd_fpi_type_te_v2 = 5

    	TE v2

    .. data:: mgmt_lsd_fpi_type_dmtc_ext_intf = 6

    	DMTC External Interface

    """

    mgmt_lsd_fpi_type_label = Enum.YLeaf(0, "mgmt-lsd-fpi-type-label")

    mgmt_lsd_fpi_type_te = Enum.YLeaf(1, "mgmt-lsd-fpi-type-te")

    mgmt_lsd_fpi_type_ipv4 = Enum.YLeaf(2, "mgmt-lsd-fpi-type-ipv4")

    mgmt_lsd_fpi_type_ipv6 = Enum.YLeaf(3, "mgmt-lsd-fpi-type-ipv6")

    mgmt_lsd_fpi_type_pw_list = Enum.YLeaf(4, "mgmt-lsd-fpi-type-pw-list")

    mgmt_lsd_fpi_type_te_v2 = Enum.YLeaf(5, "mgmt-lsd-fpi-type-te-v2")

    mgmt_lsd_fpi_type_dmtc_ext_intf = Enum.YLeaf(6, "mgmt-lsd-fpi-type-dmtc-ext-intf")


class MgmtLsdFrrState(Enum):
    """
    MgmtLsdFrrState

    Mgmt lsd frr state

    .. data:: mgmt_lsd_frr_state_partial = 0

    	Partial

    .. data:: mgmt_lsd_frr_state_active = 1

    	Active

    .. data:: mgmt_lsd_frr_state_ready = 2

    	Ready

    .. data:: mgmt_lsd_frr_state_complete = 3

    	Complete

    .. data:: mgmt_lsd_frr_state_any = 4

    	Any

    .. data:: mgmt_lsd_frr_state_igp = 5

    	IGP

    """

    mgmt_lsd_frr_state_partial = Enum.YLeaf(0, "mgmt-lsd-frr-state-partial")

    mgmt_lsd_frr_state_active = Enum.YLeaf(1, "mgmt-lsd-frr-state-active")

    mgmt_lsd_frr_state_ready = Enum.YLeaf(2, "mgmt-lsd-frr-state-ready")

    mgmt_lsd_frr_state_complete = Enum.YLeaf(3, "mgmt-lsd-frr-state-complete")

    mgmt_lsd_frr_state_any = Enum.YLeaf(4, "mgmt-lsd-frr-state-any")

    mgmt_lsd_frr_state_igp = Enum.YLeaf(5, "mgmt-lsd-frr-state-igp")


class MgmtLsdIntfState(Enum):
    """
    MgmtLsdIntfState

    Mgmt lsd intf state

    .. data:: mgmt_lsd_intf_state_unknown = 0

    	unknown

    .. data:: mgmt_lsd_intf_state_up = 1

    	up

    .. data:: mgmt_lsd_intf_state_down = 2

    	down

    """

    mgmt_lsd_intf_state_unknown = Enum.YLeaf(0, "mgmt-lsd-intf-state-unknown")

    mgmt_lsd_intf_state_up = Enum.YLeaf(1, "mgmt-lsd-intf-state-up")

    mgmt_lsd_intf_state_down = Enum.YLeaf(2, "mgmt-lsd-intf-state-down")


class MgmtLsdLblCtx(Enum):
    """
    MgmtLsdLblCtx

    Mgmt lsd lbl ctx

    .. data:: mgmt_lsd_lbl_ctx_type_none = 0

    	None

    .. data:: mgmt_lsd_lbl_ctx_type_ipv4 = 1

    	IPv4

    .. data:: mgmt_lsd_lbl_ctx_type_ipv6 = 2

    	IPv6

    .. data:: mgmt_lsd_lbl_ctx_type_tev4 = 3

    	TE IPv4

    .. data:: mgmt_lsd_lbl_ctx_type_l3vpn_ipv4 = 4

    	L3VPN IPv4

    .. data:: mgmt_lsd_lbl_ctx_type_l3vpn_ipv6 = 5

    	L3VPN IPv6

    .. data:: mgmt_lsd_lbl_ctx_type_l3vpn_vrf = 6

    	L3VPN Per-VRF

    .. data:: mgmt_lsd_lbl_ctx_type_l3vpn_cev4 = 7

    	L3VPN IPv4 Per-CE

    .. data:: mgmt_lsd_lbl_ctx_type_l3vpn_cev6 = 8

    	L3VPN IPv6 Per-CE

    .. data:: mgmt_lsd_lbl_ctx_type_pw = 9

    	PW

    .. data:: mgmt_lsd_lbl_ctx_type_lbl_blk = 10

    	LBL BLK

    .. data:: mgmt_lsd_lbl_ctx_type_ip_sub = 11

    	IP SUB

    .. data:: mgmt_lsd_lbl_ctx_type_tev4_p2mp = 12

    	TE IPv4 P2MP

    .. data:: mgmt_lsd_lbl_ctx_type_mldpv4 = 13

    	MLDP IPv4

    .. data:: mgmt_lsd_lbl_ctx_type_pwhe = 14

    	PW HE

    .. data:: mgmt_lsd_lbl_ctx_type_tp = 15

    	MPLS TP

    .. data:: mgmt_lsd_lbl_ctx_type_gre = 16

    	GRE

    .. data:: mgmt_lsd_lbl_ctx_type_evpn = 17

    	EVPN

    .. data:: mgmt_lsd_lbl_ctx_type_blb_ipv4 = 18

    	BLB IPv4

    .. data:: mgmt_lsd_lbl_ctx_type_blb_ipv6 = 19

    	BLB IPv6

    .. data:: mgmt_lsd_lbl_ctx_type_pim_i_pmsi = 20

    	PIM I-PMSI

    .. data:: mgmt_lsd_lbl_ctx_type_pim_s_pmsi = 21

    	PIM S-PMSI

    .. data:: mgmt_lsd_lbl_ctx_type_l3vpn_nh_set = 22

    	L3VPN NH SET

    .. data:: mgmt_lsd_lbl_ctx_type_sr_pfx_seg = 23

    	SR Prefix Segment

    .. data:: mgmt_lsd_lbl_ctx_type_sr_adj_seg_ipv4 = 24

    	SR Adj Segment IPv4

    .. data:: mgmt_lsd_lbl_ctx_type_sr_adj_seg_ipv6 = 25

    	SR Adj Segment IPv6

    .. data:: mgmt_lsd_lbl_ctx_type_lbl_blk_srgb = 26

    	LBL BLK SRGB

    .. data:: mgmt_lsd_lbl_ctx_type_te_binding = 27

    	TE Binding

    .. data:: mgmt_lsd_lbl_ctx_type_gre_ipv6 = 28

    	GRE IPV6

    .. data:: mgmt_lsd_lbl_ctx_type_any = 29

    	Any

    """

    mgmt_lsd_lbl_ctx_type_none = Enum.YLeaf(0, "mgmt-lsd-lbl-ctx-type-none")

    mgmt_lsd_lbl_ctx_type_ipv4 = Enum.YLeaf(1, "mgmt-lsd-lbl-ctx-type-ipv4")

    mgmt_lsd_lbl_ctx_type_ipv6 = Enum.YLeaf(2, "mgmt-lsd-lbl-ctx-type-ipv6")

    mgmt_lsd_lbl_ctx_type_tev4 = Enum.YLeaf(3, "mgmt-lsd-lbl-ctx-type-tev4")

    mgmt_lsd_lbl_ctx_type_l3vpn_ipv4 = Enum.YLeaf(4, "mgmt-lsd-lbl-ctx-type-l3vpn-ipv4")

    mgmt_lsd_lbl_ctx_type_l3vpn_ipv6 = Enum.YLeaf(5, "mgmt-lsd-lbl-ctx-type-l3vpn-ipv6")

    mgmt_lsd_lbl_ctx_type_l3vpn_vrf = Enum.YLeaf(6, "mgmt-lsd-lbl-ctx-type-l3vpn-vrf")

    mgmt_lsd_lbl_ctx_type_l3vpn_cev4 = Enum.YLeaf(7, "mgmt-lsd-lbl-ctx-type-l3vpn-cev4")

    mgmt_lsd_lbl_ctx_type_l3vpn_cev6 = Enum.YLeaf(8, "mgmt-lsd-lbl-ctx-type-l3vpn-cev6")

    mgmt_lsd_lbl_ctx_type_pw = Enum.YLeaf(9, "mgmt-lsd-lbl-ctx-type-pw")

    mgmt_lsd_lbl_ctx_type_lbl_blk = Enum.YLeaf(10, "mgmt-lsd-lbl-ctx-type-lbl-blk")

    mgmt_lsd_lbl_ctx_type_ip_sub = Enum.YLeaf(11, "mgmt-lsd-lbl-ctx-type-ip-sub")

    mgmt_lsd_lbl_ctx_type_tev4_p2mp = Enum.YLeaf(12, "mgmt-lsd-lbl-ctx-type-tev4-p2mp")

    mgmt_lsd_lbl_ctx_type_mldpv4 = Enum.YLeaf(13, "mgmt-lsd-lbl-ctx-type-mldpv4")

    mgmt_lsd_lbl_ctx_type_pwhe = Enum.YLeaf(14, "mgmt-lsd-lbl-ctx-type-pwhe")

    mgmt_lsd_lbl_ctx_type_tp = Enum.YLeaf(15, "mgmt-lsd-lbl-ctx-type-tp")

    mgmt_lsd_lbl_ctx_type_gre = Enum.YLeaf(16, "mgmt-lsd-lbl-ctx-type-gre")

    mgmt_lsd_lbl_ctx_type_evpn = Enum.YLeaf(17, "mgmt-lsd-lbl-ctx-type-evpn")

    mgmt_lsd_lbl_ctx_type_blb_ipv4 = Enum.YLeaf(18, "mgmt-lsd-lbl-ctx-type-blb-ipv4")

    mgmt_lsd_lbl_ctx_type_blb_ipv6 = Enum.YLeaf(19, "mgmt-lsd-lbl-ctx-type-blb-ipv6")

    mgmt_lsd_lbl_ctx_type_pim_i_pmsi = Enum.YLeaf(20, "mgmt-lsd-lbl-ctx-type-pim-i-pmsi")

    mgmt_lsd_lbl_ctx_type_pim_s_pmsi = Enum.YLeaf(21, "mgmt-lsd-lbl-ctx-type-pim-s-pmsi")

    mgmt_lsd_lbl_ctx_type_l3vpn_nh_set = Enum.YLeaf(22, "mgmt-lsd-lbl-ctx-type-l3vpn-nh-set")

    mgmt_lsd_lbl_ctx_type_sr_pfx_seg = Enum.YLeaf(23, "mgmt-lsd-lbl-ctx-type-sr-pfx-seg")

    mgmt_lsd_lbl_ctx_type_sr_adj_seg_ipv4 = Enum.YLeaf(24, "mgmt-lsd-lbl-ctx-type-sr-adj-seg-ipv4")

    mgmt_lsd_lbl_ctx_type_sr_adj_seg_ipv6 = Enum.YLeaf(25, "mgmt-lsd-lbl-ctx-type-sr-adj-seg-ipv6")

    mgmt_lsd_lbl_ctx_type_lbl_blk_srgb = Enum.YLeaf(26, "mgmt-lsd-lbl-ctx-type-lbl-blk-srgb")

    mgmt_lsd_lbl_ctx_type_te_binding = Enum.YLeaf(27, "mgmt-lsd-lbl-ctx-type-te-binding")

    mgmt_lsd_lbl_ctx_type_gre_ipv6 = Enum.YLeaf(28, "mgmt-lsd-lbl-ctx-type-gre-ipv6")

    mgmt_lsd_lbl_ctx_type_any = Enum.YLeaf(29, "mgmt-lsd-lbl-ctx-type-any")


class MgmtLsdLspRole(Enum):
    """
    MgmtLsdLspRole

    Mgmt lsd lsp role

    .. data:: mgmt_lsd_lsp_role_head = 0

    	Head

    .. data:: mgmt_lsd_lsp_role_mid = 1

    	Midpoint

    """

    mgmt_lsd_lsp_role_head = Enum.YLeaf(0, "mgmt-lsd-lsp-role-head")

    mgmt_lsd_lsp_role_mid = Enum.YLeaf(1, "mgmt-lsd-lsp-role-mid")


class MgmtLsdMoi(Enum):
    """
    MgmtLsdMoi

    Mgmt lsd moi

    .. data:: mgmt_lsd_moi_type_pop_and_lkup_ipv4 = 0

    	Pop-and-lookup IPv4

    .. data:: mgmt_lsd_moi_type_ipv4 = 1

    	IPv4

    .. data:: mgmt_lsd_moi_type_ipv6 = 2

    	IPv6

    .. data:: mgmt_lsd_moi_type_tev4 = 3

    	TE IPv4

    .. data:: mgmt_lsd_moi_type_pw = 4

    	PW

    .. data:: mgmt_lsd_moi_type_pop_and_lkup_ipv6 = 5

    	Pop-and-lookup IPv6

    .. data:: mgmt_lsd_moi_type_ip_sub = 6

    	IP Subscriber

    .. data:: mgmt_lsd_moi_type_pwhe = 7

    	PW HE

    .. data:: mgmt_lsd_moi_type_pw_list = 8

    	PW List

    .. data:: mgmt_lsd_moi_type_ipv4_stack = 9

    	IPv4 Multi-Label

    .. data:: mgmt_lsd_moi_type_pop_and_lkup_tp = 10

    	Pop-and-lookup TP

    .. data:: mgmt_lsd_moi_type_ipv6_stack = 11

    	IPv6 Multi-Label

    .. data:: mgmt_lsd_moi_type_te_head = 12

    	TE Head

    .. data:: mgmt_lsd_moi_type_dmtc_ext_intf = 13

    	Demand Matrix Traffic-Collector

    """

    mgmt_lsd_moi_type_pop_and_lkup_ipv4 = Enum.YLeaf(0, "mgmt-lsd-moi-type-pop-and-lkup-ipv4")

    mgmt_lsd_moi_type_ipv4 = Enum.YLeaf(1, "mgmt-lsd-moi-type-ipv4")

    mgmt_lsd_moi_type_ipv6 = Enum.YLeaf(2, "mgmt-lsd-moi-type-ipv6")

    mgmt_lsd_moi_type_tev4 = Enum.YLeaf(3, "mgmt-lsd-moi-type-tev4")

    mgmt_lsd_moi_type_pw = Enum.YLeaf(4, "mgmt-lsd-moi-type-pw")

    mgmt_lsd_moi_type_pop_and_lkup_ipv6 = Enum.YLeaf(5, "mgmt-lsd-moi-type-pop-and-lkup-ipv6")

    mgmt_lsd_moi_type_ip_sub = Enum.YLeaf(6, "mgmt-lsd-moi-type-ip-sub")

    mgmt_lsd_moi_type_pwhe = Enum.YLeaf(7, "mgmt-lsd-moi-type-pwhe")

    mgmt_lsd_moi_type_pw_list = Enum.YLeaf(8, "mgmt-lsd-moi-type-pw-list")

    mgmt_lsd_moi_type_ipv4_stack = Enum.YLeaf(9, "mgmt-lsd-moi-type-ipv4-stack")

    mgmt_lsd_moi_type_pop_and_lkup_tp = Enum.YLeaf(10, "mgmt-lsd-moi-type-pop-and-lkup-tp")

    mgmt_lsd_moi_type_ipv6_stack = Enum.YLeaf(11, "mgmt-lsd-moi-type-ipv6-stack")

    mgmt_lsd_moi_type_te_head = Enum.YLeaf(12, "mgmt-lsd-moi-type-te-head")

    mgmt_lsd_moi_type_dmtc_ext_intf = Enum.YLeaf(13, "mgmt-lsd-moi-type-dmtc-ext-intf")


class MgmtLsdRwId(Enum):
    """
    MgmtLsdRwId

    Mgmt lsd rw id

    .. data:: mgmt_lsd_rw_id_type_none = 0

    	None

    .. data:: mgmt_lsd_rw_id_type_lbl_ctx = 1

    	Label Context

    .. data:: mgmt_lsd_rw_id_type_loc_lbl = 2

    	Local Label

    """

    mgmt_lsd_rw_id_type_none = Enum.YLeaf(0, "mgmt-lsd-rw-id-type-none")

    mgmt_lsd_rw_id_type_lbl_ctx = Enum.YLeaf(1, "mgmt-lsd-rw-id-type-lbl-ctx")

    mgmt_lsd_rw_id_type_loc_lbl = Enum.YLeaf(2, "mgmt-lsd-rw-id-type-loc-lbl")


class MgmtLsdTeBinding(Enum):
    """
    MgmtLsdTeBinding

    Mgmt lsd te binding

    .. data:: mgmt_lsd_ident_p2p_tun_id = 0

    	mgmt lsd ident p2p tun id

    .. data:: mgmt_lsd_ident_p2p_grp_id = 1

    	mgmt lsd ident p2p grp id

    .. data:: mgmt_lsd_ident_p2mp_tun_id = 2

    	mgmt lsd ident p2mp tun id

    .. data:: mgmt_lsd_ident_p2mp_grp_id = 3

    	mgmt lsd ident p2mp grp id

    """

    mgmt_lsd_ident_p2p_tun_id = Enum.YLeaf(0, "mgmt-lsd-ident-p2p-tun-id")

    mgmt_lsd_ident_p2p_grp_id = Enum.YLeaf(1, "mgmt-lsd-ident-p2p-grp-id")

    mgmt_lsd_ident_p2mp_tun_id = Enum.YLeaf(2, "mgmt-lsd-ident-p2mp-tun-id")

    mgmt_lsd_ident_p2mp_grp_id = Enum.YLeaf(3, "mgmt-lsd-ident-p2mp-grp-id")



class MplsLsdNodes(Entity):
    """
    Location MPLS LSD operational data
    
    .. attribute:: mpls_lsd_node
    
    	The MPLS LSD operational data for a particular node
    	**type**\: list of    :py:class:`MplsLsdNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode>`
    
    

    """

    _prefix = 'mpls-lsd-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(MplsLsdNodes, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-lsd-nodes"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-lsd-oper"

        self.mpls_lsd_node = YList(self)

    def __setattr__(self, name, value):
        self._check_monkey_patching_error(name, value)
        with _handle_type_error():
            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                    "Please use list append or extend method."
                                    .format(value))
            if isinstance(value, Enum.YLeaf):
                value = value.name
            if name in () and name in self.__dict__:
                if isinstance(value, YLeaf):
                    self.__dict__[name].set(value.get())
                elif isinstance(value, YLeafList):
                    super(MplsLsdNodes, self).__setattr__(name, value)
                else:
                    self.__dict__[name].set(value)
            else:
                if hasattr(value, "parent") and name != "parent":
                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                        value.parent = self
                    elif value.parent is None and value.yang_name in self._children_yang_names:
                        value.parent = self
                super(MplsLsdNodes, self).__setattr__(name, value)


    class MplsLsdNode(Entity):
        """
        The MPLS LSD operational data for a particular
        node
        
        .. attribute:: node_name  <key>
        
        	The identifier for the node
        	**type**\:  str
        
        	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
        
        .. attribute:: applications
        
        	Table of MPLS applications using LSD
        	**type**\:   :py:class:`Applications <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Applications>`
        
        .. attribute:: clients
        
        	Table of MPLS clients using LSD
        	**type**\:   :py:class:`Clients <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Clients>`
        
        .. attribute:: frr_database
        
        	FRR database
        	**type**\:   :py:class:`FrrDatabase <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase>`
        
        .. attribute:: interfaces
        
        	Table of MPLS interfaces
        	**type**\:   :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Interfaces>`
        
        .. attribute:: label_range
        
        	Label range
        	**type**\:   :py:class:`LabelRange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.LabelRange>`
        
        .. attribute:: label_summary
        
        	Dynamic label range
        	**type**\:   :py:class:`LabelSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.LabelSummary>`
        
        .. attribute:: label_summary_vrfs
        
        	Dynamic label range summary by VRF
        	**type**\:   :py:class:`LabelSummaryVrfs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs>`
        
        .. attribute:: labels
        
        	Table of labels
        	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels>`
        
        .. attribute:: rewrite
        
        	Table of rewrites
        	**type**\:   :py:class:`Rewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite>`
        
        .. attribute:: rewrite_summary
        
        	Rewrite Summary 
        	**type**\:   :py:class:`RewriteSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.RewriteSummary>`
        
        .. attribute:: rewrite_summary_vrfs
        
        	Rewrite Summary by VRF
        	**type**\:   :py:class:`RewriteSummaryVrfs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs>`
        
        

        """

        _prefix = 'mpls-lsd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLsdNodes.MplsLsdNode, self).__init__()

            self.yang_name = "mpls-lsd-node"
            self.yang_parent_name = "mpls-lsd-nodes"

            self.node_name = YLeaf(YType.str, "node-name")

            self.applications = MplsLsdNodes.MplsLsdNode.Applications()
            self.applications.parent = self
            self._children_name_map["applications"] = "applications"
            self._children_yang_names.add("applications")

            self.clients = MplsLsdNodes.MplsLsdNode.Clients()
            self.clients.parent = self
            self._children_name_map["clients"] = "clients"
            self._children_yang_names.add("clients")

            self.frr_database = MplsLsdNodes.MplsLsdNode.FrrDatabase()
            self.frr_database.parent = self
            self._children_name_map["frr_database"] = "frr-database"
            self._children_yang_names.add("frr-database")

            self.interfaces = MplsLsdNodes.MplsLsdNode.Interfaces()
            self.interfaces.parent = self
            self._children_name_map["interfaces"] = "interfaces"
            self._children_yang_names.add("interfaces")

            self.label_range = MplsLsdNodes.MplsLsdNode.LabelRange()
            self.label_range.parent = self
            self._children_name_map["label_range"] = "label-range"
            self._children_yang_names.add("label-range")

            self.label_summary = MplsLsdNodes.MplsLsdNode.LabelSummary()
            self.label_summary.parent = self
            self._children_name_map["label_summary"] = "label-summary"
            self._children_yang_names.add("label-summary")

            self.label_summary_vrfs = MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs()
            self.label_summary_vrfs.parent = self
            self._children_name_map["label_summary_vrfs"] = "label-summary-vrfs"
            self._children_yang_names.add("label-summary-vrfs")

            self.labels = MplsLsdNodes.MplsLsdNode.Labels()
            self.labels.parent = self
            self._children_name_map["labels"] = "labels"
            self._children_yang_names.add("labels")

            self.rewrite = MplsLsdNodes.MplsLsdNode.Rewrite()
            self.rewrite.parent = self
            self._children_name_map["rewrite"] = "rewrite"
            self._children_yang_names.add("rewrite")

            self.rewrite_summary = MplsLsdNodes.MplsLsdNode.RewriteSummary()
            self.rewrite_summary.parent = self
            self._children_name_map["rewrite_summary"] = "rewrite-summary"
            self._children_yang_names.add("rewrite-summary")

            self.rewrite_summary_vrfs = MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs()
            self.rewrite_summary_vrfs.parent = self
            self._children_name_map["rewrite_summary_vrfs"] = "rewrite-summary-vrfs"
            self._children_yang_names.add("rewrite-summary-vrfs")

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("node_name") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLsdNodes.MplsLsdNode, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLsdNodes.MplsLsdNode, self).__setattr__(name, value)


        class Clients(Entity):
            """
            Table of MPLS clients using LSD
            
            .. attribute:: client
            
            	Data for MPLS client using LSD
            	**type**\: list of    :py:class:`Client <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Clients.Client>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsdNodes.MplsLsdNode.Clients, self).__init__()

                self.yang_name = "clients"
                self.yang_parent_name = "mpls-lsd-node"

                self.client = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsdNodes.MplsLsdNode.Clients, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsdNodes.MplsLsdNode.Clients, self).__setattr__(name, value)


            class Client(Entity):
                """
                Data for MPLS client using LSD
                
                .. attribute:: client_name  <key>
                
                	Client Instance name in the form of     'Application\-<client\_name>' or      'BCDL\_Agent\-<index\:parent\_index>'
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: client_index
                
                	Client Index Value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: client_union
                
                	Client union
                	**type**\:   :py:class:`ClientUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion>`
                
                .. attribute:: node_id
                
                	Node ID
                	**type**\:  str
                
                	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.Clients.Client, self).__init__()

                    self.yang_name = "client"
                    self.yang_parent_name = "clients"

                    self.client_name = YLeaf(YType.str, "client-name")

                    self.client_index = YLeaf(YType.uint32, "client-index")

                    self.node_id = YLeaf(YType.str, "node-id")

                    self.client_union = MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion()
                    self.client_union.parent = self
                    self._children_name_map["client_union"] = "client-union"
                    self._children_yang_names.add("client-union")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("client_name",
                                    "client_index",
                                    "node_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.Clients.Client, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.Clients.Client, self).__setattr__(name, value)


                class ClientUnion(Entity):
                    """
                    Client union
                    
                    .. attribute:: application
                    
                    	Application client
                    	**type**\:   :py:class:`Application <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion.Application>`
                    
                    .. attribute:: bcdl_agent
                    
                    	BCDL agent client
                    	**type**\:   :py:class:`BcdlAgent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion.BcdlAgent>`
                    
                    .. attribute:: lsd_client_type
                    
                    	LSDClientType
                    	**type**\:   :py:class:`MgmtLsdClient <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdClient>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion, self).__init__()

                        self.yang_name = "client-union"
                        self.yang_parent_name = "client"

                        self.lsd_client_type = YLeaf(YType.enumeration, "lsd-client-type")

                        self.application = MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion.Application()
                        self.application.parent = self
                        self._children_name_map["application"] = "application"
                        self._children_yang_names.add("application")

                        self.bcdl_agent = MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion.BcdlAgent()
                        self.bcdl_agent.parent = self
                        self._children_name_map["bcdl_agent"] = "bcdl-agent"
                        self._children_yang_names.add("bcdl-agent")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("lsd_client_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion, self).__setattr__(name, value)


                    class Application(Entity):
                        """
                        Application client
                        
                        .. attribute:: application_instance
                        
                        	client\-app instance
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion.Application, self).__init__()

                            self.yang_name = "application"
                            self.yang_parent_name = "client-union"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion.Application, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion.Application, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix


                    class BcdlAgent(Entity):
                        """
                        BCDL agent client
                        
                        .. attribute:: client_conn_index
                        
                        	BCDL Agent client connection index
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: parent_client_conn_index
                        
                        	BCDL Agent parent client connection index
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion.BcdlAgent, self).__init__()

                            self.yang_name = "bcdl-agent"
                            self.yang_parent_name = "client-union"

                            self.client_conn_index = YLeaf(YType.int32, "client-conn-index")

                            self.parent_client_conn_index = YLeaf(YType.int32, "parent-client-conn-index")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("client_conn_index",
                                            "parent_client_conn_index") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion.BcdlAgent, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion.BcdlAgent, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.client_conn_index.is_set or
                                self.parent_client_conn_index.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.client_conn_index.yfilter != YFilter.not_set or
                                self.parent_client_conn_index.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bcdl-agent" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.client_conn_index.is_set or self.client_conn_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_conn_index.get_name_leafdata())
                            if (self.parent_client_conn_index.is_set or self.parent_client_conn_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.parent_client_conn_index.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "client-conn-index" or name == "parent-client-conn-index"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "client-conn-index"):
                                self.client_conn_index = value
                                self.client_conn_index.value_namespace = name_space
                                self.client_conn_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "parent-client-conn-index"):
                                self.parent_client_conn_index = value
                                self.parent_client_conn_index.value_namespace = name_space
                                self.parent_client_conn_index.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.lsd_client_type.is_set or
                            (self.application is not None and self.application.has_data()) or
                            (self.bcdl_agent is not None and self.bcdl_agent.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.lsd_client_type.yfilter != YFilter.not_set or
                            (self.application is not None and self.application.has_operation()) or
                            (self.bcdl_agent is not None and self.bcdl_agent.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "client-union" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.lsd_client_type.is_set or self.lsd_client_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsd_client_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application"):
                            if (self.application is None):
                                self.application = MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion.Application()
                                self.application.parent = self
                                self._children_name_map["application"] = "application"
                            return self.application

                        if (child_yang_name == "bcdl-agent"):
                            if (self.bcdl_agent is None):
                                self.bcdl_agent = MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion.BcdlAgent()
                                self.bcdl_agent.parent = self
                                self._children_name_map["bcdl_agent"] = "bcdl-agent"
                            return self.bcdl_agent

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application" or name == "bcdl-agent" or name == "lsd-client-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "lsd-client-type"):
                            self.lsd_client_type = value
                            self.lsd_client_type.value_namespace = name_space
                            self.lsd_client_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.client_name.is_set or
                        self.client_index.is_set or
                        self.node_id.is_set or
                        (self.client_union is not None and self.client_union.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.client_name.yfilter != YFilter.not_set or
                        self.client_index.yfilter != YFilter.not_set or
                        self.node_id.yfilter != YFilter.not_set or
                        (self.client_union is not None and self.client_union.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "client" + "[client-name='" + self.client_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.client_name.is_set or self.client_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.client_name.get_name_leafdata())
                    if (self.client_index.is_set or self.client_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.client_index.get_name_leafdata())
                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "client-union"):
                        if (self.client_union is None):
                            self.client_union = MplsLsdNodes.MplsLsdNode.Clients.Client.ClientUnion()
                            self.client_union.parent = self
                            self._children_name_map["client_union"] = "client-union"
                        return self.client_union

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "client-union" or name == "client-name" or name == "client-index" or name == "node-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "client-name"):
                        self.client_name = value
                        self.client_name.value_namespace = name_space
                        self.client_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "client-index"):
                        self.client_index = value
                        self.client_index.value_namespace = name_space
                        self.client_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-id"):
                        self.node_id = value
                        self.node_id.value_namespace = name_space
                        self.node_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.client:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.client:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "clients" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "client"):
                    for c in self.client:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsdNodes.MplsLsdNode.Clients.Client()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.client.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "client"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class LabelSummary(Entity):
            """
            Dynamic label range
            
            .. attribute:: owner_count
            
            	Owner counts
            	**type**\: list of    :py:class:`OwnerCount <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.LabelSummary.OwnerCount>`
            
            .. attribute:: rsi_connected
            
            	Rsi connected
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: total_labels
            
            	Total labels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: vrf_name_xr
            
            	VRF Name
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsdNodes.MplsLsdNode.LabelSummary, self).__init__()

                self.yang_name = "label-summary"
                self.yang_parent_name = "mpls-lsd-node"

                self.rsi_connected = YLeaf(YType.int32, "rsi-connected")

                self.total_labels = YLeaf(YType.uint32, "total-labels")

                self.vrf_name_xr = YLeaf(YType.str, "vrf-name-xr")

                self.owner_count = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("rsi_connected",
                                "total_labels",
                                "vrf_name_xr") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsdNodes.MplsLsdNode.LabelSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsdNodes.MplsLsdNode.LabelSummary, self).__setattr__(name, value)


            class OwnerCount(Entity):
                """
                Owner counts
                
                .. attribute:: application_instance
                
                	client\-app identifier
                	**type**\:  str
                
                .. attribute:: application_name
                
                	Application name
                	**type**\:  str
                
                .. attribute:: application_role_primary
                
                	Primary/Backup role
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: application_type
                
                	Application type
                	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                
                .. attribute:: number_of_labels
                
                	Number of labels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.LabelSummary.OwnerCount, self).__init__()

                    self.yang_name = "owner-count"
                    self.yang_parent_name = "label-summary"

                    self.application_instance = YLeaf(YType.str, "application-instance")

                    self.application_name = YLeaf(YType.str, "application-name")

                    self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                    self.application_type = YLeaf(YType.enumeration, "application-type")

                    self.number_of_labels = YLeaf(YType.uint32, "number-of-labels")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("application_instance",
                                    "application_name",
                                    "application_role_primary",
                                    "application_type",
                                    "number_of_labels") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.LabelSummary.OwnerCount, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.LabelSummary.OwnerCount, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.application_instance.is_set or
                        self.application_name.is_set or
                        self.application_role_primary.is_set or
                        self.application_type.is_set or
                        self.number_of_labels.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.application_instance.yfilter != YFilter.not_set or
                        self.application_name.yfilter != YFilter.not_set or
                        self.application_role_primary.yfilter != YFilter.not_set or
                        self.application_type.yfilter != YFilter.not_set or
                        self.number_of_labels.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "owner-count" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_instance.get_name_leafdata())
                    if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_name.get_name_leafdata())
                    if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                    if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_type.get_name_leafdata())
                    if (self.number_of_labels.is_set or self.number_of_labels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_labels.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "number-of-labels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "application-instance"):
                        self.application_instance = value
                        self.application_instance.value_namespace = name_space
                        self.application_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-name"):
                        self.application_name = value
                        self.application_name.value_namespace = name_space
                        self.application_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-role-primary"):
                        self.application_role_primary = value
                        self.application_role_primary.value_namespace = name_space
                        self.application_role_primary.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-type"):
                        self.application_type = value
                        self.application_type.value_namespace = name_space
                        self.application_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-labels"):
                        self.number_of_labels = value
                        self.number_of_labels.value_namespace = name_space
                        self.number_of_labels.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.owner_count:
                    if (c.has_data()):
                        return True
                return (
                    self.rsi_connected.is_set or
                    self.total_labels.is_set or
                    self.vrf_name_xr.is_set)

            def has_operation(self):
                for c in self.owner_count:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.rsi_connected.yfilter != YFilter.not_set or
                    self.total_labels.yfilter != YFilter.not_set or
                    self.vrf_name_xr.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "label-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.rsi_connected.is_set or self.rsi_connected.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rsi_connected.get_name_leafdata())
                if (self.total_labels.is_set or self.total_labels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_labels.get_name_leafdata())
                if (self.vrf_name_xr.is_set or self.vrf_name_xr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.vrf_name_xr.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "owner-count"):
                    for c in self.owner_count:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsdNodes.MplsLsdNode.LabelSummary.OwnerCount()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.owner_count.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "owner-count" or name == "rsi-connected" or name == "total-labels" or name == "vrf-name-xr"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "rsi-connected"):
                    self.rsi_connected = value
                    self.rsi_connected.value_namespace = name_space
                    self.rsi_connected.value_namespace_prefix = name_space_prefix
                if(value_path == "total-labels"):
                    self.total_labels = value
                    self.total_labels.value_namespace = name_space
                    self.total_labels.value_namespace_prefix = name_space_prefix
                if(value_path == "vrf-name-xr"):
                    self.vrf_name_xr = value
                    self.vrf_name_xr.value_namespace = name_space
                    self.vrf_name_xr.value_namespace_prefix = name_space_prefix


        class Labels(Entity):
            """
            Table of labels
            
            .. attribute:: label
            
            	Data for label
            	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsdNodes.MplsLsdNode.Labels, self).__init__()

                self.yang_name = "labels"
                self.yang_parent_name = "mpls-lsd-node"

                self.label = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsdNodes.MplsLsdNode.Labels, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsdNodes.MplsLsdNode.Labels, self).__setattr__(name, value)


            class Label(Entity):
                """
                Data for label
                
                .. attribute:: label_id  <key>
                
                	Label value
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: application_owner
                
                	Application owner
                	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.ApplicationOwner>`
                
                .. attribute:: label
                
                	Label value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: label_context
                
                	Label context
                	**type**\:   :py:class:`LabelContext <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext>`
                
                .. attribute:: rewrite_is_bound
                
                	Rewrite bound to label
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: rewrite_owners
                
                	Rewrite owner
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: rs_iconnected
                
                	RSI connected
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: vrf_name
                
                	VRF Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.Labels.Label, self).__init__()

                    self.yang_name = "label"
                    self.yang_parent_name = "labels"

                    self.label_id = YLeaf(YType.int32, "label-id")

                    self.label = YLeaf(YType.uint32, "label")

                    self.rewrite_is_bound = YLeaf(YType.int32, "rewrite-is-bound")

                    self.rewrite_owners = YLeaf(YType.uint32, "rewrite-owners")

                    self.rs_iconnected = YLeaf(YType.int32, "rs-iconnected")

                    self.vrf_name = YLeaf(YType.str, "vrf-name")

                    self.label_context = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext()
                    self.label_context.parent = self
                    self._children_name_map["label_context"] = "label-context"
                    self._children_yang_names.add("label-context")

                    self.application_owner = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("label_id",
                                    "label",
                                    "rewrite_is_bound",
                                    "rewrite_owners",
                                    "rs_iconnected",
                                    "vrf_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.Labels.Label, self).__setattr__(name, value)


                class LabelContext(Entity):
                    """
                    Label context
                    
                    .. attribute:: application_data
                    
                    	Application opaque data
                    	**type**\:  str
                    
                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                    
                    .. attribute:: key
                    
                    	Label Key
                    	**type**\:   :py:class:`Key <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext, self).__init__()

                        self.yang_name = "label-context"
                        self.yang_parent_name = "label"

                        self.application_data = YLeaf(YType.str, "application-data")

                        self.key = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key()
                        self.key.parent = self
                        self._children_name_map["key"] = "key"
                        self._children_yang_names.add("key")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("application_data") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext, self).__setattr__(name, value)


                    class Key(Entity):
                        """
                        Label Key
                        
                        .. attribute:: cev4l3vpn_data
                        
                        	L3VPN CEv4 label context
                        	**type**\:   :py:class:`Cev4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Cev4L3VpnData>`
                        
                        .. attribute:: cev6l3vpn_data
                        
                        	L3VPN CEv6 label context
                        	**type**\:   :py:class:`Cev6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Cev6L3VpnData>`
                        
                        .. attribute:: evpn_data
                        
                        	EVPN context
                        	**type**\:   :py:class:`EvpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.EvpnData>`
                        
                        .. attribute:: generic_routing_encapsulation
                        
                        	Generic routing encapsulation context
                        	**type**\:   :py:class:`GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.GenericRoutingEncapsulation>`
                        
                        .. attribute:: ip_sub_data
                        
                        	IP Subscriber context
                        	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.IpSubData>`
                        
                        .. attribute:: ipv4_data
                        
                        	IPv4 label context
                        	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4Data>`
                        
                        .. attribute:: ipv4blb_data
                        
                        	BFD BLB label context
                        	**type**\:   :py:class:`Ipv4BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4BlbData>`
                        
                        .. attribute:: ipv4l3vpn_data
                        
                        	L3VPN IPv4 label context
                        	**type**\:   :py:class:`Ipv4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4L3VpnData>`
                        
                        .. attribute:: ipv6_data
                        
                        	IPv6 label context
                        	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6Data>`
                        
                        .. attribute:: ipv6_generic_routing_encapsulation
                        
                        	Generic routing encapsulation context
                        	**type**\:   :py:class:`Ipv6GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6GenericRoutingEncapsulation>`
                        
                        .. attribute:: ipv6blb_data
                        
                        	BFD BLB label context
                        	**type**\:   :py:class:`Ipv6BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6BlbData>`
                        
                        .. attribute:: ipv6l3vpn_data
                        
                        	L3VPN IPv6 label context
                        	**type**\:   :py:class:`Ipv6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6L3VpnData>`
                        
                        .. attribute:: label_block_data
                        
                        	Label block context
                        	**type**\:   :py:class:`LabelBlockData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.LabelBlockData>`
                        
                        .. attribute:: label_block_srgb_data
                        
                        	Label block SRGB context
                        	**type**\:   :py:class:`LabelBlockSrgbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.LabelBlockSrgbData>`
                        
                        .. attribute:: label_context_type
                        
                        	LabelContextType
                        	**type**\:   :py:class:`MgmtLsdLblCtx <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLblCtx>`
                        
                        .. attribute:: mld_pv4_data
                        
                        	MLDPv4 LSM\-ID context
                        	**type**\:   :py:class:`MldPv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.MldPv4Data>`
                        
                        .. attribute:: next_hop_set_l3vpn
                        
                        	L3VPN NH SET label context
                        	**type**\:   :py:class:`NextHopSetL3Vpn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.NextHopSetL3Vpn>`
                        
                        .. attribute:: pi_mi_pmsi_data
                        
                        	PIM I\-PMSI label conext
                        	**type**\:   :py:class:`PiMiPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PiMiPmsiData>`
                        
                        .. attribute:: pi_ms_pmsi_data
                        
                        	PIM S\-PMSI label conext
                        	**type**\:   :py:class:`PiMsPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PiMsPmsiData>`
                        
                        .. attribute:: pseudowire_data
                        
                        	Pseudowire label context
                        	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PseudowireData>`
                        
                        .. attribute:: pseudowire_head_end_data
                        
                        	Pseudowire Head\-end label context
                        	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PseudowireHeadEndData>`
                        
                        .. attribute:: sr_adj_segment_ipv4
                        
                        	SR Adj Segment ipv4 context
                        	**type**\:   :py:class:`SrAdjSegmentIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrAdjSegmentIpv4>`
                        
                        .. attribute:: sr_adj_segment_ipv6
                        
                        	SR Adj Segment ipv6 context
                        	**type**\:   :py:class:`SrAdjSegmentIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrAdjSegmentIpv6>`
                        
                        .. attribute:: sr_prefix_segment
                        
                        	SR Prefix Segment context
                        	**type**\:   :py:class:`SrPrefixSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrPrefixSegment>`
                        
                        .. attribute:: te_binding
                        
                        	MPLS TE tunnel binding context
                        	**type**\:   :py:class:`TeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.TeBinding>`
                        
                        .. attribute:: tev4_data
                        
                        	TEv4 label context
                        	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Tev4Data>`
                        
                        .. attribute:: tev4p2mp_data
                        
                        	TEv4 P2MP context
                        	**type**\:   :py:class:`Tev4P2MpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Tev4P2MpData>`
                        
                        .. attribute:: tp_data
                        
                        	TP context
                        	**type**\:   :py:class:`TpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.TpData>`
                        
                        .. attribute:: vrf_l3vpn_data
                        
                        	L3VPN VRF label context
                        	**type**\:   :py:class:`VrfL3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.VrfL3VpnData>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key, self).__init__()

                            self.yang_name = "key"
                            self.yang_parent_name = "label-context"

                            self.label_context_type = YLeaf(YType.enumeration, "label-context-type")

                            self.cev4l3vpn_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Cev4L3VpnData()
                            self.cev4l3vpn_data.parent = self
                            self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                            self._children_yang_names.add("cev4l3vpn-data")

                            self.cev6l3vpn_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Cev6L3VpnData()
                            self.cev6l3vpn_data.parent = self
                            self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                            self._children_yang_names.add("cev6l3vpn-data")

                            self.evpn_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.EvpnData()
                            self.evpn_data.parent = self
                            self._children_name_map["evpn_data"] = "evpn-data"
                            self._children_yang_names.add("evpn-data")

                            self.generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.GenericRoutingEncapsulation()
                            self.generic_routing_encapsulation.parent = self
                            self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                            self._children_yang_names.add("generic-routing-encapsulation")

                            self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.IpSubData()
                            self.ip_sub_data.parent = self
                            self._children_name_map["ip_sub_data"] = "ip-sub-data"
                            self._children_yang_names.add("ip-sub-data")

                            self.ipv4_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4Data()
                            self.ipv4_data.parent = self
                            self._children_name_map["ipv4_data"] = "ipv4-data"
                            self._children_yang_names.add("ipv4-data")

                            self.ipv4blb_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4BlbData()
                            self.ipv4blb_data.parent = self
                            self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                            self._children_yang_names.add("ipv4blb-data")

                            self.ipv4l3vpn_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4L3VpnData()
                            self.ipv4l3vpn_data.parent = self
                            self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                            self._children_yang_names.add("ipv4l3vpn-data")

                            self.ipv6_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6Data()
                            self.ipv6_data.parent = self
                            self._children_name_map["ipv6_data"] = "ipv6-data"
                            self._children_yang_names.add("ipv6-data")

                            self.ipv6_generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6GenericRoutingEncapsulation()
                            self.ipv6_generic_routing_encapsulation.parent = self
                            self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                            self._children_yang_names.add("ipv6-generic-routing-encapsulation")

                            self.ipv6blb_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6BlbData()
                            self.ipv6blb_data.parent = self
                            self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                            self._children_yang_names.add("ipv6blb-data")

                            self.ipv6l3vpn_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6L3VpnData()
                            self.ipv6l3vpn_data.parent = self
                            self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                            self._children_yang_names.add("ipv6l3vpn-data")

                            self.label_block_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.LabelBlockData()
                            self.label_block_data.parent = self
                            self._children_name_map["label_block_data"] = "label-block-data"
                            self._children_yang_names.add("label-block-data")

                            self.label_block_srgb_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.LabelBlockSrgbData()
                            self.label_block_srgb_data.parent = self
                            self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                            self._children_yang_names.add("label-block-srgb-data")

                            self.mld_pv4_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.MldPv4Data()
                            self.mld_pv4_data.parent = self
                            self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                            self._children_yang_names.add("mld-pv4-data")

                            self.next_hop_set_l3vpn = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.NextHopSetL3Vpn()
                            self.next_hop_set_l3vpn.parent = self
                            self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                            self._children_yang_names.add("next-hop-set-l3vpn")

                            self.pi_mi_pmsi_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PiMiPmsiData()
                            self.pi_mi_pmsi_data.parent = self
                            self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                            self._children_yang_names.add("pi-mi-pmsi-data")

                            self.pi_ms_pmsi_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PiMsPmsiData()
                            self.pi_ms_pmsi_data.parent = self
                            self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                            self._children_yang_names.add("pi-ms-pmsi-data")

                            self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PseudowireData()
                            self.pseudowire_data.parent = self
                            self._children_name_map["pseudowire_data"] = "pseudowire-data"
                            self._children_yang_names.add("pseudowire-data")

                            self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PseudowireHeadEndData()
                            self.pseudowire_head_end_data.parent = self
                            self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                            self._children_yang_names.add("pseudowire-head-end-data")

                            self.sr_adj_segment_ipv4 = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrAdjSegmentIpv4()
                            self.sr_adj_segment_ipv4.parent = self
                            self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                            self._children_yang_names.add("sr-adj-segment-ipv4")

                            self.sr_adj_segment_ipv6 = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrAdjSegmentIpv6()
                            self.sr_adj_segment_ipv6.parent = self
                            self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                            self._children_yang_names.add("sr-adj-segment-ipv6")

                            self.sr_prefix_segment = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrPrefixSegment()
                            self.sr_prefix_segment.parent = self
                            self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                            self._children_yang_names.add("sr-prefix-segment")

                            self.te_binding = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.TeBinding()
                            self.te_binding.parent = self
                            self._children_name_map["te_binding"] = "te-binding"
                            self._children_yang_names.add("te-binding")

                            self.tev4_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Tev4Data()
                            self.tev4_data.parent = self
                            self._children_name_map["tev4_data"] = "tev4-data"
                            self._children_yang_names.add("tev4-data")

                            self.tev4p2mp_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Tev4P2MpData()
                            self.tev4p2mp_data.parent = self
                            self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                            self._children_yang_names.add("tev4p2mp-data")

                            self.tp_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.TpData()
                            self.tp_data.parent = self
                            self._children_name_map["tp_data"] = "tp-data"
                            self._children_yang_names.add("tp-data")

                            self.vrf_l3vpn_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.VrfL3VpnData()
                            self.vrf_l3vpn_data.parent = self
                            self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                            self._children_yang_names.add("vrf-l3vpn-data")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("label_context_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key, self).__setattr__(name, value)


                        class Ipv4Data(Entity):
                            """
                            IPv4 label context
                            
                            .. attribute:: prefix
                            
                            	IPv4 prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	IPv4 prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: vrf_name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            	**length:** 0..33
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4Data, self).__init__()

                                self.yang_name = "ipv4-data"
                                self.yang_parent_name = "key"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.security_id = YLeaf(YType.uint32, "security-id")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.vrf_name = YLeaf(YType.str, "vrf-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "security_id",
                                                "table_id",
                                                "vrf_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.security_id.is_set or
                                    self.table_id.is_set or
                                    self.vrf_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.vrf_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "vrf-name"):
                                    self.vrf_name = value
                                    self.vrf_name.value_namespace = name_space
                                    self.vrf_name.value_namespace_prefix = name_space_prefix


                        class Ipv6Data(Entity):
                            """
                            IPv6 label context
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: vrf_name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            	**length:** 0..33
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6Data, self).__init__()

                                self.yang_name = "ipv6-data"
                                self.yang_parent_name = "key"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.security_id = YLeaf(YType.uint32, "security-id")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.vrf_name = YLeaf(YType.str, "vrf-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "security_id",
                                                "table_id",
                                                "vrf_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.security_id.is_set or
                                    self.table_id.is_set or
                                    self.vrf_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.vrf_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv6-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "vrf-name"):
                                    self.vrf_name = value
                                    self.vrf_name.value_namespace = name_space
                                    self.vrf_name.value_namespace_prefix = name_space_prefix


                        class Tev4Data(Entity):
                            """
                            TEv4 label context
                            
                            .. attribute:: is_srte
                            
                            	Is this an SRTE head tunnel
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_dest
                            
                            	Tunnel destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_id_extension
                            
                            	Extended tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_lsp_id
                            
                            	Tunnel LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_source
                            
                            	Tunnel source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Tev4Data, self).__init__()

                                self.yang_name = "tev4-data"
                                self.yang_parent_name = "key"

                                self.is_srte = YLeaf(YType.int32, "is-srte")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.tunnel_dest = YLeaf(YType.str, "tunnel-dest")

                                self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_srte",
                                                "table_id",
                                                "tunnel_dest",
                                                "tunnel_id",
                                                "tunnel_id_extension",
                                                "tunnel_lsp_id",
                                                "tunnel_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Tev4Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Tev4Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.is_srte.is_set or
                                    self.table_id.is_set or
                                    self.tunnel_dest.is_set or
                                    self.tunnel_id.is_set or
                                    self.tunnel_id_extension.is_set or
                                    self.tunnel_lsp_id.is_set or
                                    self.tunnel_source.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_srte.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.tunnel_dest.yfilter != YFilter.not_set or
                                    self.tunnel_id.yfilter != YFilter.not_set or
                                    self.tunnel_id_extension.yfilter != YFilter.not_set or
                                    self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                    self.tunnel_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tev4-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_srte.is_set or self.is_srte.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_srte.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.tunnel_dest.is_set or self.tunnel_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_dest.get_name_leafdata())
                                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "is-srte" or name == "table-id" or name == "tunnel-dest" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-srte"):
                                    self.is_srte = value
                                    self.is_srte.value_namespace = name_space
                                    self.is_srte.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-dest"):
                                    self.tunnel_dest = value
                                    self.tunnel_dest.value_namespace = name_space
                                    self.tunnel_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id"):
                                    self.tunnel_id = value
                                    self.tunnel_id.value_namespace = name_space
                                    self.tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id-extension"):
                                    self.tunnel_id_extension = value
                                    self.tunnel_id_extension.value_namespace = name_space
                                    self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-lsp-id"):
                                    self.tunnel_lsp_id = value
                                    self.tunnel_lsp_id.value_namespace = name_space
                                    self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-source"):
                                    self.tunnel_source = value
                                    self.tunnel_source.value_namespace = name_space
                                    self.tunnel_source.value_namespace_prefix = name_space_prefix


                        class Ipv4L3VpnData(Entity):
                            """
                            L3VPN IPv4 label context
                            
                            .. attribute:: prefix
                            
                            	IPv4 prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: route_distinguisher
                            
                            	Route distinguisher
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4L3VpnData, self).__init__()

                                self.yang_name = "ipv4l3vpn-data"
                                self.yang_parent_name = "key"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "route_distinguisher") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4L3VpnData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4L3VpnData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.route_distinguisher.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.route_distinguisher.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4l3vpn-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-distinguisher"):
                                    self.route_distinguisher = value
                                    self.route_distinguisher.value_namespace = name_space
                                    self.route_distinguisher.value_namespace_prefix = name_space_prefix


                        class Ipv6L3VpnData(Entity):
                            """
                            L3VPN IPv6 label context
                            
                            .. attribute:: prefix
                            
                            	IPv6 prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: route_distinguisher
                            
                            	Route distinguisher
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6L3VpnData, self).__init__()

                                self.yang_name = "ipv6l3vpn-data"
                                self.yang_parent_name = "key"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "route_distinguisher") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6L3VpnData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6L3VpnData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.route_distinguisher.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.route_distinguisher.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv6l3vpn-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "route-distinguisher"):
                                    self.route_distinguisher = value
                                    self.route_distinguisher.value_namespace = name_space
                                    self.route_distinguisher.value_namespace_prefix = name_space_prefix


                        class VrfL3VpnData(Entity):
                            """
                            L3VPN VRF label context
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.VrfL3VpnData, self).__init__()

                                self.yang_name = "vrf-l3vpn-data"
                                self.yang_parent_name = "key"

                                self.security_id = YLeaf(YType.uint32, "security-id")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("security_id",
                                                "table_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.VrfL3VpnData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.VrfL3VpnData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.security_id.is_set or
                                    self.table_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf-l3vpn-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "security-id" or name == "table-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix


                        class Cev4L3VpnData(Entity):
                            """
                            L3VPN CEv4 label context
                            
                            .. attribute:: ipv4_next_hop
                            
                            	IPv4 nexthop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Cev4L3VpnData, self).__init__()

                                self.yang_name = "cev4l3vpn-data"
                                self.yang_parent_name = "key"

                                self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                self.security_id = YLeaf(YType.uint32, "security-id")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ipv4_next_hop",
                                                "security_id",
                                                "table_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Cev4L3VpnData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Cev4L3VpnData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ipv4_next_hop.is_set or
                                    self.security_id.is_set or
                                    self.table_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ipv4_next_hop.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "cev4l3vpn-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4-next-hop" or name == "security-id" or name == "table-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ipv4-next-hop"):
                                    self.ipv4_next_hop = value
                                    self.ipv4_next_hop.value_namespace = name_space
                                    self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix


                        class Cev6L3VpnData(Entity):
                            """
                            L3VPN CEv6 label context
                            
                            .. attribute:: ipv6_next_hop
                            
                            	IPv6 nexthop
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Cev6L3VpnData, self).__init__()

                                self.yang_name = "cev6l3vpn-data"
                                self.yang_parent_name = "key"

                                self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                self.security_id = YLeaf(YType.uint32, "security-id")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ipv6_next_hop",
                                                "security_id",
                                                "table_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Cev6L3VpnData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Cev6L3VpnData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ipv6_next_hop.is_set or
                                    self.security_id.is_set or
                                    self.table_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ipv6_next_hop.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "cev6l3vpn-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv6-next-hop" or name == "security-id" or name == "table-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ipv6-next-hop"):
                                    self.ipv6_next_hop = value
                                    self.ipv6_next_hop.value_namespace = name_space
                                    self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix


                        class PseudowireData(Entity):
                            """
                            Pseudowire label context
                            
                            .. attribute:: prefix
                            
                            	Address prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: pseudowire_id
                            
                            	Pseudo\-wire ID
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: remote_l2_router_id
                            
                            	Remote L2 Router ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: subinterface
                            
                            	Subinterface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PseudowireData, self).__init__()

                                self.yang_name = "pseudowire-data"
                                self.yang_parent_name = "key"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.pseudowire_id = YLeaf(YType.uint64, "pseudowire-id")

                                self.remote_l2_router_id = YLeaf(YType.uint32, "remote-l2-router-id")

                                self.subinterface = YLeaf(YType.str, "subinterface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "pseudowire_id",
                                                "remote_l2_router_id",
                                                "subinterface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PseudowireData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PseudowireData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.pseudowire_id.is_set or
                                    self.remote_l2_router_id.is_set or
                                    self.subinterface.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.pseudowire_id.yfilter != YFilter.not_set or
                                    self.remote_l2_router_id.yfilter != YFilter.not_set or
                                    self.subinterface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pseudowire-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pseudowire_id.get_name_leafdata())
                                if (self.remote_l2_router_id.is_set or self.remote_l2_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_l2_router_id.get_name_leafdata())
                                if (self.subinterface.is_set or self.subinterface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.subinterface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "pseudowire-id" or name == "remote-l2-router-id" or name == "subinterface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "pseudowire-id"):
                                    self.pseudowire_id = value
                                    self.pseudowire_id.value_namespace = name_space
                                    self.pseudowire_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-l2-router-id"):
                                    self.remote_l2_router_id = value
                                    self.remote_l2_router_id.value_namespace = name_space
                                    self.remote_l2_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "subinterface"):
                                    self.subinterface = value
                                    self.subinterface.value_namespace = name_space
                                    self.subinterface.value_namespace_prefix = name_space_prefix


                        class LabelBlockData(Entity):
                            """
                            Label block context
                            
                            .. attribute:: edge_id
                            
                            	Edge ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: offset
                            
                            	Offset
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: service
                            
                            	Service
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: size
                            
                            	Number of labels
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: vpn_id
                            
                            	VPN ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.LabelBlockData, self).__init__()

                                self.yang_name = "label-block-data"
                                self.yang_parent_name = "key"

                                self.edge_id = YLeaf(YType.uint16, "edge-id")

                                self.offset = YLeaf(YType.uint32, "offset")

                                self.service = YLeaf(YType.uint8, "service")

                                self.size = YLeaf(YType.uint32, "size")

                                self.vpn_id = YLeaf(YType.uint16, "vpn-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("edge_id",
                                                "offset",
                                                "service",
                                                "size",
                                                "vpn_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.LabelBlockData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.LabelBlockData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.edge_id.is_set or
                                    self.offset.is_set or
                                    self.service.is_set or
                                    self.size.is_set or
                                    self.vpn_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.edge_id.yfilter != YFilter.not_set or
                                    self.offset.yfilter != YFilter.not_set or
                                    self.service.yfilter != YFilter.not_set or
                                    self.size.yfilter != YFilter.not_set or
                                    self.vpn_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-block-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.edge_id.is_set or self.edge_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.edge_id.get_name_leafdata())
                                if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.offset.get_name_leafdata())
                                if (self.service.is_set or self.service.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.service.get_name_leafdata())
                                if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.size.get_name_leafdata())
                                if (self.vpn_id.is_set or self.vpn_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.vpn_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "edge-id" or name == "offset" or name == "service" or name == "size" or name == "vpn-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "edge-id"):
                                    self.edge_id = value
                                    self.edge_id.value_namespace = name_space
                                    self.edge_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "offset"):
                                    self.offset = value
                                    self.offset.value_namespace = name_space
                                    self.offset.value_namespace_prefix = name_space_prefix
                                if(value_path == "service"):
                                    self.service = value
                                    self.service.value_namespace = name_space
                                    self.service.value_namespace_prefix = name_space_prefix
                                if(value_path == "size"):
                                    self.size = value
                                    self.size.value_namespace = name_space
                                    self.size.value_namespace_prefix = name_space_prefix
                                if(value_path == "vpn-id"):
                                    self.vpn_id = value
                                    self.vpn_id.value_namespace = name_space
                                    self.vpn_id.value_namespace_prefix = name_space_prefix


                        class IpSubData(Entity):
                            """
                            IP Subscriber context
                            
                            .. attribute:: parent_interface
                            
                            	Parent interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: table_id
                            
                            	Table Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.IpSubData, self).__init__()

                                self.yang_name = "ip-sub-data"
                                self.yang_parent_name = "key"

                                self.parent_interface = YLeaf(YType.str, "parent-interface")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("parent_interface",
                                                "table_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.IpSubData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.IpSubData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.parent_interface.is_set or
                                    self.table_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.parent_interface.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ip-sub-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.parent_interface.is_set or self.parent_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "parent-interface" or name == "table-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "parent-interface"):
                                    self.parent_interface = value
                                    self.parent_interface.value_namespace = name_space
                                    self.parent_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix


                        class Tev4P2MpData(Entity):
                            """
                            TEv4 P2MP context
                            
                            .. attribute:: p2mp_id
                            
                            	Point to multipoint ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: previous_hop
                            
                            	Previous hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_id_extension
                            
                            	Tunnel ID extension
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_lsp_id
                            
                            	Tunnel LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_source
                            
                            	Tunnel source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Tev4P2MpData, self).__init__()

                                self.yang_name = "tev4p2mp-data"
                                self.yang_parent_name = "key"

                                self.p2mp_id = YLeaf(YType.uint32, "p2mp-id")

                                self.previous_hop = YLeaf(YType.str, "previous-hop")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("p2mp_id",
                                                "previous_hop",
                                                "table_id",
                                                "tunnel_id",
                                                "tunnel_id_extension",
                                                "tunnel_lsp_id",
                                                "tunnel_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Tev4P2MpData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Tev4P2MpData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.p2mp_id.is_set or
                                    self.previous_hop.is_set or
                                    self.table_id.is_set or
                                    self.tunnel_id.is_set or
                                    self.tunnel_id_extension.is_set or
                                    self.tunnel_lsp_id.is_set or
                                    self.tunnel_source.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.p2mp_id.yfilter != YFilter.not_set or
                                    self.previous_hop.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.tunnel_id.yfilter != YFilter.not_set or
                                    self.tunnel_id_extension.yfilter != YFilter.not_set or
                                    self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                    self.tunnel_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tev4p2mp-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                                if (self.previous_hop.is_set or self.previous_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.previous_hop.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "p2mp-id" or name == "previous-hop" or name == "table-id" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "p2mp-id"):
                                    self.p2mp_id = value
                                    self.p2mp_id.value_namespace = name_space
                                    self.p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "previous-hop"):
                                    self.previous_hop = value
                                    self.previous_hop.value_namespace = name_space
                                    self.previous_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id"):
                                    self.tunnel_id = value
                                    self.tunnel_id.value_namespace = name_space
                                    self.tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id-extension"):
                                    self.tunnel_id_extension = value
                                    self.tunnel_id_extension.value_namespace = name_space
                                    self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-lsp-id"):
                                    self.tunnel_lsp_id = value
                                    self.tunnel_lsp_id.value_namespace = name_space
                                    self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-source"):
                                    self.tunnel_source = value
                                    self.tunnel_source.value_namespace = name_space
                                    self.tunnel_source.value_namespace_prefix = name_space_prefix


                        class MldPv4Data(Entity):
                            """
                            MLDPv4 LSM\-ID context
                            
                            .. attribute:: lsm_id
                            
                            	LSM ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: peer_label_space_id
                            
                            	Peer Label Space Id
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: peer_lsrid
                            
                            	Peer LSR Id
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: type
                            
                            	LSM ID Type
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.MldPv4Data, self).__init__()

                                self.yang_name = "mld-pv4-data"
                                self.yang_parent_name = "key"

                                self.lsm_id = YLeaf(YType.uint32, "lsm-id")

                                self.peer_label_space_id = YLeaf(YType.uint16, "peer-label-space-id")

                                self.peer_lsrid = YLeaf(YType.str, "peer-lsrid")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.type = YLeaf(YType.uint16, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsm_id",
                                                "peer_label_space_id",
                                                "peer_lsrid",
                                                "table_id",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.MldPv4Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.MldPv4Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsm_id.is_set or
                                    self.peer_label_space_id.is_set or
                                    self.peer_lsrid.is_set or
                                    self.table_id.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsm_id.yfilter != YFilter.not_set or
                                    self.peer_label_space_id.yfilter != YFilter.not_set or
                                    self.peer_lsrid.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "mld-pv4-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsm_id.is_set or self.lsm_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsm_id.get_name_leafdata())
                                if (self.peer_label_space_id.is_set or self.peer_label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peer_label_space_id.get_name_leafdata())
                                if (self.peer_lsrid.is_set or self.peer_lsrid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peer_lsrid.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsm-id" or name == "peer-label-space-id" or name == "peer-lsrid" or name == "table-id" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsm-id"):
                                    self.lsm_id = value
                                    self.lsm_id.value_namespace = name_space
                                    self.lsm_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "peer-label-space-id"):
                                    self.peer_label_space_id = value
                                    self.peer_label_space_id.value_namespace = name_space
                                    self.peer_label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "peer-lsrid"):
                                    self.peer_lsrid = value
                                    self.peer_lsrid.value_namespace = name_space
                                    self.peer_lsrid.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix


                        class PseudowireHeadEndData(Entity):
                            """
                            Pseudowire Head\-end label context
                            
                            .. attribute:: pwhe_intf
                            
                            	Pseudo\-wire Head\-end interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PseudowireHeadEndData, self).__init__()

                                self.yang_name = "pseudowire-head-end-data"
                                self.yang_parent_name = "key"

                                self.pwhe_intf = YLeaf(YType.str, "pwhe-intf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("pwhe_intf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PseudowireHeadEndData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PseudowireHeadEndData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.pwhe_intf.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.pwhe_intf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pseudowire-head-end-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.pwhe_intf.is_set or self.pwhe_intf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pwhe_intf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "pwhe-intf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "pwhe-intf"):
                                    self.pwhe_intf = value
                                    self.pwhe_intf.value_namespace = name_space
                                    self.pwhe_intf.value_namespace_prefix = name_space_prefix


                        class TpData(Entity):
                            """
                            TP context
                            
                            .. attribute:: dest_global_id
                            
                            	TP destination global ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: dest_node_id
                            
                            	TP destination node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: dest_tunnel_id
                            
                            	TP destination tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsp_id
                            
                            	TP LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: source_global_id
                            
                            	TP source global ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: source_node_id
                            
                            	TP source node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: source_tunnel_id
                            
                            	TP source tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.TpData, self).__init__()

                                self.yang_name = "tp-data"
                                self.yang_parent_name = "key"

                                self.dest_global_id = YLeaf(YType.uint32, "dest-global-id")

                                self.dest_node_id = YLeaf(YType.str, "dest-node-id")

                                self.dest_tunnel_id = YLeaf(YType.uint16, "dest-tunnel-id")

                                self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                                self.source_node_id = YLeaf(YType.str, "source-node-id")

                                self.source_tunnel_id = YLeaf(YType.uint16, "source-tunnel-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("dest_global_id",
                                                "dest_node_id",
                                                "dest_tunnel_id",
                                                "lsp_id",
                                                "source_global_id",
                                                "source_node_id",
                                                "source_tunnel_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.TpData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.TpData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.dest_global_id.is_set or
                                    self.dest_node_id.is_set or
                                    self.dest_tunnel_id.is_set or
                                    self.lsp_id.is_set or
                                    self.source_global_id.is_set or
                                    self.source_node_id.is_set or
                                    self.source_tunnel_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.dest_global_id.yfilter != YFilter.not_set or
                                    self.dest_node_id.yfilter != YFilter.not_set or
                                    self.dest_tunnel_id.yfilter != YFilter.not_set or
                                    self.lsp_id.yfilter != YFilter.not_set or
                                    self.source_global_id.yfilter != YFilter.not_set or
                                    self.source_node_id.yfilter != YFilter.not_set or
                                    self.source_tunnel_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tp-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.dest_global_id.is_set or self.dest_global_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dest_global_id.get_name_leafdata())
                                if (self.dest_node_id.is_set or self.dest_node_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dest_node_id.get_name_leafdata())
                                if (self.dest_tunnel_id.is_set or self.dest_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dest_tunnel_id.get_name_leafdata())
                                if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_id.get_name_leafdata())
                                if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.source_global_id.get_name_leafdata())
                                if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.source_node_id.get_name_leafdata())
                                if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dest-global-id" or name == "dest-node-id" or name == "dest-tunnel-id" or name == "lsp-id" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "dest-global-id"):
                                    self.dest_global_id = value
                                    self.dest_global_id.value_namespace = name_space
                                    self.dest_global_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "dest-node-id"):
                                    self.dest_node_id = value
                                    self.dest_node_id.value_namespace = name_space
                                    self.dest_node_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "dest-tunnel-id"):
                                    self.dest_tunnel_id = value
                                    self.dest_tunnel_id.value_namespace = name_space
                                    self.dest_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-id"):
                                    self.lsp_id = value
                                    self.lsp_id.value_namespace = name_space
                                    self.lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "source-global-id"):
                                    self.source_global_id = value
                                    self.source_global_id.value_namespace = name_space
                                    self.source_global_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "source-node-id"):
                                    self.source_node_id = value
                                    self.source_node_id.value_namespace = name_space
                                    self.source_node_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "source-tunnel-id"):
                                    self.source_tunnel_id = value
                                    self.source_tunnel_id.value_namespace = name_space
                                    self.source_tunnel_id.value_namespace_prefix = name_space_prefix


                        class GenericRoutingEncapsulation(Entity):
                            """
                            Generic routing encapsulation context
                            
                            .. attribute:: gre_interface
                            
                            	Generic routing encapsulation interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.GenericRoutingEncapsulation, self).__init__()

                                self.yang_name = "generic-routing-encapsulation"
                                self.yang_parent_name = "key"

                                self.gre_interface = YLeaf(YType.str, "gre-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("gre_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.GenericRoutingEncapsulation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.GenericRoutingEncapsulation, self).__setattr__(name, value)

                            def has_data(self):
                                return self.gre_interface.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.gre_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-routing-encapsulation" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.gre_interface.is_set or self.gre_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.gre_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "gre-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "gre-interface"):
                                    self.gre_interface = value
                                    self.gre_interface.value_namespace = name_space
                                    self.gre_interface.value_namespace_prefix = name_space_prefix


                        class Ipv6GenericRoutingEncapsulation(Entity):
                            """
                            Generic routing encapsulation context
                            
                            .. attribute:: greipv6_interface
                            
                            	Generic routing encapsulation IPv6 interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6GenericRoutingEncapsulation, self).__init__()

                                self.yang_name = "ipv6-generic-routing-encapsulation"
                                self.yang_parent_name = "key"

                                self.greipv6_interface = YLeaf(YType.str, "greipv6-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("greipv6_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)

                            def has_data(self):
                                return self.greipv6_interface.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.greipv6_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv6-generic-routing-encapsulation" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.greipv6_interface.is_set or self.greipv6_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.greipv6_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "greipv6-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "greipv6-interface"):
                                    self.greipv6_interface = value
                                    self.greipv6_interface.value_namespace = name_space
                                    self.greipv6_interface.value_namespace_prefix = name_space_prefix


                        class EvpnData(Entity):
                            """
                            EVPN context
                            
                            .. attribute:: ethernet_segment
                            
                            	Ethernet Segment ID
                            	**type**\:  str
                            
                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                            
                            .. attribute:: evpn_id
                            
                            	EVPN ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: evpn_tag
                            
                            	EVPN TAG
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.EvpnData, self).__init__()

                                self.yang_name = "evpn-data"
                                self.yang_parent_name = "key"

                                self.ethernet_segment = YLeaf(YType.str, "ethernet-segment")

                                self.evpn_id = YLeaf(YType.uint32, "evpn-id")

                                self.evpn_tag = YLeaf(YType.uint32, "evpn-tag")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ethernet_segment",
                                                "evpn_id",
                                                "evpn_tag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.EvpnData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.EvpnData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ethernet_segment.is_set or
                                    self.evpn_id.is_set or
                                    self.evpn_tag.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ethernet_segment.yfilter != YFilter.not_set or
                                    self.evpn_id.yfilter != YFilter.not_set or
                                    self.evpn_tag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "evpn-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ethernet_segment.is_set or self.ethernet_segment.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ethernet_segment.get_name_leafdata())
                                if (self.evpn_id.is_set or self.evpn_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.evpn_id.get_name_leafdata())
                                if (self.evpn_tag.is_set or self.evpn_tag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.evpn_tag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ethernet-segment" or name == "evpn-id" or name == "evpn-tag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ethernet-segment"):
                                    self.ethernet_segment = value
                                    self.ethernet_segment.value_namespace = name_space
                                    self.ethernet_segment.value_namespace_prefix = name_space_prefix
                                if(value_path == "evpn-id"):
                                    self.evpn_id = value
                                    self.evpn_id.value_namespace = name_space
                                    self.evpn_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "evpn-tag"):
                                    self.evpn_tag = value
                                    self.evpn_tag.value_namespace = name_space
                                    self.evpn_tag.value_namespace_prefix = name_space_prefix


                        class Ipv4BlbData(Entity):
                            """
                            BFD BLB label context
                            
                            .. attribute:: blb_intf
                            
                            	BFD BLB interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: prefix
                            
                            	IPv4 prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4BlbData, self).__init__()

                                self.yang_name = "ipv4blb-data"
                                self.yang_parent_name = "key"

                                self.blb_intf = YLeaf(YType.str, "blb-intf")

                                self.prefix = YLeaf(YType.str, "prefix")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("blb_intf",
                                                "prefix") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4BlbData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4BlbData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.blb_intf.is_set or
                                    self.prefix.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.blb_intf.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4blb-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "blb-intf" or name == "prefix"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "blb-intf"):
                                    self.blb_intf = value
                                    self.blb_intf.value_namespace = name_space
                                    self.blb_intf.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix


                        class Ipv6BlbData(Entity):
                            """
                            BFD BLB label context
                            
                            .. attribute:: blb_intf
                            
                            	BFD BLB interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: prefix
                            
                            	IPv6 prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6BlbData, self).__init__()

                                self.yang_name = "ipv6blb-data"
                                self.yang_parent_name = "key"

                                self.blb_intf = YLeaf(YType.str, "blb-intf")

                                self.prefix = YLeaf(YType.str, "prefix")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("blb_intf",
                                                "prefix") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6BlbData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6BlbData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.blb_intf.is_set or
                                    self.prefix.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.blb_intf.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv6blb-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "blb-intf" or name == "prefix"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "blb-intf"):
                                    self.blb_intf = value
                                    self.blb_intf.value_namespace = name_space
                                    self.blb_intf.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix


                        class PiMiPmsiData(Entity):
                            """
                            PIM I\-PMSI label conext
                            
                            .. attribute:: head
                            
                            	Head
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: v6
                            
                            	PIM6
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: vrf_id
                            
                            	VRF ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PiMiPmsiData, self).__init__()

                                self.yang_name = "pi-mi-pmsi-data"
                                self.yang_parent_name = "key"

                                self.head = YLeaf(YType.int32, "head")

                                self.v6 = YLeaf(YType.int32, "v6")

                                self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("head",
                                                "v6",
                                                "vrf_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PiMiPmsiData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PiMiPmsiData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.head.is_set or
                                    self.v6.is_set or
                                    self.vrf_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.head.yfilter != YFilter.not_set or
                                    self.v6.yfilter != YFilter.not_set or
                                    self.vrf_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pi-mi-pmsi-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.head.get_name_leafdata())
                                if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.v6.get_name_leafdata())
                                if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "head" or name == "v6" or name == "vrf-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "head"):
                                    self.head = value
                                    self.head.value_namespace = name_space
                                    self.head.value_namespace_prefix = name_space_prefix
                                if(value_path == "v6"):
                                    self.v6 = value
                                    self.v6.value_namespace = name_space
                                    self.v6.value_namespace_prefix = name_space_prefix
                                if(value_path == "vrf-id"):
                                    self.vrf_id = value
                                    self.vrf_id.value_namespace = name_space
                                    self.vrf_id.value_namespace_prefix = name_space_prefix


                        class PiMsPmsiData(Entity):
                            """
                            PIM S\-PMSI label conext
                            
                            .. attribute:: head
                            
                            	Head
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: hli
                            
                            	Head LSM\-ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: seg
                            
                            	Segmented Multicast
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: source
                            
                            	Originating Router
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: v6
                            
                            	PIM6
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: vrf_id
                            
                            	VRF ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PiMsPmsiData, self).__init__()

                                self.yang_name = "pi-ms-pmsi-data"
                                self.yang_parent_name = "key"

                                self.head = YLeaf(YType.int32, "head")

                                self.hli = YLeaf(YType.uint32, "hli")

                                self.seg = YLeaf(YType.int32, "seg")

                                self.source = YLeaf(YType.str, "source")

                                self.v6 = YLeaf(YType.int32, "v6")

                                self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("head",
                                                "hli",
                                                "seg",
                                                "source",
                                                "v6",
                                                "vrf_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PiMsPmsiData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PiMsPmsiData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.head.is_set or
                                    self.hli.is_set or
                                    self.seg.is_set or
                                    self.source.is_set or
                                    self.v6.is_set or
                                    self.vrf_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.head.yfilter != YFilter.not_set or
                                    self.hli.yfilter != YFilter.not_set or
                                    self.seg.yfilter != YFilter.not_set or
                                    self.source.yfilter != YFilter.not_set or
                                    self.v6.yfilter != YFilter.not_set or
                                    self.vrf_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pi-ms-pmsi-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.head.get_name_leafdata())
                                if (self.hli.is_set or self.hli.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hli.get_name_leafdata())
                                if (self.seg.is_set or self.seg.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.seg.get_name_leafdata())
                                if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.source.get_name_leafdata())
                                if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.v6.get_name_leafdata())
                                if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "head" or name == "hli" or name == "seg" or name == "source" or name == "v6" or name == "vrf-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "head"):
                                    self.head = value
                                    self.head.value_namespace = name_space
                                    self.head.value_namespace_prefix = name_space_prefix
                                if(value_path == "hli"):
                                    self.hli = value
                                    self.hli.value_namespace = name_space
                                    self.hli.value_namespace_prefix = name_space_prefix
                                if(value_path == "seg"):
                                    self.seg = value
                                    self.seg.value_namespace = name_space
                                    self.seg.value_namespace_prefix = name_space_prefix
                                if(value_path == "source"):
                                    self.source = value
                                    self.source.value_namespace = name_space
                                    self.source.value_namespace_prefix = name_space_prefix
                                if(value_path == "v6"):
                                    self.v6 = value
                                    self.v6.value_namespace = name_space
                                    self.v6.value_namespace_prefix = name_space_prefix
                                if(value_path == "vrf-id"):
                                    self.vrf_id = value
                                    self.vrf_id.value_namespace = name_space
                                    self.vrf_id.value_namespace_prefix = name_space_prefix


                        class NextHopSetL3Vpn(Entity):
                            """
                            L3VPN NH SET label context
                            
                            .. attribute:: next_hop_set_id
                            
                            	Next Hop Set ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.NextHopSetL3Vpn, self).__init__()

                                self.yang_name = "next-hop-set-l3vpn"
                                self.yang_parent_name = "key"

                                self.next_hop_set_id = YLeaf(YType.uint32, "next-hop-set-id")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_set_id",
                                                "table_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.NextHopSetL3Vpn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.NextHopSetL3Vpn, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.next_hop_set_id.is_set or
                                    self.table_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_set_id.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-set-l3vpn" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_set_id.is_set or self.next_hop_set_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_set_id.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "next-hop-set-id" or name == "table-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-set-id"):
                                    self.next_hop_set_id = value
                                    self.next_hop_set_id.value_namespace = name_space
                                    self.next_hop_set_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix


                        class SrPrefixSegment(Entity):
                            """
                            SR Prefix Segment context
                            
                            .. attribute:: segment_id
                            
                            	Prefix Segment ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrPrefixSegment, self).__init__()

                                self.yang_name = "sr-prefix-segment"
                                self.yang_parent_name = "key"

                                self.segment_id = YLeaf(YType.uint32, "segment-id")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("segment_id",
                                                "table_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrPrefixSegment, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrPrefixSegment, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.segment_id.is_set or
                                    self.table_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.segment_id.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sr-prefix-segment" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.segment_id.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "segment-id" or name == "table-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "segment-id"):
                                    self.segment_id = value
                                    self.segment_id.value_namespace = name_space
                                    self.segment_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix


                        class SrAdjSegmentIpv4(Entity):
                            """
                            SR Adj Segment ipv4 context
                            
                            .. attribute:: addr
                            
                            	Adjacency nexthop IPv4 address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: index
                            
                            	Adjacency index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: intf
                            
                            	Adjacency interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: type
                            
                            	Adjacency type
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrAdjSegmentIpv4, self).__init__()

                                self.yang_name = "sr-adj-segment-ipv4"
                                self.yang_parent_name = "key"

                                self.addr = YLeaf(YType.str, "addr")

                                self.index = YLeaf(YType.uint32, "index")

                                self.intf = YLeaf(YType.str, "intf")

                                self.type = YLeaf(YType.uint32, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("addr",
                                                "index",
                                                "intf",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrAdjSegmentIpv4, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrAdjSegmentIpv4, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.addr.is_set or
                                    self.index.is_set or
                                    self.intf.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.addr.yfilter != YFilter.not_set or
                                    self.index.yfilter != YFilter.not_set or
                                    self.intf.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sr-adj-segment-ipv4" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.addr.get_name_leafdata())
                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.index.get_name_leafdata())
                                if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.intf.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "addr"):
                                    self.addr = value
                                    self.addr.value_namespace = name_space
                                    self.addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "index"):
                                    self.index = value
                                    self.index.value_namespace = name_space
                                    self.index.value_namespace_prefix = name_space_prefix
                                if(value_path == "intf"):
                                    self.intf = value
                                    self.intf.value_namespace = name_space
                                    self.intf.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix


                        class SrAdjSegmentIpv6(Entity):
                            """
                            SR Adj Segment ipv6 context
                            
                            .. attribute:: addr
                            
                            	Adjacency nexthop IPv6 address
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: index
                            
                            	Adjacency index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: intf
                            
                            	Adjacency interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: type
                            
                            	Adjacency type
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrAdjSegmentIpv6, self).__init__()

                                self.yang_name = "sr-adj-segment-ipv6"
                                self.yang_parent_name = "key"

                                self.addr = YLeaf(YType.str, "addr")

                                self.index = YLeaf(YType.uint32, "index")

                                self.intf = YLeaf(YType.str, "intf")

                                self.type = YLeaf(YType.uint32, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("addr",
                                                "index",
                                                "intf",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrAdjSegmentIpv6, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrAdjSegmentIpv6, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.addr.is_set or
                                    self.index.is_set or
                                    self.intf.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.addr.yfilter != YFilter.not_set or
                                    self.index.yfilter != YFilter.not_set or
                                    self.intf.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sr-adj-segment-ipv6" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.addr.get_name_leafdata())
                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.index.get_name_leafdata())
                                if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.intf.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "addr"):
                                    self.addr = value
                                    self.addr.value_namespace = name_space
                                    self.addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "index"):
                                    self.index = value
                                    self.index.value_namespace = name_space
                                    self.index.value_namespace_prefix = name_space_prefix
                                if(value_path == "intf"):
                                    self.intf = value
                                    self.intf.value_namespace = name_space
                                    self.intf.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix


                        class LabelBlockSrgbData(Entity):
                            """
                            Label block SRGB context
                            
                            .. attribute:: offset
                            
                            	Offset
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: size
                            
                            	Number of labels
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: start_label
                            
                            	Start Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.LabelBlockSrgbData, self).__init__()

                                self.yang_name = "label-block-srgb-data"
                                self.yang_parent_name = "key"

                                self.offset = YLeaf(YType.uint32, "offset")

                                self.size = YLeaf(YType.uint32, "size")

                                self.start_label = YLeaf(YType.uint32, "start-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("offset",
                                                "size",
                                                "start_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.LabelBlockSrgbData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.LabelBlockSrgbData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.offset.is_set or
                                    self.size.is_set or
                                    self.start_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.offset.yfilter != YFilter.not_set or
                                    self.size.yfilter != YFilter.not_set or
                                    self.start_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-block-srgb-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.offset.get_name_leafdata())
                                if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.size.get_name_leafdata())
                                if (self.start_label.is_set or self.start_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.start_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "offset" or name == "size" or name == "start-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "offset"):
                                    self.offset = value
                                    self.offset.value_namespace = name_space
                                    self.offset.value_namespace_prefix = name_space_prefix
                                if(value_path == "size"):
                                    self.size = value
                                    self.size.value_namespace = name_space
                                    self.size.value_namespace_prefix = name_space_prefix
                                if(value_path == "start-label"):
                                    self.start_label = value
                                    self.start_label.value_namespace = name_space
                                    self.start_label.value_namespace_prefix = name_space_prefix


                        class TeBinding(Entity):
                            """
                            MPLS TE tunnel binding context
                            
                            .. attribute:: te_identifier
                            
                            	MPLS Traffic Engineering Tunnel or Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: te_type
                            
                            	Type of identifier for the binding
                            	**type**\:   :py:class:`MgmtLsdTeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdTeBinding>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.TeBinding, self).__init__()

                                self.yang_name = "te-binding"
                                self.yang_parent_name = "key"

                                self.te_identifier = YLeaf(YType.uint32, "te-identifier")

                                self.te_type = YLeaf(YType.enumeration, "te-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("te_identifier",
                                                "te_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.TeBinding, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.TeBinding, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.te_identifier.is_set or
                                    self.te_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.te_identifier.yfilter != YFilter.not_set or
                                    self.te_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-binding" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.te_identifier.is_set or self.te_identifier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.te_identifier.get_name_leafdata())
                                if (self.te_type.is_set or self.te_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.te_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-identifier" or name == "te-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "te-identifier"):
                                    self.te_identifier = value
                                    self.te_identifier.value_namespace = name_space
                                    self.te_identifier.value_namespace_prefix = name_space_prefix
                                if(value_path == "te-type"):
                                    self.te_type = value
                                    self.te_type.value_namespace = name_space
                                    self.te_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.label_context_type.is_set or
                                (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_data()) or
                                (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_data()) or
                                (self.evpn_data is not None and self.evpn_data.has_data()) or
                                (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_data()) or
                                (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                (self.ipv4blb_data is not None and self.ipv4blb_data.has_data()) or
                                (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_data()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_data()) or
                                (self.ipv6blb_data is not None and self.ipv6blb_data.has_data()) or
                                (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_data()) or
                                (self.label_block_data is not None and self.label_block_data.has_data()) or
                                (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_data()) or
                                (self.mld_pv4_data is not None and self.mld_pv4_data.has_data()) or
                                (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_data()) or
                                (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_data()) or
                                (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_data()) or
                                (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_data()) or
                                (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_data()) or
                                (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_data()) or
                                (self.te_binding is not None and self.te_binding.has_data()) or
                                (self.tev4_data is not None and self.tev4_data.has_data()) or
                                (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_data()) or
                                (self.tp_data is not None and self.tp_data.has_data()) or
                                (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.label_context_type.yfilter != YFilter.not_set or
                                (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_operation()) or
                                (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_operation()) or
                                (self.evpn_data is not None and self.evpn_data.has_operation()) or
                                (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_operation()) or
                                (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                (self.ipv4blb_data is not None and self.ipv4blb_data.has_operation()) or
                                (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_operation()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_operation()) or
                                (self.ipv6blb_data is not None and self.ipv6blb_data.has_operation()) or
                                (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_operation()) or
                                (self.label_block_data is not None and self.label_block_data.has_operation()) or
                                (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_operation()) or
                                (self.mld_pv4_data is not None and self.mld_pv4_data.has_operation()) or
                                (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_operation()) or
                                (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_operation()) or
                                (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_operation()) or
                                (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_operation()) or
                                (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_operation()) or
                                (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_operation()) or
                                (self.te_binding is not None and self.te_binding.has_operation()) or
                                (self.tev4_data is not None and self.tev4_data.has_operation()) or
                                (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_operation()) or
                                (self.tp_data is not None and self.tp_data.has_operation()) or
                                (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "key" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.label_context_type.is_set or self.label_context_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_context_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "cev4l3vpn-data"):
                                if (self.cev4l3vpn_data is None):
                                    self.cev4l3vpn_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Cev4L3VpnData()
                                    self.cev4l3vpn_data.parent = self
                                    self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                return self.cev4l3vpn_data

                            if (child_yang_name == "cev6l3vpn-data"):
                                if (self.cev6l3vpn_data is None):
                                    self.cev6l3vpn_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Cev6L3VpnData()
                                    self.cev6l3vpn_data.parent = self
                                    self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                return self.cev6l3vpn_data

                            if (child_yang_name == "evpn-data"):
                                if (self.evpn_data is None):
                                    self.evpn_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.EvpnData()
                                    self.evpn_data.parent = self
                                    self._children_name_map["evpn_data"] = "evpn-data"
                                return self.evpn_data

                            if (child_yang_name == "generic-routing-encapsulation"):
                                if (self.generic_routing_encapsulation is None):
                                    self.generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.GenericRoutingEncapsulation()
                                    self.generic_routing_encapsulation.parent = self
                                    self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                return self.generic_routing_encapsulation

                            if (child_yang_name == "ip-sub-data"):
                                if (self.ip_sub_data is None):
                                    self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.IpSubData()
                                    self.ip_sub_data.parent = self
                                    self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                return self.ip_sub_data

                            if (child_yang_name == "ipv4-data"):
                                if (self.ipv4_data is None):
                                    self.ipv4_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                return self.ipv4_data

                            if (child_yang_name == "ipv4blb-data"):
                                if (self.ipv4blb_data is None):
                                    self.ipv4blb_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4BlbData()
                                    self.ipv4blb_data.parent = self
                                    self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                return self.ipv4blb_data

                            if (child_yang_name == "ipv4l3vpn-data"):
                                if (self.ipv4l3vpn_data is None):
                                    self.ipv4l3vpn_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv4L3VpnData()
                                    self.ipv4l3vpn_data.parent = self
                                    self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                return self.ipv4l3vpn_data

                            if (child_yang_name == "ipv6-data"):
                                if (self.ipv6_data is None):
                                    self.ipv6_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                return self.ipv6_data

                            if (child_yang_name == "ipv6-generic-routing-encapsulation"):
                                if (self.ipv6_generic_routing_encapsulation is None):
                                    self.ipv6_generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6GenericRoutingEncapsulation()
                                    self.ipv6_generic_routing_encapsulation.parent = self
                                    self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                return self.ipv6_generic_routing_encapsulation

                            if (child_yang_name == "ipv6blb-data"):
                                if (self.ipv6blb_data is None):
                                    self.ipv6blb_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6BlbData()
                                    self.ipv6blb_data.parent = self
                                    self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                return self.ipv6blb_data

                            if (child_yang_name == "ipv6l3vpn-data"):
                                if (self.ipv6l3vpn_data is None):
                                    self.ipv6l3vpn_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Ipv6L3VpnData()
                                    self.ipv6l3vpn_data.parent = self
                                    self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                return self.ipv6l3vpn_data

                            if (child_yang_name == "label-block-data"):
                                if (self.label_block_data is None):
                                    self.label_block_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.LabelBlockData()
                                    self.label_block_data.parent = self
                                    self._children_name_map["label_block_data"] = "label-block-data"
                                return self.label_block_data

                            if (child_yang_name == "label-block-srgb-data"):
                                if (self.label_block_srgb_data is None):
                                    self.label_block_srgb_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.LabelBlockSrgbData()
                                    self.label_block_srgb_data.parent = self
                                    self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                return self.label_block_srgb_data

                            if (child_yang_name == "mld-pv4-data"):
                                if (self.mld_pv4_data is None):
                                    self.mld_pv4_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.MldPv4Data()
                                    self.mld_pv4_data.parent = self
                                    self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                return self.mld_pv4_data

                            if (child_yang_name == "next-hop-set-l3vpn"):
                                if (self.next_hop_set_l3vpn is None):
                                    self.next_hop_set_l3vpn = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.NextHopSetL3Vpn()
                                    self.next_hop_set_l3vpn.parent = self
                                    self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                return self.next_hop_set_l3vpn

                            if (child_yang_name == "pi-mi-pmsi-data"):
                                if (self.pi_mi_pmsi_data is None):
                                    self.pi_mi_pmsi_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PiMiPmsiData()
                                    self.pi_mi_pmsi_data.parent = self
                                    self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                return self.pi_mi_pmsi_data

                            if (child_yang_name == "pi-ms-pmsi-data"):
                                if (self.pi_ms_pmsi_data is None):
                                    self.pi_ms_pmsi_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PiMsPmsiData()
                                    self.pi_ms_pmsi_data.parent = self
                                    self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                return self.pi_ms_pmsi_data

                            if (child_yang_name == "pseudowire-data"):
                                if (self.pseudowire_data is None):
                                    self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PseudowireData()
                                    self.pseudowire_data.parent = self
                                    self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                return self.pseudowire_data

                            if (child_yang_name == "pseudowire-head-end-data"):
                                if (self.pseudowire_head_end_data is None):
                                    self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.PseudowireHeadEndData()
                                    self.pseudowire_head_end_data.parent = self
                                    self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                return self.pseudowire_head_end_data

                            if (child_yang_name == "sr-adj-segment-ipv4"):
                                if (self.sr_adj_segment_ipv4 is None):
                                    self.sr_adj_segment_ipv4 = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrAdjSegmentIpv4()
                                    self.sr_adj_segment_ipv4.parent = self
                                    self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                return self.sr_adj_segment_ipv4

                            if (child_yang_name == "sr-adj-segment-ipv6"):
                                if (self.sr_adj_segment_ipv6 is None):
                                    self.sr_adj_segment_ipv6 = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrAdjSegmentIpv6()
                                    self.sr_adj_segment_ipv6.parent = self
                                    self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                return self.sr_adj_segment_ipv6

                            if (child_yang_name == "sr-prefix-segment"):
                                if (self.sr_prefix_segment is None):
                                    self.sr_prefix_segment = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.SrPrefixSegment()
                                    self.sr_prefix_segment.parent = self
                                    self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                return self.sr_prefix_segment

                            if (child_yang_name == "te-binding"):
                                if (self.te_binding is None):
                                    self.te_binding = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.TeBinding()
                                    self.te_binding.parent = self
                                    self._children_name_map["te_binding"] = "te-binding"
                                return self.te_binding

                            if (child_yang_name == "tev4-data"):
                                if (self.tev4_data is None):
                                    self.tev4_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Tev4Data()
                                    self.tev4_data.parent = self
                                    self._children_name_map["tev4_data"] = "tev4-data"
                                return self.tev4_data

                            if (child_yang_name == "tev4p2mp-data"):
                                if (self.tev4p2mp_data is None):
                                    self.tev4p2mp_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.Tev4P2MpData()
                                    self.tev4p2mp_data.parent = self
                                    self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                return self.tev4p2mp_data

                            if (child_yang_name == "tp-data"):
                                if (self.tp_data is None):
                                    self.tp_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.TpData()
                                    self.tp_data.parent = self
                                    self._children_name_map["tp_data"] = "tp-data"
                                return self.tp_data

                            if (child_yang_name == "vrf-l3vpn-data"):
                                if (self.vrf_l3vpn_data is None):
                                    self.vrf_l3vpn_data = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key.VrfL3VpnData()
                                    self.vrf_l3vpn_data.parent = self
                                    self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                return self.vrf_l3vpn_data

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "cev4l3vpn-data" or name == "cev6l3vpn-data" or name == "evpn-data" or name == "generic-routing-encapsulation" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv4blb-data" or name == "ipv4l3vpn-data" or name == "ipv6-data" or name == "ipv6-generic-routing-encapsulation" or name == "ipv6blb-data" or name == "ipv6l3vpn-data" or name == "label-block-data" or name == "label-block-srgb-data" or name == "mld-pv4-data" or name == "next-hop-set-l3vpn" or name == "pi-mi-pmsi-data" or name == "pi-ms-pmsi-data" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "sr-adj-segment-ipv4" or name == "sr-adj-segment-ipv6" or name == "sr-prefix-segment" or name == "te-binding" or name == "tev4-data" or name == "tev4p2mp-data" or name == "tp-data" or name == "vrf-l3vpn-data" or name == "label-context-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "label-context-type"):
                                self.label_context_type = value
                                self.label_context_type.value_namespace = name_space
                                self.label_context_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.application_data.is_set or
                            (self.key is not None and self.key.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.application_data.yfilter != YFilter.not_set or
                            (self.key is not None and self.key.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "label-context" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.application_data.is_set or self.application_data.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_data.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "key"):
                            if (self.key is None):
                                self.key = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext.Key()
                                self.key.parent = self
                                self._children_name_map["key"] = "key"
                            return self.key

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "key" or name == "application-data"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "application-data"):
                            self.application_data = value
                            self.application_data.value_namespace = name_space
                            self.application_data.value_namespace_prefix = name_space_prefix


                class ApplicationOwner(Entity):
                    """
                    Application owner
                    
                    .. attribute:: application_instance
                    
                    	Application instance Name
                    	**type**\:  str
                    
                    .. attribute:: application_name
                    
                    	Application name
                    	**type**\:  str
                    
                    .. attribute:: application_role_primary
                    
                    	Primary/Backup role
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: application_type
                    
                    	Application type
                    	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                    
                    .. attribute:: resource_state
                    
                    	Application resource state
                    	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.Labels.Label.ApplicationOwner, self).__init__()

                        self.yang_name = "application-owner"
                        self.yang_parent_name = "label"

                        self.application_instance = YLeaf(YType.str, "application-instance")

                        self.application_name = YLeaf(YType.str, "application-name")

                        self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                        self.application_type = YLeaf(YType.enumeration, "application-type")

                        self.resource_state = YLeaf(YType.enumeration, "resource-state")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("application_instance",
                                        "application_name",
                                        "application_role_primary",
                                        "application_type",
                                        "resource_state") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.Labels.Label.ApplicationOwner, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.Labels.Label.ApplicationOwner, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.application_instance.is_set or
                            self.application_name.is_set or
                            self.application_role_primary.is_set or
                            self.application_type.is_set or
                            self.resource_state.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.application_instance.yfilter != YFilter.not_set or
                            self.application_name.yfilter != YFilter.not_set or
                            self.application_role_primary.yfilter != YFilter.not_set or
                            self.application_type.yfilter != YFilter.not_set or
                            self.resource_state.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "application-owner" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_instance.get_name_leafdata())
                        if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_name.get_name_leafdata())
                        if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                        if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_type.get_name_leafdata())
                        if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.resource_state.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "application-instance"):
                            self.application_instance = value
                            self.application_instance.value_namespace = name_space
                            self.application_instance.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-name"):
                            self.application_name = value
                            self.application_name.value_namespace = name_space
                            self.application_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-role-primary"):
                            self.application_role_primary = value
                            self.application_role_primary.value_namespace = name_space
                            self.application_role_primary.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-type"):
                            self.application_type = value
                            self.application_type.value_namespace = name_space
                            self.application_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "resource-state"):
                            self.resource_state = value
                            self.resource_state.value_namespace = name_space
                            self.resource_state.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.application_owner:
                        if (c.has_data()):
                            return True
                    return (
                        self.label_id.is_set or
                        self.label.is_set or
                        self.rewrite_is_bound.is_set or
                        self.rewrite_owners.is_set or
                        self.rs_iconnected.is_set or
                        self.vrf_name.is_set or
                        (self.label_context is not None and self.label_context.has_data()))

                def has_operation(self):
                    for c in self.application_owner:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.label_id.yfilter != YFilter.not_set or
                        self.label.yfilter != YFilter.not_set or
                        self.rewrite_is_bound.yfilter != YFilter.not_set or
                        self.rewrite_owners.yfilter != YFilter.not_set or
                        self.rs_iconnected.yfilter != YFilter.not_set or
                        self.vrf_name.yfilter != YFilter.not_set or
                        (self.label_context is not None and self.label_context.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "label" + "[label-id='" + self.label_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.label_id.is_set or self.label_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.label_id.get_name_leafdata())
                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.label.get_name_leafdata())
                    if (self.rewrite_is_bound.is_set or self.rewrite_is_bound.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rewrite_is_bound.get_name_leafdata())
                    if (self.rewrite_owners.is_set or self.rewrite_owners.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rewrite_owners.get_name_leafdata())
                    if (self.rs_iconnected.is_set or self.rs_iconnected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rs_iconnected.get_name_leafdata())
                    if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.vrf_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "application-owner"):
                        for c in self.application_owner:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsdNodes.MplsLsdNode.Labels.Label.ApplicationOwner()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.application_owner.append(c)
                        return c

                    if (child_yang_name == "label-context"):
                        if (self.label_context is None):
                            self.label_context = MplsLsdNodes.MplsLsdNode.Labels.Label.LabelContext()
                            self.label_context.parent = self
                            self._children_name_map["label_context"] = "label-context"
                        return self.label_context

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "application-owner" or name == "label-context" or name == "label-id" or name == "label" or name == "rewrite-is-bound" or name == "rewrite-owners" or name == "rs-iconnected" or name == "vrf-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "label-id"):
                        self.label_id = value
                        self.label_id.value_namespace = name_space
                        self.label_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "label"):
                        self.label = value
                        self.label.value_namespace = name_space
                        self.label.value_namespace_prefix = name_space_prefix
                    if(value_path == "rewrite-is-bound"):
                        self.rewrite_is_bound = value
                        self.rewrite_is_bound.value_namespace = name_space
                        self.rewrite_is_bound.value_namespace_prefix = name_space_prefix
                    if(value_path == "rewrite-owners"):
                        self.rewrite_owners = value
                        self.rewrite_owners.value_namespace = name_space
                        self.rewrite_owners.value_namespace_prefix = name_space_prefix
                    if(value_path == "rs-iconnected"):
                        self.rs_iconnected = value
                        self.rs_iconnected.value_namespace = name_space
                        self.rs_iconnected.value_namespace_prefix = name_space_prefix
                    if(value_path == "vrf-name"):
                        self.vrf_name = value
                        self.vrf_name.value_namespace = name_space
                        self.vrf_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.label:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.label:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "labels" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "label"):
                    for c in self.label:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsdNodes.MplsLsdNode.Labels.Label()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.label.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "label"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class FrrDatabase(Entity):
            """
            FRR database
            
            .. attribute:: summary_protected_interfaces
            
            	Sumary table of Protected Interfaces
            	**type**\:   :py:class:`SummaryProtectedInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.SummaryProtectedInterfaces>`
            
            .. attribute:: tunnel_head_summary
            
            	Summary data for FRR database entry \- Tunnel head
            	**type**\:   :py:class:`TunnelHeadSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeadSummary>`
            
            .. attribute:: tunnel_heads
            
            	Table of FRR database entries \- Tunnel heads
            	**type**\:   :py:class:`TunnelHeads <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads>`
            
            .. attribute:: tunnel_midpoint_summary
            
            	Summary data for FRR database entry \- Tunnel midpoint
            	**type**\:   :py:class:`TunnelMidpointSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpointSummary>`
            
            .. attribute:: tunnel_midpoints
            
            	Table of FRR database entries \- Tunnel midpoints
            	**type**\:   :py:class:`TunnelMidpoints <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints>`
            
            .. attribute:: tunnel_summary
            
            	Summary data for FRR database entry
            	**type**\:   :py:class:`TunnelSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelSummary>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsdNodes.MplsLsdNode.FrrDatabase, self).__init__()

                self.yang_name = "frr-database"
                self.yang_parent_name = "mpls-lsd-node"

                self.summary_protected_interfaces = MplsLsdNodes.MplsLsdNode.FrrDatabase.SummaryProtectedInterfaces()
                self.summary_protected_interfaces.parent = self
                self._children_name_map["summary_protected_interfaces"] = "summary-protected-interfaces"
                self._children_yang_names.add("summary-protected-interfaces")

                self.tunnel_head_summary = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeadSummary()
                self.tunnel_head_summary.parent = self
                self._children_name_map["tunnel_head_summary"] = "tunnel-head-summary"
                self._children_yang_names.add("tunnel-head-summary")

                self.tunnel_heads = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads()
                self.tunnel_heads.parent = self
                self._children_name_map["tunnel_heads"] = "tunnel-heads"
                self._children_yang_names.add("tunnel-heads")

                self.tunnel_midpoint_summary = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpointSummary()
                self.tunnel_midpoint_summary.parent = self
                self._children_name_map["tunnel_midpoint_summary"] = "tunnel-midpoint-summary"
                self._children_yang_names.add("tunnel-midpoint-summary")

                self.tunnel_midpoints = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints()
                self.tunnel_midpoints.parent = self
                self._children_name_map["tunnel_midpoints"] = "tunnel-midpoints"
                self._children_yang_names.add("tunnel-midpoints")

                self.tunnel_summary = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelSummary()
                self.tunnel_summary.parent = self
                self._children_name_map["tunnel_summary"] = "tunnel-summary"
                self._children_yang_names.add("tunnel-summary")


            class TunnelMidpoints(Entity):
                """
                Table of FRR database entries \- Tunnel
                midpoints
                
                .. attribute:: tunnel_midpoint
                
                	Data for FRR database entry \- Tunnel midpoint
                	**type**\: list of    :py:class:`TunnelMidpoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints, self).__init__()

                    self.yang_name = "tunnel-midpoints"
                    self.yang_parent_name = "frr-database"

                    self.tunnel_midpoint = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints, self).__setattr__(name, value)


                class TunnelMidpoint(Entity):
                    """
                    Data for FRR database entry \- Tunnel midpoint
                    
                    .. attribute:: label  <key>
                    
                    	Label value
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: entry_frr_state
                    
                    	MPLS FRR entry state
                    	**type**\:   :py:class:`MgmtLsdFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFrrState>`
                    
                    .. attribute:: frr_entry_id
                    
                    	FRR entry ID
                    	**type**\:   :py:class:`FrrEntryId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId>`
                    
                    .. attribute:: input_label
                    
                    	Input label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: out_path
                    
                    	Out Path List
                    	**type**\: list of    :py:class:`OutPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.OutPath>`
                    
                    .. attribute:: tunnel_interface
                    
                    	Tunnel interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint, self).__init__()

                        self.yang_name = "tunnel-midpoint"
                        self.yang_parent_name = "tunnel-midpoints"

                        self.label = YLeaf(YType.int32, "label")

                        self.entry_frr_state = YLeaf(YType.enumeration, "entry-frr-state")

                        self.input_label = YLeaf(YType.uint32, "input-label")

                        self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                        self.frr_entry_id = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId()
                        self.frr_entry_id.parent = self
                        self._children_name_map["frr_entry_id"] = "frr-entry-id"
                        self._children_yang_names.add("frr-entry-id")

                        self.out_path = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("label",
                                        "entry_frr_state",
                                        "input_label",
                                        "tunnel_interface") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint, self).__setattr__(name, value)


                    class FrrEntryId(Entity):
                        """
                        FRR entry ID
                        
                        .. attribute:: head
                        
                        	head
                        	**type**\:   :py:class:`Head <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Head>`
                        
                        .. attribute:: midpoint
                        
                        	midpoint
                        	**type**\:   :py:class:`Midpoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Midpoint>`
                        
                        .. attribute:: role
                        
                        	Role
                        	**type**\:   :py:class:`MgmtLsdLspRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLspRole>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId, self).__init__()

                            self.yang_name = "frr-entry-id"
                            self.yang_parent_name = "tunnel-midpoint"

                            self.role = YLeaf(YType.enumeration, "role")

                            self.head = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Head()
                            self.head.parent = self
                            self._children_name_map["head"] = "head"
                            self._children_yang_names.add("head")

                            self.midpoint = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Midpoint()
                            self.midpoint.parent = self
                            self._children_name_map["midpoint"] = "midpoint"
                            self._children_yang_names.add("midpoint")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("role") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId, self).__setattr__(name, value)


                        class Head(Entity):
                            """
                            head
                            
                            .. attribute:: destination_prefix
                            
                            	Destination prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: destination_prefix_length
                            
                            	Destination prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Head, self).__init__()

                                self.yang_name = "head"
                                self.yang_parent_name = "frr-entry-id"

                                self.destination_prefix = YLeaf(YType.str, "destination-prefix")

                                self.destination_prefix_length = YLeaf(YType.uint8, "destination-prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("destination_prefix",
                                                "destination_prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Head, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Head, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.destination_prefix.is_set or
                                    self.destination_prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.destination_prefix.yfilter != YFilter.not_set or
                                    self.destination_prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.destination_prefix.is_set or self.destination_prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_prefix.get_name_leafdata())
                                if (self.destination_prefix_length.is_set or self.destination_prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "destination-prefix" or name == "destination-prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "destination-prefix"):
                                    self.destination_prefix = value
                                    self.destination_prefix.value_namespace = name_space
                                    self.destination_prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "destination-prefix-length"):
                                    self.destination_prefix_length = value
                                    self.destination_prefix_length.value_namespace = name_space
                                    self.destination_prefix_length.value_namespace_prefix = name_space_prefix


                        class Midpoint(Entity):
                            """
                            midpoint
                            
                            .. attribute:: lspid
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: source_address
                            
                            	Source IPv4 address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Midpoint, self).__init__()

                                self.yang_name = "midpoint"
                                self.yang_parent_name = "frr-entry-id"

                                self.lspid = YLeaf(YType.uint32, "lspid")

                                self.source_address = YLeaf(YType.str, "source-address")

                                self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lspid",
                                                "source_address",
                                                "tunnel_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Midpoint, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Midpoint, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lspid.is_set or
                                    self.source_address.is_set or
                                    self.tunnel_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lspid.yfilter != YFilter.not_set or
                                    self.source_address.yfilter != YFilter.not_set or
                                    self.tunnel_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "midpoint" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lspid.is_set or self.lspid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspid.get_name_leafdata())
                                if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.source_address.get_name_leafdata())
                                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lspid" or name == "source-address" or name == "tunnel-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lspid"):
                                    self.lspid = value
                                    self.lspid.value_namespace = name_space
                                    self.lspid.value_namespace_prefix = name_space_prefix
                                if(value_path == "source-address"):
                                    self.source_address = value
                                    self.source_address.value_namespace = name_space
                                    self.source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id"):
                                    self.tunnel_id = value
                                    self.tunnel_id.value_namespace = name_space
                                    self.tunnel_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.role.is_set or
                                (self.head is not None and self.head.has_data()) or
                                (self.midpoint is not None and self.midpoint.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                (self.head is not None and self.head.has_operation()) or
                                (self.midpoint is not None and self.midpoint.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "frr-entry-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "head"):
                                if (self.head is None):
                                    self.head = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Head()
                                    self.head.parent = self
                                    self._children_name_map["head"] = "head"
                                return self.head

                            if (child_yang_name == "midpoint"):
                                if (self.midpoint is None):
                                    self.midpoint = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Midpoint()
                                    self.midpoint.parent = self
                                    self._children_name_map["midpoint"] = "midpoint"
                                return self.midpoint

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "head" or name == "midpoint" or name == "role"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix


                    class OutPath(Entity):
                        """
                        Out Path List
                        
                        .. attribute:: frr_interface
                        
                        	FRR interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: frr_label
                        
                        	FRR output label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: ipv4_next_hop
                        
                        	Next hop IPv4 address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: out_interface
                        
                        	Outgoing interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.OutPath, self).__init__()

                            self.yang_name = "out-path"
                            self.yang_parent_name = "tunnel-midpoint"

                            self.frr_interface = YLeaf(YType.str, "frr-interface")

                            self.frr_label = YLeaf(YType.uint32, "frr-label")

                            self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                            self.out_interface = YLeaf(YType.str, "out-interface")

                            self.out_label = YLeaf(YType.uint32, "out-label")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("frr_interface",
                                            "frr_label",
                                            "ipv4_next_hop",
                                            "out_interface",
                                            "out_label") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.OutPath, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.OutPath, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.frr_interface.is_set or
                                self.frr_label.is_set or
                                self.ipv4_next_hop.is_set or
                                self.out_interface.is_set or
                                self.out_label.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.frr_interface.yfilter != YFilter.not_set or
                                self.frr_label.yfilter != YFilter.not_set or
                                self.ipv4_next_hop.yfilter != YFilter.not_set or
                                self.out_interface.yfilter != YFilter.not_set or
                                self.out_label.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "out-path" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.frr_interface.is_set or self.frr_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_interface.get_name_leafdata())
                            if (self.frr_label.is_set or self.frr_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_label.get_name_leafdata())
                            if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                            if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_interface.get_name_leafdata())
                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_label.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "frr-interface" or name == "frr-label" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "frr-interface"):
                                self.frr_interface = value
                                self.frr_interface.value_namespace = name_space
                                self.frr_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-label"):
                                self.frr_label = value
                                self.frr_label.value_namespace = name_space
                                self.frr_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipv4-next-hop"):
                                self.ipv4_next_hop = value
                                self.ipv4_next_hop.value_namespace = name_space
                                self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-interface"):
                                self.out_interface = value
                                self.out_interface.value_namespace = name_space
                                self.out_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-label"):
                                self.out_label = value
                                self.out_label.value_namespace = name_space
                                self.out_label.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.out_path:
                            if (c.has_data()):
                                return True
                        return (
                            self.label.is_set or
                            self.entry_frr_state.is_set or
                            self.input_label.is_set or
                            self.tunnel_interface.is_set or
                            (self.frr_entry_id is not None and self.frr_entry_id.has_data()))

                    def has_operation(self):
                        for c in self.out_path:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.label.yfilter != YFilter.not_set or
                            self.entry_frr_state.yfilter != YFilter.not_set or
                            self.input_label.yfilter != YFilter.not_set or
                            self.tunnel_interface.yfilter != YFilter.not_set or
                            (self.frr_entry_id is not None and self.frr_entry_id.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-midpoint" + "[label='" + self.label.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.label.get_name_leafdata())
                        if (self.entry_frr_state.is_set or self.entry_frr_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry_frr_state.get_name_leafdata())
                        if (self.input_label.is_set or self.input_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.input_label.get_name_leafdata())
                        if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "frr-entry-id"):
                            if (self.frr_entry_id is None):
                                self.frr_entry_id = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId()
                                self.frr_entry_id.parent = self
                                self._children_name_map["frr_entry_id"] = "frr-entry-id"
                            return self.frr_entry_id

                        if (child_yang_name == "out-path"):
                            for c in self.out_path:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint.OutPath()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.out_path.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "frr-entry-id" or name == "out-path" or name == "label" or name == "entry-frr-state" or name == "input-label" or name == "tunnel-interface"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "label"):
                            self.label = value
                            self.label.value_namespace = name_space
                            self.label.value_namespace_prefix = name_space_prefix
                        if(value_path == "entry-frr-state"):
                            self.entry_frr_state = value
                            self.entry_frr_state.value_namespace = name_space
                            self.entry_frr_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "input-label"):
                            self.input_label = value
                            self.input_label.value_namespace = name_space
                            self.input_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-interface"):
                            self.tunnel_interface = value
                            self.tunnel_interface.value_namespace = name_space
                            self.tunnel_interface.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.tunnel_midpoint:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.tunnel_midpoint:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-midpoints" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "tunnel-midpoint"):
                        for c in self.tunnel_midpoint:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints.TunnelMidpoint()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.tunnel_midpoint.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tunnel-midpoint"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class TunnelHeads(Entity):
                """
                Table of FRR database entries \- Tunnel heads
                
                .. attribute:: tunnel_head
                
                	Data for FRR database entry \- Tunnel head
                	**type**\: list of    :py:class:`TunnelHead <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads, self).__init__()

                    self.yang_name = "tunnel-heads"
                    self.yang_parent_name = "frr-database"

                    self.tunnel_head = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads, self).__setattr__(name, value)


                class TunnelHead(Entity):
                    """
                    Data for FRR database entry \- Tunnel head
                    
                    .. attribute:: interface_name  <key>
                    
                    	Tunnel interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: entry_frr_state
                    
                    	MPLS FRR entry state
                    	**type**\:   :py:class:`MgmtLsdFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFrrState>`
                    
                    .. attribute:: frr_entry_id
                    
                    	FRR entry ID
                    	**type**\:   :py:class:`FrrEntryId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId>`
                    
                    .. attribute:: input_label
                    
                    	Input label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: out_path
                    
                    	Out Path List
                    	**type**\: list of    :py:class:`OutPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.OutPath>`
                    
                    .. attribute:: tunnel_interface
                    
                    	Tunnel interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead, self).__init__()

                        self.yang_name = "tunnel-head"
                        self.yang_parent_name = "tunnel-heads"

                        self.interface_name = YLeaf(YType.str, "interface-name")

                        self.entry_frr_state = YLeaf(YType.enumeration, "entry-frr-state")

                        self.input_label = YLeaf(YType.uint32, "input-label")

                        self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                        self.frr_entry_id = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId()
                        self.frr_entry_id.parent = self
                        self._children_name_map["frr_entry_id"] = "frr-entry-id"
                        self._children_yang_names.add("frr-entry-id")

                        self.out_path = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("interface_name",
                                        "entry_frr_state",
                                        "input_label",
                                        "tunnel_interface") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead, self).__setattr__(name, value)


                    class FrrEntryId(Entity):
                        """
                        FRR entry ID
                        
                        .. attribute:: head
                        
                        	head
                        	**type**\:   :py:class:`Head <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Head>`
                        
                        .. attribute:: midpoint
                        
                        	midpoint
                        	**type**\:   :py:class:`Midpoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Midpoint>`
                        
                        .. attribute:: role
                        
                        	Role
                        	**type**\:   :py:class:`MgmtLsdLspRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLspRole>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId, self).__init__()

                            self.yang_name = "frr-entry-id"
                            self.yang_parent_name = "tunnel-head"

                            self.role = YLeaf(YType.enumeration, "role")

                            self.head = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Head()
                            self.head.parent = self
                            self._children_name_map["head"] = "head"
                            self._children_yang_names.add("head")

                            self.midpoint = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Midpoint()
                            self.midpoint.parent = self
                            self._children_name_map["midpoint"] = "midpoint"
                            self._children_yang_names.add("midpoint")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("role") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId, self).__setattr__(name, value)


                        class Head(Entity):
                            """
                            head
                            
                            .. attribute:: destination_prefix
                            
                            	Destination prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: destination_prefix_length
                            
                            	Destination prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Head, self).__init__()

                                self.yang_name = "head"
                                self.yang_parent_name = "frr-entry-id"

                                self.destination_prefix = YLeaf(YType.str, "destination-prefix")

                                self.destination_prefix_length = YLeaf(YType.uint8, "destination-prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("destination_prefix",
                                                "destination_prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Head, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Head, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.destination_prefix.is_set or
                                    self.destination_prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.destination_prefix.yfilter != YFilter.not_set or
                                    self.destination_prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.destination_prefix.is_set or self.destination_prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_prefix.get_name_leafdata())
                                if (self.destination_prefix_length.is_set or self.destination_prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "destination-prefix" or name == "destination-prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "destination-prefix"):
                                    self.destination_prefix = value
                                    self.destination_prefix.value_namespace = name_space
                                    self.destination_prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "destination-prefix-length"):
                                    self.destination_prefix_length = value
                                    self.destination_prefix_length.value_namespace = name_space
                                    self.destination_prefix_length.value_namespace_prefix = name_space_prefix


                        class Midpoint(Entity):
                            """
                            midpoint
                            
                            .. attribute:: lspid
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: source_address
                            
                            	Source IPv4 address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Midpoint, self).__init__()

                                self.yang_name = "midpoint"
                                self.yang_parent_name = "frr-entry-id"

                                self.lspid = YLeaf(YType.uint32, "lspid")

                                self.source_address = YLeaf(YType.str, "source-address")

                                self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lspid",
                                                "source_address",
                                                "tunnel_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Midpoint, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Midpoint, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lspid.is_set or
                                    self.source_address.is_set or
                                    self.tunnel_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lspid.yfilter != YFilter.not_set or
                                    self.source_address.yfilter != YFilter.not_set or
                                    self.tunnel_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "midpoint" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lspid.is_set or self.lspid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspid.get_name_leafdata())
                                if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.source_address.get_name_leafdata())
                                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lspid" or name == "source-address" or name == "tunnel-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lspid"):
                                    self.lspid = value
                                    self.lspid.value_namespace = name_space
                                    self.lspid.value_namespace_prefix = name_space_prefix
                                if(value_path == "source-address"):
                                    self.source_address = value
                                    self.source_address.value_namespace = name_space
                                    self.source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id"):
                                    self.tunnel_id = value
                                    self.tunnel_id.value_namespace = name_space
                                    self.tunnel_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.role.is_set or
                                (self.head is not None and self.head.has_data()) or
                                (self.midpoint is not None and self.midpoint.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                (self.head is not None and self.head.has_operation()) or
                                (self.midpoint is not None and self.midpoint.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "frr-entry-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "head"):
                                if (self.head is None):
                                    self.head = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Head()
                                    self.head.parent = self
                                    self._children_name_map["head"] = "head"
                                return self.head

                            if (child_yang_name == "midpoint"):
                                if (self.midpoint is None):
                                    self.midpoint = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Midpoint()
                                    self.midpoint.parent = self
                                    self._children_name_map["midpoint"] = "midpoint"
                                return self.midpoint

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "head" or name == "midpoint" or name == "role"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix


                    class OutPath(Entity):
                        """
                        Out Path List
                        
                        .. attribute:: frr_interface
                        
                        	FRR interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: frr_label
                        
                        	FRR output label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: ipv4_next_hop
                        
                        	Next hop IPv4 address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: out_interface
                        
                        	Outgoing interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.OutPath, self).__init__()

                            self.yang_name = "out-path"
                            self.yang_parent_name = "tunnel-head"

                            self.frr_interface = YLeaf(YType.str, "frr-interface")

                            self.frr_label = YLeaf(YType.uint32, "frr-label")

                            self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                            self.out_interface = YLeaf(YType.str, "out-interface")

                            self.out_label = YLeaf(YType.uint32, "out-label")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("frr_interface",
                                            "frr_label",
                                            "ipv4_next_hop",
                                            "out_interface",
                                            "out_label") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.OutPath, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.OutPath, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.frr_interface.is_set or
                                self.frr_label.is_set or
                                self.ipv4_next_hop.is_set or
                                self.out_interface.is_set or
                                self.out_label.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.frr_interface.yfilter != YFilter.not_set or
                                self.frr_label.yfilter != YFilter.not_set or
                                self.ipv4_next_hop.yfilter != YFilter.not_set or
                                self.out_interface.yfilter != YFilter.not_set or
                                self.out_label.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "out-path" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.frr_interface.is_set or self.frr_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_interface.get_name_leafdata())
                            if (self.frr_label.is_set or self.frr_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_label.get_name_leafdata())
                            if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                            if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_interface.get_name_leafdata())
                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_label.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "frr-interface" or name == "frr-label" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "frr-interface"):
                                self.frr_interface = value
                                self.frr_interface.value_namespace = name_space
                                self.frr_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-label"):
                                self.frr_label = value
                                self.frr_label.value_namespace = name_space
                                self.frr_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipv4-next-hop"):
                                self.ipv4_next_hop = value
                                self.ipv4_next_hop.value_namespace = name_space
                                self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-interface"):
                                self.out_interface = value
                                self.out_interface.value_namespace = name_space
                                self.out_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-label"):
                                self.out_label = value
                                self.out_label.value_namespace = name_space
                                self.out_label.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.out_path:
                            if (c.has_data()):
                                return True
                        return (
                            self.interface_name.is_set or
                            self.entry_frr_state.is_set or
                            self.input_label.is_set or
                            self.tunnel_interface.is_set or
                            (self.frr_entry_id is not None and self.frr_entry_id.has_data()))

                    def has_operation(self):
                        for c in self.out_path:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.interface_name.yfilter != YFilter.not_set or
                            self.entry_frr_state.yfilter != YFilter.not_set or
                            self.input_label.yfilter != YFilter.not_set or
                            self.tunnel_interface.yfilter != YFilter.not_set or
                            (self.frr_entry_id is not None and self.frr_entry_id.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-head" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                        if (self.entry_frr_state.is_set or self.entry_frr_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry_frr_state.get_name_leafdata())
                        if (self.input_label.is_set or self.input_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.input_label.get_name_leafdata())
                        if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "frr-entry-id"):
                            if (self.frr_entry_id is None):
                                self.frr_entry_id = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId()
                                self.frr_entry_id.parent = self
                                self._children_name_map["frr_entry_id"] = "frr-entry-id"
                            return self.frr_entry_id

                        if (child_yang_name == "out-path"):
                            for c in self.out_path:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead.OutPath()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.out_path.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "frr-entry-id" or name == "out-path" or name == "interface-name" or name == "entry-frr-state" or name == "input-label" or name == "tunnel-interface"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "interface-name"):
                            self.interface_name = value
                            self.interface_name.value_namespace = name_space
                            self.interface_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "entry-frr-state"):
                            self.entry_frr_state = value
                            self.entry_frr_state.value_namespace = name_space
                            self.entry_frr_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "input-label"):
                            self.input_label = value
                            self.input_label.value_namespace = name_space
                            self.input_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-interface"):
                            self.tunnel_interface = value
                            self.tunnel_interface.value_namespace = name_space
                            self.tunnel_interface.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.tunnel_head:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.tunnel_head:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-heads" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "tunnel-head"):
                        for c in self.tunnel_head:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads.TunnelHead()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.tunnel_head.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tunnel-head"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class TunnelHeadSummary(Entity):
                """
                Summary data for FRR database entry \- Tunnel
                head
                
                .. attribute:: active
                
                	Number of FRR rewrites in Active state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: igp
                
                	Number of FRR rewrites in IGP state for SR\-TE
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: partial
                
                	Number of FRR rewrites in Partial state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: ready
                
                	Number of FRR rewrites in Ready state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeadSummary, self).__init__()

                    self.yang_name = "tunnel-head-summary"
                    self.yang_parent_name = "frr-database"

                    self.active = YLeaf(YType.uint32, "active")

                    self.igp = YLeaf(YType.uint32, "igp")

                    self.partial = YLeaf(YType.uint32, "partial")

                    self.ready = YLeaf(YType.uint32, "ready")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("active",
                                    "igp",
                                    "partial",
                                    "ready") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeadSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeadSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.active.is_set or
                        self.igp.is_set or
                        self.partial.is_set or
                        self.ready.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.active.yfilter != YFilter.not_set or
                        self.igp.yfilter != YFilter.not_set or
                        self.partial.yfilter != YFilter.not_set or
                        self.ready.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-head-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.active.is_set or self.active.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.active.get_name_leafdata())
                    if (self.igp.is_set or self.igp.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp.get_name_leafdata())
                    if (self.partial.is_set or self.partial.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.partial.get_name_leafdata())
                    if (self.ready.is_set or self.ready.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ready.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "active" or name == "igp" or name == "partial" or name == "ready"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "active"):
                        self.active = value
                        self.active.value_namespace = name_space
                        self.active.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp"):
                        self.igp = value
                        self.igp.value_namespace = name_space
                        self.igp.value_namespace_prefix = name_space_prefix
                    if(value_path == "partial"):
                        self.partial = value
                        self.partial.value_namespace = name_space
                        self.partial.value_namespace_prefix = name_space_prefix
                    if(value_path == "ready"):
                        self.ready = value
                        self.ready.value_namespace = name_space
                        self.ready.value_namespace_prefix = name_space_prefix


            class SummaryProtectedInterfaces(Entity):
                """
                Sumary table of Protected Interfaces
                
                .. attribute:: summary_protected_interface
                
                	Data for MPLS interface
                	**type**\: list of    :py:class:`SummaryProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.FrrDatabase.SummaryProtectedInterfaces.SummaryProtectedInterface>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.SummaryProtectedInterfaces, self).__init__()

                    self.yang_name = "summary-protected-interfaces"
                    self.yang_parent_name = "frr-database"

                    self.summary_protected_interface = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.SummaryProtectedInterfaces, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.SummaryProtectedInterfaces, self).__setattr__(name, value)


                class SummaryProtectedInterface(Entity):
                    """
                    Data for MPLS interface
                    
                    .. attribute:: interface_name  <key>
                    
                    	Interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: active
                    
                    	Number of FRR rewrites in Active state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: igp
                    
                    	Number of FRR rewrites in IGP state for SR\-TE
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: partial
                    
                    	Number of FRR rewrites in Partial state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: ready
                    
                    	Number of FRR rewrites in Ready state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.FrrDatabase.SummaryProtectedInterfaces.SummaryProtectedInterface, self).__init__()

                        self.yang_name = "summary-protected-interface"
                        self.yang_parent_name = "summary-protected-interfaces"

                        self.interface_name = YLeaf(YType.str, "interface-name")

                        self.active = YLeaf(YType.uint32, "active")

                        self.igp = YLeaf(YType.uint32, "igp")

                        self.partial = YLeaf(YType.uint32, "partial")

                        self.ready = YLeaf(YType.uint32, "ready")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("interface_name",
                                        "active",
                                        "igp",
                                        "partial",
                                        "ready") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.SummaryProtectedInterfaces.SummaryProtectedInterface, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.SummaryProtectedInterfaces.SummaryProtectedInterface, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.interface_name.is_set or
                            self.active.is_set or
                            self.igp.is_set or
                            self.partial.is_set or
                            self.ready.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.interface_name.yfilter != YFilter.not_set or
                            self.active.yfilter != YFilter.not_set or
                            self.igp.yfilter != YFilter.not_set or
                            self.partial.yfilter != YFilter.not_set or
                            self.ready.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "summary-protected-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                        if (self.active.is_set or self.active.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.active.get_name_leafdata())
                        if (self.igp.is_set or self.igp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp.get_name_leafdata())
                        if (self.partial.is_set or self.partial.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.partial.get_name_leafdata())
                        if (self.ready.is_set or self.ready.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ready.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "interface-name" or name == "active" or name == "igp" or name == "partial" or name == "ready"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "interface-name"):
                            self.interface_name = value
                            self.interface_name.value_namespace = name_space
                            self.interface_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "active"):
                            self.active = value
                            self.active.value_namespace = name_space
                            self.active.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp"):
                            self.igp = value
                            self.igp.value_namespace = name_space
                            self.igp.value_namespace_prefix = name_space_prefix
                        if(value_path == "partial"):
                            self.partial = value
                            self.partial.value_namespace = name_space
                            self.partial.value_namespace_prefix = name_space_prefix
                        if(value_path == "ready"):
                            self.ready = value
                            self.ready.value_namespace = name_space
                            self.ready.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.summary_protected_interface:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.summary_protected_interface:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "summary-protected-interfaces" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "summary-protected-interface"):
                        for c in self.summary_protected_interface:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsdNodes.MplsLsdNode.FrrDatabase.SummaryProtectedInterfaces.SummaryProtectedInterface()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.summary_protected_interface.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "summary-protected-interface"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class TunnelSummary(Entity):
                """
                Summary data for FRR database entry
                
                .. attribute:: active
                
                	Number of FRR rewrites in Active state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: igp
                
                	Number of FRR rewrites in IGP state for SR\-TE
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: partial
                
                	Number of FRR rewrites in Partial state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: ready
                
                	Number of FRR rewrites in Ready state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelSummary, self).__init__()

                    self.yang_name = "tunnel-summary"
                    self.yang_parent_name = "frr-database"

                    self.active = YLeaf(YType.uint32, "active")

                    self.igp = YLeaf(YType.uint32, "igp")

                    self.partial = YLeaf(YType.uint32, "partial")

                    self.ready = YLeaf(YType.uint32, "ready")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("active",
                                    "igp",
                                    "partial",
                                    "ready") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.active.is_set or
                        self.igp.is_set or
                        self.partial.is_set or
                        self.ready.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.active.yfilter != YFilter.not_set or
                        self.igp.yfilter != YFilter.not_set or
                        self.partial.yfilter != YFilter.not_set or
                        self.ready.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.active.is_set or self.active.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.active.get_name_leafdata())
                    if (self.igp.is_set or self.igp.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp.get_name_leafdata())
                    if (self.partial.is_set or self.partial.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.partial.get_name_leafdata())
                    if (self.ready.is_set or self.ready.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ready.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "active" or name == "igp" or name == "partial" or name == "ready"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "active"):
                        self.active = value
                        self.active.value_namespace = name_space
                        self.active.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp"):
                        self.igp = value
                        self.igp.value_namespace = name_space
                        self.igp.value_namespace_prefix = name_space_prefix
                    if(value_path == "partial"):
                        self.partial = value
                        self.partial.value_namespace = name_space
                        self.partial.value_namespace_prefix = name_space_prefix
                    if(value_path == "ready"):
                        self.ready = value
                        self.ready.value_namespace = name_space
                        self.ready.value_namespace_prefix = name_space_prefix


            class TunnelMidpointSummary(Entity):
                """
                Summary data for FRR database entry \- Tunnel
                midpoint
                
                .. attribute:: active
                
                	Number of FRR rewrites in Active state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: igp
                
                	Number of FRR rewrites in IGP state for SR\-TE
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: partial
                
                	Number of FRR rewrites in Partial state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: ready
                
                	Number of FRR rewrites in Ready state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpointSummary, self).__init__()

                    self.yang_name = "tunnel-midpoint-summary"
                    self.yang_parent_name = "frr-database"

                    self.active = YLeaf(YType.uint32, "active")

                    self.igp = YLeaf(YType.uint32, "igp")

                    self.partial = YLeaf(YType.uint32, "partial")

                    self.ready = YLeaf(YType.uint32, "ready")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("active",
                                    "igp",
                                    "partial",
                                    "ready") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpointSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpointSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.active.is_set or
                        self.igp.is_set or
                        self.partial.is_set or
                        self.ready.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.active.yfilter != YFilter.not_set or
                        self.igp.yfilter != YFilter.not_set or
                        self.partial.yfilter != YFilter.not_set or
                        self.ready.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-midpoint-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.active.is_set or self.active.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.active.get_name_leafdata())
                    if (self.igp.is_set or self.igp.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp.get_name_leafdata())
                    if (self.partial.is_set or self.partial.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.partial.get_name_leafdata())
                    if (self.ready.is_set or self.ready.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ready.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "active" or name == "igp" or name == "partial" or name == "ready"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "active"):
                        self.active = value
                        self.active.value_namespace = name_space
                        self.active.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp"):
                        self.igp = value
                        self.igp.value_namespace = name_space
                        self.igp.value_namespace_prefix = name_space_prefix
                    if(value_path == "partial"):
                        self.partial = value
                        self.partial.value_namespace = name_space
                        self.partial.value_namespace_prefix = name_space_prefix
                    if(value_path == "ready"):
                        self.ready = value
                        self.ready.value_namespace = name_space
                        self.ready.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    (self.summary_protected_interfaces is not None and self.summary_protected_interfaces.has_data()) or
                    (self.tunnel_head_summary is not None and self.tunnel_head_summary.has_data()) or
                    (self.tunnel_heads is not None and self.tunnel_heads.has_data()) or
                    (self.tunnel_midpoint_summary is not None and self.tunnel_midpoint_summary.has_data()) or
                    (self.tunnel_midpoints is not None and self.tunnel_midpoints.has_data()) or
                    (self.tunnel_summary is not None and self.tunnel_summary.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.summary_protected_interfaces is not None and self.summary_protected_interfaces.has_operation()) or
                    (self.tunnel_head_summary is not None and self.tunnel_head_summary.has_operation()) or
                    (self.tunnel_heads is not None and self.tunnel_heads.has_operation()) or
                    (self.tunnel_midpoint_summary is not None and self.tunnel_midpoint_summary.has_operation()) or
                    (self.tunnel_midpoints is not None and self.tunnel_midpoints.has_operation()) or
                    (self.tunnel_summary is not None and self.tunnel_summary.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "frr-database" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "summary-protected-interfaces"):
                    if (self.summary_protected_interfaces is None):
                        self.summary_protected_interfaces = MplsLsdNodes.MplsLsdNode.FrrDatabase.SummaryProtectedInterfaces()
                        self.summary_protected_interfaces.parent = self
                        self._children_name_map["summary_protected_interfaces"] = "summary-protected-interfaces"
                    return self.summary_protected_interfaces

                if (child_yang_name == "tunnel-head-summary"):
                    if (self.tunnel_head_summary is None):
                        self.tunnel_head_summary = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeadSummary()
                        self.tunnel_head_summary.parent = self
                        self._children_name_map["tunnel_head_summary"] = "tunnel-head-summary"
                    return self.tunnel_head_summary

                if (child_yang_name == "tunnel-heads"):
                    if (self.tunnel_heads is None):
                        self.tunnel_heads = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelHeads()
                        self.tunnel_heads.parent = self
                        self._children_name_map["tunnel_heads"] = "tunnel-heads"
                    return self.tunnel_heads

                if (child_yang_name == "tunnel-midpoint-summary"):
                    if (self.tunnel_midpoint_summary is None):
                        self.tunnel_midpoint_summary = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpointSummary()
                        self.tunnel_midpoint_summary.parent = self
                        self._children_name_map["tunnel_midpoint_summary"] = "tunnel-midpoint-summary"
                    return self.tunnel_midpoint_summary

                if (child_yang_name == "tunnel-midpoints"):
                    if (self.tunnel_midpoints is None):
                        self.tunnel_midpoints = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelMidpoints()
                        self.tunnel_midpoints.parent = self
                        self._children_name_map["tunnel_midpoints"] = "tunnel-midpoints"
                    return self.tunnel_midpoints

                if (child_yang_name == "tunnel-summary"):
                    if (self.tunnel_summary is None):
                        self.tunnel_summary = MplsLsdNodes.MplsLsdNode.FrrDatabase.TunnelSummary()
                        self.tunnel_summary.parent = self
                        self._children_name_map["tunnel_summary"] = "tunnel-summary"
                    return self.tunnel_summary

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "summary-protected-interfaces" or name == "tunnel-head-summary" or name == "tunnel-heads" or name == "tunnel-midpoint-summary" or name == "tunnel-midpoints" or name == "tunnel-summary"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Rewrite(Entity):
            """
            Table of rewrites
            
            .. attribute:: rewrite_ipv4s
            
            	Table of Rewrites
            	**type**\:   :py:class:`RewriteIpv4S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S>`
            
            .. attribute:: rewrite_labels
            
            	Table of Rewrites
            	**type**\:   :py:class:`RewriteLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels>`
            
            .. attribute:: rewrite_pws
            
            	Table of Rewrites
            	**type**\:   :py:class:`RewritePws <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws>`
            
            .. attribute:: rewrite_tes
            
            	Table of Traffic Engineering Rewrites
            	**type**\:   :py:class:`RewriteTes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsdNodes.MplsLsdNode.Rewrite, self).__init__()

                self.yang_name = "rewrite"
                self.yang_parent_name = "mpls-lsd-node"

                self.rewrite_ipv4s = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S()
                self.rewrite_ipv4s.parent = self
                self._children_name_map["rewrite_ipv4s"] = "rewrite-ipv4s"
                self._children_yang_names.add("rewrite-ipv4s")

                self.rewrite_labels = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels()
                self.rewrite_labels.parent = self
                self._children_name_map["rewrite_labels"] = "rewrite-labels"
                self._children_yang_names.add("rewrite-labels")

                self.rewrite_pws = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws()
                self.rewrite_pws.parent = self
                self._children_name_map["rewrite_pws"] = "rewrite-pws"
                self._children_yang_names.add("rewrite-pws")

                self.rewrite_tes = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes()
                self.rewrite_tes.parent = self
                self._children_name_map["rewrite_tes"] = "rewrite-tes"
                self._children_yang_names.add("rewrite-tes")


            class RewritePws(Entity):
                """
                Table of Rewrites
                
                .. attribute:: rewrite_pw
                
                	FPI rewrite for PW List
                	**type**\: list of    :py:class:`RewritePw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws, self).__init__()

                    self.yang_name = "rewrite-pws"
                    self.yang_parent_name = "rewrite"

                    self.rewrite_pw = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws, self).__setattr__(name, value)


                class RewritePw(Entity):
                    """
                    FPI rewrite for PW List
                    
                    .. attribute:: pw_list_id  <key>
                    
                    	PW List ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: associated_fpi
                    
                    	Associated FPI
                    	**type**\: list of    :py:class:`AssociatedFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi>`
                    
                    .. attribute:: bcdl_priority
                    
                    	BCDL Priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: fpi_key
                    
                    	fpi key
                    	**type**\:   :py:class:`FpiKey <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey>`
                    
                    .. attribute:: lsd_queue
                    
                    	LSD queue
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: mois
                    
                    	Mois
                    	**type**\: list of    :py:class:`Mois <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois>`
                    
                    .. attribute:: priority_updated
                    
                    	Is rewrite's BCDL priority updated
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: rewrite_id
                    
                    	Rewrite ID
                    	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId>`
                    
                    .. attribute:: rewrite_version
                    
                    	Rewrite version
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rw_install_age
                    
                    	Rewrite install age
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rw_install_time
                    
                    	Rewrite install timestamp
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rw_updated
                    
                    	Is rewrite ever updated
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: v4_rpf
                    
                    	IPv4 RPF neighbors
                    	**type**\: list of    :py:class:`V4Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.V4Rpf>`
                    
                    .. attribute:: v6_rpf
                    
                    	IPv6 RPF neighbors
                    	**type**\: list of    :py:class:`V6Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.V6Rpf>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw, self).__init__()

                        self.yang_name = "rewrite-pw"
                        self.yang_parent_name = "rewrite-pws"

                        self.pw_list_id = YLeaf(YType.int32, "pw-list-id")

                        self.bcdl_priority = YLeaf(YType.uint8, "bcdl-priority")

                        self.lsd_queue = YLeaf(YType.uint8, "lsd-queue")

                        self.priority_updated = YLeaf(YType.int32, "priority-updated")

                        self.rewrite_version = YLeaf(YType.uint64, "rewrite-version")

                        self.rw_install_age = YLeaf(YType.uint64, "rw-install-age")

                        self.rw_install_time = YLeaf(YType.uint64, "rw-install-time")

                        self.rw_updated = YLeaf(YType.int32, "rw-updated")

                        self.fpi_key = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey()
                        self.fpi_key.parent = self
                        self._children_name_map["fpi_key"] = "fpi-key"
                        self._children_yang_names.add("fpi-key")

                        self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId()
                        self.rewrite_id.parent = self
                        self._children_name_map["rewrite_id"] = "rewrite-id"
                        self._children_yang_names.add("rewrite-id")

                        self.associated_fpi = YList(self)
                        self.mois = YList(self)
                        self.v4_rpf = YList(self)
                        self.v6_rpf = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("pw_list_id",
                                        "bcdl_priority",
                                        "lsd_queue",
                                        "priority_updated",
                                        "rewrite_version",
                                        "rw_install_age",
                                        "rw_install_time",
                                        "rw_updated") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw, self).__setattr__(name, value)


                    class FpiKey(Entity):
                        """
                        fpi key
                        
                        .. attribute:: application_owner
                        
                        	Application owner instance
                        	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.ApplicationOwner>`
                        
                        .. attribute:: fpi
                        
                        	FPI
                        	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey, self).__init__()

                            self.yang_name = "fpi-key"
                            self.yang_parent_name = "rewrite-pw"

                            self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi()
                            self.fpi.parent = self
                            self._children_name_map["fpi"] = "fpi"
                            self._children_yang_names.add("fpi")

                            self.application_owner = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey, self).__setattr__(name, value)


                        class Fpi(Entity):
                            """
                            FPI
                            
                            .. attribute:: dmtc_ext_intf_data
                            
                            	dmtc ext intf data
                            	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.DmtcExtIntfData>`
                            
                            .. attribute:: fpi_type
                            
                            	FPIType
                            	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                            
                            .. attribute:: ipv4_data
                            
                            	ipv4 data
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv4Data>`
                            
                            .. attribute:: ipv6_data
                            
                            	ipv6 data
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv6Data>`
                            
                            .. attribute:: label_data
                            
                            	label data
                            	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.LabelData>`
                            
                            .. attribute:: pw_list_data
                            
                            	pw list data
                            	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.PwListData>`
                            
                            .. attribute:: te_data
                            
                            	te data
                            	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.TeData>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi, self).__init__()

                                self.yang_name = "fpi"
                                self.yang_parent_name = "fpi-key"

                                self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                                self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.DmtcExtIntfData()
                                self.dmtc_ext_intf_data.parent = self
                                self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                self._children_yang_names.add("dmtc-ext-intf-data")

                                self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.LabelData()
                                self.label_data.parent = self
                                self._children_name_map["label_data"] = "label-data"
                                self._children_yang_names.add("label-data")

                                self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.PwListData()
                                self.pw_list_data.parent = self
                                self._children_name_map["pw_list_data"] = "pw-list-data"
                                self._children_yang_names.add("pw-list-data")

                                self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.TeData()
                                self.te_data.parent = self
                                self._children_name_map["te_data"] = "te-data"
                                self._children_yang_names.add("te-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fpi_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi, self).__setattr__(name, value)


                            class LabelData(Entity):
                                """
                                label data
                                
                                .. attribute:: elc
                                
                                	ELC
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: label
                                
                                	Label value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.LabelData, self).__init__()

                                    self.yang_name = "label-data"
                                    self.yang_parent_name = "fpi"

                                    self.elc = YLeaf(YType.int32, "elc")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("elc",
                                                    "label",
                                                    "security_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.LabelData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.LabelData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.elc.is_set or
                                        self.label.is_set or
                                        self.security_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.elc.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.elc.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "elc" or name == "label" or name == "security-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "elc"):
                                        self.elc = value
                                        self.elc.value_namespace = name_space
                                        self.elc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix


                            class TeData(Entity):
                                """
                                te data
                                
                                .. attribute:: local_label
                                
                                	Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_interface
                                
                                	Tunnel interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.TeData, self).__init__()

                                    self.yang_name = "te-data"
                                    self.yang_parent_name = "fpi"

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("local_label",
                                                    "tunnel_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.TeData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.TeData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.local_label.is_set or
                                        self.tunnel_interface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.tunnel_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "local-label" or name == "tunnel-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface"):
                                        self.tunnel_interface = value
                                        self.tunnel_interface.value_namespace = name_space
                                        self.tunnel_interface.value_namespace_prefix = name_space_prefix


                            class Ipv4Data(Entity):
                                """
                                ipv4 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: sr_local_label
                                
                                	SR related Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "sr_local_label",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.sr_local_label.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.sr_local_label.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sr-local-label"):
                                        self.sr_local_label = value
                                        self.sr_local_label.value_namespace = name_space
                                        self.sr_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                ipv6 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: router_flags
                                
                                	Route flags
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    self.router_flags = YLeaf(YType.uint32, "router-flags")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_len",
                                                    "router_flags",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_len.is_set or
                                        self.router_flags.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set or
                                        self.router_flags.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                    if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_flags.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-flags"):
                                        self.router_flags = value
                                        self.router_flags.value_namespace = name_space
                                        self.router_flags.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class PwListData(Entity):
                                """
                                pw list data
                                
                                .. attribute:: pwhe_list_id
                                
                                	Pseudowire List Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.PwListData, self).__init__()

                                    self.yang_name = "pw-list-data"
                                    self.yang_parent_name = "fpi"

                                    self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("pwhe_list_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.PwListData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.PwListData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.pwhe_list_id.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.pwhe_list_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pw-list-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "pwhe-list-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "pwhe-list-id"):
                                        self.pwhe_list_id = value
                                        self.pwhe_list_id.value_namespace = name_space
                                        self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                            class DmtcExtIntfData(Entity):
                                """
                                dmtc ext intf data
                                
                                .. attribute:: dmtc_ext_ifh
                                
                                	DMTC External Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.DmtcExtIntfData, self).__init__()

                                    self.yang_name = "dmtc-ext-intf-data"
                                    self.yang_parent_name = "fpi"

                                    self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.dmtc_ext_ifh.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "dmtc-ext-intf-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-ext-ifh"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dmtc-ext-ifh"):
                                        self.dmtc_ext_ifh = value
                                        self.dmtc_ext_ifh.value_namespace = name_space
                                        self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fpi_type.is_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.label_data is not None and self.label_data.has_data()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                    (self.te_data is not None and self.te_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fpi_type.yfilter != YFilter.not_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.label_data is not None and self.label_data.has_operation()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                    (self.te_data is not None and self.te_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fpi" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fpi_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "dmtc-ext-intf-data"):
                                    if (self.dmtc_ext_intf_data is None):
                                        self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.DmtcExtIntfData()
                                        self.dmtc_ext_intf_data.parent = self
                                        self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                    return self.dmtc_ext_intf_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "label-data"):
                                    if (self.label_data is None):
                                        self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.LabelData()
                                        self.label_data.parent = self
                                        self._children_name_map["label_data"] = "label-data"
                                    return self.label_data

                                if (child_yang_name == "pw-list-data"):
                                    if (self.pw_list_data is None):
                                        self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.PwListData()
                                        self.pw_list_data.parent = self
                                        self._children_name_map["pw_list_data"] = "pw-list-data"
                                    return self.pw_list_data

                                if (child_yang_name == "te-data"):
                                    if (self.te_data is None):
                                        self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.TeData()
                                        self.te_data.parent = self
                                        self._children_name_map["te_data"] = "te-data"
                                    return self.te_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fpi-type"):
                                    self.fpi_type = value
                                    self.fpi_type.value_namespace = name_space
                                    self.fpi_type.value_namespace_prefix = name_space_prefix


                        class ApplicationOwner(Entity):
                            """
                            Application owner instance
                            
                            .. attribute:: application_instance
                            
                            	Application instance Name
                            	**type**\:  str
                            
                            .. attribute:: application_name
                            
                            	Application name
                            	**type**\:  str
                            
                            .. attribute:: application_role_primary
                            
                            	Primary/Backup role
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: application_type
                            
                            	Application type
                            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                            
                            .. attribute:: resource_state
                            
                            	Application resource state
                            	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.ApplicationOwner, self).__init__()

                                self.yang_name = "application-owner"
                                self.yang_parent_name = "fpi-key"

                                self.application_instance = YLeaf(YType.str, "application-instance")

                                self.application_name = YLeaf(YType.str, "application-name")

                                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                                self.application_type = YLeaf(YType.enumeration, "application-type")

                                self.resource_state = YLeaf(YType.enumeration, "resource-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("application_instance",
                                                "application_name",
                                                "application_role_primary",
                                                "application_type",
                                                "resource_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.ApplicationOwner, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.ApplicationOwner, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.application_instance.is_set or
                                    self.application_name.is_set or
                                    self.application_role_primary.is_set or
                                    self.application_type.is_set or
                                    self.resource_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.application_instance.yfilter != YFilter.not_set or
                                    self.application_name.yfilter != YFilter.not_set or
                                    self.application_role_primary.yfilter != YFilter.not_set or
                                    self.application_type.yfilter != YFilter.not_set or
                                    self.resource_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "application-owner" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_name.get_name_leafdata())
                                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_type.get_name_leafdata())
                                if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resource_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "application-instance"):
                                    self.application_instance = value
                                    self.application_instance.value_namespace = name_space
                                    self.application_instance.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-name"):
                                    self.application_name = value
                                    self.application_name.value_namespace = name_space
                                    self.application_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-role-primary"):
                                    self.application_role_primary = value
                                    self.application_role_primary.value_namespace = name_space
                                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-type"):
                                    self.application_type = value
                                    self.application_type.value_namespace = name_space
                                    self.application_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "resource-state"):
                                    self.resource_state = value
                                    self.resource_state.value_namespace = name_space
                                    self.resource_state.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.application_owner:
                                if (c.has_data()):
                                    return True
                            return (self.fpi is not None and self.fpi.has_data())

                        def has_operation(self):
                            for c in self.application_owner:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.fpi is not None and self.fpi.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fpi-key" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "application-owner"):
                                for c in self.application_owner:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.ApplicationOwner()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.application_owner.append(c)
                                return c

                            if (child_yang_name == "fpi"):
                                if (self.fpi is None):
                                    self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey.Fpi()
                                    self.fpi.parent = self
                                    self._children_name_map["fpi"] = "fpi"
                                return self.fpi

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-owner" or name == "fpi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class RewriteId(Entity):
                        """
                        Rewrite ID
                        
                        .. attribute:: rewrite_id
                        
                        	Rewrite ID
                        	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId, self).__init__()

                            self.yang_name = "rewrite-id"
                            self.yang_parent_name = "rewrite-pw"

                            self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId()
                            self.rewrite_id.parent = self
                            self._children_name_map["rewrite_id"] = "rewrite-id"
                            self._children_yang_names.add("rewrite-id")


                        class RewriteId(Entity):
                            """
                            Rewrite ID
                            
                            .. attribute:: label_context
                            
                            	Label context
                            	**type**\:   :py:class:`LabelContext <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext>`
                            
                            .. attribute:: local_label_rewrite
                            
                            	Local label rewrite information
                            	**type**\:   :py:class:`LocalLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LocalLabelRewrite>`
                            
                            .. attribute:: rewrite_id_type
                            
                            	RewriteIDType
                            	**type**\:   :py:class:`MgmtLsdRwId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdRwId>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId, self).__init__()

                                self.yang_name = "rewrite-id"
                                self.yang_parent_name = "rewrite-id"

                                self.rewrite_id_type = YLeaf(YType.enumeration, "rewrite-id-type")

                                self.label_context = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext()
                                self.label_context.parent = self
                                self._children_name_map["label_context"] = "label-context"
                                self._children_yang_names.add("label-context")

                                self.local_label_rewrite = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LocalLabelRewrite()
                                self.local_label_rewrite.parent = self
                                self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                                self._children_yang_names.add("local-label-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rewrite_id_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId, self).__setattr__(name, value)


                            class LabelContext(Entity):
                                """
                                Label context
                                
                                .. attribute:: cev4l3vpn_data
                                
                                	L3VPN CEv4 label context
                                	**type**\:   :py:class:`Cev4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev4L3VpnData>`
                                
                                .. attribute:: cev6l3vpn_data
                                
                                	L3VPN CEv6 label context
                                	**type**\:   :py:class:`Cev6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev6L3VpnData>`
                                
                                .. attribute:: evpn_data
                                
                                	EVPN context
                                	**type**\:   :py:class:`EvpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.EvpnData>`
                                
                                .. attribute:: generic_routing_encapsulation
                                
                                	Generic routing encapsulation context
                                	**type**\:   :py:class:`GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation>`
                                
                                .. attribute:: ip_sub_data
                                
                                	IP Subscriber context
                                	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.IpSubData>`
                                
                                .. attribute:: ipv4_data
                                
                                	IPv4 label context
                                	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4Data>`
                                
                                .. attribute:: ipv4blb_data
                                
                                	BFD BLB label context
                                	**type**\:   :py:class:`Ipv4BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4BlbData>`
                                
                                .. attribute:: ipv4l3vpn_data
                                
                                	L3VPN IPv4 label context
                                	**type**\:   :py:class:`Ipv4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData>`
                                
                                .. attribute:: ipv6_data
                                
                                	IPv6 label context
                                	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6Data>`
                                
                                .. attribute:: ipv6_generic_routing_encapsulation
                                
                                	Generic routing encapsulation context
                                	**type**\:   :py:class:`Ipv6GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation>`
                                
                                .. attribute:: ipv6blb_data
                                
                                	BFD BLB label context
                                	**type**\:   :py:class:`Ipv6BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6BlbData>`
                                
                                .. attribute:: ipv6l3vpn_data
                                
                                	L3VPN IPv6 label context
                                	**type**\:   :py:class:`Ipv6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData>`
                                
                                .. attribute:: label_block_data
                                
                                	Label block context
                                	**type**\:   :py:class:`LabelBlockData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockData>`
                                
                                .. attribute:: label_block_srgb_data
                                
                                	Label block SRGB context
                                	**type**\:   :py:class:`LabelBlockSrgbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData>`
                                
                                .. attribute:: label_context_type
                                
                                	LabelContextType
                                	**type**\:   :py:class:`MgmtLsdLblCtx <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLblCtx>`
                                
                                .. attribute:: mld_pv4_data
                                
                                	MLDPv4 LSM\-ID context
                                	**type**\:   :py:class:`MldPv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.MldPv4Data>`
                                
                                .. attribute:: next_hop_set_l3vpn
                                
                                	L3VPN NH SET label context
                                	**type**\:   :py:class:`NextHopSetL3Vpn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn>`
                                
                                .. attribute:: pi_mi_pmsi_data
                                
                                	PIM I\-PMSI label conext
                                	**type**\:   :py:class:`PiMiPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMiPmsiData>`
                                
                                .. attribute:: pi_ms_pmsi_data
                                
                                	PIM S\-PMSI label conext
                                	**type**\:   :py:class:`PiMsPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMsPmsiData>`
                                
                                .. attribute:: pseudowire_data
                                
                                	Pseudowire label context
                                	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireData>`
                                
                                .. attribute:: pseudowire_head_end_data
                                
                                	Pseudowire Head\-end label context
                                	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData>`
                                
                                .. attribute:: sr_adj_segment_ipv4
                                
                                	SR Adj Segment ipv4 context
                                	**type**\:   :py:class:`SrAdjSegmentIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4>`
                                
                                .. attribute:: sr_adj_segment_ipv6
                                
                                	SR Adj Segment ipv6 context
                                	**type**\:   :py:class:`SrAdjSegmentIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6>`
                                
                                .. attribute:: sr_prefix_segment
                                
                                	SR Prefix Segment context
                                	**type**\:   :py:class:`SrPrefixSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrPrefixSegment>`
                                
                                .. attribute:: te_binding
                                
                                	MPLS TE tunnel binding context
                                	**type**\:   :py:class:`TeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TeBinding>`
                                
                                .. attribute:: tev4_data
                                
                                	TEv4 label context
                                	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4Data>`
                                
                                .. attribute:: tev4p2mp_data
                                
                                	TEv4 P2MP context
                                	**type**\:   :py:class:`Tev4P2MpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4P2MpData>`
                                
                                .. attribute:: tp_data
                                
                                	TP context
                                	**type**\:   :py:class:`TpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TpData>`
                                
                                .. attribute:: vrf_l3vpn_data
                                
                                	L3VPN VRF label context
                                	**type**\:   :py:class:`VrfL3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.VrfL3VpnData>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext, self).__init__()

                                    self.yang_name = "label-context"
                                    self.yang_parent_name = "rewrite-id"

                                    self.label_context_type = YLeaf(YType.enumeration, "label-context-type")

                                    self.cev4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                    self.cev4l3vpn_data.parent = self
                                    self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                    self._children_yang_names.add("cev4l3vpn-data")

                                    self.cev6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                    self.cev6l3vpn_data.parent = self
                                    self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                    self._children_yang_names.add("cev6l3vpn-data")

                                    self.evpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.EvpnData()
                                    self.evpn_data.parent = self
                                    self._children_name_map["evpn_data"] = "evpn-data"
                                    self._children_yang_names.add("evpn-data")

                                    self.generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                    self.generic_routing_encapsulation.parent = self
                                    self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                    self._children_yang_names.add("generic-routing-encapsulation")

                                    self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.IpSubData()
                                    self.ip_sub_data.parent = self
                                    self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    self._children_yang_names.add("ip-sub-data")

                                    self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                    self._children_yang_names.add("ipv4-data")

                                    self.ipv4blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                    self.ipv4blb_data.parent = self
                                    self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                    self._children_yang_names.add("ipv4blb-data")

                                    self.ipv4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                    self.ipv4l3vpn_data.parent = self
                                    self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                    self._children_yang_names.add("ipv4l3vpn-data")

                                    self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                    self._children_yang_names.add("ipv6-data")

                                    self.ipv6_generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                    self.ipv6_generic_routing_encapsulation.parent = self
                                    self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                    self._children_yang_names.add("ipv6-generic-routing-encapsulation")

                                    self.ipv6blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                    self.ipv6blb_data.parent = self
                                    self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                    self._children_yang_names.add("ipv6blb-data")

                                    self.ipv6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                    self.ipv6l3vpn_data.parent = self
                                    self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                    self._children_yang_names.add("ipv6l3vpn-data")

                                    self.label_block_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                    self.label_block_data.parent = self
                                    self._children_name_map["label_block_data"] = "label-block-data"
                                    self._children_yang_names.add("label-block-data")

                                    self.label_block_srgb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                    self.label_block_srgb_data.parent = self
                                    self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                    self._children_yang_names.add("label-block-srgb-data")

                                    self.mld_pv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                    self.mld_pv4_data.parent = self
                                    self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                    self._children_yang_names.add("mld-pv4-data")

                                    self.next_hop_set_l3vpn = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                    self.next_hop_set_l3vpn.parent = self
                                    self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                    self._children_yang_names.add("next-hop-set-l3vpn")

                                    self.pi_mi_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                    self.pi_mi_pmsi_data.parent = self
                                    self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                    self._children_yang_names.add("pi-mi-pmsi-data")

                                    self.pi_ms_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                    self.pi_ms_pmsi_data.parent = self
                                    self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                    self._children_yang_names.add("pi-ms-pmsi-data")

                                    self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireData()
                                    self.pseudowire_data.parent = self
                                    self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    self._children_yang_names.add("pseudowire-data")

                                    self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                    self.pseudowire_head_end_data.parent = self
                                    self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    self._children_yang_names.add("pseudowire-head-end-data")

                                    self.sr_adj_segment_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                    self.sr_adj_segment_ipv4.parent = self
                                    self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                    self._children_yang_names.add("sr-adj-segment-ipv4")

                                    self.sr_adj_segment_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                    self.sr_adj_segment_ipv6.parent = self
                                    self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                    self._children_yang_names.add("sr-adj-segment-ipv6")

                                    self.sr_prefix_segment = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                    self.sr_prefix_segment.parent = self
                                    self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                    self._children_yang_names.add("sr-prefix-segment")

                                    self.te_binding = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TeBinding()
                                    self.te_binding.parent = self
                                    self._children_name_map["te_binding"] = "te-binding"
                                    self._children_yang_names.add("te-binding")

                                    self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4Data()
                                    self.tev4_data.parent = self
                                    self._children_name_map["tev4_data"] = "tev4-data"
                                    self._children_yang_names.add("tev4-data")

                                    self.tev4p2mp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                    self.tev4p2mp_data.parent = self
                                    self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                    self._children_yang_names.add("tev4p2mp-data")

                                    self.tp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TpData()
                                    self.tp_data.parent = self
                                    self._children_name_map["tp_data"] = "tp-data"
                                    self._children_yang_names.add("tp-data")

                                    self.vrf_l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                    self.vrf_l3vpn_data.parent = self
                                    self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                    self._children_yang_names.add("vrf-l3vpn-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_context_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)


                                class Ipv4Data(Entity):
                                    """
                                    IPv4 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv4 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	IPv4 prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf_name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..33
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__init__()

                                        self.yang_name = "ipv4-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.vrf_name = YLeaf(YType.str, "vrf-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "security_id",
                                                        "table_id",
                                                        "vrf_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set or
                                            self.vrf_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.vrf_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-name"):
                                            self.vrf_name = value
                                            self.vrf_name.value_namespace = name_space
                                            self.vrf_name.value_namespace_prefix = name_space_prefix


                                class Ipv6Data(Entity):
                                    """
                                    IPv6 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf_name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..33
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__init__()

                                        self.yang_name = "ipv6-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.vrf_name = YLeaf(YType.str, "vrf-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "security_id",
                                                        "table_id",
                                                        "vrf_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set or
                                            self.vrf_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.vrf_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-name"):
                                            self.vrf_name = value
                                            self.vrf_name.value_namespace = name_space
                                            self.vrf_name.value_namespace_prefix = name_space_prefix


                                class Tev4Data(Entity):
                                    """
                                    TEv4 label context
                                    
                                    .. attribute:: is_srte
                                    
                                    	Is this an SRTE head tunnel
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_dest
                                    
                                    	Tunnel destination
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_id_extension
                                    
                                    	Extended tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_lsp_id
                                    
                                    	Tunnel LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_source
                                    
                                    	Tunnel source
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4Data, self).__init__()

                                        self.yang_name = "tev4-data"
                                        self.yang_parent_name = "label-context"

                                        self.is_srte = YLeaf(YType.int32, "is-srte")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.tunnel_dest = YLeaf(YType.str, "tunnel-dest")

                                        self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                        self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                        self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                        self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_srte",
                                                        "table_id",
                                                        "tunnel_dest",
                                                        "tunnel_id",
                                                        "tunnel_id_extension",
                                                        "tunnel_lsp_id",
                                                        "tunnel_source") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_srte.is_set or
                                            self.table_id.is_set or
                                            self.tunnel_dest.is_set or
                                            self.tunnel_id.is_set or
                                            self.tunnel_id_extension.is_set or
                                            self.tunnel_lsp_id.is_set or
                                            self.tunnel_source.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_srte.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.tunnel_dest.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set or
                                            self.tunnel_id_extension.yfilter != YFilter.not_set or
                                            self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                            self.tunnel_source.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tev4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_srte.is_set or self.is_srte.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_srte.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.tunnel_dest.is_set or self.tunnel_dest.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_dest.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                        if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                        if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                        if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-srte" or name == "table-id" or name == "tunnel-dest" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-srte"):
                                            self.is_srte = value
                                            self.is_srte.value_namespace = name_space
                                            self.is_srte.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-dest"):
                                            self.tunnel_dest = value
                                            self.tunnel_dest.value_namespace = name_space
                                            self.tunnel_dest.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id-extension"):
                                            self.tunnel_id_extension = value
                                            self.tunnel_id_extension.value_namespace = name_space
                                            self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-lsp-id"):
                                            self.tunnel_lsp_id = value
                                            self.tunnel_lsp_id.value_namespace = name_space
                                            self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-source"):
                                            self.tunnel_source = value
                                            self.tunnel_source.value_namespace = name_space
                                            self.tunnel_source.value_namespace_prefix = name_space_prefix


                                class Ipv4L3VpnData(Entity):
                                    """
                                    L3VPN IPv4 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv4 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: route_distinguisher
                                    
                                    	Route distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__init__()

                                        self.yang_name = "ipv4l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "route_distinguisher") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.route_distinguisher.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.route_distinguisher.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "route-distinguisher"):
                                            self.route_distinguisher = value
                                            self.route_distinguisher.value_namespace = name_space
                                            self.route_distinguisher.value_namespace_prefix = name_space_prefix


                                class Ipv6L3VpnData(Entity):
                                    """
                                    L3VPN IPv6 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv6 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: route_distinguisher
                                    
                                    	Route distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__init__()

                                        self.yang_name = "ipv6l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "route_distinguisher") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.route_distinguisher.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.route_distinguisher.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "route-distinguisher"):
                                            self.route_distinguisher = value
                                            self.route_distinguisher.value_namespace = name_space
                                            self.route_distinguisher.value_namespace_prefix = name_space_prefix


                                class VrfL3VpnData(Entity):
                                    """
                                    L3VPN VRF label context
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__init__()

                                        self.yang_name = "vrf-l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("security_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.security_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf-l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "security-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class Cev4L3VpnData(Entity):
                                    """
                                    L3VPN CEv4 label context
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__init__()

                                        self.yang_name = "cev4l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ipv4_next_hop",
                                                        "security_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ipv4_next_hop.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cev4l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ipv4-next-hop" or name == "security-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class Cev6L3VpnData(Entity):
                                    """
                                    L3VPN CEv6 label context
                                    
                                    .. attribute:: ipv6_next_hop
                                    
                                    	IPv6 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__init__()

                                        self.yang_name = "cev6l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ipv6_next_hop",
                                                        "security_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ipv6_next_hop.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ipv6_next_hop.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cev6l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ipv6-next-hop" or name == "security-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ipv6-next-hop"):
                                            self.ipv6_next_hop = value
                                            self.ipv6_next_hop.value_namespace = name_space
                                            self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class PseudowireData(Entity):
                                    """
                                    Pseudowire label context
                                    
                                    .. attribute:: prefix
                                    
                                    	Address prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: pseudowire_id
                                    
                                    	Pseudo\-wire ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: remote_l2_router_id
                                    
                                    	Remote L2 Router ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: subinterface
                                    
                                    	Subinterface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireData, self).__init__()

                                        self.yang_name = "pseudowire-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.pseudowire_id = YLeaf(YType.uint64, "pseudowire-id")

                                        self.remote_l2_router_id = YLeaf(YType.uint32, "remote-l2-router-id")

                                        self.subinterface = YLeaf(YType.str, "subinterface")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "pseudowire_id",
                                                        "remote_l2_router_id",
                                                        "subinterface") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.pseudowire_id.is_set or
                                            self.remote_l2_router_id.is_set or
                                            self.subinterface.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.pseudowire_id.yfilter != YFilter.not_set or
                                            self.remote_l2_router_id.yfilter != YFilter.not_set or
                                            self.subinterface.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pseudowire_id.get_name_leafdata())
                                        if (self.remote_l2_router_id.is_set or self.remote_l2_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remote_l2_router_id.get_name_leafdata())
                                        if (self.subinterface.is_set or self.subinterface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.subinterface.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "pseudowire-id" or name == "remote-l2-router-id" or name == "subinterface"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pseudowire-id"):
                                            self.pseudowire_id = value
                                            self.pseudowire_id.value_namespace = name_space
                                            self.pseudowire_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remote-l2-router-id"):
                                            self.remote_l2_router_id = value
                                            self.remote_l2_router_id.value_namespace = name_space
                                            self.remote_l2_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "subinterface"):
                                            self.subinterface = value
                                            self.subinterface.value_namespace = name_space
                                            self.subinterface.value_namespace_prefix = name_space_prefix


                                class LabelBlockData(Entity):
                                    """
                                    Label block context
                                    
                                    .. attribute:: edge_id
                                    
                                    	Edge ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: offset
                                    
                                    	Offset
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: service
                                    
                                    	Service
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: size
                                    
                                    	Number of labels
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vpn_id
                                    
                                    	VPN ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__init__()

                                        self.yang_name = "label-block-data"
                                        self.yang_parent_name = "label-context"

                                        self.edge_id = YLeaf(YType.uint16, "edge-id")

                                        self.offset = YLeaf(YType.uint32, "offset")

                                        self.service = YLeaf(YType.uint8, "service")

                                        self.size = YLeaf(YType.uint32, "size")

                                        self.vpn_id = YLeaf(YType.uint16, "vpn-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("edge_id",
                                                        "offset",
                                                        "service",
                                                        "size",
                                                        "vpn_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.edge_id.is_set or
                                            self.offset.is_set or
                                            self.service.is_set or
                                            self.size.is_set or
                                            self.vpn_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.edge_id.yfilter != YFilter.not_set or
                                            self.offset.yfilter != YFilter.not_set or
                                            self.service.yfilter != YFilter.not_set or
                                            self.size.yfilter != YFilter.not_set or
                                            self.vpn_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "label-block-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.edge_id.is_set or self.edge_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.edge_id.get_name_leafdata())
                                        if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.offset.get_name_leafdata())
                                        if (self.service.is_set or self.service.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.service.get_name_leafdata())
                                        if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.size.get_name_leafdata())
                                        if (self.vpn_id.is_set or self.vpn_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vpn_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "edge-id" or name == "offset" or name == "service" or name == "size" or name == "vpn-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "edge-id"):
                                            self.edge_id = value
                                            self.edge_id.value_namespace = name_space
                                            self.edge_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "offset"):
                                            self.offset = value
                                            self.offset.value_namespace = name_space
                                            self.offset.value_namespace_prefix = name_space_prefix
                                        if(value_path == "service"):
                                            self.service = value
                                            self.service.value_namespace = name_space
                                            self.service.value_namespace_prefix = name_space_prefix
                                        if(value_path == "size"):
                                            self.size = value
                                            self.size.value_namespace = name_space
                                            self.size.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vpn-id"):
                                            self.vpn_id = value
                                            self.vpn_id.value_namespace = name_space
                                            self.vpn_id.value_namespace_prefix = name_space_prefix


                                class IpSubData(Entity):
                                    """
                                    IP Subscriber context
                                    
                                    .. attribute:: parent_interface
                                    
                                    	Parent interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: table_id
                                    
                                    	Table Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.IpSubData, self).__init__()

                                        self.yang_name = "ip-sub-data"
                                        self.yang_parent_name = "label-context"

                                        self.parent_interface = YLeaf(YType.str, "parent-interface")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("parent_interface",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.parent_interface.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.parent_interface.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ip-sub-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.parent_interface.is_set or self.parent_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_interface.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "parent-interface" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "parent-interface"):
                                            self.parent_interface = value
                                            self.parent_interface.value_namespace = name_space
                                            self.parent_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class Tev4P2MpData(Entity):
                                    """
                                    TEv4 P2MP context
                                    
                                    .. attribute:: p2mp_id
                                    
                                    	Point to multipoint ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: previous_hop
                                    
                                    	Previous hop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_id_extension
                                    
                                    	Tunnel ID extension
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_lsp_id
                                    
                                    	Tunnel LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_source
                                    
                                    	Tunnel source
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__init__()

                                        self.yang_name = "tev4p2mp-data"
                                        self.yang_parent_name = "label-context"

                                        self.p2mp_id = YLeaf(YType.uint32, "p2mp-id")

                                        self.previous_hop = YLeaf(YType.str, "previous-hop")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                        self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                        self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                        self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("p2mp_id",
                                                        "previous_hop",
                                                        "table_id",
                                                        "tunnel_id",
                                                        "tunnel_id_extension",
                                                        "tunnel_lsp_id",
                                                        "tunnel_source") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.p2mp_id.is_set or
                                            self.previous_hop.is_set or
                                            self.table_id.is_set or
                                            self.tunnel_id.is_set or
                                            self.tunnel_id_extension.is_set or
                                            self.tunnel_lsp_id.is_set or
                                            self.tunnel_source.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.p2mp_id.yfilter != YFilter.not_set or
                                            self.previous_hop.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set or
                                            self.tunnel_id_extension.yfilter != YFilter.not_set or
                                            self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                            self.tunnel_source.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tev4p2mp-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                                        if (self.previous_hop.is_set or self.previous_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.previous_hop.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                        if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                        if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                        if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "p2mp-id" or name == "previous-hop" or name == "table-id" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "p2mp-id"):
                                            self.p2mp_id = value
                                            self.p2mp_id.value_namespace = name_space
                                            self.p2mp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "previous-hop"):
                                            self.previous_hop = value
                                            self.previous_hop.value_namespace = name_space
                                            self.previous_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id-extension"):
                                            self.tunnel_id_extension = value
                                            self.tunnel_id_extension.value_namespace = name_space
                                            self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-lsp-id"):
                                            self.tunnel_lsp_id = value
                                            self.tunnel_lsp_id.value_namespace = name_space
                                            self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-source"):
                                            self.tunnel_source = value
                                            self.tunnel_source.value_namespace = name_space
                                            self.tunnel_source.value_namespace_prefix = name_space_prefix


                                class MldPv4Data(Entity):
                                    """
                                    MLDPv4 LSM\-ID context
                                    
                                    .. attribute:: lsm_id
                                    
                                    	LSM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: peer_label_space_id
                                    
                                    	Peer Label Space Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: peer_lsrid
                                    
                                    	Peer LSR Id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: type
                                    
                                    	LSM ID Type
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__init__()

                                        self.yang_name = "mld-pv4-data"
                                        self.yang_parent_name = "label-context"

                                        self.lsm_id = YLeaf(YType.uint32, "lsm-id")

                                        self.peer_label_space_id = YLeaf(YType.uint16, "peer-label-space-id")

                                        self.peer_lsrid = YLeaf(YType.str, "peer-lsrid")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.type = YLeaf(YType.uint16, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("lsm_id",
                                                        "peer_label_space_id",
                                                        "peer_lsrid",
                                                        "table_id",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.lsm_id.is_set or
                                            self.peer_label_space_id.is_set or
                                            self.peer_lsrid.is_set or
                                            self.table_id.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.lsm_id.yfilter != YFilter.not_set or
                                            self.peer_label_space_id.yfilter != YFilter.not_set or
                                            self.peer_lsrid.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "mld-pv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.lsm_id.is_set or self.lsm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsm_id.get_name_leafdata())
                                        if (self.peer_label_space_id.is_set or self.peer_label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.peer_label_space_id.get_name_leafdata())
                                        if (self.peer_lsrid.is_set or self.peer_lsrid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.peer_lsrid.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsm-id" or name == "peer-label-space-id" or name == "peer-lsrid" or name == "table-id" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "lsm-id"):
                                            self.lsm_id = value
                                            self.lsm_id.value_namespace = name_space
                                            self.lsm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "peer-label-space-id"):
                                            self.peer_label_space_id = value
                                            self.peer_label_space_id.value_namespace = name_space
                                            self.peer_label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "peer-lsrid"):
                                            self.peer_lsrid = value
                                            self.peer_lsrid.value_namespace = name_space
                                            self.peer_lsrid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class PseudowireHeadEndData(Entity):
                                    """
                                    Pseudowire Head\-end label context
                                    
                                    .. attribute:: pwhe_intf
                                    
                                    	Pseudo\-wire Head\-end interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__init__()

                                        self.yang_name = "pseudowire-head-end-data"
                                        self.yang_parent_name = "label-context"

                                        self.pwhe_intf = YLeaf(YType.str, "pwhe-intf")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("pwhe_intf") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.pwhe_intf.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.pwhe_intf.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-head-end-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.pwhe_intf.is_set or self.pwhe_intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pwhe_intf.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "pwhe-intf"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "pwhe-intf"):
                                            self.pwhe_intf = value
                                            self.pwhe_intf.value_namespace = name_space
                                            self.pwhe_intf.value_namespace_prefix = name_space_prefix


                                class TpData(Entity):
                                    """
                                    TP context
                                    
                                    .. attribute:: dest_global_id
                                    
                                    	TP destination global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dest_node_id
                                    
                                    	TP destination node ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: dest_tunnel_id
                                    
                                    	TP destination tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsp_id
                                    
                                    	TP LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: source_global_id
                                    
                                    	TP source global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: source_node_id
                                    
                                    	TP source node ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: source_tunnel_id
                                    
                                    	TP source tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TpData, self).__init__()

                                        self.yang_name = "tp-data"
                                        self.yang_parent_name = "label-context"

                                        self.dest_global_id = YLeaf(YType.uint32, "dest-global-id")

                                        self.dest_node_id = YLeaf(YType.str, "dest-node-id")

                                        self.dest_tunnel_id = YLeaf(YType.uint16, "dest-tunnel-id")

                                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                        self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                                        self.source_node_id = YLeaf(YType.str, "source-node-id")

                                        self.source_tunnel_id = YLeaf(YType.uint16, "source-tunnel-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("dest_global_id",
                                                        "dest_node_id",
                                                        "dest_tunnel_id",
                                                        "lsp_id",
                                                        "source_global_id",
                                                        "source_node_id",
                                                        "source_tunnel_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.dest_global_id.is_set or
                                            self.dest_node_id.is_set or
                                            self.dest_tunnel_id.is_set or
                                            self.lsp_id.is_set or
                                            self.source_global_id.is_set or
                                            self.source_node_id.is_set or
                                            self.source_tunnel_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.dest_global_id.yfilter != YFilter.not_set or
                                            self.dest_node_id.yfilter != YFilter.not_set or
                                            self.dest_tunnel_id.yfilter != YFilter.not_set or
                                            self.lsp_id.yfilter != YFilter.not_set or
                                            self.source_global_id.yfilter != YFilter.not_set or
                                            self.source_node_id.yfilter != YFilter.not_set or
                                            self.source_tunnel_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tp-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.dest_global_id.is_set or self.dest_global_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dest_global_id.get_name_leafdata())
                                        if (self.dest_node_id.is_set or self.dest_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dest_node_id.get_name_leafdata())
                                        if (self.dest_tunnel_id.is_set or self.dest_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dest_tunnel_id.get_name_leafdata())
                                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsp_id.get_name_leafdata())
                                        if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source_global_id.get_name_leafdata())
                                        if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source_node_id.get_name_leafdata())
                                        if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dest-global-id" or name == "dest-node-id" or name == "dest-tunnel-id" or name == "lsp-id" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "dest-global-id"):
                                            self.dest_global_id = value
                                            self.dest_global_id.value_namespace = name_space
                                            self.dest_global_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dest-node-id"):
                                            self.dest_node_id = value
                                            self.dest_node_id.value_namespace = name_space
                                            self.dest_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dest-tunnel-id"):
                                            self.dest_tunnel_id = value
                                            self.dest_tunnel_id.value_namespace = name_space
                                            self.dest_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsp-id"):
                                            self.lsp_id = value
                                            self.lsp_id.value_namespace = name_space
                                            self.lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source-global-id"):
                                            self.source_global_id = value
                                            self.source_global_id.value_namespace = name_space
                                            self.source_global_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source-node-id"):
                                            self.source_node_id = value
                                            self.source_node_id.value_namespace = name_space
                                            self.source_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source-tunnel-id"):
                                            self.source_tunnel_id = value
                                            self.source_tunnel_id.value_namespace = name_space
                                            self.source_tunnel_id.value_namespace_prefix = name_space_prefix


                                class GenericRoutingEncapsulation(Entity):
                                    """
                                    Generic routing encapsulation context
                                    
                                    .. attribute:: gre_interface
                                    
                                    	Generic routing encapsulation interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__init__()

                                        self.yang_name = "generic-routing-encapsulation"
                                        self.yang_parent_name = "label-context"

                                        self.gre_interface = YLeaf(YType.str, "gre-interface")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("gre_interface") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.gre_interface.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.gre_interface.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "generic-routing-encapsulation" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.gre_interface.is_set or self.gre_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gre_interface.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "gre-interface"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "gre-interface"):
                                            self.gre_interface = value
                                            self.gre_interface.value_namespace = name_space
                                            self.gre_interface.value_namespace_prefix = name_space_prefix


                                class Ipv6GenericRoutingEncapsulation(Entity):
                                    """
                                    Generic routing encapsulation context
                                    
                                    .. attribute:: greipv6_interface
                                    
                                    	Generic routing encapsulation IPv6 interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__init__()

                                        self.yang_name = "ipv6-generic-routing-encapsulation"
                                        self.yang_parent_name = "label-context"

                                        self.greipv6_interface = YLeaf(YType.str, "greipv6-interface")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("greipv6_interface") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.greipv6_interface.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.greipv6_interface.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-generic-routing-encapsulation" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.greipv6_interface.is_set or self.greipv6_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.greipv6_interface.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "greipv6-interface"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "greipv6-interface"):
                                            self.greipv6_interface = value
                                            self.greipv6_interface.value_namespace = name_space
                                            self.greipv6_interface.value_namespace_prefix = name_space_prefix


                                class EvpnData(Entity):
                                    """
                                    EVPN context
                                    
                                    .. attribute:: ethernet_segment
                                    
                                    	Ethernet Segment ID
                                    	**type**\:  str
                                    
                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                    
                                    .. attribute:: evpn_id
                                    
                                    	EVPN ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: evpn_tag
                                    
                                    	EVPN TAG
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.EvpnData, self).__init__()

                                        self.yang_name = "evpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.ethernet_segment = YLeaf(YType.str, "ethernet-segment")

                                        self.evpn_id = YLeaf(YType.uint32, "evpn-id")

                                        self.evpn_tag = YLeaf(YType.uint32, "evpn-tag")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ethernet_segment",
                                                        "evpn_id",
                                                        "evpn_tag") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ethernet_segment.is_set or
                                            self.evpn_id.is_set or
                                            self.evpn_tag.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ethernet_segment.yfilter != YFilter.not_set or
                                            self.evpn_id.yfilter != YFilter.not_set or
                                            self.evpn_tag.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "evpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ethernet_segment.is_set or self.ethernet_segment.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ethernet_segment.get_name_leafdata())
                                        if (self.evpn_id.is_set or self.evpn_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.evpn_id.get_name_leafdata())
                                        if (self.evpn_tag.is_set or self.evpn_tag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.evpn_tag.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ethernet-segment" or name == "evpn-id" or name == "evpn-tag"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ethernet-segment"):
                                            self.ethernet_segment = value
                                            self.ethernet_segment.value_namespace = name_space
                                            self.ethernet_segment.value_namespace_prefix = name_space_prefix
                                        if(value_path == "evpn-id"):
                                            self.evpn_id = value
                                            self.evpn_id.value_namespace = name_space
                                            self.evpn_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "evpn-tag"):
                                            self.evpn_tag = value
                                            self.evpn_tag.value_namespace = name_space
                                            self.evpn_tag.value_namespace_prefix = name_space_prefix


                                class Ipv4BlbData(Entity):
                                    """
                                    BFD BLB label context
                                    
                                    .. attribute:: blb_intf
                                    
                                    	BFD BLB interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv4 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__init__()

                                        self.yang_name = "ipv4blb-data"
                                        self.yang_parent_name = "label-context"

                                        self.blb_intf = YLeaf(YType.str, "blb-intf")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("blb_intf",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.blb_intf.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.blb_intf.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4blb-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "blb-intf" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "blb-intf"):
                                            self.blb_intf = value
                                            self.blb_intf.value_namespace = name_space
                                            self.blb_intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix


                                class Ipv6BlbData(Entity):
                                    """
                                    BFD BLB label context
                                    
                                    .. attribute:: blb_intf
                                    
                                    	BFD BLB interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv6 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__init__()

                                        self.yang_name = "ipv6blb-data"
                                        self.yang_parent_name = "label-context"

                                        self.blb_intf = YLeaf(YType.str, "blb-intf")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("blb_intf",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.blb_intf.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.blb_intf.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6blb-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "blb-intf" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "blb-intf"):
                                            self.blb_intf = value
                                            self.blb_intf.value_namespace = name_space
                                            self.blb_intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix


                                class PiMiPmsiData(Entity):
                                    """
                                    PIM I\-PMSI label conext
                                    
                                    .. attribute:: head
                                    
                                    	Head
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: v6
                                    
                                    	PIM6
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: vrf_id
                                    
                                    	VRF ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__init__()

                                        self.yang_name = "pi-mi-pmsi-data"
                                        self.yang_parent_name = "label-context"

                                        self.head = YLeaf(YType.int32, "head")

                                        self.v6 = YLeaf(YType.int32, "v6")

                                        self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("head",
                                                        "v6",
                                                        "vrf_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.head.is_set or
                                            self.v6.is_set or
                                            self.vrf_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.head.yfilter != YFilter.not_set or
                                            self.v6.yfilter != YFilter.not_set or
                                            self.vrf_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pi-mi-pmsi-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.head.get_name_leafdata())
                                        if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.v6.get_name_leafdata())
                                        if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "head" or name == "v6" or name == "vrf-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "head"):
                                            self.head = value
                                            self.head.value_namespace = name_space
                                            self.head.value_namespace_prefix = name_space_prefix
                                        if(value_path == "v6"):
                                            self.v6 = value
                                            self.v6.value_namespace = name_space
                                            self.v6.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-id"):
                                            self.vrf_id = value
                                            self.vrf_id.value_namespace = name_space
                                            self.vrf_id.value_namespace_prefix = name_space_prefix


                                class PiMsPmsiData(Entity):
                                    """
                                    PIM S\-PMSI label conext
                                    
                                    .. attribute:: head
                                    
                                    	Head
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: hli
                                    
                                    	Head LSM\-ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: seg
                                    
                                    	Segmented Multicast
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: source
                                    
                                    	Originating Router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: v6
                                    
                                    	PIM6
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: vrf_id
                                    
                                    	VRF ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__init__()

                                        self.yang_name = "pi-ms-pmsi-data"
                                        self.yang_parent_name = "label-context"

                                        self.head = YLeaf(YType.int32, "head")

                                        self.hli = YLeaf(YType.uint32, "hli")

                                        self.seg = YLeaf(YType.int32, "seg")

                                        self.source = YLeaf(YType.str, "source")

                                        self.v6 = YLeaf(YType.int32, "v6")

                                        self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("head",
                                                        "hli",
                                                        "seg",
                                                        "source",
                                                        "v6",
                                                        "vrf_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.head.is_set or
                                            self.hli.is_set or
                                            self.seg.is_set or
                                            self.source.is_set or
                                            self.v6.is_set or
                                            self.vrf_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.head.yfilter != YFilter.not_set or
                                            self.hli.yfilter != YFilter.not_set or
                                            self.seg.yfilter != YFilter.not_set or
                                            self.source.yfilter != YFilter.not_set or
                                            self.v6.yfilter != YFilter.not_set or
                                            self.vrf_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pi-ms-pmsi-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.head.get_name_leafdata())
                                        if (self.hli.is_set or self.hli.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hli.get_name_leafdata())
                                        if (self.seg.is_set or self.seg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.seg.get_name_leafdata())
                                        if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source.get_name_leafdata())
                                        if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.v6.get_name_leafdata())
                                        if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "head" or name == "hli" or name == "seg" or name == "source" or name == "v6" or name == "vrf-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "head"):
                                            self.head = value
                                            self.head.value_namespace = name_space
                                            self.head.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hli"):
                                            self.hli = value
                                            self.hli.value_namespace = name_space
                                            self.hli.value_namespace_prefix = name_space_prefix
                                        if(value_path == "seg"):
                                            self.seg = value
                                            self.seg.value_namespace = name_space
                                            self.seg.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source"):
                                            self.source = value
                                            self.source.value_namespace = name_space
                                            self.source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "v6"):
                                            self.v6 = value
                                            self.v6.value_namespace = name_space
                                            self.v6.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-id"):
                                            self.vrf_id = value
                                            self.vrf_id.value_namespace = name_space
                                            self.vrf_id.value_namespace_prefix = name_space_prefix


                                class NextHopSetL3Vpn(Entity):
                                    """
                                    L3VPN NH SET label context
                                    
                                    .. attribute:: next_hop_set_id
                                    
                                    	Next Hop Set ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__init__()

                                        self.yang_name = "next-hop-set-l3vpn"
                                        self.yang_parent_name = "label-context"

                                        self.next_hop_set_id = YLeaf(YType.uint32, "next-hop-set-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("next_hop_set_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.next_hop_set_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.next_hop_set_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "next-hop-set-l3vpn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.next_hop_set_id.is_set or self.next_hop_set_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_set_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "next-hop-set-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "next-hop-set-id"):
                                            self.next_hop_set_id = value
                                            self.next_hop_set_id.value_namespace = name_space
                                            self.next_hop_set_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class SrPrefixSegment(Entity):
                                    """
                                    SR Prefix Segment context
                                    
                                    .. attribute:: segment_id
                                    
                                    	Prefix Segment ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__init__()

                                        self.yang_name = "sr-prefix-segment"
                                        self.yang_parent_name = "label-context"

                                        self.segment_id = YLeaf(YType.uint32, "segment-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("segment_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.segment_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.segment_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-prefix-segment" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.segment_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "segment-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "segment-id"):
                                            self.segment_id = value
                                            self.segment_id.value_namespace = name_space
                                            self.segment_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class SrAdjSegmentIpv4(Entity):
                                    """
                                    SR Adj Segment ipv4 context
                                    
                                    .. attribute:: addr
                                    
                                    	Adjacency nexthop IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: index
                                    
                                    	Adjacency index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: intf
                                    
                                    	Adjacency interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: type
                                    
                                    	Adjacency type
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__init__()

                                        self.yang_name = "sr-adj-segment-ipv4"
                                        self.yang_parent_name = "label-context"

                                        self.addr = YLeaf(YType.str, "addr")

                                        self.index = YLeaf(YType.uint32, "index")

                                        self.intf = YLeaf(YType.str, "intf")

                                        self.type = YLeaf(YType.uint32, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("addr",
                                                        "index",
                                                        "intf",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.addr.is_set or
                                            self.index.is_set or
                                            self.intf.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.addr.yfilter != YFilter.not_set or
                                            self.index.yfilter != YFilter.not_set or
                                            self.intf.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-adj-segment-ipv4" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.addr.get_name_leafdata())
                                        if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.index.get_name_leafdata())
                                        if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.intf.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "addr"):
                                            self.addr = value
                                            self.addr.value_namespace = name_space
                                            self.addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "index"):
                                            self.index = value
                                            self.index.value_namespace = name_space
                                            self.index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "intf"):
                                            self.intf = value
                                            self.intf.value_namespace = name_space
                                            self.intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class SrAdjSegmentIpv6(Entity):
                                    """
                                    SR Adj Segment ipv6 context
                                    
                                    .. attribute:: addr
                                    
                                    	Adjacency nexthop IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: index
                                    
                                    	Adjacency index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: intf
                                    
                                    	Adjacency interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: type
                                    
                                    	Adjacency type
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__init__()

                                        self.yang_name = "sr-adj-segment-ipv6"
                                        self.yang_parent_name = "label-context"

                                        self.addr = YLeaf(YType.str, "addr")

                                        self.index = YLeaf(YType.uint32, "index")

                                        self.intf = YLeaf(YType.str, "intf")

                                        self.type = YLeaf(YType.uint32, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("addr",
                                                        "index",
                                                        "intf",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.addr.is_set or
                                            self.index.is_set or
                                            self.intf.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.addr.yfilter != YFilter.not_set or
                                            self.index.yfilter != YFilter.not_set or
                                            self.intf.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-adj-segment-ipv6" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.addr.get_name_leafdata())
                                        if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.index.get_name_leafdata())
                                        if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.intf.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "addr"):
                                            self.addr = value
                                            self.addr.value_namespace = name_space
                                            self.addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "index"):
                                            self.index = value
                                            self.index.value_namespace = name_space
                                            self.index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "intf"):
                                            self.intf = value
                                            self.intf.value_namespace = name_space
                                            self.intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class LabelBlockSrgbData(Entity):
                                    """
                                    Label block SRGB context
                                    
                                    .. attribute:: offset
                                    
                                    	Offset
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: size
                                    
                                    	Number of labels
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: start_label
                                    
                                    	Start Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__init__()

                                        self.yang_name = "label-block-srgb-data"
                                        self.yang_parent_name = "label-context"

                                        self.offset = YLeaf(YType.uint32, "offset")

                                        self.size = YLeaf(YType.uint32, "size")

                                        self.start_label = YLeaf(YType.uint32, "start-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("offset",
                                                        "size",
                                                        "start_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.offset.is_set or
                                            self.size.is_set or
                                            self.start_label.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.offset.yfilter != YFilter.not_set or
                                            self.size.yfilter != YFilter.not_set or
                                            self.start_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "label-block-srgb-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.offset.get_name_leafdata())
                                        if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.size.get_name_leafdata())
                                        if (self.start_label.is_set or self.start_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.start_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "offset" or name == "size" or name == "start-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "offset"):
                                            self.offset = value
                                            self.offset.value_namespace = name_space
                                            self.offset.value_namespace_prefix = name_space_prefix
                                        if(value_path == "size"):
                                            self.size = value
                                            self.size.value_namespace = name_space
                                            self.size.value_namespace_prefix = name_space_prefix
                                        if(value_path == "start-label"):
                                            self.start_label = value
                                            self.start_label.value_namespace = name_space
                                            self.start_label.value_namespace_prefix = name_space_prefix


                                class TeBinding(Entity):
                                    """
                                    MPLS TE tunnel binding context
                                    
                                    .. attribute:: te_identifier
                                    
                                    	MPLS Traffic Engineering Tunnel or Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_type
                                    
                                    	Type of identifier for the binding
                                    	**type**\:   :py:class:`MgmtLsdTeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdTeBinding>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TeBinding, self).__init__()

                                        self.yang_name = "te-binding"
                                        self.yang_parent_name = "label-context"

                                        self.te_identifier = YLeaf(YType.uint32, "te-identifier")

                                        self.te_type = YLeaf(YType.enumeration, "te-type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("te_identifier",
                                                        "te_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.te_identifier.is_set or
                                            self.te_type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.te_identifier.yfilter != YFilter.not_set or
                                            self.te_type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "te-binding" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.te_identifier.is_set or self.te_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_identifier.get_name_leafdata())
                                        if (self.te_type.is_set or self.te_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "te-identifier" or name == "te-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "te-identifier"):
                                            self.te_identifier = value
                                            self.te_identifier.value_namespace = name_space
                                            self.te_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-type"):
                                            self.te_type = value
                                            self.te_type.value_namespace = name_space
                                            self.te_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_context_type.is_set or
                                        (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_data()) or
                                        (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_data()) or
                                        (self.evpn_data is not None and self.evpn_data.has_data()) or
                                        (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_data()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                        (self.ipv4blb_data is not None and self.ipv4blb_data.has_data()) or
                                        (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_data()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                        (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_data()) or
                                        (self.ipv6blb_data is not None and self.ipv6blb_data.has_data()) or
                                        (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_data()) or
                                        (self.label_block_data is not None and self.label_block_data.has_data()) or
                                        (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_data()) or
                                        (self.mld_pv4_data is not None and self.mld_pv4_data.has_data()) or
                                        (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_data()) or
                                        (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_data()) or
                                        (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_data()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                        (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_data()) or
                                        (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_data()) or
                                        (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_data()) or
                                        (self.te_binding is not None and self.te_binding.has_data()) or
                                        (self.tev4_data is not None and self.tev4_data.has_data()) or
                                        (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_data()) or
                                        (self.tp_data is not None and self.tp_data.has_data()) or
                                        (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_context_type.yfilter != YFilter.not_set or
                                        (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_operation()) or
                                        (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_operation()) or
                                        (self.evpn_data is not None and self.evpn_data.has_operation()) or
                                        (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_operation()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                        (self.ipv4blb_data is not None and self.ipv4blb_data.has_operation()) or
                                        (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_operation()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                        (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_operation()) or
                                        (self.ipv6blb_data is not None and self.ipv6blb_data.has_operation()) or
                                        (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_operation()) or
                                        (self.label_block_data is not None and self.label_block_data.has_operation()) or
                                        (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_operation()) or
                                        (self.mld_pv4_data is not None and self.mld_pv4_data.has_operation()) or
                                        (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_operation()) or
                                        (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_operation()) or
                                        (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_operation()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                        (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_operation()) or
                                        (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_operation()) or
                                        (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_operation()) or
                                        (self.te_binding is not None and self.te_binding.has_operation()) or
                                        (self.tev4_data is not None and self.tev4_data.has_operation()) or
                                        (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_operation()) or
                                        (self.tp_data is not None and self.tp_data.has_operation()) or
                                        (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-context" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_context_type.is_set or self.label_context_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_context_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cev4l3vpn-data"):
                                        if (self.cev4l3vpn_data is None):
                                            self.cev4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                            self.cev4l3vpn_data.parent = self
                                            self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                        return self.cev4l3vpn_data

                                    if (child_yang_name == "cev6l3vpn-data"):
                                        if (self.cev6l3vpn_data is None):
                                            self.cev6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                            self.cev6l3vpn_data.parent = self
                                            self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                        return self.cev6l3vpn_data

                                    if (child_yang_name == "evpn-data"):
                                        if (self.evpn_data is None):
                                            self.evpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.EvpnData()
                                            self.evpn_data.parent = self
                                            self._children_name_map["evpn_data"] = "evpn-data"
                                        return self.evpn_data

                                    if (child_yang_name == "generic-routing-encapsulation"):
                                        if (self.generic_routing_encapsulation is None):
                                            self.generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                            self.generic_routing_encapsulation.parent = self
                                            self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                        return self.generic_routing_encapsulation

                                    if (child_yang_name == "ip-sub-data"):
                                        if (self.ip_sub_data is None):
                                            self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.IpSubData()
                                            self.ip_sub_data.parent = self
                                            self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                        return self.ip_sub_data

                                    if (child_yang_name == "ipv4-data"):
                                        if (self.ipv4_data is None):
                                            self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                            self.ipv4_data.parent = self
                                            self._children_name_map["ipv4_data"] = "ipv4-data"
                                        return self.ipv4_data

                                    if (child_yang_name == "ipv4blb-data"):
                                        if (self.ipv4blb_data is None):
                                            self.ipv4blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                            self.ipv4blb_data.parent = self
                                            self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                        return self.ipv4blb_data

                                    if (child_yang_name == "ipv4l3vpn-data"):
                                        if (self.ipv4l3vpn_data is None):
                                            self.ipv4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                            self.ipv4l3vpn_data.parent = self
                                            self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                        return self.ipv4l3vpn_data

                                    if (child_yang_name == "ipv6-data"):
                                        if (self.ipv6_data is None):
                                            self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                            self.ipv6_data.parent = self
                                            self._children_name_map["ipv6_data"] = "ipv6-data"
                                        return self.ipv6_data

                                    if (child_yang_name == "ipv6-generic-routing-encapsulation"):
                                        if (self.ipv6_generic_routing_encapsulation is None):
                                            self.ipv6_generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                            self.ipv6_generic_routing_encapsulation.parent = self
                                            self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                        return self.ipv6_generic_routing_encapsulation

                                    if (child_yang_name == "ipv6blb-data"):
                                        if (self.ipv6blb_data is None):
                                            self.ipv6blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                            self.ipv6blb_data.parent = self
                                            self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                        return self.ipv6blb_data

                                    if (child_yang_name == "ipv6l3vpn-data"):
                                        if (self.ipv6l3vpn_data is None):
                                            self.ipv6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                            self.ipv6l3vpn_data.parent = self
                                            self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                        return self.ipv6l3vpn_data

                                    if (child_yang_name == "label-block-data"):
                                        if (self.label_block_data is None):
                                            self.label_block_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                            self.label_block_data.parent = self
                                            self._children_name_map["label_block_data"] = "label-block-data"
                                        return self.label_block_data

                                    if (child_yang_name == "label-block-srgb-data"):
                                        if (self.label_block_srgb_data is None):
                                            self.label_block_srgb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                            self.label_block_srgb_data.parent = self
                                            self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                        return self.label_block_srgb_data

                                    if (child_yang_name == "mld-pv4-data"):
                                        if (self.mld_pv4_data is None):
                                            self.mld_pv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                            self.mld_pv4_data.parent = self
                                            self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                        return self.mld_pv4_data

                                    if (child_yang_name == "next-hop-set-l3vpn"):
                                        if (self.next_hop_set_l3vpn is None):
                                            self.next_hop_set_l3vpn = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                            self.next_hop_set_l3vpn.parent = self
                                            self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                        return self.next_hop_set_l3vpn

                                    if (child_yang_name == "pi-mi-pmsi-data"):
                                        if (self.pi_mi_pmsi_data is None):
                                            self.pi_mi_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                            self.pi_mi_pmsi_data.parent = self
                                            self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                        return self.pi_mi_pmsi_data

                                    if (child_yang_name == "pi-ms-pmsi-data"):
                                        if (self.pi_ms_pmsi_data is None):
                                            self.pi_ms_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                            self.pi_ms_pmsi_data.parent = self
                                            self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                        return self.pi_ms_pmsi_data

                                    if (child_yang_name == "pseudowire-data"):
                                        if (self.pseudowire_data is None):
                                            self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireData()
                                            self.pseudowire_data.parent = self
                                            self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                        return self.pseudowire_data

                                    if (child_yang_name == "pseudowire-head-end-data"):
                                        if (self.pseudowire_head_end_data is None):
                                            self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                            self.pseudowire_head_end_data.parent = self
                                            self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                        return self.pseudowire_head_end_data

                                    if (child_yang_name == "sr-adj-segment-ipv4"):
                                        if (self.sr_adj_segment_ipv4 is None):
                                            self.sr_adj_segment_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                            self.sr_adj_segment_ipv4.parent = self
                                            self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                        return self.sr_adj_segment_ipv4

                                    if (child_yang_name == "sr-adj-segment-ipv6"):
                                        if (self.sr_adj_segment_ipv6 is None):
                                            self.sr_adj_segment_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                            self.sr_adj_segment_ipv6.parent = self
                                            self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                        return self.sr_adj_segment_ipv6

                                    if (child_yang_name == "sr-prefix-segment"):
                                        if (self.sr_prefix_segment is None):
                                            self.sr_prefix_segment = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                            self.sr_prefix_segment.parent = self
                                            self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                        return self.sr_prefix_segment

                                    if (child_yang_name == "te-binding"):
                                        if (self.te_binding is None):
                                            self.te_binding = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TeBinding()
                                            self.te_binding.parent = self
                                            self._children_name_map["te_binding"] = "te-binding"
                                        return self.te_binding

                                    if (child_yang_name == "tev4-data"):
                                        if (self.tev4_data is None):
                                            self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4Data()
                                            self.tev4_data.parent = self
                                            self._children_name_map["tev4_data"] = "tev4-data"
                                        return self.tev4_data

                                    if (child_yang_name == "tev4p2mp-data"):
                                        if (self.tev4p2mp_data is None):
                                            self.tev4p2mp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                            self.tev4p2mp_data.parent = self
                                            self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                        return self.tev4p2mp_data

                                    if (child_yang_name == "tp-data"):
                                        if (self.tp_data is None):
                                            self.tp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TpData()
                                            self.tp_data.parent = self
                                            self._children_name_map["tp_data"] = "tp-data"
                                        return self.tp_data

                                    if (child_yang_name == "vrf-l3vpn-data"):
                                        if (self.vrf_l3vpn_data is None):
                                            self.vrf_l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                            self.vrf_l3vpn_data.parent = self
                                            self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                        return self.vrf_l3vpn_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cev4l3vpn-data" or name == "cev6l3vpn-data" or name == "evpn-data" or name == "generic-routing-encapsulation" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv4blb-data" or name == "ipv4l3vpn-data" or name == "ipv6-data" or name == "ipv6-generic-routing-encapsulation" or name == "ipv6blb-data" or name == "ipv6l3vpn-data" or name == "label-block-data" or name == "label-block-srgb-data" or name == "mld-pv4-data" or name == "next-hop-set-l3vpn" or name == "pi-mi-pmsi-data" or name == "pi-ms-pmsi-data" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "sr-adj-segment-ipv4" or name == "sr-adj-segment-ipv6" or name == "sr-prefix-segment" or name == "te-binding" or name == "tev4-data" or name == "tev4p2mp-data" or name == "tp-data" or name == "vrf-l3vpn-data" or name == "label-context-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-context-type"):
                                        self.label_context_type = value
                                        self.label_context_type.value_namespace = name_space
                                        self.label_context_type.value_namespace_prefix = name_space_prefix


                            class LocalLabelRewrite(Entity):
                                """
                                Local label rewrite information
                                
                                .. attribute:: label_data
                                
                                	label data
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LocalLabelRewrite, self).__init__()

                                    self.yang_name = "local-label-rewrite"
                                    self.yang_parent_name = "rewrite-id"

                                    self.label_data = YLeafList(YType.uint32, "label-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_data") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)

                                def has_data(self):
                                    for leaf in self.label_data.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    return False

                                def has_operation(self):
                                    for leaf in self.label_data.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_data.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "local-label-rewrite" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    leaf_name_data.extend(self.label_data.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "label-data"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-data"):
                                        self.label_data.append(value)

                            def has_data(self):
                                return (
                                    self.rewrite_id_type.is_set or
                                    (self.label_context is not None and self.label_context.has_data()) or
                                    (self.local_label_rewrite is not None and self.local_label_rewrite.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rewrite_id_type.yfilter != YFilter.not_set or
                                    (self.label_context is not None and self.label_context.has_operation()) or
                                    (self.local_label_rewrite is not None and self.local_label_rewrite.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "rewrite-id" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rewrite_id_type.is_set or self.rewrite_id_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rewrite_id_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "label-context"):
                                    if (self.label_context is None):
                                        self.label_context = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext()
                                        self.label_context.parent = self
                                        self._children_name_map["label_context"] = "label-context"
                                    return self.label_context

                                if (child_yang_name == "local-label-rewrite"):
                                    if (self.local_label_rewrite is None):
                                        self.local_label_rewrite = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LocalLabelRewrite()
                                        self.local_label_rewrite.parent = self
                                        self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                                    return self.local_label_rewrite

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "label-context" or name == "local-label-rewrite" or name == "rewrite-id-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rewrite-id-type"):
                                    self.rewrite_id_type = value
                                    self.rewrite_id_type.value_namespace = name_space
                                    self.rewrite_id_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.rewrite_id is not None and self.rewrite_id.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rewrite-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "rewrite-id"):
                                if (self.rewrite_id is None):
                                    self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId()
                                    self.rewrite_id.parent = self
                                    self._children_name_map["rewrite_id"] = "rewrite-id"
                                return self.rewrite_id

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "rewrite-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class AssociatedFpi(Entity):
                        """
                        Associated FPI
                        
                        .. attribute:: application_owner
                        
                        	Application owner instance
                        	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.ApplicationOwner>`
                        
                        .. attribute:: fpi
                        
                        	FPI
                        	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi, self).__init__()

                            self.yang_name = "associated-fpi"
                            self.yang_parent_name = "rewrite-pw"

                            self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi()
                            self.fpi.parent = self
                            self._children_name_map["fpi"] = "fpi"
                            self._children_yang_names.add("fpi")

                            self.application_owner = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi, self).__setattr__(name, value)


                        class Fpi(Entity):
                            """
                            FPI
                            
                            .. attribute:: dmtc_ext_intf_data
                            
                            	dmtc ext intf data
                            	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.DmtcExtIntfData>`
                            
                            .. attribute:: fpi_type
                            
                            	FPIType
                            	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                            
                            .. attribute:: ipv4_data
                            
                            	ipv4 data
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv4Data>`
                            
                            .. attribute:: ipv6_data
                            
                            	ipv6 data
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv6Data>`
                            
                            .. attribute:: label_data
                            
                            	label data
                            	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.LabelData>`
                            
                            .. attribute:: pw_list_data
                            
                            	pw list data
                            	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.PwListData>`
                            
                            .. attribute:: te_data
                            
                            	te data
                            	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.TeData>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi, self).__init__()

                                self.yang_name = "fpi"
                                self.yang_parent_name = "associated-fpi"

                                self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                                self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.DmtcExtIntfData()
                                self.dmtc_ext_intf_data.parent = self
                                self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                self._children_yang_names.add("dmtc-ext-intf-data")

                                self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.LabelData()
                                self.label_data.parent = self
                                self._children_name_map["label_data"] = "label-data"
                                self._children_yang_names.add("label-data")

                                self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.PwListData()
                                self.pw_list_data.parent = self
                                self._children_name_map["pw_list_data"] = "pw-list-data"
                                self._children_yang_names.add("pw-list-data")

                                self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.TeData()
                                self.te_data.parent = self
                                self._children_name_map["te_data"] = "te-data"
                                self._children_yang_names.add("te-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fpi_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi, self).__setattr__(name, value)


                            class LabelData(Entity):
                                """
                                label data
                                
                                .. attribute:: elc
                                
                                	ELC
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: label
                                
                                	Label value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.LabelData, self).__init__()

                                    self.yang_name = "label-data"
                                    self.yang_parent_name = "fpi"

                                    self.elc = YLeaf(YType.int32, "elc")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("elc",
                                                    "label",
                                                    "security_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.elc.is_set or
                                        self.label.is_set or
                                        self.security_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.elc.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.elc.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "elc" or name == "label" or name == "security-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "elc"):
                                        self.elc = value
                                        self.elc.value_namespace = name_space
                                        self.elc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix


                            class TeData(Entity):
                                """
                                te data
                                
                                .. attribute:: local_label
                                
                                	Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_interface
                                
                                	Tunnel interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.TeData, self).__init__()

                                    self.yang_name = "te-data"
                                    self.yang_parent_name = "fpi"

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("local_label",
                                                    "tunnel_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.local_label.is_set or
                                        self.tunnel_interface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.tunnel_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "local-label" or name == "tunnel-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface"):
                                        self.tunnel_interface = value
                                        self.tunnel_interface.value_namespace = name_space
                                        self.tunnel_interface.value_namespace_prefix = name_space_prefix


                            class Ipv4Data(Entity):
                                """
                                ipv4 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: sr_local_label
                                
                                	SR related Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "sr_local_label",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.sr_local_label.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.sr_local_label.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sr-local-label"):
                                        self.sr_local_label = value
                                        self.sr_local_label.value_namespace = name_space
                                        self.sr_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                ipv6 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: router_flags
                                
                                	Route flags
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    self.router_flags = YLeaf(YType.uint32, "router-flags")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_len",
                                                    "router_flags",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_len.is_set or
                                        self.router_flags.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set or
                                        self.router_flags.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                    if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_flags.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-flags"):
                                        self.router_flags = value
                                        self.router_flags.value_namespace = name_space
                                        self.router_flags.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class PwListData(Entity):
                                """
                                pw list data
                                
                                .. attribute:: pwhe_list_id
                                
                                	Pseudowire List Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.PwListData, self).__init__()

                                    self.yang_name = "pw-list-data"
                                    self.yang_parent_name = "fpi"

                                    self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("pwhe_list_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.pwhe_list_id.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.pwhe_list_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pw-list-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "pwhe-list-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "pwhe-list-id"):
                                        self.pwhe_list_id = value
                                        self.pwhe_list_id.value_namespace = name_space
                                        self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                            class DmtcExtIntfData(Entity):
                                """
                                dmtc ext intf data
                                
                                .. attribute:: dmtc_ext_ifh
                                
                                	DMTC External Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.DmtcExtIntfData, self).__init__()

                                    self.yang_name = "dmtc-ext-intf-data"
                                    self.yang_parent_name = "fpi"

                                    self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.dmtc_ext_ifh.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "dmtc-ext-intf-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-ext-ifh"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dmtc-ext-ifh"):
                                        self.dmtc_ext_ifh = value
                                        self.dmtc_ext_ifh.value_namespace = name_space
                                        self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fpi_type.is_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.label_data is not None and self.label_data.has_data()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                    (self.te_data is not None and self.te_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fpi_type.yfilter != YFilter.not_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.label_data is not None and self.label_data.has_operation()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                    (self.te_data is not None and self.te_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fpi" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fpi_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "dmtc-ext-intf-data"):
                                    if (self.dmtc_ext_intf_data is None):
                                        self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.DmtcExtIntfData()
                                        self.dmtc_ext_intf_data.parent = self
                                        self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                    return self.dmtc_ext_intf_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "label-data"):
                                    if (self.label_data is None):
                                        self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.LabelData()
                                        self.label_data.parent = self
                                        self._children_name_map["label_data"] = "label-data"
                                    return self.label_data

                                if (child_yang_name == "pw-list-data"):
                                    if (self.pw_list_data is None):
                                        self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.PwListData()
                                        self.pw_list_data.parent = self
                                        self._children_name_map["pw_list_data"] = "pw-list-data"
                                    return self.pw_list_data

                                if (child_yang_name == "te-data"):
                                    if (self.te_data is None):
                                        self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.TeData()
                                        self.te_data.parent = self
                                        self._children_name_map["te_data"] = "te-data"
                                    return self.te_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fpi-type"):
                                    self.fpi_type = value
                                    self.fpi_type.value_namespace = name_space
                                    self.fpi_type.value_namespace_prefix = name_space_prefix


                        class ApplicationOwner(Entity):
                            """
                            Application owner instance
                            
                            .. attribute:: application_instance
                            
                            	Application instance Name
                            	**type**\:  str
                            
                            .. attribute:: application_name
                            
                            	Application name
                            	**type**\:  str
                            
                            .. attribute:: application_role_primary
                            
                            	Primary/Backup role
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: application_type
                            
                            	Application type
                            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                            
                            .. attribute:: resource_state
                            
                            	Application resource state
                            	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.ApplicationOwner, self).__init__()

                                self.yang_name = "application-owner"
                                self.yang_parent_name = "associated-fpi"

                                self.application_instance = YLeaf(YType.str, "application-instance")

                                self.application_name = YLeaf(YType.str, "application-name")

                                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                                self.application_type = YLeaf(YType.enumeration, "application-type")

                                self.resource_state = YLeaf(YType.enumeration, "resource-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("application_instance",
                                                "application_name",
                                                "application_role_primary",
                                                "application_type",
                                                "resource_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.application_instance.is_set or
                                    self.application_name.is_set or
                                    self.application_role_primary.is_set or
                                    self.application_type.is_set or
                                    self.resource_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.application_instance.yfilter != YFilter.not_set or
                                    self.application_name.yfilter != YFilter.not_set or
                                    self.application_role_primary.yfilter != YFilter.not_set or
                                    self.application_type.yfilter != YFilter.not_set or
                                    self.resource_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "application-owner" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_name.get_name_leafdata())
                                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_type.get_name_leafdata())
                                if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resource_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "application-instance"):
                                    self.application_instance = value
                                    self.application_instance.value_namespace = name_space
                                    self.application_instance.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-name"):
                                    self.application_name = value
                                    self.application_name.value_namespace = name_space
                                    self.application_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-role-primary"):
                                    self.application_role_primary = value
                                    self.application_role_primary.value_namespace = name_space
                                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-type"):
                                    self.application_type = value
                                    self.application_type.value_namespace = name_space
                                    self.application_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "resource-state"):
                                    self.resource_state = value
                                    self.resource_state.value_namespace = name_space
                                    self.resource_state.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.application_owner:
                                if (c.has_data()):
                                    return True
                            return (self.fpi is not None and self.fpi.has_data())

                        def has_operation(self):
                            for c in self.application_owner:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.fpi is not None and self.fpi.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "associated-fpi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "application-owner"):
                                for c in self.application_owner:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.ApplicationOwner()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.application_owner.append(c)
                                return c

                            if (child_yang_name == "fpi"):
                                if (self.fpi is None):
                                    self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi()
                                    self.fpi.parent = self
                                    self._children_name_map["fpi"] = "fpi"
                                return self.fpi

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-owner" or name == "fpi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class V4Rpf(Entity):
                        """
                        IPv4 RPF neighbors
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: v4_rpf_neighbor
                        
                        	V4 RPF Neighbor
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.V4Rpf, self).__init__()

                            self.yang_name = "v4-rpf"
                            self.yang_parent_name = "rewrite-pw"

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.v4_rpf_neighbor = YLeaf(YType.str, "v4-rpf-neighbor")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("table_id",
                                            "v4_rpf_neighbor") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.V4Rpf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.V4Rpf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.table_id.is_set or
                                self.v4_rpf_neighbor.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.v4_rpf_neighbor.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "v4-rpf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.v4_rpf_neighbor.is_set or self.v4_rpf_neighbor.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.v4_rpf_neighbor.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "table-id" or name == "v4-rpf-neighbor"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "v4-rpf-neighbor"):
                                self.v4_rpf_neighbor = value
                                self.v4_rpf_neighbor.value_namespace = name_space
                                self.v4_rpf_neighbor.value_namespace_prefix = name_space_prefix


                    class V6Rpf(Entity):
                        """
                        IPv6 RPF neighbors
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: v6_rpf_neighbor
                        
                        	V6 RPF Neighbor
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.V6Rpf, self).__init__()

                            self.yang_name = "v6-rpf"
                            self.yang_parent_name = "rewrite-pw"

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.v6_rpf_neighbor = YLeaf(YType.str, "v6-rpf-neighbor")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("table_id",
                                            "v6_rpf_neighbor") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.V6Rpf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.V6Rpf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.table_id.is_set or
                                self.v6_rpf_neighbor.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.v6_rpf_neighbor.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "v6-rpf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.v6_rpf_neighbor.is_set or self.v6_rpf_neighbor.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.v6_rpf_neighbor.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "table-id" or name == "v6-rpf-neighbor"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "v6-rpf-neighbor"):
                                self.v6_rpf_neighbor = value
                                self.v6_rpf_neighbor.value_namespace = name_space
                                self.v6_rpf_neighbor.value_namespace_prefix = name_space_prefix


                    class Mois(Entity):
                        """
                        Mois
                        
                        .. attribute:: application_resource
                        
                        	Application state
                        	**type**\:   :py:class:`ApplicationResource <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.ApplicationResource>`
                        
                        .. attribute:: moi_array
                        
                        	moi array
                        	**type**\: list of    :py:class:`MoiArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois, self).__init__()

                            self.yang_name = "mois"
                            self.yang_parent_name = "rewrite-pw"

                            self.application_resource = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.ApplicationResource()
                            self.application_resource.parent = self
                            self._children_name_map["application_resource"] = "application-resource"
                            self._children_yang_names.add("application-resource")

                            self.moi_array = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois, self).__setattr__(name, value)


                        class ApplicationResource(Entity):
                            """
                            Application state
                            
                            .. attribute:: application_instance
                            
                            	Application instance Name
                            	**type**\:  str
                            
                            .. attribute:: application_name
                            
                            	Application name
                            	**type**\:  str
                            
                            .. attribute:: application_role_primary
                            
                            	Primary/Backup role
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: application_type
                            
                            	Application type
                            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                            
                            .. attribute:: resource_state
                            
                            	Application resource state
                            	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.ApplicationResource, self).__init__()

                                self.yang_name = "application-resource"
                                self.yang_parent_name = "mois"

                                self.application_instance = YLeaf(YType.str, "application-instance")

                                self.application_name = YLeaf(YType.str, "application-name")

                                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                                self.application_type = YLeaf(YType.enumeration, "application-type")

                                self.resource_state = YLeaf(YType.enumeration, "resource-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("application_instance",
                                                "application_name",
                                                "application_role_primary",
                                                "application_type",
                                                "resource_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.ApplicationResource, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.ApplicationResource, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.application_instance.is_set or
                                    self.application_name.is_set or
                                    self.application_role_primary.is_set or
                                    self.application_type.is_set or
                                    self.resource_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.application_instance.yfilter != YFilter.not_set or
                                    self.application_name.yfilter != YFilter.not_set or
                                    self.application_role_primary.yfilter != YFilter.not_set or
                                    self.application_type.yfilter != YFilter.not_set or
                                    self.resource_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "application-resource" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_name.get_name_leafdata())
                                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_type.get_name_leafdata())
                                if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resource_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "application-instance"):
                                    self.application_instance = value
                                    self.application_instance.value_namespace = name_space
                                    self.application_instance.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-name"):
                                    self.application_name = value
                                    self.application_name.value_namespace = name_space
                                    self.application_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-role-primary"):
                                    self.application_role_primary = value
                                    self.application_role_primary.value_namespace = name_space
                                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-type"):
                                    self.application_type = value
                                    self.application_type.value_namespace = name_space
                                    self.application_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "resource-state"):
                                    self.resource_state = value
                                    self.resource_state.value_namespace = name_space
                                    self.resource_state.value_namespace_prefix = name_space_prefix


                        class MoiArray(Entity):
                            """
                            moi array
                            
                            .. attribute:: moi
                            
                            	Moi
                            	**type**\:   :py:class:`Moi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray, self).__init__()

                                self.yang_name = "moi-array"
                                self.yang_parent_name = "mois"

                                self.moi = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi()
                                self.moi.parent = self
                                self._children_name_map["moi"] = "moi"
                                self._children_yang_names.add("moi")


                            class Moi(Entity):
                                """
                                Moi
                                
                                .. attribute:: dmtc_data
                                
                                	dmtc data
                                	**type**\:   :py:class:`DmtcData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.DmtcData>`
                                
                                .. attribute:: ip_sub_data
                                
                                	ip sub data
                                	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.IpSubData>`
                                
                                .. attribute:: ipv4_data
                                
                                	ipv4 data
                                	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv4Data>`
                                
                                .. attribute:: ipv6_data
                                
                                	ipv6 data
                                	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv6Data>`
                                
                                .. attribute:: moi_type
                                
                                	MoiType
                                	**type**\:   :py:class:`MgmtLsdMoi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdMoi>`
                                
                                .. attribute:: pop_and_lookup_ipv4
                                
                                	pop and lookup ipv4
                                	**type**\:   :py:class:`PopAndLookupIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv4>`
                                
                                .. attribute:: pop_and_lookup_ipv6
                                
                                	pop and lookup ipv6
                                	**type**\:   :py:class:`PopAndLookupIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv6>`
                                
                                .. attribute:: pop_and_lookup_tp
                                
                                	pop and lookup tp
                                	**type**\:   :py:class:`PopAndLookupTp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupTp>`
                                
                                .. attribute:: pseudowire_data
                                
                                	pseudowire data
                                	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireData>`
                                
                                .. attribute:: pseudowire_head_end_data
                                
                                	pseudowire head end data
                                	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireHeadEndData>`
                                
                                .. attribute:: pw_list_data
                                
                                	pw list data
                                	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PwListData>`
                                
                                .. attribute:: stackv4_data
                                
                                	stackv4 data
                                	**type**\:   :py:class:`Stackv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data>`
                                
                                .. attribute:: stackv6_data
                                
                                	stackv6 data
                                	**type**\:   :py:class:`Stackv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data>`
                                
                                .. attribute:: te_head_data
                                
                                	te head data
                                	**type**\:   :py:class:`TeHeadData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.TeHeadData>`
                                
                                .. attribute:: tev4_data
                                
                                	tev4 data
                                	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Tev4Data>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi, self).__init__()

                                    self.yang_name = "moi"
                                    self.yang_parent_name = "moi-array"

                                    self.moi_type = YLeaf(YType.enumeration, "moi-type")

                                    self.dmtc_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.DmtcData()
                                    self.dmtc_data.parent = self
                                    self._children_name_map["dmtc_data"] = "dmtc-data"
                                    self._children_yang_names.add("dmtc-data")

                                    self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.IpSubData()
                                    self.ip_sub_data.parent = self
                                    self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    self._children_yang_names.add("ip-sub-data")

                                    self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                    self._children_yang_names.add("ipv4-data")

                                    self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                    self._children_yang_names.add("ipv6-data")

                                    self.pop_and_lookup_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                    self.pop_and_lookup_ipv4.parent = self
                                    self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                    self._children_yang_names.add("pop-and-lookup-ipv4")

                                    self.pop_and_lookup_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                    self.pop_and_lookup_ipv6.parent = self
                                    self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                    self._children_yang_names.add("pop-and-lookup-ipv6")

                                    self.pop_and_lookup_tp = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupTp()
                                    self.pop_and_lookup_tp.parent = self
                                    self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                    self._children_yang_names.add("pop-and-lookup-tp")

                                    self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireData()
                                    self.pseudowire_data.parent = self
                                    self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    self._children_yang_names.add("pseudowire-data")

                                    self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                    self.pseudowire_head_end_data.parent = self
                                    self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    self._children_yang_names.add("pseudowire-head-end-data")

                                    self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PwListData()
                                    self.pw_list_data.parent = self
                                    self._children_name_map["pw_list_data"] = "pw-list-data"
                                    self._children_yang_names.add("pw-list-data")

                                    self.stackv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data()
                                    self.stackv4_data.parent = self
                                    self._children_name_map["stackv4_data"] = "stackv4-data"
                                    self._children_yang_names.add("stackv4-data")

                                    self.stackv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data()
                                    self.stackv6_data.parent = self
                                    self._children_name_map["stackv6_data"] = "stackv6-data"
                                    self._children_yang_names.add("stackv6-data")

                                    self.te_head_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.TeHeadData()
                                    self.te_head_data.parent = self
                                    self._children_name_map["te_head_data"] = "te-head-data"
                                    self._children_yang_names.add("te-head-data")

                                    self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Tev4Data()
                                    self.tev4_data.parent = self
                                    self._children_name_map["tev4_data"] = "tev4-data"
                                    self._children_yang_names.add("tev4-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("moi_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi, self).__setattr__(name, value)


                                class PopAndLookupIpv4(Entity):
                                    """
                                    pop and lookup ipv4
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__init__()

                                        self.yang_name = "pop-and-lookup-ipv4"
                                        self.yang_parent_name = "moi"

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pop-and-lookup-ipv4" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class PopAndLookupTp(Entity):
                                    """
                                    pop and lookup tp
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupTp, self).__init__()

                                        self.yang_name = "pop-and-lookup-tp"
                                        self.yang_parent_name = "moi"

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("out_label",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.out_label.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pop-and-lookup-tp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "out-label" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class PopAndLookupIpv6(Entity):
                                    """
                                    pop and lookup ipv6
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__init__()

                                        self.yang_name = "pop-and-lookup-ipv6"
                                        self.yang_parent_name = "moi"

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pop-and-lookup-ipv6" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class Ipv4Data(Entity):
                                    """
                                    ipv4 data
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: load_metric
                                    
                                    	Routing path's load metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: local_label
                                    
                                    	TE backup path local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_interface_parent
                                    
                                    	Outgoing Interface's parent
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv4Data, self).__init__()

                                        self.yang_name = "ipv4-data"
                                        self.yang_parent_name = "moi"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.load_metric = YLeaf(YType.uint32, "load-metric")

                                        self.local_label = YLeaf(YType.uint32, "local-label")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv4_next_hop",
                                                        "load_metric",
                                                        "local_label",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_interface_parent",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.load_metric.is_set or
                                            self.local_label.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_interface_parent.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.load_metric.yfilter != YFilter.not_set or
                                            self.local_label.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_interface_parent.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_metric.get_name_leafdata())
                                        if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_label.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-metric"):
                                            self.load_metric = value
                                            self.load_metric.value_namespace = name_space
                                            self.load_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-label"):
                                            self.local_label = value
                                            self.local_label.value_namespace = name_space
                                            self.local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface-parent"):
                                            self.out_interface_parent = value
                                            self.out_interface_parent.value_namespace = name_space
                                            self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix


                                class Ipv6Data(Entity):
                                    """
                                    ipv6 data
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv6_next_hop
                                    
                                    	IPv6 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv6Data, self).__init__()

                                        self.yang_name = "ipv6-data"
                                        self.yang_parent_name = "moi"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv6_next_hop",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv6_next_hop.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv6_next_hop.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6-next-hop"):
                                            self.ipv6_next_hop = value
                                            self.ipv6_next_hop.value_namespace = name_space
                                            self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class Tev4Data(Entity):
                                    """
                                    tev4 data
                                    
                                    .. attribute:: backup_interface
                                    
                                    	Backup interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: backup_ipv4_next_hop
                                    
                                    	Backup IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: backup_local_label
                                    
                                    	Backup local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: data_out_parent_interface
                                    
                                    	Outgoing data parent interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: merge_point_label
                                    
                                    	Merge point label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_class
                                    
                                    	Tunnel class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_interface
                                    
                                    	Tunnel interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: tunnel_weight
                                    
                                    	Tunnel weight
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Tev4Data, self).__init__()

                                        self.yang_name = "tev4-data"
                                        self.yang_parent_name = "moi"

                                        self.backup_interface = YLeaf(YType.str, "backup-interface")

                                        self.backup_ipv4_next_hop = YLeaf(YType.str, "backup-ipv4-next-hop")

                                        self.backup_local_label = YLeaf(YType.uint32, "backup-local-label")

                                        self.data_out_parent_interface = YLeaf(YType.str, "data-out-parent-interface")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.merge_point_label = YLeaf(YType.uint32, "merge-point-label")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_class = YLeaf(YType.uint32, "tunnel-class")

                                        self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                        self.tunnel_weight = YLeaf(YType.uint32, "tunnel-weight")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_interface",
                                                        "backup_ipv4_next_hop",
                                                        "backup_local_label",
                                                        "data_out_parent_interface",
                                                        "ipv4_next_hop",
                                                        "merge_point_label",
                                                        "out_interface",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_class",
                                                        "tunnel_interface",
                                                        "tunnel_weight") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_interface.is_set or
                                            self.backup_ipv4_next_hop.is_set or
                                            self.backup_local_label.is_set or
                                            self.data_out_parent_interface.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.merge_point_label.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_class.is_set or
                                            self.tunnel_interface.is_set or
                                            self.tunnel_weight.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_interface.yfilter != YFilter.not_set or
                                            self.backup_ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.backup_local_label.yfilter != YFilter.not_set or
                                            self.data_out_parent_interface.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.merge_point_label.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_class.yfilter != YFilter.not_set or
                                            self.tunnel_interface.yfilter != YFilter.not_set or
                                            self.tunnel_weight.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tev4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_interface.is_set or self.backup_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_interface.get_name_leafdata())
                                        if (self.backup_ipv4_next_hop.is_set or self.backup_ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_ipv4_next_hop.get_name_leafdata())
                                        if (self.backup_local_label.is_set or self.backup_local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_local_label.get_name_leafdata())
                                        if (self.data_out_parent_interface.is_set or self.data_out_parent_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.data_out_parent_interface.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.merge_point_label.is_set or self.merge_point_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.merge_point_label.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_class.is_set or self.tunnel_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_class.get_name_leafdata())
                                        if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_interface.get_name_leafdata())
                                        if (self.tunnel_weight.is_set or self.tunnel_weight.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_weight.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-interface" or name == "backup-ipv4-next-hop" or name == "backup-local-label" or name == "data-out-parent-interface" or name == "ipv4-next-hop" or name == "merge-point-label" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-class" or name == "tunnel-interface" or name == "tunnel-weight"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-interface"):
                                            self.backup_interface = value
                                            self.backup_interface.value_namespace = name_space
                                            self.backup_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-ipv4-next-hop"):
                                            self.backup_ipv4_next_hop = value
                                            self.backup_ipv4_next_hop.value_namespace = name_space
                                            self.backup_ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-local-label"):
                                            self.backup_local_label = value
                                            self.backup_local_label.value_namespace = name_space
                                            self.backup_local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "data-out-parent-interface"):
                                            self.data_out_parent_interface = value
                                            self.data_out_parent_interface.value_namespace = name_space
                                            self.data_out_parent_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "merge-point-label"):
                                            self.merge_point_label = value
                                            self.merge_point_label.value_namespace = name_space
                                            self.merge_point_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-class"):
                                            self.tunnel_class = value
                                            self.tunnel_class.value_namespace = name_space
                                            self.tunnel_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-interface"):
                                            self.tunnel_interface = value
                                            self.tunnel_interface.value_namespace = name_space
                                            self.tunnel_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-weight"):
                                            self.tunnel_weight = value
                                            self.tunnel_weight.value_namespace = name_space
                                            self.tunnel_weight.value_namespace_prefix = name_space_prefix


                                class PseudowireData(Entity):
                                    """
                                    pseudowire data
                                    
                                    .. attribute:: bridge_id
                                    
                                    	Bridge ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: cross_connect_id
                                    
                                    	Cross\-connect ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: pseuodo_wire_connect_id
                                    
                                    	PseudoWire Cross\-connect ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: split_horizon_id
                                    
                                    	Split horizon group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireData, self).__init__()

                                        self.yang_name = "pseudowire-data"
                                        self.yang_parent_name = "moi"

                                        self.bridge_id = YLeaf(YType.uint32, "bridge-id")

                                        self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.pseuodo_wire_connect_id = YLeaf(YType.uint32, "pseuodo-wire-connect-id")

                                        self.split_horizon_id = YLeaf(YType.uint32, "split-horizon-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bridge_id",
                                                        "cross_connect_id",
                                                        "ipv4_next_hop",
                                                        "out_interface",
                                                        "out_label",
                                                        "path_flags_decode",
                                                        "pseuodo_wire_connect_id",
                                                        "split_horizon_id",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.bridge_id.is_set or
                                            self.cross_connect_id.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.path_flags_decode.is_set or
                                            self.pseuodo_wire_connect_id.is_set or
                                            self.split_horizon_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bridge_id.yfilter != YFilter.not_set or
                                            self.cross_connect_id.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.pseuodo_wire_connect_id.yfilter != YFilter.not_set or
                                            self.split_horizon_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bridge_id.is_set or self.bridge_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bridge_id.get_name_leafdata())
                                        if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.pseuodo_wire_connect_id.is_set or self.pseuodo_wire_connect_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pseuodo_wire_connect_id.get_name_leafdata())
                                        if (self.split_horizon_id.is_set or self.split_horizon_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.split_horizon_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bridge-id" or name == "cross-connect-id" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pseuodo-wire-connect-id" or name == "split-horizon-id" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bridge-id"):
                                            self.bridge_id = value
                                            self.bridge_id.value_namespace = name_space
                                            self.bridge_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cross-connect-id"):
                                            self.cross_connect_id = value
                                            self.cross_connect_id.value_namespace = name_space
                                            self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pseuodo-wire-connect-id"):
                                            self.pseuodo_wire_connect_id = value
                                            self.pseuodo_wire_connect_id.value_namespace = name_space
                                            self.pseuodo_wire_connect_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "split-horizon-id"):
                                            self.split_horizon_id = value
                                            self.split_horizon_id.value_namespace = name_space
                                            self.split_horizon_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class IpSubData(Entity):
                                    """
                                    ip sub data
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	VRF table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.IpSubData, self).__init__()

                                        self.yang_name = "ip-sub-data"
                                        self.yang_parent_name = "moi"

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("out_interface",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.out_interface.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ip-sub-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "out-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class PseudowireHeadEndData(Entity):
                                    """
                                    pseudowire head end data
                                    
                                    .. attribute:: control_word
                                    
                                    	Is control word present
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: imposition
                                    
                                    	Is PWHE IMposition
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: pw_list_id
                                    
                                    	Pseudo\-wire List Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: pwhe_interface
                                    
                                    	Pseudo\-wire Head\-end interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: vctype
                                    
                                    	Virtual Circuit Type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__init__()

                                        self.yang_name = "pseudowire-head-end-data"
                                        self.yang_parent_name = "moi"

                                        self.control_word = YLeaf(YType.int32, "control-word")

                                        self.imposition = YLeaf(YType.int32, "imposition")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.pw_list_id = YLeaf(YType.uint16, "pw-list-id")

                                        self.pwhe_interface = YLeaf(YType.str, "pwhe-interface")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.vctype = YLeaf(YType.uint8, "vctype")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("control_word",
                                                        "imposition",
                                                        "ipv4_next_hop",
                                                        "out_interface",
                                                        "out_label",
                                                        "path_flags_decode",
                                                        "pw_list_id",
                                                        "pwhe_interface",
                                                        "table_id",
                                                        "table_name",
                                                        "vctype") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.control_word.is_set or
                                            self.imposition.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.path_flags_decode.is_set or
                                            self.pw_list_id.is_set or
                                            self.pwhe_interface.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.vctype.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.control_word.yfilter != YFilter.not_set or
                                            self.imposition.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.pw_list_id.yfilter != YFilter.not_set or
                                            self.pwhe_interface.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.vctype.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-head-end-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.control_word.is_set or self.control_word.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.control_word.get_name_leafdata())
                                        if (self.imposition.is_set or self.imposition.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.imposition.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.pw_list_id.is_set or self.pw_list_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pw_list_id.get_name_leafdata())
                                        if (self.pwhe_interface.is_set or self.pwhe_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pwhe_interface.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.vctype.is_set or self.vctype.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vctype.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "control-word" or name == "imposition" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pw-list-id" or name == "pwhe-interface" or name == "table-id" or name == "table-name" or name == "vctype"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "control-word"):
                                            self.control_word = value
                                            self.control_word.value_namespace = name_space
                                            self.control_word.value_namespace_prefix = name_space_prefix
                                        if(value_path == "imposition"):
                                            self.imposition = value
                                            self.imposition.value_namespace = name_space
                                            self.imposition.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pw-list-id"):
                                            self.pw_list_id = value
                                            self.pw_list_id.value_namespace = name_space
                                            self.pw_list_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pwhe-interface"):
                                            self.pwhe_interface = value
                                            self.pwhe_interface.value_namespace = name_space
                                            self.pwhe_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vctype"):
                                            self.vctype = value
                                            self.vctype.value_namespace = name_space
                                            self.vctype.value_namespace_prefix = name_space_prefix


                                class PwListData(Entity):
                                    """
                                    pw list data
                                    
                                    .. attribute:: l2_interface
                                    
                                    	Pseudo\-wire Layer 2 interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: l3_interface
                                    
                                    	Pseudo\-wire Layer 3 interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PwListData, self).__init__()

                                        self.yang_name = "pw-list-data"
                                        self.yang_parent_name = "moi"

                                        self.l2_interface = YLeaf(YType.str, "l2-interface")

                                        self.l3_interface = YLeaf(YType.str, "l3-interface")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("l2_interface",
                                                        "l3_interface",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.l2_interface.is_set or
                                            self.l3_interface.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.l2_interface.yfilter != YFilter.not_set or
                                            self.l3_interface.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pw-list-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.l2_interface.is_set or self.l2_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.l2_interface.get_name_leafdata())
                                        if (self.l3_interface.is_set or self.l3_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.l3_interface.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "l2-interface" or name == "l3-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "l2-interface"):
                                            self.l2_interface = value
                                            self.l2_interface.value_namespace = name_space
                                            self.l2_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "l3-interface"):
                                            self.l3_interface = value
                                            self.l3_interface.value_namespace = name_space
                                            self.l3_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class Stackv4Data(Entity):
                                    """
                                    stackv4 data
                                    
                                    .. attribute:: inner_stack
                                    
                                    	Inner stack
                                    	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Nexthop
                                    	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.Nexthop>`
                                    
                                    .. attribute:: owner_application_type
                                    
                                    	Owner application type
                                    	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data, self).__init__()

                                        self.yang_name = "stackv4-data"
                                        self.yang_parent_name = "moi"

                                        self.owner_application_type = YLeaf(YType.enumeration, "owner-application-type")

                                        self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                        self.inner_stack.parent = self
                                        self._children_name_map["inner_stack"] = "inner-stack"
                                        self._children_yang_names.add("inner-stack")

                                        self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                        self.nexthop.parent = self
                                        self._children_name_map["nexthop"] = "nexthop"
                                        self._children_yang_names.add("nexthop")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("owner_application_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)


                                    class Nexthop(Entity):
                                        """
                                        Nexthop
                                        
                                        .. attribute:: backup_path_id
                                        
                                        	Routing path backup id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4_next_hop
                                        
                                        	IPv4 nexthop
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: load_metric
                                        
                                        	Routing path's load metric
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: local_label
                                        
                                        	TE backup path local label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: next_hop_id
                                        
                                        	Next hop ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_interface
                                        
                                        	Outgoing Interface
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: out_interface_parent
                                        
                                        	Outgoing Interface's parent
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: out_label
                                        
                                        	Outgoing Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_label_name
                                        
                                        	Outgoing label name
                                        	**type**\:  str
                                        
                                        .. attribute:: path_flags_decode
                                        
                                        	Path flag decoded string
                                        	**type**\:  str
                                        
                                        .. attribute:: path_id
                                        
                                        	Routing path id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: table_id
                                        
                                        	Table ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: table_name
                                        
                                        	VRF table name
                                        	**type**\:  str
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__init__()

                                            self.yang_name = "nexthop"
                                            self.yang_parent_name = "stackv4-data"

                                            self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                            self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                            self.load_metric = YLeaf(YType.uint32, "load-metric")

                                            self.local_label = YLeaf(YType.uint32, "local-label")

                                            self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                            self.out_interface = YLeaf(YType.str, "out-interface")

                                            self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                            self.out_label = YLeaf(YType.uint32, "out-label")

                                            self.out_label_name = YLeaf(YType.str, "out-label-name")

                                            self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                            self.path_id = YLeaf(YType.uint8, "path-id")

                                            self.table_id = YLeaf(YType.uint32, "table-id")

                                            self.table_name = YLeaf(YType.str, "table-name")

                                            self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("backup_path_id",
                                                            "ipv4_next_hop",
                                                            "load_metric",
                                                            "local_label",
                                                            "next_hop_id",
                                                            "out_interface",
                                                            "out_interface_parent",
                                                            "out_label",
                                                            "out_label_name",
                                                            "path_flags_decode",
                                                            "path_id",
                                                            "table_id",
                                                            "table_name",
                                                            "tunnel_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.backup_path_id.is_set or
                                                self.ipv4_next_hop.is_set or
                                                self.load_metric.is_set or
                                                self.local_label.is_set or
                                                self.next_hop_id.is_set or
                                                self.out_interface.is_set or
                                                self.out_interface_parent.is_set or
                                                self.out_label.is_set or
                                                self.out_label_name.is_set or
                                                self.path_flags_decode.is_set or
                                                self.path_id.is_set or
                                                self.table_id.is_set or
                                                self.table_name.is_set or
                                                self.tunnel_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.backup_path_id.yfilter != YFilter.not_set or
                                                self.ipv4_next_hop.yfilter != YFilter.not_set or
                                                self.load_metric.yfilter != YFilter.not_set or
                                                self.local_label.yfilter != YFilter.not_set or
                                                self.next_hop_id.yfilter != YFilter.not_set or
                                                self.out_interface.yfilter != YFilter.not_set or
                                                self.out_interface_parent.yfilter != YFilter.not_set or
                                                self.out_label.yfilter != YFilter.not_set or
                                                self.out_label_name.yfilter != YFilter.not_set or
                                                self.path_flags_decode.yfilter != YFilter.not_set or
                                                self.path_id.yfilter != YFilter.not_set or
                                                self.table_id.yfilter != YFilter.not_set or
                                                self.table_name.yfilter != YFilter.not_set or
                                                self.tunnel_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nexthop" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                            if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                            if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_metric.get_name_leafdata())
                                            if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_label.get_name_leafdata())
                                            if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                            if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_interface.get_name_leafdata())
                                            if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label.get_name_leafdata())
                                            if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                            if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                            if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_id.get_name_leafdata())
                                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_id.get_name_leafdata())
                                            if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_name.get_name_leafdata())
                                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "backup-path-id"):
                                                self.backup_path_id = value
                                                self.backup_path_id.value_namespace = name_space
                                                self.backup_path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4-next-hop"):
                                                self.ipv4_next_hop = value
                                                self.ipv4_next_hop.value_namespace = name_space
                                                self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-metric"):
                                                self.load_metric = value
                                                self.load_metric.value_namespace = name_space
                                                self.load_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-label"):
                                                self.local_label = value
                                                self.local_label.value_namespace = name_space
                                                self.local_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hop-id"):
                                                self.next_hop_id = value
                                                self.next_hop_id.value_namespace = name_space
                                                self.next_hop_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-interface"):
                                                self.out_interface = value
                                                self.out_interface.value_namespace = name_space
                                                self.out_interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-interface-parent"):
                                                self.out_interface_parent = value
                                                self.out_interface_parent.value_namespace = name_space
                                                self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label"):
                                                self.out_label = value
                                                self.out_label.value_namespace = name_space
                                                self.out_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label-name"):
                                                self.out_label_name = value
                                                self.out_label_name.value_namespace = name_space
                                                self.out_label_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-flags-decode"):
                                                self.path_flags_decode = value
                                                self.path_flags_decode.value_namespace = name_space
                                                self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-id"):
                                                self.path_id = value
                                                self.path_id.value_namespace = name_space
                                                self.path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-id"):
                                                self.table_id = value
                                                self.table_id.value_namespace = name_space
                                                self.table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-name"):
                                                self.table_name = value
                                                self.table_name.value_namespace = name_space
                                                self.table_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tunnel-id"):
                                                self.tunnel_id = value
                                                self.tunnel_id.value_namespace = name_space
                                                self.tunnel_id.value_namespace_prefix = name_space_prefix


                                    class InnerStack(Entity):
                                        """
                                        Inner stack
                                        
                                        .. attribute:: label
                                        
                                        	Info related to outgoing labels
                                        	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label>`
                                        
                                        .. attribute:: nexthop
                                        
                                        	Remote nexthop addresses
                                        	**type**\:  list of str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: num_lbls
                                        
                                        	Depth of inner label stack
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: num_nexthops
                                        
                                        	Number of remote nexthop addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__init__()

                                            self.yang_name = "inner-stack"
                                            self.yang_parent_name = "stackv4-data"

                                            self.nexthop = YLeafList(YType.str, "nexthop")

                                            self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                            self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                            self.label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("nexthop",
                                                            "num_lbls",
                                                            "num_nexthops") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)


                                        class Label(Entity):
                                            """
                                            Info related to outgoing labels
                                            
                                            .. attribute:: outgoing_label
                                            
                                            	Remote Label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: outgoing_label_str
                                            
                                            	Remote Label string
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-lsd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__init__()

                                                self.yang_name = "label"
                                                self.yang_parent_name = "inner-stack"

                                                self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                                self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("outgoing_label",
                                                                "outgoing_label_str") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.outgoing_label.is_set or
                                                    self.outgoing_label_str.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.outgoing_label.yfilter != YFilter.not_set or
                                                    self.outgoing_label_str.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                                if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "outgoing-label"):
                                                    self.outgoing_label = value
                                                    self.outgoing_label.value_namespace = name_space
                                                    self.outgoing_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "outgoing-label-str"):
                                                    self.outgoing_label_str = value
                                                    self.outgoing_label_str.value_namespace = name_space
                                                    self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.label:
                                                if (c.has_data()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            return (
                                                self.num_lbls.is_set or
                                                self.num_nexthops.is_set)

                                        def has_operation(self):
                                            for c in self.label:
                                                if (c.has_operation()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.nexthop.yfilter != YFilter.not_set or
                                                self.num_lbls.yfilter != YFilter.not_set or
                                                self.num_nexthops.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "inner-stack" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                            if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                            leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "label"):
                                                for c in self.label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "nexthop"):
                                                self.nexthop.append(value)
                                            if(value_path == "num-lbls"):
                                                self.num_lbls = value
                                                self.num_lbls.value_namespace = name_space
                                                self.num_lbls.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-nexthops"):
                                                self.num_nexthops = value
                                                self.num_nexthops.value_namespace = name_space
                                                self.num_nexthops.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.owner_application_type.is_set or
                                            (self.inner_stack is not None and self.inner_stack.has_data()) or
                                            (self.nexthop is not None and self.nexthop.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.owner_application_type.yfilter != YFilter.not_set or
                                            (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                            (self.nexthop is not None and self.nexthop.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stackv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.owner_application_type.is_set or self.owner_application_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.owner_application_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "inner-stack"):
                                            if (self.inner_stack is None):
                                                self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                                self.inner_stack.parent = self
                                                self._children_name_map["inner_stack"] = "inner-stack"
                                            return self.inner_stack

                                        if (child_yang_name == "nexthop"):
                                            if (self.nexthop is None):
                                                self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                                self.nexthop.parent = self
                                                self._children_name_map["nexthop"] = "nexthop"
                                            return self.nexthop

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "inner-stack" or name == "nexthop" or name == "owner-application-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "owner-application-type"):
                                            self.owner_application_type = value
                                            self.owner_application_type.value_namespace = name_space
                                            self.owner_application_type.value_namespace_prefix = name_space_prefix


                                class Stackv6Data(Entity):
                                    """
                                    stackv6 data
                                    
                                    .. attribute:: inner_stack
                                    
                                    	Inner stack
                                    	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Nexthop
                                    	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.Nexthop>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data, self).__init__()

                                        self.yang_name = "stackv6-data"
                                        self.yang_parent_name = "moi"

                                        self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                        self.inner_stack.parent = self
                                        self._children_name_map["inner_stack"] = "inner-stack"
                                        self._children_yang_names.add("inner-stack")

                                        self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                        self.nexthop.parent = self
                                        self._children_name_map["nexthop"] = "nexthop"
                                        self._children_yang_names.add("nexthop")


                                    class Nexthop(Entity):
                                        """
                                        Nexthop
                                        
                                        .. attribute:: backup_path_id
                                        
                                        	Routing path backup id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv6_next_hop
                                        
                                        	IPv6 nexthop
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: next_hop_id
                                        
                                        	Next hop ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_interface
                                        
                                        	Outgoing interface
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: out_label
                                        
                                        	Outgoing label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_label_name
                                        
                                        	Outgoing label name
                                        	**type**\:  str
                                        
                                        .. attribute:: path_flags_decode
                                        
                                        	Path flag decoded string
                                        	**type**\:  str
                                        
                                        .. attribute:: path_id
                                        
                                        	Routing path id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: table_id
                                        
                                        	Table ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: table_name
                                        
                                        	VRF table name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__init__()

                                            self.yang_name = "nexthop"
                                            self.yang_parent_name = "stackv6-data"

                                            self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                            self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                            self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                            self.out_interface = YLeaf(YType.str, "out-interface")

                                            self.out_label = YLeaf(YType.uint32, "out-label")

                                            self.out_label_name = YLeaf(YType.str, "out-label-name")

                                            self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                            self.path_id = YLeaf(YType.uint8, "path-id")

                                            self.table_id = YLeaf(YType.uint32, "table-id")

                                            self.table_name = YLeaf(YType.str, "table-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("backup_path_id",
                                                            "ipv6_next_hop",
                                                            "next_hop_id",
                                                            "out_interface",
                                                            "out_label",
                                                            "out_label_name",
                                                            "path_flags_decode",
                                                            "path_id",
                                                            "table_id",
                                                            "table_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.backup_path_id.is_set or
                                                self.ipv6_next_hop.is_set or
                                                self.next_hop_id.is_set or
                                                self.out_interface.is_set or
                                                self.out_label.is_set or
                                                self.out_label_name.is_set or
                                                self.path_flags_decode.is_set or
                                                self.path_id.is_set or
                                                self.table_id.is_set or
                                                self.table_name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.backup_path_id.yfilter != YFilter.not_set or
                                                self.ipv6_next_hop.yfilter != YFilter.not_set or
                                                self.next_hop_id.yfilter != YFilter.not_set or
                                                self.out_interface.yfilter != YFilter.not_set or
                                                self.out_label.yfilter != YFilter.not_set or
                                                self.out_label_name.yfilter != YFilter.not_set or
                                                self.path_flags_decode.yfilter != YFilter.not_set or
                                                self.path_id.yfilter != YFilter.not_set or
                                                self.table_id.yfilter != YFilter.not_set or
                                                self.table_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nexthop" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                            if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                            if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                            if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_interface.get_name_leafdata())
                                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label.get_name_leafdata())
                                            if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                            if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                            if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_id.get_name_leafdata())
                                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_id.get_name_leafdata())
                                            if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "backup-path-id"):
                                                self.backup_path_id = value
                                                self.backup_path_id.value_namespace = name_space
                                                self.backup_path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6-next-hop"):
                                                self.ipv6_next_hop = value
                                                self.ipv6_next_hop.value_namespace = name_space
                                                self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hop-id"):
                                                self.next_hop_id = value
                                                self.next_hop_id.value_namespace = name_space
                                                self.next_hop_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-interface"):
                                                self.out_interface = value
                                                self.out_interface.value_namespace = name_space
                                                self.out_interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label"):
                                                self.out_label = value
                                                self.out_label.value_namespace = name_space
                                                self.out_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label-name"):
                                                self.out_label_name = value
                                                self.out_label_name.value_namespace = name_space
                                                self.out_label_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-flags-decode"):
                                                self.path_flags_decode = value
                                                self.path_flags_decode.value_namespace = name_space
                                                self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-id"):
                                                self.path_id = value
                                                self.path_id.value_namespace = name_space
                                                self.path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-id"):
                                                self.table_id = value
                                                self.table_id.value_namespace = name_space
                                                self.table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-name"):
                                                self.table_name = value
                                                self.table_name.value_namespace = name_space
                                                self.table_name.value_namespace_prefix = name_space_prefix


                                    class InnerStack(Entity):
                                        """
                                        Inner stack
                                        
                                        .. attribute:: label
                                        
                                        	Info related to outgoing labels
                                        	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label>`
                                        
                                        .. attribute:: nexthop
                                        
                                        	Remote nexthop addresses
                                        	**type**\:  list of str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: num_lbls
                                        
                                        	Depth of inner label stack
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: num_nexthops
                                        
                                        	Number of remote nexthop addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__init__()

                                            self.yang_name = "inner-stack"
                                            self.yang_parent_name = "stackv6-data"

                                            self.nexthop = YLeafList(YType.str, "nexthop")

                                            self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                            self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                            self.label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("nexthop",
                                                            "num_lbls",
                                                            "num_nexthops") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)


                                        class Label(Entity):
                                            """
                                            Info related to outgoing labels
                                            
                                            .. attribute:: outgoing_label
                                            
                                            	Remote Label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: outgoing_label_str
                                            
                                            	Remote Label string
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-lsd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__init__()

                                                self.yang_name = "label"
                                                self.yang_parent_name = "inner-stack"

                                                self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                                self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("outgoing_label",
                                                                "outgoing_label_str") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.outgoing_label.is_set or
                                                    self.outgoing_label_str.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.outgoing_label.yfilter != YFilter.not_set or
                                                    self.outgoing_label_str.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                                if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "outgoing-label"):
                                                    self.outgoing_label = value
                                                    self.outgoing_label.value_namespace = name_space
                                                    self.outgoing_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "outgoing-label-str"):
                                                    self.outgoing_label_str = value
                                                    self.outgoing_label_str.value_namespace = name_space
                                                    self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.label:
                                                if (c.has_data()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            return (
                                                self.num_lbls.is_set or
                                                self.num_nexthops.is_set)

                                        def has_operation(self):
                                            for c in self.label:
                                                if (c.has_operation()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.nexthop.yfilter != YFilter.not_set or
                                                self.num_lbls.yfilter != YFilter.not_set or
                                                self.num_nexthops.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "inner-stack" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                            if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                            leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "label"):
                                                for c in self.label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "nexthop"):
                                                self.nexthop.append(value)
                                            if(value_path == "num-lbls"):
                                                self.num_lbls = value
                                                self.num_lbls.value_namespace = name_space
                                                self.num_lbls.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-nexthops"):
                                                self.num_nexthops = value
                                                self.num_nexthops.value_namespace = name_space
                                                self.num_nexthops.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.inner_stack is not None and self.inner_stack.has_data()) or
                                            (self.nexthop is not None and self.nexthop.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                            (self.nexthop is not None and self.nexthop.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stackv6-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "inner-stack"):
                                            if (self.inner_stack is None):
                                                self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                                self.inner_stack.parent = self
                                                self._children_name_map["inner_stack"] = "inner-stack"
                                            return self.inner_stack

                                        if (child_yang_name == "nexthop"):
                                            if (self.nexthop is None):
                                                self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                                self.nexthop.parent = self
                                                self._children_name_map["nexthop"] = "nexthop"
                                            return self.nexthop

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "inner-stack" or name == "nexthop"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class TeHeadData(Entity):
                                    """
                                    te head data
                                    
                                    .. attribute:: flags_decode
                                    
                                    	Flags decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_fwd_class
                                    
                                    	Tunnel forwarding class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_load_metric
                                    
                                    	Tunnel Load metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_local_label
                                    
                                    	Tunnel local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_local_label_str
                                    
                                    	Tunnel local label stringified
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.TeHeadData, self).__init__()

                                        self.yang_name = "te-head-data"
                                        self.yang_parent_name = "moi"

                                        self.flags_decode = YLeaf(YType.str, "flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_fwd_class = YLeaf(YType.uint8, "tunnel-fwd-class")

                                        self.tunnel_load_metric = YLeaf(YType.uint32, "tunnel-load-metric")

                                        self.tunnel_local_label = YLeaf(YType.uint32, "tunnel-local-label")

                                        self.tunnel_local_label_str = YLeaf(YType.str, "tunnel-local-label-str")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("flags_decode",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_fwd_class",
                                                        "tunnel_load_metric",
                                                        "tunnel_local_label",
                                                        "tunnel_local_label_str") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_fwd_class.is_set or
                                            self.tunnel_load_metric.is_set or
                                            self.tunnel_local_label.is_set or
                                            self.tunnel_local_label_str.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_fwd_class.yfilter != YFilter.not_set or
                                            self.tunnel_load_metric.yfilter != YFilter.not_set or
                                            self.tunnel_local_label.yfilter != YFilter.not_set or
                                            self.tunnel_local_label_str.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "te-head-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.flags_decode.is_set or self.flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_fwd_class.is_set or self.tunnel_fwd_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_fwd_class.get_name_leafdata())
                                        if (self.tunnel_load_metric.is_set or self.tunnel_load_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_load_metric.get_name_leafdata())
                                        if (self.tunnel_local_label.is_set or self.tunnel_local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_local_label.get_name_leafdata())
                                        if (self.tunnel_local_label_str.is_set or self.tunnel_local_label_str.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_local_label_str.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-fwd-class" or name == "tunnel-load-metric" or name == "tunnel-local-label" or name == "tunnel-local-label-str"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "flags-decode"):
                                            self.flags_decode = value
                                            self.flags_decode.value_namespace = name_space
                                            self.flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-fwd-class"):
                                            self.tunnel_fwd_class = value
                                            self.tunnel_fwd_class.value_namespace = name_space
                                            self.tunnel_fwd_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-load-metric"):
                                            self.tunnel_load_metric = value
                                            self.tunnel_load_metric.value_namespace = name_space
                                            self.tunnel_load_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-local-label"):
                                            self.tunnel_local_label = value
                                            self.tunnel_local_label.value_namespace = name_space
                                            self.tunnel_local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-local-label-str"):
                                            self.tunnel_local_label_str = value
                                            self.tunnel_local_label_str.value_namespace = name_space
                                            self.tunnel_local_label_str.value_namespace_prefix = name_space_prefix


                                class DmtcData(Entity):
                                    """
                                    dmtc data
                                    
                                    .. attribute:: dmtc_ext_ifh
                                    
                                    	DMTC External Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.DmtcData, self).__init__()

                                        self.yang_name = "dmtc-data"
                                        self.yang_parent_name = "moi"

                                        self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.dmtc_ext_ifh.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "dmtc-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dmtc-ext-ifh"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "dmtc-ext-ifh"):
                                            self.dmtc_ext_ifh = value
                                            self.dmtc_ext_ifh.value_namespace = name_space
                                            self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.moi_type.is_set or
                                        (self.dmtc_data is not None and self.dmtc_data.has_data()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                        (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_data()) or
                                        (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_data()) or
                                        (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_data()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                        (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                        (self.stackv4_data is not None and self.stackv4_data.has_data()) or
                                        (self.stackv6_data is not None and self.stackv6_data.has_data()) or
                                        (self.te_head_data is not None and self.te_head_data.has_data()) or
                                        (self.tev4_data is not None and self.tev4_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.moi_type.yfilter != YFilter.not_set or
                                        (self.dmtc_data is not None and self.dmtc_data.has_operation()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                        (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_operation()) or
                                        (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_operation()) or
                                        (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_operation()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                        (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                        (self.stackv4_data is not None and self.stackv4_data.has_operation()) or
                                        (self.stackv6_data is not None and self.stackv6_data.has_operation()) or
                                        (self.te_head_data is not None and self.te_head_data.has_operation()) or
                                        (self.tev4_data is not None and self.tev4_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "moi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.moi_type.is_set or self.moi_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.moi_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "dmtc-data"):
                                        if (self.dmtc_data is None):
                                            self.dmtc_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.DmtcData()
                                            self.dmtc_data.parent = self
                                            self._children_name_map["dmtc_data"] = "dmtc-data"
                                        return self.dmtc_data

                                    if (child_yang_name == "ip-sub-data"):
                                        if (self.ip_sub_data is None):
                                            self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.IpSubData()
                                            self.ip_sub_data.parent = self
                                            self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                        return self.ip_sub_data

                                    if (child_yang_name == "ipv4-data"):
                                        if (self.ipv4_data is None):
                                            self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv4Data()
                                            self.ipv4_data.parent = self
                                            self._children_name_map["ipv4_data"] = "ipv4-data"
                                        return self.ipv4_data

                                    if (child_yang_name == "ipv6-data"):
                                        if (self.ipv6_data is None):
                                            self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv6Data()
                                            self.ipv6_data.parent = self
                                            self._children_name_map["ipv6_data"] = "ipv6-data"
                                        return self.ipv6_data

                                    if (child_yang_name == "pop-and-lookup-ipv4"):
                                        if (self.pop_and_lookup_ipv4 is None):
                                            self.pop_and_lookup_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                            self.pop_and_lookup_ipv4.parent = self
                                            self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                        return self.pop_and_lookup_ipv4

                                    if (child_yang_name == "pop-and-lookup-ipv6"):
                                        if (self.pop_and_lookup_ipv6 is None):
                                            self.pop_and_lookup_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                            self.pop_and_lookup_ipv6.parent = self
                                            self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                        return self.pop_and_lookup_ipv6

                                    if (child_yang_name == "pop-and-lookup-tp"):
                                        if (self.pop_and_lookup_tp is None):
                                            self.pop_and_lookup_tp = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupTp()
                                            self.pop_and_lookup_tp.parent = self
                                            self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                        return self.pop_and_lookup_tp

                                    if (child_yang_name == "pseudowire-data"):
                                        if (self.pseudowire_data is None):
                                            self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireData()
                                            self.pseudowire_data.parent = self
                                            self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                        return self.pseudowire_data

                                    if (child_yang_name == "pseudowire-head-end-data"):
                                        if (self.pseudowire_head_end_data is None):
                                            self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                            self.pseudowire_head_end_data.parent = self
                                            self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                        return self.pseudowire_head_end_data

                                    if (child_yang_name == "pw-list-data"):
                                        if (self.pw_list_data is None):
                                            self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PwListData()
                                            self.pw_list_data.parent = self
                                            self._children_name_map["pw_list_data"] = "pw-list-data"
                                        return self.pw_list_data

                                    if (child_yang_name == "stackv4-data"):
                                        if (self.stackv4_data is None):
                                            self.stackv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data()
                                            self.stackv4_data.parent = self
                                            self._children_name_map["stackv4_data"] = "stackv4-data"
                                        return self.stackv4_data

                                    if (child_yang_name == "stackv6-data"):
                                        if (self.stackv6_data is None):
                                            self.stackv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data()
                                            self.stackv6_data.parent = self
                                            self._children_name_map["stackv6_data"] = "stackv6-data"
                                        return self.stackv6_data

                                    if (child_yang_name == "te-head-data"):
                                        if (self.te_head_data is None):
                                            self.te_head_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.TeHeadData()
                                            self.te_head_data.parent = self
                                            self._children_name_map["te_head_data"] = "te-head-data"
                                        return self.te_head_data

                                    if (child_yang_name == "tev4-data"):
                                        if (self.tev4_data is None):
                                            self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Tev4Data()
                                            self.tev4_data.parent = self
                                            self._children_name_map["tev4_data"] = "tev4-data"
                                        return self.tev4_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-data" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv6-data" or name == "pop-and-lookup-ipv4" or name == "pop-and-lookup-ipv6" or name == "pop-and-lookup-tp" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "pw-list-data" or name == "stackv4-data" or name == "stackv6-data" or name == "te-head-data" or name == "tev4-data" or name == "moi-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "moi-type"):
                                        self.moi_type = value
                                        self.moi_type.value_namespace = name_space
                                        self.moi_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.moi is not None and self.moi.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.moi is not None and self.moi.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "moi-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "moi"):
                                    if (self.moi is None):
                                        self.moi = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi()
                                        self.moi.parent = self
                                        self._children_name_map["moi"] = "moi"
                                    return self.moi

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "moi"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            for c in self.moi_array:
                                if (c.has_data()):
                                    return True
                            return (self.application_resource is not None and self.application_resource.has_data())

                        def has_operation(self):
                            for c in self.moi_array:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.application_resource is not None and self.application_resource.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "mois" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "application-resource"):
                                if (self.application_resource is None):
                                    self.application_resource = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.ApplicationResource()
                                    self.application_resource.parent = self
                                    self._children_name_map["application_resource"] = "application-resource"
                                return self.application_resource

                            if (child_yang_name == "moi-array"):
                                for c in self.moi_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois.MoiArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.moi_array.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-resource" or name == "moi-array"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        for c in self.associated_fpi:
                            if (c.has_data()):
                                return True
                        for c in self.mois:
                            if (c.has_data()):
                                return True
                        for c in self.v4_rpf:
                            if (c.has_data()):
                                return True
                        for c in self.v6_rpf:
                            if (c.has_data()):
                                return True
                        return (
                            self.pw_list_id.is_set or
                            self.bcdl_priority.is_set or
                            self.lsd_queue.is_set or
                            self.priority_updated.is_set or
                            self.rewrite_version.is_set or
                            self.rw_install_age.is_set or
                            self.rw_install_time.is_set or
                            self.rw_updated.is_set or
                            (self.fpi_key is not None and self.fpi_key.has_data()) or
                            (self.rewrite_id is not None and self.rewrite_id.has_data()))

                    def has_operation(self):
                        for c in self.associated_fpi:
                            if (c.has_operation()):
                                return True
                        for c in self.mois:
                            if (c.has_operation()):
                                return True
                        for c in self.v4_rpf:
                            if (c.has_operation()):
                                return True
                        for c in self.v6_rpf:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.pw_list_id.yfilter != YFilter.not_set or
                            self.bcdl_priority.yfilter != YFilter.not_set or
                            self.lsd_queue.yfilter != YFilter.not_set or
                            self.priority_updated.yfilter != YFilter.not_set or
                            self.rewrite_version.yfilter != YFilter.not_set or
                            self.rw_install_age.yfilter != YFilter.not_set or
                            self.rw_install_time.yfilter != YFilter.not_set or
                            self.rw_updated.yfilter != YFilter.not_set or
                            (self.fpi_key is not None and self.fpi_key.has_operation()) or
                            (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rewrite-pw" + "[pw-list-id='" + self.pw_list_id.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.pw_list_id.is_set or self.pw_list_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pw_list_id.get_name_leafdata())
                        if (self.bcdl_priority.is_set or self.bcdl_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bcdl_priority.get_name_leafdata())
                        if (self.lsd_queue.is_set or self.lsd_queue.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsd_queue.get_name_leafdata())
                        if (self.priority_updated.is_set or self.priority_updated.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.priority_updated.get_name_leafdata())
                        if (self.rewrite_version.is_set or self.rewrite_version.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rewrite_version.get_name_leafdata())
                        if (self.rw_install_age.is_set or self.rw_install_age.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rw_install_age.get_name_leafdata())
                        if (self.rw_install_time.is_set or self.rw_install_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rw_install_time.get_name_leafdata())
                        if (self.rw_updated.is_set or self.rw_updated.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rw_updated.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "associated-fpi"):
                            for c in self.associated_fpi:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.AssociatedFpi()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.associated_fpi.append(c)
                            return c

                        if (child_yang_name == "fpi-key"):
                            if (self.fpi_key is None):
                                self.fpi_key = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.FpiKey()
                                self.fpi_key.parent = self
                                self._children_name_map["fpi_key"] = "fpi-key"
                            return self.fpi_key

                        if (child_yang_name == "mois"):
                            for c in self.mois:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.Mois()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.mois.append(c)
                            return c

                        if (child_yang_name == "rewrite-id"):
                            if (self.rewrite_id is None):
                                self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.RewriteId()
                                self.rewrite_id.parent = self
                                self._children_name_map["rewrite_id"] = "rewrite-id"
                            return self.rewrite_id

                        if (child_yang_name == "v4-rpf"):
                            for c in self.v4_rpf:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.V4Rpf()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.v4_rpf.append(c)
                            return c

                        if (child_yang_name == "v6-rpf"):
                            for c in self.v6_rpf:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw.V6Rpf()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.v6_rpf.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "associated-fpi" or name == "fpi-key" or name == "mois" or name == "rewrite-id" or name == "v4-rpf" or name == "v6-rpf" or name == "pw-list-id" or name == "bcdl-priority" or name == "lsd-queue" or name == "priority-updated" or name == "rewrite-version" or name == "rw-install-age" or name == "rw-install-time" or name == "rw-updated"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "pw-list-id"):
                            self.pw_list_id = value
                            self.pw_list_id.value_namespace = name_space
                            self.pw_list_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "bcdl-priority"):
                            self.bcdl_priority = value
                            self.bcdl_priority.value_namespace = name_space
                            self.bcdl_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsd-queue"):
                            self.lsd_queue = value
                            self.lsd_queue.value_namespace = name_space
                            self.lsd_queue.value_namespace_prefix = name_space_prefix
                        if(value_path == "priority-updated"):
                            self.priority_updated = value
                            self.priority_updated.value_namespace = name_space
                            self.priority_updated.value_namespace_prefix = name_space_prefix
                        if(value_path == "rewrite-version"):
                            self.rewrite_version = value
                            self.rewrite_version.value_namespace = name_space
                            self.rewrite_version.value_namespace_prefix = name_space_prefix
                        if(value_path == "rw-install-age"):
                            self.rw_install_age = value
                            self.rw_install_age.value_namespace = name_space
                            self.rw_install_age.value_namespace_prefix = name_space_prefix
                        if(value_path == "rw-install-time"):
                            self.rw_install_time = value
                            self.rw_install_time.value_namespace = name_space
                            self.rw_install_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "rw-updated"):
                            self.rw_updated = value
                            self.rw_updated.value_namespace = name_space
                            self.rw_updated.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.rewrite_pw:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.rewrite_pw:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "rewrite-pws" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "rewrite-pw"):
                        for c in self.rewrite_pw:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws.RewritePw()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.rewrite_pw.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "rewrite-pw"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class RewriteIpv4S(Entity):
                """
                Table of Rewrites
                
                .. attribute:: rewrite_ipv4
                
                	FPI rewrite for label
                	**type**\: list of    :py:class:`RewriteIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S, self).__init__()

                    self.yang_name = "rewrite-ipv4s"
                    self.yang_parent_name = "rewrite"

                    self.rewrite_ipv4 = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S, self).__setattr__(name, value)


                class RewriteIpv4(Entity):
                    """
                    FPI rewrite for label
                    
                    .. attribute:: associated_fpi
                    
                    	Associated FPI
                    	**type**\: list of    :py:class:`AssociatedFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi>`
                    
                    .. attribute:: bcdl_priority
                    
                    	BCDL Priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: fpi_key
                    
                    	fpi key
                    	**type**\:   :py:class:`FpiKey <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey>`
                    
                    .. attribute:: lsd_queue
                    
                    	LSD queue
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: mois
                    
                    	Mois
                    	**type**\: list of    :py:class:`Mois <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois>`
                    
                    .. attribute:: prefix
                    
                    	IPv4 Prefix
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: prefix_length
                    
                    	Prefix length
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: priority_updated
                    
                    	Is rewrite's BCDL priority updated
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: rewrite_id
                    
                    	Rewrite ID
                    	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId>`
                    
                    .. attribute:: rewrite_version
                    
                    	Rewrite version
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rsi_table_id
                    
                    	RSI table ID
                    	**type**\:  str
                    
                    	**pattern:** [0\-9a\-fA\-F]{1,8}
                    
                    .. attribute:: rsi_table_name
                    
                    	RSI table name
                    	**type**\:  str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    .. attribute:: rw_install_age
                    
                    	Rewrite install age
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rw_install_time
                    
                    	Rewrite install timestamp
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rw_updated
                    
                    	Is rewrite ever updated
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: v4_rpf
                    
                    	IPv4 RPF neighbors
                    	**type**\: list of    :py:class:`V4Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.V4Rpf>`
                    
                    .. attribute:: v6_rpf
                    
                    	IPv6 RPF neighbors
                    	**type**\: list of    :py:class:`V6Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.V6Rpf>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4, self).__init__()

                        self.yang_name = "rewrite-ipv4"
                        self.yang_parent_name = "rewrite-ipv4s"

                        self.bcdl_priority = YLeaf(YType.uint8, "bcdl-priority")

                        self.lsd_queue = YLeaf(YType.uint8, "lsd-queue")

                        self.prefix = YLeaf(YType.str, "prefix")

                        self.prefix_length = YLeaf(YType.int32, "prefix-length")

                        self.priority_updated = YLeaf(YType.int32, "priority-updated")

                        self.rewrite_version = YLeaf(YType.uint64, "rewrite-version")

                        self.rsi_table_id = YLeaf(YType.str, "rsi-table-id")

                        self.rsi_table_name = YLeaf(YType.str, "rsi-table-name")

                        self.rw_install_age = YLeaf(YType.uint64, "rw-install-age")

                        self.rw_install_time = YLeaf(YType.uint64, "rw-install-time")

                        self.rw_updated = YLeaf(YType.int32, "rw-updated")

                        self.fpi_key = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey()
                        self.fpi_key.parent = self
                        self._children_name_map["fpi_key"] = "fpi-key"
                        self._children_yang_names.add("fpi-key")

                        self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId()
                        self.rewrite_id.parent = self
                        self._children_name_map["rewrite_id"] = "rewrite-id"
                        self._children_yang_names.add("rewrite-id")

                        self.associated_fpi = YList(self)
                        self.mois = YList(self)
                        self.v4_rpf = YList(self)
                        self.v6_rpf = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bcdl_priority",
                                        "lsd_queue",
                                        "prefix",
                                        "prefix_length",
                                        "priority_updated",
                                        "rewrite_version",
                                        "rsi_table_id",
                                        "rsi_table_name",
                                        "rw_install_age",
                                        "rw_install_time",
                                        "rw_updated") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4, self).__setattr__(name, value)


                    class FpiKey(Entity):
                        """
                        fpi key
                        
                        .. attribute:: application_owner
                        
                        	Application owner instance
                        	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.ApplicationOwner>`
                        
                        .. attribute:: fpi
                        
                        	FPI
                        	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey, self).__init__()

                            self.yang_name = "fpi-key"
                            self.yang_parent_name = "rewrite-ipv4"

                            self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi()
                            self.fpi.parent = self
                            self._children_name_map["fpi"] = "fpi"
                            self._children_yang_names.add("fpi")

                            self.application_owner = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey, self).__setattr__(name, value)


                        class Fpi(Entity):
                            """
                            FPI
                            
                            .. attribute:: dmtc_ext_intf_data
                            
                            	dmtc ext intf data
                            	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.DmtcExtIntfData>`
                            
                            .. attribute:: fpi_type
                            
                            	FPIType
                            	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                            
                            .. attribute:: ipv4_data
                            
                            	ipv4 data
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv4Data>`
                            
                            .. attribute:: ipv6_data
                            
                            	ipv6 data
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv6Data>`
                            
                            .. attribute:: label_data
                            
                            	label data
                            	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.LabelData>`
                            
                            .. attribute:: pw_list_data
                            
                            	pw list data
                            	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.PwListData>`
                            
                            .. attribute:: te_data
                            
                            	te data
                            	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.TeData>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi, self).__init__()

                                self.yang_name = "fpi"
                                self.yang_parent_name = "fpi-key"

                                self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                                self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.DmtcExtIntfData()
                                self.dmtc_ext_intf_data.parent = self
                                self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                self._children_yang_names.add("dmtc-ext-intf-data")

                                self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.LabelData()
                                self.label_data.parent = self
                                self._children_name_map["label_data"] = "label-data"
                                self._children_yang_names.add("label-data")

                                self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.PwListData()
                                self.pw_list_data.parent = self
                                self._children_name_map["pw_list_data"] = "pw-list-data"
                                self._children_yang_names.add("pw-list-data")

                                self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.TeData()
                                self.te_data.parent = self
                                self._children_name_map["te_data"] = "te-data"
                                self._children_yang_names.add("te-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fpi_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi, self).__setattr__(name, value)


                            class LabelData(Entity):
                                """
                                label data
                                
                                .. attribute:: elc
                                
                                	ELC
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: label
                                
                                	Label value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.LabelData, self).__init__()

                                    self.yang_name = "label-data"
                                    self.yang_parent_name = "fpi"

                                    self.elc = YLeaf(YType.int32, "elc")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("elc",
                                                    "label",
                                                    "security_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.LabelData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.LabelData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.elc.is_set or
                                        self.label.is_set or
                                        self.security_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.elc.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.elc.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "elc" or name == "label" or name == "security-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "elc"):
                                        self.elc = value
                                        self.elc.value_namespace = name_space
                                        self.elc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix


                            class TeData(Entity):
                                """
                                te data
                                
                                .. attribute:: local_label
                                
                                	Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_interface
                                
                                	Tunnel interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.TeData, self).__init__()

                                    self.yang_name = "te-data"
                                    self.yang_parent_name = "fpi"

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("local_label",
                                                    "tunnel_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.TeData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.TeData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.local_label.is_set or
                                        self.tunnel_interface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.tunnel_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "local-label" or name == "tunnel-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface"):
                                        self.tunnel_interface = value
                                        self.tunnel_interface.value_namespace = name_space
                                        self.tunnel_interface.value_namespace_prefix = name_space_prefix


                            class Ipv4Data(Entity):
                                """
                                ipv4 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: sr_local_label
                                
                                	SR related Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "sr_local_label",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.sr_local_label.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.sr_local_label.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sr-local-label"):
                                        self.sr_local_label = value
                                        self.sr_local_label.value_namespace = name_space
                                        self.sr_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                ipv6 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: router_flags
                                
                                	Route flags
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    self.router_flags = YLeaf(YType.uint32, "router-flags")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_len",
                                                    "router_flags",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_len.is_set or
                                        self.router_flags.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set or
                                        self.router_flags.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                    if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_flags.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-flags"):
                                        self.router_flags = value
                                        self.router_flags.value_namespace = name_space
                                        self.router_flags.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class PwListData(Entity):
                                """
                                pw list data
                                
                                .. attribute:: pwhe_list_id
                                
                                	Pseudowire List Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.PwListData, self).__init__()

                                    self.yang_name = "pw-list-data"
                                    self.yang_parent_name = "fpi"

                                    self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("pwhe_list_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.PwListData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.PwListData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.pwhe_list_id.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.pwhe_list_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pw-list-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "pwhe-list-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "pwhe-list-id"):
                                        self.pwhe_list_id = value
                                        self.pwhe_list_id.value_namespace = name_space
                                        self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                            class DmtcExtIntfData(Entity):
                                """
                                dmtc ext intf data
                                
                                .. attribute:: dmtc_ext_ifh
                                
                                	DMTC External Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.DmtcExtIntfData, self).__init__()

                                    self.yang_name = "dmtc-ext-intf-data"
                                    self.yang_parent_name = "fpi"

                                    self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.dmtc_ext_ifh.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "dmtc-ext-intf-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-ext-ifh"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dmtc-ext-ifh"):
                                        self.dmtc_ext_ifh = value
                                        self.dmtc_ext_ifh.value_namespace = name_space
                                        self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fpi_type.is_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.label_data is not None and self.label_data.has_data()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                    (self.te_data is not None and self.te_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fpi_type.yfilter != YFilter.not_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.label_data is not None and self.label_data.has_operation()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                    (self.te_data is not None and self.te_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fpi" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fpi_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "dmtc-ext-intf-data"):
                                    if (self.dmtc_ext_intf_data is None):
                                        self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.DmtcExtIntfData()
                                        self.dmtc_ext_intf_data.parent = self
                                        self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                    return self.dmtc_ext_intf_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "label-data"):
                                    if (self.label_data is None):
                                        self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.LabelData()
                                        self.label_data.parent = self
                                        self._children_name_map["label_data"] = "label-data"
                                    return self.label_data

                                if (child_yang_name == "pw-list-data"):
                                    if (self.pw_list_data is None):
                                        self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.PwListData()
                                        self.pw_list_data.parent = self
                                        self._children_name_map["pw_list_data"] = "pw-list-data"
                                    return self.pw_list_data

                                if (child_yang_name == "te-data"):
                                    if (self.te_data is None):
                                        self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.TeData()
                                        self.te_data.parent = self
                                        self._children_name_map["te_data"] = "te-data"
                                    return self.te_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fpi-type"):
                                    self.fpi_type = value
                                    self.fpi_type.value_namespace = name_space
                                    self.fpi_type.value_namespace_prefix = name_space_prefix


                        class ApplicationOwner(Entity):
                            """
                            Application owner instance
                            
                            .. attribute:: application_instance
                            
                            	Application instance Name
                            	**type**\:  str
                            
                            .. attribute:: application_name
                            
                            	Application name
                            	**type**\:  str
                            
                            .. attribute:: application_role_primary
                            
                            	Primary/Backup role
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: application_type
                            
                            	Application type
                            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                            
                            .. attribute:: resource_state
                            
                            	Application resource state
                            	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.ApplicationOwner, self).__init__()

                                self.yang_name = "application-owner"
                                self.yang_parent_name = "fpi-key"

                                self.application_instance = YLeaf(YType.str, "application-instance")

                                self.application_name = YLeaf(YType.str, "application-name")

                                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                                self.application_type = YLeaf(YType.enumeration, "application-type")

                                self.resource_state = YLeaf(YType.enumeration, "resource-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("application_instance",
                                                "application_name",
                                                "application_role_primary",
                                                "application_type",
                                                "resource_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.ApplicationOwner, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.ApplicationOwner, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.application_instance.is_set or
                                    self.application_name.is_set or
                                    self.application_role_primary.is_set or
                                    self.application_type.is_set or
                                    self.resource_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.application_instance.yfilter != YFilter.not_set or
                                    self.application_name.yfilter != YFilter.not_set or
                                    self.application_role_primary.yfilter != YFilter.not_set or
                                    self.application_type.yfilter != YFilter.not_set or
                                    self.resource_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "application-owner" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_name.get_name_leafdata())
                                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_type.get_name_leafdata())
                                if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resource_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "application-instance"):
                                    self.application_instance = value
                                    self.application_instance.value_namespace = name_space
                                    self.application_instance.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-name"):
                                    self.application_name = value
                                    self.application_name.value_namespace = name_space
                                    self.application_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-role-primary"):
                                    self.application_role_primary = value
                                    self.application_role_primary.value_namespace = name_space
                                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-type"):
                                    self.application_type = value
                                    self.application_type.value_namespace = name_space
                                    self.application_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "resource-state"):
                                    self.resource_state = value
                                    self.resource_state.value_namespace = name_space
                                    self.resource_state.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.application_owner:
                                if (c.has_data()):
                                    return True
                            return (self.fpi is not None and self.fpi.has_data())

                        def has_operation(self):
                            for c in self.application_owner:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.fpi is not None and self.fpi.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fpi-key" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "application-owner"):
                                for c in self.application_owner:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.ApplicationOwner()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.application_owner.append(c)
                                return c

                            if (child_yang_name == "fpi"):
                                if (self.fpi is None):
                                    self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi()
                                    self.fpi.parent = self
                                    self._children_name_map["fpi"] = "fpi"
                                return self.fpi

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-owner" or name == "fpi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class RewriteId(Entity):
                        """
                        Rewrite ID
                        
                        .. attribute:: rewrite_id
                        
                        	Rewrite ID
                        	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId, self).__init__()

                            self.yang_name = "rewrite-id"
                            self.yang_parent_name = "rewrite-ipv4"

                            self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId()
                            self.rewrite_id.parent = self
                            self._children_name_map["rewrite_id"] = "rewrite-id"
                            self._children_yang_names.add("rewrite-id")


                        class RewriteId(Entity):
                            """
                            Rewrite ID
                            
                            .. attribute:: label_context
                            
                            	Label context
                            	**type**\:   :py:class:`LabelContext <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext>`
                            
                            .. attribute:: local_label_rewrite
                            
                            	Local label rewrite information
                            	**type**\:   :py:class:`LocalLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LocalLabelRewrite>`
                            
                            .. attribute:: rewrite_id_type
                            
                            	RewriteIDType
                            	**type**\:   :py:class:`MgmtLsdRwId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdRwId>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId, self).__init__()

                                self.yang_name = "rewrite-id"
                                self.yang_parent_name = "rewrite-id"

                                self.rewrite_id_type = YLeaf(YType.enumeration, "rewrite-id-type")

                                self.label_context = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext()
                                self.label_context.parent = self
                                self._children_name_map["label_context"] = "label-context"
                                self._children_yang_names.add("label-context")

                                self.local_label_rewrite = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LocalLabelRewrite()
                                self.local_label_rewrite.parent = self
                                self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                                self._children_yang_names.add("local-label-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rewrite_id_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId, self).__setattr__(name, value)


                            class LabelContext(Entity):
                                """
                                Label context
                                
                                .. attribute:: cev4l3vpn_data
                                
                                	L3VPN CEv4 label context
                                	**type**\:   :py:class:`Cev4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev4L3VpnData>`
                                
                                .. attribute:: cev6l3vpn_data
                                
                                	L3VPN CEv6 label context
                                	**type**\:   :py:class:`Cev6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev6L3VpnData>`
                                
                                .. attribute:: evpn_data
                                
                                	EVPN context
                                	**type**\:   :py:class:`EvpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.EvpnData>`
                                
                                .. attribute:: generic_routing_encapsulation
                                
                                	Generic routing encapsulation context
                                	**type**\:   :py:class:`GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation>`
                                
                                .. attribute:: ip_sub_data
                                
                                	IP Subscriber context
                                	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.IpSubData>`
                                
                                .. attribute:: ipv4_data
                                
                                	IPv4 label context
                                	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4Data>`
                                
                                .. attribute:: ipv4blb_data
                                
                                	BFD BLB label context
                                	**type**\:   :py:class:`Ipv4BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4BlbData>`
                                
                                .. attribute:: ipv4l3vpn_data
                                
                                	L3VPN IPv4 label context
                                	**type**\:   :py:class:`Ipv4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData>`
                                
                                .. attribute:: ipv6_data
                                
                                	IPv6 label context
                                	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6Data>`
                                
                                .. attribute:: ipv6_generic_routing_encapsulation
                                
                                	Generic routing encapsulation context
                                	**type**\:   :py:class:`Ipv6GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation>`
                                
                                .. attribute:: ipv6blb_data
                                
                                	BFD BLB label context
                                	**type**\:   :py:class:`Ipv6BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6BlbData>`
                                
                                .. attribute:: ipv6l3vpn_data
                                
                                	L3VPN IPv6 label context
                                	**type**\:   :py:class:`Ipv6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData>`
                                
                                .. attribute:: label_block_data
                                
                                	Label block context
                                	**type**\:   :py:class:`LabelBlockData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockData>`
                                
                                .. attribute:: label_block_srgb_data
                                
                                	Label block SRGB context
                                	**type**\:   :py:class:`LabelBlockSrgbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData>`
                                
                                .. attribute:: label_context_type
                                
                                	LabelContextType
                                	**type**\:   :py:class:`MgmtLsdLblCtx <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLblCtx>`
                                
                                .. attribute:: mld_pv4_data
                                
                                	MLDPv4 LSM\-ID context
                                	**type**\:   :py:class:`MldPv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.MldPv4Data>`
                                
                                .. attribute:: next_hop_set_l3vpn
                                
                                	L3VPN NH SET label context
                                	**type**\:   :py:class:`NextHopSetL3Vpn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn>`
                                
                                .. attribute:: pi_mi_pmsi_data
                                
                                	PIM I\-PMSI label conext
                                	**type**\:   :py:class:`PiMiPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMiPmsiData>`
                                
                                .. attribute:: pi_ms_pmsi_data
                                
                                	PIM S\-PMSI label conext
                                	**type**\:   :py:class:`PiMsPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMsPmsiData>`
                                
                                .. attribute:: pseudowire_data
                                
                                	Pseudowire label context
                                	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireData>`
                                
                                .. attribute:: pseudowire_head_end_data
                                
                                	Pseudowire Head\-end label context
                                	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData>`
                                
                                .. attribute:: sr_adj_segment_ipv4
                                
                                	SR Adj Segment ipv4 context
                                	**type**\:   :py:class:`SrAdjSegmentIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4>`
                                
                                .. attribute:: sr_adj_segment_ipv6
                                
                                	SR Adj Segment ipv6 context
                                	**type**\:   :py:class:`SrAdjSegmentIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6>`
                                
                                .. attribute:: sr_prefix_segment
                                
                                	SR Prefix Segment context
                                	**type**\:   :py:class:`SrPrefixSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrPrefixSegment>`
                                
                                .. attribute:: te_binding
                                
                                	MPLS TE tunnel binding context
                                	**type**\:   :py:class:`TeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TeBinding>`
                                
                                .. attribute:: tev4_data
                                
                                	TEv4 label context
                                	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4Data>`
                                
                                .. attribute:: tev4p2mp_data
                                
                                	TEv4 P2MP context
                                	**type**\:   :py:class:`Tev4P2MpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4P2MpData>`
                                
                                .. attribute:: tp_data
                                
                                	TP context
                                	**type**\:   :py:class:`TpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TpData>`
                                
                                .. attribute:: vrf_l3vpn_data
                                
                                	L3VPN VRF label context
                                	**type**\:   :py:class:`VrfL3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.VrfL3VpnData>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext, self).__init__()

                                    self.yang_name = "label-context"
                                    self.yang_parent_name = "rewrite-id"

                                    self.label_context_type = YLeaf(YType.enumeration, "label-context-type")

                                    self.cev4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                    self.cev4l3vpn_data.parent = self
                                    self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                    self._children_yang_names.add("cev4l3vpn-data")

                                    self.cev6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                    self.cev6l3vpn_data.parent = self
                                    self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                    self._children_yang_names.add("cev6l3vpn-data")

                                    self.evpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.EvpnData()
                                    self.evpn_data.parent = self
                                    self._children_name_map["evpn_data"] = "evpn-data"
                                    self._children_yang_names.add("evpn-data")

                                    self.generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                    self.generic_routing_encapsulation.parent = self
                                    self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                    self._children_yang_names.add("generic-routing-encapsulation")

                                    self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.IpSubData()
                                    self.ip_sub_data.parent = self
                                    self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    self._children_yang_names.add("ip-sub-data")

                                    self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                    self._children_yang_names.add("ipv4-data")

                                    self.ipv4blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                    self.ipv4blb_data.parent = self
                                    self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                    self._children_yang_names.add("ipv4blb-data")

                                    self.ipv4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                    self.ipv4l3vpn_data.parent = self
                                    self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                    self._children_yang_names.add("ipv4l3vpn-data")

                                    self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                    self._children_yang_names.add("ipv6-data")

                                    self.ipv6_generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                    self.ipv6_generic_routing_encapsulation.parent = self
                                    self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                    self._children_yang_names.add("ipv6-generic-routing-encapsulation")

                                    self.ipv6blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                    self.ipv6blb_data.parent = self
                                    self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                    self._children_yang_names.add("ipv6blb-data")

                                    self.ipv6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                    self.ipv6l3vpn_data.parent = self
                                    self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                    self._children_yang_names.add("ipv6l3vpn-data")

                                    self.label_block_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                    self.label_block_data.parent = self
                                    self._children_name_map["label_block_data"] = "label-block-data"
                                    self._children_yang_names.add("label-block-data")

                                    self.label_block_srgb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                    self.label_block_srgb_data.parent = self
                                    self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                    self._children_yang_names.add("label-block-srgb-data")

                                    self.mld_pv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                    self.mld_pv4_data.parent = self
                                    self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                    self._children_yang_names.add("mld-pv4-data")

                                    self.next_hop_set_l3vpn = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                    self.next_hop_set_l3vpn.parent = self
                                    self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                    self._children_yang_names.add("next-hop-set-l3vpn")

                                    self.pi_mi_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                    self.pi_mi_pmsi_data.parent = self
                                    self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                    self._children_yang_names.add("pi-mi-pmsi-data")

                                    self.pi_ms_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                    self.pi_ms_pmsi_data.parent = self
                                    self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                    self._children_yang_names.add("pi-ms-pmsi-data")

                                    self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireData()
                                    self.pseudowire_data.parent = self
                                    self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    self._children_yang_names.add("pseudowire-data")

                                    self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                    self.pseudowire_head_end_data.parent = self
                                    self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    self._children_yang_names.add("pseudowire-head-end-data")

                                    self.sr_adj_segment_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                    self.sr_adj_segment_ipv4.parent = self
                                    self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                    self._children_yang_names.add("sr-adj-segment-ipv4")

                                    self.sr_adj_segment_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                    self.sr_adj_segment_ipv6.parent = self
                                    self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                    self._children_yang_names.add("sr-adj-segment-ipv6")

                                    self.sr_prefix_segment = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                    self.sr_prefix_segment.parent = self
                                    self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                    self._children_yang_names.add("sr-prefix-segment")

                                    self.te_binding = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TeBinding()
                                    self.te_binding.parent = self
                                    self._children_name_map["te_binding"] = "te-binding"
                                    self._children_yang_names.add("te-binding")

                                    self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4Data()
                                    self.tev4_data.parent = self
                                    self._children_name_map["tev4_data"] = "tev4-data"
                                    self._children_yang_names.add("tev4-data")

                                    self.tev4p2mp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                    self.tev4p2mp_data.parent = self
                                    self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                    self._children_yang_names.add("tev4p2mp-data")

                                    self.tp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TpData()
                                    self.tp_data.parent = self
                                    self._children_name_map["tp_data"] = "tp-data"
                                    self._children_yang_names.add("tp-data")

                                    self.vrf_l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                    self.vrf_l3vpn_data.parent = self
                                    self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                    self._children_yang_names.add("vrf-l3vpn-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_context_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)


                                class Ipv4Data(Entity):
                                    """
                                    IPv4 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv4 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	IPv4 prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf_name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..33
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__init__()

                                        self.yang_name = "ipv4-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.vrf_name = YLeaf(YType.str, "vrf-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "security_id",
                                                        "table_id",
                                                        "vrf_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set or
                                            self.vrf_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.vrf_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-name"):
                                            self.vrf_name = value
                                            self.vrf_name.value_namespace = name_space
                                            self.vrf_name.value_namespace_prefix = name_space_prefix


                                class Ipv6Data(Entity):
                                    """
                                    IPv6 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf_name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..33
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__init__()

                                        self.yang_name = "ipv6-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.vrf_name = YLeaf(YType.str, "vrf-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "security_id",
                                                        "table_id",
                                                        "vrf_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set or
                                            self.vrf_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.vrf_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-name"):
                                            self.vrf_name = value
                                            self.vrf_name.value_namespace = name_space
                                            self.vrf_name.value_namespace_prefix = name_space_prefix


                                class Tev4Data(Entity):
                                    """
                                    TEv4 label context
                                    
                                    .. attribute:: is_srte
                                    
                                    	Is this an SRTE head tunnel
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_dest
                                    
                                    	Tunnel destination
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_id_extension
                                    
                                    	Extended tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_lsp_id
                                    
                                    	Tunnel LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_source
                                    
                                    	Tunnel source
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4Data, self).__init__()

                                        self.yang_name = "tev4-data"
                                        self.yang_parent_name = "label-context"

                                        self.is_srte = YLeaf(YType.int32, "is-srte")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.tunnel_dest = YLeaf(YType.str, "tunnel-dest")

                                        self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                        self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                        self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                        self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_srte",
                                                        "table_id",
                                                        "tunnel_dest",
                                                        "tunnel_id",
                                                        "tunnel_id_extension",
                                                        "tunnel_lsp_id",
                                                        "tunnel_source") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_srte.is_set or
                                            self.table_id.is_set or
                                            self.tunnel_dest.is_set or
                                            self.tunnel_id.is_set or
                                            self.tunnel_id_extension.is_set or
                                            self.tunnel_lsp_id.is_set or
                                            self.tunnel_source.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_srte.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.tunnel_dest.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set or
                                            self.tunnel_id_extension.yfilter != YFilter.not_set or
                                            self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                            self.tunnel_source.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tev4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_srte.is_set or self.is_srte.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_srte.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.tunnel_dest.is_set or self.tunnel_dest.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_dest.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                        if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                        if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                        if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-srte" or name == "table-id" or name == "tunnel-dest" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-srte"):
                                            self.is_srte = value
                                            self.is_srte.value_namespace = name_space
                                            self.is_srte.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-dest"):
                                            self.tunnel_dest = value
                                            self.tunnel_dest.value_namespace = name_space
                                            self.tunnel_dest.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id-extension"):
                                            self.tunnel_id_extension = value
                                            self.tunnel_id_extension.value_namespace = name_space
                                            self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-lsp-id"):
                                            self.tunnel_lsp_id = value
                                            self.tunnel_lsp_id.value_namespace = name_space
                                            self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-source"):
                                            self.tunnel_source = value
                                            self.tunnel_source.value_namespace = name_space
                                            self.tunnel_source.value_namespace_prefix = name_space_prefix


                                class Ipv4L3VpnData(Entity):
                                    """
                                    L3VPN IPv4 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv4 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: route_distinguisher
                                    
                                    	Route distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__init__()

                                        self.yang_name = "ipv4l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "route_distinguisher") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.route_distinguisher.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.route_distinguisher.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "route-distinguisher"):
                                            self.route_distinguisher = value
                                            self.route_distinguisher.value_namespace = name_space
                                            self.route_distinguisher.value_namespace_prefix = name_space_prefix


                                class Ipv6L3VpnData(Entity):
                                    """
                                    L3VPN IPv6 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv6 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: route_distinguisher
                                    
                                    	Route distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__init__()

                                        self.yang_name = "ipv6l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "route_distinguisher") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.route_distinguisher.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.route_distinguisher.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "route-distinguisher"):
                                            self.route_distinguisher = value
                                            self.route_distinguisher.value_namespace = name_space
                                            self.route_distinguisher.value_namespace_prefix = name_space_prefix


                                class VrfL3VpnData(Entity):
                                    """
                                    L3VPN VRF label context
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__init__()

                                        self.yang_name = "vrf-l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("security_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.security_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf-l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "security-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class Cev4L3VpnData(Entity):
                                    """
                                    L3VPN CEv4 label context
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__init__()

                                        self.yang_name = "cev4l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ipv4_next_hop",
                                                        "security_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ipv4_next_hop.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cev4l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ipv4-next-hop" or name == "security-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class Cev6L3VpnData(Entity):
                                    """
                                    L3VPN CEv6 label context
                                    
                                    .. attribute:: ipv6_next_hop
                                    
                                    	IPv6 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__init__()

                                        self.yang_name = "cev6l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ipv6_next_hop",
                                                        "security_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ipv6_next_hop.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ipv6_next_hop.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cev6l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ipv6-next-hop" or name == "security-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ipv6-next-hop"):
                                            self.ipv6_next_hop = value
                                            self.ipv6_next_hop.value_namespace = name_space
                                            self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class PseudowireData(Entity):
                                    """
                                    Pseudowire label context
                                    
                                    .. attribute:: prefix
                                    
                                    	Address prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: pseudowire_id
                                    
                                    	Pseudo\-wire ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: remote_l2_router_id
                                    
                                    	Remote L2 Router ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: subinterface
                                    
                                    	Subinterface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireData, self).__init__()

                                        self.yang_name = "pseudowire-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.pseudowire_id = YLeaf(YType.uint64, "pseudowire-id")

                                        self.remote_l2_router_id = YLeaf(YType.uint32, "remote-l2-router-id")

                                        self.subinterface = YLeaf(YType.str, "subinterface")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "pseudowire_id",
                                                        "remote_l2_router_id",
                                                        "subinterface") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.pseudowire_id.is_set or
                                            self.remote_l2_router_id.is_set or
                                            self.subinterface.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.pseudowire_id.yfilter != YFilter.not_set or
                                            self.remote_l2_router_id.yfilter != YFilter.not_set or
                                            self.subinterface.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pseudowire_id.get_name_leafdata())
                                        if (self.remote_l2_router_id.is_set or self.remote_l2_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remote_l2_router_id.get_name_leafdata())
                                        if (self.subinterface.is_set or self.subinterface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.subinterface.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "pseudowire-id" or name == "remote-l2-router-id" or name == "subinterface"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pseudowire-id"):
                                            self.pseudowire_id = value
                                            self.pseudowire_id.value_namespace = name_space
                                            self.pseudowire_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remote-l2-router-id"):
                                            self.remote_l2_router_id = value
                                            self.remote_l2_router_id.value_namespace = name_space
                                            self.remote_l2_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "subinterface"):
                                            self.subinterface = value
                                            self.subinterface.value_namespace = name_space
                                            self.subinterface.value_namespace_prefix = name_space_prefix


                                class LabelBlockData(Entity):
                                    """
                                    Label block context
                                    
                                    .. attribute:: edge_id
                                    
                                    	Edge ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: offset
                                    
                                    	Offset
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: service
                                    
                                    	Service
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: size
                                    
                                    	Number of labels
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vpn_id
                                    
                                    	VPN ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__init__()

                                        self.yang_name = "label-block-data"
                                        self.yang_parent_name = "label-context"

                                        self.edge_id = YLeaf(YType.uint16, "edge-id")

                                        self.offset = YLeaf(YType.uint32, "offset")

                                        self.service = YLeaf(YType.uint8, "service")

                                        self.size = YLeaf(YType.uint32, "size")

                                        self.vpn_id = YLeaf(YType.uint16, "vpn-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("edge_id",
                                                        "offset",
                                                        "service",
                                                        "size",
                                                        "vpn_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.edge_id.is_set or
                                            self.offset.is_set or
                                            self.service.is_set or
                                            self.size.is_set or
                                            self.vpn_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.edge_id.yfilter != YFilter.not_set or
                                            self.offset.yfilter != YFilter.not_set or
                                            self.service.yfilter != YFilter.not_set or
                                            self.size.yfilter != YFilter.not_set or
                                            self.vpn_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "label-block-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.edge_id.is_set or self.edge_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.edge_id.get_name_leafdata())
                                        if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.offset.get_name_leafdata())
                                        if (self.service.is_set or self.service.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.service.get_name_leafdata())
                                        if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.size.get_name_leafdata())
                                        if (self.vpn_id.is_set or self.vpn_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vpn_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "edge-id" or name == "offset" or name == "service" or name == "size" or name == "vpn-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "edge-id"):
                                            self.edge_id = value
                                            self.edge_id.value_namespace = name_space
                                            self.edge_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "offset"):
                                            self.offset = value
                                            self.offset.value_namespace = name_space
                                            self.offset.value_namespace_prefix = name_space_prefix
                                        if(value_path == "service"):
                                            self.service = value
                                            self.service.value_namespace = name_space
                                            self.service.value_namespace_prefix = name_space_prefix
                                        if(value_path == "size"):
                                            self.size = value
                                            self.size.value_namespace = name_space
                                            self.size.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vpn-id"):
                                            self.vpn_id = value
                                            self.vpn_id.value_namespace = name_space
                                            self.vpn_id.value_namespace_prefix = name_space_prefix


                                class IpSubData(Entity):
                                    """
                                    IP Subscriber context
                                    
                                    .. attribute:: parent_interface
                                    
                                    	Parent interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: table_id
                                    
                                    	Table Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.IpSubData, self).__init__()

                                        self.yang_name = "ip-sub-data"
                                        self.yang_parent_name = "label-context"

                                        self.parent_interface = YLeaf(YType.str, "parent-interface")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("parent_interface",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.parent_interface.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.parent_interface.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ip-sub-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.parent_interface.is_set or self.parent_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_interface.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "parent-interface" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "parent-interface"):
                                            self.parent_interface = value
                                            self.parent_interface.value_namespace = name_space
                                            self.parent_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class Tev4P2MpData(Entity):
                                    """
                                    TEv4 P2MP context
                                    
                                    .. attribute:: p2mp_id
                                    
                                    	Point to multipoint ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: previous_hop
                                    
                                    	Previous hop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_id_extension
                                    
                                    	Tunnel ID extension
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_lsp_id
                                    
                                    	Tunnel LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_source
                                    
                                    	Tunnel source
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__init__()

                                        self.yang_name = "tev4p2mp-data"
                                        self.yang_parent_name = "label-context"

                                        self.p2mp_id = YLeaf(YType.uint32, "p2mp-id")

                                        self.previous_hop = YLeaf(YType.str, "previous-hop")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                        self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                        self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                        self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("p2mp_id",
                                                        "previous_hop",
                                                        "table_id",
                                                        "tunnel_id",
                                                        "tunnel_id_extension",
                                                        "tunnel_lsp_id",
                                                        "tunnel_source") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.p2mp_id.is_set or
                                            self.previous_hop.is_set or
                                            self.table_id.is_set or
                                            self.tunnel_id.is_set or
                                            self.tunnel_id_extension.is_set or
                                            self.tunnel_lsp_id.is_set or
                                            self.tunnel_source.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.p2mp_id.yfilter != YFilter.not_set or
                                            self.previous_hop.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set or
                                            self.tunnel_id_extension.yfilter != YFilter.not_set or
                                            self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                            self.tunnel_source.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tev4p2mp-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                                        if (self.previous_hop.is_set or self.previous_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.previous_hop.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                        if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                        if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                        if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "p2mp-id" or name == "previous-hop" or name == "table-id" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "p2mp-id"):
                                            self.p2mp_id = value
                                            self.p2mp_id.value_namespace = name_space
                                            self.p2mp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "previous-hop"):
                                            self.previous_hop = value
                                            self.previous_hop.value_namespace = name_space
                                            self.previous_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id-extension"):
                                            self.tunnel_id_extension = value
                                            self.tunnel_id_extension.value_namespace = name_space
                                            self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-lsp-id"):
                                            self.tunnel_lsp_id = value
                                            self.tunnel_lsp_id.value_namespace = name_space
                                            self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-source"):
                                            self.tunnel_source = value
                                            self.tunnel_source.value_namespace = name_space
                                            self.tunnel_source.value_namespace_prefix = name_space_prefix


                                class MldPv4Data(Entity):
                                    """
                                    MLDPv4 LSM\-ID context
                                    
                                    .. attribute:: lsm_id
                                    
                                    	LSM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: peer_label_space_id
                                    
                                    	Peer Label Space Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: peer_lsrid
                                    
                                    	Peer LSR Id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: type
                                    
                                    	LSM ID Type
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__init__()

                                        self.yang_name = "mld-pv4-data"
                                        self.yang_parent_name = "label-context"

                                        self.lsm_id = YLeaf(YType.uint32, "lsm-id")

                                        self.peer_label_space_id = YLeaf(YType.uint16, "peer-label-space-id")

                                        self.peer_lsrid = YLeaf(YType.str, "peer-lsrid")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.type = YLeaf(YType.uint16, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("lsm_id",
                                                        "peer_label_space_id",
                                                        "peer_lsrid",
                                                        "table_id",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.lsm_id.is_set or
                                            self.peer_label_space_id.is_set or
                                            self.peer_lsrid.is_set or
                                            self.table_id.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.lsm_id.yfilter != YFilter.not_set or
                                            self.peer_label_space_id.yfilter != YFilter.not_set or
                                            self.peer_lsrid.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "mld-pv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.lsm_id.is_set or self.lsm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsm_id.get_name_leafdata())
                                        if (self.peer_label_space_id.is_set or self.peer_label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.peer_label_space_id.get_name_leafdata())
                                        if (self.peer_lsrid.is_set or self.peer_lsrid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.peer_lsrid.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsm-id" or name == "peer-label-space-id" or name == "peer-lsrid" or name == "table-id" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "lsm-id"):
                                            self.lsm_id = value
                                            self.lsm_id.value_namespace = name_space
                                            self.lsm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "peer-label-space-id"):
                                            self.peer_label_space_id = value
                                            self.peer_label_space_id.value_namespace = name_space
                                            self.peer_label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "peer-lsrid"):
                                            self.peer_lsrid = value
                                            self.peer_lsrid.value_namespace = name_space
                                            self.peer_lsrid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class PseudowireHeadEndData(Entity):
                                    """
                                    Pseudowire Head\-end label context
                                    
                                    .. attribute:: pwhe_intf
                                    
                                    	Pseudo\-wire Head\-end interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__init__()

                                        self.yang_name = "pseudowire-head-end-data"
                                        self.yang_parent_name = "label-context"

                                        self.pwhe_intf = YLeaf(YType.str, "pwhe-intf")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("pwhe_intf") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.pwhe_intf.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.pwhe_intf.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-head-end-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.pwhe_intf.is_set or self.pwhe_intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pwhe_intf.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "pwhe-intf"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "pwhe-intf"):
                                            self.pwhe_intf = value
                                            self.pwhe_intf.value_namespace = name_space
                                            self.pwhe_intf.value_namespace_prefix = name_space_prefix


                                class TpData(Entity):
                                    """
                                    TP context
                                    
                                    .. attribute:: dest_global_id
                                    
                                    	TP destination global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dest_node_id
                                    
                                    	TP destination node ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: dest_tunnel_id
                                    
                                    	TP destination tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsp_id
                                    
                                    	TP LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: source_global_id
                                    
                                    	TP source global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: source_node_id
                                    
                                    	TP source node ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: source_tunnel_id
                                    
                                    	TP source tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TpData, self).__init__()

                                        self.yang_name = "tp-data"
                                        self.yang_parent_name = "label-context"

                                        self.dest_global_id = YLeaf(YType.uint32, "dest-global-id")

                                        self.dest_node_id = YLeaf(YType.str, "dest-node-id")

                                        self.dest_tunnel_id = YLeaf(YType.uint16, "dest-tunnel-id")

                                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                        self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                                        self.source_node_id = YLeaf(YType.str, "source-node-id")

                                        self.source_tunnel_id = YLeaf(YType.uint16, "source-tunnel-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("dest_global_id",
                                                        "dest_node_id",
                                                        "dest_tunnel_id",
                                                        "lsp_id",
                                                        "source_global_id",
                                                        "source_node_id",
                                                        "source_tunnel_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.dest_global_id.is_set or
                                            self.dest_node_id.is_set or
                                            self.dest_tunnel_id.is_set or
                                            self.lsp_id.is_set or
                                            self.source_global_id.is_set or
                                            self.source_node_id.is_set or
                                            self.source_tunnel_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.dest_global_id.yfilter != YFilter.not_set or
                                            self.dest_node_id.yfilter != YFilter.not_set or
                                            self.dest_tunnel_id.yfilter != YFilter.not_set or
                                            self.lsp_id.yfilter != YFilter.not_set or
                                            self.source_global_id.yfilter != YFilter.not_set or
                                            self.source_node_id.yfilter != YFilter.not_set or
                                            self.source_tunnel_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tp-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.dest_global_id.is_set or self.dest_global_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dest_global_id.get_name_leafdata())
                                        if (self.dest_node_id.is_set or self.dest_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dest_node_id.get_name_leafdata())
                                        if (self.dest_tunnel_id.is_set or self.dest_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dest_tunnel_id.get_name_leafdata())
                                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsp_id.get_name_leafdata())
                                        if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source_global_id.get_name_leafdata())
                                        if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source_node_id.get_name_leafdata())
                                        if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dest-global-id" or name == "dest-node-id" or name == "dest-tunnel-id" or name == "lsp-id" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "dest-global-id"):
                                            self.dest_global_id = value
                                            self.dest_global_id.value_namespace = name_space
                                            self.dest_global_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dest-node-id"):
                                            self.dest_node_id = value
                                            self.dest_node_id.value_namespace = name_space
                                            self.dest_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dest-tunnel-id"):
                                            self.dest_tunnel_id = value
                                            self.dest_tunnel_id.value_namespace = name_space
                                            self.dest_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsp-id"):
                                            self.lsp_id = value
                                            self.lsp_id.value_namespace = name_space
                                            self.lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source-global-id"):
                                            self.source_global_id = value
                                            self.source_global_id.value_namespace = name_space
                                            self.source_global_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source-node-id"):
                                            self.source_node_id = value
                                            self.source_node_id.value_namespace = name_space
                                            self.source_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source-tunnel-id"):
                                            self.source_tunnel_id = value
                                            self.source_tunnel_id.value_namespace = name_space
                                            self.source_tunnel_id.value_namespace_prefix = name_space_prefix


                                class GenericRoutingEncapsulation(Entity):
                                    """
                                    Generic routing encapsulation context
                                    
                                    .. attribute:: gre_interface
                                    
                                    	Generic routing encapsulation interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__init__()

                                        self.yang_name = "generic-routing-encapsulation"
                                        self.yang_parent_name = "label-context"

                                        self.gre_interface = YLeaf(YType.str, "gre-interface")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("gre_interface") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.gre_interface.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.gre_interface.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "generic-routing-encapsulation" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.gre_interface.is_set or self.gre_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gre_interface.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "gre-interface"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "gre-interface"):
                                            self.gre_interface = value
                                            self.gre_interface.value_namespace = name_space
                                            self.gre_interface.value_namespace_prefix = name_space_prefix


                                class Ipv6GenericRoutingEncapsulation(Entity):
                                    """
                                    Generic routing encapsulation context
                                    
                                    .. attribute:: greipv6_interface
                                    
                                    	Generic routing encapsulation IPv6 interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__init__()

                                        self.yang_name = "ipv6-generic-routing-encapsulation"
                                        self.yang_parent_name = "label-context"

                                        self.greipv6_interface = YLeaf(YType.str, "greipv6-interface")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("greipv6_interface") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.greipv6_interface.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.greipv6_interface.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-generic-routing-encapsulation" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.greipv6_interface.is_set or self.greipv6_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.greipv6_interface.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "greipv6-interface"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "greipv6-interface"):
                                            self.greipv6_interface = value
                                            self.greipv6_interface.value_namespace = name_space
                                            self.greipv6_interface.value_namespace_prefix = name_space_prefix


                                class EvpnData(Entity):
                                    """
                                    EVPN context
                                    
                                    .. attribute:: ethernet_segment
                                    
                                    	Ethernet Segment ID
                                    	**type**\:  str
                                    
                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                    
                                    .. attribute:: evpn_id
                                    
                                    	EVPN ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: evpn_tag
                                    
                                    	EVPN TAG
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.EvpnData, self).__init__()

                                        self.yang_name = "evpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.ethernet_segment = YLeaf(YType.str, "ethernet-segment")

                                        self.evpn_id = YLeaf(YType.uint32, "evpn-id")

                                        self.evpn_tag = YLeaf(YType.uint32, "evpn-tag")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ethernet_segment",
                                                        "evpn_id",
                                                        "evpn_tag") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ethernet_segment.is_set or
                                            self.evpn_id.is_set or
                                            self.evpn_tag.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ethernet_segment.yfilter != YFilter.not_set or
                                            self.evpn_id.yfilter != YFilter.not_set or
                                            self.evpn_tag.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "evpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ethernet_segment.is_set or self.ethernet_segment.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ethernet_segment.get_name_leafdata())
                                        if (self.evpn_id.is_set or self.evpn_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.evpn_id.get_name_leafdata())
                                        if (self.evpn_tag.is_set or self.evpn_tag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.evpn_tag.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ethernet-segment" or name == "evpn-id" or name == "evpn-tag"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ethernet-segment"):
                                            self.ethernet_segment = value
                                            self.ethernet_segment.value_namespace = name_space
                                            self.ethernet_segment.value_namespace_prefix = name_space_prefix
                                        if(value_path == "evpn-id"):
                                            self.evpn_id = value
                                            self.evpn_id.value_namespace = name_space
                                            self.evpn_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "evpn-tag"):
                                            self.evpn_tag = value
                                            self.evpn_tag.value_namespace = name_space
                                            self.evpn_tag.value_namespace_prefix = name_space_prefix


                                class Ipv4BlbData(Entity):
                                    """
                                    BFD BLB label context
                                    
                                    .. attribute:: blb_intf
                                    
                                    	BFD BLB interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv4 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__init__()

                                        self.yang_name = "ipv4blb-data"
                                        self.yang_parent_name = "label-context"

                                        self.blb_intf = YLeaf(YType.str, "blb-intf")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("blb_intf",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.blb_intf.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.blb_intf.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4blb-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "blb-intf" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "blb-intf"):
                                            self.blb_intf = value
                                            self.blb_intf.value_namespace = name_space
                                            self.blb_intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix


                                class Ipv6BlbData(Entity):
                                    """
                                    BFD BLB label context
                                    
                                    .. attribute:: blb_intf
                                    
                                    	BFD BLB interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv6 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__init__()

                                        self.yang_name = "ipv6blb-data"
                                        self.yang_parent_name = "label-context"

                                        self.blb_intf = YLeaf(YType.str, "blb-intf")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("blb_intf",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.blb_intf.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.blb_intf.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6blb-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "blb-intf" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "blb-intf"):
                                            self.blb_intf = value
                                            self.blb_intf.value_namespace = name_space
                                            self.blb_intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix


                                class PiMiPmsiData(Entity):
                                    """
                                    PIM I\-PMSI label conext
                                    
                                    .. attribute:: head
                                    
                                    	Head
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: v6
                                    
                                    	PIM6
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: vrf_id
                                    
                                    	VRF ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__init__()

                                        self.yang_name = "pi-mi-pmsi-data"
                                        self.yang_parent_name = "label-context"

                                        self.head = YLeaf(YType.int32, "head")

                                        self.v6 = YLeaf(YType.int32, "v6")

                                        self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("head",
                                                        "v6",
                                                        "vrf_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.head.is_set or
                                            self.v6.is_set or
                                            self.vrf_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.head.yfilter != YFilter.not_set or
                                            self.v6.yfilter != YFilter.not_set or
                                            self.vrf_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pi-mi-pmsi-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.head.get_name_leafdata())
                                        if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.v6.get_name_leafdata())
                                        if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "head" or name == "v6" or name == "vrf-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "head"):
                                            self.head = value
                                            self.head.value_namespace = name_space
                                            self.head.value_namespace_prefix = name_space_prefix
                                        if(value_path == "v6"):
                                            self.v6 = value
                                            self.v6.value_namespace = name_space
                                            self.v6.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-id"):
                                            self.vrf_id = value
                                            self.vrf_id.value_namespace = name_space
                                            self.vrf_id.value_namespace_prefix = name_space_prefix


                                class PiMsPmsiData(Entity):
                                    """
                                    PIM S\-PMSI label conext
                                    
                                    .. attribute:: head
                                    
                                    	Head
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: hli
                                    
                                    	Head LSM\-ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: seg
                                    
                                    	Segmented Multicast
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: source
                                    
                                    	Originating Router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: v6
                                    
                                    	PIM6
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: vrf_id
                                    
                                    	VRF ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__init__()

                                        self.yang_name = "pi-ms-pmsi-data"
                                        self.yang_parent_name = "label-context"

                                        self.head = YLeaf(YType.int32, "head")

                                        self.hli = YLeaf(YType.uint32, "hli")

                                        self.seg = YLeaf(YType.int32, "seg")

                                        self.source = YLeaf(YType.str, "source")

                                        self.v6 = YLeaf(YType.int32, "v6")

                                        self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("head",
                                                        "hli",
                                                        "seg",
                                                        "source",
                                                        "v6",
                                                        "vrf_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.head.is_set or
                                            self.hli.is_set or
                                            self.seg.is_set or
                                            self.source.is_set or
                                            self.v6.is_set or
                                            self.vrf_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.head.yfilter != YFilter.not_set or
                                            self.hli.yfilter != YFilter.not_set or
                                            self.seg.yfilter != YFilter.not_set or
                                            self.source.yfilter != YFilter.not_set or
                                            self.v6.yfilter != YFilter.not_set or
                                            self.vrf_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pi-ms-pmsi-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.head.get_name_leafdata())
                                        if (self.hli.is_set or self.hli.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hli.get_name_leafdata())
                                        if (self.seg.is_set or self.seg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.seg.get_name_leafdata())
                                        if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source.get_name_leafdata())
                                        if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.v6.get_name_leafdata())
                                        if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "head" or name == "hli" or name == "seg" or name == "source" or name == "v6" or name == "vrf-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "head"):
                                            self.head = value
                                            self.head.value_namespace = name_space
                                            self.head.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hli"):
                                            self.hli = value
                                            self.hli.value_namespace = name_space
                                            self.hli.value_namespace_prefix = name_space_prefix
                                        if(value_path == "seg"):
                                            self.seg = value
                                            self.seg.value_namespace = name_space
                                            self.seg.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source"):
                                            self.source = value
                                            self.source.value_namespace = name_space
                                            self.source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "v6"):
                                            self.v6 = value
                                            self.v6.value_namespace = name_space
                                            self.v6.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-id"):
                                            self.vrf_id = value
                                            self.vrf_id.value_namespace = name_space
                                            self.vrf_id.value_namespace_prefix = name_space_prefix


                                class NextHopSetL3Vpn(Entity):
                                    """
                                    L3VPN NH SET label context
                                    
                                    .. attribute:: next_hop_set_id
                                    
                                    	Next Hop Set ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__init__()

                                        self.yang_name = "next-hop-set-l3vpn"
                                        self.yang_parent_name = "label-context"

                                        self.next_hop_set_id = YLeaf(YType.uint32, "next-hop-set-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("next_hop_set_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.next_hop_set_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.next_hop_set_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "next-hop-set-l3vpn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.next_hop_set_id.is_set or self.next_hop_set_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_set_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "next-hop-set-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "next-hop-set-id"):
                                            self.next_hop_set_id = value
                                            self.next_hop_set_id.value_namespace = name_space
                                            self.next_hop_set_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class SrPrefixSegment(Entity):
                                    """
                                    SR Prefix Segment context
                                    
                                    .. attribute:: segment_id
                                    
                                    	Prefix Segment ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__init__()

                                        self.yang_name = "sr-prefix-segment"
                                        self.yang_parent_name = "label-context"

                                        self.segment_id = YLeaf(YType.uint32, "segment-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("segment_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.segment_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.segment_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-prefix-segment" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.segment_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "segment-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "segment-id"):
                                            self.segment_id = value
                                            self.segment_id.value_namespace = name_space
                                            self.segment_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class SrAdjSegmentIpv4(Entity):
                                    """
                                    SR Adj Segment ipv4 context
                                    
                                    .. attribute:: addr
                                    
                                    	Adjacency nexthop IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: index
                                    
                                    	Adjacency index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: intf
                                    
                                    	Adjacency interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: type
                                    
                                    	Adjacency type
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__init__()

                                        self.yang_name = "sr-adj-segment-ipv4"
                                        self.yang_parent_name = "label-context"

                                        self.addr = YLeaf(YType.str, "addr")

                                        self.index = YLeaf(YType.uint32, "index")

                                        self.intf = YLeaf(YType.str, "intf")

                                        self.type = YLeaf(YType.uint32, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("addr",
                                                        "index",
                                                        "intf",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.addr.is_set or
                                            self.index.is_set or
                                            self.intf.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.addr.yfilter != YFilter.not_set or
                                            self.index.yfilter != YFilter.not_set or
                                            self.intf.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-adj-segment-ipv4" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.addr.get_name_leafdata())
                                        if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.index.get_name_leafdata())
                                        if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.intf.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "addr"):
                                            self.addr = value
                                            self.addr.value_namespace = name_space
                                            self.addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "index"):
                                            self.index = value
                                            self.index.value_namespace = name_space
                                            self.index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "intf"):
                                            self.intf = value
                                            self.intf.value_namespace = name_space
                                            self.intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class SrAdjSegmentIpv6(Entity):
                                    """
                                    SR Adj Segment ipv6 context
                                    
                                    .. attribute:: addr
                                    
                                    	Adjacency nexthop IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: index
                                    
                                    	Adjacency index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: intf
                                    
                                    	Adjacency interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: type
                                    
                                    	Adjacency type
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__init__()

                                        self.yang_name = "sr-adj-segment-ipv6"
                                        self.yang_parent_name = "label-context"

                                        self.addr = YLeaf(YType.str, "addr")

                                        self.index = YLeaf(YType.uint32, "index")

                                        self.intf = YLeaf(YType.str, "intf")

                                        self.type = YLeaf(YType.uint32, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("addr",
                                                        "index",
                                                        "intf",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.addr.is_set or
                                            self.index.is_set or
                                            self.intf.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.addr.yfilter != YFilter.not_set or
                                            self.index.yfilter != YFilter.not_set or
                                            self.intf.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-adj-segment-ipv6" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.addr.get_name_leafdata())
                                        if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.index.get_name_leafdata())
                                        if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.intf.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "addr"):
                                            self.addr = value
                                            self.addr.value_namespace = name_space
                                            self.addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "index"):
                                            self.index = value
                                            self.index.value_namespace = name_space
                                            self.index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "intf"):
                                            self.intf = value
                                            self.intf.value_namespace = name_space
                                            self.intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class LabelBlockSrgbData(Entity):
                                    """
                                    Label block SRGB context
                                    
                                    .. attribute:: offset
                                    
                                    	Offset
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: size
                                    
                                    	Number of labels
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: start_label
                                    
                                    	Start Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__init__()

                                        self.yang_name = "label-block-srgb-data"
                                        self.yang_parent_name = "label-context"

                                        self.offset = YLeaf(YType.uint32, "offset")

                                        self.size = YLeaf(YType.uint32, "size")

                                        self.start_label = YLeaf(YType.uint32, "start-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("offset",
                                                        "size",
                                                        "start_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.offset.is_set or
                                            self.size.is_set or
                                            self.start_label.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.offset.yfilter != YFilter.not_set or
                                            self.size.yfilter != YFilter.not_set or
                                            self.start_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "label-block-srgb-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.offset.get_name_leafdata())
                                        if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.size.get_name_leafdata())
                                        if (self.start_label.is_set or self.start_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.start_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "offset" or name == "size" or name == "start-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "offset"):
                                            self.offset = value
                                            self.offset.value_namespace = name_space
                                            self.offset.value_namespace_prefix = name_space_prefix
                                        if(value_path == "size"):
                                            self.size = value
                                            self.size.value_namespace = name_space
                                            self.size.value_namespace_prefix = name_space_prefix
                                        if(value_path == "start-label"):
                                            self.start_label = value
                                            self.start_label.value_namespace = name_space
                                            self.start_label.value_namespace_prefix = name_space_prefix


                                class TeBinding(Entity):
                                    """
                                    MPLS TE tunnel binding context
                                    
                                    .. attribute:: te_identifier
                                    
                                    	MPLS Traffic Engineering Tunnel or Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_type
                                    
                                    	Type of identifier for the binding
                                    	**type**\:   :py:class:`MgmtLsdTeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdTeBinding>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TeBinding, self).__init__()

                                        self.yang_name = "te-binding"
                                        self.yang_parent_name = "label-context"

                                        self.te_identifier = YLeaf(YType.uint32, "te-identifier")

                                        self.te_type = YLeaf(YType.enumeration, "te-type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("te_identifier",
                                                        "te_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.te_identifier.is_set or
                                            self.te_type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.te_identifier.yfilter != YFilter.not_set or
                                            self.te_type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "te-binding" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.te_identifier.is_set or self.te_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_identifier.get_name_leafdata())
                                        if (self.te_type.is_set or self.te_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "te-identifier" or name == "te-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "te-identifier"):
                                            self.te_identifier = value
                                            self.te_identifier.value_namespace = name_space
                                            self.te_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-type"):
                                            self.te_type = value
                                            self.te_type.value_namespace = name_space
                                            self.te_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_context_type.is_set or
                                        (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_data()) or
                                        (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_data()) or
                                        (self.evpn_data is not None and self.evpn_data.has_data()) or
                                        (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_data()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                        (self.ipv4blb_data is not None and self.ipv4blb_data.has_data()) or
                                        (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_data()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                        (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_data()) or
                                        (self.ipv6blb_data is not None and self.ipv6blb_data.has_data()) or
                                        (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_data()) or
                                        (self.label_block_data is not None and self.label_block_data.has_data()) or
                                        (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_data()) or
                                        (self.mld_pv4_data is not None and self.mld_pv4_data.has_data()) or
                                        (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_data()) or
                                        (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_data()) or
                                        (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_data()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                        (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_data()) or
                                        (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_data()) or
                                        (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_data()) or
                                        (self.te_binding is not None and self.te_binding.has_data()) or
                                        (self.tev4_data is not None and self.tev4_data.has_data()) or
                                        (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_data()) or
                                        (self.tp_data is not None and self.tp_data.has_data()) or
                                        (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_context_type.yfilter != YFilter.not_set or
                                        (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_operation()) or
                                        (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_operation()) or
                                        (self.evpn_data is not None and self.evpn_data.has_operation()) or
                                        (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_operation()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                        (self.ipv4blb_data is not None and self.ipv4blb_data.has_operation()) or
                                        (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_operation()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                        (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_operation()) or
                                        (self.ipv6blb_data is not None and self.ipv6blb_data.has_operation()) or
                                        (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_operation()) or
                                        (self.label_block_data is not None and self.label_block_data.has_operation()) or
                                        (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_operation()) or
                                        (self.mld_pv4_data is not None and self.mld_pv4_data.has_operation()) or
                                        (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_operation()) or
                                        (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_operation()) or
                                        (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_operation()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                        (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_operation()) or
                                        (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_operation()) or
                                        (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_operation()) or
                                        (self.te_binding is not None and self.te_binding.has_operation()) or
                                        (self.tev4_data is not None and self.tev4_data.has_operation()) or
                                        (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_operation()) or
                                        (self.tp_data is not None and self.tp_data.has_operation()) or
                                        (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-context" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_context_type.is_set or self.label_context_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_context_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cev4l3vpn-data"):
                                        if (self.cev4l3vpn_data is None):
                                            self.cev4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                            self.cev4l3vpn_data.parent = self
                                            self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                        return self.cev4l3vpn_data

                                    if (child_yang_name == "cev6l3vpn-data"):
                                        if (self.cev6l3vpn_data is None):
                                            self.cev6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                            self.cev6l3vpn_data.parent = self
                                            self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                        return self.cev6l3vpn_data

                                    if (child_yang_name == "evpn-data"):
                                        if (self.evpn_data is None):
                                            self.evpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.EvpnData()
                                            self.evpn_data.parent = self
                                            self._children_name_map["evpn_data"] = "evpn-data"
                                        return self.evpn_data

                                    if (child_yang_name == "generic-routing-encapsulation"):
                                        if (self.generic_routing_encapsulation is None):
                                            self.generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                            self.generic_routing_encapsulation.parent = self
                                            self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                        return self.generic_routing_encapsulation

                                    if (child_yang_name == "ip-sub-data"):
                                        if (self.ip_sub_data is None):
                                            self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.IpSubData()
                                            self.ip_sub_data.parent = self
                                            self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                        return self.ip_sub_data

                                    if (child_yang_name == "ipv4-data"):
                                        if (self.ipv4_data is None):
                                            self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                            self.ipv4_data.parent = self
                                            self._children_name_map["ipv4_data"] = "ipv4-data"
                                        return self.ipv4_data

                                    if (child_yang_name == "ipv4blb-data"):
                                        if (self.ipv4blb_data is None):
                                            self.ipv4blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                            self.ipv4blb_data.parent = self
                                            self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                        return self.ipv4blb_data

                                    if (child_yang_name == "ipv4l3vpn-data"):
                                        if (self.ipv4l3vpn_data is None):
                                            self.ipv4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                            self.ipv4l3vpn_data.parent = self
                                            self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                        return self.ipv4l3vpn_data

                                    if (child_yang_name == "ipv6-data"):
                                        if (self.ipv6_data is None):
                                            self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                            self.ipv6_data.parent = self
                                            self._children_name_map["ipv6_data"] = "ipv6-data"
                                        return self.ipv6_data

                                    if (child_yang_name == "ipv6-generic-routing-encapsulation"):
                                        if (self.ipv6_generic_routing_encapsulation is None):
                                            self.ipv6_generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                            self.ipv6_generic_routing_encapsulation.parent = self
                                            self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                        return self.ipv6_generic_routing_encapsulation

                                    if (child_yang_name == "ipv6blb-data"):
                                        if (self.ipv6blb_data is None):
                                            self.ipv6blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                            self.ipv6blb_data.parent = self
                                            self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                        return self.ipv6blb_data

                                    if (child_yang_name == "ipv6l3vpn-data"):
                                        if (self.ipv6l3vpn_data is None):
                                            self.ipv6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                            self.ipv6l3vpn_data.parent = self
                                            self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                        return self.ipv6l3vpn_data

                                    if (child_yang_name == "label-block-data"):
                                        if (self.label_block_data is None):
                                            self.label_block_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                            self.label_block_data.parent = self
                                            self._children_name_map["label_block_data"] = "label-block-data"
                                        return self.label_block_data

                                    if (child_yang_name == "label-block-srgb-data"):
                                        if (self.label_block_srgb_data is None):
                                            self.label_block_srgb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                            self.label_block_srgb_data.parent = self
                                            self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                        return self.label_block_srgb_data

                                    if (child_yang_name == "mld-pv4-data"):
                                        if (self.mld_pv4_data is None):
                                            self.mld_pv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                            self.mld_pv4_data.parent = self
                                            self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                        return self.mld_pv4_data

                                    if (child_yang_name == "next-hop-set-l3vpn"):
                                        if (self.next_hop_set_l3vpn is None):
                                            self.next_hop_set_l3vpn = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                            self.next_hop_set_l3vpn.parent = self
                                            self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                        return self.next_hop_set_l3vpn

                                    if (child_yang_name == "pi-mi-pmsi-data"):
                                        if (self.pi_mi_pmsi_data is None):
                                            self.pi_mi_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                            self.pi_mi_pmsi_data.parent = self
                                            self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                        return self.pi_mi_pmsi_data

                                    if (child_yang_name == "pi-ms-pmsi-data"):
                                        if (self.pi_ms_pmsi_data is None):
                                            self.pi_ms_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                            self.pi_ms_pmsi_data.parent = self
                                            self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                        return self.pi_ms_pmsi_data

                                    if (child_yang_name == "pseudowire-data"):
                                        if (self.pseudowire_data is None):
                                            self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireData()
                                            self.pseudowire_data.parent = self
                                            self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                        return self.pseudowire_data

                                    if (child_yang_name == "pseudowire-head-end-data"):
                                        if (self.pseudowire_head_end_data is None):
                                            self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                            self.pseudowire_head_end_data.parent = self
                                            self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                        return self.pseudowire_head_end_data

                                    if (child_yang_name == "sr-adj-segment-ipv4"):
                                        if (self.sr_adj_segment_ipv4 is None):
                                            self.sr_adj_segment_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                            self.sr_adj_segment_ipv4.parent = self
                                            self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                        return self.sr_adj_segment_ipv4

                                    if (child_yang_name == "sr-adj-segment-ipv6"):
                                        if (self.sr_adj_segment_ipv6 is None):
                                            self.sr_adj_segment_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                            self.sr_adj_segment_ipv6.parent = self
                                            self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                        return self.sr_adj_segment_ipv6

                                    if (child_yang_name == "sr-prefix-segment"):
                                        if (self.sr_prefix_segment is None):
                                            self.sr_prefix_segment = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                            self.sr_prefix_segment.parent = self
                                            self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                        return self.sr_prefix_segment

                                    if (child_yang_name == "te-binding"):
                                        if (self.te_binding is None):
                                            self.te_binding = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TeBinding()
                                            self.te_binding.parent = self
                                            self._children_name_map["te_binding"] = "te-binding"
                                        return self.te_binding

                                    if (child_yang_name == "tev4-data"):
                                        if (self.tev4_data is None):
                                            self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4Data()
                                            self.tev4_data.parent = self
                                            self._children_name_map["tev4_data"] = "tev4-data"
                                        return self.tev4_data

                                    if (child_yang_name == "tev4p2mp-data"):
                                        if (self.tev4p2mp_data is None):
                                            self.tev4p2mp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                            self.tev4p2mp_data.parent = self
                                            self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                        return self.tev4p2mp_data

                                    if (child_yang_name == "tp-data"):
                                        if (self.tp_data is None):
                                            self.tp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TpData()
                                            self.tp_data.parent = self
                                            self._children_name_map["tp_data"] = "tp-data"
                                        return self.tp_data

                                    if (child_yang_name == "vrf-l3vpn-data"):
                                        if (self.vrf_l3vpn_data is None):
                                            self.vrf_l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                            self.vrf_l3vpn_data.parent = self
                                            self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                        return self.vrf_l3vpn_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cev4l3vpn-data" or name == "cev6l3vpn-data" or name == "evpn-data" or name == "generic-routing-encapsulation" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv4blb-data" or name == "ipv4l3vpn-data" or name == "ipv6-data" or name == "ipv6-generic-routing-encapsulation" or name == "ipv6blb-data" or name == "ipv6l3vpn-data" or name == "label-block-data" or name == "label-block-srgb-data" or name == "mld-pv4-data" or name == "next-hop-set-l3vpn" or name == "pi-mi-pmsi-data" or name == "pi-ms-pmsi-data" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "sr-adj-segment-ipv4" or name == "sr-adj-segment-ipv6" or name == "sr-prefix-segment" or name == "te-binding" or name == "tev4-data" or name == "tev4p2mp-data" or name == "tp-data" or name == "vrf-l3vpn-data" or name == "label-context-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-context-type"):
                                        self.label_context_type = value
                                        self.label_context_type.value_namespace = name_space
                                        self.label_context_type.value_namespace_prefix = name_space_prefix


                            class LocalLabelRewrite(Entity):
                                """
                                Local label rewrite information
                                
                                .. attribute:: label_data
                                
                                	label data
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LocalLabelRewrite, self).__init__()

                                    self.yang_name = "local-label-rewrite"
                                    self.yang_parent_name = "rewrite-id"

                                    self.label_data = YLeafList(YType.uint32, "label-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_data") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)

                                def has_data(self):
                                    for leaf in self.label_data.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    return False

                                def has_operation(self):
                                    for leaf in self.label_data.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_data.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "local-label-rewrite" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    leaf_name_data.extend(self.label_data.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "label-data"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-data"):
                                        self.label_data.append(value)

                            def has_data(self):
                                return (
                                    self.rewrite_id_type.is_set or
                                    (self.label_context is not None and self.label_context.has_data()) or
                                    (self.local_label_rewrite is not None and self.local_label_rewrite.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rewrite_id_type.yfilter != YFilter.not_set or
                                    (self.label_context is not None and self.label_context.has_operation()) or
                                    (self.local_label_rewrite is not None and self.local_label_rewrite.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "rewrite-id" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rewrite_id_type.is_set or self.rewrite_id_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rewrite_id_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "label-context"):
                                    if (self.label_context is None):
                                        self.label_context = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext()
                                        self.label_context.parent = self
                                        self._children_name_map["label_context"] = "label-context"
                                    return self.label_context

                                if (child_yang_name == "local-label-rewrite"):
                                    if (self.local_label_rewrite is None):
                                        self.local_label_rewrite = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LocalLabelRewrite()
                                        self.local_label_rewrite.parent = self
                                        self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                                    return self.local_label_rewrite

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "label-context" or name == "local-label-rewrite" or name == "rewrite-id-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rewrite-id-type"):
                                    self.rewrite_id_type = value
                                    self.rewrite_id_type.value_namespace = name_space
                                    self.rewrite_id_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.rewrite_id is not None and self.rewrite_id.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rewrite-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "rewrite-id"):
                                if (self.rewrite_id is None):
                                    self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId()
                                    self.rewrite_id.parent = self
                                    self._children_name_map["rewrite_id"] = "rewrite-id"
                                return self.rewrite_id

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "rewrite-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class AssociatedFpi(Entity):
                        """
                        Associated FPI
                        
                        .. attribute:: application_owner
                        
                        	Application owner instance
                        	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.ApplicationOwner>`
                        
                        .. attribute:: fpi
                        
                        	FPI
                        	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi, self).__init__()

                            self.yang_name = "associated-fpi"
                            self.yang_parent_name = "rewrite-ipv4"

                            self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi()
                            self.fpi.parent = self
                            self._children_name_map["fpi"] = "fpi"
                            self._children_yang_names.add("fpi")

                            self.application_owner = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi, self).__setattr__(name, value)


                        class Fpi(Entity):
                            """
                            FPI
                            
                            .. attribute:: dmtc_ext_intf_data
                            
                            	dmtc ext intf data
                            	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.DmtcExtIntfData>`
                            
                            .. attribute:: fpi_type
                            
                            	FPIType
                            	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                            
                            .. attribute:: ipv4_data
                            
                            	ipv4 data
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv4Data>`
                            
                            .. attribute:: ipv6_data
                            
                            	ipv6 data
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv6Data>`
                            
                            .. attribute:: label_data
                            
                            	label data
                            	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.LabelData>`
                            
                            .. attribute:: pw_list_data
                            
                            	pw list data
                            	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.PwListData>`
                            
                            .. attribute:: te_data
                            
                            	te data
                            	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.TeData>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi, self).__init__()

                                self.yang_name = "fpi"
                                self.yang_parent_name = "associated-fpi"

                                self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                                self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.DmtcExtIntfData()
                                self.dmtc_ext_intf_data.parent = self
                                self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                self._children_yang_names.add("dmtc-ext-intf-data")

                                self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.LabelData()
                                self.label_data.parent = self
                                self._children_name_map["label_data"] = "label-data"
                                self._children_yang_names.add("label-data")

                                self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.PwListData()
                                self.pw_list_data.parent = self
                                self._children_name_map["pw_list_data"] = "pw-list-data"
                                self._children_yang_names.add("pw-list-data")

                                self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.TeData()
                                self.te_data.parent = self
                                self._children_name_map["te_data"] = "te-data"
                                self._children_yang_names.add("te-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fpi_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi, self).__setattr__(name, value)


                            class LabelData(Entity):
                                """
                                label data
                                
                                .. attribute:: elc
                                
                                	ELC
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: label
                                
                                	Label value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.LabelData, self).__init__()

                                    self.yang_name = "label-data"
                                    self.yang_parent_name = "fpi"

                                    self.elc = YLeaf(YType.int32, "elc")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("elc",
                                                    "label",
                                                    "security_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.elc.is_set or
                                        self.label.is_set or
                                        self.security_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.elc.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.elc.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "elc" or name == "label" or name == "security-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "elc"):
                                        self.elc = value
                                        self.elc.value_namespace = name_space
                                        self.elc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix


                            class TeData(Entity):
                                """
                                te data
                                
                                .. attribute:: local_label
                                
                                	Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_interface
                                
                                	Tunnel interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.TeData, self).__init__()

                                    self.yang_name = "te-data"
                                    self.yang_parent_name = "fpi"

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("local_label",
                                                    "tunnel_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.local_label.is_set or
                                        self.tunnel_interface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.tunnel_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "local-label" or name == "tunnel-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface"):
                                        self.tunnel_interface = value
                                        self.tunnel_interface.value_namespace = name_space
                                        self.tunnel_interface.value_namespace_prefix = name_space_prefix


                            class Ipv4Data(Entity):
                                """
                                ipv4 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: sr_local_label
                                
                                	SR related Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "sr_local_label",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.sr_local_label.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.sr_local_label.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sr-local-label"):
                                        self.sr_local_label = value
                                        self.sr_local_label.value_namespace = name_space
                                        self.sr_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                ipv6 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: router_flags
                                
                                	Route flags
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    self.router_flags = YLeaf(YType.uint32, "router-flags")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_len",
                                                    "router_flags",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_len.is_set or
                                        self.router_flags.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set or
                                        self.router_flags.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                    if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_flags.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-flags"):
                                        self.router_flags = value
                                        self.router_flags.value_namespace = name_space
                                        self.router_flags.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class PwListData(Entity):
                                """
                                pw list data
                                
                                .. attribute:: pwhe_list_id
                                
                                	Pseudowire List Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.PwListData, self).__init__()

                                    self.yang_name = "pw-list-data"
                                    self.yang_parent_name = "fpi"

                                    self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("pwhe_list_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.pwhe_list_id.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.pwhe_list_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pw-list-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "pwhe-list-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "pwhe-list-id"):
                                        self.pwhe_list_id = value
                                        self.pwhe_list_id.value_namespace = name_space
                                        self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                            class DmtcExtIntfData(Entity):
                                """
                                dmtc ext intf data
                                
                                .. attribute:: dmtc_ext_ifh
                                
                                	DMTC External Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.DmtcExtIntfData, self).__init__()

                                    self.yang_name = "dmtc-ext-intf-data"
                                    self.yang_parent_name = "fpi"

                                    self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.dmtc_ext_ifh.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "dmtc-ext-intf-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-ext-ifh"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dmtc-ext-ifh"):
                                        self.dmtc_ext_ifh = value
                                        self.dmtc_ext_ifh.value_namespace = name_space
                                        self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fpi_type.is_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.label_data is not None and self.label_data.has_data()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                    (self.te_data is not None and self.te_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fpi_type.yfilter != YFilter.not_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.label_data is not None and self.label_data.has_operation()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                    (self.te_data is not None and self.te_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fpi" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fpi_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "dmtc-ext-intf-data"):
                                    if (self.dmtc_ext_intf_data is None):
                                        self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.DmtcExtIntfData()
                                        self.dmtc_ext_intf_data.parent = self
                                        self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                    return self.dmtc_ext_intf_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "label-data"):
                                    if (self.label_data is None):
                                        self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.LabelData()
                                        self.label_data.parent = self
                                        self._children_name_map["label_data"] = "label-data"
                                    return self.label_data

                                if (child_yang_name == "pw-list-data"):
                                    if (self.pw_list_data is None):
                                        self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.PwListData()
                                        self.pw_list_data.parent = self
                                        self._children_name_map["pw_list_data"] = "pw-list-data"
                                    return self.pw_list_data

                                if (child_yang_name == "te-data"):
                                    if (self.te_data is None):
                                        self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.TeData()
                                        self.te_data.parent = self
                                        self._children_name_map["te_data"] = "te-data"
                                    return self.te_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fpi-type"):
                                    self.fpi_type = value
                                    self.fpi_type.value_namespace = name_space
                                    self.fpi_type.value_namespace_prefix = name_space_prefix


                        class ApplicationOwner(Entity):
                            """
                            Application owner instance
                            
                            .. attribute:: application_instance
                            
                            	Application instance Name
                            	**type**\:  str
                            
                            .. attribute:: application_name
                            
                            	Application name
                            	**type**\:  str
                            
                            .. attribute:: application_role_primary
                            
                            	Primary/Backup role
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: application_type
                            
                            	Application type
                            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                            
                            .. attribute:: resource_state
                            
                            	Application resource state
                            	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.ApplicationOwner, self).__init__()

                                self.yang_name = "application-owner"
                                self.yang_parent_name = "associated-fpi"

                                self.application_instance = YLeaf(YType.str, "application-instance")

                                self.application_name = YLeaf(YType.str, "application-name")

                                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                                self.application_type = YLeaf(YType.enumeration, "application-type")

                                self.resource_state = YLeaf(YType.enumeration, "resource-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("application_instance",
                                                "application_name",
                                                "application_role_primary",
                                                "application_type",
                                                "resource_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.application_instance.is_set or
                                    self.application_name.is_set or
                                    self.application_role_primary.is_set or
                                    self.application_type.is_set or
                                    self.resource_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.application_instance.yfilter != YFilter.not_set or
                                    self.application_name.yfilter != YFilter.not_set or
                                    self.application_role_primary.yfilter != YFilter.not_set or
                                    self.application_type.yfilter != YFilter.not_set or
                                    self.resource_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "application-owner" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_name.get_name_leafdata())
                                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_type.get_name_leafdata())
                                if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resource_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "application-instance"):
                                    self.application_instance = value
                                    self.application_instance.value_namespace = name_space
                                    self.application_instance.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-name"):
                                    self.application_name = value
                                    self.application_name.value_namespace = name_space
                                    self.application_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-role-primary"):
                                    self.application_role_primary = value
                                    self.application_role_primary.value_namespace = name_space
                                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-type"):
                                    self.application_type = value
                                    self.application_type.value_namespace = name_space
                                    self.application_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "resource-state"):
                                    self.resource_state = value
                                    self.resource_state.value_namespace = name_space
                                    self.resource_state.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.application_owner:
                                if (c.has_data()):
                                    return True
                            return (self.fpi is not None and self.fpi.has_data())

                        def has_operation(self):
                            for c in self.application_owner:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.fpi is not None and self.fpi.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "associated-fpi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "application-owner"):
                                for c in self.application_owner:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.ApplicationOwner()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.application_owner.append(c)
                                return c

                            if (child_yang_name == "fpi"):
                                if (self.fpi is None):
                                    self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi()
                                    self.fpi.parent = self
                                    self._children_name_map["fpi"] = "fpi"
                                return self.fpi

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-owner" or name == "fpi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class V4Rpf(Entity):
                        """
                        IPv4 RPF neighbors
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: v4_rpf_neighbor
                        
                        	V4 RPF Neighbor
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.V4Rpf, self).__init__()

                            self.yang_name = "v4-rpf"
                            self.yang_parent_name = "rewrite-ipv4"

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.v4_rpf_neighbor = YLeaf(YType.str, "v4-rpf-neighbor")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("table_id",
                                            "v4_rpf_neighbor") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.V4Rpf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.V4Rpf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.table_id.is_set or
                                self.v4_rpf_neighbor.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.v4_rpf_neighbor.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "v4-rpf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.v4_rpf_neighbor.is_set or self.v4_rpf_neighbor.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.v4_rpf_neighbor.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "table-id" or name == "v4-rpf-neighbor"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "v4-rpf-neighbor"):
                                self.v4_rpf_neighbor = value
                                self.v4_rpf_neighbor.value_namespace = name_space
                                self.v4_rpf_neighbor.value_namespace_prefix = name_space_prefix


                    class V6Rpf(Entity):
                        """
                        IPv6 RPF neighbors
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: v6_rpf_neighbor
                        
                        	V6 RPF Neighbor
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.V6Rpf, self).__init__()

                            self.yang_name = "v6-rpf"
                            self.yang_parent_name = "rewrite-ipv4"

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.v6_rpf_neighbor = YLeaf(YType.str, "v6-rpf-neighbor")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("table_id",
                                            "v6_rpf_neighbor") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.V6Rpf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.V6Rpf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.table_id.is_set or
                                self.v6_rpf_neighbor.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.v6_rpf_neighbor.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "v6-rpf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.v6_rpf_neighbor.is_set or self.v6_rpf_neighbor.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.v6_rpf_neighbor.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "table-id" or name == "v6-rpf-neighbor"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "v6-rpf-neighbor"):
                                self.v6_rpf_neighbor = value
                                self.v6_rpf_neighbor.value_namespace = name_space
                                self.v6_rpf_neighbor.value_namespace_prefix = name_space_prefix


                    class Mois(Entity):
                        """
                        Mois
                        
                        .. attribute:: application_resource
                        
                        	Application state
                        	**type**\:   :py:class:`ApplicationResource <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.ApplicationResource>`
                        
                        .. attribute:: moi_array
                        
                        	moi array
                        	**type**\: list of    :py:class:`MoiArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois, self).__init__()

                            self.yang_name = "mois"
                            self.yang_parent_name = "rewrite-ipv4"

                            self.application_resource = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.ApplicationResource()
                            self.application_resource.parent = self
                            self._children_name_map["application_resource"] = "application-resource"
                            self._children_yang_names.add("application-resource")

                            self.moi_array = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois, self).__setattr__(name, value)


                        class ApplicationResource(Entity):
                            """
                            Application state
                            
                            .. attribute:: application_instance
                            
                            	Application instance Name
                            	**type**\:  str
                            
                            .. attribute:: application_name
                            
                            	Application name
                            	**type**\:  str
                            
                            .. attribute:: application_role_primary
                            
                            	Primary/Backup role
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: application_type
                            
                            	Application type
                            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                            
                            .. attribute:: resource_state
                            
                            	Application resource state
                            	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.ApplicationResource, self).__init__()

                                self.yang_name = "application-resource"
                                self.yang_parent_name = "mois"

                                self.application_instance = YLeaf(YType.str, "application-instance")

                                self.application_name = YLeaf(YType.str, "application-name")

                                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                                self.application_type = YLeaf(YType.enumeration, "application-type")

                                self.resource_state = YLeaf(YType.enumeration, "resource-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("application_instance",
                                                "application_name",
                                                "application_role_primary",
                                                "application_type",
                                                "resource_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.ApplicationResource, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.ApplicationResource, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.application_instance.is_set or
                                    self.application_name.is_set or
                                    self.application_role_primary.is_set or
                                    self.application_type.is_set or
                                    self.resource_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.application_instance.yfilter != YFilter.not_set or
                                    self.application_name.yfilter != YFilter.not_set or
                                    self.application_role_primary.yfilter != YFilter.not_set or
                                    self.application_type.yfilter != YFilter.not_set or
                                    self.resource_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "application-resource" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_name.get_name_leafdata())
                                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_type.get_name_leafdata())
                                if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resource_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "application-instance"):
                                    self.application_instance = value
                                    self.application_instance.value_namespace = name_space
                                    self.application_instance.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-name"):
                                    self.application_name = value
                                    self.application_name.value_namespace = name_space
                                    self.application_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-role-primary"):
                                    self.application_role_primary = value
                                    self.application_role_primary.value_namespace = name_space
                                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-type"):
                                    self.application_type = value
                                    self.application_type.value_namespace = name_space
                                    self.application_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "resource-state"):
                                    self.resource_state = value
                                    self.resource_state.value_namespace = name_space
                                    self.resource_state.value_namespace_prefix = name_space_prefix


                        class MoiArray(Entity):
                            """
                            moi array
                            
                            .. attribute:: moi
                            
                            	Moi
                            	**type**\:   :py:class:`Moi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray, self).__init__()

                                self.yang_name = "moi-array"
                                self.yang_parent_name = "mois"

                                self.moi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi()
                                self.moi.parent = self
                                self._children_name_map["moi"] = "moi"
                                self._children_yang_names.add("moi")


                            class Moi(Entity):
                                """
                                Moi
                                
                                .. attribute:: dmtc_data
                                
                                	dmtc data
                                	**type**\:   :py:class:`DmtcData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.DmtcData>`
                                
                                .. attribute:: ip_sub_data
                                
                                	ip sub data
                                	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.IpSubData>`
                                
                                .. attribute:: ipv4_data
                                
                                	ipv4 data
                                	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv4Data>`
                                
                                .. attribute:: ipv6_data
                                
                                	ipv6 data
                                	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv6Data>`
                                
                                .. attribute:: moi_type
                                
                                	MoiType
                                	**type**\:   :py:class:`MgmtLsdMoi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdMoi>`
                                
                                .. attribute:: pop_and_lookup_ipv4
                                
                                	pop and lookup ipv4
                                	**type**\:   :py:class:`PopAndLookupIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv4>`
                                
                                .. attribute:: pop_and_lookup_ipv6
                                
                                	pop and lookup ipv6
                                	**type**\:   :py:class:`PopAndLookupIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv6>`
                                
                                .. attribute:: pop_and_lookup_tp
                                
                                	pop and lookup tp
                                	**type**\:   :py:class:`PopAndLookupTp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupTp>`
                                
                                .. attribute:: pseudowire_data
                                
                                	pseudowire data
                                	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireData>`
                                
                                .. attribute:: pseudowire_head_end_data
                                
                                	pseudowire head end data
                                	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireHeadEndData>`
                                
                                .. attribute:: pw_list_data
                                
                                	pw list data
                                	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PwListData>`
                                
                                .. attribute:: stackv4_data
                                
                                	stackv4 data
                                	**type**\:   :py:class:`Stackv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data>`
                                
                                .. attribute:: stackv6_data
                                
                                	stackv6 data
                                	**type**\:   :py:class:`Stackv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data>`
                                
                                .. attribute:: te_head_data
                                
                                	te head data
                                	**type**\:   :py:class:`TeHeadData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.TeHeadData>`
                                
                                .. attribute:: tev4_data
                                
                                	tev4 data
                                	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Tev4Data>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi, self).__init__()

                                    self.yang_name = "moi"
                                    self.yang_parent_name = "moi-array"

                                    self.moi_type = YLeaf(YType.enumeration, "moi-type")

                                    self.dmtc_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.DmtcData()
                                    self.dmtc_data.parent = self
                                    self._children_name_map["dmtc_data"] = "dmtc-data"
                                    self._children_yang_names.add("dmtc-data")

                                    self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.IpSubData()
                                    self.ip_sub_data.parent = self
                                    self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    self._children_yang_names.add("ip-sub-data")

                                    self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                    self._children_yang_names.add("ipv4-data")

                                    self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                    self._children_yang_names.add("ipv6-data")

                                    self.pop_and_lookup_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                    self.pop_and_lookup_ipv4.parent = self
                                    self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                    self._children_yang_names.add("pop-and-lookup-ipv4")

                                    self.pop_and_lookup_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                    self.pop_and_lookup_ipv6.parent = self
                                    self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                    self._children_yang_names.add("pop-and-lookup-ipv6")

                                    self.pop_and_lookup_tp = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupTp()
                                    self.pop_and_lookup_tp.parent = self
                                    self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                    self._children_yang_names.add("pop-and-lookup-tp")

                                    self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireData()
                                    self.pseudowire_data.parent = self
                                    self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    self._children_yang_names.add("pseudowire-data")

                                    self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                    self.pseudowire_head_end_data.parent = self
                                    self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    self._children_yang_names.add("pseudowire-head-end-data")

                                    self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PwListData()
                                    self.pw_list_data.parent = self
                                    self._children_name_map["pw_list_data"] = "pw-list-data"
                                    self._children_yang_names.add("pw-list-data")

                                    self.stackv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data()
                                    self.stackv4_data.parent = self
                                    self._children_name_map["stackv4_data"] = "stackv4-data"
                                    self._children_yang_names.add("stackv4-data")

                                    self.stackv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data()
                                    self.stackv6_data.parent = self
                                    self._children_name_map["stackv6_data"] = "stackv6-data"
                                    self._children_yang_names.add("stackv6-data")

                                    self.te_head_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.TeHeadData()
                                    self.te_head_data.parent = self
                                    self._children_name_map["te_head_data"] = "te-head-data"
                                    self._children_yang_names.add("te-head-data")

                                    self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Tev4Data()
                                    self.tev4_data.parent = self
                                    self._children_name_map["tev4_data"] = "tev4-data"
                                    self._children_yang_names.add("tev4-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("moi_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi, self).__setattr__(name, value)


                                class PopAndLookupIpv4(Entity):
                                    """
                                    pop and lookup ipv4
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__init__()

                                        self.yang_name = "pop-and-lookup-ipv4"
                                        self.yang_parent_name = "moi"

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pop-and-lookup-ipv4" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class PopAndLookupTp(Entity):
                                    """
                                    pop and lookup tp
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupTp, self).__init__()

                                        self.yang_name = "pop-and-lookup-tp"
                                        self.yang_parent_name = "moi"

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("out_label",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.out_label.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pop-and-lookup-tp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "out-label" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class PopAndLookupIpv6(Entity):
                                    """
                                    pop and lookup ipv6
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__init__()

                                        self.yang_name = "pop-and-lookup-ipv6"
                                        self.yang_parent_name = "moi"

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pop-and-lookup-ipv6" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class Ipv4Data(Entity):
                                    """
                                    ipv4 data
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: load_metric
                                    
                                    	Routing path's load metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: local_label
                                    
                                    	TE backup path local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_interface_parent
                                    
                                    	Outgoing Interface's parent
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv4Data, self).__init__()

                                        self.yang_name = "ipv4-data"
                                        self.yang_parent_name = "moi"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.load_metric = YLeaf(YType.uint32, "load-metric")

                                        self.local_label = YLeaf(YType.uint32, "local-label")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv4_next_hop",
                                                        "load_metric",
                                                        "local_label",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_interface_parent",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.load_metric.is_set or
                                            self.local_label.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_interface_parent.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.load_metric.yfilter != YFilter.not_set or
                                            self.local_label.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_interface_parent.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_metric.get_name_leafdata())
                                        if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_label.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-metric"):
                                            self.load_metric = value
                                            self.load_metric.value_namespace = name_space
                                            self.load_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-label"):
                                            self.local_label = value
                                            self.local_label.value_namespace = name_space
                                            self.local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface-parent"):
                                            self.out_interface_parent = value
                                            self.out_interface_parent.value_namespace = name_space
                                            self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix


                                class Ipv6Data(Entity):
                                    """
                                    ipv6 data
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv6_next_hop
                                    
                                    	IPv6 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv6Data, self).__init__()

                                        self.yang_name = "ipv6-data"
                                        self.yang_parent_name = "moi"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv6_next_hop",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv6_next_hop.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv6_next_hop.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6-next-hop"):
                                            self.ipv6_next_hop = value
                                            self.ipv6_next_hop.value_namespace = name_space
                                            self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class Tev4Data(Entity):
                                    """
                                    tev4 data
                                    
                                    .. attribute:: backup_interface
                                    
                                    	Backup interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: backup_ipv4_next_hop
                                    
                                    	Backup IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: backup_local_label
                                    
                                    	Backup local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: data_out_parent_interface
                                    
                                    	Outgoing data parent interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: merge_point_label
                                    
                                    	Merge point label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_class
                                    
                                    	Tunnel class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_interface
                                    
                                    	Tunnel interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: tunnel_weight
                                    
                                    	Tunnel weight
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Tev4Data, self).__init__()

                                        self.yang_name = "tev4-data"
                                        self.yang_parent_name = "moi"

                                        self.backup_interface = YLeaf(YType.str, "backup-interface")

                                        self.backup_ipv4_next_hop = YLeaf(YType.str, "backup-ipv4-next-hop")

                                        self.backup_local_label = YLeaf(YType.uint32, "backup-local-label")

                                        self.data_out_parent_interface = YLeaf(YType.str, "data-out-parent-interface")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.merge_point_label = YLeaf(YType.uint32, "merge-point-label")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_class = YLeaf(YType.uint32, "tunnel-class")

                                        self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                        self.tunnel_weight = YLeaf(YType.uint32, "tunnel-weight")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_interface",
                                                        "backup_ipv4_next_hop",
                                                        "backup_local_label",
                                                        "data_out_parent_interface",
                                                        "ipv4_next_hop",
                                                        "merge_point_label",
                                                        "out_interface",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_class",
                                                        "tunnel_interface",
                                                        "tunnel_weight") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_interface.is_set or
                                            self.backup_ipv4_next_hop.is_set or
                                            self.backup_local_label.is_set or
                                            self.data_out_parent_interface.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.merge_point_label.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_class.is_set or
                                            self.tunnel_interface.is_set or
                                            self.tunnel_weight.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_interface.yfilter != YFilter.not_set or
                                            self.backup_ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.backup_local_label.yfilter != YFilter.not_set or
                                            self.data_out_parent_interface.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.merge_point_label.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_class.yfilter != YFilter.not_set or
                                            self.tunnel_interface.yfilter != YFilter.not_set or
                                            self.tunnel_weight.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tev4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_interface.is_set or self.backup_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_interface.get_name_leafdata())
                                        if (self.backup_ipv4_next_hop.is_set or self.backup_ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_ipv4_next_hop.get_name_leafdata())
                                        if (self.backup_local_label.is_set or self.backup_local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_local_label.get_name_leafdata())
                                        if (self.data_out_parent_interface.is_set or self.data_out_parent_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.data_out_parent_interface.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.merge_point_label.is_set or self.merge_point_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.merge_point_label.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_class.is_set or self.tunnel_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_class.get_name_leafdata())
                                        if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_interface.get_name_leafdata())
                                        if (self.tunnel_weight.is_set or self.tunnel_weight.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_weight.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-interface" or name == "backup-ipv4-next-hop" or name == "backup-local-label" or name == "data-out-parent-interface" or name == "ipv4-next-hop" or name == "merge-point-label" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-class" or name == "tunnel-interface" or name == "tunnel-weight"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-interface"):
                                            self.backup_interface = value
                                            self.backup_interface.value_namespace = name_space
                                            self.backup_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-ipv4-next-hop"):
                                            self.backup_ipv4_next_hop = value
                                            self.backup_ipv4_next_hop.value_namespace = name_space
                                            self.backup_ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-local-label"):
                                            self.backup_local_label = value
                                            self.backup_local_label.value_namespace = name_space
                                            self.backup_local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "data-out-parent-interface"):
                                            self.data_out_parent_interface = value
                                            self.data_out_parent_interface.value_namespace = name_space
                                            self.data_out_parent_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "merge-point-label"):
                                            self.merge_point_label = value
                                            self.merge_point_label.value_namespace = name_space
                                            self.merge_point_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-class"):
                                            self.tunnel_class = value
                                            self.tunnel_class.value_namespace = name_space
                                            self.tunnel_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-interface"):
                                            self.tunnel_interface = value
                                            self.tunnel_interface.value_namespace = name_space
                                            self.tunnel_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-weight"):
                                            self.tunnel_weight = value
                                            self.tunnel_weight.value_namespace = name_space
                                            self.tunnel_weight.value_namespace_prefix = name_space_prefix


                                class PseudowireData(Entity):
                                    """
                                    pseudowire data
                                    
                                    .. attribute:: bridge_id
                                    
                                    	Bridge ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: cross_connect_id
                                    
                                    	Cross\-connect ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: pseuodo_wire_connect_id
                                    
                                    	PseudoWire Cross\-connect ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: split_horizon_id
                                    
                                    	Split horizon group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireData, self).__init__()

                                        self.yang_name = "pseudowire-data"
                                        self.yang_parent_name = "moi"

                                        self.bridge_id = YLeaf(YType.uint32, "bridge-id")

                                        self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.pseuodo_wire_connect_id = YLeaf(YType.uint32, "pseuodo-wire-connect-id")

                                        self.split_horizon_id = YLeaf(YType.uint32, "split-horizon-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bridge_id",
                                                        "cross_connect_id",
                                                        "ipv4_next_hop",
                                                        "out_interface",
                                                        "out_label",
                                                        "path_flags_decode",
                                                        "pseuodo_wire_connect_id",
                                                        "split_horizon_id",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.bridge_id.is_set or
                                            self.cross_connect_id.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.path_flags_decode.is_set or
                                            self.pseuodo_wire_connect_id.is_set or
                                            self.split_horizon_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bridge_id.yfilter != YFilter.not_set or
                                            self.cross_connect_id.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.pseuodo_wire_connect_id.yfilter != YFilter.not_set or
                                            self.split_horizon_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bridge_id.is_set or self.bridge_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bridge_id.get_name_leafdata())
                                        if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.pseuodo_wire_connect_id.is_set or self.pseuodo_wire_connect_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pseuodo_wire_connect_id.get_name_leafdata())
                                        if (self.split_horizon_id.is_set or self.split_horizon_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.split_horizon_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bridge-id" or name == "cross-connect-id" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pseuodo-wire-connect-id" or name == "split-horizon-id" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bridge-id"):
                                            self.bridge_id = value
                                            self.bridge_id.value_namespace = name_space
                                            self.bridge_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cross-connect-id"):
                                            self.cross_connect_id = value
                                            self.cross_connect_id.value_namespace = name_space
                                            self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pseuodo-wire-connect-id"):
                                            self.pseuodo_wire_connect_id = value
                                            self.pseuodo_wire_connect_id.value_namespace = name_space
                                            self.pseuodo_wire_connect_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "split-horizon-id"):
                                            self.split_horizon_id = value
                                            self.split_horizon_id.value_namespace = name_space
                                            self.split_horizon_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class IpSubData(Entity):
                                    """
                                    ip sub data
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	VRF table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.IpSubData, self).__init__()

                                        self.yang_name = "ip-sub-data"
                                        self.yang_parent_name = "moi"

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("out_interface",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.out_interface.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ip-sub-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "out-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class PseudowireHeadEndData(Entity):
                                    """
                                    pseudowire head end data
                                    
                                    .. attribute:: control_word
                                    
                                    	Is control word present
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: imposition
                                    
                                    	Is PWHE IMposition
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: pw_list_id
                                    
                                    	Pseudo\-wire List Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: pwhe_interface
                                    
                                    	Pseudo\-wire Head\-end interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: vctype
                                    
                                    	Virtual Circuit Type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__init__()

                                        self.yang_name = "pseudowire-head-end-data"
                                        self.yang_parent_name = "moi"

                                        self.control_word = YLeaf(YType.int32, "control-word")

                                        self.imposition = YLeaf(YType.int32, "imposition")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.pw_list_id = YLeaf(YType.uint16, "pw-list-id")

                                        self.pwhe_interface = YLeaf(YType.str, "pwhe-interface")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.vctype = YLeaf(YType.uint8, "vctype")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("control_word",
                                                        "imposition",
                                                        "ipv4_next_hop",
                                                        "out_interface",
                                                        "out_label",
                                                        "path_flags_decode",
                                                        "pw_list_id",
                                                        "pwhe_interface",
                                                        "table_id",
                                                        "table_name",
                                                        "vctype") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.control_word.is_set or
                                            self.imposition.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.path_flags_decode.is_set or
                                            self.pw_list_id.is_set or
                                            self.pwhe_interface.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.vctype.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.control_word.yfilter != YFilter.not_set or
                                            self.imposition.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.pw_list_id.yfilter != YFilter.not_set or
                                            self.pwhe_interface.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.vctype.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-head-end-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.control_word.is_set or self.control_word.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.control_word.get_name_leafdata())
                                        if (self.imposition.is_set or self.imposition.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.imposition.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.pw_list_id.is_set or self.pw_list_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pw_list_id.get_name_leafdata())
                                        if (self.pwhe_interface.is_set or self.pwhe_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pwhe_interface.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.vctype.is_set or self.vctype.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vctype.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "control-word" or name == "imposition" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pw-list-id" or name == "pwhe-interface" or name == "table-id" or name == "table-name" or name == "vctype"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "control-word"):
                                            self.control_word = value
                                            self.control_word.value_namespace = name_space
                                            self.control_word.value_namespace_prefix = name_space_prefix
                                        if(value_path == "imposition"):
                                            self.imposition = value
                                            self.imposition.value_namespace = name_space
                                            self.imposition.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pw-list-id"):
                                            self.pw_list_id = value
                                            self.pw_list_id.value_namespace = name_space
                                            self.pw_list_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pwhe-interface"):
                                            self.pwhe_interface = value
                                            self.pwhe_interface.value_namespace = name_space
                                            self.pwhe_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vctype"):
                                            self.vctype = value
                                            self.vctype.value_namespace = name_space
                                            self.vctype.value_namespace_prefix = name_space_prefix


                                class PwListData(Entity):
                                    """
                                    pw list data
                                    
                                    .. attribute:: l2_interface
                                    
                                    	Pseudo\-wire Layer 2 interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: l3_interface
                                    
                                    	Pseudo\-wire Layer 3 interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PwListData, self).__init__()

                                        self.yang_name = "pw-list-data"
                                        self.yang_parent_name = "moi"

                                        self.l2_interface = YLeaf(YType.str, "l2-interface")

                                        self.l3_interface = YLeaf(YType.str, "l3-interface")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("l2_interface",
                                                        "l3_interface",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.l2_interface.is_set or
                                            self.l3_interface.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.l2_interface.yfilter != YFilter.not_set or
                                            self.l3_interface.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pw-list-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.l2_interface.is_set or self.l2_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.l2_interface.get_name_leafdata())
                                        if (self.l3_interface.is_set or self.l3_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.l3_interface.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "l2-interface" or name == "l3-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "l2-interface"):
                                            self.l2_interface = value
                                            self.l2_interface.value_namespace = name_space
                                            self.l2_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "l3-interface"):
                                            self.l3_interface = value
                                            self.l3_interface.value_namespace = name_space
                                            self.l3_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class Stackv4Data(Entity):
                                    """
                                    stackv4 data
                                    
                                    .. attribute:: inner_stack
                                    
                                    	Inner stack
                                    	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Nexthop
                                    	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.Nexthop>`
                                    
                                    .. attribute:: owner_application_type
                                    
                                    	Owner application type
                                    	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data, self).__init__()

                                        self.yang_name = "stackv4-data"
                                        self.yang_parent_name = "moi"

                                        self.owner_application_type = YLeaf(YType.enumeration, "owner-application-type")

                                        self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                        self.inner_stack.parent = self
                                        self._children_name_map["inner_stack"] = "inner-stack"
                                        self._children_yang_names.add("inner-stack")

                                        self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                        self.nexthop.parent = self
                                        self._children_name_map["nexthop"] = "nexthop"
                                        self._children_yang_names.add("nexthop")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("owner_application_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)


                                    class Nexthop(Entity):
                                        """
                                        Nexthop
                                        
                                        .. attribute:: backup_path_id
                                        
                                        	Routing path backup id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4_next_hop
                                        
                                        	IPv4 nexthop
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: load_metric
                                        
                                        	Routing path's load metric
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: local_label
                                        
                                        	TE backup path local label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: next_hop_id
                                        
                                        	Next hop ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_interface
                                        
                                        	Outgoing Interface
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: out_interface_parent
                                        
                                        	Outgoing Interface's parent
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: out_label
                                        
                                        	Outgoing Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_label_name
                                        
                                        	Outgoing label name
                                        	**type**\:  str
                                        
                                        .. attribute:: path_flags_decode
                                        
                                        	Path flag decoded string
                                        	**type**\:  str
                                        
                                        .. attribute:: path_id
                                        
                                        	Routing path id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: table_id
                                        
                                        	Table ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: table_name
                                        
                                        	VRF table name
                                        	**type**\:  str
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__init__()

                                            self.yang_name = "nexthop"
                                            self.yang_parent_name = "stackv4-data"

                                            self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                            self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                            self.load_metric = YLeaf(YType.uint32, "load-metric")

                                            self.local_label = YLeaf(YType.uint32, "local-label")

                                            self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                            self.out_interface = YLeaf(YType.str, "out-interface")

                                            self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                            self.out_label = YLeaf(YType.uint32, "out-label")

                                            self.out_label_name = YLeaf(YType.str, "out-label-name")

                                            self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                            self.path_id = YLeaf(YType.uint8, "path-id")

                                            self.table_id = YLeaf(YType.uint32, "table-id")

                                            self.table_name = YLeaf(YType.str, "table-name")

                                            self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("backup_path_id",
                                                            "ipv4_next_hop",
                                                            "load_metric",
                                                            "local_label",
                                                            "next_hop_id",
                                                            "out_interface",
                                                            "out_interface_parent",
                                                            "out_label",
                                                            "out_label_name",
                                                            "path_flags_decode",
                                                            "path_id",
                                                            "table_id",
                                                            "table_name",
                                                            "tunnel_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.backup_path_id.is_set or
                                                self.ipv4_next_hop.is_set or
                                                self.load_metric.is_set or
                                                self.local_label.is_set or
                                                self.next_hop_id.is_set or
                                                self.out_interface.is_set or
                                                self.out_interface_parent.is_set or
                                                self.out_label.is_set or
                                                self.out_label_name.is_set or
                                                self.path_flags_decode.is_set or
                                                self.path_id.is_set or
                                                self.table_id.is_set or
                                                self.table_name.is_set or
                                                self.tunnel_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.backup_path_id.yfilter != YFilter.not_set or
                                                self.ipv4_next_hop.yfilter != YFilter.not_set or
                                                self.load_metric.yfilter != YFilter.not_set or
                                                self.local_label.yfilter != YFilter.not_set or
                                                self.next_hop_id.yfilter != YFilter.not_set or
                                                self.out_interface.yfilter != YFilter.not_set or
                                                self.out_interface_parent.yfilter != YFilter.not_set or
                                                self.out_label.yfilter != YFilter.not_set or
                                                self.out_label_name.yfilter != YFilter.not_set or
                                                self.path_flags_decode.yfilter != YFilter.not_set or
                                                self.path_id.yfilter != YFilter.not_set or
                                                self.table_id.yfilter != YFilter.not_set or
                                                self.table_name.yfilter != YFilter.not_set or
                                                self.tunnel_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nexthop" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                            if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                            if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_metric.get_name_leafdata())
                                            if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_label.get_name_leafdata())
                                            if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                            if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_interface.get_name_leafdata())
                                            if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label.get_name_leafdata())
                                            if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                            if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                            if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_id.get_name_leafdata())
                                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_id.get_name_leafdata())
                                            if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_name.get_name_leafdata())
                                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "backup-path-id"):
                                                self.backup_path_id = value
                                                self.backup_path_id.value_namespace = name_space
                                                self.backup_path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4-next-hop"):
                                                self.ipv4_next_hop = value
                                                self.ipv4_next_hop.value_namespace = name_space
                                                self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-metric"):
                                                self.load_metric = value
                                                self.load_metric.value_namespace = name_space
                                                self.load_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-label"):
                                                self.local_label = value
                                                self.local_label.value_namespace = name_space
                                                self.local_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hop-id"):
                                                self.next_hop_id = value
                                                self.next_hop_id.value_namespace = name_space
                                                self.next_hop_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-interface"):
                                                self.out_interface = value
                                                self.out_interface.value_namespace = name_space
                                                self.out_interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-interface-parent"):
                                                self.out_interface_parent = value
                                                self.out_interface_parent.value_namespace = name_space
                                                self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label"):
                                                self.out_label = value
                                                self.out_label.value_namespace = name_space
                                                self.out_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label-name"):
                                                self.out_label_name = value
                                                self.out_label_name.value_namespace = name_space
                                                self.out_label_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-flags-decode"):
                                                self.path_flags_decode = value
                                                self.path_flags_decode.value_namespace = name_space
                                                self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-id"):
                                                self.path_id = value
                                                self.path_id.value_namespace = name_space
                                                self.path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-id"):
                                                self.table_id = value
                                                self.table_id.value_namespace = name_space
                                                self.table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-name"):
                                                self.table_name = value
                                                self.table_name.value_namespace = name_space
                                                self.table_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tunnel-id"):
                                                self.tunnel_id = value
                                                self.tunnel_id.value_namespace = name_space
                                                self.tunnel_id.value_namespace_prefix = name_space_prefix


                                    class InnerStack(Entity):
                                        """
                                        Inner stack
                                        
                                        .. attribute:: label
                                        
                                        	Info related to outgoing labels
                                        	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label>`
                                        
                                        .. attribute:: nexthop
                                        
                                        	Remote nexthop addresses
                                        	**type**\:  list of str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: num_lbls
                                        
                                        	Depth of inner label stack
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: num_nexthops
                                        
                                        	Number of remote nexthop addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__init__()

                                            self.yang_name = "inner-stack"
                                            self.yang_parent_name = "stackv4-data"

                                            self.nexthop = YLeafList(YType.str, "nexthop")

                                            self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                            self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                            self.label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("nexthop",
                                                            "num_lbls",
                                                            "num_nexthops") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)


                                        class Label(Entity):
                                            """
                                            Info related to outgoing labels
                                            
                                            .. attribute:: outgoing_label
                                            
                                            	Remote Label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: outgoing_label_str
                                            
                                            	Remote Label string
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-lsd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__init__()

                                                self.yang_name = "label"
                                                self.yang_parent_name = "inner-stack"

                                                self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                                self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("outgoing_label",
                                                                "outgoing_label_str") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.outgoing_label.is_set or
                                                    self.outgoing_label_str.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.outgoing_label.yfilter != YFilter.not_set or
                                                    self.outgoing_label_str.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                                if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "outgoing-label"):
                                                    self.outgoing_label = value
                                                    self.outgoing_label.value_namespace = name_space
                                                    self.outgoing_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "outgoing-label-str"):
                                                    self.outgoing_label_str = value
                                                    self.outgoing_label_str.value_namespace = name_space
                                                    self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.label:
                                                if (c.has_data()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            return (
                                                self.num_lbls.is_set or
                                                self.num_nexthops.is_set)

                                        def has_operation(self):
                                            for c in self.label:
                                                if (c.has_operation()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.nexthop.yfilter != YFilter.not_set or
                                                self.num_lbls.yfilter != YFilter.not_set or
                                                self.num_nexthops.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "inner-stack" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                            if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                            leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "label"):
                                                for c in self.label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "nexthop"):
                                                self.nexthop.append(value)
                                            if(value_path == "num-lbls"):
                                                self.num_lbls = value
                                                self.num_lbls.value_namespace = name_space
                                                self.num_lbls.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-nexthops"):
                                                self.num_nexthops = value
                                                self.num_nexthops.value_namespace = name_space
                                                self.num_nexthops.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.owner_application_type.is_set or
                                            (self.inner_stack is not None and self.inner_stack.has_data()) or
                                            (self.nexthop is not None and self.nexthop.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.owner_application_type.yfilter != YFilter.not_set or
                                            (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                            (self.nexthop is not None and self.nexthop.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stackv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.owner_application_type.is_set or self.owner_application_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.owner_application_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "inner-stack"):
                                            if (self.inner_stack is None):
                                                self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                                self.inner_stack.parent = self
                                                self._children_name_map["inner_stack"] = "inner-stack"
                                            return self.inner_stack

                                        if (child_yang_name == "nexthop"):
                                            if (self.nexthop is None):
                                                self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                                self.nexthop.parent = self
                                                self._children_name_map["nexthop"] = "nexthop"
                                            return self.nexthop

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "inner-stack" or name == "nexthop" or name == "owner-application-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "owner-application-type"):
                                            self.owner_application_type = value
                                            self.owner_application_type.value_namespace = name_space
                                            self.owner_application_type.value_namespace_prefix = name_space_prefix


                                class Stackv6Data(Entity):
                                    """
                                    stackv6 data
                                    
                                    .. attribute:: inner_stack
                                    
                                    	Inner stack
                                    	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Nexthop
                                    	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.Nexthop>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data, self).__init__()

                                        self.yang_name = "stackv6-data"
                                        self.yang_parent_name = "moi"

                                        self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                        self.inner_stack.parent = self
                                        self._children_name_map["inner_stack"] = "inner-stack"
                                        self._children_yang_names.add("inner-stack")

                                        self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                        self.nexthop.parent = self
                                        self._children_name_map["nexthop"] = "nexthop"
                                        self._children_yang_names.add("nexthop")


                                    class Nexthop(Entity):
                                        """
                                        Nexthop
                                        
                                        .. attribute:: backup_path_id
                                        
                                        	Routing path backup id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv6_next_hop
                                        
                                        	IPv6 nexthop
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: next_hop_id
                                        
                                        	Next hop ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_interface
                                        
                                        	Outgoing interface
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: out_label
                                        
                                        	Outgoing label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_label_name
                                        
                                        	Outgoing label name
                                        	**type**\:  str
                                        
                                        .. attribute:: path_flags_decode
                                        
                                        	Path flag decoded string
                                        	**type**\:  str
                                        
                                        .. attribute:: path_id
                                        
                                        	Routing path id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: table_id
                                        
                                        	Table ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: table_name
                                        
                                        	VRF table name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__init__()

                                            self.yang_name = "nexthop"
                                            self.yang_parent_name = "stackv6-data"

                                            self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                            self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                            self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                            self.out_interface = YLeaf(YType.str, "out-interface")

                                            self.out_label = YLeaf(YType.uint32, "out-label")

                                            self.out_label_name = YLeaf(YType.str, "out-label-name")

                                            self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                            self.path_id = YLeaf(YType.uint8, "path-id")

                                            self.table_id = YLeaf(YType.uint32, "table-id")

                                            self.table_name = YLeaf(YType.str, "table-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("backup_path_id",
                                                            "ipv6_next_hop",
                                                            "next_hop_id",
                                                            "out_interface",
                                                            "out_label",
                                                            "out_label_name",
                                                            "path_flags_decode",
                                                            "path_id",
                                                            "table_id",
                                                            "table_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.backup_path_id.is_set or
                                                self.ipv6_next_hop.is_set or
                                                self.next_hop_id.is_set or
                                                self.out_interface.is_set or
                                                self.out_label.is_set or
                                                self.out_label_name.is_set or
                                                self.path_flags_decode.is_set or
                                                self.path_id.is_set or
                                                self.table_id.is_set or
                                                self.table_name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.backup_path_id.yfilter != YFilter.not_set or
                                                self.ipv6_next_hop.yfilter != YFilter.not_set or
                                                self.next_hop_id.yfilter != YFilter.not_set or
                                                self.out_interface.yfilter != YFilter.not_set or
                                                self.out_label.yfilter != YFilter.not_set or
                                                self.out_label_name.yfilter != YFilter.not_set or
                                                self.path_flags_decode.yfilter != YFilter.not_set or
                                                self.path_id.yfilter != YFilter.not_set or
                                                self.table_id.yfilter != YFilter.not_set or
                                                self.table_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nexthop" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                            if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                            if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                            if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_interface.get_name_leafdata())
                                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label.get_name_leafdata())
                                            if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                            if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                            if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_id.get_name_leafdata())
                                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_id.get_name_leafdata())
                                            if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "backup-path-id"):
                                                self.backup_path_id = value
                                                self.backup_path_id.value_namespace = name_space
                                                self.backup_path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6-next-hop"):
                                                self.ipv6_next_hop = value
                                                self.ipv6_next_hop.value_namespace = name_space
                                                self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hop-id"):
                                                self.next_hop_id = value
                                                self.next_hop_id.value_namespace = name_space
                                                self.next_hop_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-interface"):
                                                self.out_interface = value
                                                self.out_interface.value_namespace = name_space
                                                self.out_interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label"):
                                                self.out_label = value
                                                self.out_label.value_namespace = name_space
                                                self.out_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label-name"):
                                                self.out_label_name = value
                                                self.out_label_name.value_namespace = name_space
                                                self.out_label_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-flags-decode"):
                                                self.path_flags_decode = value
                                                self.path_flags_decode.value_namespace = name_space
                                                self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-id"):
                                                self.path_id = value
                                                self.path_id.value_namespace = name_space
                                                self.path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-id"):
                                                self.table_id = value
                                                self.table_id.value_namespace = name_space
                                                self.table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-name"):
                                                self.table_name = value
                                                self.table_name.value_namespace = name_space
                                                self.table_name.value_namespace_prefix = name_space_prefix


                                    class InnerStack(Entity):
                                        """
                                        Inner stack
                                        
                                        .. attribute:: label
                                        
                                        	Info related to outgoing labels
                                        	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label>`
                                        
                                        .. attribute:: nexthop
                                        
                                        	Remote nexthop addresses
                                        	**type**\:  list of str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: num_lbls
                                        
                                        	Depth of inner label stack
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: num_nexthops
                                        
                                        	Number of remote nexthop addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__init__()

                                            self.yang_name = "inner-stack"
                                            self.yang_parent_name = "stackv6-data"

                                            self.nexthop = YLeafList(YType.str, "nexthop")

                                            self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                            self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                            self.label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("nexthop",
                                                            "num_lbls",
                                                            "num_nexthops") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)


                                        class Label(Entity):
                                            """
                                            Info related to outgoing labels
                                            
                                            .. attribute:: outgoing_label
                                            
                                            	Remote Label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: outgoing_label_str
                                            
                                            	Remote Label string
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-lsd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__init__()

                                                self.yang_name = "label"
                                                self.yang_parent_name = "inner-stack"

                                                self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                                self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("outgoing_label",
                                                                "outgoing_label_str") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.outgoing_label.is_set or
                                                    self.outgoing_label_str.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.outgoing_label.yfilter != YFilter.not_set or
                                                    self.outgoing_label_str.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                                if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "outgoing-label"):
                                                    self.outgoing_label = value
                                                    self.outgoing_label.value_namespace = name_space
                                                    self.outgoing_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "outgoing-label-str"):
                                                    self.outgoing_label_str = value
                                                    self.outgoing_label_str.value_namespace = name_space
                                                    self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.label:
                                                if (c.has_data()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            return (
                                                self.num_lbls.is_set or
                                                self.num_nexthops.is_set)

                                        def has_operation(self):
                                            for c in self.label:
                                                if (c.has_operation()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.nexthop.yfilter != YFilter.not_set or
                                                self.num_lbls.yfilter != YFilter.not_set or
                                                self.num_nexthops.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "inner-stack" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                            if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                            leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "label"):
                                                for c in self.label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "nexthop"):
                                                self.nexthop.append(value)
                                            if(value_path == "num-lbls"):
                                                self.num_lbls = value
                                                self.num_lbls.value_namespace = name_space
                                                self.num_lbls.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-nexthops"):
                                                self.num_nexthops = value
                                                self.num_nexthops.value_namespace = name_space
                                                self.num_nexthops.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.inner_stack is not None and self.inner_stack.has_data()) or
                                            (self.nexthop is not None and self.nexthop.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                            (self.nexthop is not None and self.nexthop.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stackv6-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "inner-stack"):
                                            if (self.inner_stack is None):
                                                self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                                self.inner_stack.parent = self
                                                self._children_name_map["inner_stack"] = "inner-stack"
                                            return self.inner_stack

                                        if (child_yang_name == "nexthop"):
                                            if (self.nexthop is None):
                                                self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                                self.nexthop.parent = self
                                                self._children_name_map["nexthop"] = "nexthop"
                                            return self.nexthop

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "inner-stack" or name == "nexthop"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class TeHeadData(Entity):
                                    """
                                    te head data
                                    
                                    .. attribute:: flags_decode
                                    
                                    	Flags decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_fwd_class
                                    
                                    	Tunnel forwarding class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_load_metric
                                    
                                    	Tunnel Load metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_local_label
                                    
                                    	Tunnel local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_local_label_str
                                    
                                    	Tunnel local label stringified
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.TeHeadData, self).__init__()

                                        self.yang_name = "te-head-data"
                                        self.yang_parent_name = "moi"

                                        self.flags_decode = YLeaf(YType.str, "flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_fwd_class = YLeaf(YType.uint8, "tunnel-fwd-class")

                                        self.tunnel_load_metric = YLeaf(YType.uint32, "tunnel-load-metric")

                                        self.tunnel_local_label = YLeaf(YType.uint32, "tunnel-local-label")

                                        self.tunnel_local_label_str = YLeaf(YType.str, "tunnel-local-label-str")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("flags_decode",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_fwd_class",
                                                        "tunnel_load_metric",
                                                        "tunnel_local_label",
                                                        "tunnel_local_label_str") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_fwd_class.is_set or
                                            self.tunnel_load_metric.is_set or
                                            self.tunnel_local_label.is_set or
                                            self.tunnel_local_label_str.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_fwd_class.yfilter != YFilter.not_set or
                                            self.tunnel_load_metric.yfilter != YFilter.not_set or
                                            self.tunnel_local_label.yfilter != YFilter.not_set or
                                            self.tunnel_local_label_str.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "te-head-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.flags_decode.is_set or self.flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_fwd_class.is_set or self.tunnel_fwd_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_fwd_class.get_name_leafdata())
                                        if (self.tunnel_load_metric.is_set or self.tunnel_load_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_load_metric.get_name_leafdata())
                                        if (self.tunnel_local_label.is_set or self.tunnel_local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_local_label.get_name_leafdata())
                                        if (self.tunnel_local_label_str.is_set or self.tunnel_local_label_str.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_local_label_str.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-fwd-class" or name == "tunnel-load-metric" or name == "tunnel-local-label" or name == "tunnel-local-label-str"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "flags-decode"):
                                            self.flags_decode = value
                                            self.flags_decode.value_namespace = name_space
                                            self.flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-fwd-class"):
                                            self.tunnel_fwd_class = value
                                            self.tunnel_fwd_class.value_namespace = name_space
                                            self.tunnel_fwd_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-load-metric"):
                                            self.tunnel_load_metric = value
                                            self.tunnel_load_metric.value_namespace = name_space
                                            self.tunnel_load_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-local-label"):
                                            self.tunnel_local_label = value
                                            self.tunnel_local_label.value_namespace = name_space
                                            self.tunnel_local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-local-label-str"):
                                            self.tunnel_local_label_str = value
                                            self.tunnel_local_label_str.value_namespace = name_space
                                            self.tunnel_local_label_str.value_namespace_prefix = name_space_prefix


                                class DmtcData(Entity):
                                    """
                                    dmtc data
                                    
                                    .. attribute:: dmtc_ext_ifh
                                    
                                    	DMTC External Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.DmtcData, self).__init__()

                                        self.yang_name = "dmtc-data"
                                        self.yang_parent_name = "moi"

                                        self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.dmtc_ext_ifh.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "dmtc-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dmtc-ext-ifh"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "dmtc-ext-ifh"):
                                            self.dmtc_ext_ifh = value
                                            self.dmtc_ext_ifh.value_namespace = name_space
                                            self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.moi_type.is_set or
                                        (self.dmtc_data is not None and self.dmtc_data.has_data()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                        (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_data()) or
                                        (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_data()) or
                                        (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_data()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                        (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                        (self.stackv4_data is not None and self.stackv4_data.has_data()) or
                                        (self.stackv6_data is not None and self.stackv6_data.has_data()) or
                                        (self.te_head_data is not None and self.te_head_data.has_data()) or
                                        (self.tev4_data is not None and self.tev4_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.moi_type.yfilter != YFilter.not_set or
                                        (self.dmtc_data is not None and self.dmtc_data.has_operation()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                        (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_operation()) or
                                        (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_operation()) or
                                        (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_operation()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                        (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                        (self.stackv4_data is not None and self.stackv4_data.has_operation()) or
                                        (self.stackv6_data is not None and self.stackv6_data.has_operation()) or
                                        (self.te_head_data is not None and self.te_head_data.has_operation()) or
                                        (self.tev4_data is not None and self.tev4_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "moi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.moi_type.is_set or self.moi_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.moi_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "dmtc-data"):
                                        if (self.dmtc_data is None):
                                            self.dmtc_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.DmtcData()
                                            self.dmtc_data.parent = self
                                            self._children_name_map["dmtc_data"] = "dmtc-data"
                                        return self.dmtc_data

                                    if (child_yang_name == "ip-sub-data"):
                                        if (self.ip_sub_data is None):
                                            self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.IpSubData()
                                            self.ip_sub_data.parent = self
                                            self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                        return self.ip_sub_data

                                    if (child_yang_name == "ipv4-data"):
                                        if (self.ipv4_data is None):
                                            self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv4Data()
                                            self.ipv4_data.parent = self
                                            self._children_name_map["ipv4_data"] = "ipv4-data"
                                        return self.ipv4_data

                                    if (child_yang_name == "ipv6-data"):
                                        if (self.ipv6_data is None):
                                            self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv6Data()
                                            self.ipv6_data.parent = self
                                            self._children_name_map["ipv6_data"] = "ipv6-data"
                                        return self.ipv6_data

                                    if (child_yang_name == "pop-and-lookup-ipv4"):
                                        if (self.pop_and_lookup_ipv4 is None):
                                            self.pop_and_lookup_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                            self.pop_and_lookup_ipv4.parent = self
                                            self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                        return self.pop_and_lookup_ipv4

                                    if (child_yang_name == "pop-and-lookup-ipv6"):
                                        if (self.pop_and_lookup_ipv6 is None):
                                            self.pop_and_lookup_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                            self.pop_and_lookup_ipv6.parent = self
                                            self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                        return self.pop_and_lookup_ipv6

                                    if (child_yang_name == "pop-and-lookup-tp"):
                                        if (self.pop_and_lookup_tp is None):
                                            self.pop_and_lookup_tp = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupTp()
                                            self.pop_and_lookup_tp.parent = self
                                            self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                        return self.pop_and_lookup_tp

                                    if (child_yang_name == "pseudowire-data"):
                                        if (self.pseudowire_data is None):
                                            self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireData()
                                            self.pseudowire_data.parent = self
                                            self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                        return self.pseudowire_data

                                    if (child_yang_name == "pseudowire-head-end-data"):
                                        if (self.pseudowire_head_end_data is None):
                                            self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                            self.pseudowire_head_end_data.parent = self
                                            self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                        return self.pseudowire_head_end_data

                                    if (child_yang_name == "pw-list-data"):
                                        if (self.pw_list_data is None):
                                            self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PwListData()
                                            self.pw_list_data.parent = self
                                            self._children_name_map["pw_list_data"] = "pw-list-data"
                                        return self.pw_list_data

                                    if (child_yang_name == "stackv4-data"):
                                        if (self.stackv4_data is None):
                                            self.stackv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data()
                                            self.stackv4_data.parent = self
                                            self._children_name_map["stackv4_data"] = "stackv4-data"
                                        return self.stackv4_data

                                    if (child_yang_name == "stackv6-data"):
                                        if (self.stackv6_data is None):
                                            self.stackv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data()
                                            self.stackv6_data.parent = self
                                            self._children_name_map["stackv6_data"] = "stackv6-data"
                                        return self.stackv6_data

                                    if (child_yang_name == "te-head-data"):
                                        if (self.te_head_data is None):
                                            self.te_head_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.TeHeadData()
                                            self.te_head_data.parent = self
                                            self._children_name_map["te_head_data"] = "te-head-data"
                                        return self.te_head_data

                                    if (child_yang_name == "tev4-data"):
                                        if (self.tev4_data is None):
                                            self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Tev4Data()
                                            self.tev4_data.parent = self
                                            self._children_name_map["tev4_data"] = "tev4-data"
                                        return self.tev4_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-data" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv6-data" or name == "pop-and-lookup-ipv4" or name == "pop-and-lookup-ipv6" or name == "pop-and-lookup-tp" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "pw-list-data" or name == "stackv4-data" or name == "stackv6-data" or name == "te-head-data" or name == "tev4-data" or name == "moi-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "moi-type"):
                                        self.moi_type = value
                                        self.moi_type.value_namespace = name_space
                                        self.moi_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.moi is not None and self.moi.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.moi is not None and self.moi.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "moi-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "moi"):
                                    if (self.moi is None):
                                        self.moi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi()
                                        self.moi.parent = self
                                        self._children_name_map["moi"] = "moi"
                                    return self.moi

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "moi"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            for c in self.moi_array:
                                if (c.has_data()):
                                    return True
                            return (self.application_resource is not None and self.application_resource.has_data())

                        def has_operation(self):
                            for c in self.moi_array:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.application_resource is not None and self.application_resource.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "mois" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "application-resource"):
                                if (self.application_resource is None):
                                    self.application_resource = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.ApplicationResource()
                                    self.application_resource.parent = self
                                    self._children_name_map["application_resource"] = "application-resource"
                                return self.application_resource

                            if (child_yang_name == "moi-array"):
                                for c in self.moi_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.moi_array.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-resource" or name == "moi-array"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        for c in self.associated_fpi:
                            if (c.has_data()):
                                return True
                        for c in self.mois:
                            if (c.has_data()):
                                return True
                        for c in self.v4_rpf:
                            if (c.has_data()):
                                return True
                        for c in self.v6_rpf:
                            if (c.has_data()):
                                return True
                        return (
                            self.bcdl_priority.is_set or
                            self.lsd_queue.is_set or
                            self.prefix.is_set or
                            self.prefix_length.is_set or
                            self.priority_updated.is_set or
                            self.rewrite_version.is_set or
                            self.rsi_table_id.is_set or
                            self.rsi_table_name.is_set or
                            self.rw_install_age.is_set or
                            self.rw_install_time.is_set or
                            self.rw_updated.is_set or
                            (self.fpi_key is not None and self.fpi_key.has_data()) or
                            (self.rewrite_id is not None and self.rewrite_id.has_data()))

                    def has_operation(self):
                        for c in self.associated_fpi:
                            if (c.has_operation()):
                                return True
                        for c in self.mois:
                            if (c.has_operation()):
                                return True
                        for c in self.v4_rpf:
                            if (c.has_operation()):
                                return True
                        for c in self.v6_rpf:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bcdl_priority.yfilter != YFilter.not_set or
                            self.lsd_queue.yfilter != YFilter.not_set or
                            self.prefix.yfilter != YFilter.not_set or
                            self.prefix_length.yfilter != YFilter.not_set or
                            self.priority_updated.yfilter != YFilter.not_set or
                            self.rewrite_version.yfilter != YFilter.not_set or
                            self.rsi_table_id.yfilter != YFilter.not_set or
                            self.rsi_table_name.yfilter != YFilter.not_set or
                            self.rw_install_age.yfilter != YFilter.not_set or
                            self.rw_install_time.yfilter != YFilter.not_set or
                            self.rw_updated.yfilter != YFilter.not_set or
                            (self.fpi_key is not None and self.fpi_key.has_operation()) or
                            (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rewrite-ipv4" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bcdl_priority.is_set or self.bcdl_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bcdl_priority.get_name_leafdata())
                        if (self.lsd_queue.is_set or self.lsd_queue.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsd_queue.get_name_leafdata())
                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.prefix.get_name_leafdata())
                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                        if (self.priority_updated.is_set or self.priority_updated.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.priority_updated.get_name_leafdata())
                        if (self.rewrite_version.is_set or self.rewrite_version.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rewrite_version.get_name_leafdata())
                        if (self.rsi_table_id.is_set or self.rsi_table_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rsi_table_id.get_name_leafdata())
                        if (self.rsi_table_name.is_set or self.rsi_table_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rsi_table_name.get_name_leafdata())
                        if (self.rw_install_age.is_set or self.rw_install_age.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rw_install_age.get_name_leafdata())
                        if (self.rw_install_time.is_set or self.rw_install_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rw_install_time.get_name_leafdata())
                        if (self.rw_updated.is_set or self.rw_updated.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rw_updated.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "associated-fpi"):
                            for c in self.associated_fpi:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.associated_fpi.append(c)
                            return c

                        if (child_yang_name == "fpi-key"):
                            if (self.fpi_key is None):
                                self.fpi_key = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey()
                                self.fpi_key.parent = self
                                self._children_name_map["fpi_key"] = "fpi-key"
                            return self.fpi_key

                        if (child_yang_name == "mois"):
                            for c in self.mois:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.Mois()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.mois.append(c)
                            return c

                        if (child_yang_name == "rewrite-id"):
                            if (self.rewrite_id is None):
                                self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId()
                                self.rewrite_id.parent = self
                                self._children_name_map["rewrite_id"] = "rewrite-id"
                            return self.rewrite_id

                        if (child_yang_name == "v4-rpf"):
                            for c in self.v4_rpf:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.V4Rpf()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.v4_rpf.append(c)
                            return c

                        if (child_yang_name == "v6-rpf"):
                            for c in self.v6_rpf:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4.V6Rpf()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.v6_rpf.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "associated-fpi" or name == "fpi-key" or name == "mois" or name == "rewrite-id" or name == "v4-rpf" or name == "v6-rpf" or name == "bcdl-priority" or name == "lsd-queue" or name == "prefix" or name == "prefix-length" or name == "priority-updated" or name == "rewrite-version" or name == "rsi-table-id" or name == "rsi-table-name" or name == "rw-install-age" or name == "rw-install-time" or name == "rw-updated"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bcdl-priority"):
                            self.bcdl_priority = value
                            self.bcdl_priority.value_namespace = name_space
                            self.bcdl_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsd-queue"):
                            self.lsd_queue = value
                            self.lsd_queue.value_namespace = name_space
                            self.lsd_queue.value_namespace_prefix = name_space_prefix
                        if(value_path == "prefix"):
                            self.prefix = value
                            self.prefix.value_namespace = name_space
                            self.prefix.value_namespace_prefix = name_space_prefix
                        if(value_path == "prefix-length"):
                            self.prefix_length = value
                            self.prefix_length.value_namespace = name_space
                            self.prefix_length.value_namespace_prefix = name_space_prefix
                        if(value_path == "priority-updated"):
                            self.priority_updated = value
                            self.priority_updated.value_namespace = name_space
                            self.priority_updated.value_namespace_prefix = name_space_prefix
                        if(value_path == "rewrite-version"):
                            self.rewrite_version = value
                            self.rewrite_version.value_namespace = name_space
                            self.rewrite_version.value_namespace_prefix = name_space_prefix
                        if(value_path == "rsi-table-id"):
                            self.rsi_table_id = value
                            self.rsi_table_id.value_namespace = name_space
                            self.rsi_table_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "rsi-table-name"):
                            self.rsi_table_name = value
                            self.rsi_table_name.value_namespace = name_space
                            self.rsi_table_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "rw-install-age"):
                            self.rw_install_age = value
                            self.rw_install_age.value_namespace = name_space
                            self.rw_install_age.value_namespace_prefix = name_space_prefix
                        if(value_path == "rw-install-time"):
                            self.rw_install_time = value
                            self.rw_install_time.value_namespace = name_space
                            self.rw_install_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "rw-updated"):
                            self.rw_updated = value
                            self.rw_updated.value_namespace = name_space
                            self.rw_updated.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.rewrite_ipv4:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.rewrite_ipv4:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "rewrite-ipv4s" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "rewrite-ipv4"):
                        for c in self.rewrite_ipv4:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S.RewriteIpv4()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.rewrite_ipv4.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "rewrite-ipv4"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class RewriteTes(Entity):
                """
                Table of Traffic Engineering Rewrites
                
                .. attribute:: rewrite_te
                
                	FPI rewrite for TE
                	**type**\: list of    :py:class:`RewriteTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes, self).__init__()

                    self.yang_name = "rewrite-tes"
                    self.yang_parent_name = "rewrite"

                    self.rewrite_te = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes, self).__setattr__(name, value)


                class RewriteTe(Entity):
                    """
                    FPI rewrite for TE
                    
                    .. attribute:: interface_name  <key>
                    
                    	Tunnel interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: associated_fpi
                    
                    	Associated FPI
                    	**type**\: list of    :py:class:`AssociatedFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi>`
                    
                    .. attribute:: bcdl_priority
                    
                    	BCDL Priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: fpi_key
                    
                    	fpi key
                    	**type**\:   :py:class:`FpiKey <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey>`
                    
                    .. attribute:: lsd_queue
                    
                    	LSD queue
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: mois
                    
                    	Mois
                    	**type**\: list of    :py:class:`Mois <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois>`
                    
                    .. attribute:: priority_updated
                    
                    	Is rewrite's BCDL priority updated
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: rewrite_id
                    
                    	Rewrite ID
                    	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId>`
                    
                    .. attribute:: rewrite_version
                    
                    	Rewrite version
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rw_install_age
                    
                    	Rewrite install age
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rw_install_time
                    
                    	Rewrite install timestamp
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rw_updated
                    
                    	Is rewrite ever updated
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: v4_rpf
                    
                    	IPv4 RPF neighbors
                    	**type**\: list of    :py:class:`V4Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.V4Rpf>`
                    
                    .. attribute:: v6_rpf
                    
                    	IPv6 RPF neighbors
                    	**type**\: list of    :py:class:`V6Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.V6Rpf>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe, self).__init__()

                        self.yang_name = "rewrite-te"
                        self.yang_parent_name = "rewrite-tes"

                        self.interface_name = YLeaf(YType.str, "interface-name")

                        self.bcdl_priority = YLeaf(YType.uint8, "bcdl-priority")

                        self.lsd_queue = YLeaf(YType.uint8, "lsd-queue")

                        self.priority_updated = YLeaf(YType.int32, "priority-updated")

                        self.rewrite_version = YLeaf(YType.uint64, "rewrite-version")

                        self.rw_install_age = YLeaf(YType.uint64, "rw-install-age")

                        self.rw_install_time = YLeaf(YType.uint64, "rw-install-time")

                        self.rw_updated = YLeaf(YType.int32, "rw-updated")

                        self.fpi_key = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey()
                        self.fpi_key.parent = self
                        self._children_name_map["fpi_key"] = "fpi-key"
                        self._children_yang_names.add("fpi-key")

                        self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId()
                        self.rewrite_id.parent = self
                        self._children_name_map["rewrite_id"] = "rewrite-id"
                        self._children_yang_names.add("rewrite-id")

                        self.associated_fpi = YList(self)
                        self.mois = YList(self)
                        self.v4_rpf = YList(self)
                        self.v6_rpf = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("interface_name",
                                        "bcdl_priority",
                                        "lsd_queue",
                                        "priority_updated",
                                        "rewrite_version",
                                        "rw_install_age",
                                        "rw_install_time",
                                        "rw_updated") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe, self).__setattr__(name, value)


                    class FpiKey(Entity):
                        """
                        fpi key
                        
                        .. attribute:: application_owner
                        
                        	Application owner instance
                        	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.ApplicationOwner>`
                        
                        .. attribute:: fpi
                        
                        	FPI
                        	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey, self).__init__()

                            self.yang_name = "fpi-key"
                            self.yang_parent_name = "rewrite-te"

                            self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi()
                            self.fpi.parent = self
                            self._children_name_map["fpi"] = "fpi"
                            self._children_yang_names.add("fpi")

                            self.application_owner = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey, self).__setattr__(name, value)


                        class Fpi(Entity):
                            """
                            FPI
                            
                            .. attribute:: dmtc_ext_intf_data
                            
                            	dmtc ext intf data
                            	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.DmtcExtIntfData>`
                            
                            .. attribute:: fpi_type
                            
                            	FPIType
                            	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                            
                            .. attribute:: ipv4_data
                            
                            	ipv4 data
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv4Data>`
                            
                            .. attribute:: ipv6_data
                            
                            	ipv6 data
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv6Data>`
                            
                            .. attribute:: label_data
                            
                            	label data
                            	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.LabelData>`
                            
                            .. attribute:: pw_list_data
                            
                            	pw list data
                            	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.PwListData>`
                            
                            .. attribute:: te_data
                            
                            	te data
                            	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.TeData>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi, self).__init__()

                                self.yang_name = "fpi"
                                self.yang_parent_name = "fpi-key"

                                self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                                self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.DmtcExtIntfData()
                                self.dmtc_ext_intf_data.parent = self
                                self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                self._children_yang_names.add("dmtc-ext-intf-data")

                                self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.LabelData()
                                self.label_data.parent = self
                                self._children_name_map["label_data"] = "label-data"
                                self._children_yang_names.add("label-data")

                                self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.PwListData()
                                self.pw_list_data.parent = self
                                self._children_name_map["pw_list_data"] = "pw-list-data"
                                self._children_yang_names.add("pw-list-data")

                                self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.TeData()
                                self.te_data.parent = self
                                self._children_name_map["te_data"] = "te-data"
                                self._children_yang_names.add("te-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fpi_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi, self).__setattr__(name, value)


                            class LabelData(Entity):
                                """
                                label data
                                
                                .. attribute:: elc
                                
                                	ELC
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: label
                                
                                	Label value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.LabelData, self).__init__()

                                    self.yang_name = "label-data"
                                    self.yang_parent_name = "fpi"

                                    self.elc = YLeaf(YType.int32, "elc")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("elc",
                                                    "label",
                                                    "security_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.LabelData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.LabelData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.elc.is_set or
                                        self.label.is_set or
                                        self.security_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.elc.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.elc.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "elc" or name == "label" or name == "security-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "elc"):
                                        self.elc = value
                                        self.elc.value_namespace = name_space
                                        self.elc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix


                            class TeData(Entity):
                                """
                                te data
                                
                                .. attribute:: local_label
                                
                                	Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_interface
                                
                                	Tunnel interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.TeData, self).__init__()

                                    self.yang_name = "te-data"
                                    self.yang_parent_name = "fpi"

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("local_label",
                                                    "tunnel_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.TeData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.TeData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.local_label.is_set or
                                        self.tunnel_interface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.tunnel_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "local-label" or name == "tunnel-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface"):
                                        self.tunnel_interface = value
                                        self.tunnel_interface.value_namespace = name_space
                                        self.tunnel_interface.value_namespace_prefix = name_space_prefix


                            class Ipv4Data(Entity):
                                """
                                ipv4 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: sr_local_label
                                
                                	SR related Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "sr_local_label",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.sr_local_label.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.sr_local_label.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sr-local-label"):
                                        self.sr_local_label = value
                                        self.sr_local_label.value_namespace = name_space
                                        self.sr_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                ipv6 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: router_flags
                                
                                	Route flags
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    self.router_flags = YLeaf(YType.uint32, "router-flags")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_len",
                                                    "router_flags",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_len.is_set or
                                        self.router_flags.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set or
                                        self.router_flags.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                    if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_flags.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-flags"):
                                        self.router_flags = value
                                        self.router_flags.value_namespace = name_space
                                        self.router_flags.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class PwListData(Entity):
                                """
                                pw list data
                                
                                .. attribute:: pwhe_list_id
                                
                                	Pseudowire List Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.PwListData, self).__init__()

                                    self.yang_name = "pw-list-data"
                                    self.yang_parent_name = "fpi"

                                    self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("pwhe_list_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.PwListData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.PwListData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.pwhe_list_id.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.pwhe_list_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pw-list-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "pwhe-list-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "pwhe-list-id"):
                                        self.pwhe_list_id = value
                                        self.pwhe_list_id.value_namespace = name_space
                                        self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                            class DmtcExtIntfData(Entity):
                                """
                                dmtc ext intf data
                                
                                .. attribute:: dmtc_ext_ifh
                                
                                	DMTC External Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.DmtcExtIntfData, self).__init__()

                                    self.yang_name = "dmtc-ext-intf-data"
                                    self.yang_parent_name = "fpi"

                                    self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.dmtc_ext_ifh.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "dmtc-ext-intf-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-ext-ifh"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dmtc-ext-ifh"):
                                        self.dmtc_ext_ifh = value
                                        self.dmtc_ext_ifh.value_namespace = name_space
                                        self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fpi_type.is_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.label_data is not None and self.label_data.has_data()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                    (self.te_data is not None and self.te_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fpi_type.yfilter != YFilter.not_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.label_data is not None and self.label_data.has_operation()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                    (self.te_data is not None and self.te_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fpi" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fpi_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "dmtc-ext-intf-data"):
                                    if (self.dmtc_ext_intf_data is None):
                                        self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.DmtcExtIntfData()
                                        self.dmtc_ext_intf_data.parent = self
                                        self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                    return self.dmtc_ext_intf_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "label-data"):
                                    if (self.label_data is None):
                                        self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.LabelData()
                                        self.label_data.parent = self
                                        self._children_name_map["label_data"] = "label-data"
                                    return self.label_data

                                if (child_yang_name == "pw-list-data"):
                                    if (self.pw_list_data is None):
                                        self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.PwListData()
                                        self.pw_list_data.parent = self
                                        self._children_name_map["pw_list_data"] = "pw-list-data"
                                    return self.pw_list_data

                                if (child_yang_name == "te-data"):
                                    if (self.te_data is None):
                                        self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.TeData()
                                        self.te_data.parent = self
                                        self._children_name_map["te_data"] = "te-data"
                                    return self.te_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fpi-type"):
                                    self.fpi_type = value
                                    self.fpi_type.value_namespace = name_space
                                    self.fpi_type.value_namespace_prefix = name_space_prefix


                        class ApplicationOwner(Entity):
                            """
                            Application owner instance
                            
                            .. attribute:: application_instance
                            
                            	Application instance Name
                            	**type**\:  str
                            
                            .. attribute:: application_name
                            
                            	Application name
                            	**type**\:  str
                            
                            .. attribute:: application_role_primary
                            
                            	Primary/Backup role
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: application_type
                            
                            	Application type
                            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                            
                            .. attribute:: resource_state
                            
                            	Application resource state
                            	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.ApplicationOwner, self).__init__()

                                self.yang_name = "application-owner"
                                self.yang_parent_name = "fpi-key"

                                self.application_instance = YLeaf(YType.str, "application-instance")

                                self.application_name = YLeaf(YType.str, "application-name")

                                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                                self.application_type = YLeaf(YType.enumeration, "application-type")

                                self.resource_state = YLeaf(YType.enumeration, "resource-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("application_instance",
                                                "application_name",
                                                "application_role_primary",
                                                "application_type",
                                                "resource_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.ApplicationOwner, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.ApplicationOwner, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.application_instance.is_set or
                                    self.application_name.is_set or
                                    self.application_role_primary.is_set or
                                    self.application_type.is_set or
                                    self.resource_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.application_instance.yfilter != YFilter.not_set or
                                    self.application_name.yfilter != YFilter.not_set or
                                    self.application_role_primary.yfilter != YFilter.not_set or
                                    self.application_type.yfilter != YFilter.not_set or
                                    self.resource_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "application-owner" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_name.get_name_leafdata())
                                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_type.get_name_leafdata())
                                if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resource_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "application-instance"):
                                    self.application_instance = value
                                    self.application_instance.value_namespace = name_space
                                    self.application_instance.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-name"):
                                    self.application_name = value
                                    self.application_name.value_namespace = name_space
                                    self.application_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-role-primary"):
                                    self.application_role_primary = value
                                    self.application_role_primary.value_namespace = name_space
                                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-type"):
                                    self.application_type = value
                                    self.application_type.value_namespace = name_space
                                    self.application_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "resource-state"):
                                    self.resource_state = value
                                    self.resource_state.value_namespace = name_space
                                    self.resource_state.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.application_owner:
                                if (c.has_data()):
                                    return True
                            return (self.fpi is not None and self.fpi.has_data())

                        def has_operation(self):
                            for c in self.application_owner:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.fpi is not None and self.fpi.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fpi-key" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "application-owner"):
                                for c in self.application_owner:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.ApplicationOwner()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.application_owner.append(c)
                                return c

                            if (child_yang_name == "fpi"):
                                if (self.fpi is None):
                                    self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi()
                                    self.fpi.parent = self
                                    self._children_name_map["fpi"] = "fpi"
                                return self.fpi

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-owner" or name == "fpi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class RewriteId(Entity):
                        """
                        Rewrite ID
                        
                        .. attribute:: rewrite_id
                        
                        	Rewrite ID
                        	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId, self).__init__()

                            self.yang_name = "rewrite-id"
                            self.yang_parent_name = "rewrite-te"

                            self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId()
                            self.rewrite_id.parent = self
                            self._children_name_map["rewrite_id"] = "rewrite-id"
                            self._children_yang_names.add("rewrite-id")


                        class RewriteId(Entity):
                            """
                            Rewrite ID
                            
                            .. attribute:: label_context
                            
                            	Label context
                            	**type**\:   :py:class:`LabelContext <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext>`
                            
                            .. attribute:: local_label_rewrite
                            
                            	Local label rewrite information
                            	**type**\:   :py:class:`LocalLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LocalLabelRewrite>`
                            
                            .. attribute:: rewrite_id_type
                            
                            	RewriteIDType
                            	**type**\:   :py:class:`MgmtLsdRwId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdRwId>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId, self).__init__()

                                self.yang_name = "rewrite-id"
                                self.yang_parent_name = "rewrite-id"

                                self.rewrite_id_type = YLeaf(YType.enumeration, "rewrite-id-type")

                                self.label_context = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext()
                                self.label_context.parent = self
                                self._children_name_map["label_context"] = "label-context"
                                self._children_yang_names.add("label-context")

                                self.local_label_rewrite = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LocalLabelRewrite()
                                self.local_label_rewrite.parent = self
                                self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                                self._children_yang_names.add("local-label-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rewrite_id_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId, self).__setattr__(name, value)


                            class LabelContext(Entity):
                                """
                                Label context
                                
                                .. attribute:: cev4l3vpn_data
                                
                                	L3VPN CEv4 label context
                                	**type**\:   :py:class:`Cev4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev4L3VpnData>`
                                
                                .. attribute:: cev6l3vpn_data
                                
                                	L3VPN CEv6 label context
                                	**type**\:   :py:class:`Cev6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev6L3VpnData>`
                                
                                .. attribute:: evpn_data
                                
                                	EVPN context
                                	**type**\:   :py:class:`EvpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.EvpnData>`
                                
                                .. attribute:: generic_routing_encapsulation
                                
                                	Generic routing encapsulation context
                                	**type**\:   :py:class:`GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation>`
                                
                                .. attribute:: ip_sub_data
                                
                                	IP Subscriber context
                                	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.IpSubData>`
                                
                                .. attribute:: ipv4_data
                                
                                	IPv4 label context
                                	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4Data>`
                                
                                .. attribute:: ipv4blb_data
                                
                                	BFD BLB label context
                                	**type**\:   :py:class:`Ipv4BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4BlbData>`
                                
                                .. attribute:: ipv4l3vpn_data
                                
                                	L3VPN IPv4 label context
                                	**type**\:   :py:class:`Ipv4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData>`
                                
                                .. attribute:: ipv6_data
                                
                                	IPv6 label context
                                	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6Data>`
                                
                                .. attribute:: ipv6_generic_routing_encapsulation
                                
                                	Generic routing encapsulation context
                                	**type**\:   :py:class:`Ipv6GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation>`
                                
                                .. attribute:: ipv6blb_data
                                
                                	BFD BLB label context
                                	**type**\:   :py:class:`Ipv6BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6BlbData>`
                                
                                .. attribute:: ipv6l3vpn_data
                                
                                	L3VPN IPv6 label context
                                	**type**\:   :py:class:`Ipv6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData>`
                                
                                .. attribute:: label_block_data
                                
                                	Label block context
                                	**type**\:   :py:class:`LabelBlockData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockData>`
                                
                                .. attribute:: label_block_srgb_data
                                
                                	Label block SRGB context
                                	**type**\:   :py:class:`LabelBlockSrgbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData>`
                                
                                .. attribute:: label_context_type
                                
                                	LabelContextType
                                	**type**\:   :py:class:`MgmtLsdLblCtx <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLblCtx>`
                                
                                .. attribute:: mld_pv4_data
                                
                                	MLDPv4 LSM\-ID context
                                	**type**\:   :py:class:`MldPv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.MldPv4Data>`
                                
                                .. attribute:: next_hop_set_l3vpn
                                
                                	L3VPN NH SET label context
                                	**type**\:   :py:class:`NextHopSetL3Vpn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn>`
                                
                                .. attribute:: pi_mi_pmsi_data
                                
                                	PIM I\-PMSI label conext
                                	**type**\:   :py:class:`PiMiPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMiPmsiData>`
                                
                                .. attribute:: pi_ms_pmsi_data
                                
                                	PIM S\-PMSI label conext
                                	**type**\:   :py:class:`PiMsPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMsPmsiData>`
                                
                                .. attribute:: pseudowire_data
                                
                                	Pseudowire label context
                                	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireData>`
                                
                                .. attribute:: pseudowire_head_end_data
                                
                                	Pseudowire Head\-end label context
                                	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData>`
                                
                                .. attribute:: sr_adj_segment_ipv4
                                
                                	SR Adj Segment ipv4 context
                                	**type**\:   :py:class:`SrAdjSegmentIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4>`
                                
                                .. attribute:: sr_adj_segment_ipv6
                                
                                	SR Adj Segment ipv6 context
                                	**type**\:   :py:class:`SrAdjSegmentIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6>`
                                
                                .. attribute:: sr_prefix_segment
                                
                                	SR Prefix Segment context
                                	**type**\:   :py:class:`SrPrefixSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrPrefixSegment>`
                                
                                .. attribute:: te_binding
                                
                                	MPLS TE tunnel binding context
                                	**type**\:   :py:class:`TeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TeBinding>`
                                
                                .. attribute:: tev4_data
                                
                                	TEv4 label context
                                	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4Data>`
                                
                                .. attribute:: tev4p2mp_data
                                
                                	TEv4 P2MP context
                                	**type**\:   :py:class:`Tev4P2MpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4P2MpData>`
                                
                                .. attribute:: tp_data
                                
                                	TP context
                                	**type**\:   :py:class:`TpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TpData>`
                                
                                .. attribute:: vrf_l3vpn_data
                                
                                	L3VPN VRF label context
                                	**type**\:   :py:class:`VrfL3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.VrfL3VpnData>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext, self).__init__()

                                    self.yang_name = "label-context"
                                    self.yang_parent_name = "rewrite-id"

                                    self.label_context_type = YLeaf(YType.enumeration, "label-context-type")

                                    self.cev4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                    self.cev4l3vpn_data.parent = self
                                    self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                    self._children_yang_names.add("cev4l3vpn-data")

                                    self.cev6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                    self.cev6l3vpn_data.parent = self
                                    self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                    self._children_yang_names.add("cev6l3vpn-data")

                                    self.evpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.EvpnData()
                                    self.evpn_data.parent = self
                                    self._children_name_map["evpn_data"] = "evpn-data"
                                    self._children_yang_names.add("evpn-data")

                                    self.generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                    self.generic_routing_encapsulation.parent = self
                                    self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                    self._children_yang_names.add("generic-routing-encapsulation")

                                    self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.IpSubData()
                                    self.ip_sub_data.parent = self
                                    self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    self._children_yang_names.add("ip-sub-data")

                                    self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                    self._children_yang_names.add("ipv4-data")

                                    self.ipv4blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                    self.ipv4blb_data.parent = self
                                    self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                    self._children_yang_names.add("ipv4blb-data")

                                    self.ipv4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                    self.ipv4l3vpn_data.parent = self
                                    self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                    self._children_yang_names.add("ipv4l3vpn-data")

                                    self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                    self._children_yang_names.add("ipv6-data")

                                    self.ipv6_generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                    self.ipv6_generic_routing_encapsulation.parent = self
                                    self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                    self._children_yang_names.add("ipv6-generic-routing-encapsulation")

                                    self.ipv6blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                    self.ipv6blb_data.parent = self
                                    self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                    self._children_yang_names.add("ipv6blb-data")

                                    self.ipv6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                    self.ipv6l3vpn_data.parent = self
                                    self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                    self._children_yang_names.add("ipv6l3vpn-data")

                                    self.label_block_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                    self.label_block_data.parent = self
                                    self._children_name_map["label_block_data"] = "label-block-data"
                                    self._children_yang_names.add("label-block-data")

                                    self.label_block_srgb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                    self.label_block_srgb_data.parent = self
                                    self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                    self._children_yang_names.add("label-block-srgb-data")

                                    self.mld_pv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                    self.mld_pv4_data.parent = self
                                    self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                    self._children_yang_names.add("mld-pv4-data")

                                    self.next_hop_set_l3vpn = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                    self.next_hop_set_l3vpn.parent = self
                                    self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                    self._children_yang_names.add("next-hop-set-l3vpn")

                                    self.pi_mi_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                    self.pi_mi_pmsi_data.parent = self
                                    self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                    self._children_yang_names.add("pi-mi-pmsi-data")

                                    self.pi_ms_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                    self.pi_ms_pmsi_data.parent = self
                                    self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                    self._children_yang_names.add("pi-ms-pmsi-data")

                                    self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireData()
                                    self.pseudowire_data.parent = self
                                    self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    self._children_yang_names.add("pseudowire-data")

                                    self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                    self.pseudowire_head_end_data.parent = self
                                    self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    self._children_yang_names.add("pseudowire-head-end-data")

                                    self.sr_adj_segment_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                    self.sr_adj_segment_ipv4.parent = self
                                    self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                    self._children_yang_names.add("sr-adj-segment-ipv4")

                                    self.sr_adj_segment_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                    self.sr_adj_segment_ipv6.parent = self
                                    self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                    self._children_yang_names.add("sr-adj-segment-ipv6")

                                    self.sr_prefix_segment = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                    self.sr_prefix_segment.parent = self
                                    self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                    self._children_yang_names.add("sr-prefix-segment")

                                    self.te_binding = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TeBinding()
                                    self.te_binding.parent = self
                                    self._children_name_map["te_binding"] = "te-binding"
                                    self._children_yang_names.add("te-binding")

                                    self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4Data()
                                    self.tev4_data.parent = self
                                    self._children_name_map["tev4_data"] = "tev4-data"
                                    self._children_yang_names.add("tev4-data")

                                    self.tev4p2mp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                    self.tev4p2mp_data.parent = self
                                    self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                    self._children_yang_names.add("tev4p2mp-data")

                                    self.tp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TpData()
                                    self.tp_data.parent = self
                                    self._children_name_map["tp_data"] = "tp-data"
                                    self._children_yang_names.add("tp-data")

                                    self.vrf_l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                    self.vrf_l3vpn_data.parent = self
                                    self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                    self._children_yang_names.add("vrf-l3vpn-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_context_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)


                                class Ipv4Data(Entity):
                                    """
                                    IPv4 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv4 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	IPv4 prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf_name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..33
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__init__()

                                        self.yang_name = "ipv4-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.vrf_name = YLeaf(YType.str, "vrf-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "security_id",
                                                        "table_id",
                                                        "vrf_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set or
                                            self.vrf_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.vrf_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-name"):
                                            self.vrf_name = value
                                            self.vrf_name.value_namespace = name_space
                                            self.vrf_name.value_namespace_prefix = name_space_prefix


                                class Ipv6Data(Entity):
                                    """
                                    IPv6 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf_name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..33
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__init__()

                                        self.yang_name = "ipv6-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.vrf_name = YLeaf(YType.str, "vrf-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "security_id",
                                                        "table_id",
                                                        "vrf_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set or
                                            self.vrf_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.vrf_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-name"):
                                            self.vrf_name = value
                                            self.vrf_name.value_namespace = name_space
                                            self.vrf_name.value_namespace_prefix = name_space_prefix


                                class Tev4Data(Entity):
                                    """
                                    TEv4 label context
                                    
                                    .. attribute:: is_srte
                                    
                                    	Is this an SRTE head tunnel
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_dest
                                    
                                    	Tunnel destination
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_id_extension
                                    
                                    	Extended tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_lsp_id
                                    
                                    	Tunnel LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_source
                                    
                                    	Tunnel source
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4Data, self).__init__()

                                        self.yang_name = "tev4-data"
                                        self.yang_parent_name = "label-context"

                                        self.is_srte = YLeaf(YType.int32, "is-srte")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.tunnel_dest = YLeaf(YType.str, "tunnel-dest")

                                        self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                        self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                        self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                        self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_srte",
                                                        "table_id",
                                                        "tunnel_dest",
                                                        "tunnel_id",
                                                        "tunnel_id_extension",
                                                        "tunnel_lsp_id",
                                                        "tunnel_source") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_srte.is_set or
                                            self.table_id.is_set or
                                            self.tunnel_dest.is_set or
                                            self.tunnel_id.is_set or
                                            self.tunnel_id_extension.is_set or
                                            self.tunnel_lsp_id.is_set or
                                            self.tunnel_source.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_srte.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.tunnel_dest.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set or
                                            self.tunnel_id_extension.yfilter != YFilter.not_set or
                                            self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                            self.tunnel_source.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tev4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_srte.is_set or self.is_srte.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_srte.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.tunnel_dest.is_set or self.tunnel_dest.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_dest.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                        if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                        if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                        if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-srte" or name == "table-id" or name == "tunnel-dest" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-srte"):
                                            self.is_srte = value
                                            self.is_srte.value_namespace = name_space
                                            self.is_srte.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-dest"):
                                            self.tunnel_dest = value
                                            self.tunnel_dest.value_namespace = name_space
                                            self.tunnel_dest.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id-extension"):
                                            self.tunnel_id_extension = value
                                            self.tunnel_id_extension.value_namespace = name_space
                                            self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-lsp-id"):
                                            self.tunnel_lsp_id = value
                                            self.tunnel_lsp_id.value_namespace = name_space
                                            self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-source"):
                                            self.tunnel_source = value
                                            self.tunnel_source.value_namespace = name_space
                                            self.tunnel_source.value_namespace_prefix = name_space_prefix


                                class Ipv4L3VpnData(Entity):
                                    """
                                    L3VPN IPv4 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv4 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: route_distinguisher
                                    
                                    	Route distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__init__()

                                        self.yang_name = "ipv4l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "route_distinguisher") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.route_distinguisher.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.route_distinguisher.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "route-distinguisher"):
                                            self.route_distinguisher = value
                                            self.route_distinguisher.value_namespace = name_space
                                            self.route_distinguisher.value_namespace_prefix = name_space_prefix


                                class Ipv6L3VpnData(Entity):
                                    """
                                    L3VPN IPv6 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv6 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: route_distinguisher
                                    
                                    	Route distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__init__()

                                        self.yang_name = "ipv6l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "route_distinguisher") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.route_distinguisher.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.route_distinguisher.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "route-distinguisher"):
                                            self.route_distinguisher = value
                                            self.route_distinguisher.value_namespace = name_space
                                            self.route_distinguisher.value_namespace_prefix = name_space_prefix


                                class VrfL3VpnData(Entity):
                                    """
                                    L3VPN VRF label context
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__init__()

                                        self.yang_name = "vrf-l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("security_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.security_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf-l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "security-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class Cev4L3VpnData(Entity):
                                    """
                                    L3VPN CEv4 label context
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__init__()

                                        self.yang_name = "cev4l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ipv4_next_hop",
                                                        "security_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ipv4_next_hop.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cev4l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ipv4-next-hop" or name == "security-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class Cev6L3VpnData(Entity):
                                    """
                                    L3VPN CEv6 label context
                                    
                                    .. attribute:: ipv6_next_hop
                                    
                                    	IPv6 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__init__()

                                        self.yang_name = "cev6l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ipv6_next_hop",
                                                        "security_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ipv6_next_hop.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ipv6_next_hop.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cev6l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ipv6-next-hop" or name == "security-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ipv6-next-hop"):
                                            self.ipv6_next_hop = value
                                            self.ipv6_next_hop.value_namespace = name_space
                                            self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class PseudowireData(Entity):
                                    """
                                    Pseudowire label context
                                    
                                    .. attribute:: prefix
                                    
                                    	Address prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: pseudowire_id
                                    
                                    	Pseudo\-wire ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: remote_l2_router_id
                                    
                                    	Remote L2 Router ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: subinterface
                                    
                                    	Subinterface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireData, self).__init__()

                                        self.yang_name = "pseudowire-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.pseudowire_id = YLeaf(YType.uint64, "pseudowire-id")

                                        self.remote_l2_router_id = YLeaf(YType.uint32, "remote-l2-router-id")

                                        self.subinterface = YLeaf(YType.str, "subinterface")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "pseudowire_id",
                                                        "remote_l2_router_id",
                                                        "subinterface") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.pseudowire_id.is_set or
                                            self.remote_l2_router_id.is_set or
                                            self.subinterface.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.pseudowire_id.yfilter != YFilter.not_set or
                                            self.remote_l2_router_id.yfilter != YFilter.not_set or
                                            self.subinterface.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pseudowire_id.get_name_leafdata())
                                        if (self.remote_l2_router_id.is_set or self.remote_l2_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remote_l2_router_id.get_name_leafdata())
                                        if (self.subinterface.is_set or self.subinterface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.subinterface.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "pseudowire-id" or name == "remote-l2-router-id" or name == "subinterface"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pseudowire-id"):
                                            self.pseudowire_id = value
                                            self.pseudowire_id.value_namespace = name_space
                                            self.pseudowire_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remote-l2-router-id"):
                                            self.remote_l2_router_id = value
                                            self.remote_l2_router_id.value_namespace = name_space
                                            self.remote_l2_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "subinterface"):
                                            self.subinterface = value
                                            self.subinterface.value_namespace = name_space
                                            self.subinterface.value_namespace_prefix = name_space_prefix


                                class LabelBlockData(Entity):
                                    """
                                    Label block context
                                    
                                    .. attribute:: edge_id
                                    
                                    	Edge ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: offset
                                    
                                    	Offset
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: service
                                    
                                    	Service
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: size
                                    
                                    	Number of labels
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vpn_id
                                    
                                    	VPN ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__init__()

                                        self.yang_name = "label-block-data"
                                        self.yang_parent_name = "label-context"

                                        self.edge_id = YLeaf(YType.uint16, "edge-id")

                                        self.offset = YLeaf(YType.uint32, "offset")

                                        self.service = YLeaf(YType.uint8, "service")

                                        self.size = YLeaf(YType.uint32, "size")

                                        self.vpn_id = YLeaf(YType.uint16, "vpn-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("edge_id",
                                                        "offset",
                                                        "service",
                                                        "size",
                                                        "vpn_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.edge_id.is_set or
                                            self.offset.is_set or
                                            self.service.is_set or
                                            self.size.is_set or
                                            self.vpn_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.edge_id.yfilter != YFilter.not_set or
                                            self.offset.yfilter != YFilter.not_set or
                                            self.service.yfilter != YFilter.not_set or
                                            self.size.yfilter != YFilter.not_set or
                                            self.vpn_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "label-block-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.edge_id.is_set or self.edge_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.edge_id.get_name_leafdata())
                                        if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.offset.get_name_leafdata())
                                        if (self.service.is_set or self.service.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.service.get_name_leafdata())
                                        if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.size.get_name_leafdata())
                                        if (self.vpn_id.is_set or self.vpn_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vpn_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "edge-id" or name == "offset" or name == "service" or name == "size" or name == "vpn-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "edge-id"):
                                            self.edge_id = value
                                            self.edge_id.value_namespace = name_space
                                            self.edge_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "offset"):
                                            self.offset = value
                                            self.offset.value_namespace = name_space
                                            self.offset.value_namespace_prefix = name_space_prefix
                                        if(value_path == "service"):
                                            self.service = value
                                            self.service.value_namespace = name_space
                                            self.service.value_namespace_prefix = name_space_prefix
                                        if(value_path == "size"):
                                            self.size = value
                                            self.size.value_namespace = name_space
                                            self.size.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vpn-id"):
                                            self.vpn_id = value
                                            self.vpn_id.value_namespace = name_space
                                            self.vpn_id.value_namespace_prefix = name_space_prefix


                                class IpSubData(Entity):
                                    """
                                    IP Subscriber context
                                    
                                    .. attribute:: parent_interface
                                    
                                    	Parent interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: table_id
                                    
                                    	Table Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.IpSubData, self).__init__()

                                        self.yang_name = "ip-sub-data"
                                        self.yang_parent_name = "label-context"

                                        self.parent_interface = YLeaf(YType.str, "parent-interface")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("parent_interface",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.parent_interface.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.parent_interface.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ip-sub-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.parent_interface.is_set or self.parent_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_interface.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "parent-interface" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "parent-interface"):
                                            self.parent_interface = value
                                            self.parent_interface.value_namespace = name_space
                                            self.parent_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class Tev4P2MpData(Entity):
                                    """
                                    TEv4 P2MP context
                                    
                                    .. attribute:: p2mp_id
                                    
                                    	Point to multipoint ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: previous_hop
                                    
                                    	Previous hop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_id_extension
                                    
                                    	Tunnel ID extension
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_lsp_id
                                    
                                    	Tunnel LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_source
                                    
                                    	Tunnel source
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__init__()

                                        self.yang_name = "tev4p2mp-data"
                                        self.yang_parent_name = "label-context"

                                        self.p2mp_id = YLeaf(YType.uint32, "p2mp-id")

                                        self.previous_hop = YLeaf(YType.str, "previous-hop")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                        self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                        self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                        self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("p2mp_id",
                                                        "previous_hop",
                                                        "table_id",
                                                        "tunnel_id",
                                                        "tunnel_id_extension",
                                                        "tunnel_lsp_id",
                                                        "tunnel_source") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.p2mp_id.is_set or
                                            self.previous_hop.is_set or
                                            self.table_id.is_set or
                                            self.tunnel_id.is_set or
                                            self.tunnel_id_extension.is_set or
                                            self.tunnel_lsp_id.is_set or
                                            self.tunnel_source.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.p2mp_id.yfilter != YFilter.not_set or
                                            self.previous_hop.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set or
                                            self.tunnel_id_extension.yfilter != YFilter.not_set or
                                            self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                            self.tunnel_source.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tev4p2mp-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                                        if (self.previous_hop.is_set or self.previous_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.previous_hop.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                        if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                        if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                        if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "p2mp-id" or name == "previous-hop" or name == "table-id" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "p2mp-id"):
                                            self.p2mp_id = value
                                            self.p2mp_id.value_namespace = name_space
                                            self.p2mp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "previous-hop"):
                                            self.previous_hop = value
                                            self.previous_hop.value_namespace = name_space
                                            self.previous_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id-extension"):
                                            self.tunnel_id_extension = value
                                            self.tunnel_id_extension.value_namespace = name_space
                                            self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-lsp-id"):
                                            self.tunnel_lsp_id = value
                                            self.tunnel_lsp_id.value_namespace = name_space
                                            self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-source"):
                                            self.tunnel_source = value
                                            self.tunnel_source.value_namespace = name_space
                                            self.tunnel_source.value_namespace_prefix = name_space_prefix


                                class MldPv4Data(Entity):
                                    """
                                    MLDPv4 LSM\-ID context
                                    
                                    .. attribute:: lsm_id
                                    
                                    	LSM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: peer_label_space_id
                                    
                                    	Peer Label Space Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: peer_lsrid
                                    
                                    	Peer LSR Id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: type
                                    
                                    	LSM ID Type
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__init__()

                                        self.yang_name = "mld-pv4-data"
                                        self.yang_parent_name = "label-context"

                                        self.lsm_id = YLeaf(YType.uint32, "lsm-id")

                                        self.peer_label_space_id = YLeaf(YType.uint16, "peer-label-space-id")

                                        self.peer_lsrid = YLeaf(YType.str, "peer-lsrid")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.type = YLeaf(YType.uint16, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("lsm_id",
                                                        "peer_label_space_id",
                                                        "peer_lsrid",
                                                        "table_id",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.lsm_id.is_set or
                                            self.peer_label_space_id.is_set or
                                            self.peer_lsrid.is_set or
                                            self.table_id.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.lsm_id.yfilter != YFilter.not_set or
                                            self.peer_label_space_id.yfilter != YFilter.not_set or
                                            self.peer_lsrid.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "mld-pv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.lsm_id.is_set or self.lsm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsm_id.get_name_leafdata())
                                        if (self.peer_label_space_id.is_set or self.peer_label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.peer_label_space_id.get_name_leafdata())
                                        if (self.peer_lsrid.is_set or self.peer_lsrid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.peer_lsrid.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsm-id" or name == "peer-label-space-id" or name == "peer-lsrid" or name == "table-id" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "lsm-id"):
                                            self.lsm_id = value
                                            self.lsm_id.value_namespace = name_space
                                            self.lsm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "peer-label-space-id"):
                                            self.peer_label_space_id = value
                                            self.peer_label_space_id.value_namespace = name_space
                                            self.peer_label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "peer-lsrid"):
                                            self.peer_lsrid = value
                                            self.peer_lsrid.value_namespace = name_space
                                            self.peer_lsrid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class PseudowireHeadEndData(Entity):
                                    """
                                    Pseudowire Head\-end label context
                                    
                                    .. attribute:: pwhe_intf
                                    
                                    	Pseudo\-wire Head\-end interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__init__()

                                        self.yang_name = "pseudowire-head-end-data"
                                        self.yang_parent_name = "label-context"

                                        self.pwhe_intf = YLeaf(YType.str, "pwhe-intf")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("pwhe_intf") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.pwhe_intf.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.pwhe_intf.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-head-end-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.pwhe_intf.is_set or self.pwhe_intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pwhe_intf.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "pwhe-intf"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "pwhe-intf"):
                                            self.pwhe_intf = value
                                            self.pwhe_intf.value_namespace = name_space
                                            self.pwhe_intf.value_namespace_prefix = name_space_prefix


                                class TpData(Entity):
                                    """
                                    TP context
                                    
                                    .. attribute:: dest_global_id
                                    
                                    	TP destination global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dest_node_id
                                    
                                    	TP destination node ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: dest_tunnel_id
                                    
                                    	TP destination tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsp_id
                                    
                                    	TP LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: source_global_id
                                    
                                    	TP source global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: source_node_id
                                    
                                    	TP source node ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: source_tunnel_id
                                    
                                    	TP source tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TpData, self).__init__()

                                        self.yang_name = "tp-data"
                                        self.yang_parent_name = "label-context"

                                        self.dest_global_id = YLeaf(YType.uint32, "dest-global-id")

                                        self.dest_node_id = YLeaf(YType.str, "dest-node-id")

                                        self.dest_tunnel_id = YLeaf(YType.uint16, "dest-tunnel-id")

                                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                        self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                                        self.source_node_id = YLeaf(YType.str, "source-node-id")

                                        self.source_tunnel_id = YLeaf(YType.uint16, "source-tunnel-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("dest_global_id",
                                                        "dest_node_id",
                                                        "dest_tunnel_id",
                                                        "lsp_id",
                                                        "source_global_id",
                                                        "source_node_id",
                                                        "source_tunnel_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.dest_global_id.is_set or
                                            self.dest_node_id.is_set or
                                            self.dest_tunnel_id.is_set or
                                            self.lsp_id.is_set or
                                            self.source_global_id.is_set or
                                            self.source_node_id.is_set or
                                            self.source_tunnel_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.dest_global_id.yfilter != YFilter.not_set or
                                            self.dest_node_id.yfilter != YFilter.not_set or
                                            self.dest_tunnel_id.yfilter != YFilter.not_set or
                                            self.lsp_id.yfilter != YFilter.not_set or
                                            self.source_global_id.yfilter != YFilter.not_set or
                                            self.source_node_id.yfilter != YFilter.not_set or
                                            self.source_tunnel_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tp-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.dest_global_id.is_set or self.dest_global_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dest_global_id.get_name_leafdata())
                                        if (self.dest_node_id.is_set or self.dest_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dest_node_id.get_name_leafdata())
                                        if (self.dest_tunnel_id.is_set or self.dest_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dest_tunnel_id.get_name_leafdata())
                                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsp_id.get_name_leafdata())
                                        if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source_global_id.get_name_leafdata())
                                        if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source_node_id.get_name_leafdata())
                                        if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dest-global-id" or name == "dest-node-id" or name == "dest-tunnel-id" or name == "lsp-id" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "dest-global-id"):
                                            self.dest_global_id = value
                                            self.dest_global_id.value_namespace = name_space
                                            self.dest_global_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dest-node-id"):
                                            self.dest_node_id = value
                                            self.dest_node_id.value_namespace = name_space
                                            self.dest_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dest-tunnel-id"):
                                            self.dest_tunnel_id = value
                                            self.dest_tunnel_id.value_namespace = name_space
                                            self.dest_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsp-id"):
                                            self.lsp_id = value
                                            self.lsp_id.value_namespace = name_space
                                            self.lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source-global-id"):
                                            self.source_global_id = value
                                            self.source_global_id.value_namespace = name_space
                                            self.source_global_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source-node-id"):
                                            self.source_node_id = value
                                            self.source_node_id.value_namespace = name_space
                                            self.source_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source-tunnel-id"):
                                            self.source_tunnel_id = value
                                            self.source_tunnel_id.value_namespace = name_space
                                            self.source_tunnel_id.value_namespace_prefix = name_space_prefix


                                class GenericRoutingEncapsulation(Entity):
                                    """
                                    Generic routing encapsulation context
                                    
                                    .. attribute:: gre_interface
                                    
                                    	Generic routing encapsulation interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__init__()

                                        self.yang_name = "generic-routing-encapsulation"
                                        self.yang_parent_name = "label-context"

                                        self.gre_interface = YLeaf(YType.str, "gre-interface")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("gre_interface") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.gre_interface.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.gre_interface.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "generic-routing-encapsulation" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.gre_interface.is_set or self.gre_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gre_interface.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "gre-interface"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "gre-interface"):
                                            self.gre_interface = value
                                            self.gre_interface.value_namespace = name_space
                                            self.gre_interface.value_namespace_prefix = name_space_prefix


                                class Ipv6GenericRoutingEncapsulation(Entity):
                                    """
                                    Generic routing encapsulation context
                                    
                                    .. attribute:: greipv6_interface
                                    
                                    	Generic routing encapsulation IPv6 interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__init__()

                                        self.yang_name = "ipv6-generic-routing-encapsulation"
                                        self.yang_parent_name = "label-context"

                                        self.greipv6_interface = YLeaf(YType.str, "greipv6-interface")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("greipv6_interface") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.greipv6_interface.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.greipv6_interface.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-generic-routing-encapsulation" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.greipv6_interface.is_set or self.greipv6_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.greipv6_interface.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "greipv6-interface"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "greipv6-interface"):
                                            self.greipv6_interface = value
                                            self.greipv6_interface.value_namespace = name_space
                                            self.greipv6_interface.value_namespace_prefix = name_space_prefix


                                class EvpnData(Entity):
                                    """
                                    EVPN context
                                    
                                    .. attribute:: ethernet_segment
                                    
                                    	Ethernet Segment ID
                                    	**type**\:  str
                                    
                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                    
                                    .. attribute:: evpn_id
                                    
                                    	EVPN ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: evpn_tag
                                    
                                    	EVPN TAG
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.EvpnData, self).__init__()

                                        self.yang_name = "evpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.ethernet_segment = YLeaf(YType.str, "ethernet-segment")

                                        self.evpn_id = YLeaf(YType.uint32, "evpn-id")

                                        self.evpn_tag = YLeaf(YType.uint32, "evpn-tag")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ethernet_segment",
                                                        "evpn_id",
                                                        "evpn_tag") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ethernet_segment.is_set or
                                            self.evpn_id.is_set or
                                            self.evpn_tag.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ethernet_segment.yfilter != YFilter.not_set or
                                            self.evpn_id.yfilter != YFilter.not_set or
                                            self.evpn_tag.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "evpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ethernet_segment.is_set or self.ethernet_segment.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ethernet_segment.get_name_leafdata())
                                        if (self.evpn_id.is_set or self.evpn_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.evpn_id.get_name_leafdata())
                                        if (self.evpn_tag.is_set or self.evpn_tag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.evpn_tag.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ethernet-segment" or name == "evpn-id" or name == "evpn-tag"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ethernet-segment"):
                                            self.ethernet_segment = value
                                            self.ethernet_segment.value_namespace = name_space
                                            self.ethernet_segment.value_namespace_prefix = name_space_prefix
                                        if(value_path == "evpn-id"):
                                            self.evpn_id = value
                                            self.evpn_id.value_namespace = name_space
                                            self.evpn_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "evpn-tag"):
                                            self.evpn_tag = value
                                            self.evpn_tag.value_namespace = name_space
                                            self.evpn_tag.value_namespace_prefix = name_space_prefix


                                class Ipv4BlbData(Entity):
                                    """
                                    BFD BLB label context
                                    
                                    .. attribute:: blb_intf
                                    
                                    	BFD BLB interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv4 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__init__()

                                        self.yang_name = "ipv4blb-data"
                                        self.yang_parent_name = "label-context"

                                        self.blb_intf = YLeaf(YType.str, "blb-intf")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("blb_intf",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.blb_intf.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.blb_intf.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4blb-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "blb-intf" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "blb-intf"):
                                            self.blb_intf = value
                                            self.blb_intf.value_namespace = name_space
                                            self.blb_intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix


                                class Ipv6BlbData(Entity):
                                    """
                                    BFD BLB label context
                                    
                                    .. attribute:: blb_intf
                                    
                                    	BFD BLB interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv6 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__init__()

                                        self.yang_name = "ipv6blb-data"
                                        self.yang_parent_name = "label-context"

                                        self.blb_intf = YLeaf(YType.str, "blb-intf")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("blb_intf",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.blb_intf.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.blb_intf.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6blb-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "blb-intf" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "blb-intf"):
                                            self.blb_intf = value
                                            self.blb_intf.value_namespace = name_space
                                            self.blb_intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix


                                class PiMiPmsiData(Entity):
                                    """
                                    PIM I\-PMSI label conext
                                    
                                    .. attribute:: head
                                    
                                    	Head
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: v6
                                    
                                    	PIM6
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: vrf_id
                                    
                                    	VRF ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__init__()

                                        self.yang_name = "pi-mi-pmsi-data"
                                        self.yang_parent_name = "label-context"

                                        self.head = YLeaf(YType.int32, "head")

                                        self.v6 = YLeaf(YType.int32, "v6")

                                        self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("head",
                                                        "v6",
                                                        "vrf_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.head.is_set or
                                            self.v6.is_set or
                                            self.vrf_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.head.yfilter != YFilter.not_set or
                                            self.v6.yfilter != YFilter.not_set or
                                            self.vrf_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pi-mi-pmsi-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.head.get_name_leafdata())
                                        if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.v6.get_name_leafdata())
                                        if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "head" or name == "v6" or name == "vrf-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "head"):
                                            self.head = value
                                            self.head.value_namespace = name_space
                                            self.head.value_namespace_prefix = name_space_prefix
                                        if(value_path == "v6"):
                                            self.v6 = value
                                            self.v6.value_namespace = name_space
                                            self.v6.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-id"):
                                            self.vrf_id = value
                                            self.vrf_id.value_namespace = name_space
                                            self.vrf_id.value_namespace_prefix = name_space_prefix


                                class PiMsPmsiData(Entity):
                                    """
                                    PIM S\-PMSI label conext
                                    
                                    .. attribute:: head
                                    
                                    	Head
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: hli
                                    
                                    	Head LSM\-ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: seg
                                    
                                    	Segmented Multicast
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: source
                                    
                                    	Originating Router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: v6
                                    
                                    	PIM6
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: vrf_id
                                    
                                    	VRF ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__init__()

                                        self.yang_name = "pi-ms-pmsi-data"
                                        self.yang_parent_name = "label-context"

                                        self.head = YLeaf(YType.int32, "head")

                                        self.hli = YLeaf(YType.uint32, "hli")

                                        self.seg = YLeaf(YType.int32, "seg")

                                        self.source = YLeaf(YType.str, "source")

                                        self.v6 = YLeaf(YType.int32, "v6")

                                        self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("head",
                                                        "hli",
                                                        "seg",
                                                        "source",
                                                        "v6",
                                                        "vrf_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.head.is_set or
                                            self.hli.is_set or
                                            self.seg.is_set or
                                            self.source.is_set or
                                            self.v6.is_set or
                                            self.vrf_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.head.yfilter != YFilter.not_set or
                                            self.hli.yfilter != YFilter.not_set or
                                            self.seg.yfilter != YFilter.not_set or
                                            self.source.yfilter != YFilter.not_set or
                                            self.v6.yfilter != YFilter.not_set or
                                            self.vrf_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pi-ms-pmsi-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.head.get_name_leafdata())
                                        if (self.hli.is_set or self.hli.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hli.get_name_leafdata())
                                        if (self.seg.is_set or self.seg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.seg.get_name_leafdata())
                                        if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source.get_name_leafdata())
                                        if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.v6.get_name_leafdata())
                                        if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "head" or name == "hli" or name == "seg" or name == "source" or name == "v6" or name == "vrf-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "head"):
                                            self.head = value
                                            self.head.value_namespace = name_space
                                            self.head.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hli"):
                                            self.hli = value
                                            self.hli.value_namespace = name_space
                                            self.hli.value_namespace_prefix = name_space_prefix
                                        if(value_path == "seg"):
                                            self.seg = value
                                            self.seg.value_namespace = name_space
                                            self.seg.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source"):
                                            self.source = value
                                            self.source.value_namespace = name_space
                                            self.source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "v6"):
                                            self.v6 = value
                                            self.v6.value_namespace = name_space
                                            self.v6.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-id"):
                                            self.vrf_id = value
                                            self.vrf_id.value_namespace = name_space
                                            self.vrf_id.value_namespace_prefix = name_space_prefix


                                class NextHopSetL3Vpn(Entity):
                                    """
                                    L3VPN NH SET label context
                                    
                                    .. attribute:: next_hop_set_id
                                    
                                    	Next Hop Set ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__init__()

                                        self.yang_name = "next-hop-set-l3vpn"
                                        self.yang_parent_name = "label-context"

                                        self.next_hop_set_id = YLeaf(YType.uint32, "next-hop-set-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("next_hop_set_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.next_hop_set_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.next_hop_set_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "next-hop-set-l3vpn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.next_hop_set_id.is_set or self.next_hop_set_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_set_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "next-hop-set-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "next-hop-set-id"):
                                            self.next_hop_set_id = value
                                            self.next_hop_set_id.value_namespace = name_space
                                            self.next_hop_set_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class SrPrefixSegment(Entity):
                                    """
                                    SR Prefix Segment context
                                    
                                    .. attribute:: segment_id
                                    
                                    	Prefix Segment ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__init__()

                                        self.yang_name = "sr-prefix-segment"
                                        self.yang_parent_name = "label-context"

                                        self.segment_id = YLeaf(YType.uint32, "segment-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("segment_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.segment_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.segment_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-prefix-segment" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.segment_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "segment-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "segment-id"):
                                            self.segment_id = value
                                            self.segment_id.value_namespace = name_space
                                            self.segment_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class SrAdjSegmentIpv4(Entity):
                                    """
                                    SR Adj Segment ipv4 context
                                    
                                    .. attribute:: addr
                                    
                                    	Adjacency nexthop IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: index
                                    
                                    	Adjacency index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: intf
                                    
                                    	Adjacency interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: type
                                    
                                    	Adjacency type
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__init__()

                                        self.yang_name = "sr-adj-segment-ipv4"
                                        self.yang_parent_name = "label-context"

                                        self.addr = YLeaf(YType.str, "addr")

                                        self.index = YLeaf(YType.uint32, "index")

                                        self.intf = YLeaf(YType.str, "intf")

                                        self.type = YLeaf(YType.uint32, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("addr",
                                                        "index",
                                                        "intf",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.addr.is_set or
                                            self.index.is_set or
                                            self.intf.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.addr.yfilter != YFilter.not_set or
                                            self.index.yfilter != YFilter.not_set or
                                            self.intf.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-adj-segment-ipv4" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.addr.get_name_leafdata())
                                        if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.index.get_name_leafdata())
                                        if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.intf.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "addr"):
                                            self.addr = value
                                            self.addr.value_namespace = name_space
                                            self.addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "index"):
                                            self.index = value
                                            self.index.value_namespace = name_space
                                            self.index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "intf"):
                                            self.intf = value
                                            self.intf.value_namespace = name_space
                                            self.intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class SrAdjSegmentIpv6(Entity):
                                    """
                                    SR Adj Segment ipv6 context
                                    
                                    .. attribute:: addr
                                    
                                    	Adjacency nexthop IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: index
                                    
                                    	Adjacency index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: intf
                                    
                                    	Adjacency interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: type
                                    
                                    	Adjacency type
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__init__()

                                        self.yang_name = "sr-adj-segment-ipv6"
                                        self.yang_parent_name = "label-context"

                                        self.addr = YLeaf(YType.str, "addr")

                                        self.index = YLeaf(YType.uint32, "index")

                                        self.intf = YLeaf(YType.str, "intf")

                                        self.type = YLeaf(YType.uint32, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("addr",
                                                        "index",
                                                        "intf",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.addr.is_set or
                                            self.index.is_set or
                                            self.intf.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.addr.yfilter != YFilter.not_set or
                                            self.index.yfilter != YFilter.not_set or
                                            self.intf.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-adj-segment-ipv6" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.addr.get_name_leafdata())
                                        if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.index.get_name_leafdata())
                                        if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.intf.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "addr"):
                                            self.addr = value
                                            self.addr.value_namespace = name_space
                                            self.addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "index"):
                                            self.index = value
                                            self.index.value_namespace = name_space
                                            self.index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "intf"):
                                            self.intf = value
                                            self.intf.value_namespace = name_space
                                            self.intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class LabelBlockSrgbData(Entity):
                                    """
                                    Label block SRGB context
                                    
                                    .. attribute:: offset
                                    
                                    	Offset
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: size
                                    
                                    	Number of labels
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: start_label
                                    
                                    	Start Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__init__()

                                        self.yang_name = "label-block-srgb-data"
                                        self.yang_parent_name = "label-context"

                                        self.offset = YLeaf(YType.uint32, "offset")

                                        self.size = YLeaf(YType.uint32, "size")

                                        self.start_label = YLeaf(YType.uint32, "start-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("offset",
                                                        "size",
                                                        "start_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.offset.is_set or
                                            self.size.is_set or
                                            self.start_label.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.offset.yfilter != YFilter.not_set or
                                            self.size.yfilter != YFilter.not_set or
                                            self.start_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "label-block-srgb-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.offset.get_name_leafdata())
                                        if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.size.get_name_leafdata())
                                        if (self.start_label.is_set or self.start_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.start_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "offset" or name == "size" or name == "start-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "offset"):
                                            self.offset = value
                                            self.offset.value_namespace = name_space
                                            self.offset.value_namespace_prefix = name_space_prefix
                                        if(value_path == "size"):
                                            self.size = value
                                            self.size.value_namespace = name_space
                                            self.size.value_namespace_prefix = name_space_prefix
                                        if(value_path == "start-label"):
                                            self.start_label = value
                                            self.start_label.value_namespace = name_space
                                            self.start_label.value_namespace_prefix = name_space_prefix


                                class TeBinding(Entity):
                                    """
                                    MPLS TE tunnel binding context
                                    
                                    .. attribute:: te_identifier
                                    
                                    	MPLS Traffic Engineering Tunnel or Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_type
                                    
                                    	Type of identifier for the binding
                                    	**type**\:   :py:class:`MgmtLsdTeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdTeBinding>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TeBinding, self).__init__()

                                        self.yang_name = "te-binding"
                                        self.yang_parent_name = "label-context"

                                        self.te_identifier = YLeaf(YType.uint32, "te-identifier")

                                        self.te_type = YLeaf(YType.enumeration, "te-type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("te_identifier",
                                                        "te_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.te_identifier.is_set or
                                            self.te_type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.te_identifier.yfilter != YFilter.not_set or
                                            self.te_type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "te-binding" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.te_identifier.is_set or self.te_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_identifier.get_name_leafdata())
                                        if (self.te_type.is_set or self.te_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "te-identifier" or name == "te-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "te-identifier"):
                                            self.te_identifier = value
                                            self.te_identifier.value_namespace = name_space
                                            self.te_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-type"):
                                            self.te_type = value
                                            self.te_type.value_namespace = name_space
                                            self.te_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_context_type.is_set or
                                        (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_data()) or
                                        (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_data()) or
                                        (self.evpn_data is not None and self.evpn_data.has_data()) or
                                        (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_data()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                        (self.ipv4blb_data is not None and self.ipv4blb_data.has_data()) or
                                        (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_data()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                        (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_data()) or
                                        (self.ipv6blb_data is not None and self.ipv6blb_data.has_data()) or
                                        (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_data()) or
                                        (self.label_block_data is not None and self.label_block_data.has_data()) or
                                        (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_data()) or
                                        (self.mld_pv4_data is not None and self.mld_pv4_data.has_data()) or
                                        (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_data()) or
                                        (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_data()) or
                                        (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_data()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                        (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_data()) or
                                        (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_data()) or
                                        (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_data()) or
                                        (self.te_binding is not None and self.te_binding.has_data()) or
                                        (self.tev4_data is not None and self.tev4_data.has_data()) or
                                        (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_data()) or
                                        (self.tp_data is not None and self.tp_data.has_data()) or
                                        (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_context_type.yfilter != YFilter.not_set or
                                        (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_operation()) or
                                        (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_operation()) or
                                        (self.evpn_data is not None and self.evpn_data.has_operation()) or
                                        (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_operation()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                        (self.ipv4blb_data is not None and self.ipv4blb_data.has_operation()) or
                                        (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_operation()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                        (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_operation()) or
                                        (self.ipv6blb_data is not None and self.ipv6blb_data.has_operation()) or
                                        (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_operation()) or
                                        (self.label_block_data is not None and self.label_block_data.has_operation()) or
                                        (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_operation()) or
                                        (self.mld_pv4_data is not None and self.mld_pv4_data.has_operation()) or
                                        (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_operation()) or
                                        (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_operation()) or
                                        (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_operation()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                        (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_operation()) or
                                        (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_operation()) or
                                        (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_operation()) or
                                        (self.te_binding is not None and self.te_binding.has_operation()) or
                                        (self.tev4_data is not None and self.tev4_data.has_operation()) or
                                        (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_operation()) or
                                        (self.tp_data is not None and self.tp_data.has_operation()) or
                                        (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-context" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_context_type.is_set or self.label_context_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_context_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cev4l3vpn-data"):
                                        if (self.cev4l3vpn_data is None):
                                            self.cev4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                            self.cev4l3vpn_data.parent = self
                                            self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                        return self.cev4l3vpn_data

                                    if (child_yang_name == "cev6l3vpn-data"):
                                        if (self.cev6l3vpn_data is None):
                                            self.cev6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                            self.cev6l3vpn_data.parent = self
                                            self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                        return self.cev6l3vpn_data

                                    if (child_yang_name == "evpn-data"):
                                        if (self.evpn_data is None):
                                            self.evpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.EvpnData()
                                            self.evpn_data.parent = self
                                            self._children_name_map["evpn_data"] = "evpn-data"
                                        return self.evpn_data

                                    if (child_yang_name == "generic-routing-encapsulation"):
                                        if (self.generic_routing_encapsulation is None):
                                            self.generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                            self.generic_routing_encapsulation.parent = self
                                            self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                        return self.generic_routing_encapsulation

                                    if (child_yang_name == "ip-sub-data"):
                                        if (self.ip_sub_data is None):
                                            self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.IpSubData()
                                            self.ip_sub_data.parent = self
                                            self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                        return self.ip_sub_data

                                    if (child_yang_name == "ipv4-data"):
                                        if (self.ipv4_data is None):
                                            self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                            self.ipv4_data.parent = self
                                            self._children_name_map["ipv4_data"] = "ipv4-data"
                                        return self.ipv4_data

                                    if (child_yang_name == "ipv4blb-data"):
                                        if (self.ipv4blb_data is None):
                                            self.ipv4blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                            self.ipv4blb_data.parent = self
                                            self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                        return self.ipv4blb_data

                                    if (child_yang_name == "ipv4l3vpn-data"):
                                        if (self.ipv4l3vpn_data is None):
                                            self.ipv4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                            self.ipv4l3vpn_data.parent = self
                                            self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                        return self.ipv4l3vpn_data

                                    if (child_yang_name == "ipv6-data"):
                                        if (self.ipv6_data is None):
                                            self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                            self.ipv6_data.parent = self
                                            self._children_name_map["ipv6_data"] = "ipv6-data"
                                        return self.ipv6_data

                                    if (child_yang_name == "ipv6-generic-routing-encapsulation"):
                                        if (self.ipv6_generic_routing_encapsulation is None):
                                            self.ipv6_generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                            self.ipv6_generic_routing_encapsulation.parent = self
                                            self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                        return self.ipv6_generic_routing_encapsulation

                                    if (child_yang_name == "ipv6blb-data"):
                                        if (self.ipv6blb_data is None):
                                            self.ipv6blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                            self.ipv6blb_data.parent = self
                                            self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                        return self.ipv6blb_data

                                    if (child_yang_name == "ipv6l3vpn-data"):
                                        if (self.ipv6l3vpn_data is None):
                                            self.ipv6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                            self.ipv6l3vpn_data.parent = self
                                            self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                        return self.ipv6l3vpn_data

                                    if (child_yang_name == "label-block-data"):
                                        if (self.label_block_data is None):
                                            self.label_block_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                            self.label_block_data.parent = self
                                            self._children_name_map["label_block_data"] = "label-block-data"
                                        return self.label_block_data

                                    if (child_yang_name == "label-block-srgb-data"):
                                        if (self.label_block_srgb_data is None):
                                            self.label_block_srgb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                            self.label_block_srgb_data.parent = self
                                            self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                        return self.label_block_srgb_data

                                    if (child_yang_name == "mld-pv4-data"):
                                        if (self.mld_pv4_data is None):
                                            self.mld_pv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                            self.mld_pv4_data.parent = self
                                            self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                        return self.mld_pv4_data

                                    if (child_yang_name == "next-hop-set-l3vpn"):
                                        if (self.next_hop_set_l3vpn is None):
                                            self.next_hop_set_l3vpn = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                            self.next_hop_set_l3vpn.parent = self
                                            self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                        return self.next_hop_set_l3vpn

                                    if (child_yang_name == "pi-mi-pmsi-data"):
                                        if (self.pi_mi_pmsi_data is None):
                                            self.pi_mi_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                            self.pi_mi_pmsi_data.parent = self
                                            self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                        return self.pi_mi_pmsi_data

                                    if (child_yang_name == "pi-ms-pmsi-data"):
                                        if (self.pi_ms_pmsi_data is None):
                                            self.pi_ms_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                            self.pi_ms_pmsi_data.parent = self
                                            self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                        return self.pi_ms_pmsi_data

                                    if (child_yang_name == "pseudowire-data"):
                                        if (self.pseudowire_data is None):
                                            self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireData()
                                            self.pseudowire_data.parent = self
                                            self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                        return self.pseudowire_data

                                    if (child_yang_name == "pseudowire-head-end-data"):
                                        if (self.pseudowire_head_end_data is None):
                                            self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                            self.pseudowire_head_end_data.parent = self
                                            self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                        return self.pseudowire_head_end_data

                                    if (child_yang_name == "sr-adj-segment-ipv4"):
                                        if (self.sr_adj_segment_ipv4 is None):
                                            self.sr_adj_segment_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                            self.sr_adj_segment_ipv4.parent = self
                                            self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                        return self.sr_adj_segment_ipv4

                                    if (child_yang_name == "sr-adj-segment-ipv6"):
                                        if (self.sr_adj_segment_ipv6 is None):
                                            self.sr_adj_segment_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                            self.sr_adj_segment_ipv6.parent = self
                                            self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                        return self.sr_adj_segment_ipv6

                                    if (child_yang_name == "sr-prefix-segment"):
                                        if (self.sr_prefix_segment is None):
                                            self.sr_prefix_segment = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                            self.sr_prefix_segment.parent = self
                                            self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                        return self.sr_prefix_segment

                                    if (child_yang_name == "te-binding"):
                                        if (self.te_binding is None):
                                            self.te_binding = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TeBinding()
                                            self.te_binding.parent = self
                                            self._children_name_map["te_binding"] = "te-binding"
                                        return self.te_binding

                                    if (child_yang_name == "tev4-data"):
                                        if (self.tev4_data is None):
                                            self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4Data()
                                            self.tev4_data.parent = self
                                            self._children_name_map["tev4_data"] = "tev4-data"
                                        return self.tev4_data

                                    if (child_yang_name == "tev4p2mp-data"):
                                        if (self.tev4p2mp_data is None):
                                            self.tev4p2mp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                            self.tev4p2mp_data.parent = self
                                            self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                        return self.tev4p2mp_data

                                    if (child_yang_name == "tp-data"):
                                        if (self.tp_data is None):
                                            self.tp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TpData()
                                            self.tp_data.parent = self
                                            self._children_name_map["tp_data"] = "tp-data"
                                        return self.tp_data

                                    if (child_yang_name == "vrf-l3vpn-data"):
                                        if (self.vrf_l3vpn_data is None):
                                            self.vrf_l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                            self.vrf_l3vpn_data.parent = self
                                            self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                        return self.vrf_l3vpn_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cev4l3vpn-data" or name == "cev6l3vpn-data" or name == "evpn-data" or name == "generic-routing-encapsulation" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv4blb-data" or name == "ipv4l3vpn-data" or name == "ipv6-data" or name == "ipv6-generic-routing-encapsulation" or name == "ipv6blb-data" or name == "ipv6l3vpn-data" or name == "label-block-data" or name == "label-block-srgb-data" or name == "mld-pv4-data" or name == "next-hop-set-l3vpn" or name == "pi-mi-pmsi-data" or name == "pi-ms-pmsi-data" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "sr-adj-segment-ipv4" or name == "sr-adj-segment-ipv6" or name == "sr-prefix-segment" or name == "te-binding" or name == "tev4-data" or name == "tev4p2mp-data" or name == "tp-data" or name == "vrf-l3vpn-data" or name == "label-context-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-context-type"):
                                        self.label_context_type = value
                                        self.label_context_type.value_namespace = name_space
                                        self.label_context_type.value_namespace_prefix = name_space_prefix


                            class LocalLabelRewrite(Entity):
                                """
                                Local label rewrite information
                                
                                .. attribute:: label_data
                                
                                	label data
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LocalLabelRewrite, self).__init__()

                                    self.yang_name = "local-label-rewrite"
                                    self.yang_parent_name = "rewrite-id"

                                    self.label_data = YLeafList(YType.uint32, "label-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_data") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)

                                def has_data(self):
                                    for leaf in self.label_data.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    return False

                                def has_operation(self):
                                    for leaf in self.label_data.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_data.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "local-label-rewrite" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    leaf_name_data.extend(self.label_data.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "label-data"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-data"):
                                        self.label_data.append(value)

                            def has_data(self):
                                return (
                                    self.rewrite_id_type.is_set or
                                    (self.label_context is not None and self.label_context.has_data()) or
                                    (self.local_label_rewrite is not None and self.local_label_rewrite.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rewrite_id_type.yfilter != YFilter.not_set or
                                    (self.label_context is not None and self.label_context.has_operation()) or
                                    (self.local_label_rewrite is not None and self.local_label_rewrite.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "rewrite-id" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rewrite_id_type.is_set or self.rewrite_id_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rewrite_id_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "label-context"):
                                    if (self.label_context is None):
                                        self.label_context = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext()
                                        self.label_context.parent = self
                                        self._children_name_map["label_context"] = "label-context"
                                    return self.label_context

                                if (child_yang_name == "local-label-rewrite"):
                                    if (self.local_label_rewrite is None):
                                        self.local_label_rewrite = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LocalLabelRewrite()
                                        self.local_label_rewrite.parent = self
                                        self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                                    return self.local_label_rewrite

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "label-context" or name == "local-label-rewrite" or name == "rewrite-id-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rewrite-id-type"):
                                    self.rewrite_id_type = value
                                    self.rewrite_id_type.value_namespace = name_space
                                    self.rewrite_id_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.rewrite_id is not None and self.rewrite_id.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rewrite-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "rewrite-id"):
                                if (self.rewrite_id is None):
                                    self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId()
                                    self.rewrite_id.parent = self
                                    self._children_name_map["rewrite_id"] = "rewrite-id"
                                return self.rewrite_id

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "rewrite-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class AssociatedFpi(Entity):
                        """
                        Associated FPI
                        
                        .. attribute:: application_owner
                        
                        	Application owner instance
                        	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.ApplicationOwner>`
                        
                        .. attribute:: fpi
                        
                        	FPI
                        	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi, self).__init__()

                            self.yang_name = "associated-fpi"
                            self.yang_parent_name = "rewrite-te"

                            self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi()
                            self.fpi.parent = self
                            self._children_name_map["fpi"] = "fpi"
                            self._children_yang_names.add("fpi")

                            self.application_owner = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi, self).__setattr__(name, value)


                        class Fpi(Entity):
                            """
                            FPI
                            
                            .. attribute:: dmtc_ext_intf_data
                            
                            	dmtc ext intf data
                            	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.DmtcExtIntfData>`
                            
                            .. attribute:: fpi_type
                            
                            	FPIType
                            	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                            
                            .. attribute:: ipv4_data
                            
                            	ipv4 data
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv4Data>`
                            
                            .. attribute:: ipv6_data
                            
                            	ipv6 data
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv6Data>`
                            
                            .. attribute:: label_data
                            
                            	label data
                            	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.LabelData>`
                            
                            .. attribute:: pw_list_data
                            
                            	pw list data
                            	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.PwListData>`
                            
                            .. attribute:: te_data
                            
                            	te data
                            	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.TeData>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi, self).__init__()

                                self.yang_name = "fpi"
                                self.yang_parent_name = "associated-fpi"

                                self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                                self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.DmtcExtIntfData()
                                self.dmtc_ext_intf_data.parent = self
                                self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                self._children_yang_names.add("dmtc-ext-intf-data")

                                self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.LabelData()
                                self.label_data.parent = self
                                self._children_name_map["label_data"] = "label-data"
                                self._children_yang_names.add("label-data")

                                self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.PwListData()
                                self.pw_list_data.parent = self
                                self._children_name_map["pw_list_data"] = "pw-list-data"
                                self._children_yang_names.add("pw-list-data")

                                self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.TeData()
                                self.te_data.parent = self
                                self._children_name_map["te_data"] = "te-data"
                                self._children_yang_names.add("te-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fpi_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi, self).__setattr__(name, value)


                            class LabelData(Entity):
                                """
                                label data
                                
                                .. attribute:: elc
                                
                                	ELC
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: label
                                
                                	Label value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.LabelData, self).__init__()

                                    self.yang_name = "label-data"
                                    self.yang_parent_name = "fpi"

                                    self.elc = YLeaf(YType.int32, "elc")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("elc",
                                                    "label",
                                                    "security_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.elc.is_set or
                                        self.label.is_set or
                                        self.security_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.elc.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.elc.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "elc" or name == "label" or name == "security-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "elc"):
                                        self.elc = value
                                        self.elc.value_namespace = name_space
                                        self.elc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix


                            class TeData(Entity):
                                """
                                te data
                                
                                .. attribute:: local_label
                                
                                	Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_interface
                                
                                	Tunnel interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.TeData, self).__init__()

                                    self.yang_name = "te-data"
                                    self.yang_parent_name = "fpi"

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("local_label",
                                                    "tunnel_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.local_label.is_set or
                                        self.tunnel_interface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.tunnel_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "local-label" or name == "tunnel-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface"):
                                        self.tunnel_interface = value
                                        self.tunnel_interface.value_namespace = name_space
                                        self.tunnel_interface.value_namespace_prefix = name_space_prefix


                            class Ipv4Data(Entity):
                                """
                                ipv4 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: sr_local_label
                                
                                	SR related Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "sr_local_label",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.sr_local_label.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.sr_local_label.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sr-local-label"):
                                        self.sr_local_label = value
                                        self.sr_local_label.value_namespace = name_space
                                        self.sr_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                ipv6 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: router_flags
                                
                                	Route flags
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    self.router_flags = YLeaf(YType.uint32, "router-flags")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_len",
                                                    "router_flags",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_len.is_set or
                                        self.router_flags.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set or
                                        self.router_flags.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                    if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_flags.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-flags"):
                                        self.router_flags = value
                                        self.router_flags.value_namespace = name_space
                                        self.router_flags.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class PwListData(Entity):
                                """
                                pw list data
                                
                                .. attribute:: pwhe_list_id
                                
                                	Pseudowire List Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.PwListData, self).__init__()

                                    self.yang_name = "pw-list-data"
                                    self.yang_parent_name = "fpi"

                                    self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("pwhe_list_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.pwhe_list_id.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.pwhe_list_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pw-list-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "pwhe-list-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "pwhe-list-id"):
                                        self.pwhe_list_id = value
                                        self.pwhe_list_id.value_namespace = name_space
                                        self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                            class DmtcExtIntfData(Entity):
                                """
                                dmtc ext intf data
                                
                                .. attribute:: dmtc_ext_ifh
                                
                                	DMTC External Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.DmtcExtIntfData, self).__init__()

                                    self.yang_name = "dmtc-ext-intf-data"
                                    self.yang_parent_name = "fpi"

                                    self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.dmtc_ext_ifh.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "dmtc-ext-intf-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-ext-ifh"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dmtc-ext-ifh"):
                                        self.dmtc_ext_ifh = value
                                        self.dmtc_ext_ifh.value_namespace = name_space
                                        self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fpi_type.is_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.label_data is not None and self.label_data.has_data()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                    (self.te_data is not None and self.te_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fpi_type.yfilter != YFilter.not_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.label_data is not None and self.label_data.has_operation()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                    (self.te_data is not None and self.te_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fpi" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fpi_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "dmtc-ext-intf-data"):
                                    if (self.dmtc_ext_intf_data is None):
                                        self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.DmtcExtIntfData()
                                        self.dmtc_ext_intf_data.parent = self
                                        self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                    return self.dmtc_ext_intf_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "label-data"):
                                    if (self.label_data is None):
                                        self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.LabelData()
                                        self.label_data.parent = self
                                        self._children_name_map["label_data"] = "label-data"
                                    return self.label_data

                                if (child_yang_name == "pw-list-data"):
                                    if (self.pw_list_data is None):
                                        self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.PwListData()
                                        self.pw_list_data.parent = self
                                        self._children_name_map["pw_list_data"] = "pw-list-data"
                                    return self.pw_list_data

                                if (child_yang_name == "te-data"):
                                    if (self.te_data is None):
                                        self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.TeData()
                                        self.te_data.parent = self
                                        self._children_name_map["te_data"] = "te-data"
                                    return self.te_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fpi-type"):
                                    self.fpi_type = value
                                    self.fpi_type.value_namespace = name_space
                                    self.fpi_type.value_namespace_prefix = name_space_prefix


                        class ApplicationOwner(Entity):
                            """
                            Application owner instance
                            
                            .. attribute:: application_instance
                            
                            	Application instance Name
                            	**type**\:  str
                            
                            .. attribute:: application_name
                            
                            	Application name
                            	**type**\:  str
                            
                            .. attribute:: application_role_primary
                            
                            	Primary/Backup role
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: application_type
                            
                            	Application type
                            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                            
                            .. attribute:: resource_state
                            
                            	Application resource state
                            	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.ApplicationOwner, self).__init__()

                                self.yang_name = "application-owner"
                                self.yang_parent_name = "associated-fpi"

                                self.application_instance = YLeaf(YType.str, "application-instance")

                                self.application_name = YLeaf(YType.str, "application-name")

                                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                                self.application_type = YLeaf(YType.enumeration, "application-type")

                                self.resource_state = YLeaf(YType.enumeration, "resource-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("application_instance",
                                                "application_name",
                                                "application_role_primary",
                                                "application_type",
                                                "resource_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.application_instance.is_set or
                                    self.application_name.is_set or
                                    self.application_role_primary.is_set or
                                    self.application_type.is_set or
                                    self.resource_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.application_instance.yfilter != YFilter.not_set or
                                    self.application_name.yfilter != YFilter.not_set or
                                    self.application_role_primary.yfilter != YFilter.not_set or
                                    self.application_type.yfilter != YFilter.not_set or
                                    self.resource_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "application-owner" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_name.get_name_leafdata())
                                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_type.get_name_leafdata())
                                if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resource_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "application-instance"):
                                    self.application_instance = value
                                    self.application_instance.value_namespace = name_space
                                    self.application_instance.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-name"):
                                    self.application_name = value
                                    self.application_name.value_namespace = name_space
                                    self.application_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-role-primary"):
                                    self.application_role_primary = value
                                    self.application_role_primary.value_namespace = name_space
                                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-type"):
                                    self.application_type = value
                                    self.application_type.value_namespace = name_space
                                    self.application_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "resource-state"):
                                    self.resource_state = value
                                    self.resource_state.value_namespace = name_space
                                    self.resource_state.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.application_owner:
                                if (c.has_data()):
                                    return True
                            return (self.fpi is not None and self.fpi.has_data())

                        def has_operation(self):
                            for c in self.application_owner:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.fpi is not None and self.fpi.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "associated-fpi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "application-owner"):
                                for c in self.application_owner:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.ApplicationOwner()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.application_owner.append(c)
                                return c

                            if (child_yang_name == "fpi"):
                                if (self.fpi is None):
                                    self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi()
                                    self.fpi.parent = self
                                    self._children_name_map["fpi"] = "fpi"
                                return self.fpi

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-owner" or name == "fpi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class V4Rpf(Entity):
                        """
                        IPv4 RPF neighbors
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: v4_rpf_neighbor
                        
                        	V4 RPF Neighbor
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.V4Rpf, self).__init__()

                            self.yang_name = "v4-rpf"
                            self.yang_parent_name = "rewrite-te"

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.v4_rpf_neighbor = YLeaf(YType.str, "v4-rpf-neighbor")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("table_id",
                                            "v4_rpf_neighbor") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.V4Rpf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.V4Rpf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.table_id.is_set or
                                self.v4_rpf_neighbor.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.v4_rpf_neighbor.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "v4-rpf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.v4_rpf_neighbor.is_set or self.v4_rpf_neighbor.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.v4_rpf_neighbor.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "table-id" or name == "v4-rpf-neighbor"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "v4-rpf-neighbor"):
                                self.v4_rpf_neighbor = value
                                self.v4_rpf_neighbor.value_namespace = name_space
                                self.v4_rpf_neighbor.value_namespace_prefix = name_space_prefix


                    class V6Rpf(Entity):
                        """
                        IPv6 RPF neighbors
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: v6_rpf_neighbor
                        
                        	V6 RPF Neighbor
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.V6Rpf, self).__init__()

                            self.yang_name = "v6-rpf"
                            self.yang_parent_name = "rewrite-te"

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.v6_rpf_neighbor = YLeaf(YType.str, "v6-rpf-neighbor")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("table_id",
                                            "v6_rpf_neighbor") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.V6Rpf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.V6Rpf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.table_id.is_set or
                                self.v6_rpf_neighbor.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.v6_rpf_neighbor.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "v6-rpf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.v6_rpf_neighbor.is_set or self.v6_rpf_neighbor.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.v6_rpf_neighbor.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "table-id" or name == "v6-rpf-neighbor"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "v6-rpf-neighbor"):
                                self.v6_rpf_neighbor = value
                                self.v6_rpf_neighbor.value_namespace = name_space
                                self.v6_rpf_neighbor.value_namespace_prefix = name_space_prefix


                    class Mois(Entity):
                        """
                        Mois
                        
                        .. attribute:: application_resource
                        
                        	Application state
                        	**type**\:   :py:class:`ApplicationResource <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.ApplicationResource>`
                        
                        .. attribute:: moi_array
                        
                        	moi array
                        	**type**\: list of    :py:class:`MoiArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois, self).__init__()

                            self.yang_name = "mois"
                            self.yang_parent_name = "rewrite-te"

                            self.application_resource = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.ApplicationResource()
                            self.application_resource.parent = self
                            self._children_name_map["application_resource"] = "application-resource"
                            self._children_yang_names.add("application-resource")

                            self.moi_array = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois, self).__setattr__(name, value)


                        class ApplicationResource(Entity):
                            """
                            Application state
                            
                            .. attribute:: application_instance
                            
                            	Application instance Name
                            	**type**\:  str
                            
                            .. attribute:: application_name
                            
                            	Application name
                            	**type**\:  str
                            
                            .. attribute:: application_role_primary
                            
                            	Primary/Backup role
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: application_type
                            
                            	Application type
                            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                            
                            .. attribute:: resource_state
                            
                            	Application resource state
                            	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.ApplicationResource, self).__init__()

                                self.yang_name = "application-resource"
                                self.yang_parent_name = "mois"

                                self.application_instance = YLeaf(YType.str, "application-instance")

                                self.application_name = YLeaf(YType.str, "application-name")

                                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                                self.application_type = YLeaf(YType.enumeration, "application-type")

                                self.resource_state = YLeaf(YType.enumeration, "resource-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("application_instance",
                                                "application_name",
                                                "application_role_primary",
                                                "application_type",
                                                "resource_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.ApplicationResource, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.ApplicationResource, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.application_instance.is_set or
                                    self.application_name.is_set or
                                    self.application_role_primary.is_set or
                                    self.application_type.is_set or
                                    self.resource_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.application_instance.yfilter != YFilter.not_set or
                                    self.application_name.yfilter != YFilter.not_set or
                                    self.application_role_primary.yfilter != YFilter.not_set or
                                    self.application_type.yfilter != YFilter.not_set or
                                    self.resource_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "application-resource" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_name.get_name_leafdata())
                                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_type.get_name_leafdata())
                                if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resource_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "application-instance"):
                                    self.application_instance = value
                                    self.application_instance.value_namespace = name_space
                                    self.application_instance.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-name"):
                                    self.application_name = value
                                    self.application_name.value_namespace = name_space
                                    self.application_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-role-primary"):
                                    self.application_role_primary = value
                                    self.application_role_primary.value_namespace = name_space
                                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-type"):
                                    self.application_type = value
                                    self.application_type.value_namespace = name_space
                                    self.application_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "resource-state"):
                                    self.resource_state = value
                                    self.resource_state.value_namespace = name_space
                                    self.resource_state.value_namespace_prefix = name_space_prefix


                        class MoiArray(Entity):
                            """
                            moi array
                            
                            .. attribute:: moi
                            
                            	Moi
                            	**type**\:   :py:class:`Moi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray, self).__init__()

                                self.yang_name = "moi-array"
                                self.yang_parent_name = "mois"

                                self.moi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi()
                                self.moi.parent = self
                                self._children_name_map["moi"] = "moi"
                                self._children_yang_names.add("moi")


                            class Moi(Entity):
                                """
                                Moi
                                
                                .. attribute:: dmtc_data
                                
                                	dmtc data
                                	**type**\:   :py:class:`DmtcData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.DmtcData>`
                                
                                .. attribute:: ip_sub_data
                                
                                	ip sub data
                                	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.IpSubData>`
                                
                                .. attribute:: ipv4_data
                                
                                	ipv4 data
                                	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv4Data>`
                                
                                .. attribute:: ipv6_data
                                
                                	ipv6 data
                                	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv6Data>`
                                
                                .. attribute:: moi_type
                                
                                	MoiType
                                	**type**\:   :py:class:`MgmtLsdMoi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdMoi>`
                                
                                .. attribute:: pop_and_lookup_ipv4
                                
                                	pop and lookup ipv4
                                	**type**\:   :py:class:`PopAndLookupIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv4>`
                                
                                .. attribute:: pop_and_lookup_ipv6
                                
                                	pop and lookup ipv6
                                	**type**\:   :py:class:`PopAndLookupIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv6>`
                                
                                .. attribute:: pop_and_lookup_tp
                                
                                	pop and lookup tp
                                	**type**\:   :py:class:`PopAndLookupTp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupTp>`
                                
                                .. attribute:: pseudowire_data
                                
                                	pseudowire data
                                	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireData>`
                                
                                .. attribute:: pseudowire_head_end_data
                                
                                	pseudowire head end data
                                	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireHeadEndData>`
                                
                                .. attribute:: pw_list_data
                                
                                	pw list data
                                	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PwListData>`
                                
                                .. attribute:: stackv4_data
                                
                                	stackv4 data
                                	**type**\:   :py:class:`Stackv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data>`
                                
                                .. attribute:: stackv6_data
                                
                                	stackv6 data
                                	**type**\:   :py:class:`Stackv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data>`
                                
                                .. attribute:: te_head_data
                                
                                	te head data
                                	**type**\:   :py:class:`TeHeadData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.TeHeadData>`
                                
                                .. attribute:: tev4_data
                                
                                	tev4 data
                                	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Tev4Data>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi, self).__init__()

                                    self.yang_name = "moi"
                                    self.yang_parent_name = "moi-array"

                                    self.moi_type = YLeaf(YType.enumeration, "moi-type")

                                    self.dmtc_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.DmtcData()
                                    self.dmtc_data.parent = self
                                    self._children_name_map["dmtc_data"] = "dmtc-data"
                                    self._children_yang_names.add("dmtc-data")

                                    self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.IpSubData()
                                    self.ip_sub_data.parent = self
                                    self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    self._children_yang_names.add("ip-sub-data")

                                    self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                    self._children_yang_names.add("ipv4-data")

                                    self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                    self._children_yang_names.add("ipv6-data")

                                    self.pop_and_lookup_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                    self.pop_and_lookup_ipv4.parent = self
                                    self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                    self._children_yang_names.add("pop-and-lookup-ipv4")

                                    self.pop_and_lookup_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                    self.pop_and_lookup_ipv6.parent = self
                                    self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                    self._children_yang_names.add("pop-and-lookup-ipv6")

                                    self.pop_and_lookup_tp = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupTp()
                                    self.pop_and_lookup_tp.parent = self
                                    self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                    self._children_yang_names.add("pop-and-lookup-tp")

                                    self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireData()
                                    self.pseudowire_data.parent = self
                                    self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    self._children_yang_names.add("pseudowire-data")

                                    self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                    self.pseudowire_head_end_data.parent = self
                                    self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    self._children_yang_names.add("pseudowire-head-end-data")

                                    self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PwListData()
                                    self.pw_list_data.parent = self
                                    self._children_name_map["pw_list_data"] = "pw-list-data"
                                    self._children_yang_names.add("pw-list-data")

                                    self.stackv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data()
                                    self.stackv4_data.parent = self
                                    self._children_name_map["stackv4_data"] = "stackv4-data"
                                    self._children_yang_names.add("stackv4-data")

                                    self.stackv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data()
                                    self.stackv6_data.parent = self
                                    self._children_name_map["stackv6_data"] = "stackv6-data"
                                    self._children_yang_names.add("stackv6-data")

                                    self.te_head_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.TeHeadData()
                                    self.te_head_data.parent = self
                                    self._children_name_map["te_head_data"] = "te-head-data"
                                    self._children_yang_names.add("te-head-data")

                                    self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Tev4Data()
                                    self.tev4_data.parent = self
                                    self._children_name_map["tev4_data"] = "tev4-data"
                                    self._children_yang_names.add("tev4-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("moi_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi, self).__setattr__(name, value)


                                class PopAndLookupIpv4(Entity):
                                    """
                                    pop and lookup ipv4
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__init__()

                                        self.yang_name = "pop-and-lookup-ipv4"
                                        self.yang_parent_name = "moi"

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pop-and-lookup-ipv4" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class PopAndLookupTp(Entity):
                                    """
                                    pop and lookup tp
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupTp, self).__init__()

                                        self.yang_name = "pop-and-lookup-tp"
                                        self.yang_parent_name = "moi"

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("out_label",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.out_label.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pop-and-lookup-tp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "out-label" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class PopAndLookupIpv6(Entity):
                                    """
                                    pop and lookup ipv6
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__init__()

                                        self.yang_name = "pop-and-lookup-ipv6"
                                        self.yang_parent_name = "moi"

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pop-and-lookup-ipv6" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class Ipv4Data(Entity):
                                    """
                                    ipv4 data
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: load_metric
                                    
                                    	Routing path's load metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: local_label
                                    
                                    	TE backup path local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_interface_parent
                                    
                                    	Outgoing Interface's parent
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv4Data, self).__init__()

                                        self.yang_name = "ipv4-data"
                                        self.yang_parent_name = "moi"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.load_metric = YLeaf(YType.uint32, "load-metric")

                                        self.local_label = YLeaf(YType.uint32, "local-label")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv4_next_hop",
                                                        "load_metric",
                                                        "local_label",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_interface_parent",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.load_metric.is_set or
                                            self.local_label.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_interface_parent.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.load_metric.yfilter != YFilter.not_set or
                                            self.local_label.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_interface_parent.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_metric.get_name_leafdata())
                                        if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_label.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-metric"):
                                            self.load_metric = value
                                            self.load_metric.value_namespace = name_space
                                            self.load_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-label"):
                                            self.local_label = value
                                            self.local_label.value_namespace = name_space
                                            self.local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface-parent"):
                                            self.out_interface_parent = value
                                            self.out_interface_parent.value_namespace = name_space
                                            self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix


                                class Ipv6Data(Entity):
                                    """
                                    ipv6 data
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv6_next_hop
                                    
                                    	IPv6 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv6Data, self).__init__()

                                        self.yang_name = "ipv6-data"
                                        self.yang_parent_name = "moi"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv6_next_hop",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv6_next_hop.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv6_next_hop.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6-next-hop"):
                                            self.ipv6_next_hop = value
                                            self.ipv6_next_hop.value_namespace = name_space
                                            self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class Tev4Data(Entity):
                                    """
                                    tev4 data
                                    
                                    .. attribute:: backup_interface
                                    
                                    	Backup interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: backup_ipv4_next_hop
                                    
                                    	Backup IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: backup_local_label
                                    
                                    	Backup local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: data_out_parent_interface
                                    
                                    	Outgoing data parent interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: merge_point_label
                                    
                                    	Merge point label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_class
                                    
                                    	Tunnel class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_interface
                                    
                                    	Tunnel interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: tunnel_weight
                                    
                                    	Tunnel weight
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Tev4Data, self).__init__()

                                        self.yang_name = "tev4-data"
                                        self.yang_parent_name = "moi"

                                        self.backup_interface = YLeaf(YType.str, "backup-interface")

                                        self.backup_ipv4_next_hop = YLeaf(YType.str, "backup-ipv4-next-hop")

                                        self.backup_local_label = YLeaf(YType.uint32, "backup-local-label")

                                        self.data_out_parent_interface = YLeaf(YType.str, "data-out-parent-interface")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.merge_point_label = YLeaf(YType.uint32, "merge-point-label")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_class = YLeaf(YType.uint32, "tunnel-class")

                                        self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                        self.tunnel_weight = YLeaf(YType.uint32, "tunnel-weight")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_interface",
                                                        "backup_ipv4_next_hop",
                                                        "backup_local_label",
                                                        "data_out_parent_interface",
                                                        "ipv4_next_hop",
                                                        "merge_point_label",
                                                        "out_interface",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_class",
                                                        "tunnel_interface",
                                                        "tunnel_weight") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_interface.is_set or
                                            self.backup_ipv4_next_hop.is_set or
                                            self.backup_local_label.is_set or
                                            self.data_out_parent_interface.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.merge_point_label.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_class.is_set or
                                            self.tunnel_interface.is_set or
                                            self.tunnel_weight.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_interface.yfilter != YFilter.not_set or
                                            self.backup_ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.backup_local_label.yfilter != YFilter.not_set or
                                            self.data_out_parent_interface.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.merge_point_label.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_class.yfilter != YFilter.not_set or
                                            self.tunnel_interface.yfilter != YFilter.not_set or
                                            self.tunnel_weight.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tev4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_interface.is_set or self.backup_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_interface.get_name_leafdata())
                                        if (self.backup_ipv4_next_hop.is_set or self.backup_ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_ipv4_next_hop.get_name_leafdata())
                                        if (self.backup_local_label.is_set or self.backup_local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_local_label.get_name_leafdata())
                                        if (self.data_out_parent_interface.is_set or self.data_out_parent_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.data_out_parent_interface.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.merge_point_label.is_set or self.merge_point_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.merge_point_label.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_class.is_set or self.tunnel_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_class.get_name_leafdata())
                                        if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_interface.get_name_leafdata())
                                        if (self.tunnel_weight.is_set or self.tunnel_weight.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_weight.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-interface" or name == "backup-ipv4-next-hop" or name == "backup-local-label" or name == "data-out-parent-interface" or name == "ipv4-next-hop" or name == "merge-point-label" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-class" or name == "tunnel-interface" or name == "tunnel-weight"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-interface"):
                                            self.backup_interface = value
                                            self.backup_interface.value_namespace = name_space
                                            self.backup_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-ipv4-next-hop"):
                                            self.backup_ipv4_next_hop = value
                                            self.backup_ipv4_next_hop.value_namespace = name_space
                                            self.backup_ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-local-label"):
                                            self.backup_local_label = value
                                            self.backup_local_label.value_namespace = name_space
                                            self.backup_local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "data-out-parent-interface"):
                                            self.data_out_parent_interface = value
                                            self.data_out_parent_interface.value_namespace = name_space
                                            self.data_out_parent_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "merge-point-label"):
                                            self.merge_point_label = value
                                            self.merge_point_label.value_namespace = name_space
                                            self.merge_point_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-class"):
                                            self.tunnel_class = value
                                            self.tunnel_class.value_namespace = name_space
                                            self.tunnel_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-interface"):
                                            self.tunnel_interface = value
                                            self.tunnel_interface.value_namespace = name_space
                                            self.tunnel_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-weight"):
                                            self.tunnel_weight = value
                                            self.tunnel_weight.value_namespace = name_space
                                            self.tunnel_weight.value_namespace_prefix = name_space_prefix


                                class PseudowireData(Entity):
                                    """
                                    pseudowire data
                                    
                                    .. attribute:: bridge_id
                                    
                                    	Bridge ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: cross_connect_id
                                    
                                    	Cross\-connect ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: pseuodo_wire_connect_id
                                    
                                    	PseudoWire Cross\-connect ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: split_horizon_id
                                    
                                    	Split horizon group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireData, self).__init__()

                                        self.yang_name = "pseudowire-data"
                                        self.yang_parent_name = "moi"

                                        self.bridge_id = YLeaf(YType.uint32, "bridge-id")

                                        self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.pseuodo_wire_connect_id = YLeaf(YType.uint32, "pseuodo-wire-connect-id")

                                        self.split_horizon_id = YLeaf(YType.uint32, "split-horizon-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bridge_id",
                                                        "cross_connect_id",
                                                        "ipv4_next_hop",
                                                        "out_interface",
                                                        "out_label",
                                                        "path_flags_decode",
                                                        "pseuodo_wire_connect_id",
                                                        "split_horizon_id",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.bridge_id.is_set or
                                            self.cross_connect_id.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.path_flags_decode.is_set or
                                            self.pseuodo_wire_connect_id.is_set or
                                            self.split_horizon_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bridge_id.yfilter != YFilter.not_set or
                                            self.cross_connect_id.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.pseuodo_wire_connect_id.yfilter != YFilter.not_set or
                                            self.split_horizon_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bridge_id.is_set or self.bridge_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bridge_id.get_name_leafdata())
                                        if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.pseuodo_wire_connect_id.is_set or self.pseuodo_wire_connect_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pseuodo_wire_connect_id.get_name_leafdata())
                                        if (self.split_horizon_id.is_set or self.split_horizon_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.split_horizon_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bridge-id" or name == "cross-connect-id" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pseuodo-wire-connect-id" or name == "split-horizon-id" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bridge-id"):
                                            self.bridge_id = value
                                            self.bridge_id.value_namespace = name_space
                                            self.bridge_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cross-connect-id"):
                                            self.cross_connect_id = value
                                            self.cross_connect_id.value_namespace = name_space
                                            self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pseuodo-wire-connect-id"):
                                            self.pseuodo_wire_connect_id = value
                                            self.pseuodo_wire_connect_id.value_namespace = name_space
                                            self.pseuodo_wire_connect_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "split-horizon-id"):
                                            self.split_horizon_id = value
                                            self.split_horizon_id.value_namespace = name_space
                                            self.split_horizon_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class IpSubData(Entity):
                                    """
                                    ip sub data
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	VRF table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.IpSubData, self).__init__()

                                        self.yang_name = "ip-sub-data"
                                        self.yang_parent_name = "moi"

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("out_interface",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.out_interface.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ip-sub-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "out-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class PseudowireHeadEndData(Entity):
                                    """
                                    pseudowire head end data
                                    
                                    .. attribute:: control_word
                                    
                                    	Is control word present
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: imposition
                                    
                                    	Is PWHE IMposition
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: pw_list_id
                                    
                                    	Pseudo\-wire List Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: pwhe_interface
                                    
                                    	Pseudo\-wire Head\-end interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: vctype
                                    
                                    	Virtual Circuit Type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__init__()

                                        self.yang_name = "pseudowire-head-end-data"
                                        self.yang_parent_name = "moi"

                                        self.control_word = YLeaf(YType.int32, "control-word")

                                        self.imposition = YLeaf(YType.int32, "imposition")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.pw_list_id = YLeaf(YType.uint16, "pw-list-id")

                                        self.pwhe_interface = YLeaf(YType.str, "pwhe-interface")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.vctype = YLeaf(YType.uint8, "vctype")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("control_word",
                                                        "imposition",
                                                        "ipv4_next_hop",
                                                        "out_interface",
                                                        "out_label",
                                                        "path_flags_decode",
                                                        "pw_list_id",
                                                        "pwhe_interface",
                                                        "table_id",
                                                        "table_name",
                                                        "vctype") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.control_word.is_set or
                                            self.imposition.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.path_flags_decode.is_set or
                                            self.pw_list_id.is_set or
                                            self.pwhe_interface.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.vctype.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.control_word.yfilter != YFilter.not_set or
                                            self.imposition.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.pw_list_id.yfilter != YFilter.not_set or
                                            self.pwhe_interface.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.vctype.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-head-end-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.control_word.is_set or self.control_word.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.control_word.get_name_leafdata())
                                        if (self.imposition.is_set or self.imposition.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.imposition.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.pw_list_id.is_set or self.pw_list_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pw_list_id.get_name_leafdata())
                                        if (self.pwhe_interface.is_set or self.pwhe_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pwhe_interface.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.vctype.is_set or self.vctype.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vctype.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "control-word" or name == "imposition" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pw-list-id" or name == "pwhe-interface" or name == "table-id" or name == "table-name" or name == "vctype"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "control-word"):
                                            self.control_word = value
                                            self.control_word.value_namespace = name_space
                                            self.control_word.value_namespace_prefix = name_space_prefix
                                        if(value_path == "imposition"):
                                            self.imposition = value
                                            self.imposition.value_namespace = name_space
                                            self.imposition.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pw-list-id"):
                                            self.pw_list_id = value
                                            self.pw_list_id.value_namespace = name_space
                                            self.pw_list_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pwhe-interface"):
                                            self.pwhe_interface = value
                                            self.pwhe_interface.value_namespace = name_space
                                            self.pwhe_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vctype"):
                                            self.vctype = value
                                            self.vctype.value_namespace = name_space
                                            self.vctype.value_namespace_prefix = name_space_prefix


                                class PwListData(Entity):
                                    """
                                    pw list data
                                    
                                    .. attribute:: l2_interface
                                    
                                    	Pseudo\-wire Layer 2 interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: l3_interface
                                    
                                    	Pseudo\-wire Layer 3 interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PwListData, self).__init__()

                                        self.yang_name = "pw-list-data"
                                        self.yang_parent_name = "moi"

                                        self.l2_interface = YLeaf(YType.str, "l2-interface")

                                        self.l3_interface = YLeaf(YType.str, "l3-interface")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("l2_interface",
                                                        "l3_interface",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.l2_interface.is_set or
                                            self.l3_interface.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.l2_interface.yfilter != YFilter.not_set or
                                            self.l3_interface.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pw-list-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.l2_interface.is_set or self.l2_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.l2_interface.get_name_leafdata())
                                        if (self.l3_interface.is_set or self.l3_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.l3_interface.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "l2-interface" or name == "l3-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "l2-interface"):
                                            self.l2_interface = value
                                            self.l2_interface.value_namespace = name_space
                                            self.l2_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "l3-interface"):
                                            self.l3_interface = value
                                            self.l3_interface.value_namespace = name_space
                                            self.l3_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class Stackv4Data(Entity):
                                    """
                                    stackv4 data
                                    
                                    .. attribute:: inner_stack
                                    
                                    	Inner stack
                                    	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Nexthop
                                    	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.Nexthop>`
                                    
                                    .. attribute:: owner_application_type
                                    
                                    	Owner application type
                                    	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data, self).__init__()

                                        self.yang_name = "stackv4-data"
                                        self.yang_parent_name = "moi"

                                        self.owner_application_type = YLeaf(YType.enumeration, "owner-application-type")

                                        self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                        self.inner_stack.parent = self
                                        self._children_name_map["inner_stack"] = "inner-stack"
                                        self._children_yang_names.add("inner-stack")

                                        self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                        self.nexthop.parent = self
                                        self._children_name_map["nexthop"] = "nexthop"
                                        self._children_yang_names.add("nexthop")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("owner_application_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)


                                    class Nexthop(Entity):
                                        """
                                        Nexthop
                                        
                                        .. attribute:: backup_path_id
                                        
                                        	Routing path backup id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4_next_hop
                                        
                                        	IPv4 nexthop
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: load_metric
                                        
                                        	Routing path's load metric
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: local_label
                                        
                                        	TE backup path local label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: next_hop_id
                                        
                                        	Next hop ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_interface
                                        
                                        	Outgoing Interface
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: out_interface_parent
                                        
                                        	Outgoing Interface's parent
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: out_label
                                        
                                        	Outgoing Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_label_name
                                        
                                        	Outgoing label name
                                        	**type**\:  str
                                        
                                        .. attribute:: path_flags_decode
                                        
                                        	Path flag decoded string
                                        	**type**\:  str
                                        
                                        .. attribute:: path_id
                                        
                                        	Routing path id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: table_id
                                        
                                        	Table ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: table_name
                                        
                                        	VRF table name
                                        	**type**\:  str
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__init__()

                                            self.yang_name = "nexthop"
                                            self.yang_parent_name = "stackv4-data"

                                            self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                            self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                            self.load_metric = YLeaf(YType.uint32, "load-metric")

                                            self.local_label = YLeaf(YType.uint32, "local-label")

                                            self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                            self.out_interface = YLeaf(YType.str, "out-interface")

                                            self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                            self.out_label = YLeaf(YType.uint32, "out-label")

                                            self.out_label_name = YLeaf(YType.str, "out-label-name")

                                            self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                            self.path_id = YLeaf(YType.uint8, "path-id")

                                            self.table_id = YLeaf(YType.uint32, "table-id")

                                            self.table_name = YLeaf(YType.str, "table-name")

                                            self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("backup_path_id",
                                                            "ipv4_next_hop",
                                                            "load_metric",
                                                            "local_label",
                                                            "next_hop_id",
                                                            "out_interface",
                                                            "out_interface_parent",
                                                            "out_label",
                                                            "out_label_name",
                                                            "path_flags_decode",
                                                            "path_id",
                                                            "table_id",
                                                            "table_name",
                                                            "tunnel_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.backup_path_id.is_set or
                                                self.ipv4_next_hop.is_set or
                                                self.load_metric.is_set or
                                                self.local_label.is_set or
                                                self.next_hop_id.is_set or
                                                self.out_interface.is_set or
                                                self.out_interface_parent.is_set or
                                                self.out_label.is_set or
                                                self.out_label_name.is_set or
                                                self.path_flags_decode.is_set or
                                                self.path_id.is_set or
                                                self.table_id.is_set or
                                                self.table_name.is_set or
                                                self.tunnel_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.backup_path_id.yfilter != YFilter.not_set or
                                                self.ipv4_next_hop.yfilter != YFilter.not_set or
                                                self.load_metric.yfilter != YFilter.not_set or
                                                self.local_label.yfilter != YFilter.not_set or
                                                self.next_hop_id.yfilter != YFilter.not_set or
                                                self.out_interface.yfilter != YFilter.not_set or
                                                self.out_interface_parent.yfilter != YFilter.not_set or
                                                self.out_label.yfilter != YFilter.not_set or
                                                self.out_label_name.yfilter != YFilter.not_set or
                                                self.path_flags_decode.yfilter != YFilter.not_set or
                                                self.path_id.yfilter != YFilter.not_set or
                                                self.table_id.yfilter != YFilter.not_set or
                                                self.table_name.yfilter != YFilter.not_set or
                                                self.tunnel_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nexthop" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                            if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                            if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_metric.get_name_leafdata())
                                            if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_label.get_name_leafdata())
                                            if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                            if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_interface.get_name_leafdata())
                                            if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label.get_name_leafdata())
                                            if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                            if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                            if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_id.get_name_leafdata())
                                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_id.get_name_leafdata())
                                            if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_name.get_name_leafdata())
                                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "backup-path-id"):
                                                self.backup_path_id = value
                                                self.backup_path_id.value_namespace = name_space
                                                self.backup_path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4-next-hop"):
                                                self.ipv4_next_hop = value
                                                self.ipv4_next_hop.value_namespace = name_space
                                                self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-metric"):
                                                self.load_metric = value
                                                self.load_metric.value_namespace = name_space
                                                self.load_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-label"):
                                                self.local_label = value
                                                self.local_label.value_namespace = name_space
                                                self.local_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hop-id"):
                                                self.next_hop_id = value
                                                self.next_hop_id.value_namespace = name_space
                                                self.next_hop_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-interface"):
                                                self.out_interface = value
                                                self.out_interface.value_namespace = name_space
                                                self.out_interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-interface-parent"):
                                                self.out_interface_parent = value
                                                self.out_interface_parent.value_namespace = name_space
                                                self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label"):
                                                self.out_label = value
                                                self.out_label.value_namespace = name_space
                                                self.out_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label-name"):
                                                self.out_label_name = value
                                                self.out_label_name.value_namespace = name_space
                                                self.out_label_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-flags-decode"):
                                                self.path_flags_decode = value
                                                self.path_flags_decode.value_namespace = name_space
                                                self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-id"):
                                                self.path_id = value
                                                self.path_id.value_namespace = name_space
                                                self.path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-id"):
                                                self.table_id = value
                                                self.table_id.value_namespace = name_space
                                                self.table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-name"):
                                                self.table_name = value
                                                self.table_name.value_namespace = name_space
                                                self.table_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tunnel-id"):
                                                self.tunnel_id = value
                                                self.tunnel_id.value_namespace = name_space
                                                self.tunnel_id.value_namespace_prefix = name_space_prefix


                                    class InnerStack(Entity):
                                        """
                                        Inner stack
                                        
                                        .. attribute:: label
                                        
                                        	Info related to outgoing labels
                                        	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label>`
                                        
                                        .. attribute:: nexthop
                                        
                                        	Remote nexthop addresses
                                        	**type**\:  list of str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: num_lbls
                                        
                                        	Depth of inner label stack
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: num_nexthops
                                        
                                        	Number of remote nexthop addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__init__()

                                            self.yang_name = "inner-stack"
                                            self.yang_parent_name = "stackv4-data"

                                            self.nexthop = YLeafList(YType.str, "nexthop")

                                            self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                            self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                            self.label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("nexthop",
                                                            "num_lbls",
                                                            "num_nexthops") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)


                                        class Label(Entity):
                                            """
                                            Info related to outgoing labels
                                            
                                            .. attribute:: outgoing_label
                                            
                                            	Remote Label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: outgoing_label_str
                                            
                                            	Remote Label string
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-lsd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__init__()

                                                self.yang_name = "label"
                                                self.yang_parent_name = "inner-stack"

                                                self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                                self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("outgoing_label",
                                                                "outgoing_label_str") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.outgoing_label.is_set or
                                                    self.outgoing_label_str.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.outgoing_label.yfilter != YFilter.not_set or
                                                    self.outgoing_label_str.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                                if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "outgoing-label"):
                                                    self.outgoing_label = value
                                                    self.outgoing_label.value_namespace = name_space
                                                    self.outgoing_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "outgoing-label-str"):
                                                    self.outgoing_label_str = value
                                                    self.outgoing_label_str.value_namespace = name_space
                                                    self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.label:
                                                if (c.has_data()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            return (
                                                self.num_lbls.is_set or
                                                self.num_nexthops.is_set)

                                        def has_operation(self):
                                            for c in self.label:
                                                if (c.has_operation()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.nexthop.yfilter != YFilter.not_set or
                                                self.num_lbls.yfilter != YFilter.not_set or
                                                self.num_nexthops.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "inner-stack" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                            if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                            leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "label"):
                                                for c in self.label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "nexthop"):
                                                self.nexthop.append(value)
                                            if(value_path == "num-lbls"):
                                                self.num_lbls = value
                                                self.num_lbls.value_namespace = name_space
                                                self.num_lbls.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-nexthops"):
                                                self.num_nexthops = value
                                                self.num_nexthops.value_namespace = name_space
                                                self.num_nexthops.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.owner_application_type.is_set or
                                            (self.inner_stack is not None and self.inner_stack.has_data()) or
                                            (self.nexthop is not None and self.nexthop.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.owner_application_type.yfilter != YFilter.not_set or
                                            (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                            (self.nexthop is not None and self.nexthop.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stackv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.owner_application_type.is_set or self.owner_application_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.owner_application_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "inner-stack"):
                                            if (self.inner_stack is None):
                                                self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                                self.inner_stack.parent = self
                                                self._children_name_map["inner_stack"] = "inner-stack"
                                            return self.inner_stack

                                        if (child_yang_name == "nexthop"):
                                            if (self.nexthop is None):
                                                self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                                self.nexthop.parent = self
                                                self._children_name_map["nexthop"] = "nexthop"
                                            return self.nexthop

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "inner-stack" or name == "nexthop" or name == "owner-application-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "owner-application-type"):
                                            self.owner_application_type = value
                                            self.owner_application_type.value_namespace = name_space
                                            self.owner_application_type.value_namespace_prefix = name_space_prefix


                                class Stackv6Data(Entity):
                                    """
                                    stackv6 data
                                    
                                    .. attribute:: inner_stack
                                    
                                    	Inner stack
                                    	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Nexthop
                                    	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.Nexthop>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data, self).__init__()

                                        self.yang_name = "stackv6-data"
                                        self.yang_parent_name = "moi"

                                        self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                        self.inner_stack.parent = self
                                        self._children_name_map["inner_stack"] = "inner-stack"
                                        self._children_yang_names.add("inner-stack")

                                        self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                        self.nexthop.parent = self
                                        self._children_name_map["nexthop"] = "nexthop"
                                        self._children_yang_names.add("nexthop")


                                    class Nexthop(Entity):
                                        """
                                        Nexthop
                                        
                                        .. attribute:: backup_path_id
                                        
                                        	Routing path backup id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv6_next_hop
                                        
                                        	IPv6 nexthop
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: next_hop_id
                                        
                                        	Next hop ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_interface
                                        
                                        	Outgoing interface
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: out_label
                                        
                                        	Outgoing label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_label_name
                                        
                                        	Outgoing label name
                                        	**type**\:  str
                                        
                                        .. attribute:: path_flags_decode
                                        
                                        	Path flag decoded string
                                        	**type**\:  str
                                        
                                        .. attribute:: path_id
                                        
                                        	Routing path id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: table_id
                                        
                                        	Table ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: table_name
                                        
                                        	VRF table name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__init__()

                                            self.yang_name = "nexthop"
                                            self.yang_parent_name = "stackv6-data"

                                            self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                            self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                            self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                            self.out_interface = YLeaf(YType.str, "out-interface")

                                            self.out_label = YLeaf(YType.uint32, "out-label")

                                            self.out_label_name = YLeaf(YType.str, "out-label-name")

                                            self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                            self.path_id = YLeaf(YType.uint8, "path-id")

                                            self.table_id = YLeaf(YType.uint32, "table-id")

                                            self.table_name = YLeaf(YType.str, "table-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("backup_path_id",
                                                            "ipv6_next_hop",
                                                            "next_hop_id",
                                                            "out_interface",
                                                            "out_label",
                                                            "out_label_name",
                                                            "path_flags_decode",
                                                            "path_id",
                                                            "table_id",
                                                            "table_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.backup_path_id.is_set or
                                                self.ipv6_next_hop.is_set or
                                                self.next_hop_id.is_set or
                                                self.out_interface.is_set or
                                                self.out_label.is_set or
                                                self.out_label_name.is_set or
                                                self.path_flags_decode.is_set or
                                                self.path_id.is_set or
                                                self.table_id.is_set or
                                                self.table_name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.backup_path_id.yfilter != YFilter.not_set or
                                                self.ipv6_next_hop.yfilter != YFilter.not_set or
                                                self.next_hop_id.yfilter != YFilter.not_set or
                                                self.out_interface.yfilter != YFilter.not_set or
                                                self.out_label.yfilter != YFilter.not_set or
                                                self.out_label_name.yfilter != YFilter.not_set or
                                                self.path_flags_decode.yfilter != YFilter.not_set or
                                                self.path_id.yfilter != YFilter.not_set or
                                                self.table_id.yfilter != YFilter.not_set or
                                                self.table_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nexthop" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                            if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                            if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                            if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_interface.get_name_leafdata())
                                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label.get_name_leafdata())
                                            if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                            if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                            if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_id.get_name_leafdata())
                                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_id.get_name_leafdata())
                                            if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "backup-path-id"):
                                                self.backup_path_id = value
                                                self.backup_path_id.value_namespace = name_space
                                                self.backup_path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6-next-hop"):
                                                self.ipv6_next_hop = value
                                                self.ipv6_next_hop.value_namespace = name_space
                                                self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hop-id"):
                                                self.next_hop_id = value
                                                self.next_hop_id.value_namespace = name_space
                                                self.next_hop_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-interface"):
                                                self.out_interface = value
                                                self.out_interface.value_namespace = name_space
                                                self.out_interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label"):
                                                self.out_label = value
                                                self.out_label.value_namespace = name_space
                                                self.out_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label-name"):
                                                self.out_label_name = value
                                                self.out_label_name.value_namespace = name_space
                                                self.out_label_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-flags-decode"):
                                                self.path_flags_decode = value
                                                self.path_flags_decode.value_namespace = name_space
                                                self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-id"):
                                                self.path_id = value
                                                self.path_id.value_namespace = name_space
                                                self.path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-id"):
                                                self.table_id = value
                                                self.table_id.value_namespace = name_space
                                                self.table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-name"):
                                                self.table_name = value
                                                self.table_name.value_namespace = name_space
                                                self.table_name.value_namespace_prefix = name_space_prefix


                                    class InnerStack(Entity):
                                        """
                                        Inner stack
                                        
                                        .. attribute:: label
                                        
                                        	Info related to outgoing labels
                                        	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label>`
                                        
                                        .. attribute:: nexthop
                                        
                                        	Remote nexthop addresses
                                        	**type**\:  list of str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: num_lbls
                                        
                                        	Depth of inner label stack
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: num_nexthops
                                        
                                        	Number of remote nexthop addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__init__()

                                            self.yang_name = "inner-stack"
                                            self.yang_parent_name = "stackv6-data"

                                            self.nexthop = YLeafList(YType.str, "nexthop")

                                            self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                            self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                            self.label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("nexthop",
                                                            "num_lbls",
                                                            "num_nexthops") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)


                                        class Label(Entity):
                                            """
                                            Info related to outgoing labels
                                            
                                            .. attribute:: outgoing_label
                                            
                                            	Remote Label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: outgoing_label_str
                                            
                                            	Remote Label string
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-lsd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__init__()

                                                self.yang_name = "label"
                                                self.yang_parent_name = "inner-stack"

                                                self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                                self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("outgoing_label",
                                                                "outgoing_label_str") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.outgoing_label.is_set or
                                                    self.outgoing_label_str.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.outgoing_label.yfilter != YFilter.not_set or
                                                    self.outgoing_label_str.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                                if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "outgoing-label"):
                                                    self.outgoing_label = value
                                                    self.outgoing_label.value_namespace = name_space
                                                    self.outgoing_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "outgoing-label-str"):
                                                    self.outgoing_label_str = value
                                                    self.outgoing_label_str.value_namespace = name_space
                                                    self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.label:
                                                if (c.has_data()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            return (
                                                self.num_lbls.is_set or
                                                self.num_nexthops.is_set)

                                        def has_operation(self):
                                            for c in self.label:
                                                if (c.has_operation()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.nexthop.yfilter != YFilter.not_set or
                                                self.num_lbls.yfilter != YFilter.not_set or
                                                self.num_nexthops.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "inner-stack" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                            if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                            leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "label"):
                                                for c in self.label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "nexthop"):
                                                self.nexthop.append(value)
                                            if(value_path == "num-lbls"):
                                                self.num_lbls = value
                                                self.num_lbls.value_namespace = name_space
                                                self.num_lbls.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-nexthops"):
                                                self.num_nexthops = value
                                                self.num_nexthops.value_namespace = name_space
                                                self.num_nexthops.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.inner_stack is not None and self.inner_stack.has_data()) or
                                            (self.nexthop is not None and self.nexthop.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                            (self.nexthop is not None and self.nexthop.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stackv6-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "inner-stack"):
                                            if (self.inner_stack is None):
                                                self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                                self.inner_stack.parent = self
                                                self._children_name_map["inner_stack"] = "inner-stack"
                                            return self.inner_stack

                                        if (child_yang_name == "nexthop"):
                                            if (self.nexthop is None):
                                                self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                                self.nexthop.parent = self
                                                self._children_name_map["nexthop"] = "nexthop"
                                            return self.nexthop

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "inner-stack" or name == "nexthop"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class TeHeadData(Entity):
                                    """
                                    te head data
                                    
                                    .. attribute:: flags_decode
                                    
                                    	Flags decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_fwd_class
                                    
                                    	Tunnel forwarding class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_load_metric
                                    
                                    	Tunnel Load metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_local_label
                                    
                                    	Tunnel local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_local_label_str
                                    
                                    	Tunnel local label stringified
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.TeHeadData, self).__init__()

                                        self.yang_name = "te-head-data"
                                        self.yang_parent_name = "moi"

                                        self.flags_decode = YLeaf(YType.str, "flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_fwd_class = YLeaf(YType.uint8, "tunnel-fwd-class")

                                        self.tunnel_load_metric = YLeaf(YType.uint32, "tunnel-load-metric")

                                        self.tunnel_local_label = YLeaf(YType.uint32, "tunnel-local-label")

                                        self.tunnel_local_label_str = YLeaf(YType.str, "tunnel-local-label-str")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("flags_decode",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_fwd_class",
                                                        "tunnel_load_metric",
                                                        "tunnel_local_label",
                                                        "tunnel_local_label_str") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_fwd_class.is_set or
                                            self.tunnel_load_metric.is_set or
                                            self.tunnel_local_label.is_set or
                                            self.tunnel_local_label_str.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_fwd_class.yfilter != YFilter.not_set or
                                            self.tunnel_load_metric.yfilter != YFilter.not_set or
                                            self.tunnel_local_label.yfilter != YFilter.not_set or
                                            self.tunnel_local_label_str.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "te-head-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.flags_decode.is_set or self.flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_fwd_class.is_set or self.tunnel_fwd_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_fwd_class.get_name_leafdata())
                                        if (self.tunnel_load_metric.is_set or self.tunnel_load_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_load_metric.get_name_leafdata())
                                        if (self.tunnel_local_label.is_set or self.tunnel_local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_local_label.get_name_leafdata())
                                        if (self.tunnel_local_label_str.is_set or self.tunnel_local_label_str.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_local_label_str.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-fwd-class" or name == "tunnel-load-metric" or name == "tunnel-local-label" or name == "tunnel-local-label-str"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "flags-decode"):
                                            self.flags_decode = value
                                            self.flags_decode.value_namespace = name_space
                                            self.flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-fwd-class"):
                                            self.tunnel_fwd_class = value
                                            self.tunnel_fwd_class.value_namespace = name_space
                                            self.tunnel_fwd_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-load-metric"):
                                            self.tunnel_load_metric = value
                                            self.tunnel_load_metric.value_namespace = name_space
                                            self.tunnel_load_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-local-label"):
                                            self.tunnel_local_label = value
                                            self.tunnel_local_label.value_namespace = name_space
                                            self.tunnel_local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-local-label-str"):
                                            self.tunnel_local_label_str = value
                                            self.tunnel_local_label_str.value_namespace = name_space
                                            self.tunnel_local_label_str.value_namespace_prefix = name_space_prefix


                                class DmtcData(Entity):
                                    """
                                    dmtc data
                                    
                                    .. attribute:: dmtc_ext_ifh
                                    
                                    	DMTC External Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.DmtcData, self).__init__()

                                        self.yang_name = "dmtc-data"
                                        self.yang_parent_name = "moi"

                                        self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.dmtc_ext_ifh.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "dmtc-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dmtc-ext-ifh"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "dmtc-ext-ifh"):
                                            self.dmtc_ext_ifh = value
                                            self.dmtc_ext_ifh.value_namespace = name_space
                                            self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.moi_type.is_set or
                                        (self.dmtc_data is not None and self.dmtc_data.has_data()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                        (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_data()) or
                                        (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_data()) or
                                        (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_data()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                        (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                        (self.stackv4_data is not None and self.stackv4_data.has_data()) or
                                        (self.stackv6_data is not None and self.stackv6_data.has_data()) or
                                        (self.te_head_data is not None and self.te_head_data.has_data()) or
                                        (self.tev4_data is not None and self.tev4_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.moi_type.yfilter != YFilter.not_set or
                                        (self.dmtc_data is not None and self.dmtc_data.has_operation()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                        (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_operation()) or
                                        (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_operation()) or
                                        (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_operation()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                        (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                        (self.stackv4_data is not None and self.stackv4_data.has_operation()) or
                                        (self.stackv6_data is not None and self.stackv6_data.has_operation()) or
                                        (self.te_head_data is not None and self.te_head_data.has_operation()) or
                                        (self.tev4_data is not None and self.tev4_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "moi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.moi_type.is_set or self.moi_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.moi_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "dmtc-data"):
                                        if (self.dmtc_data is None):
                                            self.dmtc_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.DmtcData()
                                            self.dmtc_data.parent = self
                                            self._children_name_map["dmtc_data"] = "dmtc-data"
                                        return self.dmtc_data

                                    if (child_yang_name == "ip-sub-data"):
                                        if (self.ip_sub_data is None):
                                            self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.IpSubData()
                                            self.ip_sub_data.parent = self
                                            self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                        return self.ip_sub_data

                                    if (child_yang_name == "ipv4-data"):
                                        if (self.ipv4_data is None):
                                            self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv4Data()
                                            self.ipv4_data.parent = self
                                            self._children_name_map["ipv4_data"] = "ipv4-data"
                                        return self.ipv4_data

                                    if (child_yang_name == "ipv6-data"):
                                        if (self.ipv6_data is None):
                                            self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv6Data()
                                            self.ipv6_data.parent = self
                                            self._children_name_map["ipv6_data"] = "ipv6-data"
                                        return self.ipv6_data

                                    if (child_yang_name == "pop-and-lookup-ipv4"):
                                        if (self.pop_and_lookup_ipv4 is None):
                                            self.pop_and_lookup_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                            self.pop_and_lookup_ipv4.parent = self
                                            self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                        return self.pop_and_lookup_ipv4

                                    if (child_yang_name == "pop-and-lookup-ipv6"):
                                        if (self.pop_and_lookup_ipv6 is None):
                                            self.pop_and_lookup_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                            self.pop_and_lookup_ipv6.parent = self
                                            self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                        return self.pop_and_lookup_ipv6

                                    if (child_yang_name == "pop-and-lookup-tp"):
                                        if (self.pop_and_lookup_tp is None):
                                            self.pop_and_lookup_tp = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupTp()
                                            self.pop_and_lookup_tp.parent = self
                                            self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                        return self.pop_and_lookup_tp

                                    if (child_yang_name == "pseudowire-data"):
                                        if (self.pseudowire_data is None):
                                            self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireData()
                                            self.pseudowire_data.parent = self
                                            self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                        return self.pseudowire_data

                                    if (child_yang_name == "pseudowire-head-end-data"):
                                        if (self.pseudowire_head_end_data is None):
                                            self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                            self.pseudowire_head_end_data.parent = self
                                            self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                        return self.pseudowire_head_end_data

                                    if (child_yang_name == "pw-list-data"):
                                        if (self.pw_list_data is None):
                                            self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PwListData()
                                            self.pw_list_data.parent = self
                                            self._children_name_map["pw_list_data"] = "pw-list-data"
                                        return self.pw_list_data

                                    if (child_yang_name == "stackv4-data"):
                                        if (self.stackv4_data is None):
                                            self.stackv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data()
                                            self.stackv4_data.parent = self
                                            self._children_name_map["stackv4_data"] = "stackv4-data"
                                        return self.stackv4_data

                                    if (child_yang_name == "stackv6-data"):
                                        if (self.stackv6_data is None):
                                            self.stackv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data()
                                            self.stackv6_data.parent = self
                                            self._children_name_map["stackv6_data"] = "stackv6-data"
                                        return self.stackv6_data

                                    if (child_yang_name == "te-head-data"):
                                        if (self.te_head_data is None):
                                            self.te_head_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.TeHeadData()
                                            self.te_head_data.parent = self
                                            self._children_name_map["te_head_data"] = "te-head-data"
                                        return self.te_head_data

                                    if (child_yang_name == "tev4-data"):
                                        if (self.tev4_data is None):
                                            self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Tev4Data()
                                            self.tev4_data.parent = self
                                            self._children_name_map["tev4_data"] = "tev4-data"
                                        return self.tev4_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-data" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv6-data" or name == "pop-and-lookup-ipv4" or name == "pop-and-lookup-ipv6" or name == "pop-and-lookup-tp" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "pw-list-data" or name == "stackv4-data" or name == "stackv6-data" or name == "te-head-data" or name == "tev4-data" or name == "moi-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "moi-type"):
                                        self.moi_type = value
                                        self.moi_type.value_namespace = name_space
                                        self.moi_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.moi is not None and self.moi.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.moi is not None and self.moi.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "moi-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "moi"):
                                    if (self.moi is None):
                                        self.moi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi()
                                        self.moi.parent = self
                                        self._children_name_map["moi"] = "moi"
                                    return self.moi

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "moi"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            for c in self.moi_array:
                                if (c.has_data()):
                                    return True
                            return (self.application_resource is not None and self.application_resource.has_data())

                        def has_operation(self):
                            for c in self.moi_array:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.application_resource is not None and self.application_resource.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "mois" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "application-resource"):
                                if (self.application_resource is None):
                                    self.application_resource = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.ApplicationResource()
                                    self.application_resource.parent = self
                                    self._children_name_map["application_resource"] = "application-resource"
                                return self.application_resource

                            if (child_yang_name == "moi-array"):
                                for c in self.moi_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.moi_array.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-resource" or name == "moi-array"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        for c in self.associated_fpi:
                            if (c.has_data()):
                                return True
                        for c in self.mois:
                            if (c.has_data()):
                                return True
                        for c in self.v4_rpf:
                            if (c.has_data()):
                                return True
                        for c in self.v6_rpf:
                            if (c.has_data()):
                                return True
                        return (
                            self.interface_name.is_set or
                            self.bcdl_priority.is_set or
                            self.lsd_queue.is_set or
                            self.priority_updated.is_set or
                            self.rewrite_version.is_set or
                            self.rw_install_age.is_set or
                            self.rw_install_time.is_set or
                            self.rw_updated.is_set or
                            (self.fpi_key is not None and self.fpi_key.has_data()) or
                            (self.rewrite_id is not None and self.rewrite_id.has_data()))

                    def has_operation(self):
                        for c in self.associated_fpi:
                            if (c.has_operation()):
                                return True
                        for c in self.mois:
                            if (c.has_operation()):
                                return True
                        for c in self.v4_rpf:
                            if (c.has_operation()):
                                return True
                        for c in self.v6_rpf:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.interface_name.yfilter != YFilter.not_set or
                            self.bcdl_priority.yfilter != YFilter.not_set or
                            self.lsd_queue.yfilter != YFilter.not_set or
                            self.priority_updated.yfilter != YFilter.not_set or
                            self.rewrite_version.yfilter != YFilter.not_set or
                            self.rw_install_age.yfilter != YFilter.not_set or
                            self.rw_install_time.yfilter != YFilter.not_set or
                            self.rw_updated.yfilter != YFilter.not_set or
                            (self.fpi_key is not None and self.fpi_key.has_operation()) or
                            (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rewrite-te" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                        if (self.bcdl_priority.is_set or self.bcdl_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bcdl_priority.get_name_leafdata())
                        if (self.lsd_queue.is_set or self.lsd_queue.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsd_queue.get_name_leafdata())
                        if (self.priority_updated.is_set or self.priority_updated.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.priority_updated.get_name_leafdata())
                        if (self.rewrite_version.is_set or self.rewrite_version.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rewrite_version.get_name_leafdata())
                        if (self.rw_install_age.is_set or self.rw_install_age.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rw_install_age.get_name_leafdata())
                        if (self.rw_install_time.is_set or self.rw_install_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rw_install_time.get_name_leafdata())
                        if (self.rw_updated.is_set or self.rw_updated.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rw_updated.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "associated-fpi"):
                            for c in self.associated_fpi:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.AssociatedFpi()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.associated_fpi.append(c)
                            return c

                        if (child_yang_name == "fpi-key"):
                            if (self.fpi_key is None):
                                self.fpi_key = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.FpiKey()
                                self.fpi_key.parent = self
                                self._children_name_map["fpi_key"] = "fpi-key"
                            return self.fpi_key

                        if (child_yang_name == "mois"):
                            for c in self.mois:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.Mois()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.mois.append(c)
                            return c

                        if (child_yang_name == "rewrite-id"):
                            if (self.rewrite_id is None):
                                self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.RewriteId()
                                self.rewrite_id.parent = self
                                self._children_name_map["rewrite_id"] = "rewrite-id"
                            return self.rewrite_id

                        if (child_yang_name == "v4-rpf"):
                            for c in self.v4_rpf:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.V4Rpf()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.v4_rpf.append(c)
                            return c

                        if (child_yang_name == "v6-rpf"):
                            for c in self.v6_rpf:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe.V6Rpf()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.v6_rpf.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "associated-fpi" or name == "fpi-key" or name == "mois" or name == "rewrite-id" or name == "v4-rpf" or name == "v6-rpf" or name == "interface-name" or name == "bcdl-priority" or name == "lsd-queue" or name == "priority-updated" or name == "rewrite-version" or name == "rw-install-age" or name == "rw-install-time" or name == "rw-updated"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "interface-name"):
                            self.interface_name = value
                            self.interface_name.value_namespace = name_space
                            self.interface_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "bcdl-priority"):
                            self.bcdl_priority = value
                            self.bcdl_priority.value_namespace = name_space
                            self.bcdl_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsd-queue"):
                            self.lsd_queue = value
                            self.lsd_queue.value_namespace = name_space
                            self.lsd_queue.value_namespace_prefix = name_space_prefix
                        if(value_path == "priority-updated"):
                            self.priority_updated = value
                            self.priority_updated.value_namespace = name_space
                            self.priority_updated.value_namespace_prefix = name_space_prefix
                        if(value_path == "rewrite-version"):
                            self.rewrite_version = value
                            self.rewrite_version.value_namespace = name_space
                            self.rewrite_version.value_namespace_prefix = name_space_prefix
                        if(value_path == "rw-install-age"):
                            self.rw_install_age = value
                            self.rw_install_age.value_namespace = name_space
                            self.rw_install_age.value_namespace_prefix = name_space_prefix
                        if(value_path == "rw-install-time"):
                            self.rw_install_time = value
                            self.rw_install_time.value_namespace = name_space
                            self.rw_install_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "rw-updated"):
                            self.rw_updated = value
                            self.rw_updated.value_namespace = name_space
                            self.rw_updated.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.rewrite_te:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.rewrite_te:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "rewrite-tes" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "rewrite-te"):
                        for c in self.rewrite_te:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes.RewriteTe()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.rewrite_te.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "rewrite-te"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class RewriteLabels(Entity):
                """
                Table of Rewrites
                
                .. attribute:: rewrite_label
                
                	FPI rewrite for label
                	**type**\: list of    :py:class:`RewriteLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels, self).__init__()

                    self.yang_name = "rewrite-labels"
                    self.yang_parent_name = "rewrite"

                    self.rewrite_label = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels, self).__setattr__(name, value)


                class RewriteLabel(Entity):
                    """
                    FPI rewrite for label
                    
                    .. attribute:: label_id  <key>
                    
                    	Label value
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: associated_fpi
                    
                    	Associated FPI
                    	**type**\: list of    :py:class:`AssociatedFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi>`
                    
                    .. attribute:: bcdl_priority
                    
                    	BCDL Priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: fpi_key
                    
                    	fpi key
                    	**type**\:   :py:class:`FpiKey <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey>`
                    
                    .. attribute:: lsd_queue
                    
                    	LSD queue
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: mois
                    
                    	Mois
                    	**type**\: list of    :py:class:`Mois <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois>`
                    
                    .. attribute:: priority_updated
                    
                    	Is rewrite's BCDL priority updated
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: rewrite_id
                    
                    	Rewrite ID
                    	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId>`
                    
                    .. attribute:: rewrite_version
                    
                    	Rewrite version
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rw_install_age
                    
                    	Rewrite install age
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rw_install_time
                    
                    	Rewrite install timestamp
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: rw_updated
                    
                    	Is rewrite ever updated
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: v4_rpf
                    
                    	IPv4 RPF neighbors
                    	**type**\: list of    :py:class:`V4Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.V4Rpf>`
                    
                    .. attribute:: v6_rpf
                    
                    	IPv6 RPF neighbors
                    	**type**\: list of    :py:class:`V6Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.V6Rpf>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel, self).__init__()

                        self.yang_name = "rewrite-label"
                        self.yang_parent_name = "rewrite-labels"

                        self.label_id = YLeaf(YType.int32, "label-id")

                        self.bcdl_priority = YLeaf(YType.uint8, "bcdl-priority")

                        self.lsd_queue = YLeaf(YType.uint8, "lsd-queue")

                        self.priority_updated = YLeaf(YType.int32, "priority-updated")

                        self.rewrite_version = YLeaf(YType.uint64, "rewrite-version")

                        self.rw_install_age = YLeaf(YType.uint64, "rw-install-age")

                        self.rw_install_time = YLeaf(YType.uint64, "rw-install-time")

                        self.rw_updated = YLeaf(YType.int32, "rw-updated")

                        self.fpi_key = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey()
                        self.fpi_key.parent = self
                        self._children_name_map["fpi_key"] = "fpi-key"
                        self._children_yang_names.add("fpi-key")

                        self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId()
                        self.rewrite_id.parent = self
                        self._children_name_map["rewrite_id"] = "rewrite-id"
                        self._children_yang_names.add("rewrite-id")

                        self.associated_fpi = YList(self)
                        self.mois = YList(self)
                        self.v4_rpf = YList(self)
                        self.v6_rpf = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("label_id",
                                        "bcdl_priority",
                                        "lsd_queue",
                                        "priority_updated",
                                        "rewrite_version",
                                        "rw_install_age",
                                        "rw_install_time",
                                        "rw_updated") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel, self).__setattr__(name, value)


                    class FpiKey(Entity):
                        """
                        fpi key
                        
                        .. attribute:: application_owner
                        
                        	Application owner instance
                        	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.ApplicationOwner>`
                        
                        .. attribute:: fpi
                        
                        	FPI
                        	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey, self).__init__()

                            self.yang_name = "fpi-key"
                            self.yang_parent_name = "rewrite-label"

                            self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi()
                            self.fpi.parent = self
                            self._children_name_map["fpi"] = "fpi"
                            self._children_yang_names.add("fpi")

                            self.application_owner = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey, self).__setattr__(name, value)


                        class Fpi(Entity):
                            """
                            FPI
                            
                            .. attribute:: dmtc_ext_intf_data
                            
                            	dmtc ext intf data
                            	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.DmtcExtIntfData>`
                            
                            .. attribute:: fpi_type
                            
                            	FPIType
                            	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                            
                            .. attribute:: ipv4_data
                            
                            	ipv4 data
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv4Data>`
                            
                            .. attribute:: ipv6_data
                            
                            	ipv6 data
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv6Data>`
                            
                            .. attribute:: label_data
                            
                            	label data
                            	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.LabelData>`
                            
                            .. attribute:: pw_list_data
                            
                            	pw list data
                            	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.PwListData>`
                            
                            .. attribute:: te_data
                            
                            	te data
                            	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.TeData>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi, self).__init__()

                                self.yang_name = "fpi"
                                self.yang_parent_name = "fpi-key"

                                self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                                self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.DmtcExtIntfData()
                                self.dmtc_ext_intf_data.parent = self
                                self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                self._children_yang_names.add("dmtc-ext-intf-data")

                                self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.LabelData()
                                self.label_data.parent = self
                                self._children_name_map["label_data"] = "label-data"
                                self._children_yang_names.add("label-data")

                                self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.PwListData()
                                self.pw_list_data.parent = self
                                self._children_name_map["pw_list_data"] = "pw-list-data"
                                self._children_yang_names.add("pw-list-data")

                                self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.TeData()
                                self.te_data.parent = self
                                self._children_name_map["te_data"] = "te-data"
                                self._children_yang_names.add("te-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fpi_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi, self).__setattr__(name, value)


                            class LabelData(Entity):
                                """
                                label data
                                
                                .. attribute:: elc
                                
                                	ELC
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: label
                                
                                	Label value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.LabelData, self).__init__()

                                    self.yang_name = "label-data"
                                    self.yang_parent_name = "fpi"

                                    self.elc = YLeaf(YType.int32, "elc")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("elc",
                                                    "label",
                                                    "security_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.LabelData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.LabelData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.elc.is_set or
                                        self.label.is_set or
                                        self.security_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.elc.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.elc.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "elc" or name == "label" or name == "security-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "elc"):
                                        self.elc = value
                                        self.elc.value_namespace = name_space
                                        self.elc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix


                            class TeData(Entity):
                                """
                                te data
                                
                                .. attribute:: local_label
                                
                                	Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_interface
                                
                                	Tunnel interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.TeData, self).__init__()

                                    self.yang_name = "te-data"
                                    self.yang_parent_name = "fpi"

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("local_label",
                                                    "tunnel_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.TeData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.TeData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.local_label.is_set or
                                        self.tunnel_interface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.tunnel_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "local-label" or name == "tunnel-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface"):
                                        self.tunnel_interface = value
                                        self.tunnel_interface.value_namespace = name_space
                                        self.tunnel_interface.value_namespace_prefix = name_space_prefix


                            class Ipv4Data(Entity):
                                """
                                ipv4 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: sr_local_label
                                
                                	SR related Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "sr_local_label",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.sr_local_label.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.sr_local_label.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sr-local-label"):
                                        self.sr_local_label = value
                                        self.sr_local_label.value_namespace = name_space
                                        self.sr_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                ipv6 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: router_flags
                                
                                	Route flags
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    self.router_flags = YLeaf(YType.uint32, "router-flags")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_len",
                                                    "router_flags",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_len.is_set or
                                        self.router_flags.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set or
                                        self.router_flags.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                    if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_flags.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-flags"):
                                        self.router_flags = value
                                        self.router_flags.value_namespace = name_space
                                        self.router_flags.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class PwListData(Entity):
                                """
                                pw list data
                                
                                .. attribute:: pwhe_list_id
                                
                                	Pseudowire List Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.PwListData, self).__init__()

                                    self.yang_name = "pw-list-data"
                                    self.yang_parent_name = "fpi"

                                    self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("pwhe_list_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.PwListData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.PwListData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.pwhe_list_id.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.pwhe_list_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pw-list-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "pwhe-list-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "pwhe-list-id"):
                                        self.pwhe_list_id = value
                                        self.pwhe_list_id.value_namespace = name_space
                                        self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                            class DmtcExtIntfData(Entity):
                                """
                                dmtc ext intf data
                                
                                .. attribute:: dmtc_ext_ifh
                                
                                	DMTC External Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.DmtcExtIntfData, self).__init__()

                                    self.yang_name = "dmtc-ext-intf-data"
                                    self.yang_parent_name = "fpi"

                                    self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.dmtc_ext_ifh.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "dmtc-ext-intf-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-ext-ifh"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dmtc-ext-ifh"):
                                        self.dmtc_ext_ifh = value
                                        self.dmtc_ext_ifh.value_namespace = name_space
                                        self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fpi_type.is_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.label_data is not None and self.label_data.has_data()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                    (self.te_data is not None and self.te_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fpi_type.yfilter != YFilter.not_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.label_data is not None and self.label_data.has_operation()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                    (self.te_data is not None and self.te_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fpi" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fpi_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "dmtc-ext-intf-data"):
                                    if (self.dmtc_ext_intf_data is None):
                                        self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.DmtcExtIntfData()
                                        self.dmtc_ext_intf_data.parent = self
                                        self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                    return self.dmtc_ext_intf_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "label-data"):
                                    if (self.label_data is None):
                                        self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.LabelData()
                                        self.label_data.parent = self
                                        self._children_name_map["label_data"] = "label-data"
                                    return self.label_data

                                if (child_yang_name == "pw-list-data"):
                                    if (self.pw_list_data is None):
                                        self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.PwListData()
                                        self.pw_list_data.parent = self
                                        self._children_name_map["pw_list_data"] = "pw-list-data"
                                    return self.pw_list_data

                                if (child_yang_name == "te-data"):
                                    if (self.te_data is None):
                                        self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.TeData()
                                        self.te_data.parent = self
                                        self._children_name_map["te_data"] = "te-data"
                                    return self.te_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fpi-type"):
                                    self.fpi_type = value
                                    self.fpi_type.value_namespace = name_space
                                    self.fpi_type.value_namespace_prefix = name_space_prefix


                        class ApplicationOwner(Entity):
                            """
                            Application owner instance
                            
                            .. attribute:: application_instance
                            
                            	Application instance Name
                            	**type**\:  str
                            
                            .. attribute:: application_name
                            
                            	Application name
                            	**type**\:  str
                            
                            .. attribute:: application_role_primary
                            
                            	Primary/Backup role
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: application_type
                            
                            	Application type
                            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                            
                            .. attribute:: resource_state
                            
                            	Application resource state
                            	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.ApplicationOwner, self).__init__()

                                self.yang_name = "application-owner"
                                self.yang_parent_name = "fpi-key"

                                self.application_instance = YLeaf(YType.str, "application-instance")

                                self.application_name = YLeaf(YType.str, "application-name")

                                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                                self.application_type = YLeaf(YType.enumeration, "application-type")

                                self.resource_state = YLeaf(YType.enumeration, "resource-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("application_instance",
                                                "application_name",
                                                "application_role_primary",
                                                "application_type",
                                                "resource_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.ApplicationOwner, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.ApplicationOwner, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.application_instance.is_set or
                                    self.application_name.is_set or
                                    self.application_role_primary.is_set or
                                    self.application_type.is_set or
                                    self.resource_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.application_instance.yfilter != YFilter.not_set or
                                    self.application_name.yfilter != YFilter.not_set or
                                    self.application_role_primary.yfilter != YFilter.not_set or
                                    self.application_type.yfilter != YFilter.not_set or
                                    self.resource_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "application-owner" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_name.get_name_leafdata())
                                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_type.get_name_leafdata())
                                if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resource_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "application-instance"):
                                    self.application_instance = value
                                    self.application_instance.value_namespace = name_space
                                    self.application_instance.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-name"):
                                    self.application_name = value
                                    self.application_name.value_namespace = name_space
                                    self.application_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-role-primary"):
                                    self.application_role_primary = value
                                    self.application_role_primary.value_namespace = name_space
                                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-type"):
                                    self.application_type = value
                                    self.application_type.value_namespace = name_space
                                    self.application_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "resource-state"):
                                    self.resource_state = value
                                    self.resource_state.value_namespace = name_space
                                    self.resource_state.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.application_owner:
                                if (c.has_data()):
                                    return True
                            return (self.fpi is not None and self.fpi.has_data())

                        def has_operation(self):
                            for c in self.application_owner:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.fpi is not None and self.fpi.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fpi-key" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "application-owner"):
                                for c in self.application_owner:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.ApplicationOwner()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.application_owner.append(c)
                                return c

                            if (child_yang_name == "fpi"):
                                if (self.fpi is None):
                                    self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi()
                                    self.fpi.parent = self
                                    self._children_name_map["fpi"] = "fpi"
                                return self.fpi

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-owner" or name == "fpi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class RewriteId(Entity):
                        """
                        Rewrite ID
                        
                        .. attribute:: rewrite_id
                        
                        	Rewrite ID
                        	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId, self).__init__()

                            self.yang_name = "rewrite-id"
                            self.yang_parent_name = "rewrite-label"

                            self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId()
                            self.rewrite_id.parent = self
                            self._children_name_map["rewrite_id"] = "rewrite-id"
                            self._children_yang_names.add("rewrite-id")


                        class RewriteId(Entity):
                            """
                            Rewrite ID
                            
                            .. attribute:: label_context
                            
                            	Label context
                            	**type**\:   :py:class:`LabelContext <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext>`
                            
                            .. attribute:: local_label_rewrite
                            
                            	Local label rewrite information
                            	**type**\:   :py:class:`LocalLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LocalLabelRewrite>`
                            
                            .. attribute:: rewrite_id_type
                            
                            	RewriteIDType
                            	**type**\:   :py:class:`MgmtLsdRwId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdRwId>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId, self).__init__()

                                self.yang_name = "rewrite-id"
                                self.yang_parent_name = "rewrite-id"

                                self.rewrite_id_type = YLeaf(YType.enumeration, "rewrite-id-type")

                                self.label_context = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext()
                                self.label_context.parent = self
                                self._children_name_map["label_context"] = "label-context"
                                self._children_yang_names.add("label-context")

                                self.local_label_rewrite = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LocalLabelRewrite()
                                self.local_label_rewrite.parent = self
                                self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                                self._children_yang_names.add("local-label-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rewrite_id_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId, self).__setattr__(name, value)


                            class LabelContext(Entity):
                                """
                                Label context
                                
                                .. attribute:: cev4l3vpn_data
                                
                                	L3VPN CEv4 label context
                                	**type**\:   :py:class:`Cev4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev4L3VpnData>`
                                
                                .. attribute:: cev6l3vpn_data
                                
                                	L3VPN CEv6 label context
                                	**type**\:   :py:class:`Cev6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev6L3VpnData>`
                                
                                .. attribute:: evpn_data
                                
                                	EVPN context
                                	**type**\:   :py:class:`EvpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.EvpnData>`
                                
                                .. attribute:: generic_routing_encapsulation
                                
                                	Generic routing encapsulation context
                                	**type**\:   :py:class:`GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation>`
                                
                                .. attribute:: ip_sub_data
                                
                                	IP Subscriber context
                                	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.IpSubData>`
                                
                                .. attribute:: ipv4_data
                                
                                	IPv4 label context
                                	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4Data>`
                                
                                .. attribute:: ipv4blb_data
                                
                                	BFD BLB label context
                                	**type**\:   :py:class:`Ipv4BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4BlbData>`
                                
                                .. attribute:: ipv4l3vpn_data
                                
                                	L3VPN IPv4 label context
                                	**type**\:   :py:class:`Ipv4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData>`
                                
                                .. attribute:: ipv6_data
                                
                                	IPv6 label context
                                	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6Data>`
                                
                                .. attribute:: ipv6_generic_routing_encapsulation
                                
                                	Generic routing encapsulation context
                                	**type**\:   :py:class:`Ipv6GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation>`
                                
                                .. attribute:: ipv6blb_data
                                
                                	BFD BLB label context
                                	**type**\:   :py:class:`Ipv6BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6BlbData>`
                                
                                .. attribute:: ipv6l3vpn_data
                                
                                	L3VPN IPv6 label context
                                	**type**\:   :py:class:`Ipv6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData>`
                                
                                .. attribute:: label_block_data
                                
                                	Label block context
                                	**type**\:   :py:class:`LabelBlockData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockData>`
                                
                                .. attribute:: label_block_srgb_data
                                
                                	Label block SRGB context
                                	**type**\:   :py:class:`LabelBlockSrgbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData>`
                                
                                .. attribute:: label_context_type
                                
                                	LabelContextType
                                	**type**\:   :py:class:`MgmtLsdLblCtx <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLblCtx>`
                                
                                .. attribute:: mld_pv4_data
                                
                                	MLDPv4 LSM\-ID context
                                	**type**\:   :py:class:`MldPv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.MldPv4Data>`
                                
                                .. attribute:: next_hop_set_l3vpn
                                
                                	L3VPN NH SET label context
                                	**type**\:   :py:class:`NextHopSetL3Vpn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn>`
                                
                                .. attribute:: pi_mi_pmsi_data
                                
                                	PIM I\-PMSI label conext
                                	**type**\:   :py:class:`PiMiPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMiPmsiData>`
                                
                                .. attribute:: pi_ms_pmsi_data
                                
                                	PIM S\-PMSI label conext
                                	**type**\:   :py:class:`PiMsPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMsPmsiData>`
                                
                                .. attribute:: pseudowire_data
                                
                                	Pseudowire label context
                                	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireData>`
                                
                                .. attribute:: pseudowire_head_end_data
                                
                                	Pseudowire Head\-end label context
                                	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData>`
                                
                                .. attribute:: sr_adj_segment_ipv4
                                
                                	SR Adj Segment ipv4 context
                                	**type**\:   :py:class:`SrAdjSegmentIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4>`
                                
                                .. attribute:: sr_adj_segment_ipv6
                                
                                	SR Adj Segment ipv6 context
                                	**type**\:   :py:class:`SrAdjSegmentIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6>`
                                
                                .. attribute:: sr_prefix_segment
                                
                                	SR Prefix Segment context
                                	**type**\:   :py:class:`SrPrefixSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrPrefixSegment>`
                                
                                .. attribute:: te_binding
                                
                                	MPLS TE tunnel binding context
                                	**type**\:   :py:class:`TeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TeBinding>`
                                
                                .. attribute:: tev4_data
                                
                                	TEv4 label context
                                	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4Data>`
                                
                                .. attribute:: tev4p2mp_data
                                
                                	TEv4 P2MP context
                                	**type**\:   :py:class:`Tev4P2MpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4P2MpData>`
                                
                                .. attribute:: tp_data
                                
                                	TP context
                                	**type**\:   :py:class:`TpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TpData>`
                                
                                .. attribute:: vrf_l3vpn_data
                                
                                	L3VPN VRF label context
                                	**type**\:   :py:class:`VrfL3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.VrfL3VpnData>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext, self).__init__()

                                    self.yang_name = "label-context"
                                    self.yang_parent_name = "rewrite-id"

                                    self.label_context_type = YLeaf(YType.enumeration, "label-context-type")

                                    self.cev4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                    self.cev4l3vpn_data.parent = self
                                    self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                    self._children_yang_names.add("cev4l3vpn-data")

                                    self.cev6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                    self.cev6l3vpn_data.parent = self
                                    self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                    self._children_yang_names.add("cev6l3vpn-data")

                                    self.evpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.EvpnData()
                                    self.evpn_data.parent = self
                                    self._children_name_map["evpn_data"] = "evpn-data"
                                    self._children_yang_names.add("evpn-data")

                                    self.generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                    self.generic_routing_encapsulation.parent = self
                                    self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                    self._children_yang_names.add("generic-routing-encapsulation")

                                    self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.IpSubData()
                                    self.ip_sub_data.parent = self
                                    self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    self._children_yang_names.add("ip-sub-data")

                                    self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                    self._children_yang_names.add("ipv4-data")

                                    self.ipv4blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                    self.ipv4blb_data.parent = self
                                    self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                    self._children_yang_names.add("ipv4blb-data")

                                    self.ipv4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                    self.ipv4l3vpn_data.parent = self
                                    self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                    self._children_yang_names.add("ipv4l3vpn-data")

                                    self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                    self._children_yang_names.add("ipv6-data")

                                    self.ipv6_generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                    self.ipv6_generic_routing_encapsulation.parent = self
                                    self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                    self._children_yang_names.add("ipv6-generic-routing-encapsulation")

                                    self.ipv6blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                    self.ipv6blb_data.parent = self
                                    self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                    self._children_yang_names.add("ipv6blb-data")

                                    self.ipv6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                    self.ipv6l3vpn_data.parent = self
                                    self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                    self._children_yang_names.add("ipv6l3vpn-data")

                                    self.label_block_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                    self.label_block_data.parent = self
                                    self._children_name_map["label_block_data"] = "label-block-data"
                                    self._children_yang_names.add("label-block-data")

                                    self.label_block_srgb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                    self.label_block_srgb_data.parent = self
                                    self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                    self._children_yang_names.add("label-block-srgb-data")

                                    self.mld_pv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                    self.mld_pv4_data.parent = self
                                    self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                    self._children_yang_names.add("mld-pv4-data")

                                    self.next_hop_set_l3vpn = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                    self.next_hop_set_l3vpn.parent = self
                                    self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                    self._children_yang_names.add("next-hop-set-l3vpn")

                                    self.pi_mi_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                    self.pi_mi_pmsi_data.parent = self
                                    self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                    self._children_yang_names.add("pi-mi-pmsi-data")

                                    self.pi_ms_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                    self.pi_ms_pmsi_data.parent = self
                                    self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                    self._children_yang_names.add("pi-ms-pmsi-data")

                                    self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireData()
                                    self.pseudowire_data.parent = self
                                    self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    self._children_yang_names.add("pseudowire-data")

                                    self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                    self.pseudowire_head_end_data.parent = self
                                    self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    self._children_yang_names.add("pseudowire-head-end-data")

                                    self.sr_adj_segment_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                    self.sr_adj_segment_ipv4.parent = self
                                    self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                    self._children_yang_names.add("sr-adj-segment-ipv4")

                                    self.sr_adj_segment_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                    self.sr_adj_segment_ipv6.parent = self
                                    self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                    self._children_yang_names.add("sr-adj-segment-ipv6")

                                    self.sr_prefix_segment = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                    self.sr_prefix_segment.parent = self
                                    self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                    self._children_yang_names.add("sr-prefix-segment")

                                    self.te_binding = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TeBinding()
                                    self.te_binding.parent = self
                                    self._children_name_map["te_binding"] = "te-binding"
                                    self._children_yang_names.add("te-binding")

                                    self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4Data()
                                    self.tev4_data.parent = self
                                    self._children_name_map["tev4_data"] = "tev4-data"
                                    self._children_yang_names.add("tev4-data")

                                    self.tev4p2mp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                    self.tev4p2mp_data.parent = self
                                    self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                    self._children_yang_names.add("tev4p2mp-data")

                                    self.tp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TpData()
                                    self.tp_data.parent = self
                                    self._children_name_map["tp_data"] = "tp-data"
                                    self._children_yang_names.add("tp-data")

                                    self.vrf_l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                    self.vrf_l3vpn_data.parent = self
                                    self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                    self._children_yang_names.add("vrf-l3vpn-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_context_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)


                                class Ipv4Data(Entity):
                                    """
                                    IPv4 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv4 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	IPv4 prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf_name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..33
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__init__()

                                        self.yang_name = "ipv4-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.vrf_name = YLeaf(YType.str, "vrf-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "security_id",
                                                        "table_id",
                                                        "vrf_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set or
                                            self.vrf_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.vrf_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-name"):
                                            self.vrf_name = value
                                            self.vrf_name.value_namespace = name_space
                                            self.vrf_name.value_namespace_prefix = name_space_prefix


                                class Ipv6Data(Entity):
                                    """
                                    IPv6 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf_name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    	**length:** 0..33
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__init__()

                                        self.yang_name = "ipv6-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.vrf_name = YLeaf(YType.str, "vrf-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "security_id",
                                                        "table_id",
                                                        "vrf_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set or
                                            self.vrf_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.vrf_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-name"):
                                            self.vrf_name = value
                                            self.vrf_name.value_namespace = name_space
                                            self.vrf_name.value_namespace_prefix = name_space_prefix


                                class Tev4Data(Entity):
                                    """
                                    TEv4 label context
                                    
                                    .. attribute:: is_srte
                                    
                                    	Is this an SRTE head tunnel
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_dest
                                    
                                    	Tunnel destination
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_id_extension
                                    
                                    	Extended tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_lsp_id
                                    
                                    	Tunnel LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_source
                                    
                                    	Tunnel source
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4Data, self).__init__()

                                        self.yang_name = "tev4-data"
                                        self.yang_parent_name = "label-context"

                                        self.is_srte = YLeaf(YType.int32, "is-srte")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.tunnel_dest = YLeaf(YType.str, "tunnel-dest")

                                        self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                        self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                        self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                        self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_srte",
                                                        "table_id",
                                                        "tunnel_dest",
                                                        "tunnel_id",
                                                        "tunnel_id_extension",
                                                        "tunnel_lsp_id",
                                                        "tunnel_source") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_srte.is_set or
                                            self.table_id.is_set or
                                            self.tunnel_dest.is_set or
                                            self.tunnel_id.is_set or
                                            self.tunnel_id_extension.is_set or
                                            self.tunnel_lsp_id.is_set or
                                            self.tunnel_source.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_srte.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.tunnel_dest.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set or
                                            self.tunnel_id_extension.yfilter != YFilter.not_set or
                                            self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                            self.tunnel_source.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tev4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_srte.is_set or self.is_srte.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_srte.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.tunnel_dest.is_set or self.tunnel_dest.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_dest.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                        if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                        if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                        if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-srte" or name == "table-id" or name == "tunnel-dest" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-srte"):
                                            self.is_srte = value
                                            self.is_srte.value_namespace = name_space
                                            self.is_srte.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-dest"):
                                            self.tunnel_dest = value
                                            self.tunnel_dest.value_namespace = name_space
                                            self.tunnel_dest.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id-extension"):
                                            self.tunnel_id_extension = value
                                            self.tunnel_id_extension.value_namespace = name_space
                                            self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-lsp-id"):
                                            self.tunnel_lsp_id = value
                                            self.tunnel_lsp_id.value_namespace = name_space
                                            self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-source"):
                                            self.tunnel_source = value
                                            self.tunnel_source.value_namespace = name_space
                                            self.tunnel_source.value_namespace_prefix = name_space_prefix


                                class Ipv4L3VpnData(Entity):
                                    """
                                    L3VPN IPv4 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv4 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: route_distinguisher
                                    
                                    	Route distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__init__()

                                        self.yang_name = "ipv4l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "route_distinguisher") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.route_distinguisher.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.route_distinguisher.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "route-distinguisher"):
                                            self.route_distinguisher = value
                                            self.route_distinguisher.value_namespace = name_space
                                            self.route_distinguisher.value_namespace_prefix = name_space_prefix


                                class Ipv6L3VpnData(Entity):
                                    """
                                    L3VPN IPv6 label context
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv6 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: route_distinguisher
                                    
                                    	Route distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__init__()

                                        self.yang_name = "ipv6l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "route_distinguisher") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.route_distinguisher.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.route_distinguisher.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "route-distinguisher"):
                                            self.route_distinguisher = value
                                            self.route_distinguisher.value_namespace = name_space
                                            self.route_distinguisher.value_namespace_prefix = name_space_prefix


                                class VrfL3VpnData(Entity):
                                    """
                                    L3VPN VRF label context
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__init__()

                                        self.yang_name = "vrf-l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("security_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.security_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf-l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "security-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class Cev4L3VpnData(Entity):
                                    """
                                    L3VPN CEv4 label context
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__init__()

                                        self.yang_name = "cev4l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ipv4_next_hop",
                                                        "security_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ipv4_next_hop.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cev4l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ipv4-next-hop" or name == "security-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class Cev6L3VpnData(Entity):
                                    """
                                    L3VPN CEv6 label context
                                    
                                    .. attribute:: ipv6_next_hop
                                    
                                    	IPv6 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: security_id
                                    
                                    	Security ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__init__()

                                        self.yang_name = "cev6l3vpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                        self.security_id = YLeaf(YType.uint32, "security-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ipv6_next_hop",
                                                        "security_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ipv6_next_hop.is_set or
                                            self.security_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ipv6_next_hop.yfilter != YFilter.not_set or
                                            self.security_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cev6l3vpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                        if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.security_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ipv6-next-hop" or name == "security-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ipv6-next-hop"):
                                            self.ipv6_next_hop = value
                                            self.ipv6_next_hop.value_namespace = name_space
                                            self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "security-id"):
                                            self.security_id = value
                                            self.security_id.value_namespace = name_space
                                            self.security_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class PseudowireData(Entity):
                                    """
                                    Pseudowire label context
                                    
                                    .. attribute:: prefix
                                    
                                    	Address prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: pseudowire_id
                                    
                                    	Pseudo\-wire ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: remote_l2_router_id
                                    
                                    	Remote L2 Router ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: subinterface
                                    
                                    	Subinterface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireData, self).__init__()

                                        self.yang_name = "pseudowire-data"
                                        self.yang_parent_name = "label-context"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.pseudowire_id = YLeaf(YType.uint64, "pseudowire-id")

                                        self.remote_l2_router_id = YLeaf(YType.uint32, "remote-l2-router-id")

                                        self.subinterface = YLeaf(YType.str, "subinterface")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "pseudowire_id",
                                                        "remote_l2_router_id",
                                                        "subinterface") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.prefix.is_set or
                                            self.pseudowire_id.is_set or
                                            self.remote_l2_router_id.is_set or
                                            self.subinterface.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.pseudowire_id.yfilter != YFilter.not_set or
                                            self.remote_l2_router_id.yfilter != YFilter.not_set or
                                            self.subinterface.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pseudowire_id.get_name_leafdata())
                                        if (self.remote_l2_router_id.is_set or self.remote_l2_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remote_l2_router_id.get_name_leafdata())
                                        if (self.subinterface.is_set or self.subinterface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.subinterface.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "prefix" or name == "pseudowire-id" or name == "remote-l2-router-id" or name == "subinterface"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pseudowire-id"):
                                            self.pseudowire_id = value
                                            self.pseudowire_id.value_namespace = name_space
                                            self.pseudowire_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remote-l2-router-id"):
                                            self.remote_l2_router_id = value
                                            self.remote_l2_router_id.value_namespace = name_space
                                            self.remote_l2_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "subinterface"):
                                            self.subinterface = value
                                            self.subinterface.value_namespace = name_space
                                            self.subinterface.value_namespace_prefix = name_space_prefix


                                class LabelBlockData(Entity):
                                    """
                                    Label block context
                                    
                                    .. attribute:: edge_id
                                    
                                    	Edge ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: offset
                                    
                                    	Offset
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: service
                                    
                                    	Service
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: size
                                    
                                    	Number of labels
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vpn_id
                                    
                                    	VPN ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__init__()

                                        self.yang_name = "label-block-data"
                                        self.yang_parent_name = "label-context"

                                        self.edge_id = YLeaf(YType.uint16, "edge-id")

                                        self.offset = YLeaf(YType.uint32, "offset")

                                        self.service = YLeaf(YType.uint8, "service")

                                        self.size = YLeaf(YType.uint32, "size")

                                        self.vpn_id = YLeaf(YType.uint16, "vpn-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("edge_id",
                                                        "offset",
                                                        "service",
                                                        "size",
                                                        "vpn_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.edge_id.is_set or
                                            self.offset.is_set or
                                            self.service.is_set or
                                            self.size.is_set or
                                            self.vpn_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.edge_id.yfilter != YFilter.not_set or
                                            self.offset.yfilter != YFilter.not_set or
                                            self.service.yfilter != YFilter.not_set or
                                            self.size.yfilter != YFilter.not_set or
                                            self.vpn_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "label-block-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.edge_id.is_set or self.edge_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.edge_id.get_name_leafdata())
                                        if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.offset.get_name_leafdata())
                                        if (self.service.is_set or self.service.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.service.get_name_leafdata())
                                        if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.size.get_name_leafdata())
                                        if (self.vpn_id.is_set or self.vpn_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vpn_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "edge-id" or name == "offset" or name == "service" or name == "size" or name == "vpn-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "edge-id"):
                                            self.edge_id = value
                                            self.edge_id.value_namespace = name_space
                                            self.edge_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "offset"):
                                            self.offset = value
                                            self.offset.value_namespace = name_space
                                            self.offset.value_namespace_prefix = name_space_prefix
                                        if(value_path == "service"):
                                            self.service = value
                                            self.service.value_namespace = name_space
                                            self.service.value_namespace_prefix = name_space_prefix
                                        if(value_path == "size"):
                                            self.size = value
                                            self.size.value_namespace = name_space
                                            self.size.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vpn-id"):
                                            self.vpn_id = value
                                            self.vpn_id.value_namespace = name_space
                                            self.vpn_id.value_namespace_prefix = name_space_prefix


                                class IpSubData(Entity):
                                    """
                                    IP Subscriber context
                                    
                                    .. attribute:: parent_interface
                                    
                                    	Parent interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: table_id
                                    
                                    	Table Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.IpSubData, self).__init__()

                                        self.yang_name = "ip-sub-data"
                                        self.yang_parent_name = "label-context"

                                        self.parent_interface = YLeaf(YType.str, "parent-interface")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("parent_interface",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.parent_interface.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.parent_interface.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ip-sub-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.parent_interface.is_set or self.parent_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_interface.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "parent-interface" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "parent-interface"):
                                            self.parent_interface = value
                                            self.parent_interface.value_namespace = name_space
                                            self.parent_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class Tev4P2MpData(Entity):
                                    """
                                    TEv4 P2MP context
                                    
                                    .. attribute:: p2mp_id
                                    
                                    	Point to multipoint ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: previous_hop
                                    
                                    	Previous hop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_id_extension
                                    
                                    	Tunnel ID extension
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_lsp_id
                                    
                                    	Tunnel LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_source
                                    
                                    	Tunnel source
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__init__()

                                        self.yang_name = "tev4p2mp-data"
                                        self.yang_parent_name = "label-context"

                                        self.p2mp_id = YLeaf(YType.uint32, "p2mp-id")

                                        self.previous_hop = YLeaf(YType.str, "previous-hop")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                        self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                        self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                        self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("p2mp_id",
                                                        "previous_hop",
                                                        "table_id",
                                                        "tunnel_id",
                                                        "tunnel_id_extension",
                                                        "tunnel_lsp_id",
                                                        "tunnel_source") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.p2mp_id.is_set or
                                            self.previous_hop.is_set or
                                            self.table_id.is_set or
                                            self.tunnel_id.is_set or
                                            self.tunnel_id_extension.is_set or
                                            self.tunnel_lsp_id.is_set or
                                            self.tunnel_source.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.p2mp_id.yfilter != YFilter.not_set or
                                            self.previous_hop.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set or
                                            self.tunnel_id_extension.yfilter != YFilter.not_set or
                                            self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                            self.tunnel_source.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tev4p2mp-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                                        if (self.previous_hop.is_set or self.previous_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.previous_hop.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                        if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                        if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                        if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "p2mp-id" or name == "previous-hop" or name == "table-id" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "p2mp-id"):
                                            self.p2mp_id = value
                                            self.p2mp_id.value_namespace = name_space
                                            self.p2mp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "previous-hop"):
                                            self.previous_hop = value
                                            self.previous_hop.value_namespace = name_space
                                            self.previous_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id-extension"):
                                            self.tunnel_id_extension = value
                                            self.tunnel_id_extension.value_namespace = name_space
                                            self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-lsp-id"):
                                            self.tunnel_lsp_id = value
                                            self.tunnel_lsp_id.value_namespace = name_space
                                            self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-source"):
                                            self.tunnel_source = value
                                            self.tunnel_source.value_namespace = name_space
                                            self.tunnel_source.value_namespace_prefix = name_space_prefix


                                class MldPv4Data(Entity):
                                    """
                                    MLDPv4 LSM\-ID context
                                    
                                    .. attribute:: lsm_id
                                    
                                    	LSM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: peer_label_space_id
                                    
                                    	Peer Label Space Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: peer_lsrid
                                    
                                    	Peer LSR Id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: type
                                    
                                    	LSM ID Type
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__init__()

                                        self.yang_name = "mld-pv4-data"
                                        self.yang_parent_name = "label-context"

                                        self.lsm_id = YLeaf(YType.uint32, "lsm-id")

                                        self.peer_label_space_id = YLeaf(YType.uint16, "peer-label-space-id")

                                        self.peer_lsrid = YLeaf(YType.str, "peer-lsrid")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.type = YLeaf(YType.uint16, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("lsm_id",
                                                        "peer_label_space_id",
                                                        "peer_lsrid",
                                                        "table_id",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.lsm_id.is_set or
                                            self.peer_label_space_id.is_set or
                                            self.peer_lsrid.is_set or
                                            self.table_id.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.lsm_id.yfilter != YFilter.not_set or
                                            self.peer_label_space_id.yfilter != YFilter.not_set or
                                            self.peer_lsrid.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "mld-pv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.lsm_id.is_set or self.lsm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsm_id.get_name_leafdata())
                                        if (self.peer_label_space_id.is_set or self.peer_label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.peer_label_space_id.get_name_leafdata())
                                        if (self.peer_lsrid.is_set or self.peer_lsrid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.peer_lsrid.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "lsm-id" or name == "peer-label-space-id" or name == "peer-lsrid" or name == "table-id" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "lsm-id"):
                                            self.lsm_id = value
                                            self.lsm_id.value_namespace = name_space
                                            self.lsm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "peer-label-space-id"):
                                            self.peer_label_space_id = value
                                            self.peer_label_space_id.value_namespace = name_space
                                            self.peer_label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "peer-lsrid"):
                                            self.peer_lsrid = value
                                            self.peer_lsrid.value_namespace = name_space
                                            self.peer_lsrid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class PseudowireHeadEndData(Entity):
                                    """
                                    Pseudowire Head\-end label context
                                    
                                    .. attribute:: pwhe_intf
                                    
                                    	Pseudo\-wire Head\-end interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__init__()

                                        self.yang_name = "pseudowire-head-end-data"
                                        self.yang_parent_name = "label-context"

                                        self.pwhe_intf = YLeaf(YType.str, "pwhe-intf")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("pwhe_intf") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.pwhe_intf.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.pwhe_intf.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-head-end-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.pwhe_intf.is_set or self.pwhe_intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pwhe_intf.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "pwhe-intf"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "pwhe-intf"):
                                            self.pwhe_intf = value
                                            self.pwhe_intf.value_namespace = name_space
                                            self.pwhe_intf.value_namespace_prefix = name_space_prefix


                                class TpData(Entity):
                                    """
                                    TP context
                                    
                                    .. attribute:: dest_global_id
                                    
                                    	TP destination global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dest_node_id
                                    
                                    	TP destination node ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: dest_tunnel_id
                                    
                                    	TP destination tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsp_id
                                    
                                    	TP LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: source_global_id
                                    
                                    	TP source global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: source_node_id
                                    
                                    	TP source node ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: source_tunnel_id
                                    
                                    	TP source tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TpData, self).__init__()

                                        self.yang_name = "tp-data"
                                        self.yang_parent_name = "label-context"

                                        self.dest_global_id = YLeaf(YType.uint32, "dest-global-id")

                                        self.dest_node_id = YLeaf(YType.str, "dest-node-id")

                                        self.dest_tunnel_id = YLeaf(YType.uint16, "dest-tunnel-id")

                                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                        self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                                        self.source_node_id = YLeaf(YType.str, "source-node-id")

                                        self.source_tunnel_id = YLeaf(YType.uint16, "source-tunnel-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("dest_global_id",
                                                        "dest_node_id",
                                                        "dest_tunnel_id",
                                                        "lsp_id",
                                                        "source_global_id",
                                                        "source_node_id",
                                                        "source_tunnel_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.dest_global_id.is_set or
                                            self.dest_node_id.is_set or
                                            self.dest_tunnel_id.is_set or
                                            self.lsp_id.is_set or
                                            self.source_global_id.is_set or
                                            self.source_node_id.is_set or
                                            self.source_tunnel_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.dest_global_id.yfilter != YFilter.not_set or
                                            self.dest_node_id.yfilter != YFilter.not_set or
                                            self.dest_tunnel_id.yfilter != YFilter.not_set or
                                            self.lsp_id.yfilter != YFilter.not_set or
                                            self.source_global_id.yfilter != YFilter.not_set or
                                            self.source_node_id.yfilter != YFilter.not_set or
                                            self.source_tunnel_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tp-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.dest_global_id.is_set or self.dest_global_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dest_global_id.get_name_leafdata())
                                        if (self.dest_node_id.is_set or self.dest_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dest_node_id.get_name_leafdata())
                                        if (self.dest_tunnel_id.is_set or self.dest_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dest_tunnel_id.get_name_leafdata())
                                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsp_id.get_name_leafdata())
                                        if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source_global_id.get_name_leafdata())
                                        if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source_node_id.get_name_leafdata())
                                        if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dest-global-id" or name == "dest-node-id" or name == "dest-tunnel-id" or name == "lsp-id" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "dest-global-id"):
                                            self.dest_global_id = value
                                            self.dest_global_id.value_namespace = name_space
                                            self.dest_global_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dest-node-id"):
                                            self.dest_node_id = value
                                            self.dest_node_id.value_namespace = name_space
                                            self.dest_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dest-tunnel-id"):
                                            self.dest_tunnel_id = value
                                            self.dest_tunnel_id.value_namespace = name_space
                                            self.dest_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsp-id"):
                                            self.lsp_id = value
                                            self.lsp_id.value_namespace = name_space
                                            self.lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source-global-id"):
                                            self.source_global_id = value
                                            self.source_global_id.value_namespace = name_space
                                            self.source_global_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source-node-id"):
                                            self.source_node_id = value
                                            self.source_node_id.value_namespace = name_space
                                            self.source_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source-tunnel-id"):
                                            self.source_tunnel_id = value
                                            self.source_tunnel_id.value_namespace = name_space
                                            self.source_tunnel_id.value_namespace_prefix = name_space_prefix


                                class GenericRoutingEncapsulation(Entity):
                                    """
                                    Generic routing encapsulation context
                                    
                                    .. attribute:: gre_interface
                                    
                                    	Generic routing encapsulation interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__init__()

                                        self.yang_name = "generic-routing-encapsulation"
                                        self.yang_parent_name = "label-context"

                                        self.gre_interface = YLeaf(YType.str, "gre-interface")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("gre_interface") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.gre_interface.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.gre_interface.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "generic-routing-encapsulation" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.gre_interface.is_set or self.gre_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gre_interface.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "gre-interface"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "gre-interface"):
                                            self.gre_interface = value
                                            self.gre_interface.value_namespace = name_space
                                            self.gre_interface.value_namespace_prefix = name_space_prefix


                                class Ipv6GenericRoutingEncapsulation(Entity):
                                    """
                                    Generic routing encapsulation context
                                    
                                    .. attribute:: greipv6_interface
                                    
                                    	Generic routing encapsulation IPv6 interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__init__()

                                        self.yang_name = "ipv6-generic-routing-encapsulation"
                                        self.yang_parent_name = "label-context"

                                        self.greipv6_interface = YLeaf(YType.str, "greipv6-interface")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("greipv6_interface") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.greipv6_interface.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.greipv6_interface.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-generic-routing-encapsulation" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.greipv6_interface.is_set or self.greipv6_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.greipv6_interface.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "greipv6-interface"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "greipv6-interface"):
                                            self.greipv6_interface = value
                                            self.greipv6_interface.value_namespace = name_space
                                            self.greipv6_interface.value_namespace_prefix = name_space_prefix


                                class EvpnData(Entity):
                                    """
                                    EVPN context
                                    
                                    .. attribute:: ethernet_segment
                                    
                                    	Ethernet Segment ID
                                    	**type**\:  str
                                    
                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                    
                                    .. attribute:: evpn_id
                                    
                                    	EVPN ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: evpn_tag
                                    
                                    	EVPN TAG
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.EvpnData, self).__init__()

                                        self.yang_name = "evpn-data"
                                        self.yang_parent_name = "label-context"

                                        self.ethernet_segment = YLeaf(YType.str, "ethernet-segment")

                                        self.evpn_id = YLeaf(YType.uint32, "evpn-id")

                                        self.evpn_tag = YLeaf(YType.uint32, "evpn-tag")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ethernet_segment",
                                                        "evpn_id",
                                                        "evpn_tag") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ethernet_segment.is_set or
                                            self.evpn_id.is_set or
                                            self.evpn_tag.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ethernet_segment.yfilter != YFilter.not_set or
                                            self.evpn_id.yfilter != YFilter.not_set or
                                            self.evpn_tag.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "evpn-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ethernet_segment.is_set or self.ethernet_segment.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ethernet_segment.get_name_leafdata())
                                        if (self.evpn_id.is_set or self.evpn_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.evpn_id.get_name_leafdata())
                                        if (self.evpn_tag.is_set or self.evpn_tag.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.evpn_tag.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ethernet-segment" or name == "evpn-id" or name == "evpn-tag"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ethernet-segment"):
                                            self.ethernet_segment = value
                                            self.ethernet_segment.value_namespace = name_space
                                            self.ethernet_segment.value_namespace_prefix = name_space_prefix
                                        if(value_path == "evpn-id"):
                                            self.evpn_id = value
                                            self.evpn_id.value_namespace = name_space
                                            self.evpn_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "evpn-tag"):
                                            self.evpn_tag = value
                                            self.evpn_tag.value_namespace = name_space
                                            self.evpn_tag.value_namespace_prefix = name_space_prefix


                                class Ipv4BlbData(Entity):
                                    """
                                    BFD BLB label context
                                    
                                    .. attribute:: blb_intf
                                    
                                    	BFD BLB interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv4 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__init__()

                                        self.yang_name = "ipv4blb-data"
                                        self.yang_parent_name = "label-context"

                                        self.blb_intf = YLeaf(YType.str, "blb-intf")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("blb_intf",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.blb_intf.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.blb_intf.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4blb-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "blb-intf" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "blb-intf"):
                                            self.blb_intf = value
                                            self.blb_intf.value_namespace = name_space
                                            self.blb_intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix


                                class Ipv6BlbData(Entity):
                                    """
                                    BFD BLB label context
                                    
                                    .. attribute:: blb_intf
                                    
                                    	BFD BLB interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: prefix
                                    
                                    	IPv6 prefix
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__init__()

                                        self.yang_name = "ipv6blb-data"
                                        self.yang_parent_name = "label-context"

                                        self.blb_intf = YLeaf(YType.str, "blb-intf")

                                        self.prefix = YLeaf(YType.str, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("blb_intf",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.blb_intf.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.blb_intf.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6blb-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "blb-intf" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "blb-intf"):
                                            self.blb_intf = value
                                            self.blb_intf.value_namespace = name_space
                                            self.blb_intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix


                                class PiMiPmsiData(Entity):
                                    """
                                    PIM I\-PMSI label conext
                                    
                                    .. attribute:: head
                                    
                                    	Head
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: v6
                                    
                                    	PIM6
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: vrf_id
                                    
                                    	VRF ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__init__()

                                        self.yang_name = "pi-mi-pmsi-data"
                                        self.yang_parent_name = "label-context"

                                        self.head = YLeaf(YType.int32, "head")

                                        self.v6 = YLeaf(YType.int32, "v6")

                                        self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("head",
                                                        "v6",
                                                        "vrf_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.head.is_set or
                                            self.v6.is_set or
                                            self.vrf_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.head.yfilter != YFilter.not_set or
                                            self.v6.yfilter != YFilter.not_set or
                                            self.vrf_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pi-mi-pmsi-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.head.get_name_leafdata())
                                        if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.v6.get_name_leafdata())
                                        if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "head" or name == "v6" or name == "vrf-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "head"):
                                            self.head = value
                                            self.head.value_namespace = name_space
                                            self.head.value_namespace_prefix = name_space_prefix
                                        if(value_path == "v6"):
                                            self.v6 = value
                                            self.v6.value_namespace = name_space
                                            self.v6.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-id"):
                                            self.vrf_id = value
                                            self.vrf_id.value_namespace = name_space
                                            self.vrf_id.value_namespace_prefix = name_space_prefix


                                class PiMsPmsiData(Entity):
                                    """
                                    PIM S\-PMSI label conext
                                    
                                    .. attribute:: head
                                    
                                    	Head
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: hli
                                    
                                    	Head LSM\-ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: seg
                                    
                                    	Segmented Multicast
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: source
                                    
                                    	Originating Router
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: v6
                                    
                                    	PIM6
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: vrf_id
                                    
                                    	VRF ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__init__()

                                        self.yang_name = "pi-ms-pmsi-data"
                                        self.yang_parent_name = "label-context"

                                        self.head = YLeaf(YType.int32, "head")

                                        self.hli = YLeaf(YType.uint32, "hli")

                                        self.seg = YLeaf(YType.int32, "seg")

                                        self.source = YLeaf(YType.str, "source")

                                        self.v6 = YLeaf(YType.int32, "v6")

                                        self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("head",
                                                        "hli",
                                                        "seg",
                                                        "source",
                                                        "v6",
                                                        "vrf_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.head.is_set or
                                            self.hli.is_set or
                                            self.seg.is_set or
                                            self.source.is_set or
                                            self.v6.is_set or
                                            self.vrf_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.head.yfilter != YFilter.not_set or
                                            self.hli.yfilter != YFilter.not_set or
                                            self.seg.yfilter != YFilter.not_set or
                                            self.source.yfilter != YFilter.not_set or
                                            self.v6.yfilter != YFilter.not_set or
                                            self.vrf_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pi-ms-pmsi-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.head.get_name_leafdata())
                                        if (self.hli.is_set or self.hli.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hli.get_name_leafdata())
                                        if (self.seg.is_set or self.seg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.seg.get_name_leafdata())
                                        if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.source.get_name_leafdata())
                                        if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.v6.get_name_leafdata())
                                        if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "head" or name == "hli" or name == "seg" or name == "source" or name == "v6" or name == "vrf-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "head"):
                                            self.head = value
                                            self.head.value_namespace = name_space
                                            self.head.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hli"):
                                            self.hli = value
                                            self.hli.value_namespace = name_space
                                            self.hli.value_namespace_prefix = name_space_prefix
                                        if(value_path == "seg"):
                                            self.seg = value
                                            self.seg.value_namespace = name_space
                                            self.seg.value_namespace_prefix = name_space_prefix
                                        if(value_path == "source"):
                                            self.source = value
                                            self.source.value_namespace = name_space
                                            self.source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "v6"):
                                            self.v6 = value
                                            self.v6.value_namespace = name_space
                                            self.v6.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vrf-id"):
                                            self.vrf_id = value
                                            self.vrf_id.value_namespace = name_space
                                            self.vrf_id.value_namespace_prefix = name_space_prefix


                                class NextHopSetL3Vpn(Entity):
                                    """
                                    L3VPN NH SET label context
                                    
                                    .. attribute:: next_hop_set_id
                                    
                                    	Next Hop Set ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__init__()

                                        self.yang_name = "next-hop-set-l3vpn"
                                        self.yang_parent_name = "label-context"

                                        self.next_hop_set_id = YLeaf(YType.uint32, "next-hop-set-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("next_hop_set_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.next_hop_set_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.next_hop_set_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "next-hop-set-l3vpn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.next_hop_set_id.is_set or self.next_hop_set_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_set_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "next-hop-set-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "next-hop-set-id"):
                                            self.next_hop_set_id = value
                                            self.next_hop_set_id.value_namespace = name_space
                                            self.next_hop_set_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class SrPrefixSegment(Entity):
                                    """
                                    SR Prefix Segment context
                                    
                                    .. attribute:: segment_id
                                    
                                    	Prefix Segment ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__init__()

                                        self.yang_name = "sr-prefix-segment"
                                        self.yang_parent_name = "label-context"

                                        self.segment_id = YLeaf(YType.uint32, "segment-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("segment_id",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.segment_id.is_set or
                                            self.table_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.segment_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-prefix-segment" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.segment_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "segment-id" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "segment-id"):
                                            self.segment_id = value
                                            self.segment_id.value_namespace = name_space
                                            self.segment_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix


                                class SrAdjSegmentIpv4(Entity):
                                    """
                                    SR Adj Segment ipv4 context
                                    
                                    .. attribute:: addr
                                    
                                    	Adjacency nexthop IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: index
                                    
                                    	Adjacency index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: intf
                                    
                                    	Adjacency interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: type
                                    
                                    	Adjacency type
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__init__()

                                        self.yang_name = "sr-adj-segment-ipv4"
                                        self.yang_parent_name = "label-context"

                                        self.addr = YLeaf(YType.str, "addr")

                                        self.index = YLeaf(YType.uint32, "index")

                                        self.intf = YLeaf(YType.str, "intf")

                                        self.type = YLeaf(YType.uint32, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("addr",
                                                        "index",
                                                        "intf",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.addr.is_set or
                                            self.index.is_set or
                                            self.intf.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.addr.yfilter != YFilter.not_set or
                                            self.index.yfilter != YFilter.not_set or
                                            self.intf.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-adj-segment-ipv4" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.addr.get_name_leafdata())
                                        if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.index.get_name_leafdata())
                                        if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.intf.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "addr"):
                                            self.addr = value
                                            self.addr.value_namespace = name_space
                                            self.addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "index"):
                                            self.index = value
                                            self.index.value_namespace = name_space
                                            self.index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "intf"):
                                            self.intf = value
                                            self.intf.value_namespace = name_space
                                            self.intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class SrAdjSegmentIpv6(Entity):
                                    """
                                    SR Adj Segment ipv6 context
                                    
                                    .. attribute:: addr
                                    
                                    	Adjacency nexthop IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: index
                                    
                                    	Adjacency index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: intf
                                    
                                    	Adjacency interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: type
                                    
                                    	Adjacency type
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__init__()

                                        self.yang_name = "sr-adj-segment-ipv6"
                                        self.yang_parent_name = "label-context"

                                        self.addr = YLeaf(YType.str, "addr")

                                        self.index = YLeaf(YType.uint32, "index")

                                        self.intf = YLeaf(YType.str, "intf")

                                        self.type = YLeaf(YType.uint32, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("addr",
                                                        "index",
                                                        "intf",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.addr.is_set or
                                            self.index.is_set or
                                            self.intf.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.addr.yfilter != YFilter.not_set or
                                            self.index.yfilter != YFilter.not_set or
                                            self.intf.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-adj-segment-ipv6" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.addr.get_name_leafdata())
                                        if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.index.get_name_leafdata())
                                        if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.intf.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "addr"):
                                            self.addr = value
                                            self.addr.value_namespace = name_space
                                            self.addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "index"):
                                            self.index = value
                                            self.index.value_namespace = name_space
                                            self.index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "intf"):
                                            self.intf = value
                                            self.intf.value_namespace = name_space
                                            self.intf.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class LabelBlockSrgbData(Entity):
                                    """
                                    Label block SRGB context
                                    
                                    .. attribute:: offset
                                    
                                    	Offset
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: size
                                    
                                    	Number of labels
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: start_label
                                    
                                    	Start Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__init__()

                                        self.yang_name = "label-block-srgb-data"
                                        self.yang_parent_name = "label-context"

                                        self.offset = YLeaf(YType.uint32, "offset")

                                        self.size = YLeaf(YType.uint32, "size")

                                        self.start_label = YLeaf(YType.uint32, "start-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("offset",
                                                        "size",
                                                        "start_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.offset.is_set or
                                            self.size.is_set or
                                            self.start_label.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.offset.yfilter != YFilter.not_set or
                                            self.size.yfilter != YFilter.not_set or
                                            self.start_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "label-block-srgb-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.offset.get_name_leafdata())
                                        if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.size.get_name_leafdata())
                                        if (self.start_label.is_set or self.start_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.start_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "offset" or name == "size" or name == "start-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "offset"):
                                            self.offset = value
                                            self.offset.value_namespace = name_space
                                            self.offset.value_namespace_prefix = name_space_prefix
                                        if(value_path == "size"):
                                            self.size = value
                                            self.size.value_namespace = name_space
                                            self.size.value_namespace_prefix = name_space_prefix
                                        if(value_path == "start-label"):
                                            self.start_label = value
                                            self.start_label.value_namespace = name_space
                                            self.start_label.value_namespace_prefix = name_space_prefix


                                class TeBinding(Entity):
                                    """
                                    MPLS TE tunnel binding context
                                    
                                    .. attribute:: te_identifier
                                    
                                    	MPLS Traffic Engineering Tunnel or Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_type
                                    
                                    	Type of identifier for the binding
                                    	**type**\:   :py:class:`MgmtLsdTeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdTeBinding>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TeBinding, self).__init__()

                                        self.yang_name = "te-binding"
                                        self.yang_parent_name = "label-context"

                                        self.te_identifier = YLeaf(YType.uint32, "te-identifier")

                                        self.te_type = YLeaf(YType.enumeration, "te-type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("te_identifier",
                                                        "te_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.te_identifier.is_set or
                                            self.te_type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.te_identifier.yfilter != YFilter.not_set or
                                            self.te_type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "te-binding" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.te_identifier.is_set or self.te_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_identifier.get_name_leafdata())
                                        if (self.te_type.is_set or self.te_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "te-identifier" or name == "te-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "te-identifier"):
                                            self.te_identifier = value
                                            self.te_identifier.value_namespace = name_space
                                            self.te_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-type"):
                                            self.te_type = value
                                            self.te_type.value_namespace = name_space
                                            self.te_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_context_type.is_set or
                                        (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_data()) or
                                        (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_data()) or
                                        (self.evpn_data is not None and self.evpn_data.has_data()) or
                                        (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_data()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                        (self.ipv4blb_data is not None and self.ipv4blb_data.has_data()) or
                                        (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_data()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                        (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_data()) or
                                        (self.ipv6blb_data is not None and self.ipv6blb_data.has_data()) or
                                        (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_data()) or
                                        (self.label_block_data is not None and self.label_block_data.has_data()) or
                                        (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_data()) or
                                        (self.mld_pv4_data is not None and self.mld_pv4_data.has_data()) or
                                        (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_data()) or
                                        (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_data()) or
                                        (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_data()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                        (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_data()) or
                                        (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_data()) or
                                        (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_data()) or
                                        (self.te_binding is not None and self.te_binding.has_data()) or
                                        (self.tev4_data is not None and self.tev4_data.has_data()) or
                                        (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_data()) or
                                        (self.tp_data is not None and self.tp_data.has_data()) or
                                        (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_context_type.yfilter != YFilter.not_set or
                                        (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_operation()) or
                                        (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_operation()) or
                                        (self.evpn_data is not None and self.evpn_data.has_operation()) or
                                        (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_operation()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                        (self.ipv4blb_data is not None and self.ipv4blb_data.has_operation()) or
                                        (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_operation()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                        (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_operation()) or
                                        (self.ipv6blb_data is not None and self.ipv6blb_data.has_operation()) or
                                        (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_operation()) or
                                        (self.label_block_data is not None and self.label_block_data.has_operation()) or
                                        (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_operation()) or
                                        (self.mld_pv4_data is not None and self.mld_pv4_data.has_operation()) or
                                        (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_operation()) or
                                        (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_operation()) or
                                        (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_operation()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                        (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_operation()) or
                                        (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_operation()) or
                                        (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_operation()) or
                                        (self.te_binding is not None and self.te_binding.has_operation()) or
                                        (self.tev4_data is not None and self.tev4_data.has_operation()) or
                                        (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_operation()) or
                                        (self.tp_data is not None and self.tp_data.has_operation()) or
                                        (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-context" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_context_type.is_set or self.label_context_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_context_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cev4l3vpn-data"):
                                        if (self.cev4l3vpn_data is None):
                                            self.cev4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                            self.cev4l3vpn_data.parent = self
                                            self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                        return self.cev4l3vpn_data

                                    if (child_yang_name == "cev6l3vpn-data"):
                                        if (self.cev6l3vpn_data is None):
                                            self.cev6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                            self.cev6l3vpn_data.parent = self
                                            self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                        return self.cev6l3vpn_data

                                    if (child_yang_name == "evpn-data"):
                                        if (self.evpn_data is None):
                                            self.evpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.EvpnData()
                                            self.evpn_data.parent = self
                                            self._children_name_map["evpn_data"] = "evpn-data"
                                        return self.evpn_data

                                    if (child_yang_name == "generic-routing-encapsulation"):
                                        if (self.generic_routing_encapsulation is None):
                                            self.generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                            self.generic_routing_encapsulation.parent = self
                                            self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                        return self.generic_routing_encapsulation

                                    if (child_yang_name == "ip-sub-data"):
                                        if (self.ip_sub_data is None):
                                            self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.IpSubData()
                                            self.ip_sub_data.parent = self
                                            self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                        return self.ip_sub_data

                                    if (child_yang_name == "ipv4-data"):
                                        if (self.ipv4_data is None):
                                            self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                            self.ipv4_data.parent = self
                                            self._children_name_map["ipv4_data"] = "ipv4-data"
                                        return self.ipv4_data

                                    if (child_yang_name == "ipv4blb-data"):
                                        if (self.ipv4blb_data is None):
                                            self.ipv4blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                            self.ipv4blb_data.parent = self
                                            self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                        return self.ipv4blb_data

                                    if (child_yang_name == "ipv4l3vpn-data"):
                                        if (self.ipv4l3vpn_data is None):
                                            self.ipv4l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                            self.ipv4l3vpn_data.parent = self
                                            self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                        return self.ipv4l3vpn_data

                                    if (child_yang_name == "ipv6-data"):
                                        if (self.ipv6_data is None):
                                            self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                            self.ipv6_data.parent = self
                                            self._children_name_map["ipv6_data"] = "ipv6-data"
                                        return self.ipv6_data

                                    if (child_yang_name == "ipv6-generic-routing-encapsulation"):
                                        if (self.ipv6_generic_routing_encapsulation is None):
                                            self.ipv6_generic_routing_encapsulation = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                            self.ipv6_generic_routing_encapsulation.parent = self
                                            self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                        return self.ipv6_generic_routing_encapsulation

                                    if (child_yang_name == "ipv6blb-data"):
                                        if (self.ipv6blb_data is None):
                                            self.ipv6blb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                            self.ipv6blb_data.parent = self
                                            self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                        return self.ipv6blb_data

                                    if (child_yang_name == "ipv6l3vpn-data"):
                                        if (self.ipv6l3vpn_data is None):
                                            self.ipv6l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                            self.ipv6l3vpn_data.parent = self
                                            self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                        return self.ipv6l3vpn_data

                                    if (child_yang_name == "label-block-data"):
                                        if (self.label_block_data is None):
                                            self.label_block_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                            self.label_block_data.parent = self
                                            self._children_name_map["label_block_data"] = "label-block-data"
                                        return self.label_block_data

                                    if (child_yang_name == "label-block-srgb-data"):
                                        if (self.label_block_srgb_data is None):
                                            self.label_block_srgb_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                            self.label_block_srgb_data.parent = self
                                            self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                        return self.label_block_srgb_data

                                    if (child_yang_name == "mld-pv4-data"):
                                        if (self.mld_pv4_data is None):
                                            self.mld_pv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                            self.mld_pv4_data.parent = self
                                            self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                        return self.mld_pv4_data

                                    if (child_yang_name == "next-hop-set-l3vpn"):
                                        if (self.next_hop_set_l3vpn is None):
                                            self.next_hop_set_l3vpn = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                            self.next_hop_set_l3vpn.parent = self
                                            self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                        return self.next_hop_set_l3vpn

                                    if (child_yang_name == "pi-mi-pmsi-data"):
                                        if (self.pi_mi_pmsi_data is None):
                                            self.pi_mi_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                            self.pi_mi_pmsi_data.parent = self
                                            self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                        return self.pi_mi_pmsi_data

                                    if (child_yang_name == "pi-ms-pmsi-data"):
                                        if (self.pi_ms_pmsi_data is None):
                                            self.pi_ms_pmsi_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                            self.pi_ms_pmsi_data.parent = self
                                            self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                        return self.pi_ms_pmsi_data

                                    if (child_yang_name == "pseudowire-data"):
                                        if (self.pseudowire_data is None):
                                            self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireData()
                                            self.pseudowire_data.parent = self
                                            self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                        return self.pseudowire_data

                                    if (child_yang_name == "pseudowire-head-end-data"):
                                        if (self.pseudowire_head_end_data is None):
                                            self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                            self.pseudowire_head_end_data.parent = self
                                            self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                        return self.pseudowire_head_end_data

                                    if (child_yang_name == "sr-adj-segment-ipv4"):
                                        if (self.sr_adj_segment_ipv4 is None):
                                            self.sr_adj_segment_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                            self.sr_adj_segment_ipv4.parent = self
                                            self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                        return self.sr_adj_segment_ipv4

                                    if (child_yang_name == "sr-adj-segment-ipv6"):
                                        if (self.sr_adj_segment_ipv6 is None):
                                            self.sr_adj_segment_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                            self.sr_adj_segment_ipv6.parent = self
                                            self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                        return self.sr_adj_segment_ipv6

                                    if (child_yang_name == "sr-prefix-segment"):
                                        if (self.sr_prefix_segment is None):
                                            self.sr_prefix_segment = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                            self.sr_prefix_segment.parent = self
                                            self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                        return self.sr_prefix_segment

                                    if (child_yang_name == "te-binding"):
                                        if (self.te_binding is None):
                                            self.te_binding = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TeBinding()
                                            self.te_binding.parent = self
                                            self._children_name_map["te_binding"] = "te-binding"
                                        return self.te_binding

                                    if (child_yang_name == "tev4-data"):
                                        if (self.tev4_data is None):
                                            self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4Data()
                                            self.tev4_data.parent = self
                                            self._children_name_map["tev4_data"] = "tev4-data"
                                        return self.tev4_data

                                    if (child_yang_name == "tev4p2mp-data"):
                                        if (self.tev4p2mp_data is None):
                                            self.tev4p2mp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                            self.tev4p2mp_data.parent = self
                                            self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                        return self.tev4p2mp_data

                                    if (child_yang_name == "tp-data"):
                                        if (self.tp_data is None):
                                            self.tp_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TpData()
                                            self.tp_data.parent = self
                                            self._children_name_map["tp_data"] = "tp-data"
                                        return self.tp_data

                                    if (child_yang_name == "vrf-l3vpn-data"):
                                        if (self.vrf_l3vpn_data is None):
                                            self.vrf_l3vpn_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                            self.vrf_l3vpn_data.parent = self
                                            self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                        return self.vrf_l3vpn_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cev4l3vpn-data" or name == "cev6l3vpn-data" or name == "evpn-data" or name == "generic-routing-encapsulation" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv4blb-data" or name == "ipv4l3vpn-data" or name == "ipv6-data" or name == "ipv6-generic-routing-encapsulation" or name == "ipv6blb-data" or name == "ipv6l3vpn-data" or name == "label-block-data" or name == "label-block-srgb-data" or name == "mld-pv4-data" or name == "next-hop-set-l3vpn" or name == "pi-mi-pmsi-data" or name == "pi-ms-pmsi-data" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "sr-adj-segment-ipv4" or name == "sr-adj-segment-ipv6" or name == "sr-prefix-segment" or name == "te-binding" or name == "tev4-data" or name == "tev4p2mp-data" or name == "tp-data" or name == "vrf-l3vpn-data" or name == "label-context-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-context-type"):
                                        self.label_context_type = value
                                        self.label_context_type.value_namespace = name_space
                                        self.label_context_type.value_namespace_prefix = name_space_prefix


                            class LocalLabelRewrite(Entity):
                                """
                                Local label rewrite information
                                
                                .. attribute:: label_data
                                
                                	label data
                                	**type**\:  list of int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LocalLabelRewrite, self).__init__()

                                    self.yang_name = "local-label-rewrite"
                                    self.yang_parent_name = "rewrite-id"

                                    self.label_data = YLeafList(YType.uint32, "label-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_data") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)

                                def has_data(self):
                                    for leaf in self.label_data.getYLeafs():
                                        if (leaf.yfilter != YFilter.not_set):
                                            return True
                                    return False

                                def has_operation(self):
                                    for leaf in self.label_data.getYLeafs():
                                        if (leaf.is_set):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_data.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "local-label-rewrite" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    leaf_name_data.extend(self.label_data.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "label-data"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-data"):
                                        self.label_data.append(value)

                            def has_data(self):
                                return (
                                    self.rewrite_id_type.is_set or
                                    (self.label_context is not None and self.label_context.has_data()) or
                                    (self.local_label_rewrite is not None and self.local_label_rewrite.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rewrite_id_type.yfilter != YFilter.not_set or
                                    (self.label_context is not None and self.label_context.has_operation()) or
                                    (self.local_label_rewrite is not None and self.local_label_rewrite.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "rewrite-id" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rewrite_id_type.is_set or self.rewrite_id_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rewrite_id_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "label-context"):
                                    if (self.label_context is None):
                                        self.label_context = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext()
                                        self.label_context.parent = self
                                        self._children_name_map["label_context"] = "label-context"
                                    return self.label_context

                                if (child_yang_name == "local-label-rewrite"):
                                    if (self.local_label_rewrite is None):
                                        self.local_label_rewrite = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LocalLabelRewrite()
                                        self.local_label_rewrite.parent = self
                                        self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                                    return self.local_label_rewrite

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "label-context" or name == "local-label-rewrite" or name == "rewrite-id-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rewrite-id-type"):
                                    self.rewrite_id_type = value
                                    self.rewrite_id_type.value_namespace = name_space
                                    self.rewrite_id_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.rewrite_id is not None and self.rewrite_id.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rewrite-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "rewrite-id"):
                                if (self.rewrite_id is None):
                                    self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId()
                                    self.rewrite_id.parent = self
                                    self._children_name_map["rewrite_id"] = "rewrite-id"
                                return self.rewrite_id

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "rewrite-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class AssociatedFpi(Entity):
                        """
                        Associated FPI
                        
                        .. attribute:: application_owner
                        
                        	Application owner instance
                        	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.ApplicationOwner>`
                        
                        .. attribute:: fpi
                        
                        	FPI
                        	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi, self).__init__()

                            self.yang_name = "associated-fpi"
                            self.yang_parent_name = "rewrite-label"

                            self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi()
                            self.fpi.parent = self
                            self._children_name_map["fpi"] = "fpi"
                            self._children_yang_names.add("fpi")

                            self.application_owner = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi, self).__setattr__(name, value)


                        class Fpi(Entity):
                            """
                            FPI
                            
                            .. attribute:: dmtc_ext_intf_data
                            
                            	dmtc ext intf data
                            	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.DmtcExtIntfData>`
                            
                            .. attribute:: fpi_type
                            
                            	FPIType
                            	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                            
                            .. attribute:: ipv4_data
                            
                            	ipv4 data
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv4Data>`
                            
                            .. attribute:: ipv6_data
                            
                            	ipv6 data
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv6Data>`
                            
                            .. attribute:: label_data
                            
                            	label data
                            	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.LabelData>`
                            
                            .. attribute:: pw_list_data
                            
                            	pw list data
                            	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.PwListData>`
                            
                            .. attribute:: te_data
                            
                            	te data
                            	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.TeData>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi, self).__init__()

                                self.yang_name = "fpi"
                                self.yang_parent_name = "associated-fpi"

                                self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                                self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.DmtcExtIntfData()
                                self.dmtc_ext_intf_data.parent = self
                                self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                self._children_yang_names.add("dmtc-ext-intf-data")

                                self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.LabelData()
                                self.label_data.parent = self
                                self._children_name_map["label_data"] = "label-data"
                                self._children_yang_names.add("label-data")

                                self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.PwListData()
                                self.pw_list_data.parent = self
                                self._children_name_map["pw_list_data"] = "pw-list-data"
                                self._children_yang_names.add("pw-list-data")

                                self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.TeData()
                                self.te_data.parent = self
                                self._children_name_map["te_data"] = "te-data"
                                self._children_yang_names.add("te-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fpi_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi, self).__setattr__(name, value)


                            class LabelData(Entity):
                                """
                                label data
                                
                                .. attribute:: elc
                                
                                	ELC
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: label
                                
                                	Label value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.LabelData, self).__init__()

                                    self.yang_name = "label-data"
                                    self.yang_parent_name = "fpi"

                                    self.elc = YLeaf(YType.int32, "elc")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("elc",
                                                    "label",
                                                    "security_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.elc.is_set or
                                        self.label.is_set or
                                        self.security_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.elc.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.elc.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "elc" or name == "label" or name == "security-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "elc"):
                                        self.elc = value
                                        self.elc.value_namespace = name_space
                                        self.elc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix


                            class TeData(Entity):
                                """
                                te data
                                
                                .. attribute:: local_label
                                
                                	Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_interface
                                
                                	Tunnel interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.TeData, self).__init__()

                                    self.yang_name = "te-data"
                                    self.yang_parent_name = "fpi"

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("local_label",
                                                    "tunnel_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.local_label.is_set or
                                        self.tunnel_interface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.tunnel_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "local-label" or name == "tunnel-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface"):
                                        self.tunnel_interface = value
                                        self.tunnel_interface.value_namespace = name_space
                                        self.tunnel_interface.value_namespace_prefix = name_space_prefix


                            class Ipv4Data(Entity):
                                """
                                ipv4 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: sr_local_label
                                
                                	SR related Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "sr_local_label",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.sr_local_label.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.sr_local_label.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sr-local-label"):
                                        self.sr_local_label = value
                                        self.sr_local_label.value_namespace = name_space
                                        self.sr_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                ipv6 data
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: router_flags
                                
                                	Route flags
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: version
                                
                                	Version
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "fpi"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    self.router_flags = YLeaf(YType.uint32, "router-flags")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.version = YLeaf(YType.uint32, "version")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_len",
                                                    "router_flags",
                                                    "table_id",
                                                    "version") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_len.is_set or
                                        self.router_flags.is_set or
                                        self.table_id.is_set or
                                        self.version.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set or
                                        self.router_flags.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.version.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                    if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_flags.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.version.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-flags"):
                                        self.router_flags = value
                                        self.router_flags.value_namespace = name_space
                                        self.router_flags.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "version"):
                                        self.version = value
                                        self.version.value_namespace = name_space
                                        self.version.value_namespace_prefix = name_space_prefix


                            class PwListData(Entity):
                                """
                                pw list data
                                
                                .. attribute:: pwhe_list_id
                                
                                	Pseudowire List Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.PwListData, self).__init__()

                                    self.yang_name = "pw-list-data"
                                    self.yang_parent_name = "fpi"

                                    self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("pwhe_list_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.pwhe_list_id.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.pwhe_list_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pw-list-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "pwhe-list-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "pwhe-list-id"):
                                        self.pwhe_list_id = value
                                        self.pwhe_list_id.value_namespace = name_space
                                        self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                            class DmtcExtIntfData(Entity):
                                """
                                dmtc ext intf data
                                
                                .. attribute:: dmtc_ext_ifh
                                
                                	DMTC External Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.DmtcExtIntfData, self).__init__()

                                    self.yang_name = "dmtc-ext-intf-data"
                                    self.yang_parent_name = "fpi"

                                    self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.dmtc_ext_ifh.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "dmtc-ext-intf-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-ext-ifh"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dmtc-ext-ifh"):
                                        self.dmtc_ext_ifh = value
                                        self.dmtc_ext_ifh.value_namespace = name_space
                                        self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fpi_type.is_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.label_data is not None and self.label_data.has_data()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                    (self.te_data is not None and self.te_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fpi_type.yfilter != YFilter.not_set or
                                    (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.label_data is not None and self.label_data.has_operation()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                    (self.te_data is not None and self.te_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fpi" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fpi_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "dmtc-ext-intf-data"):
                                    if (self.dmtc_ext_intf_data is None):
                                        self.dmtc_ext_intf_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.DmtcExtIntfData()
                                        self.dmtc_ext_intf_data.parent = self
                                        self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                    return self.dmtc_ext_intf_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "label-data"):
                                    if (self.label_data is None):
                                        self.label_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.LabelData()
                                        self.label_data.parent = self
                                        self._children_name_map["label_data"] = "label-data"
                                    return self.label_data

                                if (child_yang_name == "pw-list-data"):
                                    if (self.pw_list_data is None):
                                        self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.PwListData()
                                        self.pw_list_data.parent = self
                                        self._children_name_map["pw_list_data"] = "pw-list-data"
                                    return self.pw_list_data

                                if (child_yang_name == "te-data"):
                                    if (self.te_data is None):
                                        self.te_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.TeData()
                                        self.te_data.parent = self
                                        self._children_name_map["te_data"] = "te-data"
                                    return self.te_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fpi-type"):
                                    self.fpi_type = value
                                    self.fpi_type.value_namespace = name_space
                                    self.fpi_type.value_namespace_prefix = name_space_prefix


                        class ApplicationOwner(Entity):
                            """
                            Application owner instance
                            
                            .. attribute:: application_instance
                            
                            	Application instance Name
                            	**type**\:  str
                            
                            .. attribute:: application_name
                            
                            	Application name
                            	**type**\:  str
                            
                            .. attribute:: application_role_primary
                            
                            	Primary/Backup role
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: application_type
                            
                            	Application type
                            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                            
                            .. attribute:: resource_state
                            
                            	Application resource state
                            	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.ApplicationOwner, self).__init__()

                                self.yang_name = "application-owner"
                                self.yang_parent_name = "associated-fpi"

                                self.application_instance = YLeaf(YType.str, "application-instance")

                                self.application_name = YLeaf(YType.str, "application-name")

                                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                                self.application_type = YLeaf(YType.enumeration, "application-type")

                                self.resource_state = YLeaf(YType.enumeration, "resource-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("application_instance",
                                                "application_name",
                                                "application_role_primary",
                                                "application_type",
                                                "resource_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.application_instance.is_set or
                                    self.application_name.is_set or
                                    self.application_role_primary.is_set or
                                    self.application_type.is_set or
                                    self.resource_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.application_instance.yfilter != YFilter.not_set or
                                    self.application_name.yfilter != YFilter.not_set or
                                    self.application_role_primary.yfilter != YFilter.not_set or
                                    self.application_type.yfilter != YFilter.not_set or
                                    self.resource_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "application-owner" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_name.get_name_leafdata())
                                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_type.get_name_leafdata())
                                if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resource_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "application-instance"):
                                    self.application_instance = value
                                    self.application_instance.value_namespace = name_space
                                    self.application_instance.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-name"):
                                    self.application_name = value
                                    self.application_name.value_namespace = name_space
                                    self.application_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-role-primary"):
                                    self.application_role_primary = value
                                    self.application_role_primary.value_namespace = name_space
                                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-type"):
                                    self.application_type = value
                                    self.application_type.value_namespace = name_space
                                    self.application_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "resource-state"):
                                    self.resource_state = value
                                    self.resource_state.value_namespace = name_space
                                    self.resource_state.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.application_owner:
                                if (c.has_data()):
                                    return True
                            return (self.fpi is not None and self.fpi.has_data())

                        def has_operation(self):
                            for c in self.application_owner:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.fpi is not None and self.fpi.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "associated-fpi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "application-owner"):
                                for c in self.application_owner:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.ApplicationOwner()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.application_owner.append(c)
                                return c

                            if (child_yang_name == "fpi"):
                                if (self.fpi is None):
                                    self.fpi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi()
                                    self.fpi.parent = self
                                    self._children_name_map["fpi"] = "fpi"
                                return self.fpi

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-owner" or name == "fpi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class V4Rpf(Entity):
                        """
                        IPv4 RPF neighbors
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: v4_rpf_neighbor
                        
                        	V4 RPF Neighbor
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.V4Rpf, self).__init__()

                            self.yang_name = "v4-rpf"
                            self.yang_parent_name = "rewrite-label"

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.v4_rpf_neighbor = YLeaf(YType.str, "v4-rpf-neighbor")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("table_id",
                                            "v4_rpf_neighbor") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.V4Rpf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.V4Rpf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.table_id.is_set or
                                self.v4_rpf_neighbor.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.v4_rpf_neighbor.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "v4-rpf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.v4_rpf_neighbor.is_set or self.v4_rpf_neighbor.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.v4_rpf_neighbor.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "table-id" or name == "v4-rpf-neighbor"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "v4-rpf-neighbor"):
                                self.v4_rpf_neighbor = value
                                self.v4_rpf_neighbor.value_namespace = name_space
                                self.v4_rpf_neighbor.value_namespace_prefix = name_space_prefix


                    class V6Rpf(Entity):
                        """
                        IPv6 RPF neighbors
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: v6_rpf_neighbor
                        
                        	V6 RPF Neighbor
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.V6Rpf, self).__init__()

                            self.yang_name = "v6-rpf"
                            self.yang_parent_name = "rewrite-label"

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.v6_rpf_neighbor = YLeaf(YType.str, "v6-rpf-neighbor")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("table_id",
                                            "v6_rpf_neighbor") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.V6Rpf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.V6Rpf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.table_id.is_set or
                                self.v6_rpf_neighbor.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.v6_rpf_neighbor.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "v6-rpf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.v6_rpf_neighbor.is_set or self.v6_rpf_neighbor.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.v6_rpf_neighbor.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "table-id" or name == "v6-rpf-neighbor"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "v6-rpf-neighbor"):
                                self.v6_rpf_neighbor = value
                                self.v6_rpf_neighbor.value_namespace = name_space
                                self.v6_rpf_neighbor.value_namespace_prefix = name_space_prefix


                    class Mois(Entity):
                        """
                        Mois
                        
                        .. attribute:: application_resource
                        
                        	Application state
                        	**type**\:   :py:class:`ApplicationResource <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.ApplicationResource>`
                        
                        .. attribute:: moi_array
                        
                        	moi array
                        	**type**\: list of    :py:class:`MoiArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois, self).__init__()

                            self.yang_name = "mois"
                            self.yang_parent_name = "rewrite-label"

                            self.application_resource = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.ApplicationResource()
                            self.application_resource.parent = self
                            self._children_name_map["application_resource"] = "application-resource"
                            self._children_yang_names.add("application-resource")

                            self.moi_array = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois, self).__setattr__(name, value)


                        class ApplicationResource(Entity):
                            """
                            Application state
                            
                            .. attribute:: application_instance
                            
                            	Application instance Name
                            	**type**\:  str
                            
                            .. attribute:: application_name
                            
                            	Application name
                            	**type**\:  str
                            
                            .. attribute:: application_role_primary
                            
                            	Primary/Backup role
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: application_type
                            
                            	Application type
                            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                            
                            .. attribute:: resource_state
                            
                            	Application resource state
                            	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.ApplicationResource, self).__init__()

                                self.yang_name = "application-resource"
                                self.yang_parent_name = "mois"

                                self.application_instance = YLeaf(YType.str, "application-instance")

                                self.application_name = YLeaf(YType.str, "application-name")

                                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                                self.application_type = YLeaf(YType.enumeration, "application-type")

                                self.resource_state = YLeaf(YType.enumeration, "resource-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("application_instance",
                                                "application_name",
                                                "application_role_primary",
                                                "application_type",
                                                "resource_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.ApplicationResource, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.ApplicationResource, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.application_instance.is_set or
                                    self.application_name.is_set or
                                    self.application_role_primary.is_set or
                                    self.application_type.is_set or
                                    self.resource_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.application_instance.yfilter != YFilter.not_set or
                                    self.application_name.yfilter != YFilter.not_set or
                                    self.application_role_primary.yfilter != YFilter.not_set or
                                    self.application_type.yfilter != YFilter.not_set or
                                    self.resource_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "application-resource" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_name.get_name_leafdata())
                                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.application_type.get_name_leafdata())
                                if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resource_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "application-instance"):
                                    self.application_instance = value
                                    self.application_instance.value_namespace = name_space
                                    self.application_instance.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-name"):
                                    self.application_name = value
                                    self.application_name.value_namespace = name_space
                                    self.application_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-role-primary"):
                                    self.application_role_primary = value
                                    self.application_role_primary.value_namespace = name_space
                                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                                if(value_path == "application-type"):
                                    self.application_type = value
                                    self.application_type.value_namespace = name_space
                                    self.application_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "resource-state"):
                                    self.resource_state = value
                                    self.resource_state.value_namespace = name_space
                                    self.resource_state.value_namespace_prefix = name_space_prefix


                        class MoiArray(Entity):
                            """
                            moi array
                            
                            .. attribute:: moi
                            
                            	Moi
                            	**type**\:   :py:class:`Moi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray, self).__init__()

                                self.yang_name = "moi-array"
                                self.yang_parent_name = "mois"

                                self.moi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi()
                                self.moi.parent = self
                                self._children_name_map["moi"] = "moi"
                                self._children_yang_names.add("moi")


                            class Moi(Entity):
                                """
                                Moi
                                
                                .. attribute:: dmtc_data
                                
                                	dmtc data
                                	**type**\:   :py:class:`DmtcData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.DmtcData>`
                                
                                .. attribute:: ip_sub_data
                                
                                	ip sub data
                                	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.IpSubData>`
                                
                                .. attribute:: ipv4_data
                                
                                	ipv4 data
                                	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv4Data>`
                                
                                .. attribute:: ipv6_data
                                
                                	ipv6 data
                                	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv6Data>`
                                
                                .. attribute:: moi_type
                                
                                	MoiType
                                	**type**\:   :py:class:`MgmtLsdMoi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdMoi>`
                                
                                .. attribute:: pop_and_lookup_ipv4
                                
                                	pop and lookup ipv4
                                	**type**\:   :py:class:`PopAndLookupIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv4>`
                                
                                .. attribute:: pop_and_lookup_ipv6
                                
                                	pop and lookup ipv6
                                	**type**\:   :py:class:`PopAndLookupIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv6>`
                                
                                .. attribute:: pop_and_lookup_tp
                                
                                	pop and lookup tp
                                	**type**\:   :py:class:`PopAndLookupTp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupTp>`
                                
                                .. attribute:: pseudowire_data
                                
                                	pseudowire data
                                	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireData>`
                                
                                .. attribute:: pseudowire_head_end_data
                                
                                	pseudowire head end data
                                	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireHeadEndData>`
                                
                                .. attribute:: pw_list_data
                                
                                	pw list data
                                	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PwListData>`
                                
                                .. attribute:: stackv4_data
                                
                                	stackv4 data
                                	**type**\:   :py:class:`Stackv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data>`
                                
                                .. attribute:: stackv6_data
                                
                                	stackv6 data
                                	**type**\:   :py:class:`Stackv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data>`
                                
                                .. attribute:: te_head_data
                                
                                	te head data
                                	**type**\:   :py:class:`TeHeadData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.TeHeadData>`
                                
                                .. attribute:: tev4_data
                                
                                	tev4 data
                                	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Tev4Data>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi, self).__init__()

                                    self.yang_name = "moi"
                                    self.yang_parent_name = "moi-array"

                                    self.moi_type = YLeaf(YType.enumeration, "moi-type")

                                    self.dmtc_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.DmtcData()
                                    self.dmtc_data.parent = self
                                    self._children_name_map["dmtc_data"] = "dmtc-data"
                                    self._children_yang_names.add("dmtc-data")

                                    self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.IpSubData()
                                    self.ip_sub_data.parent = self
                                    self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    self._children_yang_names.add("ip-sub-data")

                                    self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                    self._children_yang_names.add("ipv4-data")

                                    self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                    self._children_yang_names.add("ipv6-data")

                                    self.pop_and_lookup_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                    self.pop_and_lookup_ipv4.parent = self
                                    self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                    self._children_yang_names.add("pop-and-lookup-ipv4")

                                    self.pop_and_lookup_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                    self.pop_and_lookup_ipv6.parent = self
                                    self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                    self._children_yang_names.add("pop-and-lookup-ipv6")

                                    self.pop_and_lookup_tp = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupTp()
                                    self.pop_and_lookup_tp.parent = self
                                    self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                    self._children_yang_names.add("pop-and-lookup-tp")

                                    self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireData()
                                    self.pseudowire_data.parent = self
                                    self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    self._children_yang_names.add("pseudowire-data")

                                    self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                    self.pseudowire_head_end_data.parent = self
                                    self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    self._children_yang_names.add("pseudowire-head-end-data")

                                    self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PwListData()
                                    self.pw_list_data.parent = self
                                    self._children_name_map["pw_list_data"] = "pw-list-data"
                                    self._children_yang_names.add("pw-list-data")

                                    self.stackv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data()
                                    self.stackv4_data.parent = self
                                    self._children_name_map["stackv4_data"] = "stackv4-data"
                                    self._children_yang_names.add("stackv4-data")

                                    self.stackv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data()
                                    self.stackv6_data.parent = self
                                    self._children_name_map["stackv6_data"] = "stackv6-data"
                                    self._children_yang_names.add("stackv6-data")

                                    self.te_head_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.TeHeadData()
                                    self.te_head_data.parent = self
                                    self._children_name_map["te_head_data"] = "te-head-data"
                                    self._children_yang_names.add("te-head-data")

                                    self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Tev4Data()
                                    self.tev4_data.parent = self
                                    self._children_name_map["tev4_data"] = "tev4-data"
                                    self._children_yang_names.add("tev4-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("moi_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi, self).__setattr__(name, value)


                                class PopAndLookupIpv4(Entity):
                                    """
                                    pop and lookup ipv4
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__init__()

                                        self.yang_name = "pop-and-lookup-ipv4"
                                        self.yang_parent_name = "moi"

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pop-and-lookup-ipv4" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class PopAndLookupTp(Entity):
                                    """
                                    pop and lookup tp
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupTp, self).__init__()

                                        self.yang_name = "pop-and-lookup-tp"
                                        self.yang_parent_name = "moi"

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("out_label",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.out_label.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pop-and-lookup-tp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "out-label" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class PopAndLookupIpv6(Entity):
                                    """
                                    pop and lookup ipv6
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__init__()

                                        self.yang_name = "pop-and-lookup-ipv6"
                                        self.yang_parent_name = "moi"

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pop-and-lookup-ipv6" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class Ipv4Data(Entity):
                                    """
                                    ipv4 data
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: load_metric
                                    
                                    	Routing path's load metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: local_label
                                    
                                    	TE backup path local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_interface_parent
                                    
                                    	Outgoing Interface's parent
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv4Data, self).__init__()

                                        self.yang_name = "ipv4-data"
                                        self.yang_parent_name = "moi"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.load_metric = YLeaf(YType.uint32, "load-metric")

                                        self.local_label = YLeaf(YType.uint32, "local-label")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv4_next_hop",
                                                        "load_metric",
                                                        "local_label",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_interface_parent",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.load_metric.is_set or
                                            self.local_label.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_interface_parent.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.load_metric.yfilter != YFilter.not_set or
                                            self.local_label.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_interface_parent.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_metric.get_name_leafdata())
                                        if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_label.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-metric"):
                                            self.load_metric = value
                                            self.load_metric.value_namespace = name_space
                                            self.load_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-label"):
                                            self.local_label = value
                                            self.local_label.value_namespace = name_space
                                            self.local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface-parent"):
                                            self.out_interface_parent = value
                                            self.out_interface_parent.value_namespace = name_space
                                            self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix


                                class Ipv6Data(Entity):
                                    """
                                    ipv6 data
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv6_next_hop
                                    
                                    	IPv6 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv6Data, self).__init__()

                                        self.yang_name = "ipv6-data"
                                        self.yang_parent_name = "moi"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv6_next_hop",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv6_next_hop.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv6_next_hop.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6-next-hop"):
                                            self.ipv6_next_hop = value
                                            self.ipv6_next_hop.value_namespace = name_space
                                            self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class Tev4Data(Entity):
                                    """
                                    tev4 data
                                    
                                    .. attribute:: backup_interface
                                    
                                    	Backup interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: backup_ipv4_next_hop
                                    
                                    	Backup IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: backup_local_label
                                    
                                    	Backup local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: data_out_parent_interface
                                    
                                    	Outgoing data parent interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: merge_point_label
                                    
                                    	Merge point label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_class
                                    
                                    	Tunnel class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_interface
                                    
                                    	Tunnel interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: tunnel_weight
                                    
                                    	Tunnel weight
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Tev4Data, self).__init__()

                                        self.yang_name = "tev4-data"
                                        self.yang_parent_name = "moi"

                                        self.backup_interface = YLeaf(YType.str, "backup-interface")

                                        self.backup_ipv4_next_hop = YLeaf(YType.str, "backup-ipv4-next-hop")

                                        self.backup_local_label = YLeaf(YType.uint32, "backup-local-label")

                                        self.data_out_parent_interface = YLeaf(YType.str, "data-out-parent-interface")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.merge_point_label = YLeaf(YType.uint32, "merge-point-label")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_class = YLeaf(YType.uint32, "tunnel-class")

                                        self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                        self.tunnel_weight = YLeaf(YType.uint32, "tunnel-weight")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_interface",
                                                        "backup_ipv4_next_hop",
                                                        "backup_local_label",
                                                        "data_out_parent_interface",
                                                        "ipv4_next_hop",
                                                        "merge_point_label",
                                                        "out_interface",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_class",
                                                        "tunnel_interface",
                                                        "tunnel_weight") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_interface.is_set or
                                            self.backup_ipv4_next_hop.is_set or
                                            self.backup_local_label.is_set or
                                            self.data_out_parent_interface.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.merge_point_label.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_class.is_set or
                                            self.tunnel_interface.is_set or
                                            self.tunnel_weight.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_interface.yfilter != YFilter.not_set or
                                            self.backup_ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.backup_local_label.yfilter != YFilter.not_set or
                                            self.data_out_parent_interface.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.merge_point_label.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_class.yfilter != YFilter.not_set or
                                            self.tunnel_interface.yfilter != YFilter.not_set or
                                            self.tunnel_weight.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "tev4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_interface.is_set or self.backup_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_interface.get_name_leafdata())
                                        if (self.backup_ipv4_next_hop.is_set or self.backup_ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_ipv4_next_hop.get_name_leafdata())
                                        if (self.backup_local_label.is_set or self.backup_local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_local_label.get_name_leafdata())
                                        if (self.data_out_parent_interface.is_set or self.data_out_parent_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.data_out_parent_interface.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.merge_point_label.is_set or self.merge_point_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.merge_point_label.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_class.is_set or self.tunnel_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_class.get_name_leafdata())
                                        if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_interface.get_name_leafdata())
                                        if (self.tunnel_weight.is_set or self.tunnel_weight.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_weight.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-interface" or name == "backup-ipv4-next-hop" or name == "backup-local-label" or name == "data-out-parent-interface" or name == "ipv4-next-hop" or name == "merge-point-label" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-class" or name == "tunnel-interface" or name == "tunnel-weight"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-interface"):
                                            self.backup_interface = value
                                            self.backup_interface.value_namespace = name_space
                                            self.backup_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-ipv4-next-hop"):
                                            self.backup_ipv4_next_hop = value
                                            self.backup_ipv4_next_hop.value_namespace = name_space
                                            self.backup_ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "backup-local-label"):
                                            self.backup_local_label = value
                                            self.backup_local_label.value_namespace = name_space
                                            self.backup_local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "data-out-parent-interface"):
                                            self.data_out_parent_interface = value
                                            self.data_out_parent_interface.value_namespace = name_space
                                            self.data_out_parent_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "merge-point-label"):
                                            self.merge_point_label = value
                                            self.merge_point_label.value_namespace = name_space
                                            self.merge_point_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-class"):
                                            self.tunnel_class = value
                                            self.tunnel_class.value_namespace = name_space
                                            self.tunnel_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-interface"):
                                            self.tunnel_interface = value
                                            self.tunnel_interface.value_namespace = name_space
                                            self.tunnel_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-weight"):
                                            self.tunnel_weight = value
                                            self.tunnel_weight.value_namespace = name_space
                                            self.tunnel_weight.value_namespace_prefix = name_space_prefix


                                class PseudowireData(Entity):
                                    """
                                    pseudowire data
                                    
                                    .. attribute:: bridge_id
                                    
                                    	Bridge ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: cross_connect_id
                                    
                                    	Cross\-connect ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: pseuodo_wire_connect_id
                                    
                                    	PseudoWire Cross\-connect ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: split_horizon_id
                                    
                                    	Split horizon group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireData, self).__init__()

                                        self.yang_name = "pseudowire-data"
                                        self.yang_parent_name = "moi"

                                        self.bridge_id = YLeaf(YType.uint32, "bridge-id")

                                        self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.pseuodo_wire_connect_id = YLeaf(YType.uint32, "pseuodo-wire-connect-id")

                                        self.split_horizon_id = YLeaf(YType.uint32, "split-horizon-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bridge_id",
                                                        "cross_connect_id",
                                                        "ipv4_next_hop",
                                                        "out_interface",
                                                        "out_label",
                                                        "path_flags_decode",
                                                        "pseuodo_wire_connect_id",
                                                        "split_horizon_id",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.bridge_id.is_set or
                                            self.cross_connect_id.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.path_flags_decode.is_set or
                                            self.pseuodo_wire_connect_id.is_set or
                                            self.split_horizon_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bridge_id.yfilter != YFilter.not_set or
                                            self.cross_connect_id.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.pseuodo_wire_connect_id.yfilter != YFilter.not_set or
                                            self.split_horizon_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bridge_id.is_set or self.bridge_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bridge_id.get_name_leafdata())
                                        if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.pseuodo_wire_connect_id.is_set or self.pseuodo_wire_connect_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pseuodo_wire_connect_id.get_name_leafdata())
                                        if (self.split_horizon_id.is_set or self.split_horizon_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.split_horizon_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bridge-id" or name == "cross-connect-id" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pseuodo-wire-connect-id" or name == "split-horizon-id" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bridge-id"):
                                            self.bridge_id = value
                                            self.bridge_id.value_namespace = name_space
                                            self.bridge_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cross-connect-id"):
                                            self.cross_connect_id = value
                                            self.cross_connect_id.value_namespace = name_space
                                            self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pseuodo-wire-connect-id"):
                                            self.pseuodo_wire_connect_id = value
                                            self.pseuodo_wire_connect_id.value_namespace = name_space
                                            self.pseuodo_wire_connect_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "split-horizon-id"):
                                            self.split_horizon_id = value
                                            self.split_horizon_id.value_namespace = name_space
                                            self.split_horizon_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class IpSubData(Entity):
                                    """
                                    ip sub data
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	VRF table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.IpSubData, self).__init__()

                                        self.yang_name = "ip-sub-data"
                                        self.yang_parent_name = "moi"

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("out_interface",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.out_interface.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ip-sub-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "out-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class PseudowireHeadEndData(Entity):
                                    """
                                    pseudowire head end data
                                    
                                    .. attribute:: control_word
                                    
                                    	Is control word present
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: imposition
                                    
                                    	Is PWHE IMposition
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: pw_list_id
                                    
                                    	Pseudo\-wire List Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: pwhe_interface
                                    
                                    	Pseudo\-wire Head\-end interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: vctype
                                    
                                    	Virtual Circuit Type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__init__()

                                        self.yang_name = "pseudowire-head-end-data"
                                        self.yang_parent_name = "moi"

                                        self.control_word = YLeaf(YType.int32, "control-word")

                                        self.imposition = YLeaf(YType.int32, "imposition")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.pw_list_id = YLeaf(YType.uint16, "pw-list-id")

                                        self.pwhe_interface = YLeaf(YType.str, "pwhe-interface")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.vctype = YLeaf(YType.uint8, "vctype")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("control_word",
                                                        "imposition",
                                                        "ipv4_next_hop",
                                                        "out_interface",
                                                        "out_label",
                                                        "path_flags_decode",
                                                        "pw_list_id",
                                                        "pwhe_interface",
                                                        "table_id",
                                                        "table_name",
                                                        "vctype") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.control_word.is_set or
                                            self.imposition.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.path_flags_decode.is_set or
                                            self.pw_list_id.is_set or
                                            self.pwhe_interface.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.vctype.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.control_word.yfilter != YFilter.not_set or
                                            self.imposition.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.pw_list_id.yfilter != YFilter.not_set or
                                            self.pwhe_interface.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.vctype.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pseudowire-head-end-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.control_word.is_set or self.control_word.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.control_word.get_name_leafdata())
                                        if (self.imposition.is_set or self.imposition.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.imposition.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.pw_list_id.is_set or self.pw_list_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pw_list_id.get_name_leafdata())
                                        if (self.pwhe_interface.is_set or self.pwhe_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pwhe_interface.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.vctype.is_set or self.vctype.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.vctype.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "control-word" or name == "imposition" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pw-list-id" or name == "pwhe-interface" or name == "table-id" or name == "table-name" or name == "vctype"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "control-word"):
                                            self.control_word = value
                                            self.control_word.value_namespace = name_space
                                            self.control_word.value_namespace_prefix = name_space_prefix
                                        if(value_path == "imposition"):
                                            self.imposition = value
                                            self.imposition.value_namespace = name_space
                                            self.imposition.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pw-list-id"):
                                            self.pw_list_id = value
                                            self.pw_list_id.value_namespace = name_space
                                            self.pw_list_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pwhe-interface"):
                                            self.pwhe_interface = value
                                            self.pwhe_interface.value_namespace = name_space
                                            self.pwhe_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "vctype"):
                                            self.vctype = value
                                            self.vctype.value_namespace = name_space
                                            self.vctype.value_namespace_prefix = name_space_prefix


                                class PwListData(Entity):
                                    """
                                    pw list data
                                    
                                    .. attribute:: l2_interface
                                    
                                    	Pseudo\-wire Layer 2 interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: l3_interface
                                    
                                    	Pseudo\-wire Layer 3 interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PwListData, self).__init__()

                                        self.yang_name = "pw-list-data"
                                        self.yang_parent_name = "moi"

                                        self.l2_interface = YLeaf(YType.str, "l2-interface")

                                        self.l3_interface = YLeaf(YType.str, "l3-interface")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("l2_interface",
                                                        "l3_interface",
                                                        "path_flags_decode",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.l2_interface.is_set or
                                            self.l3_interface.is_set or
                                            self.path_flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.l2_interface.yfilter != YFilter.not_set or
                                            self.l3_interface.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pw-list-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.l2_interface.is_set or self.l2_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.l2_interface.get_name_leafdata())
                                        if (self.l3_interface.is_set or self.l3_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.l3_interface.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "l2-interface" or name == "l3-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "l2-interface"):
                                            self.l2_interface = value
                                            self.l2_interface.value_namespace = name_space
                                            self.l2_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "l3-interface"):
                                            self.l3_interface = value
                                            self.l3_interface.value_namespace = name_space
                                            self.l3_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class Stackv4Data(Entity):
                                    """
                                    stackv4 data
                                    
                                    .. attribute:: inner_stack
                                    
                                    	Inner stack
                                    	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Nexthop
                                    	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.Nexthop>`
                                    
                                    .. attribute:: owner_application_type
                                    
                                    	Owner application type
                                    	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data, self).__init__()

                                        self.yang_name = "stackv4-data"
                                        self.yang_parent_name = "moi"

                                        self.owner_application_type = YLeaf(YType.enumeration, "owner-application-type")

                                        self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                        self.inner_stack.parent = self
                                        self._children_name_map["inner_stack"] = "inner-stack"
                                        self._children_yang_names.add("inner-stack")

                                        self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                        self.nexthop.parent = self
                                        self._children_name_map["nexthop"] = "nexthop"
                                        self._children_yang_names.add("nexthop")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("owner_application_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)


                                    class Nexthop(Entity):
                                        """
                                        Nexthop
                                        
                                        .. attribute:: backup_path_id
                                        
                                        	Routing path backup id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4_next_hop
                                        
                                        	IPv4 nexthop
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: load_metric
                                        
                                        	Routing path's load metric
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: local_label
                                        
                                        	TE backup path local label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: next_hop_id
                                        
                                        	Next hop ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_interface
                                        
                                        	Outgoing Interface
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: out_interface_parent
                                        
                                        	Outgoing Interface's parent
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: out_label
                                        
                                        	Outgoing Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_label_name
                                        
                                        	Outgoing label name
                                        	**type**\:  str
                                        
                                        .. attribute:: path_flags_decode
                                        
                                        	Path flag decoded string
                                        	**type**\:  str
                                        
                                        .. attribute:: path_id
                                        
                                        	Routing path id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: table_id
                                        
                                        	Table ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: table_name
                                        
                                        	VRF table name
                                        	**type**\:  str
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__init__()

                                            self.yang_name = "nexthop"
                                            self.yang_parent_name = "stackv4-data"

                                            self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                            self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                            self.load_metric = YLeaf(YType.uint32, "load-metric")

                                            self.local_label = YLeaf(YType.uint32, "local-label")

                                            self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                            self.out_interface = YLeaf(YType.str, "out-interface")

                                            self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                            self.out_label = YLeaf(YType.uint32, "out-label")

                                            self.out_label_name = YLeaf(YType.str, "out-label-name")

                                            self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                            self.path_id = YLeaf(YType.uint8, "path-id")

                                            self.table_id = YLeaf(YType.uint32, "table-id")

                                            self.table_name = YLeaf(YType.str, "table-name")

                                            self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("backup_path_id",
                                                            "ipv4_next_hop",
                                                            "load_metric",
                                                            "local_label",
                                                            "next_hop_id",
                                                            "out_interface",
                                                            "out_interface_parent",
                                                            "out_label",
                                                            "out_label_name",
                                                            "path_flags_decode",
                                                            "path_id",
                                                            "table_id",
                                                            "table_name",
                                                            "tunnel_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.backup_path_id.is_set or
                                                self.ipv4_next_hop.is_set or
                                                self.load_metric.is_set or
                                                self.local_label.is_set or
                                                self.next_hop_id.is_set or
                                                self.out_interface.is_set or
                                                self.out_interface_parent.is_set or
                                                self.out_label.is_set or
                                                self.out_label_name.is_set or
                                                self.path_flags_decode.is_set or
                                                self.path_id.is_set or
                                                self.table_id.is_set or
                                                self.table_name.is_set or
                                                self.tunnel_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.backup_path_id.yfilter != YFilter.not_set or
                                                self.ipv4_next_hop.yfilter != YFilter.not_set or
                                                self.load_metric.yfilter != YFilter.not_set or
                                                self.local_label.yfilter != YFilter.not_set or
                                                self.next_hop_id.yfilter != YFilter.not_set or
                                                self.out_interface.yfilter != YFilter.not_set or
                                                self.out_interface_parent.yfilter != YFilter.not_set or
                                                self.out_label.yfilter != YFilter.not_set or
                                                self.out_label_name.yfilter != YFilter.not_set or
                                                self.path_flags_decode.yfilter != YFilter.not_set or
                                                self.path_id.yfilter != YFilter.not_set or
                                                self.table_id.yfilter != YFilter.not_set or
                                                self.table_name.yfilter != YFilter.not_set or
                                                self.tunnel_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nexthop" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                            if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                            if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_metric.get_name_leafdata())
                                            if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_label.get_name_leafdata())
                                            if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                            if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_interface.get_name_leafdata())
                                            if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label.get_name_leafdata())
                                            if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                            if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                            if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_id.get_name_leafdata())
                                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_id.get_name_leafdata())
                                            if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_name.get_name_leafdata())
                                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "backup-path-id"):
                                                self.backup_path_id = value
                                                self.backup_path_id.value_namespace = name_space
                                                self.backup_path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4-next-hop"):
                                                self.ipv4_next_hop = value
                                                self.ipv4_next_hop.value_namespace = name_space
                                                self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-metric"):
                                                self.load_metric = value
                                                self.load_metric.value_namespace = name_space
                                                self.load_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-label"):
                                                self.local_label = value
                                                self.local_label.value_namespace = name_space
                                                self.local_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hop-id"):
                                                self.next_hop_id = value
                                                self.next_hop_id.value_namespace = name_space
                                                self.next_hop_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-interface"):
                                                self.out_interface = value
                                                self.out_interface.value_namespace = name_space
                                                self.out_interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-interface-parent"):
                                                self.out_interface_parent = value
                                                self.out_interface_parent.value_namespace = name_space
                                                self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label"):
                                                self.out_label = value
                                                self.out_label.value_namespace = name_space
                                                self.out_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label-name"):
                                                self.out_label_name = value
                                                self.out_label_name.value_namespace = name_space
                                                self.out_label_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-flags-decode"):
                                                self.path_flags_decode = value
                                                self.path_flags_decode.value_namespace = name_space
                                                self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-id"):
                                                self.path_id = value
                                                self.path_id.value_namespace = name_space
                                                self.path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-id"):
                                                self.table_id = value
                                                self.table_id.value_namespace = name_space
                                                self.table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-name"):
                                                self.table_name = value
                                                self.table_name.value_namespace = name_space
                                                self.table_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tunnel-id"):
                                                self.tunnel_id = value
                                                self.tunnel_id.value_namespace = name_space
                                                self.tunnel_id.value_namespace_prefix = name_space_prefix


                                    class InnerStack(Entity):
                                        """
                                        Inner stack
                                        
                                        .. attribute:: label
                                        
                                        	Info related to outgoing labels
                                        	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label>`
                                        
                                        .. attribute:: nexthop
                                        
                                        	Remote nexthop addresses
                                        	**type**\:  list of str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: num_lbls
                                        
                                        	Depth of inner label stack
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: num_nexthops
                                        
                                        	Number of remote nexthop addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__init__()

                                            self.yang_name = "inner-stack"
                                            self.yang_parent_name = "stackv4-data"

                                            self.nexthop = YLeafList(YType.str, "nexthop")

                                            self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                            self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                            self.label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("nexthop",
                                                            "num_lbls",
                                                            "num_nexthops") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)


                                        class Label(Entity):
                                            """
                                            Info related to outgoing labels
                                            
                                            .. attribute:: outgoing_label
                                            
                                            	Remote Label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: outgoing_label_str
                                            
                                            	Remote Label string
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-lsd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__init__()

                                                self.yang_name = "label"
                                                self.yang_parent_name = "inner-stack"

                                                self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                                self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("outgoing_label",
                                                                "outgoing_label_str") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.outgoing_label.is_set or
                                                    self.outgoing_label_str.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.outgoing_label.yfilter != YFilter.not_set or
                                                    self.outgoing_label_str.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                                if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "outgoing-label"):
                                                    self.outgoing_label = value
                                                    self.outgoing_label.value_namespace = name_space
                                                    self.outgoing_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "outgoing-label-str"):
                                                    self.outgoing_label_str = value
                                                    self.outgoing_label_str.value_namespace = name_space
                                                    self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.label:
                                                if (c.has_data()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            return (
                                                self.num_lbls.is_set or
                                                self.num_nexthops.is_set)

                                        def has_operation(self):
                                            for c in self.label:
                                                if (c.has_operation()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.nexthop.yfilter != YFilter.not_set or
                                                self.num_lbls.yfilter != YFilter.not_set or
                                                self.num_nexthops.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "inner-stack" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                            if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                            leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "label"):
                                                for c in self.label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "nexthop"):
                                                self.nexthop.append(value)
                                            if(value_path == "num-lbls"):
                                                self.num_lbls = value
                                                self.num_lbls.value_namespace = name_space
                                                self.num_lbls.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-nexthops"):
                                                self.num_nexthops = value
                                                self.num_nexthops.value_namespace = name_space
                                                self.num_nexthops.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.owner_application_type.is_set or
                                            (self.inner_stack is not None and self.inner_stack.has_data()) or
                                            (self.nexthop is not None and self.nexthop.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.owner_application_type.yfilter != YFilter.not_set or
                                            (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                            (self.nexthop is not None and self.nexthop.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stackv4-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.owner_application_type.is_set or self.owner_application_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.owner_application_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "inner-stack"):
                                            if (self.inner_stack is None):
                                                self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                                self.inner_stack.parent = self
                                                self._children_name_map["inner_stack"] = "inner-stack"
                                            return self.inner_stack

                                        if (child_yang_name == "nexthop"):
                                            if (self.nexthop is None):
                                                self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                                self.nexthop.parent = self
                                                self._children_name_map["nexthop"] = "nexthop"
                                            return self.nexthop

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "inner-stack" or name == "nexthop" or name == "owner-application-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "owner-application-type"):
                                            self.owner_application_type = value
                                            self.owner_application_type.value_namespace = name_space
                                            self.owner_application_type.value_namespace_prefix = name_space_prefix


                                class Stackv6Data(Entity):
                                    """
                                    stackv6 data
                                    
                                    .. attribute:: inner_stack
                                    
                                    	Inner stack
                                    	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Nexthop
                                    	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.Nexthop>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data, self).__init__()

                                        self.yang_name = "stackv6-data"
                                        self.yang_parent_name = "moi"

                                        self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                        self.inner_stack.parent = self
                                        self._children_name_map["inner_stack"] = "inner-stack"
                                        self._children_yang_names.add("inner-stack")

                                        self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                        self.nexthop.parent = self
                                        self._children_name_map["nexthop"] = "nexthop"
                                        self._children_yang_names.add("nexthop")


                                    class Nexthop(Entity):
                                        """
                                        Nexthop
                                        
                                        .. attribute:: backup_path_id
                                        
                                        	Routing path backup id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv6_next_hop
                                        
                                        	IPv6 nexthop
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: next_hop_id
                                        
                                        	Next hop ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_interface
                                        
                                        	Outgoing interface
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: out_label
                                        
                                        	Outgoing label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: out_label_name
                                        
                                        	Outgoing label name
                                        	**type**\:  str
                                        
                                        .. attribute:: path_flags_decode
                                        
                                        	Path flag decoded string
                                        	**type**\:  str
                                        
                                        .. attribute:: path_id
                                        
                                        	Routing path id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: table_id
                                        
                                        	Table ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: table_name
                                        
                                        	VRF table name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__init__()

                                            self.yang_name = "nexthop"
                                            self.yang_parent_name = "stackv6-data"

                                            self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                            self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                            self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                            self.out_interface = YLeaf(YType.str, "out-interface")

                                            self.out_label = YLeaf(YType.uint32, "out-label")

                                            self.out_label_name = YLeaf(YType.str, "out-label-name")

                                            self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                            self.path_id = YLeaf(YType.uint8, "path-id")

                                            self.table_id = YLeaf(YType.uint32, "table-id")

                                            self.table_name = YLeaf(YType.str, "table-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("backup_path_id",
                                                            "ipv6_next_hop",
                                                            "next_hop_id",
                                                            "out_interface",
                                                            "out_label",
                                                            "out_label_name",
                                                            "path_flags_decode",
                                                            "path_id",
                                                            "table_id",
                                                            "table_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.backup_path_id.is_set or
                                                self.ipv6_next_hop.is_set or
                                                self.next_hop_id.is_set or
                                                self.out_interface.is_set or
                                                self.out_label.is_set or
                                                self.out_label_name.is_set or
                                                self.path_flags_decode.is_set or
                                                self.path_id.is_set or
                                                self.table_id.is_set or
                                                self.table_name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.backup_path_id.yfilter != YFilter.not_set or
                                                self.ipv6_next_hop.yfilter != YFilter.not_set or
                                                self.next_hop_id.yfilter != YFilter.not_set or
                                                self.out_interface.yfilter != YFilter.not_set or
                                                self.out_label.yfilter != YFilter.not_set or
                                                self.out_label_name.yfilter != YFilter.not_set or
                                                self.path_flags_decode.yfilter != YFilter.not_set or
                                                self.path_id.yfilter != YFilter.not_set or
                                                self.table_id.yfilter != YFilter.not_set or
                                                self.table_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nexthop" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                            if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                            if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                            if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_interface.get_name_leafdata())
                                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label.get_name_leafdata())
                                            if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                            if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                            if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_id.get_name_leafdata())
                                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_id.get_name_leafdata())
                                            if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "backup-path-id"):
                                                self.backup_path_id = value
                                                self.backup_path_id.value_namespace = name_space
                                                self.backup_path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6-next-hop"):
                                                self.ipv6_next_hop = value
                                                self.ipv6_next_hop.value_namespace = name_space
                                                self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hop-id"):
                                                self.next_hop_id = value
                                                self.next_hop_id.value_namespace = name_space
                                                self.next_hop_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-interface"):
                                                self.out_interface = value
                                                self.out_interface.value_namespace = name_space
                                                self.out_interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label"):
                                                self.out_label = value
                                                self.out_label.value_namespace = name_space
                                                self.out_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "out-label-name"):
                                                self.out_label_name = value
                                                self.out_label_name.value_namespace = name_space
                                                self.out_label_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-flags-decode"):
                                                self.path_flags_decode = value
                                                self.path_flags_decode.value_namespace = name_space
                                                self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-id"):
                                                self.path_id = value
                                                self.path_id.value_namespace = name_space
                                                self.path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-id"):
                                                self.table_id = value
                                                self.table_id.value_namespace = name_space
                                                self.table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-name"):
                                                self.table_name = value
                                                self.table_name.value_namespace = name_space
                                                self.table_name.value_namespace_prefix = name_space_prefix


                                    class InnerStack(Entity):
                                        """
                                        Inner stack
                                        
                                        .. attribute:: label
                                        
                                        	Info related to outgoing labels
                                        	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label>`
                                        
                                        .. attribute:: nexthop
                                        
                                        	Remote nexthop addresses
                                        	**type**\:  list of str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: num_lbls
                                        
                                        	Depth of inner label stack
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: num_nexthops
                                        
                                        	Number of remote nexthop addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__init__()

                                            self.yang_name = "inner-stack"
                                            self.yang_parent_name = "stackv6-data"

                                            self.nexthop = YLeafList(YType.str, "nexthop")

                                            self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                            self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                            self.label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("nexthop",
                                                            "num_lbls",
                                                            "num_nexthops") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)


                                        class Label(Entity):
                                            """
                                            Info related to outgoing labels
                                            
                                            .. attribute:: outgoing_label
                                            
                                            	Remote Label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: outgoing_label_str
                                            
                                            	Remote Label string
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-lsd-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__init__()

                                                self.yang_name = "label"
                                                self.yang_parent_name = "inner-stack"

                                                self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                                self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("outgoing_label",
                                                                "outgoing_label_str") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.outgoing_label.is_set or
                                                    self.outgoing_label_str.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.outgoing_label.yfilter != YFilter.not_set or
                                                    self.outgoing_label_str.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                                if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "outgoing-label"):
                                                    self.outgoing_label = value
                                                    self.outgoing_label.value_namespace = name_space
                                                    self.outgoing_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "outgoing-label-str"):
                                                    self.outgoing_label_str = value
                                                    self.outgoing_label_str.value_namespace = name_space
                                                    self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.label:
                                                if (c.has_data()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.yfilter != YFilter.not_set):
                                                    return True
                                            return (
                                                self.num_lbls.is_set or
                                                self.num_nexthops.is_set)

                                        def has_operation(self):
                                            for c in self.label:
                                                if (c.has_operation()):
                                                    return True
                                            for leaf in self.nexthop.getYLeafs():
                                                if (leaf.is_set):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.nexthop.yfilter != YFilter.not_set or
                                                self.num_lbls.yfilter != YFilter.not_set or
                                                self.num_nexthops.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "inner-stack" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                            if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                            leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "label"):
                                                for c in self.label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "nexthop"):
                                                self.nexthop.append(value)
                                            if(value_path == "num-lbls"):
                                                self.num_lbls = value
                                                self.num_lbls.value_namespace = name_space
                                                self.num_lbls.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-nexthops"):
                                                self.num_nexthops = value
                                                self.num_nexthops.value_namespace = name_space
                                                self.num_nexthops.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.inner_stack is not None and self.inner_stack.has_data()) or
                                            (self.nexthop is not None and self.nexthop.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                            (self.nexthop is not None and self.nexthop.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stackv6-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "inner-stack"):
                                            if (self.inner_stack is None):
                                                self.inner_stack = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                                self.inner_stack.parent = self
                                                self._children_name_map["inner_stack"] = "inner-stack"
                                            return self.inner_stack

                                        if (child_yang_name == "nexthop"):
                                            if (self.nexthop is None):
                                                self.nexthop = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                                self.nexthop.parent = self
                                                self._children_name_map["nexthop"] = "nexthop"
                                            return self.nexthop

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "inner-stack" or name == "nexthop"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class TeHeadData(Entity):
                                    """
                                    te head data
                                    
                                    .. attribute:: flags_decode
                                    
                                    	Flags decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_fwd_class
                                    
                                    	Tunnel forwarding class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_load_metric
                                    
                                    	Tunnel Load metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_local_label
                                    
                                    	Tunnel local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tunnel_local_label_str
                                    
                                    	Tunnel local label stringified
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.TeHeadData, self).__init__()

                                        self.yang_name = "te-head-data"
                                        self.yang_parent_name = "moi"

                                        self.flags_decode = YLeaf(YType.str, "flags-decode")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_fwd_class = YLeaf(YType.uint8, "tunnel-fwd-class")

                                        self.tunnel_load_metric = YLeaf(YType.uint32, "tunnel-load-metric")

                                        self.tunnel_local_label = YLeaf(YType.uint32, "tunnel-local-label")

                                        self.tunnel_local_label_str = YLeaf(YType.str, "tunnel-local-label-str")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("flags_decode",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_fwd_class",
                                                        "tunnel_load_metric",
                                                        "tunnel_local_label",
                                                        "tunnel_local_label_str") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.flags_decode.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_fwd_class.is_set or
                                            self.tunnel_load_metric.is_set or
                                            self.tunnel_local_label.is_set or
                                            self.tunnel_local_label_str.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.flags_decode.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_fwd_class.yfilter != YFilter.not_set or
                                            self.tunnel_load_metric.yfilter != YFilter.not_set or
                                            self.tunnel_local_label.yfilter != YFilter.not_set or
                                            self.tunnel_local_label_str.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "te-head-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.flags_decode.is_set or self.flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.flags_decode.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_fwd_class.is_set or self.tunnel_fwd_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_fwd_class.get_name_leafdata())
                                        if (self.tunnel_load_metric.is_set or self.tunnel_load_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_load_metric.get_name_leafdata())
                                        if (self.tunnel_local_label.is_set or self.tunnel_local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_local_label.get_name_leafdata())
                                        if (self.tunnel_local_label_str.is_set or self.tunnel_local_label_str.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_local_label_str.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-fwd-class" or name == "tunnel-load-metric" or name == "tunnel-local-label" or name == "tunnel-local-label-str"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "flags-decode"):
                                            self.flags_decode = value
                                            self.flags_decode.value_namespace = name_space
                                            self.flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-fwd-class"):
                                            self.tunnel_fwd_class = value
                                            self.tunnel_fwd_class.value_namespace = name_space
                                            self.tunnel_fwd_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-load-metric"):
                                            self.tunnel_load_metric = value
                                            self.tunnel_load_metric.value_namespace = name_space
                                            self.tunnel_load_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-local-label"):
                                            self.tunnel_local_label = value
                                            self.tunnel_local_label.value_namespace = name_space
                                            self.tunnel_local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-local-label-str"):
                                            self.tunnel_local_label_str = value
                                            self.tunnel_local_label_str.value_namespace = name_space
                                            self.tunnel_local_label_str.value_namespace_prefix = name_space_prefix


                                class DmtcData(Entity):
                                    """
                                    dmtc data
                                    
                                    .. attribute:: dmtc_ext_ifh
                                    
                                    	DMTC External Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.DmtcData, self).__init__()

                                        self.yang_name = "dmtc-data"
                                        self.yang_parent_name = "moi"

                                        self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.dmtc_ext_ifh.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "dmtc-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dmtc-ext-ifh"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "dmtc-ext-ifh"):
                                            self.dmtc_ext_ifh = value
                                            self.dmtc_ext_ifh.value_namespace = name_space
                                            self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.moi_type.is_set or
                                        (self.dmtc_data is not None and self.dmtc_data.has_data()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                        (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_data()) or
                                        (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_data()) or
                                        (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_data()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                        (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                        (self.stackv4_data is not None and self.stackv4_data.has_data()) or
                                        (self.stackv6_data is not None and self.stackv6_data.has_data()) or
                                        (self.te_head_data is not None and self.te_head_data.has_data()) or
                                        (self.tev4_data is not None and self.tev4_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.moi_type.yfilter != YFilter.not_set or
                                        (self.dmtc_data is not None and self.dmtc_data.has_operation()) or
                                        (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                        (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                        (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                        (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_operation()) or
                                        (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_operation()) or
                                        (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_operation()) or
                                        (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                        (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                        (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                        (self.stackv4_data is not None and self.stackv4_data.has_operation()) or
                                        (self.stackv6_data is not None and self.stackv6_data.has_operation()) or
                                        (self.te_head_data is not None and self.te_head_data.has_operation()) or
                                        (self.tev4_data is not None and self.tev4_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "moi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.moi_type.is_set or self.moi_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.moi_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "dmtc-data"):
                                        if (self.dmtc_data is None):
                                            self.dmtc_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.DmtcData()
                                            self.dmtc_data.parent = self
                                            self._children_name_map["dmtc_data"] = "dmtc-data"
                                        return self.dmtc_data

                                    if (child_yang_name == "ip-sub-data"):
                                        if (self.ip_sub_data is None):
                                            self.ip_sub_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.IpSubData()
                                            self.ip_sub_data.parent = self
                                            self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                        return self.ip_sub_data

                                    if (child_yang_name == "ipv4-data"):
                                        if (self.ipv4_data is None):
                                            self.ipv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv4Data()
                                            self.ipv4_data.parent = self
                                            self._children_name_map["ipv4_data"] = "ipv4-data"
                                        return self.ipv4_data

                                    if (child_yang_name == "ipv6-data"):
                                        if (self.ipv6_data is None):
                                            self.ipv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv6Data()
                                            self.ipv6_data.parent = self
                                            self._children_name_map["ipv6_data"] = "ipv6-data"
                                        return self.ipv6_data

                                    if (child_yang_name == "pop-and-lookup-ipv4"):
                                        if (self.pop_and_lookup_ipv4 is None):
                                            self.pop_and_lookup_ipv4 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                            self.pop_and_lookup_ipv4.parent = self
                                            self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                        return self.pop_and_lookup_ipv4

                                    if (child_yang_name == "pop-and-lookup-ipv6"):
                                        if (self.pop_and_lookup_ipv6 is None):
                                            self.pop_and_lookup_ipv6 = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                            self.pop_and_lookup_ipv6.parent = self
                                            self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                        return self.pop_and_lookup_ipv6

                                    if (child_yang_name == "pop-and-lookup-tp"):
                                        if (self.pop_and_lookup_tp is None):
                                            self.pop_and_lookup_tp = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupTp()
                                            self.pop_and_lookup_tp.parent = self
                                            self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                        return self.pop_and_lookup_tp

                                    if (child_yang_name == "pseudowire-data"):
                                        if (self.pseudowire_data is None):
                                            self.pseudowire_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireData()
                                            self.pseudowire_data.parent = self
                                            self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                        return self.pseudowire_data

                                    if (child_yang_name == "pseudowire-head-end-data"):
                                        if (self.pseudowire_head_end_data is None):
                                            self.pseudowire_head_end_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                            self.pseudowire_head_end_data.parent = self
                                            self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                        return self.pseudowire_head_end_data

                                    if (child_yang_name == "pw-list-data"):
                                        if (self.pw_list_data is None):
                                            self.pw_list_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PwListData()
                                            self.pw_list_data.parent = self
                                            self._children_name_map["pw_list_data"] = "pw-list-data"
                                        return self.pw_list_data

                                    if (child_yang_name == "stackv4-data"):
                                        if (self.stackv4_data is None):
                                            self.stackv4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data()
                                            self.stackv4_data.parent = self
                                            self._children_name_map["stackv4_data"] = "stackv4-data"
                                        return self.stackv4_data

                                    if (child_yang_name == "stackv6-data"):
                                        if (self.stackv6_data is None):
                                            self.stackv6_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data()
                                            self.stackv6_data.parent = self
                                            self._children_name_map["stackv6_data"] = "stackv6-data"
                                        return self.stackv6_data

                                    if (child_yang_name == "te-head-data"):
                                        if (self.te_head_data is None):
                                            self.te_head_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.TeHeadData()
                                            self.te_head_data.parent = self
                                            self._children_name_map["te_head_data"] = "te-head-data"
                                        return self.te_head_data

                                    if (child_yang_name == "tev4-data"):
                                        if (self.tev4_data is None):
                                            self.tev4_data = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Tev4Data()
                                            self.tev4_data.parent = self
                                            self._children_name_map["tev4_data"] = "tev4-data"
                                        return self.tev4_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-data" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv6-data" or name == "pop-and-lookup-ipv4" or name == "pop-and-lookup-ipv6" or name == "pop-and-lookup-tp" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "pw-list-data" or name == "stackv4-data" or name == "stackv6-data" or name == "te-head-data" or name == "tev4-data" or name == "moi-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "moi-type"):
                                        self.moi_type = value
                                        self.moi_type.value_namespace = name_space
                                        self.moi_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.moi is not None and self.moi.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.moi is not None and self.moi.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "moi-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "moi"):
                                    if (self.moi is None):
                                        self.moi = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi()
                                        self.moi.parent = self
                                        self._children_name_map["moi"] = "moi"
                                    return self.moi

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "moi"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            for c in self.moi_array:
                                if (c.has_data()):
                                    return True
                            return (self.application_resource is not None and self.application_resource.has_data())

                        def has_operation(self):
                            for c in self.moi_array:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.application_resource is not None and self.application_resource.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "mois" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "application-resource"):
                                if (self.application_resource is None):
                                    self.application_resource = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.ApplicationResource()
                                    self.application_resource.parent = self
                                    self._children_name_map["application_resource"] = "application-resource"
                                return self.application_resource

                            if (child_yang_name == "moi-array"):
                                for c in self.moi_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.moi_array.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-resource" or name == "moi-array"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        for c in self.associated_fpi:
                            if (c.has_data()):
                                return True
                        for c in self.mois:
                            if (c.has_data()):
                                return True
                        for c in self.v4_rpf:
                            if (c.has_data()):
                                return True
                        for c in self.v6_rpf:
                            if (c.has_data()):
                                return True
                        return (
                            self.label_id.is_set or
                            self.bcdl_priority.is_set or
                            self.lsd_queue.is_set or
                            self.priority_updated.is_set or
                            self.rewrite_version.is_set or
                            self.rw_install_age.is_set or
                            self.rw_install_time.is_set or
                            self.rw_updated.is_set or
                            (self.fpi_key is not None and self.fpi_key.has_data()) or
                            (self.rewrite_id is not None and self.rewrite_id.has_data()))

                    def has_operation(self):
                        for c in self.associated_fpi:
                            if (c.has_operation()):
                                return True
                        for c in self.mois:
                            if (c.has_operation()):
                                return True
                        for c in self.v4_rpf:
                            if (c.has_operation()):
                                return True
                        for c in self.v6_rpf:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.label_id.yfilter != YFilter.not_set or
                            self.bcdl_priority.yfilter != YFilter.not_set or
                            self.lsd_queue.yfilter != YFilter.not_set or
                            self.priority_updated.yfilter != YFilter.not_set or
                            self.rewrite_version.yfilter != YFilter.not_set or
                            self.rw_install_age.yfilter != YFilter.not_set or
                            self.rw_install_time.yfilter != YFilter.not_set or
                            self.rw_updated.yfilter != YFilter.not_set or
                            (self.fpi_key is not None and self.fpi_key.has_operation()) or
                            (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rewrite-label" + "[label-id='" + self.label_id.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.label_id.is_set or self.label_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.label_id.get_name_leafdata())
                        if (self.bcdl_priority.is_set or self.bcdl_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bcdl_priority.get_name_leafdata())
                        if (self.lsd_queue.is_set or self.lsd_queue.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsd_queue.get_name_leafdata())
                        if (self.priority_updated.is_set or self.priority_updated.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.priority_updated.get_name_leafdata())
                        if (self.rewrite_version.is_set or self.rewrite_version.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rewrite_version.get_name_leafdata())
                        if (self.rw_install_age.is_set or self.rw_install_age.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rw_install_age.get_name_leafdata())
                        if (self.rw_install_time.is_set or self.rw_install_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rw_install_time.get_name_leafdata())
                        if (self.rw_updated.is_set or self.rw_updated.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rw_updated.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "associated-fpi"):
                            for c in self.associated_fpi:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.associated_fpi.append(c)
                            return c

                        if (child_yang_name == "fpi-key"):
                            if (self.fpi_key is None):
                                self.fpi_key = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.FpiKey()
                                self.fpi_key.parent = self
                                self._children_name_map["fpi_key"] = "fpi-key"
                            return self.fpi_key

                        if (child_yang_name == "mois"):
                            for c in self.mois:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.Mois()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.mois.append(c)
                            return c

                        if (child_yang_name == "rewrite-id"):
                            if (self.rewrite_id is None):
                                self.rewrite_id = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.RewriteId()
                                self.rewrite_id.parent = self
                                self._children_name_map["rewrite_id"] = "rewrite-id"
                            return self.rewrite_id

                        if (child_yang_name == "v4-rpf"):
                            for c in self.v4_rpf:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.V4Rpf()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.v4_rpf.append(c)
                            return c

                        if (child_yang_name == "v6-rpf"):
                            for c in self.v6_rpf:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel.V6Rpf()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.v6_rpf.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "associated-fpi" or name == "fpi-key" or name == "mois" or name == "rewrite-id" or name == "v4-rpf" or name == "v6-rpf" or name == "label-id" or name == "bcdl-priority" or name == "lsd-queue" or name == "priority-updated" or name == "rewrite-version" or name == "rw-install-age" or name == "rw-install-time" or name == "rw-updated"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "label-id"):
                            self.label_id = value
                            self.label_id.value_namespace = name_space
                            self.label_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "bcdl-priority"):
                            self.bcdl_priority = value
                            self.bcdl_priority.value_namespace = name_space
                            self.bcdl_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsd-queue"):
                            self.lsd_queue = value
                            self.lsd_queue.value_namespace = name_space
                            self.lsd_queue.value_namespace_prefix = name_space_prefix
                        if(value_path == "priority-updated"):
                            self.priority_updated = value
                            self.priority_updated.value_namespace = name_space
                            self.priority_updated.value_namespace_prefix = name_space_prefix
                        if(value_path == "rewrite-version"):
                            self.rewrite_version = value
                            self.rewrite_version.value_namespace = name_space
                            self.rewrite_version.value_namespace_prefix = name_space_prefix
                        if(value_path == "rw-install-age"):
                            self.rw_install_age = value
                            self.rw_install_age.value_namespace = name_space
                            self.rw_install_age.value_namespace_prefix = name_space_prefix
                        if(value_path == "rw-install-time"):
                            self.rw_install_time = value
                            self.rw_install_time.value_namespace = name_space
                            self.rw_install_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "rw-updated"):
                            self.rw_updated = value
                            self.rw_updated.value_namespace = name_space
                            self.rw_updated.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.rewrite_label:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.rewrite_label:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "rewrite-labels" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "rewrite-label"):
                        for c in self.rewrite_label:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels.RewriteLabel()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.rewrite_label.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "rewrite-label"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (
                    (self.rewrite_ipv4s is not None and self.rewrite_ipv4s.has_data()) or
                    (self.rewrite_labels is not None and self.rewrite_labels.has_data()) or
                    (self.rewrite_pws is not None and self.rewrite_pws.has_data()) or
                    (self.rewrite_tes is not None and self.rewrite_tes.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.rewrite_ipv4s is not None and self.rewrite_ipv4s.has_operation()) or
                    (self.rewrite_labels is not None and self.rewrite_labels.has_operation()) or
                    (self.rewrite_pws is not None and self.rewrite_pws.has_operation()) or
                    (self.rewrite_tes is not None and self.rewrite_tes.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "rewrite" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "rewrite-ipv4s"):
                    if (self.rewrite_ipv4s is None):
                        self.rewrite_ipv4s = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteIpv4S()
                        self.rewrite_ipv4s.parent = self
                        self._children_name_map["rewrite_ipv4s"] = "rewrite-ipv4s"
                    return self.rewrite_ipv4s

                if (child_yang_name == "rewrite-labels"):
                    if (self.rewrite_labels is None):
                        self.rewrite_labels = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteLabels()
                        self.rewrite_labels.parent = self
                        self._children_name_map["rewrite_labels"] = "rewrite-labels"
                    return self.rewrite_labels

                if (child_yang_name == "rewrite-pws"):
                    if (self.rewrite_pws is None):
                        self.rewrite_pws = MplsLsdNodes.MplsLsdNode.Rewrite.RewritePws()
                        self.rewrite_pws.parent = self
                        self._children_name_map["rewrite_pws"] = "rewrite-pws"
                    return self.rewrite_pws

                if (child_yang_name == "rewrite-tes"):
                    if (self.rewrite_tes is None):
                        self.rewrite_tes = MplsLsdNodes.MplsLsdNode.Rewrite.RewriteTes()
                        self.rewrite_tes.parent = self
                        self._children_name_map["rewrite_tes"] = "rewrite-tes"
                    return self.rewrite_tes

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "rewrite-ipv4s" or name == "rewrite-labels" or name == "rewrite-pws" or name == "rewrite-tes"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class RewriteSummary(Entity):
            """
            Rewrite Summary 
            
            .. attribute:: ipv4_paths
            
            	Count for IPv4 paths
            	**type**\:   :py:class:`Ipv4Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.RewriteSummary.Ipv4Paths>`
            
            .. attribute:: ipv6_paths
            
            	Count for IPv6 paths
            	**type**\:   :py:class:`Ipv6Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.RewriteSummary.Ipv6Paths>`
            
            .. attribute:: num_dmtctefpi
            
            	Number of DMTC FPI
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_ipv4fpi
            
            	Number of IPv4 FPI
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_ipv6fpi
            
            	Number of IPv6 FPI
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_label_fpi
            
            	Number of label FPI
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_pw_list_tefpi
            
            	Number of PW List FPI
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_rewrite
            
            	Number of rewrites
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_rewrite_rpf_neighbors
            
            	Number of rewrites with RPF Neighbors
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_tefpi
            
            	Number of TE FPI
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_dmtc_intf
            
            	Total number of DMTC External Interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_forwad_update_message
            
            	Total number of forward update messages
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_forward_update
            
            	Total number of forward updates
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_ip_sub_paths
            
            	Total number of IP Subscriber paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_ipv4rpf_neighbors
            
            	Total number of IPv4 RPF Neighbors
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_ipv6rpf_neighbors
            
            	Total number of IPv6 RPF Neighbors
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_paths
            
            	Total paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_pw_paths
            
            	Total number of Pseudo\-wire paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_t_ev4_paths
            
            	Total number of Traffic Eng IPv4 paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_te_head_paths
            
            	Total number of Traffic Eng Head paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: vrf_name_xr
            
            	VRF Name
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsdNodes.MplsLsdNode.RewriteSummary, self).__init__()

                self.yang_name = "rewrite-summary"
                self.yang_parent_name = "mpls-lsd-node"

                self.num_dmtctefpi = YLeaf(YType.uint32, "num-dmtctefpi")

                self.num_ipv4fpi = YLeaf(YType.uint32, "num-ipv4fpi")

                self.num_ipv6fpi = YLeaf(YType.uint32, "num-ipv6fpi")

                self.num_label_fpi = YLeaf(YType.uint32, "num-label-fpi")

                self.num_pw_list_tefpi = YLeaf(YType.uint32, "num-pw-list-tefpi")

                self.num_rewrite = YLeaf(YType.uint32, "num-rewrite")

                self.num_rewrite_rpf_neighbors = YLeaf(YType.uint32, "num-rewrite-rpf-neighbors")

                self.num_tefpi = YLeaf(YType.uint32, "num-tefpi")

                self.total_dmtc_intf = YLeaf(YType.uint32, "total-dmtc-intf")

                self.total_forwad_update_message = YLeaf(YType.uint32, "total-forwad-update-message")

                self.total_forward_update = YLeaf(YType.uint32, "total-forward-update")

                self.total_ip_sub_paths = YLeaf(YType.uint32, "total-ip-sub-paths")

                self.total_ipv4rpf_neighbors = YLeaf(YType.uint32, "total-ipv4rpf-neighbors")

                self.total_ipv6rpf_neighbors = YLeaf(YType.uint32, "total-ipv6rpf-neighbors")

                self.total_paths = YLeaf(YType.uint32, "total-paths")

                self.total_pw_paths = YLeaf(YType.uint32, "total-pw-paths")

                self.total_t_ev4_paths = YLeaf(YType.uint32, "total-t-ev4-paths")

                self.total_te_head_paths = YLeaf(YType.uint32, "total-te-head-paths")

                self.vrf_name_xr = YLeaf(YType.str, "vrf-name-xr")

                self.ipv4_paths = MplsLsdNodes.MplsLsdNode.RewriteSummary.Ipv4Paths()
                self.ipv4_paths.parent = self
                self._children_name_map["ipv4_paths"] = "ipv4-paths"
                self._children_yang_names.add("ipv4-paths")

                self.ipv6_paths = MplsLsdNodes.MplsLsdNode.RewriteSummary.Ipv6Paths()
                self.ipv6_paths.parent = self
                self._children_name_map["ipv6_paths"] = "ipv6-paths"
                self._children_yang_names.add("ipv6-paths")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("num_dmtctefpi",
                                "num_ipv4fpi",
                                "num_ipv6fpi",
                                "num_label_fpi",
                                "num_pw_list_tefpi",
                                "num_rewrite",
                                "num_rewrite_rpf_neighbors",
                                "num_tefpi",
                                "total_dmtc_intf",
                                "total_forwad_update_message",
                                "total_forward_update",
                                "total_ip_sub_paths",
                                "total_ipv4rpf_neighbors",
                                "total_ipv6rpf_neighbors",
                                "total_paths",
                                "total_pw_paths",
                                "total_t_ev4_paths",
                                "total_te_head_paths",
                                "vrf_name_xr") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsdNodes.MplsLsdNode.RewriteSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsdNodes.MplsLsdNode.RewriteSummary, self).__setattr__(name, value)


            class Ipv4Paths(Entity):
                """
                Count for IPv4 paths
                
                .. attribute:: total_backup_paths
                
                	Total number of non\-primary backup paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_paths
                
                	Total number of IP paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_pop_lkup_paths
                
                	Total number of Pop\-and\-Lookup paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_protected_paths
                
                	Total number of protected paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_remote_backup_paths
                
                	Total number of remote backup paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.RewriteSummary.Ipv4Paths, self).__init__()

                    self.yang_name = "ipv4-paths"
                    self.yang_parent_name = "rewrite-summary"

                    self.total_backup_paths = YLeaf(YType.uint32, "total-backup-paths")

                    self.total_paths = YLeaf(YType.uint32, "total-paths")

                    self.total_pop_lkup_paths = YLeaf(YType.uint32, "total-pop-lkup-paths")

                    self.total_protected_paths = YLeaf(YType.uint32, "total-protected-paths")

                    self.total_remote_backup_paths = YLeaf(YType.uint32, "total-remote-backup-paths")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("total_backup_paths",
                                    "total_paths",
                                    "total_pop_lkup_paths",
                                    "total_protected_paths",
                                    "total_remote_backup_paths") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.RewriteSummary.Ipv4Paths, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.RewriteSummary.Ipv4Paths, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.total_backup_paths.is_set or
                        self.total_paths.is_set or
                        self.total_pop_lkup_paths.is_set or
                        self.total_protected_paths.is_set or
                        self.total_remote_backup_paths.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.total_backup_paths.yfilter != YFilter.not_set or
                        self.total_paths.yfilter != YFilter.not_set or
                        self.total_pop_lkup_paths.yfilter != YFilter.not_set or
                        self.total_protected_paths.yfilter != YFilter.not_set or
                        self.total_remote_backup_paths.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "ipv4-paths" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.total_backup_paths.is_set or self.total_backup_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_backup_paths.get_name_leafdata())
                    if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_paths.get_name_leafdata())
                    if (self.total_pop_lkup_paths.is_set or self.total_pop_lkup_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_pop_lkup_paths.get_name_leafdata())
                    if (self.total_protected_paths.is_set or self.total_protected_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_protected_paths.get_name_leafdata())
                    if (self.total_remote_backup_paths.is_set or self.total_remote_backup_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_remote_backup_paths.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "total-backup-paths" or name == "total-paths" or name == "total-pop-lkup-paths" or name == "total-protected-paths" or name == "total-remote-backup-paths"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "total-backup-paths"):
                        self.total_backup_paths = value
                        self.total_backup_paths.value_namespace = name_space
                        self.total_backup_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-paths"):
                        self.total_paths = value
                        self.total_paths.value_namespace = name_space
                        self.total_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-pop-lkup-paths"):
                        self.total_pop_lkup_paths = value
                        self.total_pop_lkup_paths.value_namespace = name_space
                        self.total_pop_lkup_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-protected-paths"):
                        self.total_protected_paths = value
                        self.total_protected_paths.value_namespace = name_space
                        self.total_protected_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-remote-backup-paths"):
                        self.total_remote_backup_paths = value
                        self.total_remote_backup_paths.value_namespace = name_space
                        self.total_remote_backup_paths.value_namespace_prefix = name_space_prefix


            class Ipv6Paths(Entity):
                """
                Count for IPv6 paths
                
                .. attribute:: total_backup_paths
                
                	Total number of non\-primary backup paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_paths
                
                	Total number of IP paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_pop_lkup_paths
                
                	Total number of Pop\-and\-Lookup paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_protected_paths
                
                	Total number of protected paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_remote_backup_paths
                
                	Total number of remote backup paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.RewriteSummary.Ipv6Paths, self).__init__()

                    self.yang_name = "ipv6-paths"
                    self.yang_parent_name = "rewrite-summary"

                    self.total_backup_paths = YLeaf(YType.uint32, "total-backup-paths")

                    self.total_paths = YLeaf(YType.uint32, "total-paths")

                    self.total_pop_lkup_paths = YLeaf(YType.uint32, "total-pop-lkup-paths")

                    self.total_protected_paths = YLeaf(YType.uint32, "total-protected-paths")

                    self.total_remote_backup_paths = YLeaf(YType.uint32, "total-remote-backup-paths")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("total_backup_paths",
                                    "total_paths",
                                    "total_pop_lkup_paths",
                                    "total_protected_paths",
                                    "total_remote_backup_paths") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.RewriteSummary.Ipv6Paths, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.RewriteSummary.Ipv6Paths, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.total_backup_paths.is_set or
                        self.total_paths.is_set or
                        self.total_pop_lkup_paths.is_set or
                        self.total_protected_paths.is_set or
                        self.total_remote_backup_paths.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.total_backup_paths.yfilter != YFilter.not_set or
                        self.total_paths.yfilter != YFilter.not_set or
                        self.total_pop_lkup_paths.yfilter != YFilter.not_set or
                        self.total_protected_paths.yfilter != YFilter.not_set or
                        self.total_remote_backup_paths.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "ipv6-paths" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.total_backup_paths.is_set or self.total_backup_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_backup_paths.get_name_leafdata())
                    if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_paths.get_name_leafdata())
                    if (self.total_pop_lkup_paths.is_set or self.total_pop_lkup_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_pop_lkup_paths.get_name_leafdata())
                    if (self.total_protected_paths.is_set or self.total_protected_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_protected_paths.get_name_leafdata())
                    if (self.total_remote_backup_paths.is_set or self.total_remote_backup_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_remote_backup_paths.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "total-backup-paths" or name == "total-paths" or name == "total-pop-lkup-paths" or name == "total-protected-paths" or name == "total-remote-backup-paths"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "total-backup-paths"):
                        self.total_backup_paths = value
                        self.total_backup_paths.value_namespace = name_space
                        self.total_backup_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-paths"):
                        self.total_paths = value
                        self.total_paths.value_namespace = name_space
                        self.total_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-pop-lkup-paths"):
                        self.total_pop_lkup_paths = value
                        self.total_pop_lkup_paths.value_namespace = name_space
                        self.total_pop_lkup_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-protected-paths"):
                        self.total_protected_paths = value
                        self.total_protected_paths.value_namespace = name_space
                        self.total_protected_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-remote-backup-paths"):
                        self.total_remote_backup_paths = value
                        self.total_remote_backup_paths.value_namespace = name_space
                        self.total_remote_backup_paths.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.num_dmtctefpi.is_set or
                    self.num_ipv4fpi.is_set or
                    self.num_ipv6fpi.is_set or
                    self.num_label_fpi.is_set or
                    self.num_pw_list_tefpi.is_set or
                    self.num_rewrite.is_set or
                    self.num_rewrite_rpf_neighbors.is_set or
                    self.num_tefpi.is_set or
                    self.total_dmtc_intf.is_set or
                    self.total_forwad_update_message.is_set or
                    self.total_forward_update.is_set or
                    self.total_ip_sub_paths.is_set or
                    self.total_ipv4rpf_neighbors.is_set or
                    self.total_ipv6rpf_neighbors.is_set or
                    self.total_paths.is_set or
                    self.total_pw_paths.is_set or
                    self.total_t_ev4_paths.is_set or
                    self.total_te_head_paths.is_set or
                    self.vrf_name_xr.is_set or
                    (self.ipv4_paths is not None and self.ipv4_paths.has_data()) or
                    (self.ipv6_paths is not None and self.ipv6_paths.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.num_dmtctefpi.yfilter != YFilter.not_set or
                    self.num_ipv4fpi.yfilter != YFilter.not_set or
                    self.num_ipv6fpi.yfilter != YFilter.not_set or
                    self.num_label_fpi.yfilter != YFilter.not_set or
                    self.num_pw_list_tefpi.yfilter != YFilter.not_set or
                    self.num_rewrite.yfilter != YFilter.not_set or
                    self.num_rewrite_rpf_neighbors.yfilter != YFilter.not_set or
                    self.num_tefpi.yfilter != YFilter.not_set or
                    self.total_dmtc_intf.yfilter != YFilter.not_set or
                    self.total_forwad_update_message.yfilter != YFilter.not_set or
                    self.total_forward_update.yfilter != YFilter.not_set or
                    self.total_ip_sub_paths.yfilter != YFilter.not_set or
                    self.total_ipv4rpf_neighbors.yfilter != YFilter.not_set or
                    self.total_ipv6rpf_neighbors.yfilter != YFilter.not_set or
                    self.total_paths.yfilter != YFilter.not_set or
                    self.total_pw_paths.yfilter != YFilter.not_set or
                    self.total_t_ev4_paths.yfilter != YFilter.not_set or
                    self.total_te_head_paths.yfilter != YFilter.not_set or
                    self.vrf_name_xr.yfilter != YFilter.not_set or
                    (self.ipv4_paths is not None and self.ipv4_paths.has_operation()) or
                    (self.ipv6_paths is not None and self.ipv6_paths.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "rewrite-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.num_dmtctefpi.is_set or self.num_dmtctefpi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_dmtctefpi.get_name_leafdata())
                if (self.num_ipv4fpi.is_set or self.num_ipv4fpi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_ipv4fpi.get_name_leafdata())
                if (self.num_ipv6fpi.is_set or self.num_ipv6fpi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_ipv6fpi.get_name_leafdata())
                if (self.num_label_fpi.is_set or self.num_label_fpi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_label_fpi.get_name_leafdata())
                if (self.num_pw_list_tefpi.is_set or self.num_pw_list_tefpi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_pw_list_tefpi.get_name_leafdata())
                if (self.num_rewrite.is_set or self.num_rewrite.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_rewrite.get_name_leafdata())
                if (self.num_rewrite_rpf_neighbors.is_set or self.num_rewrite_rpf_neighbors.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_rewrite_rpf_neighbors.get_name_leafdata())
                if (self.num_tefpi.is_set or self.num_tefpi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_tefpi.get_name_leafdata())
                if (self.total_dmtc_intf.is_set or self.total_dmtc_intf.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_dmtc_intf.get_name_leafdata())
                if (self.total_forwad_update_message.is_set or self.total_forwad_update_message.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_forwad_update_message.get_name_leafdata())
                if (self.total_forward_update.is_set or self.total_forward_update.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_forward_update.get_name_leafdata())
                if (self.total_ip_sub_paths.is_set or self.total_ip_sub_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_ip_sub_paths.get_name_leafdata())
                if (self.total_ipv4rpf_neighbors.is_set or self.total_ipv4rpf_neighbors.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_ipv4rpf_neighbors.get_name_leafdata())
                if (self.total_ipv6rpf_neighbors.is_set or self.total_ipv6rpf_neighbors.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_ipv6rpf_neighbors.get_name_leafdata())
                if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_paths.get_name_leafdata())
                if (self.total_pw_paths.is_set or self.total_pw_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_pw_paths.get_name_leafdata())
                if (self.total_t_ev4_paths.is_set or self.total_t_ev4_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_t_ev4_paths.get_name_leafdata())
                if (self.total_te_head_paths.is_set or self.total_te_head_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_te_head_paths.get_name_leafdata())
                if (self.vrf_name_xr.is_set or self.vrf_name_xr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.vrf_name_xr.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "ipv4-paths"):
                    if (self.ipv4_paths is None):
                        self.ipv4_paths = MplsLsdNodes.MplsLsdNode.RewriteSummary.Ipv4Paths()
                        self.ipv4_paths.parent = self
                        self._children_name_map["ipv4_paths"] = "ipv4-paths"
                    return self.ipv4_paths

                if (child_yang_name == "ipv6-paths"):
                    if (self.ipv6_paths is None):
                        self.ipv6_paths = MplsLsdNodes.MplsLsdNode.RewriteSummary.Ipv6Paths()
                        self.ipv6_paths.parent = self
                        self._children_name_map["ipv6_paths"] = "ipv6-paths"
                    return self.ipv6_paths

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "ipv4-paths" or name == "ipv6-paths" or name == "num-dmtctefpi" or name == "num-ipv4fpi" or name == "num-ipv6fpi" or name == "num-label-fpi" or name == "num-pw-list-tefpi" or name == "num-rewrite" or name == "num-rewrite-rpf-neighbors" or name == "num-tefpi" or name == "total-dmtc-intf" or name == "total-forwad-update-message" or name == "total-forward-update" or name == "total-ip-sub-paths" or name == "total-ipv4rpf-neighbors" or name == "total-ipv6rpf-neighbors" or name == "total-paths" or name == "total-pw-paths" or name == "total-t-ev4-paths" or name == "total-te-head-paths" or name == "vrf-name-xr"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "num-dmtctefpi"):
                    self.num_dmtctefpi = value
                    self.num_dmtctefpi.value_namespace = name_space
                    self.num_dmtctefpi.value_namespace_prefix = name_space_prefix
                if(value_path == "num-ipv4fpi"):
                    self.num_ipv4fpi = value
                    self.num_ipv4fpi.value_namespace = name_space
                    self.num_ipv4fpi.value_namespace_prefix = name_space_prefix
                if(value_path == "num-ipv6fpi"):
                    self.num_ipv6fpi = value
                    self.num_ipv6fpi.value_namespace = name_space
                    self.num_ipv6fpi.value_namespace_prefix = name_space_prefix
                if(value_path == "num-label-fpi"):
                    self.num_label_fpi = value
                    self.num_label_fpi.value_namespace = name_space
                    self.num_label_fpi.value_namespace_prefix = name_space_prefix
                if(value_path == "num-pw-list-tefpi"):
                    self.num_pw_list_tefpi = value
                    self.num_pw_list_tefpi.value_namespace = name_space
                    self.num_pw_list_tefpi.value_namespace_prefix = name_space_prefix
                if(value_path == "num-rewrite"):
                    self.num_rewrite = value
                    self.num_rewrite.value_namespace = name_space
                    self.num_rewrite.value_namespace_prefix = name_space_prefix
                if(value_path == "num-rewrite-rpf-neighbors"):
                    self.num_rewrite_rpf_neighbors = value
                    self.num_rewrite_rpf_neighbors.value_namespace = name_space
                    self.num_rewrite_rpf_neighbors.value_namespace_prefix = name_space_prefix
                if(value_path == "num-tefpi"):
                    self.num_tefpi = value
                    self.num_tefpi.value_namespace = name_space
                    self.num_tefpi.value_namespace_prefix = name_space_prefix
                if(value_path == "total-dmtc-intf"):
                    self.total_dmtc_intf = value
                    self.total_dmtc_intf.value_namespace = name_space
                    self.total_dmtc_intf.value_namespace_prefix = name_space_prefix
                if(value_path == "total-forwad-update-message"):
                    self.total_forwad_update_message = value
                    self.total_forwad_update_message.value_namespace = name_space
                    self.total_forwad_update_message.value_namespace_prefix = name_space_prefix
                if(value_path == "total-forward-update"):
                    self.total_forward_update = value
                    self.total_forward_update.value_namespace = name_space
                    self.total_forward_update.value_namespace_prefix = name_space_prefix
                if(value_path == "total-ip-sub-paths"):
                    self.total_ip_sub_paths = value
                    self.total_ip_sub_paths.value_namespace = name_space
                    self.total_ip_sub_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-ipv4rpf-neighbors"):
                    self.total_ipv4rpf_neighbors = value
                    self.total_ipv4rpf_neighbors.value_namespace = name_space
                    self.total_ipv4rpf_neighbors.value_namespace_prefix = name_space_prefix
                if(value_path == "total-ipv6rpf-neighbors"):
                    self.total_ipv6rpf_neighbors = value
                    self.total_ipv6rpf_neighbors.value_namespace = name_space
                    self.total_ipv6rpf_neighbors.value_namespace_prefix = name_space_prefix
                if(value_path == "total-paths"):
                    self.total_paths = value
                    self.total_paths.value_namespace = name_space
                    self.total_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-pw-paths"):
                    self.total_pw_paths = value
                    self.total_pw_paths.value_namespace = name_space
                    self.total_pw_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-t-ev4-paths"):
                    self.total_t_ev4_paths = value
                    self.total_t_ev4_paths.value_namespace = name_space
                    self.total_t_ev4_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-te-head-paths"):
                    self.total_te_head_paths = value
                    self.total_te_head_paths.value_namespace = name_space
                    self.total_te_head_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "vrf-name-xr"):
                    self.vrf_name_xr = value
                    self.vrf_name_xr.value_namespace = name_space
                    self.vrf_name_xr.value_namespace_prefix = name_space_prefix


        class Applications(Entity):
            """
            Table of MPLS applications using LSD
            
            .. attribute:: application
            
            	Data for MPLS application using LSD
            	**type**\: list of    :py:class:`Application <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Applications.Application>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsdNodes.MplsLsdNode.Applications, self).__init__()

                self.yang_name = "applications"
                self.yang_parent_name = "mpls-lsd-node"

                self.application = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsdNodes.MplsLsdNode.Applications, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsdNodes.MplsLsdNode.Applications, self).__setattr__(name, value)


            class Application(Entity):
                """
                Data for MPLS application using LSD
                
                .. attribute:: application_name  <key>
                
                	Application Instance name in the form of '<app\_type\_name>[\:<instance>]'
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: app_disconnect_time
                
                	App disconnect ts
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: app_flow_controlled
                
                	App flow control status
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: app_reg_time
                
                	App reg ts
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: application_instance
                
                	client\-app instance
                	**type**\:  str
                
                .. attribute:: application_name_xr
                
                	Application name
                	**type**\:  str
                
                .. attribute:: application_role_primary
                
                	Primary/Backup role
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: application_state
                
                	Application state
                	**type**\:   :py:class:`MgmtLsdAppState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppState>`
                
                .. attribute:: application_statistics
                
                	Application Statistics
                	**type**\:   :py:class:`ApplicationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Applications.Application.ApplicationStatistics>`
                
                .. attribute:: application_type
                
                	Application type
                	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                
                .. attribute:: flow_ctrl_clr_time
                
                	Flow Ctrl Clr ts
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: flow_ctrl_time
                
                	Flow Ctrl ts
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: go_act_ts
                
                	App go active timestamp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: node_id
                
                	Node ID where application is/was running
                	**type**\:  str
                
                	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
                
                .. attribute:: recovery_time_elapsed_seconds
                
                	Recovery time [secs] elapsed if client is timing out
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: recovery_time_register_seconds
                
                	Recovery time [secs] specified at registration or set explicitly
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: recovery_time_remaining_seconds
                
                	Recovery time [secs] remaining if client is timing out
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.Applications.Application, self).__init__()

                    self.yang_name = "application"
                    self.yang_parent_name = "applications"

                    self.application_name = YLeaf(YType.str, "application-name")

                    self.app_disconnect_time = YLeaf(YType.uint64, "app-disconnect-time")

                    self.app_flow_controlled = YLeaf(YType.int32, "app-flow-controlled")

                    self.app_reg_time = YLeaf(YType.uint64, "app-reg-time")

                    self.application_instance = YLeaf(YType.str, "application-instance")

                    self.application_name_xr = YLeaf(YType.str, "application-name-xr")

                    self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                    self.application_state = YLeaf(YType.enumeration, "application-state")

                    self.application_type = YLeaf(YType.enumeration, "application-type")

                    self.flow_ctrl_clr_time = YLeaf(YType.uint64, "flow-ctrl-clr-time")

                    self.flow_ctrl_time = YLeaf(YType.uint64, "flow-ctrl-time")

                    self.go_act_ts = YLeaf(YType.uint64, "go-act-ts")

                    self.node_id = YLeaf(YType.str, "node-id")

                    self.recovery_time_elapsed_seconds = YLeaf(YType.uint32, "recovery-time-elapsed-seconds")

                    self.recovery_time_register_seconds = YLeaf(YType.uint32, "recovery-time-register-seconds")

                    self.recovery_time_remaining_seconds = YLeaf(YType.uint32, "recovery-time-remaining-seconds")

                    self.application_statistics = MplsLsdNodes.MplsLsdNode.Applications.Application.ApplicationStatistics()
                    self.application_statistics.parent = self
                    self._children_name_map["application_statistics"] = "application-statistics"
                    self._children_yang_names.add("application-statistics")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("application_name",
                                    "app_disconnect_time",
                                    "app_flow_controlled",
                                    "app_reg_time",
                                    "application_instance",
                                    "application_name_xr",
                                    "application_role_primary",
                                    "application_state",
                                    "application_type",
                                    "flow_ctrl_clr_time",
                                    "flow_ctrl_time",
                                    "go_act_ts",
                                    "node_id",
                                    "recovery_time_elapsed_seconds",
                                    "recovery_time_register_seconds",
                                    "recovery_time_remaining_seconds") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.Applications.Application, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.Applications.Application, self).__setattr__(name, value)


                class ApplicationStatistics(Entity):
                    """
                    Application Statistics
                    
                    .. attribute:: connect_count
                    
                    	Connect count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: connected
                    
                    	Connected statistics
                    	**type**\:   :py:class:`Connected <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Applications.Application.ApplicationStatistics.Connected>`
                    
                    .. attribute:: interface_enable
                    
                    	Number of interface enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: interface_enable_pending
                    
                    	Number of interface enable pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: label_context_count
                    
                    	Label context count
                    	**type**\:  list of int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: label_context_pending_count
                    
                    	Label context pending count
                    	**type**\:  list of int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.Applications.Application.ApplicationStatistics, self).__init__()

                        self.yang_name = "application-statistics"
                        self.yang_parent_name = "application"

                        self.connect_count = YLeaf(YType.uint32, "connect-count")

                        self.interface_enable = YLeaf(YType.uint32, "interface-enable")

                        self.interface_enable_pending = YLeaf(YType.uint32, "interface-enable-pending")

                        self.label_context_count = YLeafList(YType.uint32, "label-context-count")

                        self.label_context_pending_count = YLeafList(YType.uint32, "label-context-pending-count")

                        self.connected = MplsLsdNodes.MplsLsdNode.Applications.Application.ApplicationStatistics.Connected()
                        self.connected.parent = self
                        self._children_name_map["connected"] = "connected"
                        self._children_yang_names.add("connected")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("connect_count",
                                        "interface_enable",
                                        "interface_enable_pending",
                                        "label_context_count",
                                        "label_context_pending_count") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.Applications.Application.ApplicationStatistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.Applications.Application.ApplicationStatistics, self).__setattr__(name, value)


                    class Connected(Entity):
                        """
                        Connected statistics
                        
                        .. attribute:: error_msg_count
                        
                        	Error count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: oor_label_count
                        
                        	Label OOR count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: operation_msg_count
                        
                        	Operation count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rt_set_msg_count
                        
                        	RT set count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsdNodes.MplsLsdNode.Applications.Application.ApplicationStatistics.Connected, self).__init__()

                            self.yang_name = "connected"
                            self.yang_parent_name = "application-statistics"

                            self.error_msg_count = YLeaf(YType.uint32, "error-msg-count")

                            self.oor_label_count = YLeaf(YType.uint32, "oor-label-count")

                            self.operation_msg_count = YLeaf(YType.uint32, "operation-msg-count")

                            self.rt_set_msg_count = YLeaf(YType.uint32, "rt-set-msg-count")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("error_msg_count",
                                            "oor_label_count",
                                            "operation_msg_count",
                                            "rt_set_msg_count") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsdNodes.MplsLsdNode.Applications.Application.ApplicationStatistics.Connected, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsdNodes.MplsLsdNode.Applications.Application.ApplicationStatistics.Connected, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.error_msg_count.is_set or
                                self.oor_label_count.is_set or
                                self.operation_msg_count.is_set or
                                self.rt_set_msg_count.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.error_msg_count.yfilter != YFilter.not_set or
                                self.oor_label_count.yfilter != YFilter.not_set or
                                self.operation_msg_count.yfilter != YFilter.not_set or
                                self.rt_set_msg_count.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "connected" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.error_msg_count.is_set or self.error_msg_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.error_msg_count.get_name_leafdata())
                            if (self.oor_label_count.is_set or self.oor_label_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.oor_label_count.get_name_leafdata())
                            if (self.operation_msg_count.is_set or self.operation_msg_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.operation_msg_count.get_name_leafdata())
                            if (self.rt_set_msg_count.is_set or self.rt_set_msg_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rt_set_msg_count.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "error-msg-count" or name == "oor-label-count" or name == "operation-msg-count" or name == "rt-set-msg-count"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "error-msg-count"):
                                self.error_msg_count = value
                                self.error_msg_count.value_namespace = name_space
                                self.error_msg_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "oor-label-count"):
                                self.oor_label_count = value
                                self.oor_label_count.value_namespace = name_space
                                self.oor_label_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "operation-msg-count"):
                                self.operation_msg_count = value
                                self.operation_msg_count.value_namespace = name_space
                                self.operation_msg_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "rt-set-msg-count"):
                                self.rt_set_msg_count = value
                                self.rt_set_msg_count.value_namespace = name_space
                                self.rt_set_msg_count.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for leaf in self.label_context_count.getYLeafs():
                            if (leaf.yfilter != YFilter.not_set):
                                return True
                        for leaf in self.label_context_pending_count.getYLeafs():
                            if (leaf.yfilter != YFilter.not_set):
                                return True
                        return (
                            self.connect_count.is_set or
                            self.interface_enable.is_set or
                            self.interface_enable_pending.is_set or
                            (self.connected is not None and self.connected.has_data()))

                    def has_operation(self):
                        for leaf in self.label_context_count.getYLeafs():
                            if (leaf.is_set):
                                return True
                        for leaf in self.label_context_pending_count.getYLeafs():
                            if (leaf.is_set):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.connect_count.yfilter != YFilter.not_set or
                            self.interface_enable.yfilter != YFilter.not_set or
                            self.interface_enable_pending.yfilter != YFilter.not_set or
                            self.label_context_count.yfilter != YFilter.not_set or
                            self.label_context_pending_count.yfilter != YFilter.not_set or
                            (self.connected is not None and self.connected.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "application-statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.connect_count.is_set or self.connect_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.connect_count.get_name_leafdata())
                        if (self.interface_enable.is_set or self.interface_enable.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_enable.get_name_leafdata())
                        if (self.interface_enable_pending.is_set or self.interface_enable_pending.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_enable_pending.get_name_leafdata())

                        leaf_name_data.extend(self.label_context_count.get_name_leafdata())

                        leaf_name_data.extend(self.label_context_pending_count.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "connected"):
                            if (self.connected is None):
                                self.connected = MplsLsdNodes.MplsLsdNode.Applications.Application.ApplicationStatistics.Connected()
                                self.connected.parent = self
                                self._children_name_map["connected"] = "connected"
                            return self.connected

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "connected" or name == "connect-count" or name == "interface-enable" or name == "interface-enable-pending" or name == "label-context-count" or name == "label-context-pending-count"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "connect-count"):
                            self.connect_count = value
                            self.connect_count.value_namespace = name_space
                            self.connect_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "interface-enable"):
                            self.interface_enable = value
                            self.interface_enable.value_namespace = name_space
                            self.interface_enable.value_namespace_prefix = name_space_prefix
                        if(value_path == "interface-enable-pending"):
                            self.interface_enable_pending = value
                            self.interface_enable_pending.value_namespace = name_space
                            self.interface_enable_pending.value_namespace_prefix = name_space_prefix
                        if(value_path == "label-context-count"):
                            self.label_context_count.append(value)
                        if(value_path == "label-context-pending-count"):
                            self.label_context_pending_count.append(value)

                def has_data(self):
                    return (
                        self.application_name.is_set or
                        self.app_disconnect_time.is_set or
                        self.app_flow_controlled.is_set or
                        self.app_reg_time.is_set or
                        self.application_instance.is_set or
                        self.application_name_xr.is_set or
                        self.application_role_primary.is_set or
                        self.application_state.is_set or
                        self.application_type.is_set or
                        self.flow_ctrl_clr_time.is_set or
                        self.flow_ctrl_time.is_set or
                        self.go_act_ts.is_set or
                        self.node_id.is_set or
                        self.recovery_time_elapsed_seconds.is_set or
                        self.recovery_time_register_seconds.is_set or
                        self.recovery_time_remaining_seconds.is_set or
                        (self.application_statistics is not None and self.application_statistics.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.application_name.yfilter != YFilter.not_set or
                        self.app_disconnect_time.yfilter != YFilter.not_set or
                        self.app_flow_controlled.yfilter != YFilter.not_set or
                        self.app_reg_time.yfilter != YFilter.not_set or
                        self.application_instance.yfilter != YFilter.not_set or
                        self.application_name_xr.yfilter != YFilter.not_set or
                        self.application_role_primary.yfilter != YFilter.not_set or
                        self.application_state.yfilter != YFilter.not_set or
                        self.application_type.yfilter != YFilter.not_set or
                        self.flow_ctrl_clr_time.yfilter != YFilter.not_set or
                        self.flow_ctrl_time.yfilter != YFilter.not_set or
                        self.go_act_ts.yfilter != YFilter.not_set or
                        self.node_id.yfilter != YFilter.not_set or
                        self.recovery_time_elapsed_seconds.yfilter != YFilter.not_set or
                        self.recovery_time_register_seconds.yfilter != YFilter.not_set or
                        self.recovery_time_remaining_seconds.yfilter != YFilter.not_set or
                        (self.application_statistics is not None and self.application_statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "application" + "[application-name='" + self.application_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_name.get_name_leafdata())
                    if (self.app_disconnect_time.is_set or self.app_disconnect_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.app_disconnect_time.get_name_leafdata())
                    if (self.app_flow_controlled.is_set or self.app_flow_controlled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.app_flow_controlled.get_name_leafdata())
                    if (self.app_reg_time.is_set or self.app_reg_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.app_reg_time.get_name_leafdata())
                    if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_instance.get_name_leafdata())
                    if (self.application_name_xr.is_set or self.application_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_name_xr.get_name_leafdata())
                    if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                    if (self.application_state.is_set or self.application_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_state.get_name_leafdata())
                    if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_type.get_name_leafdata())
                    if (self.flow_ctrl_clr_time.is_set or self.flow_ctrl_clr_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flow_ctrl_clr_time.get_name_leafdata())
                    if (self.flow_ctrl_time.is_set or self.flow_ctrl_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flow_ctrl_time.get_name_leafdata())
                    if (self.go_act_ts.is_set or self.go_act_ts.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.go_act_ts.get_name_leafdata())
                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_id.get_name_leafdata())
                    if (self.recovery_time_elapsed_seconds.is_set or self.recovery_time_elapsed_seconds.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.recovery_time_elapsed_seconds.get_name_leafdata())
                    if (self.recovery_time_register_seconds.is_set or self.recovery_time_register_seconds.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.recovery_time_register_seconds.get_name_leafdata())
                    if (self.recovery_time_remaining_seconds.is_set or self.recovery_time_remaining_seconds.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.recovery_time_remaining_seconds.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "application-statistics"):
                        if (self.application_statistics is None):
                            self.application_statistics = MplsLsdNodes.MplsLsdNode.Applications.Application.ApplicationStatistics()
                            self.application_statistics.parent = self
                            self._children_name_map["application_statistics"] = "application-statistics"
                        return self.application_statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "application-statistics" or name == "application-name" or name == "app-disconnect-time" or name == "app-flow-controlled" or name == "app-reg-time" or name == "application-instance" or name == "application-name-xr" or name == "application-role-primary" or name == "application-state" or name == "application-type" or name == "flow-ctrl-clr-time" or name == "flow-ctrl-time" or name == "go-act-ts" or name == "node-id" or name == "recovery-time-elapsed-seconds" or name == "recovery-time-register-seconds" or name == "recovery-time-remaining-seconds"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "application-name"):
                        self.application_name = value
                        self.application_name.value_namespace = name_space
                        self.application_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "app-disconnect-time"):
                        self.app_disconnect_time = value
                        self.app_disconnect_time.value_namespace = name_space
                        self.app_disconnect_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "app-flow-controlled"):
                        self.app_flow_controlled = value
                        self.app_flow_controlled.value_namespace = name_space
                        self.app_flow_controlled.value_namespace_prefix = name_space_prefix
                    if(value_path == "app-reg-time"):
                        self.app_reg_time = value
                        self.app_reg_time.value_namespace = name_space
                        self.app_reg_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-instance"):
                        self.application_instance = value
                        self.application_instance.value_namespace = name_space
                        self.application_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-name-xr"):
                        self.application_name_xr = value
                        self.application_name_xr.value_namespace = name_space
                        self.application_name_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-role-primary"):
                        self.application_role_primary = value
                        self.application_role_primary.value_namespace = name_space
                        self.application_role_primary.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-state"):
                        self.application_state = value
                        self.application_state.value_namespace = name_space
                        self.application_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-type"):
                        self.application_type = value
                        self.application_type.value_namespace = name_space
                        self.application_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "flow-ctrl-clr-time"):
                        self.flow_ctrl_clr_time = value
                        self.flow_ctrl_clr_time.value_namespace = name_space
                        self.flow_ctrl_clr_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "flow-ctrl-time"):
                        self.flow_ctrl_time = value
                        self.flow_ctrl_time.value_namespace = name_space
                        self.flow_ctrl_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "go-act-ts"):
                        self.go_act_ts = value
                        self.go_act_ts.value_namespace = name_space
                        self.go_act_ts.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-id"):
                        self.node_id = value
                        self.node_id.value_namespace = name_space
                        self.node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "recovery-time-elapsed-seconds"):
                        self.recovery_time_elapsed_seconds = value
                        self.recovery_time_elapsed_seconds.value_namespace = name_space
                        self.recovery_time_elapsed_seconds.value_namespace_prefix = name_space_prefix
                    if(value_path == "recovery-time-register-seconds"):
                        self.recovery_time_register_seconds = value
                        self.recovery_time_register_seconds.value_namespace = name_space
                        self.recovery_time_register_seconds.value_namespace_prefix = name_space_prefix
                    if(value_path == "recovery-time-remaining-seconds"):
                        self.recovery_time_remaining_seconds = value
                        self.recovery_time_remaining_seconds.value_namespace = name_space
                        self.recovery_time_remaining_seconds.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.application:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.application:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "applications" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "application"):
                    for c in self.application:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsdNodes.MplsLsdNode.Applications.Application()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.application.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "application"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class LabelSummaryVrfs(Entity):
            """
            Dynamic label range summary by VRF
            
            .. attribute:: label_summary_vrf
            
            	Dynamic label range summary by VRF
            	**type**\: list of    :py:class:`LabelSummaryVrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs.LabelSummaryVrf>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs, self).__init__()

                self.yang_name = "label-summary-vrfs"
                self.yang_parent_name = "mpls-lsd-node"

                self.label_summary_vrf = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs, self).__setattr__(name, value)


            class LabelSummaryVrf(Entity):
                """
                Dynamic label range summary by VRF
                
                .. attribute:: vrf_name  <key>
                
                	VRF name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: owner_count
                
                	Owner counts
                	**type**\: list of    :py:class:`OwnerCount <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs.LabelSummaryVrf.OwnerCount>`
                
                .. attribute:: rsi_connected
                
                	Rsi connected
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: total_labels
                
                	Total labels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: vrf_name_xr
                
                	VRF Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs.LabelSummaryVrf, self).__init__()

                    self.yang_name = "label-summary-vrf"
                    self.yang_parent_name = "label-summary-vrfs"

                    self.vrf_name = YLeaf(YType.str, "vrf-name")

                    self.rsi_connected = YLeaf(YType.int32, "rsi-connected")

                    self.total_labels = YLeaf(YType.uint32, "total-labels")

                    self.vrf_name_xr = YLeaf(YType.str, "vrf-name-xr")

                    self.owner_count = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("vrf_name",
                                    "rsi_connected",
                                    "total_labels",
                                    "vrf_name_xr") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs.LabelSummaryVrf, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs.LabelSummaryVrf, self).__setattr__(name, value)


                class OwnerCount(Entity):
                    """
                    Owner counts
                    
                    .. attribute:: application_instance
                    
                    	client\-app identifier
                    	**type**\:  str
                    
                    .. attribute:: application_name
                    
                    	Application name
                    	**type**\:  str
                    
                    .. attribute:: application_role_primary
                    
                    	Primary/Backup role
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: application_type
                    
                    	Application type
                    	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                    
                    .. attribute:: number_of_labels
                    
                    	Number of labels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs.LabelSummaryVrf.OwnerCount, self).__init__()

                        self.yang_name = "owner-count"
                        self.yang_parent_name = "label-summary-vrf"

                        self.application_instance = YLeaf(YType.str, "application-instance")

                        self.application_name = YLeaf(YType.str, "application-name")

                        self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                        self.application_type = YLeaf(YType.enumeration, "application-type")

                        self.number_of_labels = YLeaf(YType.uint32, "number-of-labels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("application_instance",
                                        "application_name",
                                        "application_role_primary",
                                        "application_type",
                                        "number_of_labels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs.LabelSummaryVrf.OwnerCount, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs.LabelSummaryVrf.OwnerCount, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.application_instance.is_set or
                            self.application_name.is_set or
                            self.application_role_primary.is_set or
                            self.application_type.is_set or
                            self.number_of_labels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.application_instance.yfilter != YFilter.not_set or
                            self.application_name.yfilter != YFilter.not_set or
                            self.application_role_primary.yfilter != YFilter.not_set or
                            self.application_type.yfilter != YFilter.not_set or
                            self.number_of_labels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "owner-count" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_instance.get_name_leafdata())
                        if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_name.get_name_leafdata())
                        if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                        if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_type.get_name_leafdata())
                        if (self.number_of_labels.is_set or self.number_of_labels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_labels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "number-of-labels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "application-instance"):
                            self.application_instance = value
                            self.application_instance.value_namespace = name_space
                            self.application_instance.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-name"):
                            self.application_name = value
                            self.application_name.value_namespace = name_space
                            self.application_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-role-primary"):
                            self.application_role_primary = value
                            self.application_role_primary.value_namespace = name_space
                            self.application_role_primary.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-type"):
                            self.application_type = value
                            self.application_type.value_namespace = name_space
                            self.application_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-labels"):
                            self.number_of_labels = value
                            self.number_of_labels.value_namespace = name_space
                            self.number_of_labels.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.owner_count:
                        if (c.has_data()):
                            return True
                    return (
                        self.vrf_name.is_set or
                        self.rsi_connected.is_set or
                        self.total_labels.is_set or
                        self.vrf_name_xr.is_set)

                def has_operation(self):
                    for c in self.owner_count:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.vrf_name.yfilter != YFilter.not_set or
                        self.rsi_connected.yfilter != YFilter.not_set or
                        self.total_labels.yfilter != YFilter.not_set or
                        self.vrf_name_xr.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "label-summary-vrf" + "[vrf-name='" + self.vrf_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.vrf_name.get_name_leafdata())
                    if (self.rsi_connected.is_set or self.rsi_connected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rsi_connected.get_name_leafdata())
                    if (self.total_labels.is_set or self.total_labels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_labels.get_name_leafdata())
                    if (self.vrf_name_xr.is_set or self.vrf_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.vrf_name_xr.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "owner-count"):
                        for c in self.owner_count:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs.LabelSummaryVrf.OwnerCount()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.owner_count.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "owner-count" or name == "vrf-name" or name == "rsi-connected" or name == "total-labels" or name == "vrf-name-xr"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "vrf-name"):
                        self.vrf_name = value
                        self.vrf_name.value_namespace = name_space
                        self.vrf_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "rsi-connected"):
                        self.rsi_connected = value
                        self.rsi_connected.value_namespace = name_space
                        self.rsi_connected.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-labels"):
                        self.total_labels = value
                        self.total_labels.value_namespace = name_space
                        self.total_labels.value_namespace_prefix = name_space_prefix
                    if(value_path == "vrf-name-xr"):
                        self.vrf_name_xr = value
                        self.vrf_name_xr.value_namespace = name_space
                        self.vrf_name_xr.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.label_summary_vrf:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.label_summary_vrf:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "label-summary-vrfs" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "label-summary-vrf"):
                    for c in self.label_summary_vrf:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs.LabelSummaryVrf()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.label_summary_vrf.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "label-summary-vrf"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class LabelRange(Entity):
            """
            Label range
            
            .. attribute:: max_dynamic_label_value
            
            	Maximum dynamic label value
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: max_static_label_value
            
            	Maximum static label value
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: min_dynamic_label_value
            
            	Minimum dynamic label value
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: min_static_label_value
            
            	Minimum static label value
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsdNodes.MplsLsdNode.LabelRange, self).__init__()

                self.yang_name = "label-range"
                self.yang_parent_name = "mpls-lsd-node"

                self.max_dynamic_label_value = YLeaf(YType.uint32, "max-dynamic-label-value")

                self.max_static_label_value = YLeaf(YType.uint32, "max-static-label-value")

                self.min_dynamic_label_value = YLeaf(YType.uint32, "min-dynamic-label-value")

                self.min_static_label_value = YLeaf(YType.uint32, "min-static-label-value")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("max_dynamic_label_value",
                                "max_static_label_value",
                                "min_dynamic_label_value",
                                "min_static_label_value") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsdNodes.MplsLsdNode.LabelRange, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsdNodes.MplsLsdNode.LabelRange, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.max_dynamic_label_value.is_set or
                    self.max_static_label_value.is_set or
                    self.min_dynamic_label_value.is_set or
                    self.min_static_label_value.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.max_dynamic_label_value.yfilter != YFilter.not_set or
                    self.max_static_label_value.yfilter != YFilter.not_set or
                    self.min_dynamic_label_value.yfilter != YFilter.not_set or
                    self.min_static_label_value.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "label-range" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.max_dynamic_label_value.is_set or self.max_dynamic_label_value.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.max_dynamic_label_value.get_name_leafdata())
                if (self.max_static_label_value.is_set or self.max_static_label_value.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.max_static_label_value.get_name_leafdata())
                if (self.min_dynamic_label_value.is_set or self.min_dynamic_label_value.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.min_dynamic_label_value.get_name_leafdata())
                if (self.min_static_label_value.is_set or self.min_static_label_value.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.min_static_label_value.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "max-dynamic-label-value" or name == "max-static-label-value" or name == "min-dynamic-label-value" or name == "min-static-label-value"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "max-dynamic-label-value"):
                    self.max_dynamic_label_value = value
                    self.max_dynamic_label_value.value_namespace = name_space
                    self.max_dynamic_label_value.value_namespace_prefix = name_space_prefix
                if(value_path == "max-static-label-value"):
                    self.max_static_label_value = value
                    self.max_static_label_value.value_namespace = name_space
                    self.max_static_label_value.value_namespace_prefix = name_space_prefix
                if(value_path == "min-dynamic-label-value"):
                    self.min_dynamic_label_value = value
                    self.min_dynamic_label_value.value_namespace = name_space
                    self.min_dynamic_label_value.value_namespace_prefix = name_space_prefix
                if(value_path == "min-static-label-value"):
                    self.min_static_label_value = value
                    self.min_static_label_value.value_namespace = name_space
                    self.min_static_label_value.value_namespace_prefix = name_space_prefix


        class RewriteSummaryVrfs(Entity):
            """
            Rewrite Summary by VRF
            
            .. attribute:: rewrite_summary_vrf
            
            	Rewrite summary by VRF VRF\-name
            	**type**\: list of    :py:class:`RewriteSummaryVrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs, self).__init__()

                self.yang_name = "rewrite-summary-vrfs"
                self.yang_parent_name = "mpls-lsd-node"

                self.rewrite_summary_vrf = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs, self).__setattr__(name, value)


            class RewriteSummaryVrf(Entity):
                """
                Rewrite summary by VRF VRF\-name
                
                .. attribute:: vrf_name  <key>
                
                	VRF name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: ipv4_paths
                
                	Count for IPv4 paths
                	**type**\:   :py:class:`Ipv4Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv4Paths>`
                
                .. attribute:: ipv6_paths
                
                	Count for IPv6 paths
                	**type**\:   :py:class:`Ipv6Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv6Paths>`
                
                .. attribute:: num_dmtctefpi
                
                	Number of DMTC FPI
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_ipv4fpi
                
                	Number of IPv4 FPI
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_ipv6fpi
                
                	Number of IPv6 FPI
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_label_fpi
                
                	Number of label FPI
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_pw_list_tefpi
                
                	Number of PW List FPI
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_rewrite
                
                	Number of rewrites
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_rewrite_rpf_neighbors
                
                	Number of rewrites with RPF Neighbors
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_tefpi
                
                	Number of TE FPI
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_dmtc_intf
                
                	Total number of DMTC External Interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_forwad_update_message
                
                	Total number of forward update messages
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_forward_update
                
                	Total number of forward updates
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_ip_sub_paths
                
                	Total number of IP Subscriber paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_ipv4rpf_neighbors
                
                	Total number of IPv4 RPF Neighbors
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_ipv6rpf_neighbors
                
                	Total number of IPv6 RPF Neighbors
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_paths
                
                	Total paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_pw_paths
                
                	Total number of Pseudo\-wire paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_t_ev4_paths
                
                	Total number of Traffic Eng IPv4 paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_te_head_paths
                
                	Total number of Traffic Eng Head paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: vrf_name_xr
                
                	VRF Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf, self).__init__()

                    self.yang_name = "rewrite-summary-vrf"
                    self.yang_parent_name = "rewrite-summary-vrfs"

                    self.vrf_name = YLeaf(YType.str, "vrf-name")

                    self.num_dmtctefpi = YLeaf(YType.uint32, "num-dmtctefpi")

                    self.num_ipv4fpi = YLeaf(YType.uint32, "num-ipv4fpi")

                    self.num_ipv6fpi = YLeaf(YType.uint32, "num-ipv6fpi")

                    self.num_label_fpi = YLeaf(YType.uint32, "num-label-fpi")

                    self.num_pw_list_tefpi = YLeaf(YType.uint32, "num-pw-list-tefpi")

                    self.num_rewrite = YLeaf(YType.uint32, "num-rewrite")

                    self.num_rewrite_rpf_neighbors = YLeaf(YType.uint32, "num-rewrite-rpf-neighbors")

                    self.num_tefpi = YLeaf(YType.uint32, "num-tefpi")

                    self.total_dmtc_intf = YLeaf(YType.uint32, "total-dmtc-intf")

                    self.total_forwad_update_message = YLeaf(YType.uint32, "total-forwad-update-message")

                    self.total_forward_update = YLeaf(YType.uint32, "total-forward-update")

                    self.total_ip_sub_paths = YLeaf(YType.uint32, "total-ip-sub-paths")

                    self.total_ipv4rpf_neighbors = YLeaf(YType.uint32, "total-ipv4rpf-neighbors")

                    self.total_ipv6rpf_neighbors = YLeaf(YType.uint32, "total-ipv6rpf-neighbors")

                    self.total_paths = YLeaf(YType.uint32, "total-paths")

                    self.total_pw_paths = YLeaf(YType.uint32, "total-pw-paths")

                    self.total_t_ev4_paths = YLeaf(YType.uint32, "total-t-ev4-paths")

                    self.total_te_head_paths = YLeaf(YType.uint32, "total-te-head-paths")

                    self.vrf_name_xr = YLeaf(YType.str, "vrf-name-xr")

                    self.ipv4_paths = MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv4Paths()
                    self.ipv4_paths.parent = self
                    self._children_name_map["ipv4_paths"] = "ipv4-paths"
                    self._children_yang_names.add("ipv4-paths")

                    self.ipv6_paths = MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv6Paths()
                    self.ipv6_paths.parent = self
                    self._children_name_map["ipv6_paths"] = "ipv6-paths"
                    self._children_yang_names.add("ipv6-paths")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("vrf_name",
                                    "num_dmtctefpi",
                                    "num_ipv4fpi",
                                    "num_ipv6fpi",
                                    "num_label_fpi",
                                    "num_pw_list_tefpi",
                                    "num_rewrite",
                                    "num_rewrite_rpf_neighbors",
                                    "num_tefpi",
                                    "total_dmtc_intf",
                                    "total_forwad_update_message",
                                    "total_forward_update",
                                    "total_ip_sub_paths",
                                    "total_ipv4rpf_neighbors",
                                    "total_ipv6rpf_neighbors",
                                    "total_paths",
                                    "total_pw_paths",
                                    "total_t_ev4_paths",
                                    "total_te_head_paths",
                                    "vrf_name_xr") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf, self).__setattr__(name, value)


                class Ipv4Paths(Entity):
                    """
                    Count for IPv4 paths
                    
                    .. attribute:: total_backup_paths
                    
                    	Total number of non\-primary backup paths
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_paths
                    
                    	Total number of IP paths
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_pop_lkup_paths
                    
                    	Total number of Pop\-and\-Lookup paths
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_protected_paths
                    
                    	Total number of protected paths
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_remote_backup_paths
                    
                    	Total number of remote backup paths
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv4Paths, self).__init__()

                        self.yang_name = "ipv4-paths"
                        self.yang_parent_name = "rewrite-summary-vrf"

                        self.total_backup_paths = YLeaf(YType.uint32, "total-backup-paths")

                        self.total_paths = YLeaf(YType.uint32, "total-paths")

                        self.total_pop_lkup_paths = YLeaf(YType.uint32, "total-pop-lkup-paths")

                        self.total_protected_paths = YLeaf(YType.uint32, "total-protected-paths")

                        self.total_remote_backup_paths = YLeaf(YType.uint32, "total-remote-backup-paths")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("total_backup_paths",
                                        "total_paths",
                                        "total_pop_lkup_paths",
                                        "total_protected_paths",
                                        "total_remote_backup_paths") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv4Paths, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv4Paths, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.total_backup_paths.is_set or
                            self.total_paths.is_set or
                            self.total_pop_lkup_paths.is_set or
                            self.total_protected_paths.is_set or
                            self.total_remote_backup_paths.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.total_backup_paths.yfilter != YFilter.not_set or
                            self.total_paths.yfilter != YFilter.not_set or
                            self.total_pop_lkup_paths.yfilter != YFilter.not_set or
                            self.total_protected_paths.yfilter != YFilter.not_set or
                            self.total_remote_backup_paths.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "ipv4-paths" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.total_backup_paths.is_set or self.total_backup_paths.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_backup_paths.get_name_leafdata())
                        if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_paths.get_name_leafdata())
                        if (self.total_pop_lkup_paths.is_set or self.total_pop_lkup_paths.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_pop_lkup_paths.get_name_leafdata())
                        if (self.total_protected_paths.is_set or self.total_protected_paths.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_protected_paths.get_name_leafdata())
                        if (self.total_remote_backup_paths.is_set or self.total_remote_backup_paths.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_remote_backup_paths.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "total-backup-paths" or name == "total-paths" or name == "total-pop-lkup-paths" or name == "total-protected-paths" or name == "total-remote-backup-paths"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "total-backup-paths"):
                            self.total_backup_paths = value
                            self.total_backup_paths.value_namespace = name_space
                            self.total_backup_paths.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-paths"):
                            self.total_paths = value
                            self.total_paths.value_namespace = name_space
                            self.total_paths.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-pop-lkup-paths"):
                            self.total_pop_lkup_paths = value
                            self.total_pop_lkup_paths.value_namespace = name_space
                            self.total_pop_lkup_paths.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-protected-paths"):
                            self.total_protected_paths = value
                            self.total_protected_paths.value_namespace = name_space
                            self.total_protected_paths.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-remote-backup-paths"):
                            self.total_remote_backup_paths = value
                            self.total_remote_backup_paths.value_namespace = name_space
                            self.total_remote_backup_paths.value_namespace_prefix = name_space_prefix


                class Ipv6Paths(Entity):
                    """
                    Count for IPv6 paths
                    
                    .. attribute:: total_backup_paths
                    
                    	Total number of non\-primary backup paths
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_paths
                    
                    	Total number of IP paths
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_pop_lkup_paths
                    
                    	Total number of Pop\-and\-Lookup paths
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_protected_paths
                    
                    	Total number of protected paths
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_remote_backup_paths
                    
                    	Total number of remote backup paths
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv6Paths, self).__init__()

                        self.yang_name = "ipv6-paths"
                        self.yang_parent_name = "rewrite-summary-vrf"

                        self.total_backup_paths = YLeaf(YType.uint32, "total-backup-paths")

                        self.total_paths = YLeaf(YType.uint32, "total-paths")

                        self.total_pop_lkup_paths = YLeaf(YType.uint32, "total-pop-lkup-paths")

                        self.total_protected_paths = YLeaf(YType.uint32, "total-protected-paths")

                        self.total_remote_backup_paths = YLeaf(YType.uint32, "total-remote-backup-paths")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("total_backup_paths",
                                        "total_paths",
                                        "total_pop_lkup_paths",
                                        "total_protected_paths",
                                        "total_remote_backup_paths") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv6Paths, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv6Paths, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.total_backup_paths.is_set or
                            self.total_paths.is_set or
                            self.total_pop_lkup_paths.is_set or
                            self.total_protected_paths.is_set or
                            self.total_remote_backup_paths.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.total_backup_paths.yfilter != YFilter.not_set or
                            self.total_paths.yfilter != YFilter.not_set or
                            self.total_pop_lkup_paths.yfilter != YFilter.not_set or
                            self.total_protected_paths.yfilter != YFilter.not_set or
                            self.total_remote_backup_paths.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "ipv6-paths" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.total_backup_paths.is_set or self.total_backup_paths.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_backup_paths.get_name_leafdata())
                        if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_paths.get_name_leafdata())
                        if (self.total_pop_lkup_paths.is_set or self.total_pop_lkup_paths.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_pop_lkup_paths.get_name_leafdata())
                        if (self.total_protected_paths.is_set or self.total_protected_paths.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_protected_paths.get_name_leafdata())
                        if (self.total_remote_backup_paths.is_set or self.total_remote_backup_paths.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_remote_backup_paths.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "total-backup-paths" or name == "total-paths" or name == "total-pop-lkup-paths" or name == "total-protected-paths" or name == "total-remote-backup-paths"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "total-backup-paths"):
                            self.total_backup_paths = value
                            self.total_backup_paths.value_namespace = name_space
                            self.total_backup_paths.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-paths"):
                            self.total_paths = value
                            self.total_paths.value_namespace = name_space
                            self.total_paths.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-pop-lkup-paths"):
                            self.total_pop_lkup_paths = value
                            self.total_pop_lkup_paths.value_namespace = name_space
                            self.total_pop_lkup_paths.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-protected-paths"):
                            self.total_protected_paths = value
                            self.total_protected_paths.value_namespace = name_space
                            self.total_protected_paths.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-remote-backup-paths"):
                            self.total_remote_backup_paths = value
                            self.total_remote_backup_paths.value_namespace = name_space
                            self.total_remote_backup_paths.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.vrf_name.is_set or
                        self.num_dmtctefpi.is_set or
                        self.num_ipv4fpi.is_set or
                        self.num_ipv6fpi.is_set or
                        self.num_label_fpi.is_set or
                        self.num_pw_list_tefpi.is_set or
                        self.num_rewrite.is_set or
                        self.num_rewrite_rpf_neighbors.is_set or
                        self.num_tefpi.is_set or
                        self.total_dmtc_intf.is_set or
                        self.total_forwad_update_message.is_set or
                        self.total_forward_update.is_set or
                        self.total_ip_sub_paths.is_set or
                        self.total_ipv4rpf_neighbors.is_set or
                        self.total_ipv6rpf_neighbors.is_set or
                        self.total_paths.is_set or
                        self.total_pw_paths.is_set or
                        self.total_t_ev4_paths.is_set or
                        self.total_te_head_paths.is_set or
                        self.vrf_name_xr.is_set or
                        (self.ipv4_paths is not None and self.ipv4_paths.has_data()) or
                        (self.ipv6_paths is not None and self.ipv6_paths.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.vrf_name.yfilter != YFilter.not_set or
                        self.num_dmtctefpi.yfilter != YFilter.not_set or
                        self.num_ipv4fpi.yfilter != YFilter.not_set or
                        self.num_ipv6fpi.yfilter != YFilter.not_set or
                        self.num_label_fpi.yfilter != YFilter.not_set or
                        self.num_pw_list_tefpi.yfilter != YFilter.not_set or
                        self.num_rewrite.yfilter != YFilter.not_set or
                        self.num_rewrite_rpf_neighbors.yfilter != YFilter.not_set or
                        self.num_tefpi.yfilter != YFilter.not_set or
                        self.total_dmtc_intf.yfilter != YFilter.not_set or
                        self.total_forwad_update_message.yfilter != YFilter.not_set or
                        self.total_forward_update.yfilter != YFilter.not_set or
                        self.total_ip_sub_paths.yfilter != YFilter.not_set or
                        self.total_ipv4rpf_neighbors.yfilter != YFilter.not_set or
                        self.total_ipv6rpf_neighbors.yfilter != YFilter.not_set or
                        self.total_paths.yfilter != YFilter.not_set or
                        self.total_pw_paths.yfilter != YFilter.not_set or
                        self.total_t_ev4_paths.yfilter != YFilter.not_set or
                        self.total_te_head_paths.yfilter != YFilter.not_set or
                        self.vrf_name_xr.yfilter != YFilter.not_set or
                        (self.ipv4_paths is not None and self.ipv4_paths.has_operation()) or
                        (self.ipv6_paths is not None and self.ipv6_paths.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "rewrite-summary-vrf" + "[vrf-name='" + self.vrf_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.vrf_name.get_name_leafdata())
                    if (self.num_dmtctefpi.is_set or self.num_dmtctefpi.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_dmtctefpi.get_name_leafdata())
                    if (self.num_ipv4fpi.is_set or self.num_ipv4fpi.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_ipv4fpi.get_name_leafdata())
                    if (self.num_ipv6fpi.is_set or self.num_ipv6fpi.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_ipv6fpi.get_name_leafdata())
                    if (self.num_label_fpi.is_set or self.num_label_fpi.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_label_fpi.get_name_leafdata())
                    if (self.num_pw_list_tefpi.is_set or self.num_pw_list_tefpi.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_pw_list_tefpi.get_name_leafdata())
                    if (self.num_rewrite.is_set or self.num_rewrite.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_rewrite.get_name_leafdata())
                    if (self.num_rewrite_rpf_neighbors.is_set or self.num_rewrite_rpf_neighbors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_rewrite_rpf_neighbors.get_name_leafdata())
                    if (self.num_tefpi.is_set or self.num_tefpi.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_tefpi.get_name_leafdata())
                    if (self.total_dmtc_intf.is_set or self.total_dmtc_intf.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_dmtc_intf.get_name_leafdata())
                    if (self.total_forwad_update_message.is_set or self.total_forwad_update_message.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_forwad_update_message.get_name_leafdata())
                    if (self.total_forward_update.is_set or self.total_forward_update.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_forward_update.get_name_leafdata())
                    if (self.total_ip_sub_paths.is_set or self.total_ip_sub_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_ip_sub_paths.get_name_leafdata())
                    if (self.total_ipv4rpf_neighbors.is_set or self.total_ipv4rpf_neighbors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_ipv4rpf_neighbors.get_name_leafdata())
                    if (self.total_ipv6rpf_neighbors.is_set or self.total_ipv6rpf_neighbors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_ipv6rpf_neighbors.get_name_leafdata())
                    if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_paths.get_name_leafdata())
                    if (self.total_pw_paths.is_set or self.total_pw_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_pw_paths.get_name_leafdata())
                    if (self.total_t_ev4_paths.is_set or self.total_t_ev4_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_t_ev4_paths.get_name_leafdata())
                    if (self.total_te_head_paths.is_set or self.total_te_head_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_te_head_paths.get_name_leafdata())
                    if (self.vrf_name_xr.is_set or self.vrf_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.vrf_name_xr.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "ipv4-paths"):
                        if (self.ipv4_paths is None):
                            self.ipv4_paths = MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv4Paths()
                            self.ipv4_paths.parent = self
                            self._children_name_map["ipv4_paths"] = "ipv4-paths"
                        return self.ipv4_paths

                    if (child_yang_name == "ipv6-paths"):
                        if (self.ipv6_paths is None):
                            self.ipv6_paths = MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv6Paths()
                            self.ipv6_paths.parent = self
                            self._children_name_map["ipv6_paths"] = "ipv6-paths"
                        return self.ipv6_paths

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ipv4-paths" or name == "ipv6-paths" or name == "vrf-name" or name == "num-dmtctefpi" or name == "num-ipv4fpi" or name == "num-ipv6fpi" or name == "num-label-fpi" or name == "num-pw-list-tefpi" or name == "num-rewrite" or name == "num-rewrite-rpf-neighbors" or name == "num-tefpi" or name == "total-dmtc-intf" or name == "total-forwad-update-message" or name == "total-forward-update" or name == "total-ip-sub-paths" or name == "total-ipv4rpf-neighbors" or name == "total-ipv6rpf-neighbors" or name == "total-paths" or name == "total-pw-paths" or name == "total-t-ev4-paths" or name == "total-te-head-paths" or name == "vrf-name-xr"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "vrf-name"):
                        self.vrf_name = value
                        self.vrf_name.value_namespace = name_space
                        self.vrf_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-dmtctefpi"):
                        self.num_dmtctefpi = value
                        self.num_dmtctefpi.value_namespace = name_space
                        self.num_dmtctefpi.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-ipv4fpi"):
                        self.num_ipv4fpi = value
                        self.num_ipv4fpi.value_namespace = name_space
                        self.num_ipv4fpi.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-ipv6fpi"):
                        self.num_ipv6fpi = value
                        self.num_ipv6fpi.value_namespace = name_space
                        self.num_ipv6fpi.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-label-fpi"):
                        self.num_label_fpi = value
                        self.num_label_fpi.value_namespace = name_space
                        self.num_label_fpi.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-pw-list-tefpi"):
                        self.num_pw_list_tefpi = value
                        self.num_pw_list_tefpi.value_namespace = name_space
                        self.num_pw_list_tefpi.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-rewrite"):
                        self.num_rewrite = value
                        self.num_rewrite.value_namespace = name_space
                        self.num_rewrite.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-rewrite-rpf-neighbors"):
                        self.num_rewrite_rpf_neighbors = value
                        self.num_rewrite_rpf_neighbors.value_namespace = name_space
                        self.num_rewrite_rpf_neighbors.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-tefpi"):
                        self.num_tefpi = value
                        self.num_tefpi.value_namespace = name_space
                        self.num_tefpi.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-dmtc-intf"):
                        self.total_dmtc_intf = value
                        self.total_dmtc_intf.value_namespace = name_space
                        self.total_dmtc_intf.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-forwad-update-message"):
                        self.total_forwad_update_message = value
                        self.total_forwad_update_message.value_namespace = name_space
                        self.total_forwad_update_message.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-forward-update"):
                        self.total_forward_update = value
                        self.total_forward_update.value_namespace = name_space
                        self.total_forward_update.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-ip-sub-paths"):
                        self.total_ip_sub_paths = value
                        self.total_ip_sub_paths.value_namespace = name_space
                        self.total_ip_sub_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-ipv4rpf-neighbors"):
                        self.total_ipv4rpf_neighbors = value
                        self.total_ipv4rpf_neighbors.value_namespace = name_space
                        self.total_ipv4rpf_neighbors.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-ipv6rpf-neighbors"):
                        self.total_ipv6rpf_neighbors = value
                        self.total_ipv6rpf_neighbors.value_namespace = name_space
                        self.total_ipv6rpf_neighbors.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-paths"):
                        self.total_paths = value
                        self.total_paths.value_namespace = name_space
                        self.total_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-pw-paths"):
                        self.total_pw_paths = value
                        self.total_pw_paths.value_namespace = name_space
                        self.total_pw_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-t-ev4-paths"):
                        self.total_t_ev4_paths = value
                        self.total_t_ev4_paths.value_namespace = name_space
                        self.total_t_ev4_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-te-head-paths"):
                        self.total_te_head_paths = value
                        self.total_te_head_paths.value_namespace = name_space
                        self.total_te_head_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "vrf-name-xr"):
                        self.vrf_name_xr = value
                        self.vrf_name_xr.value_namespace = name_space
                        self.vrf_name_xr.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.rewrite_summary_vrf:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.rewrite_summary_vrf:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "rewrite-summary-vrfs" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "rewrite-summary-vrf"):
                    for c in self.rewrite_summary_vrf:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs.RewriteSummaryVrf()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.rewrite_summary_vrf.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "rewrite-summary-vrf"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Interfaces(Entity):
            """
            Table of MPLS interfaces
            
            .. attribute:: interface
            
            	Data for MPLS interface
            	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Interfaces.Interface>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsdNodes.MplsLsdNode.Interfaces, self).__init__()

                self.yang_name = "interfaces"
                self.yang_parent_name = "mpls-lsd-node"

                self.interface = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsdNodes.MplsLsdNode.Interfaces, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsdNodes.MplsLsdNode.Interfaces, self).__setattr__(name, value)


            class Interface(Entity):
                """
                Data for MPLS interface
                
                .. attribute:: interface_name  <key>
                
                	Interface
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: application_owner
                
                	Application Owner
                	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsdNodes.MplsLsdNode.Interfaces.Interface.ApplicationOwner>`
                
                .. attribute:: interface
                
                	Interface
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: interface_state
                
                	Interface state
                	**type**\:   :py:class:`MgmtLsdIntfState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdIntfState>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsdNodes.MplsLsdNode.Interfaces.Interface, self).__init__()

                    self.yang_name = "interface"
                    self.yang_parent_name = "interfaces"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.interface = YLeaf(YType.str, "interface")

                    self.interface_state = YLeaf(YType.enumeration, "interface-state")

                    self.application_owner = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "interface",
                                    "interface_state") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsdNodes.MplsLsdNode.Interfaces.Interface, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsdNodes.MplsLsdNode.Interfaces.Interface, self).__setattr__(name, value)


                class ApplicationOwner(Entity):
                    """
                    Application Owner
                    
                    .. attribute:: application_instance
                    
                    	Application instance Name
                    	**type**\:  str
                    
                    .. attribute:: application_name
                    
                    	Application name
                    	**type**\:  str
                    
                    .. attribute:: application_role_primary
                    
                    	Primary/Backup role
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: application_type
                    
                    	Application type
                    	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                    
                    .. attribute:: resource_state
                    
                    	Application resource state
                    	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsdNodes.MplsLsdNode.Interfaces.Interface.ApplicationOwner, self).__init__()

                        self.yang_name = "application-owner"
                        self.yang_parent_name = "interface"

                        self.application_instance = YLeaf(YType.str, "application-instance")

                        self.application_name = YLeaf(YType.str, "application-name")

                        self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                        self.application_type = YLeaf(YType.enumeration, "application-type")

                        self.resource_state = YLeaf(YType.enumeration, "resource-state")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("application_instance",
                                        "application_name",
                                        "application_role_primary",
                                        "application_type",
                                        "resource_state") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsdNodes.MplsLsdNode.Interfaces.Interface.ApplicationOwner, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsdNodes.MplsLsdNode.Interfaces.Interface.ApplicationOwner, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.application_instance.is_set or
                            self.application_name.is_set or
                            self.application_role_primary.is_set or
                            self.application_type.is_set or
                            self.resource_state.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.application_instance.yfilter != YFilter.not_set or
                            self.application_name.yfilter != YFilter.not_set or
                            self.application_role_primary.yfilter != YFilter.not_set or
                            self.application_type.yfilter != YFilter.not_set or
                            self.resource_state.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "application-owner" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_instance.get_name_leafdata())
                        if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_name.get_name_leafdata())
                        if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                        if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_type.get_name_leafdata())
                        if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.resource_state.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "application-instance"):
                            self.application_instance = value
                            self.application_instance.value_namespace = name_space
                            self.application_instance.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-name"):
                            self.application_name = value
                            self.application_name.value_namespace = name_space
                            self.application_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-role-primary"):
                            self.application_role_primary = value
                            self.application_role_primary.value_namespace = name_space
                            self.application_role_primary.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-type"):
                            self.application_type = value
                            self.application_type.value_namespace = name_space
                            self.application_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "resource-state"):
                            self.resource_state = value
                            self.resource_state.value_namespace = name_space
                            self.resource_state.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.application_owner:
                        if (c.has_data()):
                            return True
                    return (
                        self.interface_name.is_set or
                        self.interface.is_set or
                        self.interface_state.is_set)

                def has_operation(self):
                    for c in self.application_owner:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.interface.yfilter != YFilter.not_set or
                        self.interface_state.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface.get_name_leafdata())
                    if (self.interface_state.is_set or self.interface_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_state.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "application-owner"):
                        for c in self.application_owner:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsdNodes.MplsLsdNode.Interfaces.Interface.ApplicationOwner()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.application_owner.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "application-owner" or name == "interface-name" or name == "interface" or name == "interface-state"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface"):
                        self.interface = value
                        self.interface.value_namespace = name_space
                        self.interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-state"):
                        self.interface_state = value
                        self.interface_state.value_namespace = name_space
                        self.interface_state.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.interface:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.interface:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "interfaces" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "interface"):
                    for c in self.interface:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsdNodes.MplsLsdNode.Interfaces.Interface()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.interface.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "interface"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                self.node_name.is_set or
                (self.applications is not None and self.applications.has_data()) or
                (self.clients is not None and self.clients.has_data()) or
                (self.frr_database is not None and self.frr_database.has_data()) or
                (self.interfaces is not None and self.interfaces.has_data()) or
                (self.label_range is not None and self.label_range.has_data()) or
                (self.label_summary is not None and self.label_summary.has_data()) or
                (self.label_summary_vrfs is not None and self.label_summary_vrfs.has_data()) or
                (self.labels is not None and self.labels.has_data()) or
                (self.rewrite is not None and self.rewrite.has_data()) or
                (self.rewrite_summary is not None and self.rewrite_summary.has_data()) or
                (self.rewrite_summary_vrfs is not None and self.rewrite_summary_vrfs.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                self.node_name.yfilter != YFilter.not_set or
                (self.applications is not None and self.applications.has_operation()) or
                (self.clients is not None and self.clients.has_operation()) or
                (self.frr_database is not None and self.frr_database.has_operation()) or
                (self.interfaces is not None and self.interfaces.has_operation()) or
                (self.label_range is not None and self.label_range.has_operation()) or
                (self.label_summary is not None and self.label_summary.has_operation()) or
                (self.label_summary_vrfs is not None and self.label_summary_vrfs.has_operation()) or
                (self.labels is not None and self.labels.has_operation()) or
                (self.rewrite is not None and self.rewrite.has_operation()) or
                (self.rewrite_summary is not None and self.rewrite_summary.has_operation()) or
                (self.rewrite_summary_vrfs is not None and self.rewrite_summary_vrfs.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "mpls-lsd-node" + "[node-name='" + self.node_name.get() + "']" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd-nodes/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.node_name.is_set or self.node_name.yfilter != YFilter.not_set):
                leaf_name_data.append(self.node_name.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "applications"):
                if (self.applications is None):
                    self.applications = MplsLsdNodes.MplsLsdNode.Applications()
                    self.applications.parent = self
                    self._children_name_map["applications"] = "applications"
                return self.applications

            if (child_yang_name == "clients"):
                if (self.clients is None):
                    self.clients = MplsLsdNodes.MplsLsdNode.Clients()
                    self.clients.parent = self
                    self._children_name_map["clients"] = "clients"
                return self.clients

            if (child_yang_name == "frr-database"):
                if (self.frr_database is None):
                    self.frr_database = MplsLsdNodes.MplsLsdNode.FrrDatabase()
                    self.frr_database.parent = self
                    self._children_name_map["frr_database"] = "frr-database"
                return self.frr_database

            if (child_yang_name == "interfaces"):
                if (self.interfaces is None):
                    self.interfaces = MplsLsdNodes.MplsLsdNode.Interfaces()
                    self.interfaces.parent = self
                    self._children_name_map["interfaces"] = "interfaces"
                return self.interfaces

            if (child_yang_name == "label-range"):
                if (self.label_range is None):
                    self.label_range = MplsLsdNodes.MplsLsdNode.LabelRange()
                    self.label_range.parent = self
                    self._children_name_map["label_range"] = "label-range"
                return self.label_range

            if (child_yang_name == "label-summary"):
                if (self.label_summary is None):
                    self.label_summary = MplsLsdNodes.MplsLsdNode.LabelSummary()
                    self.label_summary.parent = self
                    self._children_name_map["label_summary"] = "label-summary"
                return self.label_summary

            if (child_yang_name == "label-summary-vrfs"):
                if (self.label_summary_vrfs is None):
                    self.label_summary_vrfs = MplsLsdNodes.MplsLsdNode.LabelSummaryVrfs()
                    self.label_summary_vrfs.parent = self
                    self._children_name_map["label_summary_vrfs"] = "label-summary-vrfs"
                return self.label_summary_vrfs

            if (child_yang_name == "labels"):
                if (self.labels is None):
                    self.labels = MplsLsdNodes.MplsLsdNode.Labels()
                    self.labels.parent = self
                    self._children_name_map["labels"] = "labels"
                return self.labels

            if (child_yang_name == "rewrite"):
                if (self.rewrite is None):
                    self.rewrite = MplsLsdNodes.MplsLsdNode.Rewrite()
                    self.rewrite.parent = self
                    self._children_name_map["rewrite"] = "rewrite"
                return self.rewrite

            if (child_yang_name == "rewrite-summary"):
                if (self.rewrite_summary is None):
                    self.rewrite_summary = MplsLsdNodes.MplsLsdNode.RewriteSummary()
                    self.rewrite_summary.parent = self
                    self._children_name_map["rewrite_summary"] = "rewrite-summary"
                return self.rewrite_summary

            if (child_yang_name == "rewrite-summary-vrfs"):
                if (self.rewrite_summary_vrfs is None):
                    self.rewrite_summary_vrfs = MplsLsdNodes.MplsLsdNode.RewriteSummaryVrfs()
                    self.rewrite_summary_vrfs.parent = self
                    self._children_name_map["rewrite_summary_vrfs"] = "rewrite-summary-vrfs"
                return self.rewrite_summary_vrfs

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "applications" or name == "clients" or name == "frr-database" or name == "interfaces" or name == "label-range" or name == "label-summary" or name == "label-summary-vrfs" or name == "labels" or name == "rewrite" or name == "rewrite-summary" or name == "rewrite-summary-vrfs" or name == "node-name"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "node-name"):
                self.node_name = value
                self.node_name.value_namespace = name_space
                self.node_name.value_namespace_prefix = name_space_prefix

    def has_data(self):
        for c in self.mpls_lsd_node:
            if (c.has_data()):
                return True
        return False

    def has_operation(self):
        for c in self.mpls_lsd_node:
            if (c.has_operation()):
                return True
        return self.yfilter != YFilter.not_set

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd-nodes" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "mpls-lsd-node"):
            for c in self.mpls_lsd_node:
                segment = c.get_segment_path()
                if (segment_path == segment):
                    return c
            c = MplsLsdNodes.MplsLsdNode()
            c.parent = self
            local_reference_key = "ydk::seg::%s" % segment_path
            self._local_refs[local_reference_key] = c
            self.mpls_lsd_node.append(c)
            return c

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "mpls-lsd-node"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = MplsLsdNodes()
        return self._top_entity

class MplsLsd(Entity):
    """
    mpls lsd
    
    .. attribute:: applications
    
    	Table of MPLS applications using LSD
    	**type**\:   :py:class:`Applications <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Applications>`
    
    .. attribute:: clients
    
    	Table of MPLS clients using LSD
    	**type**\:   :py:class:`Clients <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Clients>`
    
    .. attribute:: frr_database
    
    	FRR database
    	**type**\:   :py:class:`FrrDatabase <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase>`
    
    .. attribute:: interfaces
    
    	Table of MPLS interfaces
    	**type**\:   :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Interfaces>`
    
    .. attribute:: label_range
    
    	Label range
    	**type**\:   :py:class:`LabelRange <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.LabelRange>`
    
    .. attribute:: label_summary
    
    	Dynamic label range
    	**type**\:   :py:class:`LabelSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.LabelSummary>`
    
    .. attribute:: label_summary_vrfs
    
    	Dynamic label range summary by VRF
    	**type**\:   :py:class:`LabelSummaryVrfs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.LabelSummaryVrfs>`
    
    .. attribute:: labels
    
    	Table of labels
    	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels>`
    
    .. attribute:: rewrite
    
    	Table of rewrites
    	**type**\:   :py:class:`Rewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite>`
    
    .. attribute:: rewrite_summary
    
    	Rewrite Summary 
    	**type**\:   :py:class:`RewriteSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.RewriteSummary>`
    
    .. attribute:: rewrite_summary_vrfs
    
    	Rewrite Summary by VRF
    	**type**\:   :py:class:`RewriteSummaryVrfs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.RewriteSummaryVrfs>`
    
    

    """

    _prefix = 'mpls-lsd-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(MplsLsd, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-lsd"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-lsd-oper"

        self.applications = MplsLsd.Applications()
        self.applications.parent = self
        self._children_name_map["applications"] = "applications"
        self._children_yang_names.add("applications")

        self.clients = MplsLsd.Clients()
        self.clients.parent = self
        self._children_name_map["clients"] = "clients"
        self._children_yang_names.add("clients")

        self.frr_database = MplsLsd.FrrDatabase()
        self.frr_database.parent = self
        self._children_name_map["frr_database"] = "frr-database"
        self._children_yang_names.add("frr-database")

        self.interfaces = MplsLsd.Interfaces()
        self.interfaces.parent = self
        self._children_name_map["interfaces"] = "interfaces"
        self._children_yang_names.add("interfaces")

        self.label_range = MplsLsd.LabelRange()
        self.label_range.parent = self
        self._children_name_map["label_range"] = "label-range"
        self._children_yang_names.add("label-range")

        self.label_summary = MplsLsd.LabelSummary()
        self.label_summary.parent = self
        self._children_name_map["label_summary"] = "label-summary"
        self._children_yang_names.add("label-summary")

        self.label_summary_vrfs = MplsLsd.LabelSummaryVrfs()
        self.label_summary_vrfs.parent = self
        self._children_name_map["label_summary_vrfs"] = "label-summary-vrfs"
        self._children_yang_names.add("label-summary-vrfs")

        self.labels = MplsLsd.Labels()
        self.labels.parent = self
        self._children_name_map["labels"] = "labels"
        self._children_yang_names.add("labels")

        self.rewrite = MplsLsd.Rewrite()
        self.rewrite.parent = self
        self._children_name_map["rewrite"] = "rewrite"
        self._children_yang_names.add("rewrite")

        self.rewrite_summary = MplsLsd.RewriteSummary()
        self.rewrite_summary.parent = self
        self._children_name_map["rewrite_summary"] = "rewrite-summary"
        self._children_yang_names.add("rewrite-summary")

        self.rewrite_summary_vrfs = MplsLsd.RewriteSummaryVrfs()
        self.rewrite_summary_vrfs.parent = self
        self._children_name_map["rewrite_summary_vrfs"] = "rewrite-summary-vrfs"
        self._children_yang_names.add("rewrite-summary-vrfs")


    class Clients(Entity):
        """
        Table of MPLS clients using LSD
        
        .. attribute:: client
        
        	Data for MPLS client using LSD
        	**type**\: list of    :py:class:`Client <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Clients.Client>`
        
        

        """

        _prefix = 'mpls-lsd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLsd.Clients, self).__init__()

            self.yang_name = "clients"
            self.yang_parent_name = "mpls-lsd"

            self.client = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLsd.Clients, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLsd.Clients, self).__setattr__(name, value)


        class Client(Entity):
            """
            Data for MPLS client using LSD
            
            .. attribute:: client_name  <key>
            
            	Client Instance name in the form of     'Application\-<client\_name>' or      'BCDL\_Agent\-<index\:parent\_index>'
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: client_index
            
            	Client Index Value
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: client_union
            
            	Client union
            	**type**\:   :py:class:`ClientUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Clients.Client.ClientUnion>`
            
            .. attribute:: node_id
            
            	Node ID
            	**type**\:  str
            
            	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.Clients.Client, self).__init__()

                self.yang_name = "client"
                self.yang_parent_name = "clients"

                self.client_name = YLeaf(YType.str, "client-name")

                self.client_index = YLeaf(YType.uint32, "client-index")

                self.node_id = YLeaf(YType.str, "node-id")

                self.client_union = MplsLsd.Clients.Client.ClientUnion()
                self.client_union.parent = self
                self._children_name_map["client_union"] = "client-union"
                self._children_yang_names.add("client-union")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("client_name",
                                "client_index",
                                "node_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.Clients.Client, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.Clients.Client, self).__setattr__(name, value)


            class ClientUnion(Entity):
                """
                Client union
                
                .. attribute:: application
                
                	Application client
                	**type**\:   :py:class:`Application <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Clients.Client.ClientUnion.Application>`
                
                .. attribute:: bcdl_agent
                
                	BCDL agent client
                	**type**\:   :py:class:`BcdlAgent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Clients.Client.ClientUnion.BcdlAgent>`
                
                .. attribute:: lsd_client_type
                
                	LSDClientType
                	**type**\:   :py:class:`MgmtLsdClient <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdClient>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.Clients.Client.ClientUnion, self).__init__()

                    self.yang_name = "client-union"
                    self.yang_parent_name = "client"

                    self.lsd_client_type = YLeaf(YType.enumeration, "lsd-client-type")

                    self.application = MplsLsd.Clients.Client.ClientUnion.Application()
                    self.application.parent = self
                    self._children_name_map["application"] = "application"
                    self._children_yang_names.add("application")

                    self.bcdl_agent = MplsLsd.Clients.Client.ClientUnion.BcdlAgent()
                    self.bcdl_agent.parent = self
                    self._children_name_map["bcdl_agent"] = "bcdl-agent"
                    self._children_yang_names.add("bcdl-agent")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("lsd_client_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.Clients.Client.ClientUnion, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.Clients.Client.ClientUnion, self).__setattr__(name, value)


                class Application(Entity):
                    """
                    Application client
                    
                    .. attribute:: application_instance
                    
                    	client\-app instance
                    	**type**\:  str
                    
                    .. attribute:: application_name
                    
                    	Application name
                    	**type**\:  str
                    
                    .. attribute:: application_role_primary
                    
                    	Primary/Backup role
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: application_type
                    
                    	Application type
                    	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Clients.Client.ClientUnion.Application, self).__init__()

                        self.yang_name = "application"
                        self.yang_parent_name = "client-union"

                        self.application_instance = YLeaf(YType.str, "application-instance")

                        self.application_name = YLeaf(YType.str, "application-name")

                        self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                        self.application_type = YLeaf(YType.enumeration, "application-type")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("application_instance",
                                        "application_name",
                                        "application_role_primary",
                                        "application_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Clients.Client.ClientUnion.Application, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Clients.Client.ClientUnion.Application, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.application_instance.is_set or
                            self.application_name.is_set or
                            self.application_role_primary.is_set or
                            self.application_type.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.application_instance.yfilter != YFilter.not_set or
                            self.application_name.yfilter != YFilter.not_set or
                            self.application_role_primary.yfilter != YFilter.not_set or
                            self.application_type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "application" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_instance.get_name_leafdata())
                        if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_name.get_name_leafdata())
                        if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                        if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "application-instance"):
                            self.application_instance = value
                            self.application_instance.value_namespace = name_space
                            self.application_instance.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-name"):
                            self.application_name = value
                            self.application_name.value_namespace = name_space
                            self.application_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-role-primary"):
                            self.application_role_primary = value
                            self.application_role_primary.value_namespace = name_space
                            self.application_role_primary.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-type"):
                            self.application_type = value
                            self.application_type.value_namespace = name_space
                            self.application_type.value_namespace_prefix = name_space_prefix


                class BcdlAgent(Entity):
                    """
                    BCDL agent client
                    
                    .. attribute:: client_conn_index
                    
                    	BCDL Agent client connection index
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: parent_client_conn_index
                    
                    	BCDL Agent parent client connection index
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Clients.Client.ClientUnion.BcdlAgent, self).__init__()

                        self.yang_name = "bcdl-agent"
                        self.yang_parent_name = "client-union"

                        self.client_conn_index = YLeaf(YType.int32, "client-conn-index")

                        self.parent_client_conn_index = YLeaf(YType.int32, "parent-client-conn-index")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("client_conn_index",
                                        "parent_client_conn_index") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Clients.Client.ClientUnion.BcdlAgent, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Clients.Client.ClientUnion.BcdlAgent, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.client_conn_index.is_set or
                            self.parent_client_conn_index.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.client_conn_index.yfilter != YFilter.not_set or
                            self.parent_client_conn_index.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bcdl-agent" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.client_conn_index.is_set or self.client_conn_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.client_conn_index.get_name_leafdata())
                        if (self.parent_client_conn_index.is_set or self.parent_client_conn_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.parent_client_conn_index.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "client-conn-index" or name == "parent-client-conn-index"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "client-conn-index"):
                            self.client_conn_index = value
                            self.client_conn_index.value_namespace = name_space
                            self.client_conn_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "parent-client-conn-index"):
                            self.parent_client_conn_index = value
                            self.parent_client_conn_index.value_namespace = name_space
                            self.parent_client_conn_index.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.lsd_client_type.is_set or
                        (self.application is not None and self.application.has_data()) or
                        (self.bcdl_agent is not None and self.bcdl_agent.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.lsd_client_type.yfilter != YFilter.not_set or
                        (self.application is not None and self.application.has_operation()) or
                        (self.bcdl_agent is not None and self.bcdl_agent.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "client-union" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.lsd_client_type.is_set or self.lsd_client_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsd_client_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "application"):
                        if (self.application is None):
                            self.application = MplsLsd.Clients.Client.ClientUnion.Application()
                            self.application.parent = self
                            self._children_name_map["application"] = "application"
                        return self.application

                    if (child_yang_name == "bcdl-agent"):
                        if (self.bcdl_agent is None):
                            self.bcdl_agent = MplsLsd.Clients.Client.ClientUnion.BcdlAgent()
                            self.bcdl_agent.parent = self
                            self._children_name_map["bcdl_agent"] = "bcdl-agent"
                        return self.bcdl_agent

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "application" or name == "bcdl-agent" or name == "lsd-client-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "lsd-client-type"):
                        self.lsd_client_type = value
                        self.lsd_client_type.value_namespace = name_space
                        self.lsd_client_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.client_name.is_set or
                    self.client_index.is_set or
                    self.node_id.is_set or
                    (self.client_union is not None and self.client_union.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.client_name.yfilter != YFilter.not_set or
                    self.client_index.yfilter != YFilter.not_set or
                    self.node_id.yfilter != YFilter.not_set or
                    (self.client_union is not None and self.client_union.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "client" + "[client-name='" + self.client_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/clients/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.client_name.is_set or self.client_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.client_name.get_name_leafdata())
                if (self.client_index.is_set or self.client_index.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.client_index.get_name_leafdata())
                if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "client-union"):
                    if (self.client_union is None):
                        self.client_union = MplsLsd.Clients.Client.ClientUnion()
                        self.client_union.parent = self
                        self._children_name_map["client_union"] = "client-union"
                    return self.client_union

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "client-union" or name == "client-name" or name == "client-index" or name == "node-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "client-name"):
                    self.client_name = value
                    self.client_name.value_namespace = name_space
                    self.client_name.value_namespace_prefix = name_space_prefix
                if(value_path == "client-index"):
                    self.client_index = value
                    self.client_index.value_namespace = name_space
                    self.client_index.value_namespace_prefix = name_space_prefix
                if(value_path == "node-id"):
                    self.node_id = value
                    self.node_id.value_namespace = name_space
                    self.node_id.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.client:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.client:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "clients" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "client"):
                for c in self.client:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLsd.Clients.Client()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.client.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "client"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class LabelSummary(Entity):
        """
        Dynamic label range
        
        .. attribute:: owner_count
        
        	Owner counts
        	**type**\: list of    :py:class:`OwnerCount <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.LabelSummary.OwnerCount>`
        
        .. attribute:: rsi_connected
        
        	Rsi connected
        	**type**\:  int
        
        	**range:** \-2147483648..2147483647
        
        .. attribute:: total_labels
        
        	Total labels
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: vrf_name_xr
        
        	VRF Name
        	**type**\:  str
        
        

        """

        _prefix = 'mpls-lsd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLsd.LabelSummary, self).__init__()

            self.yang_name = "label-summary"
            self.yang_parent_name = "mpls-lsd"

            self.rsi_connected = YLeaf(YType.int32, "rsi-connected")

            self.total_labels = YLeaf(YType.uint32, "total-labels")

            self.vrf_name_xr = YLeaf(YType.str, "vrf-name-xr")

            self.owner_count = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("rsi_connected",
                            "total_labels",
                            "vrf_name_xr") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLsd.LabelSummary, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLsd.LabelSummary, self).__setattr__(name, value)


        class OwnerCount(Entity):
            """
            Owner counts
            
            .. attribute:: application_instance
            
            	client\-app identifier
            	**type**\:  str
            
            .. attribute:: application_name
            
            	Application name
            	**type**\:  str
            
            .. attribute:: application_role_primary
            
            	Primary/Backup role
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: application_type
            
            	Application type
            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
            
            .. attribute:: number_of_labels
            
            	Number of labels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.LabelSummary.OwnerCount, self).__init__()

                self.yang_name = "owner-count"
                self.yang_parent_name = "label-summary"

                self.application_instance = YLeaf(YType.str, "application-instance")

                self.application_name = YLeaf(YType.str, "application-name")

                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                self.application_type = YLeaf(YType.enumeration, "application-type")

                self.number_of_labels = YLeaf(YType.uint32, "number-of-labels")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("application_instance",
                                "application_name",
                                "application_role_primary",
                                "application_type",
                                "number_of_labels") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.LabelSummary.OwnerCount, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.LabelSummary.OwnerCount, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.application_instance.is_set or
                    self.application_name.is_set or
                    self.application_role_primary.is_set or
                    self.application_type.is_set or
                    self.number_of_labels.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.application_instance.yfilter != YFilter.not_set or
                    self.application_name.yfilter != YFilter.not_set or
                    self.application_role_primary.yfilter != YFilter.not_set or
                    self.application_type.yfilter != YFilter.not_set or
                    self.number_of_labels.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "owner-count" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/label-summary/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_name.get_name_leafdata())
                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_type.get_name_leafdata())
                if (self.number_of_labels.is_set or self.number_of_labels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.number_of_labels.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "number-of-labels"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "application-instance"):
                    self.application_instance = value
                    self.application_instance.value_namespace = name_space
                    self.application_instance.value_namespace_prefix = name_space_prefix
                if(value_path == "application-name"):
                    self.application_name = value
                    self.application_name.value_namespace = name_space
                    self.application_name.value_namespace_prefix = name_space_prefix
                if(value_path == "application-role-primary"):
                    self.application_role_primary = value
                    self.application_role_primary.value_namespace = name_space
                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                if(value_path == "application-type"):
                    self.application_type = value
                    self.application_type.value_namespace = name_space
                    self.application_type.value_namespace_prefix = name_space_prefix
                if(value_path == "number-of-labels"):
                    self.number_of_labels = value
                    self.number_of_labels.value_namespace = name_space
                    self.number_of_labels.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.owner_count:
                if (c.has_data()):
                    return True
            return (
                self.rsi_connected.is_set or
                self.total_labels.is_set or
                self.vrf_name_xr.is_set)

        def has_operation(self):
            for c in self.owner_count:
                if (c.has_operation()):
                    return True
            return (
                self.yfilter != YFilter.not_set or
                self.rsi_connected.yfilter != YFilter.not_set or
                self.total_labels.yfilter != YFilter.not_set or
                self.vrf_name_xr.yfilter != YFilter.not_set)

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "label-summary" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.rsi_connected.is_set or self.rsi_connected.yfilter != YFilter.not_set):
                leaf_name_data.append(self.rsi_connected.get_name_leafdata())
            if (self.total_labels.is_set or self.total_labels.yfilter != YFilter.not_set):
                leaf_name_data.append(self.total_labels.get_name_leafdata())
            if (self.vrf_name_xr.is_set or self.vrf_name_xr.yfilter != YFilter.not_set):
                leaf_name_data.append(self.vrf_name_xr.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "owner-count"):
                for c in self.owner_count:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLsd.LabelSummary.OwnerCount()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.owner_count.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "owner-count" or name == "rsi-connected" or name == "total-labels" or name == "vrf-name-xr"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "rsi-connected"):
                self.rsi_connected = value
                self.rsi_connected.value_namespace = name_space
                self.rsi_connected.value_namespace_prefix = name_space_prefix
            if(value_path == "total-labels"):
                self.total_labels = value
                self.total_labels.value_namespace = name_space
                self.total_labels.value_namespace_prefix = name_space_prefix
            if(value_path == "vrf-name-xr"):
                self.vrf_name_xr = value
                self.vrf_name_xr.value_namespace = name_space
                self.vrf_name_xr.value_namespace_prefix = name_space_prefix


    class Labels(Entity):
        """
        Table of labels
        
        .. attribute:: label
        
        	Data for label
        	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label>`
        
        

        """

        _prefix = 'mpls-lsd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLsd.Labels, self).__init__()

            self.yang_name = "labels"
            self.yang_parent_name = "mpls-lsd"

            self.label = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLsd.Labels, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLsd.Labels, self).__setattr__(name, value)


        class Label(Entity):
            """
            Data for label
            
            .. attribute:: label_id  <key>
            
            	Label value
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: application_owner
            
            	Application owner
            	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.ApplicationOwner>`
            
            .. attribute:: label
            
            	Label value
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: label_context
            
            	Label context
            	**type**\:   :py:class:`LabelContext <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext>`
            
            .. attribute:: rewrite_is_bound
            
            	Rewrite bound to label
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: rewrite_owners
            
            	Rewrite owner
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rs_iconnected
            
            	RSI connected
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: vrf_name
            
            	VRF Name
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.Labels.Label, self).__init__()

                self.yang_name = "label"
                self.yang_parent_name = "labels"

                self.label_id = YLeaf(YType.int32, "label-id")

                self.label = YLeaf(YType.uint32, "label")

                self.rewrite_is_bound = YLeaf(YType.int32, "rewrite-is-bound")

                self.rewrite_owners = YLeaf(YType.uint32, "rewrite-owners")

                self.rs_iconnected = YLeaf(YType.int32, "rs-iconnected")

                self.vrf_name = YLeaf(YType.str, "vrf-name")

                self.label_context = MplsLsd.Labels.Label.LabelContext()
                self.label_context.parent = self
                self._children_name_map["label_context"] = "label-context"
                self._children_yang_names.add("label-context")

                self.application_owner = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("label_id",
                                "label",
                                "rewrite_is_bound",
                                "rewrite_owners",
                                "rs_iconnected",
                                "vrf_name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.Labels.Label, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.Labels.Label, self).__setattr__(name, value)


            class LabelContext(Entity):
                """
                Label context
                
                .. attribute:: application_data
                
                	Application opaque data
                	**type**\:  str
                
                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                
                .. attribute:: key
                
                	Label Key
                	**type**\:   :py:class:`Key <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.Labels.Label.LabelContext, self).__init__()

                    self.yang_name = "label-context"
                    self.yang_parent_name = "label"

                    self.application_data = YLeaf(YType.str, "application-data")

                    self.key = MplsLsd.Labels.Label.LabelContext.Key()
                    self.key.parent = self
                    self._children_name_map["key"] = "key"
                    self._children_yang_names.add("key")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("application_data") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.Labels.Label.LabelContext, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.Labels.Label.LabelContext, self).__setattr__(name, value)


                class Key(Entity):
                    """
                    Label Key
                    
                    .. attribute:: cev4l3vpn_data
                    
                    	L3VPN CEv4 label context
                    	**type**\:   :py:class:`Cev4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.Cev4L3VpnData>`
                    
                    .. attribute:: cev6l3vpn_data
                    
                    	L3VPN CEv6 label context
                    	**type**\:   :py:class:`Cev6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.Cev6L3VpnData>`
                    
                    .. attribute:: evpn_data
                    
                    	EVPN context
                    	**type**\:   :py:class:`EvpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.EvpnData>`
                    
                    .. attribute:: generic_routing_encapsulation
                    
                    	Generic routing encapsulation context
                    	**type**\:   :py:class:`GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.GenericRoutingEncapsulation>`
                    
                    .. attribute:: ip_sub_data
                    
                    	IP Subscriber context
                    	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.IpSubData>`
                    
                    .. attribute:: ipv4_data
                    
                    	IPv4 label context
                    	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.Ipv4Data>`
                    
                    .. attribute:: ipv4blb_data
                    
                    	BFD BLB label context
                    	**type**\:   :py:class:`Ipv4BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.Ipv4BlbData>`
                    
                    .. attribute:: ipv4l3vpn_data
                    
                    	L3VPN IPv4 label context
                    	**type**\:   :py:class:`Ipv4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.Ipv4L3VpnData>`
                    
                    .. attribute:: ipv6_data
                    
                    	IPv6 label context
                    	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.Ipv6Data>`
                    
                    .. attribute:: ipv6_generic_routing_encapsulation
                    
                    	Generic routing encapsulation context
                    	**type**\:   :py:class:`Ipv6GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.Ipv6GenericRoutingEncapsulation>`
                    
                    .. attribute:: ipv6blb_data
                    
                    	BFD BLB label context
                    	**type**\:   :py:class:`Ipv6BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.Ipv6BlbData>`
                    
                    .. attribute:: ipv6l3vpn_data
                    
                    	L3VPN IPv6 label context
                    	**type**\:   :py:class:`Ipv6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.Ipv6L3VpnData>`
                    
                    .. attribute:: label_block_data
                    
                    	Label block context
                    	**type**\:   :py:class:`LabelBlockData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.LabelBlockData>`
                    
                    .. attribute:: label_block_srgb_data
                    
                    	Label block SRGB context
                    	**type**\:   :py:class:`LabelBlockSrgbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.LabelBlockSrgbData>`
                    
                    .. attribute:: label_context_type
                    
                    	LabelContextType
                    	**type**\:   :py:class:`MgmtLsdLblCtx <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLblCtx>`
                    
                    .. attribute:: mld_pv4_data
                    
                    	MLDPv4 LSM\-ID context
                    	**type**\:   :py:class:`MldPv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.MldPv4Data>`
                    
                    .. attribute:: next_hop_set_l3vpn
                    
                    	L3VPN NH SET label context
                    	**type**\:   :py:class:`NextHopSetL3Vpn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.NextHopSetL3Vpn>`
                    
                    .. attribute:: pi_mi_pmsi_data
                    
                    	PIM I\-PMSI label conext
                    	**type**\:   :py:class:`PiMiPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.PiMiPmsiData>`
                    
                    .. attribute:: pi_ms_pmsi_data
                    
                    	PIM S\-PMSI label conext
                    	**type**\:   :py:class:`PiMsPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.PiMsPmsiData>`
                    
                    .. attribute:: pseudowire_data
                    
                    	Pseudowire label context
                    	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.PseudowireData>`
                    
                    .. attribute:: pseudowire_head_end_data
                    
                    	Pseudowire Head\-end label context
                    	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.PseudowireHeadEndData>`
                    
                    .. attribute:: sr_adj_segment_ipv4
                    
                    	SR Adj Segment ipv4 context
                    	**type**\:   :py:class:`SrAdjSegmentIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.SrAdjSegmentIpv4>`
                    
                    .. attribute:: sr_adj_segment_ipv6
                    
                    	SR Adj Segment ipv6 context
                    	**type**\:   :py:class:`SrAdjSegmentIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.SrAdjSegmentIpv6>`
                    
                    .. attribute:: sr_prefix_segment
                    
                    	SR Prefix Segment context
                    	**type**\:   :py:class:`SrPrefixSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.SrPrefixSegment>`
                    
                    .. attribute:: te_binding
                    
                    	MPLS TE tunnel binding context
                    	**type**\:   :py:class:`TeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.TeBinding>`
                    
                    .. attribute:: tev4_data
                    
                    	TEv4 label context
                    	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.Tev4Data>`
                    
                    .. attribute:: tev4p2mp_data
                    
                    	TEv4 P2MP context
                    	**type**\:   :py:class:`Tev4P2MpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.Tev4P2MpData>`
                    
                    .. attribute:: tp_data
                    
                    	TP context
                    	**type**\:   :py:class:`TpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.TpData>`
                    
                    .. attribute:: vrf_l3vpn_data
                    
                    	L3VPN VRF label context
                    	**type**\:   :py:class:`VrfL3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Labels.Label.LabelContext.Key.VrfL3VpnData>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Labels.Label.LabelContext.Key, self).__init__()

                        self.yang_name = "key"
                        self.yang_parent_name = "label-context"

                        self.label_context_type = YLeaf(YType.enumeration, "label-context-type")

                        self.cev4l3vpn_data = MplsLsd.Labels.Label.LabelContext.Key.Cev4L3VpnData()
                        self.cev4l3vpn_data.parent = self
                        self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                        self._children_yang_names.add("cev4l3vpn-data")

                        self.cev6l3vpn_data = MplsLsd.Labels.Label.LabelContext.Key.Cev6L3VpnData()
                        self.cev6l3vpn_data.parent = self
                        self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                        self._children_yang_names.add("cev6l3vpn-data")

                        self.evpn_data = MplsLsd.Labels.Label.LabelContext.Key.EvpnData()
                        self.evpn_data.parent = self
                        self._children_name_map["evpn_data"] = "evpn-data"
                        self._children_yang_names.add("evpn-data")

                        self.generic_routing_encapsulation = MplsLsd.Labels.Label.LabelContext.Key.GenericRoutingEncapsulation()
                        self.generic_routing_encapsulation.parent = self
                        self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                        self._children_yang_names.add("generic-routing-encapsulation")

                        self.ip_sub_data = MplsLsd.Labels.Label.LabelContext.Key.IpSubData()
                        self.ip_sub_data.parent = self
                        self._children_name_map["ip_sub_data"] = "ip-sub-data"
                        self._children_yang_names.add("ip-sub-data")

                        self.ipv4_data = MplsLsd.Labels.Label.LabelContext.Key.Ipv4Data()
                        self.ipv4_data.parent = self
                        self._children_name_map["ipv4_data"] = "ipv4-data"
                        self._children_yang_names.add("ipv4-data")

                        self.ipv4blb_data = MplsLsd.Labels.Label.LabelContext.Key.Ipv4BlbData()
                        self.ipv4blb_data.parent = self
                        self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                        self._children_yang_names.add("ipv4blb-data")

                        self.ipv4l3vpn_data = MplsLsd.Labels.Label.LabelContext.Key.Ipv4L3VpnData()
                        self.ipv4l3vpn_data.parent = self
                        self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                        self._children_yang_names.add("ipv4l3vpn-data")

                        self.ipv6_data = MplsLsd.Labels.Label.LabelContext.Key.Ipv6Data()
                        self.ipv6_data.parent = self
                        self._children_name_map["ipv6_data"] = "ipv6-data"
                        self._children_yang_names.add("ipv6-data")

                        self.ipv6_generic_routing_encapsulation = MplsLsd.Labels.Label.LabelContext.Key.Ipv6GenericRoutingEncapsulation()
                        self.ipv6_generic_routing_encapsulation.parent = self
                        self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                        self._children_yang_names.add("ipv6-generic-routing-encapsulation")

                        self.ipv6blb_data = MplsLsd.Labels.Label.LabelContext.Key.Ipv6BlbData()
                        self.ipv6blb_data.parent = self
                        self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                        self._children_yang_names.add("ipv6blb-data")

                        self.ipv6l3vpn_data = MplsLsd.Labels.Label.LabelContext.Key.Ipv6L3VpnData()
                        self.ipv6l3vpn_data.parent = self
                        self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                        self._children_yang_names.add("ipv6l3vpn-data")

                        self.label_block_data = MplsLsd.Labels.Label.LabelContext.Key.LabelBlockData()
                        self.label_block_data.parent = self
                        self._children_name_map["label_block_data"] = "label-block-data"
                        self._children_yang_names.add("label-block-data")

                        self.label_block_srgb_data = MplsLsd.Labels.Label.LabelContext.Key.LabelBlockSrgbData()
                        self.label_block_srgb_data.parent = self
                        self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                        self._children_yang_names.add("label-block-srgb-data")

                        self.mld_pv4_data = MplsLsd.Labels.Label.LabelContext.Key.MldPv4Data()
                        self.mld_pv4_data.parent = self
                        self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                        self._children_yang_names.add("mld-pv4-data")

                        self.next_hop_set_l3vpn = MplsLsd.Labels.Label.LabelContext.Key.NextHopSetL3Vpn()
                        self.next_hop_set_l3vpn.parent = self
                        self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                        self._children_yang_names.add("next-hop-set-l3vpn")

                        self.pi_mi_pmsi_data = MplsLsd.Labels.Label.LabelContext.Key.PiMiPmsiData()
                        self.pi_mi_pmsi_data.parent = self
                        self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                        self._children_yang_names.add("pi-mi-pmsi-data")

                        self.pi_ms_pmsi_data = MplsLsd.Labels.Label.LabelContext.Key.PiMsPmsiData()
                        self.pi_ms_pmsi_data.parent = self
                        self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                        self._children_yang_names.add("pi-ms-pmsi-data")

                        self.pseudowire_data = MplsLsd.Labels.Label.LabelContext.Key.PseudowireData()
                        self.pseudowire_data.parent = self
                        self._children_name_map["pseudowire_data"] = "pseudowire-data"
                        self._children_yang_names.add("pseudowire-data")

                        self.pseudowire_head_end_data = MplsLsd.Labels.Label.LabelContext.Key.PseudowireHeadEndData()
                        self.pseudowire_head_end_data.parent = self
                        self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                        self._children_yang_names.add("pseudowire-head-end-data")

                        self.sr_adj_segment_ipv4 = MplsLsd.Labels.Label.LabelContext.Key.SrAdjSegmentIpv4()
                        self.sr_adj_segment_ipv4.parent = self
                        self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                        self._children_yang_names.add("sr-adj-segment-ipv4")

                        self.sr_adj_segment_ipv6 = MplsLsd.Labels.Label.LabelContext.Key.SrAdjSegmentIpv6()
                        self.sr_adj_segment_ipv6.parent = self
                        self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                        self._children_yang_names.add("sr-adj-segment-ipv6")

                        self.sr_prefix_segment = MplsLsd.Labels.Label.LabelContext.Key.SrPrefixSegment()
                        self.sr_prefix_segment.parent = self
                        self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                        self._children_yang_names.add("sr-prefix-segment")

                        self.te_binding = MplsLsd.Labels.Label.LabelContext.Key.TeBinding()
                        self.te_binding.parent = self
                        self._children_name_map["te_binding"] = "te-binding"
                        self._children_yang_names.add("te-binding")

                        self.tev4_data = MplsLsd.Labels.Label.LabelContext.Key.Tev4Data()
                        self.tev4_data.parent = self
                        self._children_name_map["tev4_data"] = "tev4-data"
                        self._children_yang_names.add("tev4-data")

                        self.tev4p2mp_data = MplsLsd.Labels.Label.LabelContext.Key.Tev4P2MpData()
                        self.tev4p2mp_data.parent = self
                        self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                        self._children_yang_names.add("tev4p2mp-data")

                        self.tp_data = MplsLsd.Labels.Label.LabelContext.Key.TpData()
                        self.tp_data.parent = self
                        self._children_name_map["tp_data"] = "tp-data"
                        self._children_yang_names.add("tp-data")

                        self.vrf_l3vpn_data = MplsLsd.Labels.Label.LabelContext.Key.VrfL3VpnData()
                        self.vrf_l3vpn_data.parent = self
                        self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                        self._children_yang_names.add("vrf-l3vpn-data")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("label_context_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Labels.Label.LabelContext.Key, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Labels.Label.LabelContext.Key, self).__setattr__(name, value)


                    class Ipv4Data(Entity):
                        """
                        IPv4 label context
                        
                        .. attribute:: prefix
                        
                        	IPv4 prefix
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: prefix_length
                        
                        	IPv4 prefix length
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: security_id
                        
                        	Security ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: vrf_name
                        
                        	VRF Name
                        	**type**\:  str
                        
                        	**length:** 0..33
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.Ipv4Data, self).__init__()

                            self.yang_name = "ipv4-data"
                            self.yang_parent_name = "key"

                            self.prefix = YLeaf(YType.str, "prefix")

                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            self.security_id = YLeaf(YType.uint32, "security-id")

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.vrf_name = YLeaf(YType.str, "vrf-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("prefix",
                                            "prefix_length",
                                            "security_id",
                                            "table_id",
                                            "vrf_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.Ipv4Data, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.Ipv4Data, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.prefix.is_set or
                                self.prefix_length.is_set or
                                self.security_id.is_set or
                                self.table_id.is_set or
                                self.vrf_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.prefix.yfilter != YFilter.not_set or
                                self.prefix_length.yfilter != YFilter.not_set or
                                self.security_id.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.vrf_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ipv4-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix.get_name_leafdata())
                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                            if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.security_id.get_name_leafdata())
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vrf_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "prefix"):
                                self.prefix = value
                                self.prefix.value_namespace = name_space
                                self.prefix.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-length"):
                                self.prefix_length = value
                                self.prefix_length.value_namespace = name_space
                                self.prefix_length.value_namespace_prefix = name_space_prefix
                            if(value_path == "security-id"):
                                self.security_id = value
                                self.security_id.value_namespace = name_space
                                self.security_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "vrf-name"):
                                self.vrf_name = value
                                self.vrf_name.value_namespace = name_space
                                self.vrf_name.value_namespace_prefix = name_space_prefix


                    class Ipv6Data(Entity):
                        """
                        IPv6 label context
                        
                        .. attribute:: prefix
                        
                        	Prefix
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: security_id
                        
                        	Security ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: vrf_name
                        
                        	VRF Name
                        	**type**\:  str
                        
                        	**length:** 0..33
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.Ipv6Data, self).__init__()

                            self.yang_name = "ipv6-data"
                            self.yang_parent_name = "key"

                            self.prefix = YLeaf(YType.str, "prefix")

                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            self.security_id = YLeaf(YType.uint32, "security-id")

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.vrf_name = YLeaf(YType.str, "vrf-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("prefix",
                                            "prefix_length",
                                            "security_id",
                                            "table_id",
                                            "vrf_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.Ipv6Data, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.Ipv6Data, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.prefix.is_set or
                                self.prefix_length.is_set or
                                self.security_id.is_set or
                                self.table_id.is_set or
                                self.vrf_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.prefix.yfilter != YFilter.not_set or
                                self.prefix_length.yfilter != YFilter.not_set or
                                self.security_id.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.vrf_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ipv6-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix.get_name_leafdata())
                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                            if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.security_id.get_name_leafdata())
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vrf_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "prefix"):
                                self.prefix = value
                                self.prefix.value_namespace = name_space
                                self.prefix.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-length"):
                                self.prefix_length = value
                                self.prefix_length.value_namespace = name_space
                                self.prefix_length.value_namespace_prefix = name_space_prefix
                            if(value_path == "security-id"):
                                self.security_id = value
                                self.security_id.value_namespace = name_space
                                self.security_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "vrf-name"):
                                self.vrf_name = value
                                self.vrf_name.value_namespace = name_space
                                self.vrf_name.value_namespace_prefix = name_space_prefix


                    class Tev4Data(Entity):
                        """
                        TEv4 label context
                        
                        .. attribute:: is_srte
                        
                        	Is this an SRTE head tunnel
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tunnel_dest
                        
                        	Tunnel destination
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tunnel_id_extension
                        
                        	Extended tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tunnel_lsp_id
                        
                        	Tunnel LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tunnel_source
                        
                        	Tunnel source
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.Tev4Data, self).__init__()

                            self.yang_name = "tev4-data"
                            self.yang_parent_name = "key"

                            self.is_srte = YLeaf(YType.int32, "is-srte")

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.tunnel_dest = YLeaf(YType.str, "tunnel-dest")

                            self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                            self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                            self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                            self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_srte",
                                            "table_id",
                                            "tunnel_dest",
                                            "tunnel_id",
                                            "tunnel_id_extension",
                                            "tunnel_lsp_id",
                                            "tunnel_source") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.Tev4Data, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.Tev4Data, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.is_srte.is_set or
                                self.table_id.is_set or
                                self.tunnel_dest.is_set or
                                self.tunnel_id.is_set or
                                self.tunnel_id_extension.is_set or
                                self.tunnel_lsp_id.is_set or
                                self.tunnel_source.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_srte.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.tunnel_dest.yfilter != YFilter.not_set or
                                self.tunnel_id.yfilter != YFilter.not_set or
                                self.tunnel_id_extension.yfilter != YFilter.not_set or
                                self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                self.tunnel_source.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tev4-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_srte.is_set or self.is_srte.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_srte.get_name_leafdata())
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.tunnel_dest.is_set or self.tunnel_dest.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_dest.get_name_leafdata())
                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                            if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                            if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                            if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "is-srte" or name == "table-id" or name == "tunnel-dest" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-srte"):
                                self.is_srte = value
                                self.is_srte.value_namespace = name_space
                                self.is_srte.value_namespace_prefix = name_space_prefix
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-dest"):
                                self.tunnel_dest = value
                                self.tunnel_dest.value_namespace = name_space
                                self.tunnel_dest.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-id"):
                                self.tunnel_id = value
                                self.tunnel_id.value_namespace = name_space
                                self.tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-id-extension"):
                                self.tunnel_id_extension = value
                                self.tunnel_id_extension.value_namespace = name_space
                                self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-lsp-id"):
                                self.tunnel_lsp_id = value
                                self.tunnel_lsp_id.value_namespace = name_space
                                self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-source"):
                                self.tunnel_source = value
                                self.tunnel_source.value_namespace = name_space
                                self.tunnel_source.value_namespace_prefix = name_space_prefix


                    class Ipv4L3VpnData(Entity):
                        """
                        L3VPN IPv4 label context
                        
                        .. attribute:: prefix
                        
                        	IPv4 prefix
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: route_distinguisher
                        
                        	Route distinguisher
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.Ipv4L3VpnData, self).__init__()

                            self.yang_name = "ipv4l3vpn-data"
                            self.yang_parent_name = "key"

                            self.prefix = YLeaf(YType.str, "prefix")

                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("prefix",
                                            "prefix_length",
                                            "route_distinguisher") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.Ipv4L3VpnData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.Ipv4L3VpnData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.prefix.is_set or
                                self.prefix_length.is_set or
                                self.route_distinguisher.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.prefix.yfilter != YFilter.not_set or
                                self.prefix_length.yfilter != YFilter.not_set or
                                self.route_distinguisher.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ipv4l3vpn-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix.get_name_leafdata())
                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                            if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "prefix"):
                                self.prefix = value
                                self.prefix.value_namespace = name_space
                                self.prefix.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-length"):
                                self.prefix_length = value
                                self.prefix_length.value_namespace = name_space
                                self.prefix_length.value_namespace_prefix = name_space_prefix
                            if(value_path == "route-distinguisher"):
                                self.route_distinguisher = value
                                self.route_distinguisher.value_namespace = name_space
                                self.route_distinguisher.value_namespace_prefix = name_space_prefix


                    class Ipv6L3VpnData(Entity):
                        """
                        L3VPN IPv6 label context
                        
                        .. attribute:: prefix
                        
                        	IPv6 prefix
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: route_distinguisher
                        
                        	Route distinguisher
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.Ipv6L3VpnData, self).__init__()

                            self.yang_name = "ipv6l3vpn-data"
                            self.yang_parent_name = "key"

                            self.prefix = YLeaf(YType.str, "prefix")

                            self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("prefix",
                                            "prefix_length",
                                            "route_distinguisher") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.Ipv6L3VpnData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.Ipv6L3VpnData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.prefix.is_set or
                                self.prefix_length.is_set or
                                self.route_distinguisher.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.prefix.yfilter != YFilter.not_set or
                                self.prefix_length.yfilter != YFilter.not_set or
                                self.route_distinguisher.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ipv6l3vpn-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix.get_name_leafdata())
                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_length.get_name_leafdata())
                            if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "prefix"):
                                self.prefix = value
                                self.prefix.value_namespace = name_space
                                self.prefix.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-length"):
                                self.prefix_length = value
                                self.prefix_length.value_namespace = name_space
                                self.prefix_length.value_namespace_prefix = name_space_prefix
                            if(value_path == "route-distinguisher"):
                                self.route_distinguisher = value
                                self.route_distinguisher.value_namespace = name_space
                                self.route_distinguisher.value_namespace_prefix = name_space_prefix


                    class VrfL3VpnData(Entity):
                        """
                        L3VPN VRF label context
                        
                        .. attribute:: security_id
                        
                        	Security ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.VrfL3VpnData, self).__init__()

                            self.yang_name = "vrf-l3vpn-data"
                            self.yang_parent_name = "key"

                            self.security_id = YLeaf(YType.uint32, "security-id")

                            self.table_id = YLeaf(YType.uint32, "table-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("security_id",
                                            "table_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.VrfL3VpnData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.VrfL3VpnData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.security_id.is_set or
                                self.table_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.security_id.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vrf-l3vpn-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.security_id.get_name_leafdata())
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "security-id" or name == "table-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "security-id"):
                                self.security_id = value
                                self.security_id.value_namespace = name_space
                                self.security_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix


                    class Cev4L3VpnData(Entity):
                        """
                        L3VPN CEv4 label context
                        
                        .. attribute:: ipv4_next_hop
                        
                        	IPv4 nexthop
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: security_id
                        
                        	Security ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.Cev4L3VpnData, self).__init__()

                            self.yang_name = "cev4l3vpn-data"
                            self.yang_parent_name = "key"

                            self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                            self.security_id = YLeaf(YType.uint32, "security-id")

                            self.table_id = YLeaf(YType.uint32, "table-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ipv4_next_hop",
                                            "security_id",
                                            "table_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.Cev4L3VpnData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.Cev4L3VpnData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.ipv4_next_hop.is_set or
                                self.security_id.is_set or
                                self.table_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ipv4_next_hop.yfilter != YFilter.not_set or
                                self.security_id.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "cev4l3vpn-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                            if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.security_id.get_name_leafdata())
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4-next-hop" or name == "security-id" or name == "table-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ipv4-next-hop"):
                                self.ipv4_next_hop = value
                                self.ipv4_next_hop.value_namespace = name_space
                                self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "security-id"):
                                self.security_id = value
                                self.security_id.value_namespace = name_space
                                self.security_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix


                    class Cev6L3VpnData(Entity):
                        """
                        L3VPN CEv6 label context
                        
                        .. attribute:: ipv6_next_hop
                        
                        	IPv6 nexthop
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: security_id
                        
                        	Security ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.Cev6L3VpnData, self).__init__()

                            self.yang_name = "cev6l3vpn-data"
                            self.yang_parent_name = "key"

                            self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                            self.security_id = YLeaf(YType.uint32, "security-id")

                            self.table_id = YLeaf(YType.uint32, "table-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ipv6_next_hop",
                                            "security_id",
                                            "table_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.Cev6L3VpnData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.Cev6L3VpnData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.ipv6_next_hop.is_set or
                                self.security_id.is_set or
                                self.table_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ipv6_next_hop.yfilter != YFilter.not_set or
                                self.security_id.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "cev6l3vpn-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                            if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.security_id.get_name_leafdata())
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv6-next-hop" or name == "security-id" or name == "table-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ipv6-next-hop"):
                                self.ipv6_next_hop = value
                                self.ipv6_next_hop.value_namespace = name_space
                                self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "security-id"):
                                self.security_id = value
                                self.security_id.value_namespace = name_space
                                self.security_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix


                    class PseudowireData(Entity):
                        """
                        Pseudowire label context
                        
                        .. attribute:: prefix
                        
                        	Address prefix
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: pseudowire_id
                        
                        	Pseudo\-wire ID
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: remote_l2_router_id
                        
                        	Remote L2 Router ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: subinterface
                        
                        	Subinterface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.PseudowireData, self).__init__()

                            self.yang_name = "pseudowire-data"
                            self.yang_parent_name = "key"

                            self.prefix = YLeaf(YType.str, "prefix")

                            self.pseudowire_id = YLeaf(YType.uint64, "pseudowire-id")

                            self.remote_l2_router_id = YLeaf(YType.uint32, "remote-l2-router-id")

                            self.subinterface = YLeaf(YType.str, "subinterface")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("prefix",
                                            "pseudowire_id",
                                            "remote_l2_router_id",
                                            "subinterface") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.PseudowireData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.PseudowireData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.prefix.is_set or
                                self.pseudowire_id.is_set or
                                self.remote_l2_router_id.is_set or
                                self.subinterface.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.prefix.yfilter != YFilter.not_set or
                                self.pseudowire_id.yfilter != YFilter.not_set or
                                self.remote_l2_router_id.yfilter != YFilter.not_set or
                                self.subinterface.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "pseudowire-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix.get_name_leafdata())
                            if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pseudowire_id.get_name_leafdata())
                            if (self.remote_l2_router_id.is_set or self.remote_l2_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_l2_router_id.get_name_leafdata())
                            if (self.subinterface.is_set or self.subinterface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.subinterface.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "prefix" or name == "pseudowire-id" or name == "remote-l2-router-id" or name == "subinterface"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "prefix"):
                                self.prefix = value
                                self.prefix.value_namespace = name_space
                                self.prefix.value_namespace_prefix = name_space_prefix
                            if(value_path == "pseudowire-id"):
                                self.pseudowire_id = value
                                self.pseudowire_id.value_namespace = name_space
                                self.pseudowire_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-l2-router-id"):
                                self.remote_l2_router_id = value
                                self.remote_l2_router_id.value_namespace = name_space
                                self.remote_l2_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "subinterface"):
                                self.subinterface = value
                                self.subinterface.value_namespace = name_space
                                self.subinterface.value_namespace_prefix = name_space_prefix


                    class LabelBlockData(Entity):
                        """
                        Label block context
                        
                        .. attribute:: edge_id
                        
                        	Edge ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: offset
                        
                        	Offset
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: service
                        
                        	Service
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: size
                        
                        	Number of labels
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: vpn_id
                        
                        	VPN ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.LabelBlockData, self).__init__()

                            self.yang_name = "label-block-data"
                            self.yang_parent_name = "key"

                            self.edge_id = YLeaf(YType.uint16, "edge-id")

                            self.offset = YLeaf(YType.uint32, "offset")

                            self.service = YLeaf(YType.uint8, "service")

                            self.size = YLeaf(YType.uint32, "size")

                            self.vpn_id = YLeaf(YType.uint16, "vpn-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("edge_id",
                                            "offset",
                                            "service",
                                            "size",
                                            "vpn_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.LabelBlockData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.LabelBlockData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.edge_id.is_set or
                                self.offset.is_set or
                                self.service.is_set or
                                self.size.is_set or
                                self.vpn_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.edge_id.yfilter != YFilter.not_set or
                                self.offset.yfilter != YFilter.not_set or
                                self.service.yfilter != YFilter.not_set or
                                self.size.yfilter != YFilter.not_set or
                                self.vpn_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "label-block-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.edge_id.is_set or self.edge_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.edge_id.get_name_leafdata())
                            if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.offset.get_name_leafdata())
                            if (self.service.is_set or self.service.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.service.get_name_leafdata())
                            if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.size.get_name_leafdata())
                            if (self.vpn_id.is_set or self.vpn_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vpn_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "edge-id" or name == "offset" or name == "service" or name == "size" or name == "vpn-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "edge-id"):
                                self.edge_id = value
                                self.edge_id.value_namespace = name_space
                                self.edge_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "offset"):
                                self.offset = value
                                self.offset.value_namespace = name_space
                                self.offset.value_namespace_prefix = name_space_prefix
                            if(value_path == "service"):
                                self.service = value
                                self.service.value_namespace = name_space
                                self.service.value_namespace_prefix = name_space_prefix
                            if(value_path == "size"):
                                self.size = value
                                self.size.value_namespace = name_space
                                self.size.value_namespace_prefix = name_space_prefix
                            if(value_path == "vpn-id"):
                                self.vpn_id = value
                                self.vpn_id.value_namespace = name_space
                                self.vpn_id.value_namespace_prefix = name_space_prefix


                    class IpSubData(Entity):
                        """
                        IP Subscriber context
                        
                        .. attribute:: parent_interface
                        
                        	Parent interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: table_id
                        
                        	Table Id
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.IpSubData, self).__init__()

                            self.yang_name = "ip-sub-data"
                            self.yang_parent_name = "key"

                            self.parent_interface = YLeaf(YType.str, "parent-interface")

                            self.table_id = YLeaf(YType.uint32, "table-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("parent_interface",
                                            "table_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.IpSubData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.IpSubData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.parent_interface.is_set or
                                self.table_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.parent_interface.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ip-sub-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.parent_interface.is_set or self.parent_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.parent_interface.get_name_leafdata())
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "parent-interface" or name == "table-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "parent-interface"):
                                self.parent_interface = value
                                self.parent_interface.value_namespace = name_space
                                self.parent_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix


                    class Tev4P2MpData(Entity):
                        """
                        TEv4 P2MP context
                        
                        .. attribute:: p2mp_id
                        
                        	Point to multipoint ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: previous_hop
                        
                        	Previous hop
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tunnel_id_extension
                        
                        	Tunnel ID extension
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tunnel_lsp_id
                        
                        	Tunnel LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tunnel_source
                        
                        	Tunnel source
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.Tev4P2MpData, self).__init__()

                            self.yang_name = "tev4p2mp-data"
                            self.yang_parent_name = "key"

                            self.p2mp_id = YLeaf(YType.uint32, "p2mp-id")

                            self.previous_hop = YLeaf(YType.str, "previous-hop")

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                            self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                            self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                            self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("p2mp_id",
                                            "previous_hop",
                                            "table_id",
                                            "tunnel_id",
                                            "tunnel_id_extension",
                                            "tunnel_lsp_id",
                                            "tunnel_source") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.Tev4P2MpData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.Tev4P2MpData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.p2mp_id.is_set or
                                self.previous_hop.is_set or
                                self.table_id.is_set or
                                self.tunnel_id.is_set or
                                self.tunnel_id_extension.is_set or
                                self.tunnel_lsp_id.is_set or
                                self.tunnel_source.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.p2mp_id.yfilter != YFilter.not_set or
                                self.previous_hop.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.tunnel_id.yfilter != YFilter.not_set or
                                self.tunnel_id_extension.yfilter != YFilter.not_set or
                                self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                self.tunnel_source.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tev4p2mp-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                            if (self.previous_hop.is_set or self.previous_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop.get_name_leafdata())
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                            if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                            if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                            if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "p2mp-id" or name == "previous-hop" or name == "table-id" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "p2mp-id"):
                                self.p2mp_id = value
                                self.p2mp_id.value_namespace = name_space
                                self.p2mp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop"):
                                self.previous_hop = value
                                self.previous_hop.value_namespace = name_space
                                self.previous_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-id"):
                                self.tunnel_id = value
                                self.tunnel_id.value_namespace = name_space
                                self.tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-id-extension"):
                                self.tunnel_id_extension = value
                                self.tunnel_id_extension.value_namespace = name_space
                                self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-lsp-id"):
                                self.tunnel_lsp_id = value
                                self.tunnel_lsp_id.value_namespace = name_space
                                self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-source"):
                                self.tunnel_source = value
                                self.tunnel_source.value_namespace = name_space
                                self.tunnel_source.value_namespace_prefix = name_space_prefix


                    class MldPv4Data(Entity):
                        """
                        MLDPv4 LSM\-ID context
                        
                        .. attribute:: lsm_id
                        
                        	LSM ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: peer_label_space_id
                        
                        	Peer Label Space Id
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: peer_lsrid
                        
                        	Peer LSR Id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: type
                        
                        	LSM ID Type
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.MldPv4Data, self).__init__()

                            self.yang_name = "mld-pv4-data"
                            self.yang_parent_name = "key"

                            self.lsm_id = YLeaf(YType.uint32, "lsm-id")

                            self.peer_label_space_id = YLeaf(YType.uint16, "peer-label-space-id")

                            self.peer_lsrid = YLeaf(YType.str, "peer-lsrid")

                            self.table_id = YLeaf(YType.uint32, "table-id")

                            self.type = YLeaf(YType.uint16, "type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lsm_id",
                                            "peer_label_space_id",
                                            "peer_lsrid",
                                            "table_id",
                                            "type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.MldPv4Data, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.MldPv4Data, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.lsm_id.is_set or
                                self.peer_label_space_id.is_set or
                                self.peer_lsrid.is_set or
                                self.table_id.is_set or
                                self.type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lsm_id.yfilter != YFilter.not_set or
                                self.peer_label_space_id.yfilter != YFilter.not_set or
                                self.peer_lsrid.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set or
                                self.type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "mld-pv4-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lsm_id.is_set or self.lsm_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsm_id.get_name_leafdata())
                            if (self.peer_label_space_id.is_set or self.peer_label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.peer_label_space_id.get_name_leafdata())
                            if (self.peer_lsrid.is_set or self.peer_lsrid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.peer_lsrid.get_name_leafdata())
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())
                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lsm-id" or name == "peer-label-space-id" or name == "peer-lsrid" or name == "table-id" or name == "type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lsm-id"):
                                self.lsm_id = value
                                self.lsm_id.value_namespace = name_space
                                self.lsm_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "peer-label-space-id"):
                                self.peer_label_space_id = value
                                self.peer_label_space_id.value_namespace = name_space
                                self.peer_label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "peer-lsrid"):
                                self.peer_lsrid = value
                                self.peer_lsrid.value_namespace = name_space
                                self.peer_lsrid.value_namespace_prefix = name_space_prefix
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "type"):
                                self.type = value
                                self.type.value_namespace = name_space
                                self.type.value_namespace_prefix = name_space_prefix


                    class PseudowireHeadEndData(Entity):
                        """
                        Pseudowire Head\-end label context
                        
                        .. attribute:: pwhe_intf
                        
                        	Pseudo\-wire Head\-end interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.PseudowireHeadEndData, self).__init__()

                            self.yang_name = "pseudowire-head-end-data"
                            self.yang_parent_name = "key"

                            self.pwhe_intf = YLeaf(YType.str, "pwhe-intf")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pwhe_intf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.PseudowireHeadEndData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.PseudowireHeadEndData, self).__setattr__(name, value)

                        def has_data(self):
                            return self.pwhe_intf.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pwhe_intf.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "pseudowire-head-end-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pwhe_intf.is_set or self.pwhe_intf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pwhe_intf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pwhe-intf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pwhe-intf"):
                                self.pwhe_intf = value
                                self.pwhe_intf.value_namespace = name_space
                                self.pwhe_intf.value_namespace_prefix = name_space_prefix


                    class TpData(Entity):
                        """
                        TP context
                        
                        .. attribute:: dest_global_id
                        
                        	TP destination global ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: dest_node_id
                        
                        	TP destination node ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: dest_tunnel_id
                        
                        	TP destination tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsp_id
                        
                        	TP LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: source_global_id
                        
                        	TP source global ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: source_node_id
                        
                        	TP source node ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: source_tunnel_id
                        
                        	TP source tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.TpData, self).__init__()

                            self.yang_name = "tp-data"
                            self.yang_parent_name = "key"

                            self.dest_global_id = YLeaf(YType.uint32, "dest-global-id")

                            self.dest_node_id = YLeaf(YType.str, "dest-node-id")

                            self.dest_tunnel_id = YLeaf(YType.uint16, "dest-tunnel-id")

                            self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                            self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                            self.source_node_id = YLeaf(YType.str, "source-node-id")

                            self.source_tunnel_id = YLeaf(YType.uint16, "source-tunnel-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("dest_global_id",
                                            "dest_node_id",
                                            "dest_tunnel_id",
                                            "lsp_id",
                                            "source_global_id",
                                            "source_node_id",
                                            "source_tunnel_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.TpData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.TpData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.dest_global_id.is_set or
                                self.dest_node_id.is_set or
                                self.dest_tunnel_id.is_set or
                                self.lsp_id.is_set or
                                self.source_global_id.is_set or
                                self.source_node_id.is_set or
                                self.source_tunnel_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.dest_global_id.yfilter != YFilter.not_set or
                                self.dest_node_id.yfilter != YFilter.not_set or
                                self.dest_tunnel_id.yfilter != YFilter.not_set or
                                self.lsp_id.yfilter != YFilter.not_set or
                                self.source_global_id.yfilter != YFilter.not_set or
                                self.source_node_id.yfilter != YFilter.not_set or
                                self.source_tunnel_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tp-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.dest_global_id.is_set or self.dest_global_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dest_global_id.get_name_leafdata())
                            if (self.dest_node_id.is_set or self.dest_node_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dest_node_id.get_name_leafdata())
                            if (self.dest_tunnel_id.is_set or self.dest_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dest_tunnel_id.get_name_leafdata())
                            if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_id.get_name_leafdata())
                            if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.source_global_id.get_name_leafdata())
                            if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.source_node_id.get_name_leafdata())
                            if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "dest-global-id" or name == "dest-node-id" or name == "dest-tunnel-id" or name == "lsp-id" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "dest-global-id"):
                                self.dest_global_id = value
                                self.dest_global_id.value_namespace = name_space
                                self.dest_global_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "dest-node-id"):
                                self.dest_node_id = value
                                self.dest_node_id.value_namespace = name_space
                                self.dest_node_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "dest-tunnel-id"):
                                self.dest_tunnel_id = value
                                self.dest_tunnel_id.value_namespace = name_space
                                self.dest_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-id"):
                                self.lsp_id = value
                                self.lsp_id.value_namespace = name_space
                                self.lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "source-global-id"):
                                self.source_global_id = value
                                self.source_global_id.value_namespace = name_space
                                self.source_global_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "source-node-id"):
                                self.source_node_id = value
                                self.source_node_id.value_namespace = name_space
                                self.source_node_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "source-tunnel-id"):
                                self.source_tunnel_id = value
                                self.source_tunnel_id.value_namespace = name_space
                                self.source_tunnel_id.value_namespace_prefix = name_space_prefix


                    class GenericRoutingEncapsulation(Entity):
                        """
                        Generic routing encapsulation context
                        
                        .. attribute:: gre_interface
                        
                        	Generic routing encapsulation interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.GenericRoutingEncapsulation, self).__init__()

                            self.yang_name = "generic-routing-encapsulation"
                            self.yang_parent_name = "key"

                            self.gre_interface = YLeaf(YType.str, "gre-interface")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("gre_interface") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.GenericRoutingEncapsulation, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.GenericRoutingEncapsulation, self).__setattr__(name, value)

                        def has_data(self):
                            return self.gre_interface.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.gre_interface.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "generic-routing-encapsulation" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.gre_interface.is_set or self.gre_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.gre_interface.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "gre-interface"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "gre-interface"):
                                self.gre_interface = value
                                self.gre_interface.value_namespace = name_space
                                self.gre_interface.value_namespace_prefix = name_space_prefix


                    class Ipv6GenericRoutingEncapsulation(Entity):
                        """
                        Generic routing encapsulation context
                        
                        .. attribute:: greipv6_interface
                        
                        	Generic routing encapsulation IPv6 interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.Ipv6GenericRoutingEncapsulation, self).__init__()

                            self.yang_name = "ipv6-generic-routing-encapsulation"
                            self.yang_parent_name = "key"

                            self.greipv6_interface = YLeaf(YType.str, "greipv6-interface")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("greipv6_interface") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)

                        def has_data(self):
                            return self.greipv6_interface.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.greipv6_interface.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ipv6-generic-routing-encapsulation" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.greipv6_interface.is_set or self.greipv6_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.greipv6_interface.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "greipv6-interface"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "greipv6-interface"):
                                self.greipv6_interface = value
                                self.greipv6_interface.value_namespace = name_space
                                self.greipv6_interface.value_namespace_prefix = name_space_prefix


                    class EvpnData(Entity):
                        """
                        EVPN context
                        
                        .. attribute:: ethernet_segment
                        
                        	Ethernet Segment ID
                        	**type**\:  str
                        
                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                        
                        .. attribute:: evpn_id
                        
                        	EVPN ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: evpn_tag
                        
                        	EVPN TAG
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.EvpnData, self).__init__()

                            self.yang_name = "evpn-data"
                            self.yang_parent_name = "key"

                            self.ethernet_segment = YLeaf(YType.str, "ethernet-segment")

                            self.evpn_id = YLeaf(YType.uint32, "evpn-id")

                            self.evpn_tag = YLeaf(YType.uint32, "evpn-tag")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ethernet_segment",
                                            "evpn_id",
                                            "evpn_tag") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.EvpnData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.EvpnData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.ethernet_segment.is_set or
                                self.evpn_id.is_set or
                                self.evpn_tag.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ethernet_segment.yfilter != YFilter.not_set or
                                self.evpn_id.yfilter != YFilter.not_set or
                                self.evpn_tag.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "evpn-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ethernet_segment.is_set or self.ethernet_segment.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ethernet_segment.get_name_leafdata())
                            if (self.evpn_id.is_set or self.evpn_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.evpn_id.get_name_leafdata())
                            if (self.evpn_tag.is_set or self.evpn_tag.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.evpn_tag.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ethernet-segment" or name == "evpn-id" or name == "evpn-tag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ethernet-segment"):
                                self.ethernet_segment = value
                                self.ethernet_segment.value_namespace = name_space
                                self.ethernet_segment.value_namespace_prefix = name_space_prefix
                            if(value_path == "evpn-id"):
                                self.evpn_id = value
                                self.evpn_id.value_namespace = name_space
                                self.evpn_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "evpn-tag"):
                                self.evpn_tag = value
                                self.evpn_tag.value_namespace = name_space
                                self.evpn_tag.value_namespace_prefix = name_space_prefix


                    class Ipv4BlbData(Entity):
                        """
                        BFD BLB label context
                        
                        .. attribute:: blb_intf
                        
                        	BFD BLB interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: prefix
                        
                        	IPv4 prefix
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.Ipv4BlbData, self).__init__()

                            self.yang_name = "ipv4blb-data"
                            self.yang_parent_name = "key"

                            self.blb_intf = YLeaf(YType.str, "blb-intf")

                            self.prefix = YLeaf(YType.str, "prefix")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("blb_intf",
                                            "prefix") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.Ipv4BlbData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.Ipv4BlbData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.blb_intf.is_set or
                                self.prefix.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.blb_intf.yfilter != YFilter.not_set or
                                self.prefix.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ipv4blb-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.blb_intf.get_name_leafdata())
                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "blb-intf" or name == "prefix"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "blb-intf"):
                                self.blb_intf = value
                                self.blb_intf.value_namespace = name_space
                                self.blb_intf.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix"):
                                self.prefix = value
                                self.prefix.value_namespace = name_space
                                self.prefix.value_namespace_prefix = name_space_prefix


                    class Ipv6BlbData(Entity):
                        """
                        BFD BLB label context
                        
                        .. attribute:: blb_intf
                        
                        	BFD BLB interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: prefix
                        
                        	IPv6 prefix
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.Ipv6BlbData, self).__init__()

                            self.yang_name = "ipv6blb-data"
                            self.yang_parent_name = "key"

                            self.blb_intf = YLeaf(YType.str, "blb-intf")

                            self.prefix = YLeaf(YType.str, "prefix")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("blb_intf",
                                            "prefix") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.Ipv6BlbData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.Ipv6BlbData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.blb_intf.is_set or
                                self.prefix.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.blb_intf.yfilter != YFilter.not_set or
                                self.prefix.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ipv6blb-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.blb_intf.get_name_leafdata())
                            if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "blb-intf" or name == "prefix"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "blb-intf"):
                                self.blb_intf = value
                                self.blb_intf.value_namespace = name_space
                                self.blb_intf.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix"):
                                self.prefix = value
                                self.prefix.value_namespace = name_space
                                self.prefix.value_namespace_prefix = name_space_prefix


                    class PiMiPmsiData(Entity):
                        """
                        PIM I\-PMSI label conext
                        
                        .. attribute:: head
                        
                        	Head
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: v6
                        
                        	PIM6
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: vrf_id
                        
                        	VRF ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.PiMiPmsiData, self).__init__()

                            self.yang_name = "pi-mi-pmsi-data"
                            self.yang_parent_name = "key"

                            self.head = YLeaf(YType.int32, "head")

                            self.v6 = YLeaf(YType.int32, "v6")

                            self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("head",
                                            "v6",
                                            "vrf_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.PiMiPmsiData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.PiMiPmsiData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.head.is_set or
                                self.v6.is_set or
                                self.vrf_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.head.yfilter != YFilter.not_set or
                                self.v6.yfilter != YFilter.not_set or
                                self.vrf_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "pi-mi-pmsi-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.head.get_name_leafdata())
                            if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.v6.get_name_leafdata())
                            if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vrf_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "head" or name == "v6" or name == "vrf-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "head"):
                                self.head = value
                                self.head.value_namespace = name_space
                                self.head.value_namespace_prefix = name_space_prefix
                            if(value_path == "v6"):
                                self.v6 = value
                                self.v6.value_namespace = name_space
                                self.v6.value_namespace_prefix = name_space_prefix
                            if(value_path == "vrf-id"):
                                self.vrf_id = value
                                self.vrf_id.value_namespace = name_space
                                self.vrf_id.value_namespace_prefix = name_space_prefix


                    class PiMsPmsiData(Entity):
                        """
                        PIM S\-PMSI label conext
                        
                        .. attribute:: head
                        
                        	Head
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: hli
                        
                        	Head LSM\-ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: seg
                        
                        	Segmented Multicast
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: source
                        
                        	Originating Router
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: v6
                        
                        	PIM6
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: vrf_id
                        
                        	VRF ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.PiMsPmsiData, self).__init__()

                            self.yang_name = "pi-ms-pmsi-data"
                            self.yang_parent_name = "key"

                            self.head = YLeaf(YType.int32, "head")

                            self.hli = YLeaf(YType.uint32, "hli")

                            self.seg = YLeaf(YType.int32, "seg")

                            self.source = YLeaf(YType.str, "source")

                            self.v6 = YLeaf(YType.int32, "v6")

                            self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("head",
                                            "hli",
                                            "seg",
                                            "source",
                                            "v6",
                                            "vrf_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.PiMsPmsiData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.PiMsPmsiData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.head.is_set or
                                self.hli.is_set or
                                self.seg.is_set or
                                self.source.is_set or
                                self.v6.is_set or
                                self.vrf_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.head.yfilter != YFilter.not_set or
                                self.hli.yfilter != YFilter.not_set or
                                self.seg.yfilter != YFilter.not_set or
                                self.source.yfilter != YFilter.not_set or
                                self.v6.yfilter != YFilter.not_set or
                                self.vrf_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "pi-ms-pmsi-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.head.get_name_leafdata())
                            if (self.hli.is_set or self.hli.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hli.get_name_leafdata())
                            if (self.seg.is_set or self.seg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.seg.get_name_leafdata())
                            if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.source.get_name_leafdata())
                            if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.v6.get_name_leafdata())
                            if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vrf_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "head" or name == "hli" or name == "seg" or name == "source" or name == "v6" or name == "vrf-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "head"):
                                self.head = value
                                self.head.value_namespace = name_space
                                self.head.value_namespace_prefix = name_space_prefix
                            if(value_path == "hli"):
                                self.hli = value
                                self.hli.value_namespace = name_space
                                self.hli.value_namespace_prefix = name_space_prefix
                            if(value_path == "seg"):
                                self.seg = value
                                self.seg.value_namespace = name_space
                                self.seg.value_namespace_prefix = name_space_prefix
                            if(value_path == "source"):
                                self.source = value
                                self.source.value_namespace = name_space
                                self.source.value_namespace_prefix = name_space_prefix
                            if(value_path == "v6"):
                                self.v6 = value
                                self.v6.value_namespace = name_space
                                self.v6.value_namespace_prefix = name_space_prefix
                            if(value_path == "vrf-id"):
                                self.vrf_id = value
                                self.vrf_id.value_namespace = name_space
                                self.vrf_id.value_namespace_prefix = name_space_prefix


                    class NextHopSetL3Vpn(Entity):
                        """
                        L3VPN NH SET label context
                        
                        .. attribute:: next_hop_set_id
                        
                        	Next Hop Set ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.NextHopSetL3Vpn, self).__init__()

                            self.yang_name = "next-hop-set-l3vpn"
                            self.yang_parent_name = "key"

                            self.next_hop_set_id = YLeaf(YType.uint32, "next-hop-set-id")

                            self.table_id = YLeaf(YType.uint32, "table-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("next_hop_set_id",
                                            "table_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.NextHopSetL3Vpn, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.NextHopSetL3Vpn, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.next_hop_set_id.is_set or
                                self.table_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.next_hop_set_id.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "next-hop-set-l3vpn" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.next_hop_set_id.is_set or self.next_hop_set_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_set_id.get_name_leafdata())
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "next-hop-set-id" or name == "table-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "next-hop-set-id"):
                                self.next_hop_set_id = value
                                self.next_hop_set_id.value_namespace = name_space
                                self.next_hop_set_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix


                    class SrPrefixSegment(Entity):
                        """
                        SR Prefix Segment context
                        
                        .. attribute:: segment_id
                        
                        	Prefix Segment ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: table_id
                        
                        	Table ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.SrPrefixSegment, self).__init__()

                            self.yang_name = "sr-prefix-segment"
                            self.yang_parent_name = "key"

                            self.segment_id = YLeaf(YType.uint32, "segment-id")

                            self.table_id = YLeaf(YType.uint32, "table-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("segment_id",
                                            "table_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.SrPrefixSegment, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.SrPrefixSegment, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.segment_id.is_set or
                                self.table_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.segment_id.yfilter != YFilter.not_set or
                                self.table_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sr-prefix-segment" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id.get_name_leafdata())
                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.table_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "segment-id" or name == "table-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "segment-id"):
                                self.segment_id = value
                                self.segment_id.value_namespace = name_space
                                self.segment_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "table-id"):
                                self.table_id = value
                                self.table_id.value_namespace = name_space
                                self.table_id.value_namespace_prefix = name_space_prefix


                    class SrAdjSegmentIpv4(Entity):
                        """
                        SR Adj Segment ipv4 context
                        
                        .. attribute:: addr
                        
                        	Adjacency nexthop IPv4 address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: index
                        
                        	Adjacency index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: intf
                        
                        	Adjacency interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: type
                        
                        	Adjacency type
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.SrAdjSegmentIpv4, self).__init__()

                            self.yang_name = "sr-adj-segment-ipv4"
                            self.yang_parent_name = "key"

                            self.addr = YLeaf(YType.str, "addr")

                            self.index = YLeaf(YType.uint32, "index")

                            self.intf = YLeaf(YType.str, "intf")

                            self.type = YLeaf(YType.uint32, "type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("addr",
                                            "index",
                                            "intf",
                                            "type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.SrAdjSegmentIpv4, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.SrAdjSegmentIpv4, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.addr.is_set or
                                self.index.is_set or
                                self.intf.is_set or
                                self.type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.addr.yfilter != YFilter.not_set or
                                self.index.yfilter != YFilter.not_set or
                                self.intf.yfilter != YFilter.not_set or
                                self.type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sr-adj-segment-ipv4" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.addr.get_name_leafdata())
                            if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.index.get_name_leafdata())
                            if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.intf.get_name_leafdata())
                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "addr"):
                                self.addr = value
                                self.addr.value_namespace = name_space
                                self.addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "index"):
                                self.index = value
                                self.index.value_namespace = name_space
                                self.index.value_namespace_prefix = name_space_prefix
                            if(value_path == "intf"):
                                self.intf = value
                                self.intf.value_namespace = name_space
                                self.intf.value_namespace_prefix = name_space_prefix
                            if(value_path == "type"):
                                self.type = value
                                self.type.value_namespace = name_space
                                self.type.value_namespace_prefix = name_space_prefix


                    class SrAdjSegmentIpv6(Entity):
                        """
                        SR Adj Segment ipv6 context
                        
                        .. attribute:: addr
                        
                        	Adjacency nexthop IPv6 address
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: index
                        
                        	Adjacency index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: intf
                        
                        	Adjacency interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: type
                        
                        	Adjacency type
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.SrAdjSegmentIpv6, self).__init__()

                            self.yang_name = "sr-adj-segment-ipv6"
                            self.yang_parent_name = "key"

                            self.addr = YLeaf(YType.str, "addr")

                            self.index = YLeaf(YType.uint32, "index")

                            self.intf = YLeaf(YType.str, "intf")

                            self.type = YLeaf(YType.uint32, "type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("addr",
                                            "index",
                                            "intf",
                                            "type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.SrAdjSegmentIpv6, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.SrAdjSegmentIpv6, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.addr.is_set or
                                self.index.is_set or
                                self.intf.is_set or
                                self.type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.addr.yfilter != YFilter.not_set or
                                self.index.yfilter != YFilter.not_set or
                                self.intf.yfilter != YFilter.not_set or
                                self.type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sr-adj-segment-ipv6" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.addr.get_name_leafdata())
                            if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.index.get_name_leafdata())
                            if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.intf.get_name_leafdata())
                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "addr"):
                                self.addr = value
                                self.addr.value_namespace = name_space
                                self.addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "index"):
                                self.index = value
                                self.index.value_namespace = name_space
                                self.index.value_namespace_prefix = name_space_prefix
                            if(value_path == "intf"):
                                self.intf = value
                                self.intf.value_namespace = name_space
                                self.intf.value_namespace_prefix = name_space_prefix
                            if(value_path == "type"):
                                self.type = value
                                self.type.value_namespace = name_space
                                self.type.value_namespace_prefix = name_space_prefix


                    class LabelBlockSrgbData(Entity):
                        """
                        Label block SRGB context
                        
                        .. attribute:: offset
                        
                        	Offset
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: size
                        
                        	Number of labels
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: start_label
                        
                        	Start Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.LabelBlockSrgbData, self).__init__()

                            self.yang_name = "label-block-srgb-data"
                            self.yang_parent_name = "key"

                            self.offset = YLeaf(YType.uint32, "offset")

                            self.size = YLeaf(YType.uint32, "size")

                            self.start_label = YLeaf(YType.uint32, "start-label")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("offset",
                                            "size",
                                            "start_label") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.LabelBlockSrgbData, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.LabelBlockSrgbData, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.offset.is_set or
                                self.size.is_set or
                                self.start_label.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.offset.yfilter != YFilter.not_set or
                                self.size.yfilter != YFilter.not_set or
                                self.start_label.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "label-block-srgb-data" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.offset.get_name_leafdata())
                            if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.size.get_name_leafdata())
                            if (self.start_label.is_set or self.start_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.start_label.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "offset" or name == "size" or name == "start-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "offset"):
                                self.offset = value
                                self.offset.value_namespace = name_space
                                self.offset.value_namespace_prefix = name_space_prefix
                            if(value_path == "size"):
                                self.size = value
                                self.size.value_namespace = name_space
                                self.size.value_namespace_prefix = name_space_prefix
                            if(value_path == "start-label"):
                                self.start_label = value
                                self.start_label.value_namespace = name_space
                                self.start_label.value_namespace_prefix = name_space_prefix


                    class TeBinding(Entity):
                        """
                        MPLS TE tunnel binding context
                        
                        .. attribute:: te_identifier
                        
                        	MPLS Traffic Engineering Tunnel or Group ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: te_type
                        
                        	Type of identifier for the binding
                        	**type**\:   :py:class:`MgmtLsdTeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdTeBinding>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Labels.Label.LabelContext.Key.TeBinding, self).__init__()

                            self.yang_name = "te-binding"
                            self.yang_parent_name = "key"

                            self.te_identifier = YLeaf(YType.uint32, "te-identifier")

                            self.te_type = YLeaf(YType.enumeration, "te-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("te_identifier",
                                            "te_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Labels.Label.LabelContext.Key.TeBinding, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Labels.Label.LabelContext.Key.TeBinding, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.te_identifier.is_set or
                                self.te_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.te_identifier.yfilter != YFilter.not_set or
                                self.te_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "te-binding" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.te_identifier.is_set or self.te_identifier.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.te_identifier.get_name_leafdata())
                            if (self.te_type.is_set or self.te_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.te_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "te-identifier" or name == "te-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "te-identifier"):
                                self.te_identifier = value
                                self.te_identifier.value_namespace = name_space
                                self.te_identifier.value_namespace_prefix = name_space_prefix
                            if(value_path == "te-type"):
                                self.te_type = value
                                self.te_type.value_namespace = name_space
                                self.te_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.label_context_type.is_set or
                            (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_data()) or
                            (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_data()) or
                            (self.evpn_data is not None and self.evpn_data.has_data()) or
                            (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_data()) or
                            (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                            (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                            (self.ipv4blb_data is not None and self.ipv4blb_data.has_data()) or
                            (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_data()) or
                            (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                            (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_data()) or
                            (self.ipv6blb_data is not None and self.ipv6blb_data.has_data()) or
                            (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_data()) or
                            (self.label_block_data is not None and self.label_block_data.has_data()) or
                            (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_data()) or
                            (self.mld_pv4_data is not None and self.mld_pv4_data.has_data()) or
                            (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_data()) or
                            (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_data()) or
                            (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_data()) or
                            (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                            (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                            (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_data()) or
                            (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_data()) or
                            (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_data()) or
                            (self.te_binding is not None and self.te_binding.has_data()) or
                            (self.tev4_data is not None and self.tev4_data.has_data()) or
                            (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_data()) or
                            (self.tp_data is not None and self.tp_data.has_data()) or
                            (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.label_context_type.yfilter != YFilter.not_set or
                            (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_operation()) or
                            (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_operation()) or
                            (self.evpn_data is not None and self.evpn_data.has_operation()) or
                            (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_operation()) or
                            (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                            (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                            (self.ipv4blb_data is not None and self.ipv4blb_data.has_operation()) or
                            (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_operation()) or
                            (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                            (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_operation()) or
                            (self.ipv6blb_data is not None and self.ipv6blb_data.has_operation()) or
                            (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_operation()) or
                            (self.label_block_data is not None and self.label_block_data.has_operation()) or
                            (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_operation()) or
                            (self.mld_pv4_data is not None and self.mld_pv4_data.has_operation()) or
                            (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_operation()) or
                            (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_operation()) or
                            (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_operation()) or
                            (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                            (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                            (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_operation()) or
                            (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_operation()) or
                            (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_operation()) or
                            (self.te_binding is not None and self.te_binding.has_operation()) or
                            (self.tev4_data is not None and self.tev4_data.has_operation()) or
                            (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_operation()) or
                            (self.tp_data is not None and self.tp_data.has_operation()) or
                            (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "key" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.label_context_type.is_set or self.label_context_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.label_context_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "cev4l3vpn-data"):
                            if (self.cev4l3vpn_data is None):
                                self.cev4l3vpn_data = MplsLsd.Labels.Label.LabelContext.Key.Cev4L3VpnData()
                                self.cev4l3vpn_data.parent = self
                                self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                            return self.cev4l3vpn_data

                        if (child_yang_name == "cev6l3vpn-data"):
                            if (self.cev6l3vpn_data is None):
                                self.cev6l3vpn_data = MplsLsd.Labels.Label.LabelContext.Key.Cev6L3VpnData()
                                self.cev6l3vpn_data.parent = self
                                self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                            return self.cev6l3vpn_data

                        if (child_yang_name == "evpn-data"):
                            if (self.evpn_data is None):
                                self.evpn_data = MplsLsd.Labels.Label.LabelContext.Key.EvpnData()
                                self.evpn_data.parent = self
                                self._children_name_map["evpn_data"] = "evpn-data"
                            return self.evpn_data

                        if (child_yang_name == "generic-routing-encapsulation"):
                            if (self.generic_routing_encapsulation is None):
                                self.generic_routing_encapsulation = MplsLsd.Labels.Label.LabelContext.Key.GenericRoutingEncapsulation()
                                self.generic_routing_encapsulation.parent = self
                                self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                            return self.generic_routing_encapsulation

                        if (child_yang_name == "ip-sub-data"):
                            if (self.ip_sub_data is None):
                                self.ip_sub_data = MplsLsd.Labels.Label.LabelContext.Key.IpSubData()
                                self.ip_sub_data.parent = self
                                self._children_name_map["ip_sub_data"] = "ip-sub-data"
                            return self.ip_sub_data

                        if (child_yang_name == "ipv4-data"):
                            if (self.ipv4_data is None):
                                self.ipv4_data = MplsLsd.Labels.Label.LabelContext.Key.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                            return self.ipv4_data

                        if (child_yang_name == "ipv4blb-data"):
                            if (self.ipv4blb_data is None):
                                self.ipv4blb_data = MplsLsd.Labels.Label.LabelContext.Key.Ipv4BlbData()
                                self.ipv4blb_data.parent = self
                                self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                            return self.ipv4blb_data

                        if (child_yang_name == "ipv4l3vpn-data"):
                            if (self.ipv4l3vpn_data is None):
                                self.ipv4l3vpn_data = MplsLsd.Labels.Label.LabelContext.Key.Ipv4L3VpnData()
                                self.ipv4l3vpn_data.parent = self
                                self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                            return self.ipv4l3vpn_data

                        if (child_yang_name == "ipv6-data"):
                            if (self.ipv6_data is None):
                                self.ipv6_data = MplsLsd.Labels.Label.LabelContext.Key.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                            return self.ipv6_data

                        if (child_yang_name == "ipv6-generic-routing-encapsulation"):
                            if (self.ipv6_generic_routing_encapsulation is None):
                                self.ipv6_generic_routing_encapsulation = MplsLsd.Labels.Label.LabelContext.Key.Ipv6GenericRoutingEncapsulation()
                                self.ipv6_generic_routing_encapsulation.parent = self
                                self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                            return self.ipv6_generic_routing_encapsulation

                        if (child_yang_name == "ipv6blb-data"):
                            if (self.ipv6blb_data is None):
                                self.ipv6blb_data = MplsLsd.Labels.Label.LabelContext.Key.Ipv6BlbData()
                                self.ipv6blb_data.parent = self
                                self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                            return self.ipv6blb_data

                        if (child_yang_name == "ipv6l3vpn-data"):
                            if (self.ipv6l3vpn_data is None):
                                self.ipv6l3vpn_data = MplsLsd.Labels.Label.LabelContext.Key.Ipv6L3VpnData()
                                self.ipv6l3vpn_data.parent = self
                                self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                            return self.ipv6l3vpn_data

                        if (child_yang_name == "label-block-data"):
                            if (self.label_block_data is None):
                                self.label_block_data = MplsLsd.Labels.Label.LabelContext.Key.LabelBlockData()
                                self.label_block_data.parent = self
                                self._children_name_map["label_block_data"] = "label-block-data"
                            return self.label_block_data

                        if (child_yang_name == "label-block-srgb-data"):
                            if (self.label_block_srgb_data is None):
                                self.label_block_srgb_data = MplsLsd.Labels.Label.LabelContext.Key.LabelBlockSrgbData()
                                self.label_block_srgb_data.parent = self
                                self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                            return self.label_block_srgb_data

                        if (child_yang_name == "mld-pv4-data"):
                            if (self.mld_pv4_data is None):
                                self.mld_pv4_data = MplsLsd.Labels.Label.LabelContext.Key.MldPv4Data()
                                self.mld_pv4_data.parent = self
                                self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                            return self.mld_pv4_data

                        if (child_yang_name == "next-hop-set-l3vpn"):
                            if (self.next_hop_set_l3vpn is None):
                                self.next_hop_set_l3vpn = MplsLsd.Labels.Label.LabelContext.Key.NextHopSetL3Vpn()
                                self.next_hop_set_l3vpn.parent = self
                                self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                            return self.next_hop_set_l3vpn

                        if (child_yang_name == "pi-mi-pmsi-data"):
                            if (self.pi_mi_pmsi_data is None):
                                self.pi_mi_pmsi_data = MplsLsd.Labels.Label.LabelContext.Key.PiMiPmsiData()
                                self.pi_mi_pmsi_data.parent = self
                                self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                            return self.pi_mi_pmsi_data

                        if (child_yang_name == "pi-ms-pmsi-data"):
                            if (self.pi_ms_pmsi_data is None):
                                self.pi_ms_pmsi_data = MplsLsd.Labels.Label.LabelContext.Key.PiMsPmsiData()
                                self.pi_ms_pmsi_data.parent = self
                                self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                            return self.pi_ms_pmsi_data

                        if (child_yang_name == "pseudowire-data"):
                            if (self.pseudowire_data is None):
                                self.pseudowire_data = MplsLsd.Labels.Label.LabelContext.Key.PseudowireData()
                                self.pseudowire_data.parent = self
                                self._children_name_map["pseudowire_data"] = "pseudowire-data"
                            return self.pseudowire_data

                        if (child_yang_name == "pseudowire-head-end-data"):
                            if (self.pseudowire_head_end_data is None):
                                self.pseudowire_head_end_data = MplsLsd.Labels.Label.LabelContext.Key.PseudowireHeadEndData()
                                self.pseudowire_head_end_data.parent = self
                                self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                            return self.pseudowire_head_end_data

                        if (child_yang_name == "sr-adj-segment-ipv4"):
                            if (self.sr_adj_segment_ipv4 is None):
                                self.sr_adj_segment_ipv4 = MplsLsd.Labels.Label.LabelContext.Key.SrAdjSegmentIpv4()
                                self.sr_adj_segment_ipv4.parent = self
                                self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                            return self.sr_adj_segment_ipv4

                        if (child_yang_name == "sr-adj-segment-ipv6"):
                            if (self.sr_adj_segment_ipv6 is None):
                                self.sr_adj_segment_ipv6 = MplsLsd.Labels.Label.LabelContext.Key.SrAdjSegmentIpv6()
                                self.sr_adj_segment_ipv6.parent = self
                                self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                            return self.sr_adj_segment_ipv6

                        if (child_yang_name == "sr-prefix-segment"):
                            if (self.sr_prefix_segment is None):
                                self.sr_prefix_segment = MplsLsd.Labels.Label.LabelContext.Key.SrPrefixSegment()
                                self.sr_prefix_segment.parent = self
                                self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                            return self.sr_prefix_segment

                        if (child_yang_name == "te-binding"):
                            if (self.te_binding is None):
                                self.te_binding = MplsLsd.Labels.Label.LabelContext.Key.TeBinding()
                                self.te_binding.parent = self
                                self._children_name_map["te_binding"] = "te-binding"
                            return self.te_binding

                        if (child_yang_name == "tev4-data"):
                            if (self.tev4_data is None):
                                self.tev4_data = MplsLsd.Labels.Label.LabelContext.Key.Tev4Data()
                                self.tev4_data.parent = self
                                self._children_name_map["tev4_data"] = "tev4-data"
                            return self.tev4_data

                        if (child_yang_name == "tev4p2mp-data"):
                            if (self.tev4p2mp_data is None):
                                self.tev4p2mp_data = MplsLsd.Labels.Label.LabelContext.Key.Tev4P2MpData()
                                self.tev4p2mp_data.parent = self
                                self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                            return self.tev4p2mp_data

                        if (child_yang_name == "tp-data"):
                            if (self.tp_data is None):
                                self.tp_data = MplsLsd.Labels.Label.LabelContext.Key.TpData()
                                self.tp_data.parent = self
                                self._children_name_map["tp_data"] = "tp-data"
                            return self.tp_data

                        if (child_yang_name == "vrf-l3vpn-data"):
                            if (self.vrf_l3vpn_data is None):
                                self.vrf_l3vpn_data = MplsLsd.Labels.Label.LabelContext.Key.VrfL3VpnData()
                                self.vrf_l3vpn_data.parent = self
                                self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                            return self.vrf_l3vpn_data

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "cev4l3vpn-data" or name == "cev6l3vpn-data" or name == "evpn-data" or name == "generic-routing-encapsulation" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv4blb-data" or name == "ipv4l3vpn-data" or name == "ipv6-data" or name == "ipv6-generic-routing-encapsulation" or name == "ipv6blb-data" or name == "ipv6l3vpn-data" or name == "label-block-data" or name == "label-block-srgb-data" or name == "mld-pv4-data" or name == "next-hop-set-l3vpn" or name == "pi-mi-pmsi-data" or name == "pi-ms-pmsi-data" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "sr-adj-segment-ipv4" or name == "sr-adj-segment-ipv6" or name == "sr-prefix-segment" or name == "te-binding" or name == "tev4-data" or name == "tev4p2mp-data" or name == "tp-data" or name == "vrf-l3vpn-data" or name == "label-context-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "label-context-type"):
                            self.label_context_type = value
                            self.label_context_type.value_namespace = name_space
                            self.label_context_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.application_data.is_set or
                        (self.key is not None and self.key.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.application_data.yfilter != YFilter.not_set or
                        (self.key is not None and self.key.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "label-context" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.application_data.is_set or self.application_data.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_data.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "key"):
                        if (self.key is None):
                            self.key = MplsLsd.Labels.Label.LabelContext.Key()
                            self.key.parent = self
                            self._children_name_map["key"] = "key"
                        return self.key

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "key" or name == "application-data"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "application-data"):
                        self.application_data = value
                        self.application_data.value_namespace = name_space
                        self.application_data.value_namespace_prefix = name_space_prefix


            class ApplicationOwner(Entity):
                """
                Application owner
                
                .. attribute:: application_instance
                
                	Application instance Name
                	**type**\:  str
                
                .. attribute:: application_name
                
                	Application name
                	**type**\:  str
                
                .. attribute:: application_role_primary
                
                	Primary/Backup role
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: application_type
                
                	Application type
                	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                
                .. attribute:: resource_state
                
                	Application resource state
                	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.Labels.Label.ApplicationOwner, self).__init__()

                    self.yang_name = "application-owner"
                    self.yang_parent_name = "label"

                    self.application_instance = YLeaf(YType.str, "application-instance")

                    self.application_name = YLeaf(YType.str, "application-name")

                    self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                    self.application_type = YLeaf(YType.enumeration, "application-type")

                    self.resource_state = YLeaf(YType.enumeration, "resource-state")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("application_instance",
                                    "application_name",
                                    "application_role_primary",
                                    "application_type",
                                    "resource_state") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.Labels.Label.ApplicationOwner, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.Labels.Label.ApplicationOwner, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.application_instance.is_set or
                        self.application_name.is_set or
                        self.application_role_primary.is_set or
                        self.application_type.is_set or
                        self.resource_state.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.application_instance.yfilter != YFilter.not_set or
                        self.application_name.yfilter != YFilter.not_set or
                        self.application_role_primary.yfilter != YFilter.not_set or
                        self.application_type.yfilter != YFilter.not_set or
                        self.resource_state.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "application-owner" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_instance.get_name_leafdata())
                    if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_name.get_name_leafdata())
                    if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                    if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_type.get_name_leafdata())
                    if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.resource_state.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "application-instance"):
                        self.application_instance = value
                        self.application_instance.value_namespace = name_space
                        self.application_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-name"):
                        self.application_name = value
                        self.application_name.value_namespace = name_space
                        self.application_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-role-primary"):
                        self.application_role_primary = value
                        self.application_role_primary.value_namespace = name_space
                        self.application_role_primary.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-type"):
                        self.application_type = value
                        self.application_type.value_namespace = name_space
                        self.application_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "resource-state"):
                        self.resource_state = value
                        self.resource_state.value_namespace = name_space
                        self.resource_state.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.application_owner:
                    if (c.has_data()):
                        return True
                return (
                    self.label_id.is_set or
                    self.label.is_set or
                    self.rewrite_is_bound.is_set or
                    self.rewrite_owners.is_set or
                    self.rs_iconnected.is_set or
                    self.vrf_name.is_set or
                    (self.label_context is not None and self.label_context.has_data()))

            def has_operation(self):
                for c in self.application_owner:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.label_id.yfilter != YFilter.not_set or
                    self.label.yfilter != YFilter.not_set or
                    self.rewrite_is_bound.yfilter != YFilter.not_set or
                    self.rewrite_owners.yfilter != YFilter.not_set or
                    self.rs_iconnected.yfilter != YFilter.not_set or
                    self.vrf_name.yfilter != YFilter.not_set or
                    (self.label_context is not None and self.label_context.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "label" + "[label-id='" + self.label_id.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/labels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.label_id.is_set or self.label_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.label_id.get_name_leafdata())
                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.label.get_name_leafdata())
                if (self.rewrite_is_bound.is_set or self.rewrite_is_bound.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rewrite_is_bound.get_name_leafdata())
                if (self.rewrite_owners.is_set or self.rewrite_owners.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rewrite_owners.get_name_leafdata())
                if (self.rs_iconnected.is_set or self.rs_iconnected.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rs_iconnected.get_name_leafdata())
                if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.vrf_name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "application-owner"):
                    for c in self.application_owner:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsd.Labels.Label.ApplicationOwner()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.application_owner.append(c)
                    return c

                if (child_yang_name == "label-context"):
                    if (self.label_context is None):
                        self.label_context = MplsLsd.Labels.Label.LabelContext()
                        self.label_context.parent = self
                        self._children_name_map["label_context"] = "label-context"
                    return self.label_context

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "application-owner" or name == "label-context" or name == "label-id" or name == "label" or name == "rewrite-is-bound" or name == "rewrite-owners" or name == "rs-iconnected" or name == "vrf-name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "label-id"):
                    self.label_id = value
                    self.label_id.value_namespace = name_space
                    self.label_id.value_namespace_prefix = name_space_prefix
                if(value_path == "label"):
                    self.label = value
                    self.label.value_namespace = name_space
                    self.label.value_namespace_prefix = name_space_prefix
                if(value_path == "rewrite-is-bound"):
                    self.rewrite_is_bound = value
                    self.rewrite_is_bound.value_namespace = name_space
                    self.rewrite_is_bound.value_namespace_prefix = name_space_prefix
                if(value_path == "rewrite-owners"):
                    self.rewrite_owners = value
                    self.rewrite_owners.value_namespace = name_space
                    self.rewrite_owners.value_namespace_prefix = name_space_prefix
                if(value_path == "rs-iconnected"):
                    self.rs_iconnected = value
                    self.rs_iconnected.value_namespace = name_space
                    self.rs_iconnected.value_namespace_prefix = name_space_prefix
                if(value_path == "vrf-name"):
                    self.vrf_name = value
                    self.vrf_name.value_namespace = name_space
                    self.vrf_name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.label:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.label:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "labels" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "label"):
                for c in self.label:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLsd.Labels.Label()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.label.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "label"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class FrrDatabase(Entity):
        """
        FRR database
        
        .. attribute:: summary_protected_interfaces
        
        	Sumary table of Protected Interfaces
        	**type**\:   :py:class:`SummaryProtectedInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.SummaryProtectedInterfaces>`
        
        .. attribute:: tunnel_head_summary
        
        	Summary data for FRR database entry \- Tunnel head
        	**type**\:   :py:class:`TunnelHeadSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelHeadSummary>`
        
        .. attribute:: tunnel_heads
        
        	Table of FRR database entries \- Tunnel heads
        	**type**\:   :py:class:`TunnelHeads <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelHeads>`
        
        .. attribute:: tunnel_midpoint_summary
        
        	Summary data for FRR database entry \- Tunnel midpoint
        	**type**\:   :py:class:`TunnelMidpointSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelMidpointSummary>`
        
        .. attribute:: tunnel_midpoints
        
        	Table of FRR database entries \- Tunnel midpoints
        	**type**\:   :py:class:`TunnelMidpoints <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelMidpoints>`
        
        .. attribute:: tunnel_summary
        
        	Summary data for FRR database entry
        	**type**\:   :py:class:`TunnelSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelSummary>`
        
        

        """

        _prefix = 'mpls-lsd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLsd.FrrDatabase, self).__init__()

            self.yang_name = "frr-database"
            self.yang_parent_name = "mpls-lsd"

            self.summary_protected_interfaces = MplsLsd.FrrDatabase.SummaryProtectedInterfaces()
            self.summary_protected_interfaces.parent = self
            self._children_name_map["summary_protected_interfaces"] = "summary-protected-interfaces"
            self._children_yang_names.add("summary-protected-interfaces")

            self.tunnel_head_summary = MplsLsd.FrrDatabase.TunnelHeadSummary()
            self.tunnel_head_summary.parent = self
            self._children_name_map["tunnel_head_summary"] = "tunnel-head-summary"
            self._children_yang_names.add("tunnel-head-summary")

            self.tunnel_heads = MplsLsd.FrrDatabase.TunnelHeads()
            self.tunnel_heads.parent = self
            self._children_name_map["tunnel_heads"] = "tunnel-heads"
            self._children_yang_names.add("tunnel-heads")

            self.tunnel_midpoint_summary = MplsLsd.FrrDatabase.TunnelMidpointSummary()
            self.tunnel_midpoint_summary.parent = self
            self._children_name_map["tunnel_midpoint_summary"] = "tunnel-midpoint-summary"
            self._children_yang_names.add("tunnel-midpoint-summary")

            self.tunnel_midpoints = MplsLsd.FrrDatabase.TunnelMidpoints()
            self.tunnel_midpoints.parent = self
            self._children_name_map["tunnel_midpoints"] = "tunnel-midpoints"
            self._children_yang_names.add("tunnel-midpoints")

            self.tunnel_summary = MplsLsd.FrrDatabase.TunnelSummary()
            self.tunnel_summary.parent = self
            self._children_name_map["tunnel_summary"] = "tunnel-summary"
            self._children_yang_names.add("tunnel-summary")


        class TunnelMidpoints(Entity):
            """
            Table of FRR database entries \- Tunnel
            midpoints
            
            .. attribute:: tunnel_midpoint
            
            	Data for FRR database entry \- Tunnel midpoint
            	**type**\: list of    :py:class:`TunnelMidpoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.FrrDatabase.TunnelMidpoints, self).__init__()

                self.yang_name = "tunnel-midpoints"
                self.yang_parent_name = "frr-database"

                self.tunnel_midpoint = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.FrrDatabase.TunnelMidpoints, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.FrrDatabase.TunnelMidpoints, self).__setattr__(name, value)


            class TunnelMidpoint(Entity):
                """
                Data for FRR database entry \- Tunnel midpoint
                
                .. attribute:: label  <key>
                
                	Label value
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: entry_frr_state
                
                	MPLS FRR entry state
                	**type**\:   :py:class:`MgmtLsdFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFrrState>`
                
                .. attribute:: frr_entry_id
                
                	FRR entry ID
                	**type**\:   :py:class:`FrrEntryId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId>`
                
                .. attribute:: input_label
                
                	Input label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: out_path
                
                	Out Path List
                	**type**\: list of    :py:class:`OutPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.OutPath>`
                
                .. attribute:: tunnel_interface
                
                	Tunnel interface
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint, self).__init__()

                    self.yang_name = "tunnel-midpoint"
                    self.yang_parent_name = "tunnel-midpoints"

                    self.label = YLeaf(YType.int32, "label")

                    self.entry_frr_state = YLeaf(YType.enumeration, "entry-frr-state")

                    self.input_label = YLeaf(YType.uint32, "input-label")

                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                    self.frr_entry_id = MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId()
                    self.frr_entry_id.parent = self
                    self._children_name_map["frr_entry_id"] = "frr-entry-id"
                    self._children_yang_names.add("frr-entry-id")

                    self.out_path = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("label",
                                    "entry_frr_state",
                                    "input_label",
                                    "tunnel_interface") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint, self).__setattr__(name, value)


                class FrrEntryId(Entity):
                    """
                    FRR entry ID
                    
                    .. attribute:: head
                    
                    	head
                    	**type**\:   :py:class:`Head <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Head>`
                    
                    .. attribute:: midpoint
                    
                    	midpoint
                    	**type**\:   :py:class:`Midpoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Midpoint>`
                    
                    .. attribute:: role
                    
                    	Role
                    	**type**\:   :py:class:`MgmtLsdLspRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLspRole>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId, self).__init__()

                        self.yang_name = "frr-entry-id"
                        self.yang_parent_name = "tunnel-midpoint"

                        self.role = YLeaf(YType.enumeration, "role")

                        self.head = MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Head()
                        self.head.parent = self
                        self._children_name_map["head"] = "head"
                        self._children_yang_names.add("head")

                        self.midpoint = MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Midpoint()
                        self.midpoint.parent = self
                        self._children_name_map["midpoint"] = "midpoint"
                        self._children_yang_names.add("midpoint")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("role") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId, self).__setattr__(name, value)


                    class Head(Entity):
                        """
                        head
                        
                        .. attribute:: destination_prefix
                        
                        	Destination prefix
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: destination_prefix_length
                        
                        	Destination prefix length
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Head, self).__init__()

                            self.yang_name = "head"
                            self.yang_parent_name = "frr-entry-id"

                            self.destination_prefix = YLeaf(YType.str, "destination-prefix")

                            self.destination_prefix_length = YLeaf(YType.uint8, "destination-prefix-length")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("destination_prefix",
                                            "destination_prefix_length") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Head, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Head, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.destination_prefix.is_set or
                                self.destination_prefix_length.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.destination_prefix.yfilter != YFilter.not_set or
                                self.destination_prefix_length.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "head" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.destination_prefix.is_set or self.destination_prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_prefix.get_name_leafdata())
                            if (self.destination_prefix_length.is_set or self.destination_prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_prefix_length.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "destination-prefix" or name == "destination-prefix-length"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "destination-prefix"):
                                self.destination_prefix = value
                                self.destination_prefix.value_namespace = name_space
                                self.destination_prefix.value_namespace_prefix = name_space_prefix
                            if(value_path == "destination-prefix-length"):
                                self.destination_prefix_length = value
                                self.destination_prefix_length.value_namespace = name_space
                                self.destination_prefix_length.value_namespace_prefix = name_space_prefix


                    class Midpoint(Entity):
                        """
                        midpoint
                        
                        .. attribute:: lspid
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: source_address
                        
                        	Source IPv4 address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Midpoint, self).__init__()

                            self.yang_name = "midpoint"
                            self.yang_parent_name = "frr-entry-id"

                            self.lspid = YLeaf(YType.uint32, "lspid")

                            self.source_address = YLeaf(YType.str, "source-address")

                            self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lspid",
                                            "source_address",
                                            "tunnel_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Midpoint, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Midpoint, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.lspid.is_set or
                                self.source_address.is_set or
                                self.tunnel_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lspid.yfilter != YFilter.not_set or
                                self.source_address.yfilter != YFilter.not_set or
                                self.tunnel_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "midpoint" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lspid.is_set or self.lspid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lspid.get_name_leafdata())
                            if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.source_address.get_name_leafdata())
                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lspid" or name == "source-address" or name == "tunnel-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lspid"):
                                self.lspid = value
                                self.lspid.value_namespace = name_space
                                self.lspid.value_namespace_prefix = name_space_prefix
                            if(value_path == "source-address"):
                                self.source_address = value
                                self.source_address.value_namespace = name_space
                                self.source_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-id"):
                                self.tunnel_id = value
                                self.tunnel_id.value_namespace = name_space
                                self.tunnel_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.role.is_set or
                            (self.head is not None and self.head.has_data()) or
                            (self.midpoint is not None and self.midpoint.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.role.yfilter != YFilter.not_set or
                            (self.head is not None and self.head.has_operation()) or
                            (self.midpoint is not None and self.midpoint.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "frr-entry-id" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.role.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "head"):
                            if (self.head is None):
                                self.head = MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Head()
                                self.head.parent = self
                                self._children_name_map["head"] = "head"
                            return self.head

                        if (child_yang_name == "midpoint"):
                            if (self.midpoint is None):
                                self.midpoint = MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId.Midpoint()
                                self.midpoint.parent = self
                                self._children_name_map["midpoint"] = "midpoint"
                            return self.midpoint

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "head" or name == "midpoint" or name == "role"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "role"):
                            self.role = value
                            self.role.value_namespace = name_space
                            self.role.value_namespace_prefix = name_space_prefix


                class OutPath(Entity):
                    """
                    Out Path List
                    
                    .. attribute:: frr_interface
                    
                    	FRR interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: frr_label
                    
                    	FRR output label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: ipv4_next_hop
                    
                    	Next hop IPv4 address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: out_interface
                    
                    	Outgoing interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: out_label
                    
                    	Outgoing label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.OutPath, self).__init__()

                        self.yang_name = "out-path"
                        self.yang_parent_name = "tunnel-midpoint"

                        self.frr_interface = YLeaf(YType.str, "frr-interface")

                        self.frr_label = YLeaf(YType.uint32, "frr-label")

                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                        self.out_interface = YLeaf(YType.str, "out-interface")

                        self.out_label = YLeaf(YType.uint32, "out-label")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("frr_interface",
                                        "frr_label",
                                        "ipv4_next_hop",
                                        "out_interface",
                                        "out_label") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.OutPath, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.OutPath, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.frr_interface.is_set or
                            self.frr_label.is_set or
                            self.ipv4_next_hop.is_set or
                            self.out_interface.is_set or
                            self.out_label.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.frr_interface.yfilter != YFilter.not_set or
                            self.frr_label.yfilter != YFilter.not_set or
                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                            self.out_interface.yfilter != YFilter.not_set or
                            self.out_label.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "out-path" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.frr_interface.is_set or self.frr_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_interface.get_name_leafdata())
                        if (self.frr_label.is_set or self.frr_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_label.get_name_leafdata())
                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_label.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "frr-interface" or name == "frr-label" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "frr-interface"):
                            self.frr_interface = value
                            self.frr_interface.value_namespace = name_space
                            self.frr_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-label"):
                            self.frr_label = value
                            self.frr_label.value_namespace = name_space
                            self.frr_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv4-next-hop"):
                            self.ipv4_next_hop = value
                            self.ipv4_next_hop.value_namespace = name_space
                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-interface"):
                            self.out_interface = value
                            self.out_interface.value_namespace = name_space
                            self.out_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-label"):
                            self.out_label = value
                            self.out_label.value_namespace = name_space
                            self.out_label.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.out_path:
                        if (c.has_data()):
                            return True
                    return (
                        self.label.is_set or
                        self.entry_frr_state.is_set or
                        self.input_label.is_set or
                        self.tunnel_interface.is_set or
                        (self.frr_entry_id is not None and self.frr_entry_id.has_data()))

                def has_operation(self):
                    for c in self.out_path:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.label.yfilter != YFilter.not_set or
                        self.entry_frr_state.yfilter != YFilter.not_set or
                        self.input_label.yfilter != YFilter.not_set or
                        self.tunnel_interface.yfilter != YFilter.not_set or
                        (self.frr_entry_id is not None and self.frr_entry_id.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-midpoint" + "[label='" + self.label.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/frr-database/tunnel-midpoints/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.label.get_name_leafdata())
                    if (self.entry_frr_state.is_set or self.entry_frr_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.entry_frr_state.get_name_leafdata())
                    if (self.input_label.is_set or self.input_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.input_label.get_name_leafdata())
                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "frr-entry-id"):
                        if (self.frr_entry_id is None):
                            self.frr_entry_id = MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.FrrEntryId()
                            self.frr_entry_id.parent = self
                            self._children_name_map["frr_entry_id"] = "frr-entry-id"
                        return self.frr_entry_id

                    if (child_yang_name == "out-path"):
                        for c in self.out_path:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint.OutPath()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.out_path.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "frr-entry-id" or name == "out-path" or name == "label" or name == "entry-frr-state" or name == "input-label" or name == "tunnel-interface"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "label"):
                        self.label = value
                        self.label.value_namespace = name_space
                        self.label.value_namespace_prefix = name_space_prefix
                    if(value_path == "entry-frr-state"):
                        self.entry_frr_state = value
                        self.entry_frr_state.value_namespace = name_space
                        self.entry_frr_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "input-label"):
                        self.input_label = value
                        self.input_label.value_namespace = name_space
                        self.input_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-interface"):
                        self.tunnel_interface = value
                        self.tunnel_interface.value_namespace = name_space
                        self.tunnel_interface.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_midpoint:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_midpoint:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-midpoints" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/frr-database/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-midpoint"):
                    for c in self.tunnel_midpoint:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsd.FrrDatabase.TunnelMidpoints.TunnelMidpoint()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_midpoint.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-midpoint"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TunnelHeads(Entity):
            """
            Table of FRR database entries \- Tunnel heads
            
            .. attribute:: tunnel_head
            
            	Data for FRR database entry \- Tunnel head
            	**type**\: list of    :py:class:`TunnelHead <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelHeads.TunnelHead>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.FrrDatabase.TunnelHeads, self).__init__()

                self.yang_name = "tunnel-heads"
                self.yang_parent_name = "frr-database"

                self.tunnel_head = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.FrrDatabase.TunnelHeads, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.FrrDatabase.TunnelHeads, self).__setattr__(name, value)


            class TunnelHead(Entity):
                """
                Data for FRR database entry \- Tunnel head
                
                .. attribute:: interface_name  <key>
                
                	Tunnel interface
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: entry_frr_state
                
                	MPLS FRR entry state
                	**type**\:   :py:class:`MgmtLsdFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFrrState>`
                
                .. attribute:: frr_entry_id
                
                	FRR entry ID
                	**type**\:   :py:class:`FrrEntryId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId>`
                
                .. attribute:: input_label
                
                	Input label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: out_path
                
                	Out Path List
                	**type**\: list of    :py:class:`OutPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.OutPath>`
                
                .. attribute:: tunnel_interface
                
                	Tunnel interface
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead, self).__init__()

                    self.yang_name = "tunnel-head"
                    self.yang_parent_name = "tunnel-heads"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.entry_frr_state = YLeaf(YType.enumeration, "entry-frr-state")

                    self.input_label = YLeaf(YType.uint32, "input-label")

                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                    self.frr_entry_id = MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId()
                    self.frr_entry_id.parent = self
                    self._children_name_map["frr_entry_id"] = "frr-entry-id"
                    self._children_yang_names.add("frr-entry-id")

                    self.out_path = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "entry_frr_state",
                                    "input_label",
                                    "tunnel_interface") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead, self).__setattr__(name, value)


                class FrrEntryId(Entity):
                    """
                    FRR entry ID
                    
                    .. attribute:: head
                    
                    	head
                    	**type**\:   :py:class:`Head <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Head>`
                    
                    .. attribute:: midpoint
                    
                    	midpoint
                    	**type**\:   :py:class:`Midpoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Midpoint>`
                    
                    .. attribute:: role
                    
                    	Role
                    	**type**\:   :py:class:`MgmtLsdLspRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLspRole>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId, self).__init__()

                        self.yang_name = "frr-entry-id"
                        self.yang_parent_name = "tunnel-head"

                        self.role = YLeaf(YType.enumeration, "role")

                        self.head = MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Head()
                        self.head.parent = self
                        self._children_name_map["head"] = "head"
                        self._children_yang_names.add("head")

                        self.midpoint = MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Midpoint()
                        self.midpoint.parent = self
                        self._children_name_map["midpoint"] = "midpoint"
                        self._children_yang_names.add("midpoint")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("role") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId, self).__setattr__(name, value)


                    class Head(Entity):
                        """
                        head
                        
                        .. attribute:: destination_prefix
                        
                        	Destination prefix
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: destination_prefix_length
                        
                        	Destination prefix length
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Head, self).__init__()

                            self.yang_name = "head"
                            self.yang_parent_name = "frr-entry-id"

                            self.destination_prefix = YLeaf(YType.str, "destination-prefix")

                            self.destination_prefix_length = YLeaf(YType.uint8, "destination-prefix-length")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("destination_prefix",
                                            "destination_prefix_length") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Head, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Head, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.destination_prefix.is_set or
                                self.destination_prefix_length.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.destination_prefix.yfilter != YFilter.not_set or
                                self.destination_prefix_length.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "head" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.destination_prefix.is_set or self.destination_prefix.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_prefix.get_name_leafdata())
                            if (self.destination_prefix_length.is_set or self.destination_prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_prefix_length.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "destination-prefix" or name == "destination-prefix-length"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "destination-prefix"):
                                self.destination_prefix = value
                                self.destination_prefix.value_namespace = name_space
                                self.destination_prefix.value_namespace_prefix = name_space_prefix
                            if(value_path == "destination-prefix-length"):
                                self.destination_prefix_length = value
                                self.destination_prefix_length.value_namespace = name_space
                                self.destination_prefix_length.value_namespace_prefix = name_space_prefix


                    class Midpoint(Entity):
                        """
                        midpoint
                        
                        .. attribute:: lspid
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: source_address
                        
                        	Source IPv4 address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Midpoint, self).__init__()

                            self.yang_name = "midpoint"
                            self.yang_parent_name = "frr-entry-id"

                            self.lspid = YLeaf(YType.uint32, "lspid")

                            self.source_address = YLeaf(YType.str, "source-address")

                            self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lspid",
                                            "source_address",
                                            "tunnel_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Midpoint, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Midpoint, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.lspid.is_set or
                                self.source_address.is_set or
                                self.tunnel_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lspid.yfilter != YFilter.not_set or
                                self.source_address.yfilter != YFilter.not_set or
                                self.tunnel_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "midpoint" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lspid.is_set or self.lspid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lspid.get_name_leafdata())
                            if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.source_address.get_name_leafdata())
                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lspid" or name == "source-address" or name == "tunnel-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lspid"):
                                self.lspid = value
                                self.lspid.value_namespace = name_space
                                self.lspid.value_namespace_prefix = name_space_prefix
                            if(value_path == "source-address"):
                                self.source_address = value
                                self.source_address.value_namespace = name_space
                                self.source_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-id"):
                                self.tunnel_id = value
                                self.tunnel_id.value_namespace = name_space
                                self.tunnel_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.role.is_set or
                            (self.head is not None and self.head.has_data()) or
                            (self.midpoint is not None and self.midpoint.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.role.yfilter != YFilter.not_set or
                            (self.head is not None and self.head.has_operation()) or
                            (self.midpoint is not None and self.midpoint.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "frr-entry-id" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.role.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "head"):
                            if (self.head is None):
                                self.head = MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Head()
                                self.head.parent = self
                                self._children_name_map["head"] = "head"
                            return self.head

                        if (child_yang_name == "midpoint"):
                            if (self.midpoint is None):
                                self.midpoint = MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId.Midpoint()
                                self.midpoint.parent = self
                                self._children_name_map["midpoint"] = "midpoint"
                            return self.midpoint

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "head" or name == "midpoint" or name == "role"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "role"):
                            self.role = value
                            self.role.value_namespace = name_space
                            self.role.value_namespace_prefix = name_space_prefix


                class OutPath(Entity):
                    """
                    Out Path List
                    
                    .. attribute:: frr_interface
                    
                    	FRR interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: frr_label
                    
                    	FRR output label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: ipv4_next_hop
                    
                    	Next hop IPv4 address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: out_interface
                    
                    	Outgoing interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: out_label
                    
                    	Outgoing label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.OutPath, self).__init__()

                        self.yang_name = "out-path"
                        self.yang_parent_name = "tunnel-head"

                        self.frr_interface = YLeaf(YType.str, "frr-interface")

                        self.frr_label = YLeaf(YType.uint32, "frr-label")

                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                        self.out_interface = YLeaf(YType.str, "out-interface")

                        self.out_label = YLeaf(YType.uint32, "out-label")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("frr_interface",
                                        "frr_label",
                                        "ipv4_next_hop",
                                        "out_interface",
                                        "out_label") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.OutPath, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.OutPath, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.frr_interface.is_set or
                            self.frr_label.is_set or
                            self.ipv4_next_hop.is_set or
                            self.out_interface.is_set or
                            self.out_label.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.frr_interface.yfilter != YFilter.not_set or
                            self.frr_label.yfilter != YFilter.not_set or
                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                            self.out_interface.yfilter != YFilter.not_set or
                            self.out_label.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "out-path" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.frr_interface.is_set or self.frr_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_interface.get_name_leafdata())
                        if (self.frr_label.is_set or self.frr_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_label.get_name_leafdata())
                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_label.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "frr-interface" or name == "frr-label" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "frr-interface"):
                            self.frr_interface = value
                            self.frr_interface.value_namespace = name_space
                            self.frr_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-label"):
                            self.frr_label = value
                            self.frr_label.value_namespace = name_space
                            self.frr_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv4-next-hop"):
                            self.ipv4_next_hop = value
                            self.ipv4_next_hop.value_namespace = name_space
                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-interface"):
                            self.out_interface = value
                            self.out_interface.value_namespace = name_space
                            self.out_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-label"):
                            self.out_label = value
                            self.out_label.value_namespace = name_space
                            self.out_label.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.out_path:
                        if (c.has_data()):
                            return True
                    return (
                        self.interface_name.is_set or
                        self.entry_frr_state.is_set or
                        self.input_label.is_set or
                        self.tunnel_interface.is_set or
                        (self.frr_entry_id is not None and self.frr_entry_id.has_data()))

                def has_operation(self):
                    for c in self.out_path:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.entry_frr_state.yfilter != YFilter.not_set or
                        self.input_label.yfilter != YFilter.not_set or
                        self.tunnel_interface.yfilter != YFilter.not_set or
                        (self.frr_entry_id is not None and self.frr_entry_id.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-head" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/frr-database/tunnel-heads/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.entry_frr_state.is_set or self.entry_frr_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.entry_frr_state.get_name_leafdata())
                    if (self.input_label.is_set or self.input_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.input_label.get_name_leafdata())
                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "frr-entry-id"):
                        if (self.frr_entry_id is None):
                            self.frr_entry_id = MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.FrrEntryId()
                            self.frr_entry_id.parent = self
                            self._children_name_map["frr_entry_id"] = "frr-entry-id"
                        return self.frr_entry_id

                    if (child_yang_name == "out-path"):
                        for c in self.out_path:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.FrrDatabase.TunnelHeads.TunnelHead.OutPath()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.out_path.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "frr-entry-id" or name == "out-path" or name == "interface-name" or name == "entry-frr-state" or name == "input-label" or name == "tunnel-interface"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "entry-frr-state"):
                        self.entry_frr_state = value
                        self.entry_frr_state.value_namespace = name_space
                        self.entry_frr_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "input-label"):
                        self.input_label = value
                        self.input_label.value_namespace = name_space
                        self.input_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-interface"):
                        self.tunnel_interface = value
                        self.tunnel_interface.value_namespace = name_space
                        self.tunnel_interface.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_head:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_head:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-heads" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/frr-database/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-head"):
                    for c in self.tunnel_head:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsd.FrrDatabase.TunnelHeads.TunnelHead()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_head.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-head"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TunnelHeadSummary(Entity):
            """
            Summary data for FRR database entry \- Tunnel
            head
            
            .. attribute:: active
            
            	Number of FRR rewrites in Active state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: igp
            
            	Number of FRR rewrites in IGP state for SR\-TE
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: partial
            
            	Number of FRR rewrites in Partial state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: ready
            
            	Number of FRR rewrites in Ready state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.FrrDatabase.TunnelHeadSummary, self).__init__()

                self.yang_name = "tunnel-head-summary"
                self.yang_parent_name = "frr-database"

                self.active = YLeaf(YType.uint32, "active")

                self.igp = YLeaf(YType.uint32, "igp")

                self.partial = YLeaf(YType.uint32, "partial")

                self.ready = YLeaf(YType.uint32, "ready")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("active",
                                "igp",
                                "partial",
                                "ready") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.FrrDatabase.TunnelHeadSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.FrrDatabase.TunnelHeadSummary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.active.is_set or
                    self.igp.is_set or
                    self.partial.is_set or
                    self.ready.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.active.yfilter != YFilter.not_set or
                    self.igp.yfilter != YFilter.not_set or
                    self.partial.yfilter != YFilter.not_set or
                    self.ready.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-head-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/frr-database/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.active.is_set or self.active.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.active.get_name_leafdata())
                if (self.igp.is_set or self.igp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp.get_name_leafdata())
                if (self.partial.is_set or self.partial.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.partial.get_name_leafdata())
                if (self.ready.is_set or self.ready.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.ready.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "active" or name == "igp" or name == "partial" or name == "ready"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "active"):
                    self.active = value
                    self.active.value_namespace = name_space
                    self.active.value_namespace_prefix = name_space_prefix
                if(value_path == "igp"):
                    self.igp = value
                    self.igp.value_namespace = name_space
                    self.igp.value_namespace_prefix = name_space_prefix
                if(value_path == "partial"):
                    self.partial = value
                    self.partial.value_namespace = name_space
                    self.partial.value_namespace_prefix = name_space_prefix
                if(value_path == "ready"):
                    self.ready = value
                    self.ready.value_namespace = name_space
                    self.ready.value_namespace_prefix = name_space_prefix


        class SummaryProtectedInterfaces(Entity):
            """
            Sumary table of Protected Interfaces
            
            .. attribute:: summary_protected_interface
            
            	Data for MPLS interface
            	**type**\: list of    :py:class:`SummaryProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.FrrDatabase.SummaryProtectedInterfaces.SummaryProtectedInterface>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.FrrDatabase.SummaryProtectedInterfaces, self).__init__()

                self.yang_name = "summary-protected-interfaces"
                self.yang_parent_name = "frr-database"

                self.summary_protected_interface = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.FrrDatabase.SummaryProtectedInterfaces, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.FrrDatabase.SummaryProtectedInterfaces, self).__setattr__(name, value)


            class SummaryProtectedInterface(Entity):
                """
                Data for MPLS interface
                
                .. attribute:: interface_name  <key>
                
                	Interface
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: active
                
                	Number of FRR rewrites in Active state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: igp
                
                	Number of FRR rewrites in IGP state for SR\-TE
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: partial
                
                	Number of FRR rewrites in Partial state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: ready
                
                	Number of FRR rewrites in Ready state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.FrrDatabase.SummaryProtectedInterfaces.SummaryProtectedInterface, self).__init__()

                    self.yang_name = "summary-protected-interface"
                    self.yang_parent_name = "summary-protected-interfaces"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.active = YLeaf(YType.uint32, "active")

                    self.igp = YLeaf(YType.uint32, "igp")

                    self.partial = YLeaf(YType.uint32, "partial")

                    self.ready = YLeaf(YType.uint32, "ready")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "active",
                                    "igp",
                                    "partial",
                                    "ready") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.FrrDatabase.SummaryProtectedInterfaces.SummaryProtectedInterface, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.FrrDatabase.SummaryProtectedInterfaces.SummaryProtectedInterface, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.interface_name.is_set or
                        self.active.is_set or
                        self.igp.is_set or
                        self.partial.is_set or
                        self.ready.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.active.yfilter != YFilter.not_set or
                        self.igp.yfilter != YFilter.not_set or
                        self.partial.yfilter != YFilter.not_set or
                        self.ready.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "summary-protected-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/frr-database/summary-protected-interfaces/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.active.is_set or self.active.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.active.get_name_leafdata())
                    if (self.igp.is_set or self.igp.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp.get_name_leafdata())
                    if (self.partial.is_set or self.partial.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.partial.get_name_leafdata())
                    if (self.ready.is_set or self.ready.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ready.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "interface-name" or name == "active" or name == "igp" or name == "partial" or name == "ready"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "active"):
                        self.active = value
                        self.active.value_namespace = name_space
                        self.active.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp"):
                        self.igp = value
                        self.igp.value_namespace = name_space
                        self.igp.value_namespace_prefix = name_space_prefix
                    if(value_path == "partial"):
                        self.partial = value
                        self.partial.value_namespace = name_space
                        self.partial.value_namespace_prefix = name_space_prefix
                    if(value_path == "ready"):
                        self.ready = value
                        self.ready.value_namespace = name_space
                        self.ready.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.summary_protected_interface:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.summary_protected_interface:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "summary-protected-interfaces" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/frr-database/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "summary-protected-interface"):
                    for c in self.summary_protected_interface:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsd.FrrDatabase.SummaryProtectedInterfaces.SummaryProtectedInterface()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.summary_protected_interface.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "summary-protected-interface"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TunnelSummary(Entity):
            """
            Summary data for FRR database entry
            
            .. attribute:: active
            
            	Number of FRR rewrites in Active state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: igp
            
            	Number of FRR rewrites in IGP state for SR\-TE
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: partial
            
            	Number of FRR rewrites in Partial state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: ready
            
            	Number of FRR rewrites in Ready state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.FrrDatabase.TunnelSummary, self).__init__()

                self.yang_name = "tunnel-summary"
                self.yang_parent_name = "frr-database"

                self.active = YLeaf(YType.uint32, "active")

                self.igp = YLeaf(YType.uint32, "igp")

                self.partial = YLeaf(YType.uint32, "partial")

                self.ready = YLeaf(YType.uint32, "ready")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("active",
                                "igp",
                                "partial",
                                "ready") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.FrrDatabase.TunnelSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.FrrDatabase.TunnelSummary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.active.is_set or
                    self.igp.is_set or
                    self.partial.is_set or
                    self.ready.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.active.yfilter != YFilter.not_set or
                    self.igp.yfilter != YFilter.not_set or
                    self.partial.yfilter != YFilter.not_set or
                    self.ready.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/frr-database/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.active.is_set or self.active.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.active.get_name_leafdata())
                if (self.igp.is_set or self.igp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp.get_name_leafdata())
                if (self.partial.is_set or self.partial.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.partial.get_name_leafdata())
                if (self.ready.is_set or self.ready.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.ready.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "active" or name == "igp" or name == "partial" or name == "ready"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "active"):
                    self.active = value
                    self.active.value_namespace = name_space
                    self.active.value_namespace_prefix = name_space_prefix
                if(value_path == "igp"):
                    self.igp = value
                    self.igp.value_namespace = name_space
                    self.igp.value_namespace_prefix = name_space_prefix
                if(value_path == "partial"):
                    self.partial = value
                    self.partial.value_namespace = name_space
                    self.partial.value_namespace_prefix = name_space_prefix
                if(value_path == "ready"):
                    self.ready = value
                    self.ready.value_namespace = name_space
                    self.ready.value_namespace_prefix = name_space_prefix


        class TunnelMidpointSummary(Entity):
            """
            Summary data for FRR database entry \- Tunnel
            midpoint
            
            .. attribute:: active
            
            	Number of FRR rewrites in Active state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: igp
            
            	Number of FRR rewrites in IGP state for SR\-TE
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: partial
            
            	Number of FRR rewrites in Partial state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: ready
            
            	Number of FRR rewrites in Ready state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.FrrDatabase.TunnelMidpointSummary, self).__init__()

                self.yang_name = "tunnel-midpoint-summary"
                self.yang_parent_name = "frr-database"

                self.active = YLeaf(YType.uint32, "active")

                self.igp = YLeaf(YType.uint32, "igp")

                self.partial = YLeaf(YType.uint32, "partial")

                self.ready = YLeaf(YType.uint32, "ready")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("active",
                                "igp",
                                "partial",
                                "ready") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.FrrDatabase.TunnelMidpointSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.FrrDatabase.TunnelMidpointSummary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.active.is_set or
                    self.igp.is_set or
                    self.partial.is_set or
                    self.ready.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.active.yfilter != YFilter.not_set or
                    self.igp.yfilter != YFilter.not_set or
                    self.partial.yfilter != YFilter.not_set or
                    self.ready.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-midpoint-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/frr-database/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.active.is_set or self.active.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.active.get_name_leafdata())
                if (self.igp.is_set or self.igp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp.get_name_leafdata())
                if (self.partial.is_set or self.partial.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.partial.get_name_leafdata())
                if (self.ready.is_set or self.ready.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.ready.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "active" or name == "igp" or name == "partial" or name == "ready"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "active"):
                    self.active = value
                    self.active.value_namespace = name_space
                    self.active.value_namespace_prefix = name_space_prefix
                if(value_path == "igp"):
                    self.igp = value
                    self.igp.value_namespace = name_space
                    self.igp.value_namespace_prefix = name_space_prefix
                if(value_path == "partial"):
                    self.partial = value
                    self.partial.value_namespace = name_space
                    self.partial.value_namespace_prefix = name_space_prefix
                if(value_path == "ready"):
                    self.ready = value
                    self.ready.value_namespace = name_space
                    self.ready.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                (self.summary_protected_interfaces is not None and self.summary_protected_interfaces.has_data()) or
                (self.tunnel_head_summary is not None and self.tunnel_head_summary.has_data()) or
                (self.tunnel_heads is not None and self.tunnel_heads.has_data()) or
                (self.tunnel_midpoint_summary is not None and self.tunnel_midpoint_summary.has_data()) or
                (self.tunnel_midpoints is not None and self.tunnel_midpoints.has_data()) or
                (self.tunnel_summary is not None and self.tunnel_summary.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.summary_protected_interfaces is not None and self.summary_protected_interfaces.has_operation()) or
                (self.tunnel_head_summary is not None and self.tunnel_head_summary.has_operation()) or
                (self.tunnel_heads is not None and self.tunnel_heads.has_operation()) or
                (self.tunnel_midpoint_summary is not None and self.tunnel_midpoint_summary.has_operation()) or
                (self.tunnel_midpoints is not None and self.tunnel_midpoints.has_operation()) or
                (self.tunnel_summary is not None and self.tunnel_summary.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "frr-database" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "summary-protected-interfaces"):
                if (self.summary_protected_interfaces is None):
                    self.summary_protected_interfaces = MplsLsd.FrrDatabase.SummaryProtectedInterfaces()
                    self.summary_protected_interfaces.parent = self
                    self._children_name_map["summary_protected_interfaces"] = "summary-protected-interfaces"
                return self.summary_protected_interfaces

            if (child_yang_name == "tunnel-head-summary"):
                if (self.tunnel_head_summary is None):
                    self.tunnel_head_summary = MplsLsd.FrrDatabase.TunnelHeadSummary()
                    self.tunnel_head_summary.parent = self
                    self._children_name_map["tunnel_head_summary"] = "tunnel-head-summary"
                return self.tunnel_head_summary

            if (child_yang_name == "tunnel-heads"):
                if (self.tunnel_heads is None):
                    self.tunnel_heads = MplsLsd.FrrDatabase.TunnelHeads()
                    self.tunnel_heads.parent = self
                    self._children_name_map["tunnel_heads"] = "tunnel-heads"
                return self.tunnel_heads

            if (child_yang_name == "tunnel-midpoint-summary"):
                if (self.tunnel_midpoint_summary is None):
                    self.tunnel_midpoint_summary = MplsLsd.FrrDatabase.TunnelMidpointSummary()
                    self.tunnel_midpoint_summary.parent = self
                    self._children_name_map["tunnel_midpoint_summary"] = "tunnel-midpoint-summary"
                return self.tunnel_midpoint_summary

            if (child_yang_name == "tunnel-midpoints"):
                if (self.tunnel_midpoints is None):
                    self.tunnel_midpoints = MplsLsd.FrrDatabase.TunnelMidpoints()
                    self.tunnel_midpoints.parent = self
                    self._children_name_map["tunnel_midpoints"] = "tunnel-midpoints"
                return self.tunnel_midpoints

            if (child_yang_name == "tunnel-summary"):
                if (self.tunnel_summary is None):
                    self.tunnel_summary = MplsLsd.FrrDatabase.TunnelSummary()
                    self.tunnel_summary.parent = self
                    self._children_name_map["tunnel_summary"] = "tunnel-summary"
                return self.tunnel_summary

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "summary-protected-interfaces" or name == "tunnel-head-summary" or name == "tunnel-heads" or name == "tunnel-midpoint-summary" or name == "tunnel-midpoints" or name == "tunnel-summary"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Rewrite(Entity):
        """
        Table of rewrites
        
        .. attribute:: rewrite_ipv4s
        
        	Table of Rewrites
        	**type**\:   :py:class:`RewriteIpv4S <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S>`
        
        .. attribute:: rewrite_labels
        
        	Table of Rewrites
        	**type**\:   :py:class:`RewriteLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels>`
        
        .. attribute:: rewrite_pws
        
        	Table of Rewrites
        	**type**\:   :py:class:`RewritePws <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws>`
        
        .. attribute:: rewrite_tes
        
        	Table of Traffic Engineering Rewrites
        	**type**\:   :py:class:`RewriteTes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes>`
        
        

        """

        _prefix = 'mpls-lsd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLsd.Rewrite, self).__init__()

            self.yang_name = "rewrite"
            self.yang_parent_name = "mpls-lsd"

            self.rewrite_ipv4s = MplsLsd.Rewrite.RewriteIpv4S()
            self.rewrite_ipv4s.parent = self
            self._children_name_map["rewrite_ipv4s"] = "rewrite-ipv4s"
            self._children_yang_names.add("rewrite-ipv4s")

            self.rewrite_labels = MplsLsd.Rewrite.RewriteLabels()
            self.rewrite_labels.parent = self
            self._children_name_map["rewrite_labels"] = "rewrite-labels"
            self._children_yang_names.add("rewrite-labels")

            self.rewrite_pws = MplsLsd.Rewrite.RewritePws()
            self.rewrite_pws.parent = self
            self._children_name_map["rewrite_pws"] = "rewrite-pws"
            self._children_yang_names.add("rewrite-pws")

            self.rewrite_tes = MplsLsd.Rewrite.RewriteTes()
            self.rewrite_tes.parent = self
            self._children_name_map["rewrite_tes"] = "rewrite-tes"
            self._children_yang_names.add("rewrite-tes")


        class RewritePws(Entity):
            """
            Table of Rewrites
            
            .. attribute:: rewrite_pw
            
            	FPI rewrite for PW List
            	**type**\: list of    :py:class:`RewritePw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.Rewrite.RewritePws, self).__init__()

                self.yang_name = "rewrite-pws"
                self.yang_parent_name = "rewrite"

                self.rewrite_pw = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.Rewrite.RewritePws, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.Rewrite.RewritePws, self).__setattr__(name, value)


            class RewritePw(Entity):
                """
                FPI rewrite for PW List
                
                .. attribute:: pw_list_id  <key>
                
                	PW List ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: associated_fpi
                
                	Associated FPI
                	**type**\: list of    :py:class:`AssociatedFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi>`
                
                .. attribute:: bcdl_priority
                
                	BCDL Priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: fpi_key
                
                	fpi key
                	**type**\:   :py:class:`FpiKey <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey>`
                
                .. attribute:: lsd_queue
                
                	LSD queue
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: mois
                
                	Mois
                	**type**\: list of    :py:class:`Mois <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois>`
                
                .. attribute:: priority_updated
                
                	Is rewrite's BCDL priority updated
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: rewrite_id
                
                	Rewrite ID
                	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId>`
                
                .. attribute:: rewrite_version
                
                	Rewrite version
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: rw_install_age
                
                	Rewrite install age
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: rw_install_time
                
                	Rewrite install timestamp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: rw_updated
                
                	Is rewrite ever updated
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: v4_rpf
                
                	IPv4 RPF neighbors
                	**type**\: list of    :py:class:`V4Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.V4Rpf>`
                
                .. attribute:: v6_rpf
                
                	IPv6 RPF neighbors
                	**type**\: list of    :py:class:`V6Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.V6Rpf>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.Rewrite.RewritePws.RewritePw, self).__init__()

                    self.yang_name = "rewrite-pw"
                    self.yang_parent_name = "rewrite-pws"

                    self.pw_list_id = YLeaf(YType.int32, "pw-list-id")

                    self.bcdl_priority = YLeaf(YType.uint8, "bcdl-priority")

                    self.lsd_queue = YLeaf(YType.uint8, "lsd-queue")

                    self.priority_updated = YLeaf(YType.int32, "priority-updated")

                    self.rewrite_version = YLeaf(YType.uint64, "rewrite-version")

                    self.rw_install_age = YLeaf(YType.uint64, "rw-install-age")

                    self.rw_install_time = YLeaf(YType.uint64, "rw-install-time")

                    self.rw_updated = YLeaf(YType.int32, "rw-updated")

                    self.fpi_key = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey()
                    self.fpi_key.parent = self
                    self._children_name_map["fpi_key"] = "fpi-key"
                    self._children_yang_names.add("fpi-key")

                    self.rewrite_id = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId()
                    self.rewrite_id.parent = self
                    self._children_name_map["rewrite_id"] = "rewrite-id"
                    self._children_yang_names.add("rewrite-id")

                    self.associated_fpi = YList(self)
                    self.mois = YList(self)
                    self.v4_rpf = YList(self)
                    self.v6_rpf = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("pw_list_id",
                                    "bcdl_priority",
                                    "lsd_queue",
                                    "priority_updated",
                                    "rewrite_version",
                                    "rw_install_age",
                                    "rw_install_time",
                                    "rw_updated") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.Rewrite.RewritePws.RewritePw, self).__setattr__(name, value)


                class FpiKey(Entity):
                    """
                    fpi key
                    
                    .. attribute:: application_owner
                    
                    	Application owner instance
                    	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.ApplicationOwner>`
                    
                    .. attribute:: fpi
                    
                    	FPI
                    	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey, self).__init__()

                        self.yang_name = "fpi-key"
                        self.yang_parent_name = "rewrite-pw"

                        self.fpi = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi()
                        self.fpi.parent = self
                        self._children_name_map["fpi"] = "fpi"
                        self._children_yang_names.add("fpi")

                        self.application_owner = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey, self).__setattr__(name, value)


                    class Fpi(Entity):
                        """
                        FPI
                        
                        .. attribute:: dmtc_ext_intf_data
                        
                        	dmtc ext intf data
                        	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.DmtcExtIntfData>`
                        
                        .. attribute:: fpi_type
                        
                        	FPIType
                        	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                        
                        .. attribute:: ipv4_data
                        
                        	ipv4 data
                        	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv4Data>`
                        
                        .. attribute:: ipv6_data
                        
                        	ipv6 data
                        	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv6Data>`
                        
                        .. attribute:: label_data
                        
                        	label data
                        	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.LabelData>`
                        
                        .. attribute:: pw_list_data
                        
                        	pw list data
                        	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.PwListData>`
                        
                        .. attribute:: te_data
                        
                        	te data
                        	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.TeData>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi, self).__init__()

                            self.yang_name = "fpi"
                            self.yang_parent_name = "fpi-key"

                            self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                            self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.DmtcExtIntfData()
                            self.dmtc_ext_intf_data.parent = self
                            self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                            self._children_yang_names.add("dmtc-ext-intf-data")

                            self.ipv4_data = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv4Data()
                            self.ipv4_data.parent = self
                            self._children_name_map["ipv4_data"] = "ipv4-data"
                            self._children_yang_names.add("ipv4-data")

                            self.ipv6_data = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv6Data()
                            self.ipv6_data.parent = self
                            self._children_name_map["ipv6_data"] = "ipv6-data"
                            self._children_yang_names.add("ipv6-data")

                            self.label_data = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.LabelData()
                            self.label_data.parent = self
                            self._children_name_map["label_data"] = "label-data"
                            self._children_yang_names.add("label-data")

                            self.pw_list_data = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.PwListData()
                            self.pw_list_data.parent = self
                            self._children_name_map["pw_list_data"] = "pw-list-data"
                            self._children_yang_names.add("pw-list-data")

                            self.te_data = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.TeData()
                            self.te_data.parent = self
                            self._children_name_map["te_data"] = "te-data"
                            self._children_yang_names.add("te-data")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fpi_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi, self).__setattr__(name, value)


                        class LabelData(Entity):
                            """
                            label data
                            
                            .. attribute:: elc
                            
                            	ELC
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: label
                            
                            	Label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.LabelData, self).__init__()

                                self.yang_name = "label-data"
                                self.yang_parent_name = "fpi"

                                self.elc = YLeaf(YType.int32, "elc")

                                self.label = YLeaf(YType.uint32, "label")

                                self.security_id = YLeaf(YType.uint32, "security-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("elc",
                                                "label",
                                                "security_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.LabelData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.LabelData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.elc.is_set or
                                    self.label.is_set or
                                    self.security_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.elc.yfilter != YFilter.not_set or
                                    self.label.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.elc.get_name_leafdata())
                                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label.get_name_leafdata())
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "elc" or name == "label" or name == "security-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "elc"):
                                    self.elc = value
                                    self.elc.value_namespace = name_space
                                    self.elc.value_namespace_prefix = name_space_prefix
                                if(value_path == "label"):
                                    self.label = value
                                    self.label.value_namespace = name_space
                                    self.label.value_namespace_prefix = name_space_prefix
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix


                        class TeData(Entity):
                            """
                            te data
                            
                            .. attribute:: local_label
                            
                            	Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_interface
                            
                            	Tunnel interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.TeData, self).__init__()

                                self.yang_name = "te-data"
                                self.yang_parent_name = "fpi"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label",
                                                "tunnel_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.TeData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.TeData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.local_label.is_set or
                                    self.tunnel_interface.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.tunnel_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label" or name == "tunnel-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface"):
                                    self.tunnel_interface = value
                                    self.tunnel_interface.value_namespace = name_space
                                    self.tunnel_interface.value_namespace_prefix = name_space_prefix


                        class Ipv4Data(Entity):
                            """
                            ipv4 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: sr_local_label
                            
                            	SR related Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv4Data, self).__init__()

                                self.yang_name = "ipv4-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "sr_local_label",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.sr_local_label.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.sr_local_label.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "sr-local-label"):
                                    self.sr_local_label = value
                                    self.sr_local_label.value_namespace = name_space
                                    self.sr_local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class Ipv6Data(Entity):
                            """
                            ipv6 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_len
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: router_flags
                            
                            	Route flags
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv6Data, self).__init__()

                                self.yang_name = "ipv6-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                self.router_flags = YLeaf(YType.uint32, "router-flags")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_len",
                                                "router_flags",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_len.is_set or
                                    self.router_flags.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_len.yfilter != YFilter.not_set or
                                    self.router_flags.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv6-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.router_flags.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-len"):
                                    self.prefix_len = value
                                    self.prefix_len.value_namespace = name_space
                                    self.prefix_len.value_namespace_prefix = name_space_prefix
                                if(value_path == "router-flags"):
                                    self.router_flags = value
                                    self.router_flags.value_namespace = name_space
                                    self.router_flags.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class PwListData(Entity):
                            """
                            pw list data
                            
                            .. attribute:: pwhe_list_id
                            
                            	Pseudowire List Identifier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.PwListData, self).__init__()

                                self.yang_name = "pw-list-data"
                                self.yang_parent_name = "fpi"

                                self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("pwhe_list_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.PwListData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.PwListData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.pwhe_list_id.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.pwhe_list_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pw-list-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "pwhe-list-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "pwhe-list-id"):
                                    self.pwhe_list_id = value
                                    self.pwhe_list_id.value_namespace = name_space
                                    self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                        class DmtcExtIntfData(Entity):
                            """
                            dmtc ext intf data
                            
                            .. attribute:: dmtc_ext_ifh
                            
                            	DMTC External Interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.DmtcExtIntfData, self).__init__()

                                self.yang_name = "dmtc-ext-intf-data"
                                self.yang_parent_name = "fpi"

                                self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.dmtc_ext_ifh.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "dmtc-ext-intf-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-ifh"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "dmtc-ext-ifh"):
                                    self.dmtc_ext_ifh = value
                                    self.dmtc_ext_ifh.value_namespace = name_space
                                    self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fpi_type.is_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                (self.label_data is not None and self.label_data.has_data()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                (self.te_data is not None and self.te_data.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fpi_type.yfilter != YFilter.not_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                (self.label_data is not None and self.label_data.has_operation()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                (self.te_data is not None and self.te_data.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fpi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fpi_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "dmtc-ext-intf-data"):
                                if (self.dmtc_ext_intf_data is None):
                                    self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.DmtcExtIntfData()
                                    self.dmtc_ext_intf_data.parent = self
                                    self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                return self.dmtc_ext_intf_data

                            if (child_yang_name == "ipv4-data"):
                                if (self.ipv4_data is None):
                                    self.ipv4_data = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                return self.ipv4_data

                            if (child_yang_name == "ipv6-data"):
                                if (self.ipv6_data is None):
                                    self.ipv6_data = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                return self.ipv6_data

                            if (child_yang_name == "label-data"):
                                if (self.label_data is None):
                                    self.label_data = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.LabelData()
                                    self.label_data.parent = self
                                    self._children_name_map["label_data"] = "label-data"
                                return self.label_data

                            if (child_yang_name == "pw-list-data"):
                                if (self.pw_list_data is None):
                                    self.pw_list_data = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.PwListData()
                                    self.pw_list_data.parent = self
                                    self._children_name_map["pw_list_data"] = "pw-list-data"
                                return self.pw_list_data

                            if (child_yang_name == "te-data"):
                                if (self.te_data is None):
                                    self.te_data = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi.TeData()
                                    self.te_data.parent = self
                                    self._children_name_map["te_data"] = "te-data"
                                return self.te_data

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fpi-type"):
                                self.fpi_type = value
                                self.fpi_type.value_namespace = name_space
                                self.fpi_type.value_namespace_prefix = name_space_prefix


                    class ApplicationOwner(Entity):
                        """
                        Application owner instance
                        
                        .. attribute:: application_instance
                        
                        	Application instance Name
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        .. attribute:: resource_state
                        
                        	Application resource state
                        	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.ApplicationOwner, self).__init__()

                            self.yang_name = "application-owner"
                            self.yang_parent_name = "fpi-key"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                            self.resource_state = YLeaf(YType.enumeration, "resource-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type",
                                            "resource_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.ApplicationOwner, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.ApplicationOwner, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set or
                                self.resource_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set or
                                self.resource_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application-owner" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())
                            if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resource_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "resource-state"):
                                self.resource_state = value
                                self.resource_state.value_namespace = name_space
                                self.resource_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.application_owner:
                            if (c.has_data()):
                                return True
                        return (self.fpi is not None and self.fpi.has_data())

                    def has_operation(self):
                        for c in self.application_owner:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.fpi is not None and self.fpi.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "fpi-key" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application-owner"):
                            for c in self.application_owner:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.ApplicationOwner()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.application_owner.append(c)
                            return c

                        if (child_yang_name == "fpi"):
                            if (self.fpi is None):
                                self.fpi = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey.Fpi()
                                self.fpi.parent = self
                                self._children_name_map["fpi"] = "fpi"
                            return self.fpi

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-owner" or name == "fpi"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class RewriteId(Entity):
                    """
                    Rewrite ID
                    
                    .. attribute:: rewrite_id
                    
                    	Rewrite ID
                    	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId, self).__init__()

                        self.yang_name = "rewrite-id"
                        self.yang_parent_name = "rewrite-pw"

                        self.rewrite_id = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId()
                        self.rewrite_id.parent = self
                        self._children_name_map["rewrite_id"] = "rewrite-id"
                        self._children_yang_names.add("rewrite-id")


                    class RewriteId(Entity):
                        """
                        Rewrite ID
                        
                        .. attribute:: label_context
                        
                        	Label context
                        	**type**\:   :py:class:`LabelContext <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext>`
                        
                        .. attribute:: local_label_rewrite
                        
                        	Local label rewrite information
                        	**type**\:   :py:class:`LocalLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LocalLabelRewrite>`
                        
                        .. attribute:: rewrite_id_type
                        
                        	RewriteIDType
                        	**type**\:   :py:class:`MgmtLsdRwId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdRwId>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId, self).__init__()

                            self.yang_name = "rewrite-id"
                            self.yang_parent_name = "rewrite-id"

                            self.rewrite_id_type = YLeaf(YType.enumeration, "rewrite-id-type")

                            self.label_context = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext()
                            self.label_context.parent = self
                            self._children_name_map["label_context"] = "label-context"
                            self._children_yang_names.add("label-context")

                            self.local_label_rewrite = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LocalLabelRewrite()
                            self.local_label_rewrite.parent = self
                            self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                            self._children_yang_names.add("local-label-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("rewrite_id_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId, self).__setattr__(name, value)


                        class LabelContext(Entity):
                            """
                            Label context
                            
                            .. attribute:: cev4l3vpn_data
                            
                            	L3VPN CEv4 label context
                            	**type**\:   :py:class:`Cev4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev4L3VpnData>`
                            
                            .. attribute:: cev6l3vpn_data
                            
                            	L3VPN CEv6 label context
                            	**type**\:   :py:class:`Cev6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev6L3VpnData>`
                            
                            .. attribute:: evpn_data
                            
                            	EVPN context
                            	**type**\:   :py:class:`EvpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.EvpnData>`
                            
                            .. attribute:: generic_routing_encapsulation
                            
                            	Generic routing encapsulation context
                            	**type**\:   :py:class:`GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation>`
                            
                            .. attribute:: ip_sub_data
                            
                            	IP Subscriber context
                            	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.IpSubData>`
                            
                            .. attribute:: ipv4_data
                            
                            	IPv4 label context
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4Data>`
                            
                            .. attribute:: ipv4blb_data
                            
                            	BFD BLB label context
                            	**type**\:   :py:class:`Ipv4BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4BlbData>`
                            
                            .. attribute:: ipv4l3vpn_data
                            
                            	L3VPN IPv4 label context
                            	**type**\:   :py:class:`Ipv4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData>`
                            
                            .. attribute:: ipv6_data
                            
                            	IPv6 label context
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6Data>`
                            
                            .. attribute:: ipv6_generic_routing_encapsulation
                            
                            	Generic routing encapsulation context
                            	**type**\:   :py:class:`Ipv6GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation>`
                            
                            .. attribute:: ipv6blb_data
                            
                            	BFD BLB label context
                            	**type**\:   :py:class:`Ipv6BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6BlbData>`
                            
                            .. attribute:: ipv6l3vpn_data
                            
                            	L3VPN IPv6 label context
                            	**type**\:   :py:class:`Ipv6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData>`
                            
                            .. attribute:: label_block_data
                            
                            	Label block context
                            	**type**\:   :py:class:`LabelBlockData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockData>`
                            
                            .. attribute:: label_block_srgb_data
                            
                            	Label block SRGB context
                            	**type**\:   :py:class:`LabelBlockSrgbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData>`
                            
                            .. attribute:: label_context_type
                            
                            	LabelContextType
                            	**type**\:   :py:class:`MgmtLsdLblCtx <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLblCtx>`
                            
                            .. attribute:: mld_pv4_data
                            
                            	MLDPv4 LSM\-ID context
                            	**type**\:   :py:class:`MldPv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.MldPv4Data>`
                            
                            .. attribute:: next_hop_set_l3vpn
                            
                            	L3VPN NH SET label context
                            	**type**\:   :py:class:`NextHopSetL3Vpn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn>`
                            
                            .. attribute:: pi_mi_pmsi_data
                            
                            	PIM I\-PMSI label conext
                            	**type**\:   :py:class:`PiMiPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMiPmsiData>`
                            
                            .. attribute:: pi_ms_pmsi_data
                            
                            	PIM S\-PMSI label conext
                            	**type**\:   :py:class:`PiMsPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMsPmsiData>`
                            
                            .. attribute:: pseudowire_data
                            
                            	Pseudowire label context
                            	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireData>`
                            
                            .. attribute:: pseudowire_head_end_data
                            
                            	Pseudowire Head\-end label context
                            	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData>`
                            
                            .. attribute:: sr_adj_segment_ipv4
                            
                            	SR Adj Segment ipv4 context
                            	**type**\:   :py:class:`SrAdjSegmentIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4>`
                            
                            .. attribute:: sr_adj_segment_ipv6
                            
                            	SR Adj Segment ipv6 context
                            	**type**\:   :py:class:`SrAdjSegmentIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6>`
                            
                            .. attribute:: sr_prefix_segment
                            
                            	SR Prefix Segment context
                            	**type**\:   :py:class:`SrPrefixSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrPrefixSegment>`
                            
                            .. attribute:: te_binding
                            
                            	MPLS TE tunnel binding context
                            	**type**\:   :py:class:`TeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TeBinding>`
                            
                            .. attribute:: tev4_data
                            
                            	TEv4 label context
                            	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4Data>`
                            
                            .. attribute:: tev4p2mp_data
                            
                            	TEv4 P2MP context
                            	**type**\:   :py:class:`Tev4P2MpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4P2MpData>`
                            
                            .. attribute:: tp_data
                            
                            	TP context
                            	**type**\:   :py:class:`TpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TpData>`
                            
                            .. attribute:: vrf_l3vpn_data
                            
                            	L3VPN VRF label context
                            	**type**\:   :py:class:`VrfL3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.VrfL3VpnData>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext, self).__init__()

                                self.yang_name = "label-context"
                                self.yang_parent_name = "rewrite-id"

                                self.label_context_type = YLeaf(YType.enumeration, "label-context-type")

                                self.cev4l3vpn_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                self.cev4l3vpn_data.parent = self
                                self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                self._children_yang_names.add("cev4l3vpn-data")

                                self.cev6l3vpn_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                self.cev6l3vpn_data.parent = self
                                self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                self._children_yang_names.add("cev6l3vpn-data")

                                self.evpn_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.EvpnData()
                                self.evpn_data.parent = self
                                self._children_name_map["evpn_data"] = "evpn-data"
                                self._children_yang_names.add("evpn-data")

                                self.generic_routing_encapsulation = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                self.generic_routing_encapsulation.parent = self
                                self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                self._children_yang_names.add("generic-routing-encapsulation")

                                self.ip_sub_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.IpSubData()
                                self.ip_sub_data.parent = self
                                self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                self._children_yang_names.add("ip-sub-data")

                                self.ipv4_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv4blb_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                self.ipv4blb_data.parent = self
                                self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                self._children_yang_names.add("ipv4blb-data")

                                self.ipv4l3vpn_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                self.ipv4l3vpn_data.parent = self
                                self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                self._children_yang_names.add("ipv4l3vpn-data")

                                self.ipv6_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.ipv6_generic_routing_encapsulation = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                self.ipv6_generic_routing_encapsulation.parent = self
                                self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                self._children_yang_names.add("ipv6-generic-routing-encapsulation")

                                self.ipv6blb_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                self.ipv6blb_data.parent = self
                                self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                self._children_yang_names.add("ipv6blb-data")

                                self.ipv6l3vpn_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                self.ipv6l3vpn_data.parent = self
                                self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                self._children_yang_names.add("ipv6l3vpn-data")

                                self.label_block_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                self.label_block_data.parent = self
                                self._children_name_map["label_block_data"] = "label-block-data"
                                self._children_yang_names.add("label-block-data")

                                self.label_block_srgb_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                self.label_block_srgb_data.parent = self
                                self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                self._children_yang_names.add("label-block-srgb-data")

                                self.mld_pv4_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                self.mld_pv4_data.parent = self
                                self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                self._children_yang_names.add("mld-pv4-data")

                                self.next_hop_set_l3vpn = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                self.next_hop_set_l3vpn.parent = self
                                self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                self._children_yang_names.add("next-hop-set-l3vpn")

                                self.pi_mi_pmsi_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                self.pi_mi_pmsi_data.parent = self
                                self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                self._children_yang_names.add("pi-mi-pmsi-data")

                                self.pi_ms_pmsi_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                self.pi_ms_pmsi_data.parent = self
                                self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                self._children_yang_names.add("pi-ms-pmsi-data")

                                self.pseudowire_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireData()
                                self.pseudowire_data.parent = self
                                self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                self._children_yang_names.add("pseudowire-data")

                                self.pseudowire_head_end_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                self.pseudowire_head_end_data.parent = self
                                self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                self._children_yang_names.add("pseudowire-head-end-data")

                                self.sr_adj_segment_ipv4 = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                self.sr_adj_segment_ipv4.parent = self
                                self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                self._children_yang_names.add("sr-adj-segment-ipv4")

                                self.sr_adj_segment_ipv6 = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                self.sr_adj_segment_ipv6.parent = self
                                self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                self._children_yang_names.add("sr-adj-segment-ipv6")

                                self.sr_prefix_segment = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                self.sr_prefix_segment.parent = self
                                self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                self._children_yang_names.add("sr-prefix-segment")

                                self.te_binding = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TeBinding()
                                self.te_binding.parent = self
                                self._children_name_map["te_binding"] = "te-binding"
                                self._children_yang_names.add("te-binding")

                                self.tev4_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4Data()
                                self.tev4_data.parent = self
                                self._children_name_map["tev4_data"] = "tev4-data"
                                self._children_yang_names.add("tev4-data")

                                self.tev4p2mp_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                self.tev4p2mp_data.parent = self
                                self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                self._children_yang_names.add("tev4p2mp-data")

                                self.tp_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TpData()
                                self.tp_data.parent = self
                                self._children_name_map["tp_data"] = "tp-data"
                                self._children_yang_names.add("tp-data")

                                self.vrf_l3vpn_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                self.vrf_l3vpn_data.parent = self
                                self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                self._children_yang_names.add("vrf-l3vpn-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_context_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)


                            class Ipv4Data(Entity):
                                """
                                IPv4 label context
                                
                                .. attribute:: prefix
                                
                                	IPv4 prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	IPv4 prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf_name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                	**length:** 0..33
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.vrf_name = YLeaf(YType.str, "vrf-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "security_id",
                                                    "table_id",
                                                    "vrf_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set or
                                        self.vrf_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.vrf_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-name"):
                                        self.vrf_name = value
                                        self.vrf_name.value_namespace = name_space
                                        self.vrf_name.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                IPv6 label context
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf_name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                	**length:** 0..33
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.vrf_name = YLeaf(YType.str, "vrf-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "security_id",
                                                    "table_id",
                                                    "vrf_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set or
                                        self.vrf_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.vrf_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-name"):
                                        self.vrf_name = value
                                        self.vrf_name.value_namespace = name_space
                                        self.vrf_name.value_namespace_prefix = name_space_prefix


                            class Tev4Data(Entity):
                                """
                                TEv4 label context
                                
                                .. attribute:: is_srte
                                
                                	Is this an SRTE head tunnel
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_dest
                                
                                	Tunnel destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_id_extension
                                
                                	Extended tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_lsp_id
                                
                                	Tunnel LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_source
                                
                                	Tunnel source
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4Data, self).__init__()

                                    self.yang_name = "tev4-data"
                                    self.yang_parent_name = "label-context"

                                    self.is_srte = YLeaf(YType.int32, "is-srte")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.tunnel_dest = YLeaf(YType.str, "tunnel-dest")

                                    self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                    self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                    self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                    self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_srte",
                                                    "table_id",
                                                    "tunnel_dest",
                                                    "tunnel_id",
                                                    "tunnel_id_extension",
                                                    "tunnel_lsp_id",
                                                    "tunnel_source") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_srte.is_set or
                                        self.table_id.is_set or
                                        self.tunnel_dest.is_set or
                                        self.tunnel_id.is_set or
                                        self.tunnel_id_extension.is_set or
                                        self.tunnel_lsp_id.is_set or
                                        self.tunnel_source.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_srte.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.tunnel_dest.yfilter != YFilter.not_set or
                                        self.tunnel_id.yfilter != YFilter.not_set or
                                        self.tunnel_id_extension.yfilter != YFilter.not_set or
                                        self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                        self.tunnel_source.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tev4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_srte.is_set or self.is_srte.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_srte.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.tunnel_dest.is_set or self.tunnel_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_dest.get_name_leafdata())
                                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                    if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                    if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                    if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-srte" or name == "table-id" or name == "tunnel-dest" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-srte"):
                                        self.is_srte = value
                                        self.is_srte.value_namespace = name_space
                                        self.is_srte.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-dest"):
                                        self.tunnel_dest = value
                                        self.tunnel_dest.value_namespace = name_space
                                        self.tunnel_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id"):
                                        self.tunnel_id = value
                                        self.tunnel_id.value_namespace = name_space
                                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id-extension"):
                                        self.tunnel_id_extension = value
                                        self.tunnel_id_extension.value_namespace = name_space
                                        self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-lsp-id"):
                                        self.tunnel_lsp_id = value
                                        self.tunnel_lsp_id.value_namespace = name_space
                                        self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-source"):
                                        self.tunnel_source = value
                                        self.tunnel_source.value_namespace = name_space
                                        self.tunnel_source.value_namespace_prefix = name_space_prefix


                            class Ipv4L3VpnData(Entity):
                                """
                                L3VPN IPv4 label context
                                
                                .. attribute:: prefix
                                
                                	IPv4 prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: route_distinguisher
                                
                                	Route distinguisher
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__init__()

                                    self.yang_name = "ipv4l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "route_distinguisher") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.route_distinguisher.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.route_distinguisher.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-distinguisher"):
                                        self.route_distinguisher = value
                                        self.route_distinguisher.value_namespace = name_space
                                        self.route_distinguisher.value_namespace_prefix = name_space_prefix


                            class Ipv6L3VpnData(Entity):
                                """
                                L3VPN IPv6 label context
                                
                                .. attribute:: prefix
                                
                                	IPv6 prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: route_distinguisher
                                
                                	Route distinguisher
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__init__()

                                    self.yang_name = "ipv6l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "route_distinguisher") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.route_distinguisher.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.route_distinguisher.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-distinguisher"):
                                        self.route_distinguisher = value
                                        self.route_distinguisher.value_namespace = name_space
                                        self.route_distinguisher.value_namespace_prefix = name_space_prefix


                            class VrfL3VpnData(Entity):
                                """
                                L3VPN VRF label context
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__init__()

                                    self.yang_name = "vrf-l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("security_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.security_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf-l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "security-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class Cev4L3VpnData(Entity):
                                """
                                L3VPN CEv4 label context
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__init__()

                                    self.yang_name = "cev4l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_next_hop",
                                                    "security_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ipv4_next_hop.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "cev4l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-next-hop" or name == "security-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class Cev6L3VpnData(Entity):
                                """
                                L3VPN CEv6 label context
                                
                                .. attribute:: ipv6_next_hop
                                
                                	IPv6 nexthop
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__init__()

                                    self.yang_name = "cev6l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv6_next_hop",
                                                    "security_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ipv6_next_hop.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv6_next_hop.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "cev6l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv6-next-hop" or name == "security-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv6-next-hop"):
                                        self.ipv6_next_hop = value
                                        self.ipv6_next_hop.value_namespace = name_space
                                        self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class PseudowireData(Entity):
                                """
                                Pseudowire label context
                                
                                .. attribute:: prefix
                                
                                	Address prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: pseudowire_id
                                
                                	Pseudo\-wire ID
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: remote_l2_router_id
                                
                                	Remote L2 Router ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: subinterface
                                
                                	Subinterface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireData, self).__init__()

                                    self.yang_name = "pseudowire-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.pseudowire_id = YLeaf(YType.uint64, "pseudowire-id")

                                    self.remote_l2_router_id = YLeaf(YType.uint32, "remote-l2-router-id")

                                    self.subinterface = YLeaf(YType.str, "subinterface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "pseudowire_id",
                                                    "remote_l2_router_id",
                                                    "subinterface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.pseudowire_id.is_set or
                                        self.remote_l2_router_id.is_set or
                                        self.subinterface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.pseudowire_id.yfilter != YFilter.not_set or
                                        self.remote_l2_router_id.yfilter != YFilter.not_set or
                                        self.subinterface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pseudowire_id.get_name_leafdata())
                                    if (self.remote_l2_router_id.is_set or self.remote_l2_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.remote_l2_router_id.get_name_leafdata())
                                    if (self.subinterface.is_set or self.subinterface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.subinterface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "pseudowire-id" or name == "remote-l2-router-id" or name == "subinterface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pseudowire-id"):
                                        self.pseudowire_id = value
                                        self.pseudowire_id.value_namespace = name_space
                                        self.pseudowire_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "remote-l2-router-id"):
                                        self.remote_l2_router_id = value
                                        self.remote_l2_router_id.value_namespace = name_space
                                        self.remote_l2_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "subinterface"):
                                        self.subinterface = value
                                        self.subinterface.value_namespace = name_space
                                        self.subinterface.value_namespace_prefix = name_space_prefix


                            class LabelBlockData(Entity):
                                """
                                Label block context
                                
                                .. attribute:: edge_id
                                
                                	Edge ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: offset
                                
                                	Offset
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: service
                                
                                	Service
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: size
                                
                                	Number of labels
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vpn_id
                                
                                	VPN ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__init__()

                                    self.yang_name = "label-block-data"
                                    self.yang_parent_name = "label-context"

                                    self.edge_id = YLeaf(YType.uint16, "edge-id")

                                    self.offset = YLeaf(YType.uint32, "offset")

                                    self.service = YLeaf(YType.uint8, "service")

                                    self.size = YLeaf(YType.uint32, "size")

                                    self.vpn_id = YLeaf(YType.uint16, "vpn-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("edge_id",
                                                    "offset",
                                                    "service",
                                                    "size",
                                                    "vpn_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.edge_id.is_set or
                                        self.offset.is_set or
                                        self.service.is_set or
                                        self.size.is_set or
                                        self.vpn_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.edge_id.yfilter != YFilter.not_set or
                                        self.offset.yfilter != YFilter.not_set or
                                        self.service.yfilter != YFilter.not_set or
                                        self.size.yfilter != YFilter.not_set or
                                        self.vpn_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-block-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.edge_id.is_set or self.edge_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.edge_id.get_name_leafdata())
                                    if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.offset.get_name_leafdata())
                                    if (self.service.is_set or self.service.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service.get_name_leafdata())
                                    if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.size.get_name_leafdata())
                                    if (self.vpn_id.is_set or self.vpn_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vpn_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "edge-id" or name == "offset" or name == "service" or name == "size" or name == "vpn-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "edge-id"):
                                        self.edge_id = value
                                        self.edge_id.value_namespace = name_space
                                        self.edge_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "offset"):
                                        self.offset = value
                                        self.offset.value_namespace = name_space
                                        self.offset.value_namespace_prefix = name_space_prefix
                                    if(value_path == "service"):
                                        self.service = value
                                        self.service.value_namespace = name_space
                                        self.service.value_namespace_prefix = name_space_prefix
                                    if(value_path == "size"):
                                        self.size = value
                                        self.size.value_namespace = name_space
                                        self.size.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vpn-id"):
                                        self.vpn_id = value
                                        self.vpn_id.value_namespace = name_space
                                        self.vpn_id.value_namespace_prefix = name_space_prefix


                            class IpSubData(Entity):
                                """
                                IP Subscriber context
                                
                                .. attribute:: parent_interface
                                
                                	Parent interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: table_id
                                
                                	Table Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.IpSubData, self).__init__()

                                    self.yang_name = "ip-sub-data"
                                    self.yang_parent_name = "label-context"

                                    self.parent_interface = YLeaf(YType.str, "parent-interface")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("parent_interface",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.parent_interface.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.parent_interface.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ip-sub-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.parent_interface.is_set or self.parent_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "parent-interface" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "parent-interface"):
                                        self.parent_interface = value
                                        self.parent_interface.value_namespace = name_space
                                        self.parent_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class Tev4P2MpData(Entity):
                                """
                                TEv4 P2MP context
                                
                                .. attribute:: p2mp_id
                                
                                	Point to multipoint ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: previous_hop
                                
                                	Previous hop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_id_extension
                                
                                	Tunnel ID extension
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_lsp_id
                                
                                	Tunnel LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_source
                                
                                	Tunnel source
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__init__()

                                    self.yang_name = "tev4p2mp-data"
                                    self.yang_parent_name = "label-context"

                                    self.p2mp_id = YLeaf(YType.uint32, "p2mp-id")

                                    self.previous_hop = YLeaf(YType.str, "previous-hop")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                    self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                    self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                    self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("p2mp_id",
                                                    "previous_hop",
                                                    "table_id",
                                                    "tunnel_id",
                                                    "tunnel_id_extension",
                                                    "tunnel_lsp_id",
                                                    "tunnel_source") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.p2mp_id.is_set or
                                        self.previous_hop.is_set or
                                        self.table_id.is_set or
                                        self.tunnel_id.is_set or
                                        self.tunnel_id_extension.is_set or
                                        self.tunnel_lsp_id.is_set or
                                        self.tunnel_source.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.p2mp_id.yfilter != YFilter.not_set or
                                        self.previous_hop.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.tunnel_id.yfilter != YFilter.not_set or
                                        self.tunnel_id_extension.yfilter != YFilter.not_set or
                                        self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                        self.tunnel_source.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tev4p2mp-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                                    if (self.previous_hop.is_set or self.previous_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.previous_hop.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                    if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                    if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                    if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "p2mp-id" or name == "previous-hop" or name == "table-id" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "p2mp-id"):
                                        self.p2mp_id = value
                                        self.p2mp_id.value_namespace = name_space
                                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "previous-hop"):
                                        self.previous_hop = value
                                        self.previous_hop.value_namespace = name_space
                                        self.previous_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id"):
                                        self.tunnel_id = value
                                        self.tunnel_id.value_namespace = name_space
                                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id-extension"):
                                        self.tunnel_id_extension = value
                                        self.tunnel_id_extension.value_namespace = name_space
                                        self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-lsp-id"):
                                        self.tunnel_lsp_id = value
                                        self.tunnel_lsp_id.value_namespace = name_space
                                        self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-source"):
                                        self.tunnel_source = value
                                        self.tunnel_source.value_namespace = name_space
                                        self.tunnel_source.value_namespace_prefix = name_space_prefix


                            class MldPv4Data(Entity):
                                """
                                MLDPv4 LSM\-ID context
                                
                                .. attribute:: lsm_id
                                
                                	LSM ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: peer_label_space_id
                                
                                	Peer Label Space Id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: peer_lsrid
                                
                                	Peer LSR Id
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: type
                                
                                	LSM ID Type
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__init__()

                                    self.yang_name = "mld-pv4-data"
                                    self.yang_parent_name = "label-context"

                                    self.lsm_id = YLeaf(YType.uint32, "lsm-id")

                                    self.peer_label_space_id = YLeaf(YType.uint16, "peer-label-space-id")

                                    self.peer_lsrid = YLeaf(YType.str, "peer-lsrid")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("lsm_id",
                                                    "peer_label_space_id",
                                                    "peer_lsrid",
                                                    "table_id",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.lsm_id.is_set or
                                        self.peer_label_space_id.is_set or
                                        self.peer_lsrid.is_set or
                                        self.table_id.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.lsm_id.yfilter != YFilter.not_set or
                                        self.peer_label_space_id.yfilter != YFilter.not_set or
                                        self.peer_lsrid.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "mld-pv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.lsm_id.is_set or self.lsm_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsm_id.get_name_leafdata())
                                    if (self.peer_label_space_id.is_set or self.peer_label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_label_space_id.get_name_leafdata())
                                    if (self.peer_lsrid.is_set or self.peer_lsrid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_lsrid.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "lsm-id" or name == "peer-label-space-id" or name == "peer-lsrid" or name == "table-id" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "lsm-id"):
                                        self.lsm_id = value
                                        self.lsm_id.value_namespace = name_space
                                        self.lsm_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-label-space-id"):
                                        self.peer_label_space_id = value
                                        self.peer_label_space_id.value_namespace = name_space
                                        self.peer_label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-lsrid"):
                                        self.peer_lsrid = value
                                        self.peer_lsrid.value_namespace = name_space
                                        self.peer_lsrid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class PseudowireHeadEndData(Entity):
                                """
                                Pseudowire Head\-end label context
                                
                                .. attribute:: pwhe_intf
                                
                                	Pseudo\-wire Head\-end interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__init__()

                                    self.yang_name = "pseudowire-head-end-data"
                                    self.yang_parent_name = "label-context"

                                    self.pwhe_intf = YLeaf(YType.str, "pwhe-intf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("pwhe_intf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.pwhe_intf.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.pwhe_intf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-head-end-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.pwhe_intf.is_set or self.pwhe_intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_intf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "pwhe-intf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "pwhe-intf"):
                                        self.pwhe_intf = value
                                        self.pwhe_intf.value_namespace = name_space
                                        self.pwhe_intf.value_namespace_prefix = name_space_prefix


                            class TpData(Entity):
                                """
                                TP context
                                
                                .. attribute:: dest_global_id
                                
                                	TP destination global ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: dest_node_id
                                
                                	TP destination node ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: dest_tunnel_id
                                
                                	TP destination tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsp_id
                                
                                	TP LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: source_global_id
                                
                                	TP source global ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: source_node_id
                                
                                	TP source node ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: source_tunnel_id
                                
                                	TP source tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TpData, self).__init__()

                                    self.yang_name = "tp-data"
                                    self.yang_parent_name = "label-context"

                                    self.dest_global_id = YLeaf(YType.uint32, "dest-global-id")

                                    self.dest_node_id = YLeaf(YType.str, "dest-node-id")

                                    self.dest_tunnel_id = YLeaf(YType.uint16, "dest-tunnel-id")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                    self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                                    self.source_node_id = YLeaf(YType.str, "source-node-id")

                                    self.source_tunnel_id = YLeaf(YType.uint16, "source-tunnel-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dest_global_id",
                                                    "dest_node_id",
                                                    "dest_tunnel_id",
                                                    "lsp_id",
                                                    "source_global_id",
                                                    "source_node_id",
                                                    "source_tunnel_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.dest_global_id.is_set or
                                        self.dest_node_id.is_set or
                                        self.dest_tunnel_id.is_set or
                                        self.lsp_id.is_set or
                                        self.source_global_id.is_set or
                                        self.source_node_id.is_set or
                                        self.source_tunnel_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dest_global_id.yfilter != YFilter.not_set or
                                        self.dest_node_id.yfilter != YFilter.not_set or
                                        self.dest_tunnel_id.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set or
                                        self.source_global_id.yfilter != YFilter.not_set or
                                        self.source_node_id.yfilter != YFilter.not_set or
                                        self.source_tunnel_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tp-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dest_global_id.is_set or self.dest_global_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dest_global_id.get_name_leafdata())
                                    if (self.dest_node_id.is_set or self.dest_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dest_node_id.get_name_leafdata())
                                    if (self.dest_tunnel_id.is_set or self.dest_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dest_tunnel_id.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                                    if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_global_id.get_name_leafdata())
                                    if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_node_id.get_name_leafdata())
                                    if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dest-global-id" or name == "dest-node-id" or name == "dest-tunnel-id" or name == "lsp-id" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dest-global-id"):
                                        self.dest_global_id = value
                                        self.dest_global_id.value_namespace = name_space
                                        self.dest_global_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dest-node-id"):
                                        self.dest_node_id = value
                                        self.dest_node_id.value_namespace = name_space
                                        self.dest_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dest-tunnel-id"):
                                        self.dest_tunnel_id = value
                                        self.dest_tunnel_id.value_namespace = name_space
                                        self.dest_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-global-id"):
                                        self.source_global_id = value
                                        self.source_global_id.value_namespace = name_space
                                        self.source_global_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-node-id"):
                                        self.source_node_id = value
                                        self.source_node_id.value_namespace = name_space
                                        self.source_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-tunnel-id"):
                                        self.source_tunnel_id = value
                                        self.source_tunnel_id.value_namespace = name_space
                                        self.source_tunnel_id.value_namespace_prefix = name_space_prefix


                            class GenericRoutingEncapsulation(Entity):
                                """
                                Generic routing encapsulation context
                                
                                .. attribute:: gre_interface
                                
                                	Generic routing encapsulation interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__init__()

                                    self.yang_name = "generic-routing-encapsulation"
                                    self.yang_parent_name = "label-context"

                                    self.gre_interface = YLeaf(YType.str, "gre-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("gre_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.gre_interface.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.gre_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "generic-routing-encapsulation" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.gre_interface.is_set or self.gre_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gre_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "gre-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "gre-interface"):
                                        self.gre_interface = value
                                        self.gre_interface.value_namespace = name_space
                                        self.gre_interface.value_namespace_prefix = name_space_prefix


                            class Ipv6GenericRoutingEncapsulation(Entity):
                                """
                                Generic routing encapsulation context
                                
                                .. attribute:: greipv6_interface
                                
                                	Generic routing encapsulation IPv6 interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__init__()

                                    self.yang_name = "ipv6-generic-routing-encapsulation"
                                    self.yang_parent_name = "label-context"

                                    self.greipv6_interface = YLeaf(YType.str, "greipv6-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("greipv6_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.greipv6_interface.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.greipv6_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-generic-routing-encapsulation" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.greipv6_interface.is_set or self.greipv6_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.greipv6_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "greipv6-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "greipv6-interface"):
                                        self.greipv6_interface = value
                                        self.greipv6_interface.value_namespace = name_space
                                        self.greipv6_interface.value_namespace_prefix = name_space_prefix


                            class EvpnData(Entity):
                                """
                                EVPN context
                                
                                .. attribute:: ethernet_segment
                                
                                	Ethernet Segment ID
                                	**type**\:  str
                                
                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                
                                .. attribute:: evpn_id
                                
                                	EVPN ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: evpn_tag
                                
                                	EVPN TAG
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.EvpnData, self).__init__()

                                    self.yang_name = "evpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.ethernet_segment = YLeaf(YType.str, "ethernet-segment")

                                    self.evpn_id = YLeaf(YType.uint32, "evpn-id")

                                    self.evpn_tag = YLeaf(YType.uint32, "evpn-tag")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ethernet_segment",
                                                    "evpn_id",
                                                    "evpn_tag") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ethernet_segment.is_set or
                                        self.evpn_id.is_set or
                                        self.evpn_tag.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ethernet_segment.yfilter != YFilter.not_set or
                                        self.evpn_id.yfilter != YFilter.not_set or
                                        self.evpn_tag.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "evpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ethernet_segment.is_set or self.ethernet_segment.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ethernet_segment.get_name_leafdata())
                                    if (self.evpn_id.is_set or self.evpn_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.evpn_id.get_name_leafdata())
                                    if (self.evpn_tag.is_set or self.evpn_tag.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.evpn_tag.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ethernet-segment" or name == "evpn-id" or name == "evpn-tag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ethernet-segment"):
                                        self.ethernet_segment = value
                                        self.ethernet_segment.value_namespace = name_space
                                        self.ethernet_segment.value_namespace_prefix = name_space_prefix
                                    if(value_path == "evpn-id"):
                                        self.evpn_id = value
                                        self.evpn_id.value_namespace = name_space
                                        self.evpn_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "evpn-tag"):
                                        self.evpn_tag = value
                                        self.evpn_tag.value_namespace = name_space
                                        self.evpn_tag.value_namespace_prefix = name_space_prefix


                            class Ipv4BlbData(Entity):
                                """
                                BFD BLB label context
                                
                                .. attribute:: blb_intf
                                
                                	BFD BLB interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: prefix
                                
                                	IPv4 prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__init__()

                                    self.yang_name = "ipv4blb-data"
                                    self.yang_parent_name = "label-context"

                                    self.blb_intf = YLeaf(YType.str, "blb-intf")

                                    self.prefix = YLeaf(YType.str, "prefix")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("blb_intf",
                                                    "prefix") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.blb_intf.is_set or
                                        self.prefix.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.blb_intf.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4blb-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "blb-intf" or name == "prefix"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "blb-intf"):
                                        self.blb_intf = value
                                        self.blb_intf.value_namespace = name_space
                                        self.blb_intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix


                            class Ipv6BlbData(Entity):
                                """
                                BFD BLB label context
                                
                                .. attribute:: blb_intf
                                
                                	BFD BLB interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: prefix
                                
                                	IPv6 prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__init__()

                                    self.yang_name = "ipv6blb-data"
                                    self.yang_parent_name = "label-context"

                                    self.blb_intf = YLeaf(YType.str, "blb-intf")

                                    self.prefix = YLeaf(YType.str, "prefix")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("blb_intf",
                                                    "prefix") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.blb_intf.is_set or
                                        self.prefix.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.blb_intf.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6blb-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "blb-intf" or name == "prefix"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "blb-intf"):
                                        self.blb_intf = value
                                        self.blb_intf.value_namespace = name_space
                                        self.blb_intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix


                            class PiMiPmsiData(Entity):
                                """
                                PIM I\-PMSI label conext
                                
                                .. attribute:: head
                                
                                	Head
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: v6
                                
                                	PIM6
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: vrf_id
                                
                                	VRF ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__init__()

                                    self.yang_name = "pi-mi-pmsi-data"
                                    self.yang_parent_name = "label-context"

                                    self.head = YLeaf(YType.int32, "head")

                                    self.v6 = YLeaf(YType.int32, "v6")

                                    self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("head",
                                                    "v6",
                                                    "vrf_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.head.is_set or
                                        self.v6.is_set or
                                        self.vrf_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.head.yfilter != YFilter.not_set or
                                        self.v6.yfilter != YFilter.not_set or
                                        self.vrf_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pi-mi-pmsi-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.head.get_name_leafdata())
                                    if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.v6.get_name_leafdata())
                                    if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "head" or name == "v6" or name == "vrf-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "head"):
                                        self.head = value
                                        self.head.value_namespace = name_space
                                        self.head.value_namespace_prefix = name_space_prefix
                                    if(value_path == "v6"):
                                        self.v6 = value
                                        self.v6.value_namespace = name_space
                                        self.v6.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-id"):
                                        self.vrf_id = value
                                        self.vrf_id.value_namespace = name_space
                                        self.vrf_id.value_namespace_prefix = name_space_prefix


                            class PiMsPmsiData(Entity):
                                """
                                PIM S\-PMSI label conext
                                
                                .. attribute:: head
                                
                                	Head
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: hli
                                
                                	Head LSM\-ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: seg
                                
                                	Segmented Multicast
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: source
                                
                                	Originating Router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: v6
                                
                                	PIM6
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: vrf_id
                                
                                	VRF ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__init__()

                                    self.yang_name = "pi-ms-pmsi-data"
                                    self.yang_parent_name = "label-context"

                                    self.head = YLeaf(YType.int32, "head")

                                    self.hli = YLeaf(YType.uint32, "hli")

                                    self.seg = YLeaf(YType.int32, "seg")

                                    self.source = YLeaf(YType.str, "source")

                                    self.v6 = YLeaf(YType.int32, "v6")

                                    self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("head",
                                                    "hli",
                                                    "seg",
                                                    "source",
                                                    "v6",
                                                    "vrf_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.head.is_set or
                                        self.hli.is_set or
                                        self.seg.is_set or
                                        self.source.is_set or
                                        self.v6.is_set or
                                        self.vrf_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.head.yfilter != YFilter.not_set or
                                        self.hli.yfilter != YFilter.not_set or
                                        self.seg.yfilter != YFilter.not_set or
                                        self.source.yfilter != YFilter.not_set or
                                        self.v6.yfilter != YFilter.not_set or
                                        self.vrf_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pi-ms-pmsi-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.head.get_name_leafdata())
                                    if (self.hli.is_set or self.hli.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hli.get_name_leafdata())
                                    if (self.seg.is_set or self.seg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.seg.get_name_leafdata())
                                    if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source.get_name_leafdata())
                                    if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.v6.get_name_leafdata())
                                    if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "head" or name == "hli" or name == "seg" or name == "source" or name == "v6" or name == "vrf-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "head"):
                                        self.head = value
                                        self.head.value_namespace = name_space
                                        self.head.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hli"):
                                        self.hli = value
                                        self.hli.value_namespace = name_space
                                        self.hli.value_namespace_prefix = name_space_prefix
                                    if(value_path == "seg"):
                                        self.seg = value
                                        self.seg.value_namespace = name_space
                                        self.seg.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source"):
                                        self.source = value
                                        self.source.value_namespace = name_space
                                        self.source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "v6"):
                                        self.v6 = value
                                        self.v6.value_namespace = name_space
                                        self.v6.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-id"):
                                        self.vrf_id = value
                                        self.vrf_id.value_namespace = name_space
                                        self.vrf_id.value_namespace_prefix = name_space_prefix


                            class NextHopSetL3Vpn(Entity):
                                """
                                L3VPN NH SET label context
                                
                                .. attribute:: next_hop_set_id
                                
                                	Next Hop Set ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__init__()

                                    self.yang_name = "next-hop-set-l3vpn"
                                    self.yang_parent_name = "label-context"

                                    self.next_hop_set_id = YLeaf(YType.uint32, "next-hop-set-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_set_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.next_hop_set_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_set_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "next-hop-set-l3vpn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_set_id.is_set or self.next_hop_set_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_set_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "next-hop-set-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-set-id"):
                                        self.next_hop_set_id = value
                                        self.next_hop_set_id.value_namespace = name_space
                                        self.next_hop_set_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class SrPrefixSegment(Entity):
                                """
                                SR Prefix Segment context
                                
                                .. attribute:: segment_id
                                
                                	Prefix Segment ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__init__()

                                    self.yang_name = "sr-prefix-segment"
                                    self.yang_parent_name = "label-context"

                                    self.segment_id = YLeaf(YType.uint32, "segment-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("segment_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.segment_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.segment_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-prefix-segment" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.segment_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "segment-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "segment-id"):
                                        self.segment_id = value
                                        self.segment_id.value_namespace = name_space
                                        self.segment_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class SrAdjSegmentIpv4(Entity):
                                """
                                SR Adj Segment ipv4 context
                                
                                .. attribute:: addr
                                
                                	Adjacency nexthop IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: index
                                
                                	Adjacency index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: intf
                                
                                	Adjacency interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: type
                                
                                	Adjacency type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__init__()

                                    self.yang_name = "sr-adj-segment-ipv4"
                                    self.yang_parent_name = "label-context"

                                    self.addr = YLeaf(YType.str, "addr")

                                    self.index = YLeaf(YType.uint32, "index")

                                    self.intf = YLeaf(YType.str, "intf")

                                    self.type = YLeaf(YType.uint32, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("addr",
                                                    "index",
                                                    "intf",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.addr.is_set or
                                        self.index.is_set or
                                        self.intf.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.addr.yfilter != YFilter.not_set or
                                        self.index.yfilter != YFilter.not_set or
                                        self.intf.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-adj-segment-ipv4" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.addr.get_name_leafdata())
                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.index.get_name_leafdata())
                                    if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intf.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "addr"):
                                        self.addr = value
                                        self.addr.value_namespace = name_space
                                        self.addr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "index"):
                                        self.index = value
                                        self.index.value_namespace = name_space
                                        self.index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intf"):
                                        self.intf = value
                                        self.intf.value_namespace = name_space
                                        self.intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class SrAdjSegmentIpv6(Entity):
                                """
                                SR Adj Segment ipv6 context
                                
                                .. attribute:: addr
                                
                                	Adjacency nexthop IPv6 address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: index
                                
                                	Adjacency index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: intf
                                
                                	Adjacency interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: type
                                
                                	Adjacency type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__init__()

                                    self.yang_name = "sr-adj-segment-ipv6"
                                    self.yang_parent_name = "label-context"

                                    self.addr = YLeaf(YType.str, "addr")

                                    self.index = YLeaf(YType.uint32, "index")

                                    self.intf = YLeaf(YType.str, "intf")

                                    self.type = YLeaf(YType.uint32, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("addr",
                                                    "index",
                                                    "intf",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.addr.is_set or
                                        self.index.is_set or
                                        self.intf.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.addr.yfilter != YFilter.not_set or
                                        self.index.yfilter != YFilter.not_set or
                                        self.intf.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-adj-segment-ipv6" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.addr.get_name_leafdata())
                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.index.get_name_leafdata())
                                    if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intf.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "addr"):
                                        self.addr = value
                                        self.addr.value_namespace = name_space
                                        self.addr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "index"):
                                        self.index = value
                                        self.index.value_namespace = name_space
                                        self.index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intf"):
                                        self.intf = value
                                        self.intf.value_namespace = name_space
                                        self.intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class LabelBlockSrgbData(Entity):
                                """
                                Label block SRGB context
                                
                                .. attribute:: offset
                                
                                	Offset
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: size
                                
                                	Number of labels
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: start_label
                                
                                	Start Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__init__()

                                    self.yang_name = "label-block-srgb-data"
                                    self.yang_parent_name = "label-context"

                                    self.offset = YLeaf(YType.uint32, "offset")

                                    self.size = YLeaf(YType.uint32, "size")

                                    self.start_label = YLeaf(YType.uint32, "start-label")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("offset",
                                                    "size",
                                                    "start_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.offset.is_set or
                                        self.size.is_set or
                                        self.start_label.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.offset.yfilter != YFilter.not_set or
                                        self.size.yfilter != YFilter.not_set or
                                        self.start_label.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-block-srgb-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.offset.get_name_leafdata())
                                    if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.size.get_name_leafdata())
                                    if (self.start_label.is_set or self.start_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.start_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "offset" or name == "size" or name == "start-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "offset"):
                                        self.offset = value
                                        self.offset.value_namespace = name_space
                                        self.offset.value_namespace_prefix = name_space_prefix
                                    if(value_path == "size"):
                                        self.size = value
                                        self.size.value_namespace = name_space
                                        self.size.value_namespace_prefix = name_space_prefix
                                    if(value_path == "start-label"):
                                        self.start_label = value
                                        self.start_label.value_namespace = name_space
                                        self.start_label.value_namespace_prefix = name_space_prefix


                            class TeBinding(Entity):
                                """
                                MPLS TE tunnel binding context
                                
                                .. attribute:: te_identifier
                                
                                	MPLS Traffic Engineering Tunnel or Group ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: te_type
                                
                                	Type of identifier for the binding
                                	**type**\:   :py:class:`MgmtLsdTeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdTeBinding>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TeBinding, self).__init__()

                                    self.yang_name = "te-binding"
                                    self.yang_parent_name = "label-context"

                                    self.te_identifier = YLeaf(YType.uint32, "te-identifier")

                                    self.te_type = YLeaf(YType.enumeration, "te-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("te_identifier",
                                                    "te_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.te_identifier.is_set or
                                        self.te_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.te_identifier.yfilter != YFilter.not_set or
                                        self.te_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-binding" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.te_identifier.is_set or self.te_identifier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_identifier.get_name_leafdata())
                                    if (self.te_type.is_set or self.te_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "te-identifier" or name == "te-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "te-identifier"):
                                        self.te_identifier = value
                                        self.te_identifier.value_namespace = name_space
                                        self.te_identifier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "te-type"):
                                        self.te_type = value
                                        self.te_type.value_namespace = name_space
                                        self.te_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.label_context_type.is_set or
                                    (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_data()) or
                                    (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_data()) or
                                    (self.evpn_data is not None and self.evpn_data.has_data()) or
                                    (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_data()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv4blb_data is not None and self.ipv4blb_data.has_data()) or
                                    (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_data()) or
                                    (self.ipv6blb_data is not None and self.ipv6blb_data.has_data()) or
                                    (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_data()) or
                                    (self.label_block_data is not None and self.label_block_data.has_data()) or
                                    (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_data()) or
                                    (self.mld_pv4_data is not None and self.mld_pv4_data.has_data()) or
                                    (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_data()) or
                                    (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_data()) or
                                    (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_data()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                    (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_data()) or
                                    (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_data()) or
                                    (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_data()) or
                                    (self.te_binding is not None and self.te_binding.has_data()) or
                                    (self.tev4_data is not None and self.tev4_data.has_data()) or
                                    (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_data()) or
                                    (self.tp_data is not None and self.tp_data.has_data()) or
                                    (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_context_type.yfilter != YFilter.not_set or
                                    (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_operation()) or
                                    (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_operation()) or
                                    (self.evpn_data is not None and self.evpn_data.has_operation()) or
                                    (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_operation()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv4blb_data is not None and self.ipv4blb_data.has_operation()) or
                                    (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_operation()) or
                                    (self.ipv6blb_data is not None and self.ipv6blb_data.has_operation()) or
                                    (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_operation()) or
                                    (self.label_block_data is not None and self.label_block_data.has_operation()) or
                                    (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_operation()) or
                                    (self.mld_pv4_data is not None and self.mld_pv4_data.has_operation()) or
                                    (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_operation()) or
                                    (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_operation()) or
                                    (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_operation()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                    (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_operation()) or
                                    (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_operation()) or
                                    (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_operation()) or
                                    (self.te_binding is not None and self.te_binding.has_operation()) or
                                    (self.tev4_data is not None and self.tev4_data.has_operation()) or
                                    (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_operation()) or
                                    (self.tp_data is not None and self.tp_data.has_operation()) or
                                    (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-context" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_context_type.is_set or self.label_context_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_context_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "cev4l3vpn-data"):
                                    if (self.cev4l3vpn_data is None):
                                        self.cev4l3vpn_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                        self.cev4l3vpn_data.parent = self
                                        self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                    return self.cev4l3vpn_data

                                if (child_yang_name == "cev6l3vpn-data"):
                                    if (self.cev6l3vpn_data is None):
                                        self.cev6l3vpn_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                        self.cev6l3vpn_data.parent = self
                                        self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                    return self.cev6l3vpn_data

                                if (child_yang_name == "evpn-data"):
                                    if (self.evpn_data is None):
                                        self.evpn_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.EvpnData()
                                        self.evpn_data.parent = self
                                        self._children_name_map["evpn_data"] = "evpn-data"
                                    return self.evpn_data

                                if (child_yang_name == "generic-routing-encapsulation"):
                                    if (self.generic_routing_encapsulation is None):
                                        self.generic_routing_encapsulation = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                        self.generic_routing_encapsulation.parent = self
                                        self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                    return self.generic_routing_encapsulation

                                if (child_yang_name == "ip-sub-data"):
                                    if (self.ip_sub_data is None):
                                        self.ip_sub_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.IpSubData()
                                        self.ip_sub_data.parent = self
                                        self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    return self.ip_sub_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv4blb-data"):
                                    if (self.ipv4blb_data is None):
                                        self.ipv4blb_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                        self.ipv4blb_data.parent = self
                                        self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                    return self.ipv4blb_data

                                if (child_yang_name == "ipv4l3vpn-data"):
                                    if (self.ipv4l3vpn_data is None):
                                        self.ipv4l3vpn_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                        self.ipv4l3vpn_data.parent = self
                                        self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                    return self.ipv4l3vpn_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "ipv6-generic-routing-encapsulation"):
                                    if (self.ipv6_generic_routing_encapsulation is None):
                                        self.ipv6_generic_routing_encapsulation = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                        self.ipv6_generic_routing_encapsulation.parent = self
                                        self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                    return self.ipv6_generic_routing_encapsulation

                                if (child_yang_name == "ipv6blb-data"):
                                    if (self.ipv6blb_data is None):
                                        self.ipv6blb_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                        self.ipv6blb_data.parent = self
                                        self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                    return self.ipv6blb_data

                                if (child_yang_name == "ipv6l3vpn-data"):
                                    if (self.ipv6l3vpn_data is None):
                                        self.ipv6l3vpn_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                        self.ipv6l3vpn_data.parent = self
                                        self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                    return self.ipv6l3vpn_data

                                if (child_yang_name == "label-block-data"):
                                    if (self.label_block_data is None):
                                        self.label_block_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                        self.label_block_data.parent = self
                                        self._children_name_map["label_block_data"] = "label-block-data"
                                    return self.label_block_data

                                if (child_yang_name == "label-block-srgb-data"):
                                    if (self.label_block_srgb_data is None):
                                        self.label_block_srgb_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                        self.label_block_srgb_data.parent = self
                                        self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                    return self.label_block_srgb_data

                                if (child_yang_name == "mld-pv4-data"):
                                    if (self.mld_pv4_data is None):
                                        self.mld_pv4_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                        self.mld_pv4_data.parent = self
                                        self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                    return self.mld_pv4_data

                                if (child_yang_name == "next-hop-set-l3vpn"):
                                    if (self.next_hop_set_l3vpn is None):
                                        self.next_hop_set_l3vpn = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                        self.next_hop_set_l3vpn.parent = self
                                        self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                    return self.next_hop_set_l3vpn

                                if (child_yang_name == "pi-mi-pmsi-data"):
                                    if (self.pi_mi_pmsi_data is None):
                                        self.pi_mi_pmsi_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                        self.pi_mi_pmsi_data.parent = self
                                        self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                    return self.pi_mi_pmsi_data

                                if (child_yang_name == "pi-ms-pmsi-data"):
                                    if (self.pi_ms_pmsi_data is None):
                                        self.pi_ms_pmsi_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                        self.pi_ms_pmsi_data.parent = self
                                        self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                    return self.pi_ms_pmsi_data

                                if (child_yang_name == "pseudowire-data"):
                                    if (self.pseudowire_data is None):
                                        self.pseudowire_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireData()
                                        self.pseudowire_data.parent = self
                                        self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    return self.pseudowire_data

                                if (child_yang_name == "pseudowire-head-end-data"):
                                    if (self.pseudowire_head_end_data is None):
                                        self.pseudowire_head_end_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                        self.pseudowire_head_end_data.parent = self
                                        self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    return self.pseudowire_head_end_data

                                if (child_yang_name == "sr-adj-segment-ipv4"):
                                    if (self.sr_adj_segment_ipv4 is None):
                                        self.sr_adj_segment_ipv4 = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                        self.sr_adj_segment_ipv4.parent = self
                                        self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                    return self.sr_adj_segment_ipv4

                                if (child_yang_name == "sr-adj-segment-ipv6"):
                                    if (self.sr_adj_segment_ipv6 is None):
                                        self.sr_adj_segment_ipv6 = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                        self.sr_adj_segment_ipv6.parent = self
                                        self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                    return self.sr_adj_segment_ipv6

                                if (child_yang_name == "sr-prefix-segment"):
                                    if (self.sr_prefix_segment is None):
                                        self.sr_prefix_segment = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                        self.sr_prefix_segment.parent = self
                                        self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                    return self.sr_prefix_segment

                                if (child_yang_name == "te-binding"):
                                    if (self.te_binding is None):
                                        self.te_binding = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TeBinding()
                                        self.te_binding.parent = self
                                        self._children_name_map["te_binding"] = "te-binding"
                                    return self.te_binding

                                if (child_yang_name == "tev4-data"):
                                    if (self.tev4_data is None):
                                        self.tev4_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4Data()
                                        self.tev4_data.parent = self
                                        self._children_name_map["tev4_data"] = "tev4-data"
                                    return self.tev4_data

                                if (child_yang_name == "tev4p2mp-data"):
                                    if (self.tev4p2mp_data is None):
                                        self.tev4p2mp_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                        self.tev4p2mp_data.parent = self
                                        self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                    return self.tev4p2mp_data

                                if (child_yang_name == "tp-data"):
                                    if (self.tp_data is None):
                                        self.tp_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.TpData()
                                        self.tp_data.parent = self
                                        self._children_name_map["tp_data"] = "tp-data"
                                    return self.tp_data

                                if (child_yang_name == "vrf-l3vpn-data"):
                                    if (self.vrf_l3vpn_data is None):
                                        self.vrf_l3vpn_data = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                        self.vrf_l3vpn_data.parent = self
                                        self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                    return self.vrf_l3vpn_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "cev4l3vpn-data" or name == "cev6l3vpn-data" or name == "evpn-data" or name == "generic-routing-encapsulation" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv4blb-data" or name == "ipv4l3vpn-data" or name == "ipv6-data" or name == "ipv6-generic-routing-encapsulation" or name == "ipv6blb-data" or name == "ipv6l3vpn-data" or name == "label-block-data" or name == "label-block-srgb-data" or name == "mld-pv4-data" or name == "next-hop-set-l3vpn" or name == "pi-mi-pmsi-data" or name == "pi-ms-pmsi-data" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "sr-adj-segment-ipv4" or name == "sr-adj-segment-ipv6" or name == "sr-prefix-segment" or name == "te-binding" or name == "tev4-data" or name == "tev4p2mp-data" or name == "tp-data" or name == "vrf-l3vpn-data" or name == "label-context-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-context-type"):
                                    self.label_context_type = value
                                    self.label_context_type.value_namespace = name_space
                                    self.label_context_type.value_namespace_prefix = name_space_prefix


                        class LocalLabelRewrite(Entity):
                            """
                            Local label rewrite information
                            
                            .. attribute:: label_data
                            
                            	label data
                            	**type**\:  list of int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LocalLabelRewrite, self).__init__()

                                self.yang_name = "local-label-rewrite"
                                self.yang_parent_name = "rewrite-id"

                                self.label_data = YLeafList(YType.uint32, "label-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_data") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)

                            def has_data(self):
                                for leaf in self.label_data.getYLeafs():
                                    if (leaf.yfilter != YFilter.not_set):
                                        return True
                                return False

                            def has_operation(self):
                                for leaf in self.label_data.getYLeafs():
                                    if (leaf.is_set):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_data.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "local-label-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                leaf_name_data.extend(self.label_data.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "label-data"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-data"):
                                    self.label_data.append(value)

                        def has_data(self):
                            return (
                                self.rewrite_id_type.is_set or
                                (self.label_context is not None and self.label_context.has_data()) or
                                (self.local_label_rewrite is not None and self.local_label_rewrite.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.rewrite_id_type.yfilter != YFilter.not_set or
                                (self.label_context is not None and self.label_context.has_operation()) or
                                (self.local_label_rewrite is not None and self.local_label_rewrite.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rewrite-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.rewrite_id_type.is_set or self.rewrite_id_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rewrite_id_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "label-context"):
                                if (self.label_context is None):
                                    self.label_context = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LabelContext()
                                    self.label_context.parent = self
                                    self._children_name_map["label_context"] = "label-context"
                                return self.label_context

                            if (child_yang_name == "local-label-rewrite"):
                                if (self.local_label_rewrite is None):
                                    self.local_label_rewrite = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId.LocalLabelRewrite()
                                    self.local_label_rewrite.parent = self
                                    self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                                return self.local_label_rewrite

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "label-context" or name == "local-label-rewrite" or name == "rewrite-id-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "rewrite-id-type"):
                                self.rewrite_id_type = value
                                self.rewrite_id_type.value_namespace = name_space
                                self.rewrite_id_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (self.rewrite_id is not None and self.rewrite_id.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rewrite-id" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "rewrite-id"):
                            if (self.rewrite_id is None):
                                self.rewrite_id = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId.RewriteId()
                                self.rewrite_id.parent = self
                                self._children_name_map["rewrite_id"] = "rewrite-id"
                            return self.rewrite_id

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "rewrite-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class AssociatedFpi(Entity):
                    """
                    Associated FPI
                    
                    .. attribute:: application_owner
                    
                    	Application owner instance
                    	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.ApplicationOwner>`
                    
                    .. attribute:: fpi
                    
                    	FPI
                    	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi, self).__init__()

                        self.yang_name = "associated-fpi"
                        self.yang_parent_name = "rewrite-pw"

                        self.fpi = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi()
                        self.fpi.parent = self
                        self._children_name_map["fpi"] = "fpi"
                        self._children_yang_names.add("fpi")

                        self.application_owner = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi, self).__setattr__(name, value)


                    class Fpi(Entity):
                        """
                        FPI
                        
                        .. attribute:: dmtc_ext_intf_data
                        
                        	dmtc ext intf data
                        	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.DmtcExtIntfData>`
                        
                        .. attribute:: fpi_type
                        
                        	FPIType
                        	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                        
                        .. attribute:: ipv4_data
                        
                        	ipv4 data
                        	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv4Data>`
                        
                        .. attribute:: ipv6_data
                        
                        	ipv6 data
                        	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv6Data>`
                        
                        .. attribute:: label_data
                        
                        	label data
                        	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.LabelData>`
                        
                        .. attribute:: pw_list_data
                        
                        	pw list data
                        	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.PwListData>`
                        
                        .. attribute:: te_data
                        
                        	te data
                        	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.TeData>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi, self).__init__()

                            self.yang_name = "fpi"
                            self.yang_parent_name = "associated-fpi"

                            self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                            self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.DmtcExtIntfData()
                            self.dmtc_ext_intf_data.parent = self
                            self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                            self._children_yang_names.add("dmtc-ext-intf-data")

                            self.ipv4_data = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv4Data()
                            self.ipv4_data.parent = self
                            self._children_name_map["ipv4_data"] = "ipv4-data"
                            self._children_yang_names.add("ipv4-data")

                            self.ipv6_data = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv6Data()
                            self.ipv6_data.parent = self
                            self._children_name_map["ipv6_data"] = "ipv6-data"
                            self._children_yang_names.add("ipv6-data")

                            self.label_data = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.LabelData()
                            self.label_data.parent = self
                            self._children_name_map["label_data"] = "label-data"
                            self._children_yang_names.add("label-data")

                            self.pw_list_data = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.PwListData()
                            self.pw_list_data.parent = self
                            self._children_name_map["pw_list_data"] = "pw-list-data"
                            self._children_yang_names.add("pw-list-data")

                            self.te_data = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.TeData()
                            self.te_data.parent = self
                            self._children_name_map["te_data"] = "te-data"
                            self._children_yang_names.add("te-data")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fpi_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi, self).__setattr__(name, value)


                        class LabelData(Entity):
                            """
                            label data
                            
                            .. attribute:: elc
                            
                            	ELC
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: label
                            
                            	Label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.LabelData, self).__init__()

                                self.yang_name = "label-data"
                                self.yang_parent_name = "fpi"

                                self.elc = YLeaf(YType.int32, "elc")

                                self.label = YLeaf(YType.uint32, "label")

                                self.security_id = YLeaf(YType.uint32, "security-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("elc",
                                                "label",
                                                "security_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.elc.is_set or
                                    self.label.is_set or
                                    self.security_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.elc.yfilter != YFilter.not_set or
                                    self.label.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.elc.get_name_leafdata())
                                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label.get_name_leafdata())
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "elc" or name == "label" or name == "security-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "elc"):
                                    self.elc = value
                                    self.elc.value_namespace = name_space
                                    self.elc.value_namespace_prefix = name_space_prefix
                                if(value_path == "label"):
                                    self.label = value
                                    self.label.value_namespace = name_space
                                    self.label.value_namespace_prefix = name_space_prefix
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix


                        class TeData(Entity):
                            """
                            te data
                            
                            .. attribute:: local_label
                            
                            	Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_interface
                            
                            	Tunnel interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.TeData, self).__init__()

                                self.yang_name = "te-data"
                                self.yang_parent_name = "fpi"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label",
                                                "tunnel_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.local_label.is_set or
                                    self.tunnel_interface.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.tunnel_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label" or name == "tunnel-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface"):
                                    self.tunnel_interface = value
                                    self.tunnel_interface.value_namespace = name_space
                                    self.tunnel_interface.value_namespace_prefix = name_space_prefix


                        class Ipv4Data(Entity):
                            """
                            ipv4 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: sr_local_label
                            
                            	SR related Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv4Data, self).__init__()

                                self.yang_name = "ipv4-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "sr_local_label",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.sr_local_label.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.sr_local_label.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "sr-local-label"):
                                    self.sr_local_label = value
                                    self.sr_local_label.value_namespace = name_space
                                    self.sr_local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class Ipv6Data(Entity):
                            """
                            ipv6 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_len
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: router_flags
                            
                            	Route flags
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv6Data, self).__init__()

                                self.yang_name = "ipv6-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                self.router_flags = YLeaf(YType.uint32, "router-flags")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_len",
                                                "router_flags",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_len.is_set or
                                    self.router_flags.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_len.yfilter != YFilter.not_set or
                                    self.router_flags.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv6-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.router_flags.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-len"):
                                    self.prefix_len = value
                                    self.prefix_len.value_namespace = name_space
                                    self.prefix_len.value_namespace_prefix = name_space_prefix
                                if(value_path == "router-flags"):
                                    self.router_flags = value
                                    self.router_flags.value_namespace = name_space
                                    self.router_flags.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class PwListData(Entity):
                            """
                            pw list data
                            
                            .. attribute:: pwhe_list_id
                            
                            	Pseudowire List Identifier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.PwListData, self).__init__()

                                self.yang_name = "pw-list-data"
                                self.yang_parent_name = "fpi"

                                self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("pwhe_list_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.pwhe_list_id.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.pwhe_list_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pw-list-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "pwhe-list-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "pwhe-list-id"):
                                    self.pwhe_list_id = value
                                    self.pwhe_list_id.value_namespace = name_space
                                    self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                        class DmtcExtIntfData(Entity):
                            """
                            dmtc ext intf data
                            
                            .. attribute:: dmtc_ext_ifh
                            
                            	DMTC External Interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.DmtcExtIntfData, self).__init__()

                                self.yang_name = "dmtc-ext-intf-data"
                                self.yang_parent_name = "fpi"

                                self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.dmtc_ext_ifh.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "dmtc-ext-intf-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-ifh"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "dmtc-ext-ifh"):
                                    self.dmtc_ext_ifh = value
                                    self.dmtc_ext_ifh.value_namespace = name_space
                                    self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fpi_type.is_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                (self.label_data is not None and self.label_data.has_data()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                (self.te_data is not None and self.te_data.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fpi_type.yfilter != YFilter.not_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                (self.label_data is not None and self.label_data.has_operation()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                (self.te_data is not None and self.te_data.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fpi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fpi_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "dmtc-ext-intf-data"):
                                if (self.dmtc_ext_intf_data is None):
                                    self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.DmtcExtIntfData()
                                    self.dmtc_ext_intf_data.parent = self
                                    self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                return self.dmtc_ext_intf_data

                            if (child_yang_name == "ipv4-data"):
                                if (self.ipv4_data is None):
                                    self.ipv4_data = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                return self.ipv4_data

                            if (child_yang_name == "ipv6-data"):
                                if (self.ipv6_data is None):
                                    self.ipv6_data = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                return self.ipv6_data

                            if (child_yang_name == "label-data"):
                                if (self.label_data is None):
                                    self.label_data = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.LabelData()
                                    self.label_data.parent = self
                                    self._children_name_map["label_data"] = "label-data"
                                return self.label_data

                            if (child_yang_name == "pw-list-data"):
                                if (self.pw_list_data is None):
                                    self.pw_list_data = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.PwListData()
                                    self.pw_list_data.parent = self
                                    self._children_name_map["pw_list_data"] = "pw-list-data"
                                return self.pw_list_data

                            if (child_yang_name == "te-data"):
                                if (self.te_data is None):
                                    self.te_data = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi.TeData()
                                    self.te_data.parent = self
                                    self._children_name_map["te_data"] = "te-data"
                                return self.te_data

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fpi-type"):
                                self.fpi_type = value
                                self.fpi_type.value_namespace = name_space
                                self.fpi_type.value_namespace_prefix = name_space_prefix


                    class ApplicationOwner(Entity):
                        """
                        Application owner instance
                        
                        .. attribute:: application_instance
                        
                        	Application instance Name
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        .. attribute:: resource_state
                        
                        	Application resource state
                        	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.ApplicationOwner, self).__init__()

                            self.yang_name = "application-owner"
                            self.yang_parent_name = "associated-fpi"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                            self.resource_state = YLeaf(YType.enumeration, "resource-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type",
                                            "resource_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set or
                                self.resource_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set or
                                self.resource_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application-owner" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())
                            if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resource_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "resource-state"):
                                self.resource_state = value
                                self.resource_state.value_namespace = name_space
                                self.resource_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.application_owner:
                            if (c.has_data()):
                                return True
                        return (self.fpi is not None and self.fpi.has_data())

                    def has_operation(self):
                        for c in self.application_owner:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.fpi is not None and self.fpi.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "associated-fpi" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application-owner"):
                            for c in self.application_owner:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.ApplicationOwner()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.application_owner.append(c)
                            return c

                        if (child_yang_name == "fpi"):
                            if (self.fpi is None):
                                self.fpi = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi.Fpi()
                                self.fpi.parent = self
                                self._children_name_map["fpi"] = "fpi"
                            return self.fpi

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-owner" or name == "fpi"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class V4Rpf(Entity):
                    """
                    IPv4 RPF neighbors
                    
                    .. attribute:: table_id
                    
                    	Table ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: v4_rpf_neighbor
                    
                    	V4 RPF Neighbor
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewritePws.RewritePw.V4Rpf, self).__init__()

                        self.yang_name = "v4-rpf"
                        self.yang_parent_name = "rewrite-pw"

                        self.table_id = YLeaf(YType.uint32, "table-id")

                        self.v4_rpf_neighbor = YLeaf(YType.str, "v4-rpf-neighbor")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("table_id",
                                        "v4_rpf_neighbor") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.V4Rpf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.V4Rpf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.table_id.is_set or
                            self.v4_rpf_neighbor.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.table_id.yfilter != YFilter.not_set or
                            self.v4_rpf_neighbor.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "v4-rpf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.table_id.get_name_leafdata())
                        if (self.v4_rpf_neighbor.is_set or self.v4_rpf_neighbor.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.v4_rpf_neighbor.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "table-id" or name == "v4-rpf-neighbor"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "table-id"):
                            self.table_id = value
                            self.table_id.value_namespace = name_space
                            self.table_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "v4-rpf-neighbor"):
                            self.v4_rpf_neighbor = value
                            self.v4_rpf_neighbor.value_namespace = name_space
                            self.v4_rpf_neighbor.value_namespace_prefix = name_space_prefix


                class V6Rpf(Entity):
                    """
                    IPv6 RPF neighbors
                    
                    .. attribute:: table_id
                    
                    	Table ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: v6_rpf_neighbor
                    
                    	V6 RPF Neighbor
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewritePws.RewritePw.V6Rpf, self).__init__()

                        self.yang_name = "v6-rpf"
                        self.yang_parent_name = "rewrite-pw"

                        self.table_id = YLeaf(YType.uint32, "table-id")

                        self.v6_rpf_neighbor = YLeaf(YType.str, "v6-rpf-neighbor")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("table_id",
                                        "v6_rpf_neighbor") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.V6Rpf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.V6Rpf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.table_id.is_set or
                            self.v6_rpf_neighbor.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.table_id.yfilter != YFilter.not_set or
                            self.v6_rpf_neighbor.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "v6-rpf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.table_id.get_name_leafdata())
                        if (self.v6_rpf_neighbor.is_set or self.v6_rpf_neighbor.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.v6_rpf_neighbor.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "table-id" or name == "v6-rpf-neighbor"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "table-id"):
                            self.table_id = value
                            self.table_id.value_namespace = name_space
                            self.table_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "v6-rpf-neighbor"):
                            self.v6_rpf_neighbor = value
                            self.v6_rpf_neighbor.value_namespace = name_space
                            self.v6_rpf_neighbor.value_namespace_prefix = name_space_prefix


                class Mois(Entity):
                    """
                    Mois
                    
                    .. attribute:: application_resource
                    
                    	Application state
                    	**type**\:   :py:class:`ApplicationResource <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.ApplicationResource>`
                    
                    .. attribute:: moi_array
                    
                    	moi array
                    	**type**\: list of    :py:class:`MoiArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois, self).__init__()

                        self.yang_name = "mois"
                        self.yang_parent_name = "rewrite-pw"

                        self.application_resource = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.ApplicationResource()
                        self.application_resource.parent = self
                        self._children_name_map["application_resource"] = "application-resource"
                        self._children_yang_names.add("application-resource")

                        self.moi_array = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois, self).__setattr__(name, value)


                    class ApplicationResource(Entity):
                        """
                        Application state
                        
                        .. attribute:: application_instance
                        
                        	Application instance Name
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        .. attribute:: resource_state
                        
                        	Application resource state
                        	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.ApplicationResource, self).__init__()

                            self.yang_name = "application-resource"
                            self.yang_parent_name = "mois"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                            self.resource_state = YLeaf(YType.enumeration, "resource-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type",
                                            "resource_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.ApplicationResource, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.ApplicationResource, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set or
                                self.resource_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set or
                                self.resource_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application-resource" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())
                            if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resource_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "resource-state"):
                                self.resource_state = value
                                self.resource_state.value_namespace = name_space
                                self.resource_state.value_namespace_prefix = name_space_prefix


                    class MoiArray(Entity):
                        """
                        moi array
                        
                        .. attribute:: moi
                        
                        	Moi
                        	**type**\:   :py:class:`Moi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray, self).__init__()

                            self.yang_name = "moi-array"
                            self.yang_parent_name = "mois"

                            self.moi = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi()
                            self.moi.parent = self
                            self._children_name_map["moi"] = "moi"
                            self._children_yang_names.add("moi")


                        class Moi(Entity):
                            """
                            Moi
                            
                            .. attribute:: dmtc_data
                            
                            	dmtc data
                            	**type**\:   :py:class:`DmtcData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.DmtcData>`
                            
                            .. attribute:: ip_sub_data
                            
                            	ip sub data
                            	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.IpSubData>`
                            
                            .. attribute:: ipv4_data
                            
                            	ipv4 data
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv4Data>`
                            
                            .. attribute:: ipv6_data
                            
                            	ipv6 data
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv6Data>`
                            
                            .. attribute:: moi_type
                            
                            	MoiType
                            	**type**\:   :py:class:`MgmtLsdMoi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdMoi>`
                            
                            .. attribute:: pop_and_lookup_ipv4
                            
                            	pop and lookup ipv4
                            	**type**\:   :py:class:`PopAndLookupIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv4>`
                            
                            .. attribute:: pop_and_lookup_ipv6
                            
                            	pop and lookup ipv6
                            	**type**\:   :py:class:`PopAndLookupIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv6>`
                            
                            .. attribute:: pop_and_lookup_tp
                            
                            	pop and lookup tp
                            	**type**\:   :py:class:`PopAndLookupTp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupTp>`
                            
                            .. attribute:: pseudowire_data
                            
                            	pseudowire data
                            	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireData>`
                            
                            .. attribute:: pseudowire_head_end_data
                            
                            	pseudowire head end data
                            	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireHeadEndData>`
                            
                            .. attribute:: pw_list_data
                            
                            	pw list data
                            	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PwListData>`
                            
                            .. attribute:: stackv4_data
                            
                            	stackv4 data
                            	**type**\:   :py:class:`Stackv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data>`
                            
                            .. attribute:: stackv6_data
                            
                            	stackv6 data
                            	**type**\:   :py:class:`Stackv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data>`
                            
                            .. attribute:: te_head_data
                            
                            	te head data
                            	**type**\:   :py:class:`TeHeadData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.TeHeadData>`
                            
                            .. attribute:: tev4_data
                            
                            	tev4 data
                            	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Tev4Data>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi, self).__init__()

                                self.yang_name = "moi"
                                self.yang_parent_name = "moi-array"

                                self.moi_type = YLeaf(YType.enumeration, "moi-type")

                                self.dmtc_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.DmtcData()
                                self.dmtc_data.parent = self
                                self._children_name_map["dmtc_data"] = "dmtc-data"
                                self._children_yang_names.add("dmtc-data")

                                self.ip_sub_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.IpSubData()
                                self.ip_sub_data.parent = self
                                self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                self._children_yang_names.add("ip-sub-data")

                                self.ipv4_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv6_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.pop_and_lookup_ipv4 = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                self.pop_and_lookup_ipv4.parent = self
                                self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                self._children_yang_names.add("pop-and-lookup-ipv4")

                                self.pop_and_lookup_ipv6 = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                self.pop_and_lookup_ipv6.parent = self
                                self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                self._children_yang_names.add("pop-and-lookup-ipv6")

                                self.pop_and_lookup_tp = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupTp()
                                self.pop_and_lookup_tp.parent = self
                                self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                self._children_yang_names.add("pop-and-lookup-tp")

                                self.pseudowire_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireData()
                                self.pseudowire_data.parent = self
                                self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                self._children_yang_names.add("pseudowire-data")

                                self.pseudowire_head_end_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                self.pseudowire_head_end_data.parent = self
                                self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                self._children_yang_names.add("pseudowire-head-end-data")

                                self.pw_list_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PwListData()
                                self.pw_list_data.parent = self
                                self._children_name_map["pw_list_data"] = "pw-list-data"
                                self._children_yang_names.add("pw-list-data")

                                self.stackv4_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data()
                                self.stackv4_data.parent = self
                                self._children_name_map["stackv4_data"] = "stackv4-data"
                                self._children_yang_names.add("stackv4-data")

                                self.stackv6_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data()
                                self.stackv6_data.parent = self
                                self._children_name_map["stackv6_data"] = "stackv6-data"
                                self._children_yang_names.add("stackv6-data")

                                self.te_head_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.TeHeadData()
                                self.te_head_data.parent = self
                                self._children_name_map["te_head_data"] = "te-head-data"
                                self._children_yang_names.add("te-head-data")

                                self.tev4_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Tev4Data()
                                self.tev4_data.parent = self
                                self._children_name_map["tev4_data"] = "tev4-data"
                                self._children_yang_names.add("tev4-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("moi_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi, self).__setattr__(name, value)


                            class PopAndLookupIpv4(Entity):
                                """
                                pop and lookup ipv4
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__init__()

                                    self.yang_name = "pop-and-lookup-ipv4"
                                    self.yang_parent_name = "moi"

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pop-and-lookup-ipv4" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class PopAndLookupTp(Entity):
                                """
                                pop and lookup tp
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupTp, self).__init__()

                                    self.yang_name = "pop-and-lookup-tp"
                                    self.yang_parent_name = "moi"

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("out_label",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.out_label.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pop-and-lookup-tp" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "out-label" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class PopAndLookupIpv6(Entity):
                                """
                                pop and lookup ipv6
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__init__()

                                    self.yang_name = "pop-and-lookup-ipv6"
                                    self.yang_parent_name = "moi"

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pop-and-lookup-ipv6" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class Ipv4Data(Entity):
                                """
                                ipv4 data
                                
                                .. attribute:: backup_path_id
                                
                                	Routing path backup id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: load_metric
                                
                                	Routing path's load metric
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: local_label
                                
                                	TE backup path local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: next_hop_id
                                
                                	Next hop ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_interface
                                
                                	Outgoing Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_interface_parent
                                
                                	Outgoing Interface's parent
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_label_name
                                
                                	Outgoing label name
                                	**type**\:  str
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: path_id
                                
                                	Routing path id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "moi"

                                    self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.load_metric = YLeaf(YType.uint32, "load-metric")

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.out_label_name = YLeaf(YType.str, "out-label-name")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.path_id = YLeaf(YType.uint8, "path-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_path_id",
                                                    "ipv4_next_hop",
                                                    "load_metric",
                                                    "local_label",
                                                    "next_hop_id",
                                                    "out_interface",
                                                    "out_interface_parent",
                                                    "out_label",
                                                    "out_label_name",
                                                    "path_flags_decode",
                                                    "path_id",
                                                    "table_id",
                                                    "table_name",
                                                    "tunnel_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_path_id.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.load_metric.is_set or
                                        self.local_label.is_set or
                                        self.next_hop_id.is_set or
                                        self.out_interface.is_set or
                                        self.out_interface_parent.is_set or
                                        self.out_label.is_set or
                                        self.out_label_name.is_set or
                                        self.path_flags_decode.is_set or
                                        self.path_id.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.tunnel_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_path_id.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.load_metric.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.next_hop_id.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_interface_parent.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.out_label_name.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.path_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.tunnel_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.load_metric.get_name_leafdata())
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-path-id"):
                                        self.backup_path_id = value
                                        self.backup_path_id.value_namespace = name_space
                                        self.backup_path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "load-metric"):
                                        self.load_metric = value
                                        self.load_metric.value_namespace = name_space
                                        self.load_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "next-hop-id"):
                                        self.next_hop_id = value
                                        self.next_hop_id.value_namespace = name_space
                                        self.next_hop_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface-parent"):
                                        self.out_interface_parent = value
                                        self.out_interface_parent.value_namespace = name_space
                                        self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label-name"):
                                        self.out_label_name = value
                                        self.out_label_name.value_namespace = name_space
                                        self.out_label_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-id"):
                                        self.path_id = value
                                        self.path_id.value_namespace = name_space
                                        self.path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id"):
                                        self.tunnel_id = value
                                        self.tunnel_id.value_namespace = name_space
                                        self.tunnel_id.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                ipv6 data
                                
                                .. attribute:: backup_path_id
                                
                                	Routing path backup id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv6_next_hop
                                
                                	IPv6 nexthop
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: next_hop_id
                                
                                	Next hop ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_label_name
                                
                                	Outgoing label name
                                	**type**\:  str
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: path_id
                                
                                	Routing path id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "moi"

                                    self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                    self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                    self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.out_label_name = YLeaf(YType.str, "out-label-name")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.path_id = YLeaf(YType.uint8, "path-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_path_id",
                                                    "ipv6_next_hop",
                                                    "next_hop_id",
                                                    "out_interface",
                                                    "out_label",
                                                    "out_label_name",
                                                    "path_flags_decode",
                                                    "path_id",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_path_id.is_set or
                                        self.ipv6_next_hop.is_set or
                                        self.next_hop_id.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.out_label_name.is_set or
                                        self.path_flags_decode.is_set or
                                        self.path_id.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_path_id.yfilter != YFilter.not_set or
                                        self.ipv6_next_hop.yfilter != YFilter.not_set or
                                        self.next_hop_id.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.out_label_name.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.path_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                    if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                    if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-path-id"):
                                        self.backup_path_id = value
                                        self.backup_path_id.value_namespace = name_space
                                        self.backup_path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6-next-hop"):
                                        self.ipv6_next_hop = value
                                        self.ipv6_next_hop.value_namespace = name_space
                                        self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "next-hop-id"):
                                        self.next_hop_id = value
                                        self.next_hop_id.value_namespace = name_space
                                        self.next_hop_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label-name"):
                                        self.out_label_name = value
                                        self.out_label_name.value_namespace = name_space
                                        self.out_label_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-id"):
                                        self.path_id = value
                                        self.path_id.value_namespace = name_space
                                        self.path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class Tev4Data(Entity):
                                """
                                tev4 data
                                
                                .. attribute:: backup_interface
                                
                                	Backup interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: backup_ipv4_next_hop
                                
                                	Backup IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: backup_local_label
                                
                                	Backup local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: data_out_parent_interface
                                
                                	Outgoing data parent interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: merge_point_label
                                
                                	Merge point label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_label_name
                                
                                	Outgoing label name
                                	**type**\:  str
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_class
                                
                                	Tunnel class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_interface
                                
                                	Tunnel interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: tunnel_weight
                                
                                	Tunnel weight
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Tev4Data, self).__init__()

                                    self.yang_name = "tev4-data"
                                    self.yang_parent_name = "moi"

                                    self.backup_interface = YLeaf(YType.str, "backup-interface")

                                    self.backup_ipv4_next_hop = YLeaf(YType.str, "backup-ipv4-next-hop")

                                    self.backup_local_label = YLeaf(YType.uint32, "backup-local-label")

                                    self.data_out_parent_interface = YLeaf(YType.str, "data-out-parent-interface")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.merge_point_label = YLeaf(YType.uint32, "merge-point-label")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.out_label_name = YLeaf(YType.str, "out-label-name")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.tunnel_class = YLeaf(YType.uint32, "tunnel-class")

                                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                    self.tunnel_weight = YLeaf(YType.uint32, "tunnel-weight")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_interface",
                                                    "backup_ipv4_next_hop",
                                                    "backup_local_label",
                                                    "data_out_parent_interface",
                                                    "ipv4_next_hop",
                                                    "merge_point_label",
                                                    "out_interface",
                                                    "out_label",
                                                    "out_label_name",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name",
                                                    "tunnel_class",
                                                    "tunnel_interface",
                                                    "tunnel_weight") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_interface.is_set or
                                        self.backup_ipv4_next_hop.is_set or
                                        self.backup_local_label.is_set or
                                        self.data_out_parent_interface.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.merge_point_label.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.out_label_name.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.tunnel_class.is_set or
                                        self.tunnel_interface.is_set or
                                        self.tunnel_weight.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_interface.yfilter != YFilter.not_set or
                                        self.backup_ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.backup_local_label.yfilter != YFilter.not_set or
                                        self.data_out_parent_interface.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.merge_point_label.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.out_label_name.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.tunnel_class.yfilter != YFilter.not_set or
                                        self.tunnel_interface.yfilter != YFilter.not_set or
                                        self.tunnel_weight.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tev4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_interface.is_set or self.backup_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_interface.get_name_leafdata())
                                    if (self.backup_ipv4_next_hop.is_set or self.backup_ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_ipv4_next_hop.get_name_leafdata())
                                    if (self.backup_local_label.is_set or self.backup_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_local_label.get_name_leafdata())
                                    if (self.data_out_parent_interface.is_set or self.data_out_parent_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.data_out_parent_interface.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.merge_point_label.is_set or self.merge_point_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.merge_point_label.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.tunnel_class.is_set or self.tunnel_class.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_class.get_name_leafdata())
                                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())
                                    if (self.tunnel_weight.is_set or self.tunnel_weight.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_weight.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-interface" or name == "backup-ipv4-next-hop" or name == "backup-local-label" or name == "data-out-parent-interface" or name == "ipv4-next-hop" or name == "merge-point-label" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-class" or name == "tunnel-interface" or name == "tunnel-weight"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-interface"):
                                        self.backup_interface = value
                                        self.backup_interface.value_namespace = name_space
                                        self.backup_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-ipv4-next-hop"):
                                        self.backup_ipv4_next_hop = value
                                        self.backup_ipv4_next_hop.value_namespace = name_space
                                        self.backup_ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-local-label"):
                                        self.backup_local_label = value
                                        self.backup_local_label.value_namespace = name_space
                                        self.backup_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "data-out-parent-interface"):
                                        self.data_out_parent_interface = value
                                        self.data_out_parent_interface.value_namespace = name_space
                                        self.data_out_parent_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "merge-point-label"):
                                        self.merge_point_label = value
                                        self.merge_point_label.value_namespace = name_space
                                        self.merge_point_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label-name"):
                                        self.out_label_name = value
                                        self.out_label_name.value_namespace = name_space
                                        self.out_label_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-class"):
                                        self.tunnel_class = value
                                        self.tunnel_class.value_namespace = name_space
                                        self.tunnel_class.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface"):
                                        self.tunnel_interface = value
                                        self.tunnel_interface.value_namespace = name_space
                                        self.tunnel_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-weight"):
                                        self.tunnel_weight = value
                                        self.tunnel_weight.value_namespace = name_space
                                        self.tunnel_weight.value_namespace_prefix = name_space_prefix


                            class PseudowireData(Entity):
                                """
                                pseudowire data
                                
                                .. attribute:: bridge_id
                                
                                	Bridge ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross\-connect ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: pseuodo_wire_connect_id
                                
                                	PseudoWire Cross\-connect ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: split_horizon_id
                                
                                	Split horizon group ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireData, self).__init__()

                                    self.yang_name = "pseudowire-data"
                                    self.yang_parent_name = "moi"

                                    self.bridge_id = YLeaf(YType.uint32, "bridge-id")

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.pseuodo_wire_connect_id = YLeaf(YType.uint32, "pseuodo-wire-connect-id")

                                    self.split_horizon_id = YLeaf(YType.uint32, "split-horizon-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bridge_id",
                                                    "cross_connect_id",
                                                    "ipv4_next_hop",
                                                    "out_interface",
                                                    "out_label",
                                                    "path_flags_decode",
                                                    "pseuodo_wire_connect_id",
                                                    "split_horizon_id",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bridge_id.is_set or
                                        self.cross_connect_id.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.path_flags_decode.is_set or
                                        self.pseuodo_wire_connect_id.is_set or
                                        self.split_horizon_id.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bridge_id.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.pseuodo_wire_connect_id.yfilter != YFilter.not_set or
                                        self.split_horizon_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bridge_id.is_set or self.bridge_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bridge_id.get_name_leafdata())
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.pseuodo_wire_connect_id.is_set or self.pseuodo_wire_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pseuodo_wire_connect_id.get_name_leafdata())
                                    if (self.split_horizon_id.is_set or self.split_horizon_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.split_horizon_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bridge-id" or name == "cross-connect-id" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pseuodo-wire-connect-id" or name == "split-horizon-id" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bridge-id"):
                                        self.bridge_id = value
                                        self.bridge_id.value_namespace = name_space
                                        self.bridge_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pseuodo-wire-connect-id"):
                                        self.pseuodo_wire_connect_id = value
                                        self.pseuodo_wire_connect_id.value_namespace = name_space
                                        self.pseuodo_wire_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "split-horizon-id"):
                                        self.split_horizon_id = value
                                        self.split_horizon_id.value_namespace = name_space
                                        self.split_horizon_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class IpSubData(Entity):
                                """
                                ip sub data
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	VRF table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.IpSubData, self).__init__()

                                    self.yang_name = "ip-sub-data"
                                    self.yang_parent_name = "moi"

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("out_interface",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.out_interface.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ip-sub-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "out-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class PseudowireHeadEndData(Entity):
                                """
                                pseudowire head end data
                                
                                .. attribute:: control_word
                                
                                	Is control word present
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: imposition
                                
                                	Is PWHE IMposition
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: pw_list_id
                                
                                	Pseudo\-wire List Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: pwhe_interface
                                
                                	Pseudo\-wire Head\-end interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: vctype
                                
                                	Virtual Circuit Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__init__()

                                    self.yang_name = "pseudowire-head-end-data"
                                    self.yang_parent_name = "moi"

                                    self.control_word = YLeaf(YType.int32, "control-word")

                                    self.imposition = YLeaf(YType.int32, "imposition")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.pw_list_id = YLeaf(YType.uint16, "pw-list-id")

                                    self.pwhe_interface = YLeaf(YType.str, "pwhe-interface")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.vctype = YLeaf(YType.uint8, "vctype")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("control_word",
                                                    "imposition",
                                                    "ipv4_next_hop",
                                                    "out_interface",
                                                    "out_label",
                                                    "path_flags_decode",
                                                    "pw_list_id",
                                                    "pwhe_interface",
                                                    "table_id",
                                                    "table_name",
                                                    "vctype") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.control_word.is_set or
                                        self.imposition.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.path_flags_decode.is_set or
                                        self.pw_list_id.is_set or
                                        self.pwhe_interface.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.vctype.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.control_word.yfilter != YFilter.not_set or
                                        self.imposition.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.pw_list_id.yfilter != YFilter.not_set or
                                        self.pwhe_interface.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.vctype.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-head-end-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.control_word.is_set or self.control_word.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.control_word.get_name_leafdata())
                                    if (self.imposition.is_set or self.imposition.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.imposition.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.pw_list_id.is_set or self.pw_list_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pw_list_id.get_name_leafdata())
                                    if (self.pwhe_interface.is_set or self.pwhe_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_interface.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.vctype.is_set or self.vctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vctype.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "control-word" or name == "imposition" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pw-list-id" or name == "pwhe-interface" or name == "table-id" or name == "table-name" or name == "vctype"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "control-word"):
                                        self.control_word = value
                                        self.control_word.value_namespace = name_space
                                        self.control_word.value_namespace_prefix = name_space_prefix
                                    if(value_path == "imposition"):
                                        self.imposition = value
                                        self.imposition.value_namespace = name_space
                                        self.imposition.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pw-list-id"):
                                        self.pw_list_id = value
                                        self.pw_list_id.value_namespace = name_space
                                        self.pw_list_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pwhe-interface"):
                                        self.pwhe_interface = value
                                        self.pwhe_interface.value_namespace = name_space
                                        self.pwhe_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vctype"):
                                        self.vctype = value
                                        self.vctype.value_namespace = name_space
                                        self.vctype.value_namespace_prefix = name_space_prefix


                            class PwListData(Entity):
                                """
                                pw list data
                                
                                .. attribute:: l2_interface
                                
                                	Pseudo\-wire Layer 2 interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: l3_interface
                                
                                	Pseudo\-wire Layer 3 interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PwListData, self).__init__()

                                    self.yang_name = "pw-list-data"
                                    self.yang_parent_name = "moi"

                                    self.l2_interface = YLeaf(YType.str, "l2-interface")

                                    self.l3_interface = YLeaf(YType.str, "l3-interface")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("l2_interface",
                                                    "l3_interface",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.l2_interface.is_set or
                                        self.l3_interface.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.l2_interface.yfilter != YFilter.not_set or
                                        self.l3_interface.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pw-list-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.l2_interface.is_set or self.l2_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.l2_interface.get_name_leafdata())
                                    if (self.l3_interface.is_set or self.l3_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.l3_interface.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "l2-interface" or name == "l3-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "l2-interface"):
                                        self.l2_interface = value
                                        self.l2_interface.value_namespace = name_space
                                        self.l2_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "l3-interface"):
                                        self.l3_interface = value
                                        self.l3_interface.value_namespace = name_space
                                        self.l3_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class Stackv4Data(Entity):
                                """
                                stackv4 data
                                
                                .. attribute:: inner_stack
                                
                                	Inner stack
                                	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack>`
                                
                                .. attribute:: nexthop
                                
                                	Nexthop
                                	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.Nexthop>`
                                
                                .. attribute:: owner_application_type
                                
                                	Owner application type
                                	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data, self).__init__()

                                    self.yang_name = "stackv4-data"
                                    self.yang_parent_name = "moi"

                                    self.owner_application_type = YLeaf(YType.enumeration, "owner-application-type")

                                    self.inner_stack = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                    self.inner_stack.parent = self
                                    self._children_name_map["inner_stack"] = "inner-stack"
                                    self._children_yang_names.add("inner-stack")

                                    self.nexthop = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                    self.nexthop.parent = self
                                    self._children_name_map["nexthop"] = "nexthop"
                                    self._children_yang_names.add("nexthop")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("owner_application_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)


                                class Nexthop(Entity):
                                    """
                                    Nexthop
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: load_metric
                                    
                                    	Routing path's load metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: local_label
                                    
                                    	TE backup path local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_interface_parent
                                    
                                    	Outgoing Interface's parent
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__init__()

                                        self.yang_name = "nexthop"
                                        self.yang_parent_name = "stackv4-data"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.load_metric = YLeaf(YType.uint32, "load-metric")

                                        self.local_label = YLeaf(YType.uint32, "local-label")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv4_next_hop",
                                                        "load_metric",
                                                        "local_label",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_interface_parent",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.load_metric.is_set or
                                            self.local_label.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_interface_parent.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.load_metric.yfilter != YFilter.not_set or
                                            self.local_label.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_interface_parent.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nexthop" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_metric.get_name_leafdata())
                                        if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_label.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-metric"):
                                            self.load_metric = value
                                            self.load_metric.value_namespace = name_space
                                            self.load_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-label"):
                                            self.local_label = value
                                            self.local_label.value_namespace = name_space
                                            self.local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface-parent"):
                                            self.out_interface_parent = value
                                            self.out_interface_parent.value_namespace = name_space
                                            self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix


                                class InnerStack(Entity):
                                    """
                                    Inner stack
                                    
                                    .. attribute:: label
                                    
                                    	Info related to outgoing labels
                                    	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Remote nexthop addresses
                                    	**type**\:  list of str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: num_lbls
                                    
                                    	Depth of inner label stack
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: num_nexthops
                                    
                                    	Number of remote nexthop addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__init__()

                                        self.yang_name = "inner-stack"
                                        self.yang_parent_name = "stackv4-data"

                                        self.nexthop = YLeafList(YType.str, "nexthop")

                                        self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                        self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                        self.label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nexthop",
                                                        "num_lbls",
                                                        "num_nexthops") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)


                                    class Label(Entity):
                                        """
                                        Info related to outgoing labels
                                        
                                        .. attribute:: outgoing_label
                                        
                                        	Remote Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: outgoing_label_str
                                        
                                        	Remote Label string
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__init__()

                                            self.yang_name = "label"
                                            self.yang_parent_name = "inner-stack"

                                            self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                            self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("outgoing_label",
                                                            "outgoing_label_str") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.outgoing_label.is_set or
                                                self.outgoing_label_str.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.outgoing_label.yfilter != YFilter.not_set or
                                                self.outgoing_label_str.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                            if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "outgoing-label"):
                                                self.outgoing_label = value
                                                self.outgoing_label.value_namespace = name_space
                                                self.outgoing_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "outgoing-label-str"):
                                                self.outgoing_label_str = value
                                                self.outgoing_label_str.value_namespace = name_space
                                                self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.label:
                                            if (c.has_data()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return (
                                            self.num_lbls.is_set or
                                            self.num_nexthops.is_set)

                                    def has_operation(self):
                                        for c in self.label:
                                            if (c.has_operation()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nexthop.yfilter != YFilter.not_set or
                                            self.num_lbls.yfilter != YFilter.not_set or
                                            self.num_nexthops.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inner-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                        if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                        leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "label"):
                                            for c in self.label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nexthop"):
                                            self.nexthop.append(value)
                                        if(value_path == "num-lbls"):
                                            self.num_lbls = value
                                            self.num_lbls.value_namespace = name_space
                                            self.num_lbls.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-nexthops"):
                                            self.num_nexthops = value
                                            self.num_nexthops.value_namespace = name_space
                                            self.num_nexthops.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.owner_application_type.is_set or
                                        (self.inner_stack is not None and self.inner_stack.has_data()) or
                                        (self.nexthop is not None and self.nexthop.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.owner_application_type.yfilter != YFilter.not_set or
                                        (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                        (self.nexthop is not None and self.nexthop.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "stackv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.owner_application_type.is_set or self.owner_application_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.owner_application_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "inner-stack"):
                                        if (self.inner_stack is None):
                                            self.inner_stack = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                            self.inner_stack.parent = self
                                            self._children_name_map["inner_stack"] = "inner-stack"
                                        return self.inner_stack

                                    if (child_yang_name == "nexthop"):
                                        if (self.nexthop is None):
                                            self.nexthop = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                            self.nexthop.parent = self
                                            self._children_name_map["nexthop"] = "nexthop"
                                        return self.nexthop

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "inner-stack" or name == "nexthop" or name == "owner-application-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "owner-application-type"):
                                        self.owner_application_type = value
                                        self.owner_application_type.value_namespace = name_space
                                        self.owner_application_type.value_namespace_prefix = name_space_prefix


                            class Stackv6Data(Entity):
                                """
                                stackv6 data
                                
                                .. attribute:: inner_stack
                                
                                	Inner stack
                                	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack>`
                                
                                .. attribute:: nexthop
                                
                                	Nexthop
                                	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.Nexthop>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data, self).__init__()

                                    self.yang_name = "stackv6-data"
                                    self.yang_parent_name = "moi"

                                    self.inner_stack = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                    self.inner_stack.parent = self
                                    self._children_name_map["inner_stack"] = "inner-stack"
                                    self._children_yang_names.add("inner-stack")

                                    self.nexthop = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                    self.nexthop.parent = self
                                    self._children_name_map["nexthop"] = "nexthop"
                                    self._children_yang_names.add("nexthop")


                                class Nexthop(Entity):
                                    """
                                    Nexthop
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv6_next_hop
                                    
                                    	IPv6 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__init__()

                                        self.yang_name = "nexthop"
                                        self.yang_parent_name = "stackv6-data"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv6_next_hop",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv6_next_hop.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv6_next_hop.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nexthop" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6-next-hop"):
                                            self.ipv6_next_hop = value
                                            self.ipv6_next_hop.value_namespace = name_space
                                            self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class InnerStack(Entity):
                                    """
                                    Inner stack
                                    
                                    .. attribute:: label
                                    
                                    	Info related to outgoing labels
                                    	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Remote nexthop addresses
                                    	**type**\:  list of str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: num_lbls
                                    
                                    	Depth of inner label stack
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: num_nexthops
                                    
                                    	Number of remote nexthop addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__init__()

                                        self.yang_name = "inner-stack"
                                        self.yang_parent_name = "stackv6-data"

                                        self.nexthop = YLeafList(YType.str, "nexthop")

                                        self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                        self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                        self.label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nexthop",
                                                        "num_lbls",
                                                        "num_nexthops") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)


                                    class Label(Entity):
                                        """
                                        Info related to outgoing labels
                                        
                                        .. attribute:: outgoing_label
                                        
                                        	Remote Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: outgoing_label_str
                                        
                                        	Remote Label string
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__init__()

                                            self.yang_name = "label"
                                            self.yang_parent_name = "inner-stack"

                                            self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                            self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("outgoing_label",
                                                            "outgoing_label_str") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.outgoing_label.is_set or
                                                self.outgoing_label_str.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.outgoing_label.yfilter != YFilter.not_set or
                                                self.outgoing_label_str.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                            if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "outgoing-label"):
                                                self.outgoing_label = value
                                                self.outgoing_label.value_namespace = name_space
                                                self.outgoing_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "outgoing-label-str"):
                                                self.outgoing_label_str = value
                                                self.outgoing_label_str.value_namespace = name_space
                                                self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.label:
                                            if (c.has_data()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return (
                                            self.num_lbls.is_set or
                                            self.num_nexthops.is_set)

                                    def has_operation(self):
                                        for c in self.label:
                                            if (c.has_operation()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nexthop.yfilter != YFilter.not_set or
                                            self.num_lbls.yfilter != YFilter.not_set or
                                            self.num_nexthops.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inner-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                        if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                        leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "label"):
                                            for c in self.label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nexthop"):
                                            self.nexthop.append(value)
                                        if(value_path == "num-lbls"):
                                            self.num_lbls = value
                                            self.num_lbls.value_namespace = name_space
                                            self.num_lbls.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-nexthops"):
                                            self.num_nexthops = value
                                            self.num_nexthops.value_namespace = name_space
                                            self.num_nexthops.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.inner_stack is not None and self.inner_stack.has_data()) or
                                        (self.nexthop is not None and self.nexthop.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                        (self.nexthop is not None and self.nexthop.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "stackv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "inner-stack"):
                                        if (self.inner_stack is None):
                                            self.inner_stack = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                            self.inner_stack.parent = self
                                            self._children_name_map["inner_stack"] = "inner-stack"
                                        return self.inner_stack

                                    if (child_yang_name == "nexthop"):
                                        if (self.nexthop is None):
                                            self.nexthop = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                            self.nexthop.parent = self
                                            self._children_name_map["nexthop"] = "nexthop"
                                        return self.nexthop

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "inner-stack" or name == "nexthop"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class TeHeadData(Entity):
                                """
                                te head data
                                
                                .. attribute:: flags_decode
                                
                                	Flags decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_fwd_class
                                
                                	Tunnel forwarding class
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: tunnel_load_metric
                                
                                	Tunnel Load metric
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_local_label
                                
                                	Tunnel local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_local_label_str
                                
                                	Tunnel local label stringified
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.TeHeadData, self).__init__()

                                    self.yang_name = "te-head-data"
                                    self.yang_parent_name = "moi"

                                    self.flags_decode = YLeaf(YType.str, "flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.tunnel_fwd_class = YLeaf(YType.uint8, "tunnel-fwd-class")

                                    self.tunnel_load_metric = YLeaf(YType.uint32, "tunnel-load-metric")

                                    self.tunnel_local_label = YLeaf(YType.uint32, "tunnel-local-label")

                                    self.tunnel_local_label_str = YLeaf(YType.str, "tunnel-local-label-str")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("flags_decode",
                                                    "table_id",
                                                    "table_name",
                                                    "tunnel_fwd_class",
                                                    "tunnel_load_metric",
                                                    "tunnel_local_label",
                                                    "tunnel_local_label_str") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.tunnel_fwd_class.is_set or
                                        self.tunnel_load_metric.is_set or
                                        self.tunnel_local_label.is_set or
                                        self.tunnel_local_label_str.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.tunnel_fwd_class.yfilter != YFilter.not_set or
                                        self.tunnel_load_metric.yfilter != YFilter.not_set or
                                        self.tunnel_local_label.yfilter != YFilter.not_set or
                                        self.tunnel_local_label_str.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-head-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.flags_decode.is_set or self.flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.tunnel_fwd_class.is_set or self.tunnel_fwd_class.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_fwd_class.get_name_leafdata())
                                    if (self.tunnel_load_metric.is_set or self.tunnel_load_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_load_metric.get_name_leafdata())
                                    if (self.tunnel_local_label.is_set or self.tunnel_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_local_label.get_name_leafdata())
                                    if (self.tunnel_local_label_str.is_set or self.tunnel_local_label_str.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_local_label_str.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-fwd-class" or name == "tunnel-load-metric" or name == "tunnel-local-label" or name == "tunnel-local-label-str"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "flags-decode"):
                                        self.flags_decode = value
                                        self.flags_decode.value_namespace = name_space
                                        self.flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-fwd-class"):
                                        self.tunnel_fwd_class = value
                                        self.tunnel_fwd_class.value_namespace = name_space
                                        self.tunnel_fwd_class.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-load-metric"):
                                        self.tunnel_load_metric = value
                                        self.tunnel_load_metric.value_namespace = name_space
                                        self.tunnel_load_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-local-label"):
                                        self.tunnel_local_label = value
                                        self.tunnel_local_label.value_namespace = name_space
                                        self.tunnel_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-local-label-str"):
                                        self.tunnel_local_label_str = value
                                        self.tunnel_local_label_str.value_namespace = name_space
                                        self.tunnel_local_label_str.value_namespace_prefix = name_space_prefix


                            class DmtcData(Entity):
                                """
                                dmtc data
                                
                                .. attribute:: dmtc_ext_ifh
                                
                                	DMTC External Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.DmtcData, self).__init__()

                                    self.yang_name = "dmtc-data"
                                    self.yang_parent_name = "moi"

                                    self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.dmtc_ext_ifh.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "dmtc-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-ext-ifh"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dmtc-ext-ifh"):
                                        self.dmtc_ext_ifh = value
                                        self.dmtc_ext_ifh.value_namespace = name_space
                                        self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.moi_type.is_set or
                                    (self.dmtc_data is not None and self.dmtc_data.has_data()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_data()) or
                                    (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_data()) or
                                    (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_data()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                    (self.stackv4_data is not None and self.stackv4_data.has_data()) or
                                    (self.stackv6_data is not None and self.stackv6_data.has_data()) or
                                    (self.te_head_data is not None and self.te_head_data.has_data()) or
                                    (self.tev4_data is not None and self.tev4_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.moi_type.yfilter != YFilter.not_set or
                                    (self.dmtc_data is not None and self.dmtc_data.has_operation()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_operation()) or
                                    (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_operation()) or
                                    (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_operation()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                    (self.stackv4_data is not None and self.stackv4_data.has_operation()) or
                                    (self.stackv6_data is not None and self.stackv6_data.has_operation()) or
                                    (self.te_head_data is not None and self.te_head_data.has_operation()) or
                                    (self.tev4_data is not None and self.tev4_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "moi" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.moi_type.is_set or self.moi_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.moi_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "dmtc-data"):
                                    if (self.dmtc_data is None):
                                        self.dmtc_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.DmtcData()
                                        self.dmtc_data.parent = self
                                        self._children_name_map["dmtc_data"] = "dmtc-data"
                                    return self.dmtc_data

                                if (child_yang_name == "ip-sub-data"):
                                    if (self.ip_sub_data is None):
                                        self.ip_sub_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.IpSubData()
                                        self.ip_sub_data.parent = self
                                        self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    return self.ip_sub_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "pop-and-lookup-ipv4"):
                                    if (self.pop_and_lookup_ipv4 is None):
                                        self.pop_and_lookup_ipv4 = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                        self.pop_and_lookup_ipv4.parent = self
                                        self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                    return self.pop_and_lookup_ipv4

                                if (child_yang_name == "pop-and-lookup-ipv6"):
                                    if (self.pop_and_lookup_ipv6 is None):
                                        self.pop_and_lookup_ipv6 = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                        self.pop_and_lookup_ipv6.parent = self
                                        self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                    return self.pop_and_lookup_ipv6

                                if (child_yang_name == "pop-and-lookup-tp"):
                                    if (self.pop_and_lookup_tp is None):
                                        self.pop_and_lookup_tp = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PopAndLookupTp()
                                        self.pop_and_lookup_tp.parent = self
                                        self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                    return self.pop_and_lookup_tp

                                if (child_yang_name == "pseudowire-data"):
                                    if (self.pseudowire_data is None):
                                        self.pseudowire_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireData()
                                        self.pseudowire_data.parent = self
                                        self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    return self.pseudowire_data

                                if (child_yang_name == "pseudowire-head-end-data"):
                                    if (self.pseudowire_head_end_data is None):
                                        self.pseudowire_head_end_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                        self.pseudowire_head_end_data.parent = self
                                        self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    return self.pseudowire_head_end_data

                                if (child_yang_name == "pw-list-data"):
                                    if (self.pw_list_data is None):
                                        self.pw_list_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.PwListData()
                                        self.pw_list_data.parent = self
                                        self._children_name_map["pw_list_data"] = "pw-list-data"
                                    return self.pw_list_data

                                if (child_yang_name == "stackv4-data"):
                                    if (self.stackv4_data is None):
                                        self.stackv4_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv4Data()
                                        self.stackv4_data.parent = self
                                        self._children_name_map["stackv4_data"] = "stackv4-data"
                                    return self.stackv4_data

                                if (child_yang_name == "stackv6-data"):
                                    if (self.stackv6_data is None):
                                        self.stackv6_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Stackv6Data()
                                        self.stackv6_data.parent = self
                                        self._children_name_map["stackv6_data"] = "stackv6-data"
                                    return self.stackv6_data

                                if (child_yang_name == "te-head-data"):
                                    if (self.te_head_data is None):
                                        self.te_head_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.TeHeadData()
                                        self.te_head_data.parent = self
                                        self._children_name_map["te_head_data"] = "te-head-data"
                                    return self.te_head_data

                                if (child_yang_name == "tev4-data"):
                                    if (self.tev4_data is None):
                                        self.tev4_data = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi.Tev4Data()
                                        self.tev4_data.parent = self
                                        self._children_name_map["tev4_data"] = "tev4-data"
                                    return self.tev4_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-data" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv6-data" or name == "pop-and-lookup-ipv4" or name == "pop-and-lookup-ipv6" or name == "pop-and-lookup-tp" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "pw-list-data" or name == "stackv4-data" or name == "stackv6-data" or name == "te-head-data" or name == "tev4-data" or name == "moi-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "moi-type"):
                                    self.moi_type = value
                                    self.moi_type.value_namespace = name_space
                                    self.moi_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.moi is not None and self.moi.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.moi is not None and self.moi.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "moi-array" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "moi"):
                                if (self.moi is None):
                                    self.moi = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray.Moi()
                                    self.moi.parent = self
                                    self._children_name_map["moi"] = "moi"
                                return self.moi

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "moi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        for c in self.moi_array:
                            if (c.has_data()):
                                return True
                        return (self.application_resource is not None and self.application_resource.has_data())

                    def has_operation(self):
                        for c in self.moi_array:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.application_resource is not None and self.application_resource.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "mois" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application-resource"):
                            if (self.application_resource is None):
                                self.application_resource = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.ApplicationResource()
                                self.application_resource.parent = self
                                self._children_name_map["application_resource"] = "application-resource"
                            return self.application_resource

                        if (child_yang_name == "moi-array"):
                            for c in self.moi_array:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsd.Rewrite.RewritePws.RewritePw.Mois.MoiArray()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.moi_array.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-resource" or name == "moi-array"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    for c in self.associated_fpi:
                        if (c.has_data()):
                            return True
                    for c in self.mois:
                        if (c.has_data()):
                            return True
                    for c in self.v4_rpf:
                        if (c.has_data()):
                            return True
                    for c in self.v6_rpf:
                        if (c.has_data()):
                            return True
                    return (
                        self.pw_list_id.is_set or
                        self.bcdl_priority.is_set or
                        self.lsd_queue.is_set or
                        self.priority_updated.is_set or
                        self.rewrite_version.is_set or
                        self.rw_install_age.is_set or
                        self.rw_install_time.is_set or
                        self.rw_updated.is_set or
                        (self.fpi_key is not None and self.fpi_key.has_data()) or
                        (self.rewrite_id is not None and self.rewrite_id.has_data()))

                def has_operation(self):
                    for c in self.associated_fpi:
                        if (c.has_operation()):
                            return True
                    for c in self.mois:
                        if (c.has_operation()):
                            return True
                    for c in self.v4_rpf:
                        if (c.has_operation()):
                            return True
                    for c in self.v6_rpf:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.pw_list_id.yfilter != YFilter.not_set or
                        self.bcdl_priority.yfilter != YFilter.not_set or
                        self.lsd_queue.yfilter != YFilter.not_set or
                        self.priority_updated.yfilter != YFilter.not_set or
                        self.rewrite_version.yfilter != YFilter.not_set or
                        self.rw_install_age.yfilter != YFilter.not_set or
                        self.rw_install_time.yfilter != YFilter.not_set or
                        self.rw_updated.yfilter != YFilter.not_set or
                        (self.fpi_key is not None and self.fpi_key.has_operation()) or
                        (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "rewrite-pw" + "[pw-list-id='" + self.pw_list_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-pws/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.pw_list_id.is_set or self.pw_list_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pw_list_id.get_name_leafdata())
                    if (self.bcdl_priority.is_set or self.bcdl_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bcdl_priority.get_name_leafdata())
                    if (self.lsd_queue.is_set or self.lsd_queue.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsd_queue.get_name_leafdata())
                    if (self.priority_updated.is_set or self.priority_updated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.priority_updated.get_name_leafdata())
                    if (self.rewrite_version.is_set or self.rewrite_version.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rewrite_version.get_name_leafdata())
                    if (self.rw_install_age.is_set or self.rw_install_age.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rw_install_age.get_name_leafdata())
                    if (self.rw_install_time.is_set or self.rw_install_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rw_install_time.get_name_leafdata())
                    if (self.rw_updated.is_set or self.rw_updated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rw_updated.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "associated-fpi"):
                        for c in self.associated_fpi:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewritePws.RewritePw.AssociatedFpi()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.associated_fpi.append(c)
                        return c

                    if (child_yang_name == "fpi-key"):
                        if (self.fpi_key is None):
                            self.fpi_key = MplsLsd.Rewrite.RewritePws.RewritePw.FpiKey()
                            self.fpi_key.parent = self
                            self._children_name_map["fpi_key"] = "fpi-key"
                        return self.fpi_key

                    if (child_yang_name == "mois"):
                        for c in self.mois:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewritePws.RewritePw.Mois()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.mois.append(c)
                        return c

                    if (child_yang_name == "rewrite-id"):
                        if (self.rewrite_id is None):
                            self.rewrite_id = MplsLsd.Rewrite.RewritePws.RewritePw.RewriteId()
                            self.rewrite_id.parent = self
                            self._children_name_map["rewrite_id"] = "rewrite-id"
                        return self.rewrite_id

                    if (child_yang_name == "v4-rpf"):
                        for c in self.v4_rpf:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewritePws.RewritePw.V4Rpf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.v4_rpf.append(c)
                        return c

                    if (child_yang_name == "v6-rpf"):
                        for c in self.v6_rpf:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewritePws.RewritePw.V6Rpf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.v6_rpf.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "associated-fpi" or name == "fpi-key" or name == "mois" or name == "rewrite-id" or name == "v4-rpf" or name == "v6-rpf" or name == "pw-list-id" or name == "bcdl-priority" or name == "lsd-queue" or name == "priority-updated" or name == "rewrite-version" or name == "rw-install-age" or name == "rw-install-time" or name == "rw-updated"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "pw-list-id"):
                        self.pw_list_id = value
                        self.pw_list_id.value_namespace = name_space
                        self.pw_list_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "bcdl-priority"):
                        self.bcdl_priority = value
                        self.bcdl_priority.value_namespace = name_space
                        self.bcdl_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsd-queue"):
                        self.lsd_queue = value
                        self.lsd_queue.value_namespace = name_space
                        self.lsd_queue.value_namespace_prefix = name_space_prefix
                    if(value_path == "priority-updated"):
                        self.priority_updated = value
                        self.priority_updated.value_namespace = name_space
                        self.priority_updated.value_namespace_prefix = name_space_prefix
                    if(value_path == "rewrite-version"):
                        self.rewrite_version = value
                        self.rewrite_version.value_namespace = name_space
                        self.rewrite_version.value_namespace_prefix = name_space_prefix
                    if(value_path == "rw-install-age"):
                        self.rw_install_age = value
                        self.rw_install_age.value_namespace = name_space
                        self.rw_install_age.value_namespace_prefix = name_space_prefix
                    if(value_path == "rw-install-time"):
                        self.rw_install_time = value
                        self.rw_install_time.value_namespace = name_space
                        self.rw_install_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "rw-updated"):
                        self.rw_updated = value
                        self.rw_updated.value_namespace = name_space
                        self.rw_updated.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.rewrite_pw:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.rewrite_pw:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "rewrite-pws" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "rewrite-pw"):
                    for c in self.rewrite_pw:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsd.Rewrite.RewritePws.RewritePw()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.rewrite_pw.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "rewrite-pw"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class RewriteIpv4S(Entity):
            """
            Table of Rewrites
            
            .. attribute:: rewrite_ipv4
            
            	FPI rewrite for label
            	**type**\: list of    :py:class:`RewriteIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.Rewrite.RewriteIpv4S, self).__init__()

                self.yang_name = "rewrite-ipv4s"
                self.yang_parent_name = "rewrite"

                self.rewrite_ipv4 = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.Rewrite.RewriteIpv4S, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.Rewrite.RewriteIpv4S, self).__setattr__(name, value)


            class RewriteIpv4(Entity):
                """
                FPI rewrite for label
                
                .. attribute:: associated_fpi
                
                	Associated FPI
                	**type**\: list of    :py:class:`AssociatedFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi>`
                
                .. attribute:: bcdl_priority
                
                	BCDL Priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: fpi_key
                
                	fpi key
                	**type**\:   :py:class:`FpiKey <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey>`
                
                .. attribute:: lsd_queue
                
                	LSD queue
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: mois
                
                	Mois
                	**type**\: list of    :py:class:`Mois <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois>`
                
                .. attribute:: prefix
                
                	IPv4 Prefix
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: prefix_length
                
                	Prefix length
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: priority_updated
                
                	Is rewrite's BCDL priority updated
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: rewrite_id
                
                	Rewrite ID
                	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId>`
                
                .. attribute:: rewrite_version
                
                	Rewrite version
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: rsi_table_id
                
                	RSI table ID
                	**type**\:  str
                
                	**pattern:** [0\-9a\-fA\-F]{1,8}
                
                .. attribute:: rsi_table_name
                
                	RSI table name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: rw_install_age
                
                	Rewrite install age
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: rw_install_time
                
                	Rewrite install timestamp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: rw_updated
                
                	Is rewrite ever updated
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: v4_rpf
                
                	IPv4 RPF neighbors
                	**type**\: list of    :py:class:`V4Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.V4Rpf>`
                
                .. attribute:: v6_rpf
                
                	IPv6 RPF neighbors
                	**type**\: list of    :py:class:`V6Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.V6Rpf>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4, self).__init__()

                    self.yang_name = "rewrite-ipv4"
                    self.yang_parent_name = "rewrite-ipv4s"

                    self.bcdl_priority = YLeaf(YType.uint8, "bcdl-priority")

                    self.lsd_queue = YLeaf(YType.uint8, "lsd-queue")

                    self.prefix = YLeaf(YType.str, "prefix")

                    self.prefix_length = YLeaf(YType.int32, "prefix-length")

                    self.priority_updated = YLeaf(YType.int32, "priority-updated")

                    self.rewrite_version = YLeaf(YType.uint64, "rewrite-version")

                    self.rsi_table_id = YLeaf(YType.str, "rsi-table-id")

                    self.rsi_table_name = YLeaf(YType.str, "rsi-table-name")

                    self.rw_install_age = YLeaf(YType.uint64, "rw-install-age")

                    self.rw_install_time = YLeaf(YType.uint64, "rw-install-time")

                    self.rw_updated = YLeaf(YType.int32, "rw-updated")

                    self.fpi_key = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey()
                    self.fpi_key.parent = self
                    self._children_name_map["fpi_key"] = "fpi-key"
                    self._children_yang_names.add("fpi-key")

                    self.rewrite_id = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId()
                    self.rewrite_id.parent = self
                    self._children_name_map["rewrite_id"] = "rewrite-id"
                    self._children_yang_names.add("rewrite-id")

                    self.associated_fpi = YList(self)
                    self.mois = YList(self)
                    self.v4_rpf = YList(self)
                    self.v6_rpf = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("bcdl_priority",
                                    "lsd_queue",
                                    "prefix",
                                    "prefix_length",
                                    "priority_updated",
                                    "rewrite_version",
                                    "rsi_table_id",
                                    "rsi_table_name",
                                    "rw_install_age",
                                    "rw_install_time",
                                    "rw_updated") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4, self).__setattr__(name, value)


                class FpiKey(Entity):
                    """
                    fpi key
                    
                    .. attribute:: application_owner
                    
                    	Application owner instance
                    	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.ApplicationOwner>`
                    
                    .. attribute:: fpi
                    
                    	FPI
                    	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey, self).__init__()

                        self.yang_name = "fpi-key"
                        self.yang_parent_name = "rewrite-ipv4"

                        self.fpi = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi()
                        self.fpi.parent = self
                        self._children_name_map["fpi"] = "fpi"
                        self._children_yang_names.add("fpi")

                        self.application_owner = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey, self).__setattr__(name, value)


                    class Fpi(Entity):
                        """
                        FPI
                        
                        .. attribute:: dmtc_ext_intf_data
                        
                        	dmtc ext intf data
                        	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.DmtcExtIntfData>`
                        
                        .. attribute:: fpi_type
                        
                        	FPIType
                        	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                        
                        .. attribute:: ipv4_data
                        
                        	ipv4 data
                        	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv4Data>`
                        
                        .. attribute:: ipv6_data
                        
                        	ipv6 data
                        	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv6Data>`
                        
                        .. attribute:: label_data
                        
                        	label data
                        	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.LabelData>`
                        
                        .. attribute:: pw_list_data
                        
                        	pw list data
                        	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.PwListData>`
                        
                        .. attribute:: te_data
                        
                        	te data
                        	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.TeData>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi, self).__init__()

                            self.yang_name = "fpi"
                            self.yang_parent_name = "fpi-key"

                            self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                            self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.DmtcExtIntfData()
                            self.dmtc_ext_intf_data.parent = self
                            self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                            self._children_yang_names.add("dmtc-ext-intf-data")

                            self.ipv4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv4Data()
                            self.ipv4_data.parent = self
                            self._children_name_map["ipv4_data"] = "ipv4-data"
                            self._children_yang_names.add("ipv4-data")

                            self.ipv6_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv6Data()
                            self.ipv6_data.parent = self
                            self._children_name_map["ipv6_data"] = "ipv6-data"
                            self._children_yang_names.add("ipv6-data")

                            self.label_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.LabelData()
                            self.label_data.parent = self
                            self._children_name_map["label_data"] = "label-data"
                            self._children_yang_names.add("label-data")

                            self.pw_list_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.PwListData()
                            self.pw_list_data.parent = self
                            self._children_name_map["pw_list_data"] = "pw-list-data"
                            self._children_yang_names.add("pw-list-data")

                            self.te_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.TeData()
                            self.te_data.parent = self
                            self._children_name_map["te_data"] = "te-data"
                            self._children_yang_names.add("te-data")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fpi_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi, self).__setattr__(name, value)


                        class LabelData(Entity):
                            """
                            label data
                            
                            .. attribute:: elc
                            
                            	ELC
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: label
                            
                            	Label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.LabelData, self).__init__()

                                self.yang_name = "label-data"
                                self.yang_parent_name = "fpi"

                                self.elc = YLeaf(YType.int32, "elc")

                                self.label = YLeaf(YType.uint32, "label")

                                self.security_id = YLeaf(YType.uint32, "security-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("elc",
                                                "label",
                                                "security_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.LabelData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.LabelData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.elc.is_set or
                                    self.label.is_set or
                                    self.security_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.elc.yfilter != YFilter.not_set or
                                    self.label.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/fpi-key/fpi/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.elc.get_name_leafdata())
                                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label.get_name_leafdata())
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "elc" or name == "label" or name == "security-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "elc"):
                                    self.elc = value
                                    self.elc.value_namespace = name_space
                                    self.elc.value_namespace_prefix = name_space_prefix
                                if(value_path == "label"):
                                    self.label = value
                                    self.label.value_namespace = name_space
                                    self.label.value_namespace_prefix = name_space_prefix
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix


                        class TeData(Entity):
                            """
                            te data
                            
                            .. attribute:: local_label
                            
                            	Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_interface
                            
                            	Tunnel interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.TeData, self).__init__()

                                self.yang_name = "te-data"
                                self.yang_parent_name = "fpi"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label",
                                                "tunnel_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.TeData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.TeData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.local_label.is_set or
                                    self.tunnel_interface.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.tunnel_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/fpi-key/fpi/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label" or name == "tunnel-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface"):
                                    self.tunnel_interface = value
                                    self.tunnel_interface.value_namespace = name_space
                                    self.tunnel_interface.value_namespace_prefix = name_space_prefix


                        class Ipv4Data(Entity):
                            """
                            ipv4 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: sr_local_label
                            
                            	SR related Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv4Data, self).__init__()

                                self.yang_name = "ipv4-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "sr_local_label",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.sr_local_label.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.sr_local_label.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/fpi-key/fpi/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "sr-local-label"):
                                    self.sr_local_label = value
                                    self.sr_local_label.value_namespace = name_space
                                    self.sr_local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class Ipv6Data(Entity):
                            """
                            ipv6 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_len
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: router_flags
                            
                            	Route flags
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv6Data, self).__init__()

                                self.yang_name = "ipv6-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                self.router_flags = YLeaf(YType.uint32, "router-flags")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_len",
                                                "router_flags",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_len.is_set or
                                    self.router_flags.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_len.yfilter != YFilter.not_set or
                                    self.router_flags.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv6-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/fpi-key/fpi/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.router_flags.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-len"):
                                    self.prefix_len = value
                                    self.prefix_len.value_namespace = name_space
                                    self.prefix_len.value_namespace_prefix = name_space_prefix
                                if(value_path == "router-flags"):
                                    self.router_flags = value
                                    self.router_flags.value_namespace = name_space
                                    self.router_flags.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class PwListData(Entity):
                            """
                            pw list data
                            
                            .. attribute:: pwhe_list_id
                            
                            	Pseudowire List Identifier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.PwListData, self).__init__()

                                self.yang_name = "pw-list-data"
                                self.yang_parent_name = "fpi"

                                self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("pwhe_list_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.PwListData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.PwListData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.pwhe_list_id.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.pwhe_list_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pw-list-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/fpi-key/fpi/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "pwhe-list-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "pwhe-list-id"):
                                    self.pwhe_list_id = value
                                    self.pwhe_list_id.value_namespace = name_space
                                    self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                        class DmtcExtIntfData(Entity):
                            """
                            dmtc ext intf data
                            
                            .. attribute:: dmtc_ext_ifh
                            
                            	DMTC External Interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.DmtcExtIntfData, self).__init__()

                                self.yang_name = "dmtc-ext-intf-data"
                                self.yang_parent_name = "fpi"

                                self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.dmtc_ext_ifh.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "dmtc-ext-intf-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/fpi-key/fpi/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-ifh"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "dmtc-ext-ifh"):
                                    self.dmtc_ext_ifh = value
                                    self.dmtc_ext_ifh.value_namespace = name_space
                                    self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fpi_type.is_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                (self.label_data is not None and self.label_data.has_data()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                (self.te_data is not None and self.te_data.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fpi_type.yfilter != YFilter.not_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                (self.label_data is not None and self.label_data.has_operation()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                (self.te_data is not None and self.te_data.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fpi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/fpi-key/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fpi_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "dmtc-ext-intf-data"):
                                if (self.dmtc_ext_intf_data is None):
                                    self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.DmtcExtIntfData()
                                    self.dmtc_ext_intf_data.parent = self
                                    self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                return self.dmtc_ext_intf_data

                            if (child_yang_name == "ipv4-data"):
                                if (self.ipv4_data is None):
                                    self.ipv4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                return self.ipv4_data

                            if (child_yang_name == "ipv6-data"):
                                if (self.ipv6_data is None):
                                    self.ipv6_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                return self.ipv6_data

                            if (child_yang_name == "label-data"):
                                if (self.label_data is None):
                                    self.label_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.LabelData()
                                    self.label_data.parent = self
                                    self._children_name_map["label_data"] = "label-data"
                                return self.label_data

                            if (child_yang_name == "pw-list-data"):
                                if (self.pw_list_data is None):
                                    self.pw_list_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.PwListData()
                                    self.pw_list_data.parent = self
                                    self._children_name_map["pw_list_data"] = "pw-list-data"
                                return self.pw_list_data

                            if (child_yang_name == "te-data"):
                                if (self.te_data is None):
                                    self.te_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi.TeData()
                                    self.te_data.parent = self
                                    self._children_name_map["te_data"] = "te-data"
                                return self.te_data

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fpi-type"):
                                self.fpi_type = value
                                self.fpi_type.value_namespace = name_space
                                self.fpi_type.value_namespace_prefix = name_space_prefix


                    class ApplicationOwner(Entity):
                        """
                        Application owner instance
                        
                        .. attribute:: application_instance
                        
                        	Application instance Name
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        .. attribute:: resource_state
                        
                        	Application resource state
                        	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.ApplicationOwner, self).__init__()

                            self.yang_name = "application-owner"
                            self.yang_parent_name = "fpi-key"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                            self.resource_state = YLeaf(YType.enumeration, "resource-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type",
                                            "resource_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.ApplicationOwner, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.ApplicationOwner, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set or
                                self.resource_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set or
                                self.resource_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application-owner" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/fpi-key/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())
                            if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resource_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "resource-state"):
                                self.resource_state = value
                                self.resource_state.value_namespace = name_space
                                self.resource_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.application_owner:
                            if (c.has_data()):
                                return True
                        return (self.fpi is not None and self.fpi.has_data())

                    def has_operation(self):
                        for c in self.application_owner:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.fpi is not None and self.fpi.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "fpi-key" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application-owner"):
                            for c in self.application_owner:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.ApplicationOwner()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.application_owner.append(c)
                            return c

                        if (child_yang_name == "fpi"):
                            if (self.fpi is None):
                                self.fpi = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey.Fpi()
                                self.fpi.parent = self
                                self._children_name_map["fpi"] = "fpi"
                            return self.fpi

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-owner" or name == "fpi"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class RewriteId(Entity):
                    """
                    Rewrite ID
                    
                    .. attribute:: rewrite_id
                    
                    	Rewrite ID
                    	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId, self).__init__()

                        self.yang_name = "rewrite-id"
                        self.yang_parent_name = "rewrite-ipv4"

                        self.rewrite_id = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId()
                        self.rewrite_id.parent = self
                        self._children_name_map["rewrite_id"] = "rewrite-id"
                        self._children_yang_names.add("rewrite-id")


                    class RewriteId(Entity):
                        """
                        Rewrite ID
                        
                        .. attribute:: label_context
                        
                        	Label context
                        	**type**\:   :py:class:`LabelContext <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext>`
                        
                        .. attribute:: local_label_rewrite
                        
                        	Local label rewrite information
                        	**type**\:   :py:class:`LocalLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LocalLabelRewrite>`
                        
                        .. attribute:: rewrite_id_type
                        
                        	RewriteIDType
                        	**type**\:   :py:class:`MgmtLsdRwId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdRwId>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId, self).__init__()

                            self.yang_name = "rewrite-id"
                            self.yang_parent_name = "rewrite-id"

                            self.rewrite_id_type = YLeaf(YType.enumeration, "rewrite-id-type")

                            self.label_context = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext()
                            self.label_context.parent = self
                            self._children_name_map["label_context"] = "label-context"
                            self._children_yang_names.add("label-context")

                            self.local_label_rewrite = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LocalLabelRewrite()
                            self.local_label_rewrite.parent = self
                            self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                            self._children_yang_names.add("local-label-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("rewrite_id_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId, self).__setattr__(name, value)


                        class LabelContext(Entity):
                            """
                            Label context
                            
                            .. attribute:: cev4l3vpn_data
                            
                            	L3VPN CEv4 label context
                            	**type**\:   :py:class:`Cev4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev4L3VpnData>`
                            
                            .. attribute:: cev6l3vpn_data
                            
                            	L3VPN CEv6 label context
                            	**type**\:   :py:class:`Cev6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev6L3VpnData>`
                            
                            .. attribute:: evpn_data
                            
                            	EVPN context
                            	**type**\:   :py:class:`EvpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.EvpnData>`
                            
                            .. attribute:: generic_routing_encapsulation
                            
                            	Generic routing encapsulation context
                            	**type**\:   :py:class:`GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation>`
                            
                            .. attribute:: ip_sub_data
                            
                            	IP Subscriber context
                            	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.IpSubData>`
                            
                            .. attribute:: ipv4_data
                            
                            	IPv4 label context
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4Data>`
                            
                            .. attribute:: ipv4blb_data
                            
                            	BFD BLB label context
                            	**type**\:   :py:class:`Ipv4BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4BlbData>`
                            
                            .. attribute:: ipv4l3vpn_data
                            
                            	L3VPN IPv4 label context
                            	**type**\:   :py:class:`Ipv4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData>`
                            
                            .. attribute:: ipv6_data
                            
                            	IPv6 label context
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6Data>`
                            
                            .. attribute:: ipv6_generic_routing_encapsulation
                            
                            	Generic routing encapsulation context
                            	**type**\:   :py:class:`Ipv6GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation>`
                            
                            .. attribute:: ipv6blb_data
                            
                            	BFD BLB label context
                            	**type**\:   :py:class:`Ipv6BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6BlbData>`
                            
                            .. attribute:: ipv6l3vpn_data
                            
                            	L3VPN IPv6 label context
                            	**type**\:   :py:class:`Ipv6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData>`
                            
                            .. attribute:: label_block_data
                            
                            	Label block context
                            	**type**\:   :py:class:`LabelBlockData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockData>`
                            
                            .. attribute:: label_block_srgb_data
                            
                            	Label block SRGB context
                            	**type**\:   :py:class:`LabelBlockSrgbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData>`
                            
                            .. attribute:: label_context_type
                            
                            	LabelContextType
                            	**type**\:   :py:class:`MgmtLsdLblCtx <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLblCtx>`
                            
                            .. attribute:: mld_pv4_data
                            
                            	MLDPv4 LSM\-ID context
                            	**type**\:   :py:class:`MldPv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.MldPv4Data>`
                            
                            .. attribute:: next_hop_set_l3vpn
                            
                            	L3VPN NH SET label context
                            	**type**\:   :py:class:`NextHopSetL3Vpn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn>`
                            
                            .. attribute:: pi_mi_pmsi_data
                            
                            	PIM I\-PMSI label conext
                            	**type**\:   :py:class:`PiMiPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMiPmsiData>`
                            
                            .. attribute:: pi_ms_pmsi_data
                            
                            	PIM S\-PMSI label conext
                            	**type**\:   :py:class:`PiMsPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMsPmsiData>`
                            
                            .. attribute:: pseudowire_data
                            
                            	Pseudowire label context
                            	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireData>`
                            
                            .. attribute:: pseudowire_head_end_data
                            
                            	Pseudowire Head\-end label context
                            	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData>`
                            
                            .. attribute:: sr_adj_segment_ipv4
                            
                            	SR Adj Segment ipv4 context
                            	**type**\:   :py:class:`SrAdjSegmentIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4>`
                            
                            .. attribute:: sr_adj_segment_ipv6
                            
                            	SR Adj Segment ipv6 context
                            	**type**\:   :py:class:`SrAdjSegmentIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6>`
                            
                            .. attribute:: sr_prefix_segment
                            
                            	SR Prefix Segment context
                            	**type**\:   :py:class:`SrPrefixSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrPrefixSegment>`
                            
                            .. attribute:: te_binding
                            
                            	MPLS TE tunnel binding context
                            	**type**\:   :py:class:`TeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TeBinding>`
                            
                            .. attribute:: tev4_data
                            
                            	TEv4 label context
                            	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4Data>`
                            
                            .. attribute:: tev4p2mp_data
                            
                            	TEv4 P2MP context
                            	**type**\:   :py:class:`Tev4P2MpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4P2MpData>`
                            
                            .. attribute:: tp_data
                            
                            	TP context
                            	**type**\:   :py:class:`TpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TpData>`
                            
                            .. attribute:: vrf_l3vpn_data
                            
                            	L3VPN VRF label context
                            	**type**\:   :py:class:`VrfL3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.VrfL3VpnData>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext, self).__init__()

                                self.yang_name = "label-context"
                                self.yang_parent_name = "rewrite-id"

                                self.label_context_type = YLeaf(YType.enumeration, "label-context-type")

                                self.cev4l3vpn_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                self.cev4l3vpn_data.parent = self
                                self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                self._children_yang_names.add("cev4l3vpn-data")

                                self.cev6l3vpn_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                self.cev6l3vpn_data.parent = self
                                self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                self._children_yang_names.add("cev6l3vpn-data")

                                self.evpn_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.EvpnData()
                                self.evpn_data.parent = self
                                self._children_name_map["evpn_data"] = "evpn-data"
                                self._children_yang_names.add("evpn-data")

                                self.generic_routing_encapsulation = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                self.generic_routing_encapsulation.parent = self
                                self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                self._children_yang_names.add("generic-routing-encapsulation")

                                self.ip_sub_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.IpSubData()
                                self.ip_sub_data.parent = self
                                self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                self._children_yang_names.add("ip-sub-data")

                                self.ipv4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv4blb_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                self.ipv4blb_data.parent = self
                                self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                self._children_yang_names.add("ipv4blb-data")

                                self.ipv4l3vpn_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                self.ipv4l3vpn_data.parent = self
                                self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                self._children_yang_names.add("ipv4l3vpn-data")

                                self.ipv6_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.ipv6_generic_routing_encapsulation = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                self.ipv6_generic_routing_encapsulation.parent = self
                                self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                self._children_yang_names.add("ipv6-generic-routing-encapsulation")

                                self.ipv6blb_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                self.ipv6blb_data.parent = self
                                self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                self._children_yang_names.add("ipv6blb-data")

                                self.ipv6l3vpn_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                self.ipv6l3vpn_data.parent = self
                                self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                self._children_yang_names.add("ipv6l3vpn-data")

                                self.label_block_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                self.label_block_data.parent = self
                                self._children_name_map["label_block_data"] = "label-block-data"
                                self._children_yang_names.add("label-block-data")

                                self.label_block_srgb_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                self.label_block_srgb_data.parent = self
                                self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                self._children_yang_names.add("label-block-srgb-data")

                                self.mld_pv4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                self.mld_pv4_data.parent = self
                                self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                self._children_yang_names.add("mld-pv4-data")

                                self.next_hop_set_l3vpn = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                self.next_hop_set_l3vpn.parent = self
                                self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                self._children_yang_names.add("next-hop-set-l3vpn")

                                self.pi_mi_pmsi_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                self.pi_mi_pmsi_data.parent = self
                                self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                self._children_yang_names.add("pi-mi-pmsi-data")

                                self.pi_ms_pmsi_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                self.pi_ms_pmsi_data.parent = self
                                self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                self._children_yang_names.add("pi-ms-pmsi-data")

                                self.pseudowire_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireData()
                                self.pseudowire_data.parent = self
                                self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                self._children_yang_names.add("pseudowire-data")

                                self.pseudowire_head_end_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                self.pseudowire_head_end_data.parent = self
                                self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                self._children_yang_names.add("pseudowire-head-end-data")

                                self.sr_adj_segment_ipv4 = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                self.sr_adj_segment_ipv4.parent = self
                                self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                self._children_yang_names.add("sr-adj-segment-ipv4")

                                self.sr_adj_segment_ipv6 = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                self.sr_adj_segment_ipv6.parent = self
                                self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                self._children_yang_names.add("sr-adj-segment-ipv6")

                                self.sr_prefix_segment = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                self.sr_prefix_segment.parent = self
                                self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                self._children_yang_names.add("sr-prefix-segment")

                                self.te_binding = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TeBinding()
                                self.te_binding.parent = self
                                self._children_name_map["te_binding"] = "te-binding"
                                self._children_yang_names.add("te-binding")

                                self.tev4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4Data()
                                self.tev4_data.parent = self
                                self._children_name_map["tev4_data"] = "tev4-data"
                                self._children_yang_names.add("tev4-data")

                                self.tev4p2mp_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                self.tev4p2mp_data.parent = self
                                self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                self._children_yang_names.add("tev4p2mp-data")

                                self.tp_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TpData()
                                self.tp_data.parent = self
                                self._children_name_map["tp_data"] = "tp-data"
                                self._children_yang_names.add("tp-data")

                                self.vrf_l3vpn_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                self.vrf_l3vpn_data.parent = self
                                self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                self._children_yang_names.add("vrf-l3vpn-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_context_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)


                            class Ipv4Data(Entity):
                                """
                                IPv4 label context
                                
                                .. attribute:: prefix
                                
                                	IPv4 prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	IPv4 prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf_name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                	**length:** 0..33
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.vrf_name = YLeaf(YType.str, "vrf-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "security_id",
                                                    "table_id",
                                                    "vrf_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set or
                                        self.vrf_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.vrf_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-name"):
                                        self.vrf_name = value
                                        self.vrf_name.value_namespace = name_space
                                        self.vrf_name.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                IPv6 label context
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf_name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                	**length:** 0..33
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.vrf_name = YLeaf(YType.str, "vrf-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "security_id",
                                                    "table_id",
                                                    "vrf_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set or
                                        self.vrf_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.vrf_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-name"):
                                        self.vrf_name = value
                                        self.vrf_name.value_namespace = name_space
                                        self.vrf_name.value_namespace_prefix = name_space_prefix


                            class Tev4Data(Entity):
                                """
                                TEv4 label context
                                
                                .. attribute:: is_srte
                                
                                	Is this an SRTE head tunnel
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_dest
                                
                                	Tunnel destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_id_extension
                                
                                	Extended tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_lsp_id
                                
                                	Tunnel LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_source
                                
                                	Tunnel source
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4Data, self).__init__()

                                    self.yang_name = "tev4-data"
                                    self.yang_parent_name = "label-context"

                                    self.is_srte = YLeaf(YType.int32, "is-srte")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.tunnel_dest = YLeaf(YType.str, "tunnel-dest")

                                    self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                    self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                    self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                    self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_srte",
                                                    "table_id",
                                                    "tunnel_dest",
                                                    "tunnel_id",
                                                    "tunnel_id_extension",
                                                    "tunnel_lsp_id",
                                                    "tunnel_source") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_srte.is_set or
                                        self.table_id.is_set or
                                        self.tunnel_dest.is_set or
                                        self.tunnel_id.is_set or
                                        self.tunnel_id_extension.is_set or
                                        self.tunnel_lsp_id.is_set or
                                        self.tunnel_source.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_srte.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.tunnel_dest.yfilter != YFilter.not_set or
                                        self.tunnel_id.yfilter != YFilter.not_set or
                                        self.tunnel_id_extension.yfilter != YFilter.not_set or
                                        self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                        self.tunnel_source.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tev4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_srte.is_set or self.is_srte.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_srte.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.tunnel_dest.is_set or self.tunnel_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_dest.get_name_leafdata())
                                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                    if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                    if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                    if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-srte" or name == "table-id" or name == "tunnel-dest" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-srte"):
                                        self.is_srte = value
                                        self.is_srte.value_namespace = name_space
                                        self.is_srte.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-dest"):
                                        self.tunnel_dest = value
                                        self.tunnel_dest.value_namespace = name_space
                                        self.tunnel_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id"):
                                        self.tunnel_id = value
                                        self.tunnel_id.value_namespace = name_space
                                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id-extension"):
                                        self.tunnel_id_extension = value
                                        self.tunnel_id_extension.value_namespace = name_space
                                        self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-lsp-id"):
                                        self.tunnel_lsp_id = value
                                        self.tunnel_lsp_id.value_namespace = name_space
                                        self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-source"):
                                        self.tunnel_source = value
                                        self.tunnel_source.value_namespace = name_space
                                        self.tunnel_source.value_namespace_prefix = name_space_prefix


                            class Ipv4L3VpnData(Entity):
                                """
                                L3VPN IPv4 label context
                                
                                .. attribute:: prefix
                                
                                	IPv4 prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: route_distinguisher
                                
                                	Route distinguisher
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__init__()

                                    self.yang_name = "ipv4l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "route_distinguisher") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.route_distinguisher.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.route_distinguisher.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-distinguisher"):
                                        self.route_distinguisher = value
                                        self.route_distinguisher.value_namespace = name_space
                                        self.route_distinguisher.value_namespace_prefix = name_space_prefix


                            class Ipv6L3VpnData(Entity):
                                """
                                L3VPN IPv6 label context
                                
                                .. attribute:: prefix
                                
                                	IPv6 prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: route_distinguisher
                                
                                	Route distinguisher
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__init__()

                                    self.yang_name = "ipv6l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "route_distinguisher") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.route_distinguisher.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.route_distinguisher.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-distinguisher"):
                                        self.route_distinguisher = value
                                        self.route_distinguisher.value_namespace = name_space
                                        self.route_distinguisher.value_namespace_prefix = name_space_prefix


                            class VrfL3VpnData(Entity):
                                """
                                L3VPN VRF label context
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__init__()

                                    self.yang_name = "vrf-l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("security_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.security_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf-l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "security-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class Cev4L3VpnData(Entity):
                                """
                                L3VPN CEv4 label context
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__init__()

                                    self.yang_name = "cev4l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_next_hop",
                                                    "security_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ipv4_next_hop.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "cev4l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-next-hop" or name == "security-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class Cev6L3VpnData(Entity):
                                """
                                L3VPN CEv6 label context
                                
                                .. attribute:: ipv6_next_hop
                                
                                	IPv6 nexthop
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__init__()

                                    self.yang_name = "cev6l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv6_next_hop",
                                                    "security_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ipv6_next_hop.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv6_next_hop.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "cev6l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv6-next-hop" or name == "security-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv6-next-hop"):
                                        self.ipv6_next_hop = value
                                        self.ipv6_next_hop.value_namespace = name_space
                                        self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class PseudowireData(Entity):
                                """
                                Pseudowire label context
                                
                                .. attribute:: prefix
                                
                                	Address prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: pseudowire_id
                                
                                	Pseudo\-wire ID
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: remote_l2_router_id
                                
                                	Remote L2 Router ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: subinterface
                                
                                	Subinterface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireData, self).__init__()

                                    self.yang_name = "pseudowire-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.pseudowire_id = YLeaf(YType.uint64, "pseudowire-id")

                                    self.remote_l2_router_id = YLeaf(YType.uint32, "remote-l2-router-id")

                                    self.subinterface = YLeaf(YType.str, "subinterface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "pseudowire_id",
                                                    "remote_l2_router_id",
                                                    "subinterface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.pseudowire_id.is_set or
                                        self.remote_l2_router_id.is_set or
                                        self.subinterface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.pseudowire_id.yfilter != YFilter.not_set or
                                        self.remote_l2_router_id.yfilter != YFilter.not_set or
                                        self.subinterface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pseudowire_id.get_name_leafdata())
                                    if (self.remote_l2_router_id.is_set or self.remote_l2_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.remote_l2_router_id.get_name_leafdata())
                                    if (self.subinterface.is_set or self.subinterface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.subinterface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "pseudowire-id" or name == "remote-l2-router-id" or name == "subinterface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pseudowire-id"):
                                        self.pseudowire_id = value
                                        self.pseudowire_id.value_namespace = name_space
                                        self.pseudowire_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "remote-l2-router-id"):
                                        self.remote_l2_router_id = value
                                        self.remote_l2_router_id.value_namespace = name_space
                                        self.remote_l2_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "subinterface"):
                                        self.subinterface = value
                                        self.subinterface.value_namespace = name_space
                                        self.subinterface.value_namespace_prefix = name_space_prefix


                            class LabelBlockData(Entity):
                                """
                                Label block context
                                
                                .. attribute:: edge_id
                                
                                	Edge ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: offset
                                
                                	Offset
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: service
                                
                                	Service
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: size
                                
                                	Number of labels
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vpn_id
                                
                                	VPN ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__init__()

                                    self.yang_name = "label-block-data"
                                    self.yang_parent_name = "label-context"

                                    self.edge_id = YLeaf(YType.uint16, "edge-id")

                                    self.offset = YLeaf(YType.uint32, "offset")

                                    self.service = YLeaf(YType.uint8, "service")

                                    self.size = YLeaf(YType.uint32, "size")

                                    self.vpn_id = YLeaf(YType.uint16, "vpn-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("edge_id",
                                                    "offset",
                                                    "service",
                                                    "size",
                                                    "vpn_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.edge_id.is_set or
                                        self.offset.is_set or
                                        self.service.is_set or
                                        self.size.is_set or
                                        self.vpn_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.edge_id.yfilter != YFilter.not_set or
                                        self.offset.yfilter != YFilter.not_set or
                                        self.service.yfilter != YFilter.not_set or
                                        self.size.yfilter != YFilter.not_set or
                                        self.vpn_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-block-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.edge_id.is_set or self.edge_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.edge_id.get_name_leafdata())
                                    if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.offset.get_name_leafdata())
                                    if (self.service.is_set or self.service.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service.get_name_leafdata())
                                    if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.size.get_name_leafdata())
                                    if (self.vpn_id.is_set or self.vpn_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vpn_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "edge-id" or name == "offset" or name == "service" or name == "size" or name == "vpn-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "edge-id"):
                                        self.edge_id = value
                                        self.edge_id.value_namespace = name_space
                                        self.edge_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "offset"):
                                        self.offset = value
                                        self.offset.value_namespace = name_space
                                        self.offset.value_namespace_prefix = name_space_prefix
                                    if(value_path == "service"):
                                        self.service = value
                                        self.service.value_namespace = name_space
                                        self.service.value_namespace_prefix = name_space_prefix
                                    if(value_path == "size"):
                                        self.size = value
                                        self.size.value_namespace = name_space
                                        self.size.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vpn-id"):
                                        self.vpn_id = value
                                        self.vpn_id.value_namespace = name_space
                                        self.vpn_id.value_namespace_prefix = name_space_prefix


                            class IpSubData(Entity):
                                """
                                IP Subscriber context
                                
                                .. attribute:: parent_interface
                                
                                	Parent interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: table_id
                                
                                	Table Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.IpSubData, self).__init__()

                                    self.yang_name = "ip-sub-data"
                                    self.yang_parent_name = "label-context"

                                    self.parent_interface = YLeaf(YType.str, "parent-interface")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("parent_interface",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.parent_interface.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.parent_interface.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ip-sub-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.parent_interface.is_set or self.parent_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "parent-interface" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "parent-interface"):
                                        self.parent_interface = value
                                        self.parent_interface.value_namespace = name_space
                                        self.parent_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class Tev4P2MpData(Entity):
                                """
                                TEv4 P2MP context
                                
                                .. attribute:: p2mp_id
                                
                                	Point to multipoint ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: previous_hop
                                
                                	Previous hop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_id_extension
                                
                                	Tunnel ID extension
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_lsp_id
                                
                                	Tunnel LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_source
                                
                                	Tunnel source
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__init__()

                                    self.yang_name = "tev4p2mp-data"
                                    self.yang_parent_name = "label-context"

                                    self.p2mp_id = YLeaf(YType.uint32, "p2mp-id")

                                    self.previous_hop = YLeaf(YType.str, "previous-hop")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                    self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                    self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                    self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("p2mp_id",
                                                    "previous_hop",
                                                    "table_id",
                                                    "tunnel_id",
                                                    "tunnel_id_extension",
                                                    "tunnel_lsp_id",
                                                    "tunnel_source") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.p2mp_id.is_set or
                                        self.previous_hop.is_set or
                                        self.table_id.is_set or
                                        self.tunnel_id.is_set or
                                        self.tunnel_id_extension.is_set or
                                        self.tunnel_lsp_id.is_set or
                                        self.tunnel_source.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.p2mp_id.yfilter != YFilter.not_set or
                                        self.previous_hop.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.tunnel_id.yfilter != YFilter.not_set or
                                        self.tunnel_id_extension.yfilter != YFilter.not_set or
                                        self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                        self.tunnel_source.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tev4p2mp-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                                    if (self.previous_hop.is_set or self.previous_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.previous_hop.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                    if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                    if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                    if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "p2mp-id" or name == "previous-hop" or name == "table-id" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "p2mp-id"):
                                        self.p2mp_id = value
                                        self.p2mp_id.value_namespace = name_space
                                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "previous-hop"):
                                        self.previous_hop = value
                                        self.previous_hop.value_namespace = name_space
                                        self.previous_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id"):
                                        self.tunnel_id = value
                                        self.tunnel_id.value_namespace = name_space
                                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id-extension"):
                                        self.tunnel_id_extension = value
                                        self.tunnel_id_extension.value_namespace = name_space
                                        self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-lsp-id"):
                                        self.tunnel_lsp_id = value
                                        self.tunnel_lsp_id.value_namespace = name_space
                                        self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-source"):
                                        self.tunnel_source = value
                                        self.tunnel_source.value_namespace = name_space
                                        self.tunnel_source.value_namespace_prefix = name_space_prefix


                            class MldPv4Data(Entity):
                                """
                                MLDPv4 LSM\-ID context
                                
                                .. attribute:: lsm_id
                                
                                	LSM ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: peer_label_space_id
                                
                                	Peer Label Space Id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: peer_lsrid
                                
                                	Peer LSR Id
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: type
                                
                                	LSM ID Type
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__init__()

                                    self.yang_name = "mld-pv4-data"
                                    self.yang_parent_name = "label-context"

                                    self.lsm_id = YLeaf(YType.uint32, "lsm-id")

                                    self.peer_label_space_id = YLeaf(YType.uint16, "peer-label-space-id")

                                    self.peer_lsrid = YLeaf(YType.str, "peer-lsrid")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("lsm_id",
                                                    "peer_label_space_id",
                                                    "peer_lsrid",
                                                    "table_id",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.lsm_id.is_set or
                                        self.peer_label_space_id.is_set or
                                        self.peer_lsrid.is_set or
                                        self.table_id.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.lsm_id.yfilter != YFilter.not_set or
                                        self.peer_label_space_id.yfilter != YFilter.not_set or
                                        self.peer_lsrid.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "mld-pv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.lsm_id.is_set or self.lsm_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsm_id.get_name_leafdata())
                                    if (self.peer_label_space_id.is_set or self.peer_label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_label_space_id.get_name_leafdata())
                                    if (self.peer_lsrid.is_set or self.peer_lsrid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_lsrid.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "lsm-id" or name == "peer-label-space-id" or name == "peer-lsrid" or name == "table-id" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "lsm-id"):
                                        self.lsm_id = value
                                        self.lsm_id.value_namespace = name_space
                                        self.lsm_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-label-space-id"):
                                        self.peer_label_space_id = value
                                        self.peer_label_space_id.value_namespace = name_space
                                        self.peer_label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-lsrid"):
                                        self.peer_lsrid = value
                                        self.peer_lsrid.value_namespace = name_space
                                        self.peer_lsrid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class PseudowireHeadEndData(Entity):
                                """
                                Pseudowire Head\-end label context
                                
                                .. attribute:: pwhe_intf
                                
                                	Pseudo\-wire Head\-end interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__init__()

                                    self.yang_name = "pseudowire-head-end-data"
                                    self.yang_parent_name = "label-context"

                                    self.pwhe_intf = YLeaf(YType.str, "pwhe-intf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("pwhe_intf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.pwhe_intf.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.pwhe_intf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-head-end-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.pwhe_intf.is_set or self.pwhe_intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_intf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "pwhe-intf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "pwhe-intf"):
                                        self.pwhe_intf = value
                                        self.pwhe_intf.value_namespace = name_space
                                        self.pwhe_intf.value_namespace_prefix = name_space_prefix


                            class TpData(Entity):
                                """
                                TP context
                                
                                .. attribute:: dest_global_id
                                
                                	TP destination global ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: dest_node_id
                                
                                	TP destination node ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: dest_tunnel_id
                                
                                	TP destination tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsp_id
                                
                                	TP LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: source_global_id
                                
                                	TP source global ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: source_node_id
                                
                                	TP source node ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: source_tunnel_id
                                
                                	TP source tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TpData, self).__init__()

                                    self.yang_name = "tp-data"
                                    self.yang_parent_name = "label-context"

                                    self.dest_global_id = YLeaf(YType.uint32, "dest-global-id")

                                    self.dest_node_id = YLeaf(YType.str, "dest-node-id")

                                    self.dest_tunnel_id = YLeaf(YType.uint16, "dest-tunnel-id")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                    self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                                    self.source_node_id = YLeaf(YType.str, "source-node-id")

                                    self.source_tunnel_id = YLeaf(YType.uint16, "source-tunnel-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dest_global_id",
                                                    "dest_node_id",
                                                    "dest_tunnel_id",
                                                    "lsp_id",
                                                    "source_global_id",
                                                    "source_node_id",
                                                    "source_tunnel_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.dest_global_id.is_set or
                                        self.dest_node_id.is_set or
                                        self.dest_tunnel_id.is_set or
                                        self.lsp_id.is_set or
                                        self.source_global_id.is_set or
                                        self.source_node_id.is_set or
                                        self.source_tunnel_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dest_global_id.yfilter != YFilter.not_set or
                                        self.dest_node_id.yfilter != YFilter.not_set or
                                        self.dest_tunnel_id.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set or
                                        self.source_global_id.yfilter != YFilter.not_set or
                                        self.source_node_id.yfilter != YFilter.not_set or
                                        self.source_tunnel_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tp-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dest_global_id.is_set or self.dest_global_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dest_global_id.get_name_leafdata())
                                    if (self.dest_node_id.is_set or self.dest_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dest_node_id.get_name_leafdata())
                                    if (self.dest_tunnel_id.is_set or self.dest_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dest_tunnel_id.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                                    if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_global_id.get_name_leafdata())
                                    if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_node_id.get_name_leafdata())
                                    if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dest-global-id" or name == "dest-node-id" or name == "dest-tunnel-id" or name == "lsp-id" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dest-global-id"):
                                        self.dest_global_id = value
                                        self.dest_global_id.value_namespace = name_space
                                        self.dest_global_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dest-node-id"):
                                        self.dest_node_id = value
                                        self.dest_node_id.value_namespace = name_space
                                        self.dest_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dest-tunnel-id"):
                                        self.dest_tunnel_id = value
                                        self.dest_tunnel_id.value_namespace = name_space
                                        self.dest_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-global-id"):
                                        self.source_global_id = value
                                        self.source_global_id.value_namespace = name_space
                                        self.source_global_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-node-id"):
                                        self.source_node_id = value
                                        self.source_node_id.value_namespace = name_space
                                        self.source_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-tunnel-id"):
                                        self.source_tunnel_id = value
                                        self.source_tunnel_id.value_namespace = name_space
                                        self.source_tunnel_id.value_namespace_prefix = name_space_prefix


                            class GenericRoutingEncapsulation(Entity):
                                """
                                Generic routing encapsulation context
                                
                                .. attribute:: gre_interface
                                
                                	Generic routing encapsulation interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__init__()

                                    self.yang_name = "generic-routing-encapsulation"
                                    self.yang_parent_name = "label-context"

                                    self.gre_interface = YLeaf(YType.str, "gre-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("gre_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.gre_interface.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.gre_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "generic-routing-encapsulation" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.gre_interface.is_set or self.gre_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gre_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "gre-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "gre-interface"):
                                        self.gre_interface = value
                                        self.gre_interface.value_namespace = name_space
                                        self.gre_interface.value_namespace_prefix = name_space_prefix


                            class Ipv6GenericRoutingEncapsulation(Entity):
                                """
                                Generic routing encapsulation context
                                
                                .. attribute:: greipv6_interface
                                
                                	Generic routing encapsulation IPv6 interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__init__()

                                    self.yang_name = "ipv6-generic-routing-encapsulation"
                                    self.yang_parent_name = "label-context"

                                    self.greipv6_interface = YLeaf(YType.str, "greipv6-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("greipv6_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.greipv6_interface.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.greipv6_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-generic-routing-encapsulation" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.greipv6_interface.is_set or self.greipv6_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.greipv6_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "greipv6-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "greipv6-interface"):
                                        self.greipv6_interface = value
                                        self.greipv6_interface.value_namespace = name_space
                                        self.greipv6_interface.value_namespace_prefix = name_space_prefix


                            class EvpnData(Entity):
                                """
                                EVPN context
                                
                                .. attribute:: ethernet_segment
                                
                                	Ethernet Segment ID
                                	**type**\:  str
                                
                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                
                                .. attribute:: evpn_id
                                
                                	EVPN ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: evpn_tag
                                
                                	EVPN TAG
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.EvpnData, self).__init__()

                                    self.yang_name = "evpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.ethernet_segment = YLeaf(YType.str, "ethernet-segment")

                                    self.evpn_id = YLeaf(YType.uint32, "evpn-id")

                                    self.evpn_tag = YLeaf(YType.uint32, "evpn-tag")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ethernet_segment",
                                                    "evpn_id",
                                                    "evpn_tag") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ethernet_segment.is_set or
                                        self.evpn_id.is_set or
                                        self.evpn_tag.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ethernet_segment.yfilter != YFilter.not_set or
                                        self.evpn_id.yfilter != YFilter.not_set or
                                        self.evpn_tag.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "evpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ethernet_segment.is_set or self.ethernet_segment.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ethernet_segment.get_name_leafdata())
                                    if (self.evpn_id.is_set or self.evpn_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.evpn_id.get_name_leafdata())
                                    if (self.evpn_tag.is_set or self.evpn_tag.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.evpn_tag.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ethernet-segment" or name == "evpn-id" or name == "evpn-tag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ethernet-segment"):
                                        self.ethernet_segment = value
                                        self.ethernet_segment.value_namespace = name_space
                                        self.ethernet_segment.value_namespace_prefix = name_space_prefix
                                    if(value_path == "evpn-id"):
                                        self.evpn_id = value
                                        self.evpn_id.value_namespace = name_space
                                        self.evpn_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "evpn-tag"):
                                        self.evpn_tag = value
                                        self.evpn_tag.value_namespace = name_space
                                        self.evpn_tag.value_namespace_prefix = name_space_prefix


                            class Ipv4BlbData(Entity):
                                """
                                BFD BLB label context
                                
                                .. attribute:: blb_intf
                                
                                	BFD BLB interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: prefix
                                
                                	IPv4 prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__init__()

                                    self.yang_name = "ipv4blb-data"
                                    self.yang_parent_name = "label-context"

                                    self.blb_intf = YLeaf(YType.str, "blb-intf")

                                    self.prefix = YLeaf(YType.str, "prefix")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("blb_intf",
                                                    "prefix") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.blb_intf.is_set or
                                        self.prefix.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.blb_intf.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4blb-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "blb-intf" or name == "prefix"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "blb-intf"):
                                        self.blb_intf = value
                                        self.blb_intf.value_namespace = name_space
                                        self.blb_intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix


                            class Ipv6BlbData(Entity):
                                """
                                BFD BLB label context
                                
                                .. attribute:: blb_intf
                                
                                	BFD BLB interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: prefix
                                
                                	IPv6 prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__init__()

                                    self.yang_name = "ipv6blb-data"
                                    self.yang_parent_name = "label-context"

                                    self.blb_intf = YLeaf(YType.str, "blb-intf")

                                    self.prefix = YLeaf(YType.str, "prefix")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("blb_intf",
                                                    "prefix") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.blb_intf.is_set or
                                        self.prefix.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.blb_intf.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6blb-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "blb-intf" or name == "prefix"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "blb-intf"):
                                        self.blb_intf = value
                                        self.blb_intf.value_namespace = name_space
                                        self.blb_intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix


                            class PiMiPmsiData(Entity):
                                """
                                PIM I\-PMSI label conext
                                
                                .. attribute:: head
                                
                                	Head
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: v6
                                
                                	PIM6
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: vrf_id
                                
                                	VRF ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__init__()

                                    self.yang_name = "pi-mi-pmsi-data"
                                    self.yang_parent_name = "label-context"

                                    self.head = YLeaf(YType.int32, "head")

                                    self.v6 = YLeaf(YType.int32, "v6")

                                    self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("head",
                                                    "v6",
                                                    "vrf_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.head.is_set or
                                        self.v6.is_set or
                                        self.vrf_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.head.yfilter != YFilter.not_set or
                                        self.v6.yfilter != YFilter.not_set or
                                        self.vrf_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pi-mi-pmsi-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.head.get_name_leafdata())
                                    if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.v6.get_name_leafdata())
                                    if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "head" or name == "v6" or name == "vrf-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "head"):
                                        self.head = value
                                        self.head.value_namespace = name_space
                                        self.head.value_namespace_prefix = name_space_prefix
                                    if(value_path == "v6"):
                                        self.v6 = value
                                        self.v6.value_namespace = name_space
                                        self.v6.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-id"):
                                        self.vrf_id = value
                                        self.vrf_id.value_namespace = name_space
                                        self.vrf_id.value_namespace_prefix = name_space_prefix


                            class PiMsPmsiData(Entity):
                                """
                                PIM S\-PMSI label conext
                                
                                .. attribute:: head
                                
                                	Head
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: hli
                                
                                	Head LSM\-ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: seg
                                
                                	Segmented Multicast
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: source
                                
                                	Originating Router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: v6
                                
                                	PIM6
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: vrf_id
                                
                                	VRF ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__init__()

                                    self.yang_name = "pi-ms-pmsi-data"
                                    self.yang_parent_name = "label-context"

                                    self.head = YLeaf(YType.int32, "head")

                                    self.hli = YLeaf(YType.uint32, "hli")

                                    self.seg = YLeaf(YType.int32, "seg")

                                    self.source = YLeaf(YType.str, "source")

                                    self.v6 = YLeaf(YType.int32, "v6")

                                    self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("head",
                                                    "hli",
                                                    "seg",
                                                    "source",
                                                    "v6",
                                                    "vrf_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.head.is_set or
                                        self.hli.is_set or
                                        self.seg.is_set or
                                        self.source.is_set or
                                        self.v6.is_set or
                                        self.vrf_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.head.yfilter != YFilter.not_set or
                                        self.hli.yfilter != YFilter.not_set or
                                        self.seg.yfilter != YFilter.not_set or
                                        self.source.yfilter != YFilter.not_set or
                                        self.v6.yfilter != YFilter.not_set or
                                        self.vrf_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pi-ms-pmsi-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.head.get_name_leafdata())
                                    if (self.hli.is_set or self.hli.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hli.get_name_leafdata())
                                    if (self.seg.is_set or self.seg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.seg.get_name_leafdata())
                                    if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source.get_name_leafdata())
                                    if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.v6.get_name_leafdata())
                                    if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "head" or name == "hli" or name == "seg" or name == "source" or name == "v6" or name == "vrf-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "head"):
                                        self.head = value
                                        self.head.value_namespace = name_space
                                        self.head.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hli"):
                                        self.hli = value
                                        self.hli.value_namespace = name_space
                                        self.hli.value_namespace_prefix = name_space_prefix
                                    if(value_path == "seg"):
                                        self.seg = value
                                        self.seg.value_namespace = name_space
                                        self.seg.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source"):
                                        self.source = value
                                        self.source.value_namespace = name_space
                                        self.source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "v6"):
                                        self.v6 = value
                                        self.v6.value_namespace = name_space
                                        self.v6.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-id"):
                                        self.vrf_id = value
                                        self.vrf_id.value_namespace = name_space
                                        self.vrf_id.value_namespace_prefix = name_space_prefix


                            class NextHopSetL3Vpn(Entity):
                                """
                                L3VPN NH SET label context
                                
                                .. attribute:: next_hop_set_id
                                
                                	Next Hop Set ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__init__()

                                    self.yang_name = "next-hop-set-l3vpn"
                                    self.yang_parent_name = "label-context"

                                    self.next_hop_set_id = YLeaf(YType.uint32, "next-hop-set-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_set_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.next_hop_set_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_set_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "next-hop-set-l3vpn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_set_id.is_set or self.next_hop_set_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_set_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "next-hop-set-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-set-id"):
                                        self.next_hop_set_id = value
                                        self.next_hop_set_id.value_namespace = name_space
                                        self.next_hop_set_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class SrPrefixSegment(Entity):
                                """
                                SR Prefix Segment context
                                
                                .. attribute:: segment_id
                                
                                	Prefix Segment ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__init__()

                                    self.yang_name = "sr-prefix-segment"
                                    self.yang_parent_name = "label-context"

                                    self.segment_id = YLeaf(YType.uint32, "segment-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("segment_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.segment_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.segment_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-prefix-segment" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.segment_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "segment-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "segment-id"):
                                        self.segment_id = value
                                        self.segment_id.value_namespace = name_space
                                        self.segment_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class SrAdjSegmentIpv4(Entity):
                                """
                                SR Adj Segment ipv4 context
                                
                                .. attribute:: addr
                                
                                	Adjacency nexthop IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: index
                                
                                	Adjacency index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: intf
                                
                                	Adjacency interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: type
                                
                                	Adjacency type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__init__()

                                    self.yang_name = "sr-adj-segment-ipv4"
                                    self.yang_parent_name = "label-context"

                                    self.addr = YLeaf(YType.str, "addr")

                                    self.index = YLeaf(YType.uint32, "index")

                                    self.intf = YLeaf(YType.str, "intf")

                                    self.type = YLeaf(YType.uint32, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("addr",
                                                    "index",
                                                    "intf",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.addr.is_set or
                                        self.index.is_set or
                                        self.intf.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.addr.yfilter != YFilter.not_set or
                                        self.index.yfilter != YFilter.not_set or
                                        self.intf.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-adj-segment-ipv4" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.addr.get_name_leafdata())
                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.index.get_name_leafdata())
                                    if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intf.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "addr"):
                                        self.addr = value
                                        self.addr.value_namespace = name_space
                                        self.addr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "index"):
                                        self.index = value
                                        self.index.value_namespace = name_space
                                        self.index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intf"):
                                        self.intf = value
                                        self.intf.value_namespace = name_space
                                        self.intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class SrAdjSegmentIpv6(Entity):
                                """
                                SR Adj Segment ipv6 context
                                
                                .. attribute:: addr
                                
                                	Adjacency nexthop IPv6 address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: index
                                
                                	Adjacency index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: intf
                                
                                	Adjacency interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: type
                                
                                	Adjacency type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__init__()

                                    self.yang_name = "sr-adj-segment-ipv6"
                                    self.yang_parent_name = "label-context"

                                    self.addr = YLeaf(YType.str, "addr")

                                    self.index = YLeaf(YType.uint32, "index")

                                    self.intf = YLeaf(YType.str, "intf")

                                    self.type = YLeaf(YType.uint32, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("addr",
                                                    "index",
                                                    "intf",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.addr.is_set or
                                        self.index.is_set or
                                        self.intf.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.addr.yfilter != YFilter.not_set or
                                        self.index.yfilter != YFilter.not_set or
                                        self.intf.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-adj-segment-ipv6" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.addr.get_name_leafdata())
                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.index.get_name_leafdata())
                                    if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intf.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "addr"):
                                        self.addr = value
                                        self.addr.value_namespace = name_space
                                        self.addr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "index"):
                                        self.index = value
                                        self.index.value_namespace = name_space
                                        self.index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intf"):
                                        self.intf = value
                                        self.intf.value_namespace = name_space
                                        self.intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class LabelBlockSrgbData(Entity):
                                """
                                Label block SRGB context
                                
                                .. attribute:: offset
                                
                                	Offset
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: size
                                
                                	Number of labels
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: start_label
                                
                                	Start Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__init__()

                                    self.yang_name = "label-block-srgb-data"
                                    self.yang_parent_name = "label-context"

                                    self.offset = YLeaf(YType.uint32, "offset")

                                    self.size = YLeaf(YType.uint32, "size")

                                    self.start_label = YLeaf(YType.uint32, "start-label")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("offset",
                                                    "size",
                                                    "start_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.offset.is_set or
                                        self.size.is_set or
                                        self.start_label.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.offset.yfilter != YFilter.not_set or
                                        self.size.yfilter != YFilter.not_set or
                                        self.start_label.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-block-srgb-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.offset.get_name_leafdata())
                                    if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.size.get_name_leafdata())
                                    if (self.start_label.is_set or self.start_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.start_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "offset" or name == "size" or name == "start-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "offset"):
                                        self.offset = value
                                        self.offset.value_namespace = name_space
                                        self.offset.value_namespace_prefix = name_space_prefix
                                    if(value_path == "size"):
                                        self.size = value
                                        self.size.value_namespace = name_space
                                        self.size.value_namespace_prefix = name_space_prefix
                                    if(value_path == "start-label"):
                                        self.start_label = value
                                        self.start_label.value_namespace = name_space
                                        self.start_label.value_namespace_prefix = name_space_prefix


                            class TeBinding(Entity):
                                """
                                MPLS TE tunnel binding context
                                
                                .. attribute:: te_identifier
                                
                                	MPLS Traffic Engineering Tunnel or Group ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: te_type
                                
                                	Type of identifier for the binding
                                	**type**\:   :py:class:`MgmtLsdTeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdTeBinding>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TeBinding, self).__init__()

                                    self.yang_name = "te-binding"
                                    self.yang_parent_name = "label-context"

                                    self.te_identifier = YLeaf(YType.uint32, "te-identifier")

                                    self.te_type = YLeaf(YType.enumeration, "te-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("te_identifier",
                                                    "te_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.te_identifier.is_set or
                                        self.te_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.te_identifier.yfilter != YFilter.not_set or
                                        self.te_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-binding" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/label-context/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.te_identifier.is_set or self.te_identifier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_identifier.get_name_leafdata())
                                    if (self.te_type.is_set or self.te_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "te-identifier" or name == "te-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "te-identifier"):
                                        self.te_identifier = value
                                        self.te_identifier.value_namespace = name_space
                                        self.te_identifier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "te-type"):
                                        self.te_type = value
                                        self.te_type.value_namespace = name_space
                                        self.te_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.label_context_type.is_set or
                                    (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_data()) or
                                    (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_data()) or
                                    (self.evpn_data is not None and self.evpn_data.has_data()) or
                                    (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_data()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv4blb_data is not None and self.ipv4blb_data.has_data()) or
                                    (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_data()) or
                                    (self.ipv6blb_data is not None and self.ipv6blb_data.has_data()) or
                                    (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_data()) or
                                    (self.label_block_data is not None and self.label_block_data.has_data()) or
                                    (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_data()) or
                                    (self.mld_pv4_data is not None and self.mld_pv4_data.has_data()) or
                                    (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_data()) or
                                    (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_data()) or
                                    (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_data()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                    (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_data()) or
                                    (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_data()) or
                                    (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_data()) or
                                    (self.te_binding is not None and self.te_binding.has_data()) or
                                    (self.tev4_data is not None and self.tev4_data.has_data()) or
                                    (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_data()) or
                                    (self.tp_data is not None and self.tp_data.has_data()) or
                                    (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_context_type.yfilter != YFilter.not_set or
                                    (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_operation()) or
                                    (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_operation()) or
                                    (self.evpn_data is not None and self.evpn_data.has_operation()) or
                                    (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_operation()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv4blb_data is not None and self.ipv4blb_data.has_operation()) or
                                    (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_operation()) or
                                    (self.ipv6blb_data is not None and self.ipv6blb_data.has_operation()) or
                                    (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_operation()) or
                                    (self.label_block_data is not None and self.label_block_data.has_operation()) or
                                    (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_operation()) or
                                    (self.mld_pv4_data is not None and self.mld_pv4_data.has_operation()) or
                                    (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_operation()) or
                                    (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_operation()) or
                                    (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_operation()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                    (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_operation()) or
                                    (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_operation()) or
                                    (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_operation()) or
                                    (self.te_binding is not None and self.te_binding.has_operation()) or
                                    (self.tev4_data is not None and self.tev4_data.has_operation()) or
                                    (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_operation()) or
                                    (self.tp_data is not None and self.tp_data.has_operation()) or
                                    (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-context" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_context_type.is_set or self.label_context_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_context_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "cev4l3vpn-data"):
                                    if (self.cev4l3vpn_data is None):
                                        self.cev4l3vpn_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                        self.cev4l3vpn_data.parent = self
                                        self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                    return self.cev4l3vpn_data

                                if (child_yang_name == "cev6l3vpn-data"):
                                    if (self.cev6l3vpn_data is None):
                                        self.cev6l3vpn_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                        self.cev6l3vpn_data.parent = self
                                        self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                    return self.cev6l3vpn_data

                                if (child_yang_name == "evpn-data"):
                                    if (self.evpn_data is None):
                                        self.evpn_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.EvpnData()
                                        self.evpn_data.parent = self
                                        self._children_name_map["evpn_data"] = "evpn-data"
                                    return self.evpn_data

                                if (child_yang_name == "generic-routing-encapsulation"):
                                    if (self.generic_routing_encapsulation is None):
                                        self.generic_routing_encapsulation = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                        self.generic_routing_encapsulation.parent = self
                                        self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                    return self.generic_routing_encapsulation

                                if (child_yang_name == "ip-sub-data"):
                                    if (self.ip_sub_data is None):
                                        self.ip_sub_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.IpSubData()
                                        self.ip_sub_data.parent = self
                                        self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    return self.ip_sub_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv4blb-data"):
                                    if (self.ipv4blb_data is None):
                                        self.ipv4blb_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                        self.ipv4blb_data.parent = self
                                        self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                    return self.ipv4blb_data

                                if (child_yang_name == "ipv4l3vpn-data"):
                                    if (self.ipv4l3vpn_data is None):
                                        self.ipv4l3vpn_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                        self.ipv4l3vpn_data.parent = self
                                        self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                    return self.ipv4l3vpn_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "ipv6-generic-routing-encapsulation"):
                                    if (self.ipv6_generic_routing_encapsulation is None):
                                        self.ipv6_generic_routing_encapsulation = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                        self.ipv6_generic_routing_encapsulation.parent = self
                                        self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                    return self.ipv6_generic_routing_encapsulation

                                if (child_yang_name == "ipv6blb-data"):
                                    if (self.ipv6blb_data is None):
                                        self.ipv6blb_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                        self.ipv6blb_data.parent = self
                                        self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                    return self.ipv6blb_data

                                if (child_yang_name == "ipv6l3vpn-data"):
                                    if (self.ipv6l3vpn_data is None):
                                        self.ipv6l3vpn_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                        self.ipv6l3vpn_data.parent = self
                                        self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                    return self.ipv6l3vpn_data

                                if (child_yang_name == "label-block-data"):
                                    if (self.label_block_data is None):
                                        self.label_block_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                        self.label_block_data.parent = self
                                        self._children_name_map["label_block_data"] = "label-block-data"
                                    return self.label_block_data

                                if (child_yang_name == "label-block-srgb-data"):
                                    if (self.label_block_srgb_data is None):
                                        self.label_block_srgb_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                        self.label_block_srgb_data.parent = self
                                        self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                    return self.label_block_srgb_data

                                if (child_yang_name == "mld-pv4-data"):
                                    if (self.mld_pv4_data is None):
                                        self.mld_pv4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                        self.mld_pv4_data.parent = self
                                        self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                    return self.mld_pv4_data

                                if (child_yang_name == "next-hop-set-l3vpn"):
                                    if (self.next_hop_set_l3vpn is None):
                                        self.next_hop_set_l3vpn = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                        self.next_hop_set_l3vpn.parent = self
                                        self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                    return self.next_hop_set_l3vpn

                                if (child_yang_name == "pi-mi-pmsi-data"):
                                    if (self.pi_mi_pmsi_data is None):
                                        self.pi_mi_pmsi_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                        self.pi_mi_pmsi_data.parent = self
                                        self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                    return self.pi_mi_pmsi_data

                                if (child_yang_name == "pi-ms-pmsi-data"):
                                    if (self.pi_ms_pmsi_data is None):
                                        self.pi_ms_pmsi_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                        self.pi_ms_pmsi_data.parent = self
                                        self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                    return self.pi_ms_pmsi_data

                                if (child_yang_name == "pseudowire-data"):
                                    if (self.pseudowire_data is None):
                                        self.pseudowire_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireData()
                                        self.pseudowire_data.parent = self
                                        self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    return self.pseudowire_data

                                if (child_yang_name == "pseudowire-head-end-data"):
                                    if (self.pseudowire_head_end_data is None):
                                        self.pseudowire_head_end_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                        self.pseudowire_head_end_data.parent = self
                                        self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    return self.pseudowire_head_end_data

                                if (child_yang_name == "sr-adj-segment-ipv4"):
                                    if (self.sr_adj_segment_ipv4 is None):
                                        self.sr_adj_segment_ipv4 = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                        self.sr_adj_segment_ipv4.parent = self
                                        self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                    return self.sr_adj_segment_ipv4

                                if (child_yang_name == "sr-adj-segment-ipv6"):
                                    if (self.sr_adj_segment_ipv6 is None):
                                        self.sr_adj_segment_ipv6 = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                        self.sr_adj_segment_ipv6.parent = self
                                        self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                    return self.sr_adj_segment_ipv6

                                if (child_yang_name == "sr-prefix-segment"):
                                    if (self.sr_prefix_segment is None):
                                        self.sr_prefix_segment = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                        self.sr_prefix_segment.parent = self
                                        self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                    return self.sr_prefix_segment

                                if (child_yang_name == "te-binding"):
                                    if (self.te_binding is None):
                                        self.te_binding = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TeBinding()
                                        self.te_binding.parent = self
                                        self._children_name_map["te_binding"] = "te-binding"
                                    return self.te_binding

                                if (child_yang_name == "tev4-data"):
                                    if (self.tev4_data is None):
                                        self.tev4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4Data()
                                        self.tev4_data.parent = self
                                        self._children_name_map["tev4_data"] = "tev4-data"
                                    return self.tev4_data

                                if (child_yang_name == "tev4p2mp-data"):
                                    if (self.tev4p2mp_data is None):
                                        self.tev4p2mp_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                        self.tev4p2mp_data.parent = self
                                        self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                    return self.tev4p2mp_data

                                if (child_yang_name == "tp-data"):
                                    if (self.tp_data is None):
                                        self.tp_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.TpData()
                                        self.tp_data.parent = self
                                        self._children_name_map["tp_data"] = "tp-data"
                                    return self.tp_data

                                if (child_yang_name == "vrf-l3vpn-data"):
                                    if (self.vrf_l3vpn_data is None):
                                        self.vrf_l3vpn_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                        self.vrf_l3vpn_data.parent = self
                                        self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                    return self.vrf_l3vpn_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "cev4l3vpn-data" or name == "cev6l3vpn-data" or name == "evpn-data" or name == "generic-routing-encapsulation" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv4blb-data" or name == "ipv4l3vpn-data" or name == "ipv6-data" or name == "ipv6-generic-routing-encapsulation" or name == "ipv6blb-data" or name == "ipv6l3vpn-data" or name == "label-block-data" or name == "label-block-srgb-data" or name == "mld-pv4-data" or name == "next-hop-set-l3vpn" or name == "pi-mi-pmsi-data" or name == "pi-ms-pmsi-data" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "sr-adj-segment-ipv4" or name == "sr-adj-segment-ipv6" or name == "sr-prefix-segment" or name == "te-binding" or name == "tev4-data" or name == "tev4p2mp-data" or name == "tp-data" or name == "vrf-l3vpn-data" or name == "label-context-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-context-type"):
                                    self.label_context_type = value
                                    self.label_context_type.value_namespace = name_space
                                    self.label_context_type.value_namespace_prefix = name_space_prefix


                        class LocalLabelRewrite(Entity):
                            """
                            Local label rewrite information
                            
                            .. attribute:: label_data
                            
                            	label data
                            	**type**\:  list of int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LocalLabelRewrite, self).__init__()

                                self.yang_name = "local-label-rewrite"
                                self.yang_parent_name = "rewrite-id"

                                self.label_data = YLeafList(YType.uint32, "label-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_data") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)

                            def has_data(self):
                                for leaf in self.label_data.getYLeafs():
                                    if (leaf.yfilter != YFilter.not_set):
                                        return True
                                return False

                            def has_operation(self):
                                for leaf in self.label_data.getYLeafs():
                                    if (leaf.is_set):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_data.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "local-label-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/rewrite-id/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                leaf_name_data.extend(self.label_data.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "label-data"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-data"):
                                    self.label_data.append(value)

                        def has_data(self):
                            return (
                                self.rewrite_id_type.is_set or
                                (self.label_context is not None and self.label_context.has_data()) or
                                (self.local_label_rewrite is not None and self.local_label_rewrite.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.rewrite_id_type.yfilter != YFilter.not_set or
                                (self.label_context is not None and self.label_context.has_operation()) or
                                (self.local_label_rewrite is not None and self.local_label_rewrite.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rewrite-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/rewrite-id/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.rewrite_id_type.is_set or self.rewrite_id_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rewrite_id_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "label-context"):
                                if (self.label_context is None):
                                    self.label_context = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LabelContext()
                                    self.label_context.parent = self
                                    self._children_name_map["label_context"] = "label-context"
                                return self.label_context

                            if (child_yang_name == "local-label-rewrite"):
                                if (self.local_label_rewrite is None):
                                    self.local_label_rewrite = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId.LocalLabelRewrite()
                                    self.local_label_rewrite.parent = self
                                    self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                                return self.local_label_rewrite

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "label-context" or name == "local-label-rewrite" or name == "rewrite-id-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "rewrite-id-type"):
                                self.rewrite_id_type = value
                                self.rewrite_id_type.value_namespace = name_space
                                self.rewrite_id_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (self.rewrite_id is not None and self.rewrite_id.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rewrite-id" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "rewrite-id"):
                            if (self.rewrite_id is None):
                                self.rewrite_id = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId.RewriteId()
                                self.rewrite_id.parent = self
                                self._children_name_map["rewrite_id"] = "rewrite-id"
                            return self.rewrite_id

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "rewrite-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class AssociatedFpi(Entity):
                    """
                    Associated FPI
                    
                    .. attribute:: application_owner
                    
                    	Application owner instance
                    	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.ApplicationOwner>`
                    
                    .. attribute:: fpi
                    
                    	FPI
                    	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi, self).__init__()

                        self.yang_name = "associated-fpi"
                        self.yang_parent_name = "rewrite-ipv4"

                        self.fpi = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi()
                        self.fpi.parent = self
                        self._children_name_map["fpi"] = "fpi"
                        self._children_yang_names.add("fpi")

                        self.application_owner = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi, self).__setattr__(name, value)


                    class Fpi(Entity):
                        """
                        FPI
                        
                        .. attribute:: dmtc_ext_intf_data
                        
                        	dmtc ext intf data
                        	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.DmtcExtIntfData>`
                        
                        .. attribute:: fpi_type
                        
                        	FPIType
                        	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                        
                        .. attribute:: ipv4_data
                        
                        	ipv4 data
                        	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv4Data>`
                        
                        .. attribute:: ipv6_data
                        
                        	ipv6 data
                        	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv6Data>`
                        
                        .. attribute:: label_data
                        
                        	label data
                        	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.LabelData>`
                        
                        .. attribute:: pw_list_data
                        
                        	pw list data
                        	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.PwListData>`
                        
                        .. attribute:: te_data
                        
                        	te data
                        	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.TeData>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi, self).__init__()

                            self.yang_name = "fpi"
                            self.yang_parent_name = "associated-fpi"

                            self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                            self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.DmtcExtIntfData()
                            self.dmtc_ext_intf_data.parent = self
                            self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                            self._children_yang_names.add("dmtc-ext-intf-data")

                            self.ipv4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv4Data()
                            self.ipv4_data.parent = self
                            self._children_name_map["ipv4_data"] = "ipv4-data"
                            self._children_yang_names.add("ipv4-data")

                            self.ipv6_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv6Data()
                            self.ipv6_data.parent = self
                            self._children_name_map["ipv6_data"] = "ipv6-data"
                            self._children_yang_names.add("ipv6-data")

                            self.label_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.LabelData()
                            self.label_data.parent = self
                            self._children_name_map["label_data"] = "label-data"
                            self._children_yang_names.add("label-data")

                            self.pw_list_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.PwListData()
                            self.pw_list_data.parent = self
                            self._children_name_map["pw_list_data"] = "pw-list-data"
                            self._children_yang_names.add("pw-list-data")

                            self.te_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.TeData()
                            self.te_data.parent = self
                            self._children_name_map["te_data"] = "te-data"
                            self._children_yang_names.add("te-data")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fpi_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi, self).__setattr__(name, value)


                        class LabelData(Entity):
                            """
                            label data
                            
                            .. attribute:: elc
                            
                            	ELC
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: label
                            
                            	Label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.LabelData, self).__init__()

                                self.yang_name = "label-data"
                                self.yang_parent_name = "fpi"

                                self.elc = YLeaf(YType.int32, "elc")

                                self.label = YLeaf(YType.uint32, "label")

                                self.security_id = YLeaf(YType.uint32, "security-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("elc",
                                                "label",
                                                "security_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.elc.is_set or
                                    self.label.is_set or
                                    self.security_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.elc.yfilter != YFilter.not_set or
                                    self.label.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/associated-fpi/fpi/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.elc.get_name_leafdata())
                                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label.get_name_leafdata())
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "elc" or name == "label" or name == "security-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "elc"):
                                    self.elc = value
                                    self.elc.value_namespace = name_space
                                    self.elc.value_namespace_prefix = name_space_prefix
                                if(value_path == "label"):
                                    self.label = value
                                    self.label.value_namespace = name_space
                                    self.label.value_namespace_prefix = name_space_prefix
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix


                        class TeData(Entity):
                            """
                            te data
                            
                            .. attribute:: local_label
                            
                            	Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_interface
                            
                            	Tunnel interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.TeData, self).__init__()

                                self.yang_name = "te-data"
                                self.yang_parent_name = "fpi"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label",
                                                "tunnel_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.local_label.is_set or
                                    self.tunnel_interface.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.tunnel_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/associated-fpi/fpi/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label" or name == "tunnel-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface"):
                                    self.tunnel_interface = value
                                    self.tunnel_interface.value_namespace = name_space
                                    self.tunnel_interface.value_namespace_prefix = name_space_prefix


                        class Ipv4Data(Entity):
                            """
                            ipv4 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: sr_local_label
                            
                            	SR related Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv4Data, self).__init__()

                                self.yang_name = "ipv4-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "sr_local_label",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.sr_local_label.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.sr_local_label.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/associated-fpi/fpi/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "sr-local-label"):
                                    self.sr_local_label = value
                                    self.sr_local_label.value_namespace = name_space
                                    self.sr_local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class Ipv6Data(Entity):
                            """
                            ipv6 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_len
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: router_flags
                            
                            	Route flags
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv6Data, self).__init__()

                                self.yang_name = "ipv6-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                self.router_flags = YLeaf(YType.uint32, "router-flags")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_len",
                                                "router_flags",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_len.is_set or
                                    self.router_flags.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_len.yfilter != YFilter.not_set or
                                    self.router_flags.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv6-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/associated-fpi/fpi/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.router_flags.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-len"):
                                    self.prefix_len = value
                                    self.prefix_len.value_namespace = name_space
                                    self.prefix_len.value_namespace_prefix = name_space_prefix
                                if(value_path == "router-flags"):
                                    self.router_flags = value
                                    self.router_flags.value_namespace = name_space
                                    self.router_flags.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class PwListData(Entity):
                            """
                            pw list data
                            
                            .. attribute:: pwhe_list_id
                            
                            	Pseudowire List Identifier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.PwListData, self).__init__()

                                self.yang_name = "pw-list-data"
                                self.yang_parent_name = "fpi"

                                self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("pwhe_list_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.pwhe_list_id.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.pwhe_list_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pw-list-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/associated-fpi/fpi/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "pwhe-list-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "pwhe-list-id"):
                                    self.pwhe_list_id = value
                                    self.pwhe_list_id.value_namespace = name_space
                                    self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                        class DmtcExtIntfData(Entity):
                            """
                            dmtc ext intf data
                            
                            .. attribute:: dmtc_ext_ifh
                            
                            	DMTC External Interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.DmtcExtIntfData, self).__init__()

                                self.yang_name = "dmtc-ext-intf-data"
                                self.yang_parent_name = "fpi"

                                self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.dmtc_ext_ifh.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "dmtc-ext-intf-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/associated-fpi/fpi/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-ifh"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "dmtc-ext-ifh"):
                                    self.dmtc_ext_ifh = value
                                    self.dmtc_ext_ifh.value_namespace = name_space
                                    self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fpi_type.is_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                (self.label_data is not None and self.label_data.has_data()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                (self.te_data is not None and self.te_data.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fpi_type.yfilter != YFilter.not_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                (self.label_data is not None and self.label_data.has_operation()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                (self.te_data is not None and self.te_data.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fpi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/associated-fpi/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fpi_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "dmtc-ext-intf-data"):
                                if (self.dmtc_ext_intf_data is None):
                                    self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.DmtcExtIntfData()
                                    self.dmtc_ext_intf_data.parent = self
                                    self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                return self.dmtc_ext_intf_data

                            if (child_yang_name == "ipv4-data"):
                                if (self.ipv4_data is None):
                                    self.ipv4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                return self.ipv4_data

                            if (child_yang_name == "ipv6-data"):
                                if (self.ipv6_data is None):
                                    self.ipv6_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                return self.ipv6_data

                            if (child_yang_name == "label-data"):
                                if (self.label_data is None):
                                    self.label_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.LabelData()
                                    self.label_data.parent = self
                                    self._children_name_map["label_data"] = "label-data"
                                return self.label_data

                            if (child_yang_name == "pw-list-data"):
                                if (self.pw_list_data is None):
                                    self.pw_list_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.PwListData()
                                    self.pw_list_data.parent = self
                                    self._children_name_map["pw_list_data"] = "pw-list-data"
                                return self.pw_list_data

                            if (child_yang_name == "te-data"):
                                if (self.te_data is None):
                                    self.te_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi.TeData()
                                    self.te_data.parent = self
                                    self._children_name_map["te_data"] = "te-data"
                                return self.te_data

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fpi-type"):
                                self.fpi_type = value
                                self.fpi_type.value_namespace = name_space
                                self.fpi_type.value_namespace_prefix = name_space_prefix


                    class ApplicationOwner(Entity):
                        """
                        Application owner instance
                        
                        .. attribute:: application_instance
                        
                        	Application instance Name
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        .. attribute:: resource_state
                        
                        	Application resource state
                        	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.ApplicationOwner, self).__init__()

                            self.yang_name = "application-owner"
                            self.yang_parent_name = "associated-fpi"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                            self.resource_state = YLeaf(YType.enumeration, "resource-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type",
                                            "resource_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set or
                                self.resource_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set or
                                self.resource_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application-owner" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/associated-fpi/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())
                            if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resource_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "resource-state"):
                                self.resource_state = value
                                self.resource_state.value_namespace = name_space
                                self.resource_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.application_owner:
                            if (c.has_data()):
                                return True
                        return (self.fpi is not None and self.fpi.has_data())

                    def has_operation(self):
                        for c in self.application_owner:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.fpi is not None and self.fpi.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "associated-fpi" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application-owner"):
                            for c in self.application_owner:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.ApplicationOwner()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.application_owner.append(c)
                            return c

                        if (child_yang_name == "fpi"):
                            if (self.fpi is None):
                                self.fpi = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi.Fpi()
                                self.fpi.parent = self
                                self._children_name_map["fpi"] = "fpi"
                            return self.fpi

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-owner" or name == "fpi"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class V4Rpf(Entity):
                    """
                    IPv4 RPF neighbors
                    
                    .. attribute:: table_id
                    
                    	Table ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: v4_rpf_neighbor
                    
                    	V4 RPF Neighbor
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.V4Rpf, self).__init__()

                        self.yang_name = "v4-rpf"
                        self.yang_parent_name = "rewrite-ipv4"

                        self.table_id = YLeaf(YType.uint32, "table-id")

                        self.v4_rpf_neighbor = YLeaf(YType.str, "v4-rpf-neighbor")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("table_id",
                                        "v4_rpf_neighbor") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.V4Rpf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.V4Rpf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.table_id.is_set or
                            self.v4_rpf_neighbor.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.table_id.yfilter != YFilter.not_set or
                            self.v4_rpf_neighbor.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "v4-rpf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.table_id.get_name_leafdata())
                        if (self.v4_rpf_neighbor.is_set or self.v4_rpf_neighbor.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.v4_rpf_neighbor.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "table-id" or name == "v4-rpf-neighbor"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "table-id"):
                            self.table_id = value
                            self.table_id.value_namespace = name_space
                            self.table_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "v4-rpf-neighbor"):
                            self.v4_rpf_neighbor = value
                            self.v4_rpf_neighbor.value_namespace = name_space
                            self.v4_rpf_neighbor.value_namespace_prefix = name_space_prefix


                class V6Rpf(Entity):
                    """
                    IPv6 RPF neighbors
                    
                    .. attribute:: table_id
                    
                    	Table ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: v6_rpf_neighbor
                    
                    	V6 RPF Neighbor
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.V6Rpf, self).__init__()

                        self.yang_name = "v6-rpf"
                        self.yang_parent_name = "rewrite-ipv4"

                        self.table_id = YLeaf(YType.uint32, "table-id")

                        self.v6_rpf_neighbor = YLeaf(YType.str, "v6-rpf-neighbor")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("table_id",
                                        "v6_rpf_neighbor") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.V6Rpf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.V6Rpf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.table_id.is_set or
                            self.v6_rpf_neighbor.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.table_id.yfilter != YFilter.not_set or
                            self.v6_rpf_neighbor.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "v6-rpf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.table_id.get_name_leafdata())
                        if (self.v6_rpf_neighbor.is_set or self.v6_rpf_neighbor.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.v6_rpf_neighbor.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "table-id" or name == "v6-rpf-neighbor"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "table-id"):
                            self.table_id = value
                            self.table_id.value_namespace = name_space
                            self.table_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "v6-rpf-neighbor"):
                            self.v6_rpf_neighbor = value
                            self.v6_rpf_neighbor.value_namespace = name_space
                            self.v6_rpf_neighbor.value_namespace_prefix = name_space_prefix


                class Mois(Entity):
                    """
                    Mois
                    
                    .. attribute:: application_resource
                    
                    	Application state
                    	**type**\:   :py:class:`ApplicationResource <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.ApplicationResource>`
                    
                    .. attribute:: moi_array
                    
                    	moi array
                    	**type**\: list of    :py:class:`MoiArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois, self).__init__()

                        self.yang_name = "mois"
                        self.yang_parent_name = "rewrite-ipv4"

                        self.application_resource = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.ApplicationResource()
                        self.application_resource.parent = self
                        self._children_name_map["application_resource"] = "application-resource"
                        self._children_yang_names.add("application-resource")

                        self.moi_array = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois, self).__setattr__(name, value)


                    class ApplicationResource(Entity):
                        """
                        Application state
                        
                        .. attribute:: application_instance
                        
                        	Application instance Name
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        .. attribute:: resource_state
                        
                        	Application resource state
                        	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.ApplicationResource, self).__init__()

                            self.yang_name = "application-resource"
                            self.yang_parent_name = "mois"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                            self.resource_state = YLeaf(YType.enumeration, "resource-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type",
                                            "resource_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.ApplicationResource, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.ApplicationResource, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set or
                                self.resource_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set or
                                self.resource_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application-resource" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())
                            if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resource_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "resource-state"):
                                self.resource_state = value
                                self.resource_state.value_namespace = name_space
                                self.resource_state.value_namespace_prefix = name_space_prefix


                    class MoiArray(Entity):
                        """
                        moi array
                        
                        .. attribute:: moi
                        
                        	Moi
                        	**type**\:   :py:class:`Moi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray, self).__init__()

                            self.yang_name = "moi-array"
                            self.yang_parent_name = "mois"

                            self.moi = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi()
                            self.moi.parent = self
                            self._children_name_map["moi"] = "moi"
                            self._children_yang_names.add("moi")


                        class Moi(Entity):
                            """
                            Moi
                            
                            .. attribute:: dmtc_data
                            
                            	dmtc data
                            	**type**\:   :py:class:`DmtcData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.DmtcData>`
                            
                            .. attribute:: ip_sub_data
                            
                            	ip sub data
                            	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.IpSubData>`
                            
                            .. attribute:: ipv4_data
                            
                            	ipv4 data
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv4Data>`
                            
                            .. attribute:: ipv6_data
                            
                            	ipv6 data
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv6Data>`
                            
                            .. attribute:: moi_type
                            
                            	MoiType
                            	**type**\:   :py:class:`MgmtLsdMoi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdMoi>`
                            
                            .. attribute:: pop_and_lookup_ipv4
                            
                            	pop and lookup ipv4
                            	**type**\:   :py:class:`PopAndLookupIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv4>`
                            
                            .. attribute:: pop_and_lookup_ipv6
                            
                            	pop and lookup ipv6
                            	**type**\:   :py:class:`PopAndLookupIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv6>`
                            
                            .. attribute:: pop_and_lookup_tp
                            
                            	pop and lookup tp
                            	**type**\:   :py:class:`PopAndLookupTp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupTp>`
                            
                            .. attribute:: pseudowire_data
                            
                            	pseudowire data
                            	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireData>`
                            
                            .. attribute:: pseudowire_head_end_data
                            
                            	pseudowire head end data
                            	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireHeadEndData>`
                            
                            .. attribute:: pw_list_data
                            
                            	pw list data
                            	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PwListData>`
                            
                            .. attribute:: stackv4_data
                            
                            	stackv4 data
                            	**type**\:   :py:class:`Stackv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data>`
                            
                            .. attribute:: stackv6_data
                            
                            	stackv6 data
                            	**type**\:   :py:class:`Stackv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data>`
                            
                            .. attribute:: te_head_data
                            
                            	te head data
                            	**type**\:   :py:class:`TeHeadData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.TeHeadData>`
                            
                            .. attribute:: tev4_data
                            
                            	tev4 data
                            	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Tev4Data>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi, self).__init__()

                                self.yang_name = "moi"
                                self.yang_parent_name = "moi-array"

                                self.moi_type = YLeaf(YType.enumeration, "moi-type")

                                self.dmtc_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.DmtcData()
                                self.dmtc_data.parent = self
                                self._children_name_map["dmtc_data"] = "dmtc-data"
                                self._children_yang_names.add("dmtc-data")

                                self.ip_sub_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.IpSubData()
                                self.ip_sub_data.parent = self
                                self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                self._children_yang_names.add("ip-sub-data")

                                self.ipv4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv6_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.pop_and_lookup_ipv4 = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                self.pop_and_lookup_ipv4.parent = self
                                self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                self._children_yang_names.add("pop-and-lookup-ipv4")

                                self.pop_and_lookup_ipv6 = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                self.pop_and_lookup_ipv6.parent = self
                                self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                self._children_yang_names.add("pop-and-lookup-ipv6")

                                self.pop_and_lookup_tp = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupTp()
                                self.pop_and_lookup_tp.parent = self
                                self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                self._children_yang_names.add("pop-and-lookup-tp")

                                self.pseudowire_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireData()
                                self.pseudowire_data.parent = self
                                self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                self._children_yang_names.add("pseudowire-data")

                                self.pseudowire_head_end_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                self.pseudowire_head_end_data.parent = self
                                self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                self._children_yang_names.add("pseudowire-head-end-data")

                                self.pw_list_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PwListData()
                                self.pw_list_data.parent = self
                                self._children_name_map["pw_list_data"] = "pw-list-data"
                                self._children_yang_names.add("pw-list-data")

                                self.stackv4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data()
                                self.stackv4_data.parent = self
                                self._children_name_map["stackv4_data"] = "stackv4-data"
                                self._children_yang_names.add("stackv4-data")

                                self.stackv6_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data()
                                self.stackv6_data.parent = self
                                self._children_name_map["stackv6_data"] = "stackv6-data"
                                self._children_yang_names.add("stackv6-data")

                                self.te_head_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.TeHeadData()
                                self.te_head_data.parent = self
                                self._children_name_map["te_head_data"] = "te-head-data"
                                self._children_yang_names.add("te-head-data")

                                self.tev4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Tev4Data()
                                self.tev4_data.parent = self
                                self._children_name_map["tev4_data"] = "tev4-data"
                                self._children_yang_names.add("tev4-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("moi_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi, self).__setattr__(name, value)


                            class PopAndLookupIpv4(Entity):
                                """
                                pop and lookup ipv4
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__init__()

                                    self.yang_name = "pop-and-lookup-ipv4"
                                    self.yang_parent_name = "moi"

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pop-and-lookup-ipv4" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class PopAndLookupTp(Entity):
                                """
                                pop and lookup tp
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupTp, self).__init__()

                                    self.yang_name = "pop-and-lookup-tp"
                                    self.yang_parent_name = "moi"

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("out_label",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.out_label.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pop-and-lookup-tp" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "out-label" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class PopAndLookupIpv6(Entity):
                                """
                                pop and lookup ipv6
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__init__()

                                    self.yang_name = "pop-and-lookup-ipv6"
                                    self.yang_parent_name = "moi"

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pop-and-lookup-ipv6" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class Ipv4Data(Entity):
                                """
                                ipv4 data
                                
                                .. attribute:: backup_path_id
                                
                                	Routing path backup id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: load_metric
                                
                                	Routing path's load metric
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: local_label
                                
                                	TE backup path local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: next_hop_id
                                
                                	Next hop ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_interface
                                
                                	Outgoing Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_interface_parent
                                
                                	Outgoing Interface's parent
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_label_name
                                
                                	Outgoing label name
                                	**type**\:  str
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: path_id
                                
                                	Routing path id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "moi"

                                    self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.load_metric = YLeaf(YType.uint32, "load-metric")

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.out_label_name = YLeaf(YType.str, "out-label-name")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.path_id = YLeaf(YType.uint8, "path-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_path_id",
                                                    "ipv4_next_hop",
                                                    "load_metric",
                                                    "local_label",
                                                    "next_hop_id",
                                                    "out_interface",
                                                    "out_interface_parent",
                                                    "out_label",
                                                    "out_label_name",
                                                    "path_flags_decode",
                                                    "path_id",
                                                    "table_id",
                                                    "table_name",
                                                    "tunnel_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_path_id.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.load_metric.is_set or
                                        self.local_label.is_set or
                                        self.next_hop_id.is_set or
                                        self.out_interface.is_set or
                                        self.out_interface_parent.is_set or
                                        self.out_label.is_set or
                                        self.out_label_name.is_set or
                                        self.path_flags_decode.is_set or
                                        self.path_id.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.tunnel_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_path_id.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.load_metric.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.next_hop_id.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_interface_parent.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.out_label_name.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.path_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.tunnel_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.load_metric.get_name_leafdata())
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-path-id"):
                                        self.backup_path_id = value
                                        self.backup_path_id.value_namespace = name_space
                                        self.backup_path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "load-metric"):
                                        self.load_metric = value
                                        self.load_metric.value_namespace = name_space
                                        self.load_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "next-hop-id"):
                                        self.next_hop_id = value
                                        self.next_hop_id.value_namespace = name_space
                                        self.next_hop_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface-parent"):
                                        self.out_interface_parent = value
                                        self.out_interface_parent.value_namespace = name_space
                                        self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label-name"):
                                        self.out_label_name = value
                                        self.out_label_name.value_namespace = name_space
                                        self.out_label_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-id"):
                                        self.path_id = value
                                        self.path_id.value_namespace = name_space
                                        self.path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id"):
                                        self.tunnel_id = value
                                        self.tunnel_id.value_namespace = name_space
                                        self.tunnel_id.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                ipv6 data
                                
                                .. attribute:: backup_path_id
                                
                                	Routing path backup id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv6_next_hop
                                
                                	IPv6 nexthop
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: next_hop_id
                                
                                	Next hop ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_label_name
                                
                                	Outgoing label name
                                	**type**\:  str
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: path_id
                                
                                	Routing path id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "moi"

                                    self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                    self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                    self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.out_label_name = YLeaf(YType.str, "out-label-name")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.path_id = YLeaf(YType.uint8, "path-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_path_id",
                                                    "ipv6_next_hop",
                                                    "next_hop_id",
                                                    "out_interface",
                                                    "out_label",
                                                    "out_label_name",
                                                    "path_flags_decode",
                                                    "path_id",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_path_id.is_set or
                                        self.ipv6_next_hop.is_set or
                                        self.next_hop_id.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.out_label_name.is_set or
                                        self.path_flags_decode.is_set or
                                        self.path_id.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_path_id.yfilter != YFilter.not_set or
                                        self.ipv6_next_hop.yfilter != YFilter.not_set or
                                        self.next_hop_id.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.out_label_name.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.path_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                    if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                    if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-path-id"):
                                        self.backup_path_id = value
                                        self.backup_path_id.value_namespace = name_space
                                        self.backup_path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6-next-hop"):
                                        self.ipv6_next_hop = value
                                        self.ipv6_next_hop.value_namespace = name_space
                                        self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "next-hop-id"):
                                        self.next_hop_id = value
                                        self.next_hop_id.value_namespace = name_space
                                        self.next_hop_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label-name"):
                                        self.out_label_name = value
                                        self.out_label_name.value_namespace = name_space
                                        self.out_label_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-id"):
                                        self.path_id = value
                                        self.path_id.value_namespace = name_space
                                        self.path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class Tev4Data(Entity):
                                """
                                tev4 data
                                
                                .. attribute:: backup_interface
                                
                                	Backup interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: backup_ipv4_next_hop
                                
                                	Backup IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: backup_local_label
                                
                                	Backup local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: data_out_parent_interface
                                
                                	Outgoing data parent interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: merge_point_label
                                
                                	Merge point label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_label_name
                                
                                	Outgoing label name
                                	**type**\:  str
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_class
                                
                                	Tunnel class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_interface
                                
                                	Tunnel interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: tunnel_weight
                                
                                	Tunnel weight
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Tev4Data, self).__init__()

                                    self.yang_name = "tev4-data"
                                    self.yang_parent_name = "moi"

                                    self.backup_interface = YLeaf(YType.str, "backup-interface")

                                    self.backup_ipv4_next_hop = YLeaf(YType.str, "backup-ipv4-next-hop")

                                    self.backup_local_label = YLeaf(YType.uint32, "backup-local-label")

                                    self.data_out_parent_interface = YLeaf(YType.str, "data-out-parent-interface")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.merge_point_label = YLeaf(YType.uint32, "merge-point-label")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.out_label_name = YLeaf(YType.str, "out-label-name")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.tunnel_class = YLeaf(YType.uint32, "tunnel-class")

                                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                    self.tunnel_weight = YLeaf(YType.uint32, "tunnel-weight")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_interface",
                                                    "backup_ipv4_next_hop",
                                                    "backup_local_label",
                                                    "data_out_parent_interface",
                                                    "ipv4_next_hop",
                                                    "merge_point_label",
                                                    "out_interface",
                                                    "out_label",
                                                    "out_label_name",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name",
                                                    "tunnel_class",
                                                    "tunnel_interface",
                                                    "tunnel_weight") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_interface.is_set or
                                        self.backup_ipv4_next_hop.is_set or
                                        self.backup_local_label.is_set or
                                        self.data_out_parent_interface.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.merge_point_label.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.out_label_name.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.tunnel_class.is_set or
                                        self.tunnel_interface.is_set or
                                        self.tunnel_weight.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_interface.yfilter != YFilter.not_set or
                                        self.backup_ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.backup_local_label.yfilter != YFilter.not_set or
                                        self.data_out_parent_interface.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.merge_point_label.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.out_label_name.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.tunnel_class.yfilter != YFilter.not_set or
                                        self.tunnel_interface.yfilter != YFilter.not_set or
                                        self.tunnel_weight.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tev4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_interface.is_set or self.backup_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_interface.get_name_leafdata())
                                    if (self.backup_ipv4_next_hop.is_set or self.backup_ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_ipv4_next_hop.get_name_leafdata())
                                    if (self.backup_local_label.is_set or self.backup_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_local_label.get_name_leafdata())
                                    if (self.data_out_parent_interface.is_set or self.data_out_parent_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.data_out_parent_interface.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.merge_point_label.is_set or self.merge_point_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.merge_point_label.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.tunnel_class.is_set or self.tunnel_class.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_class.get_name_leafdata())
                                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())
                                    if (self.tunnel_weight.is_set or self.tunnel_weight.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_weight.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-interface" or name == "backup-ipv4-next-hop" or name == "backup-local-label" or name == "data-out-parent-interface" or name == "ipv4-next-hop" or name == "merge-point-label" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-class" or name == "tunnel-interface" or name == "tunnel-weight"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-interface"):
                                        self.backup_interface = value
                                        self.backup_interface.value_namespace = name_space
                                        self.backup_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-ipv4-next-hop"):
                                        self.backup_ipv4_next_hop = value
                                        self.backup_ipv4_next_hop.value_namespace = name_space
                                        self.backup_ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-local-label"):
                                        self.backup_local_label = value
                                        self.backup_local_label.value_namespace = name_space
                                        self.backup_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "data-out-parent-interface"):
                                        self.data_out_parent_interface = value
                                        self.data_out_parent_interface.value_namespace = name_space
                                        self.data_out_parent_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "merge-point-label"):
                                        self.merge_point_label = value
                                        self.merge_point_label.value_namespace = name_space
                                        self.merge_point_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label-name"):
                                        self.out_label_name = value
                                        self.out_label_name.value_namespace = name_space
                                        self.out_label_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-class"):
                                        self.tunnel_class = value
                                        self.tunnel_class.value_namespace = name_space
                                        self.tunnel_class.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface"):
                                        self.tunnel_interface = value
                                        self.tunnel_interface.value_namespace = name_space
                                        self.tunnel_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-weight"):
                                        self.tunnel_weight = value
                                        self.tunnel_weight.value_namespace = name_space
                                        self.tunnel_weight.value_namespace_prefix = name_space_prefix


                            class PseudowireData(Entity):
                                """
                                pseudowire data
                                
                                .. attribute:: bridge_id
                                
                                	Bridge ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross\-connect ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: pseuodo_wire_connect_id
                                
                                	PseudoWire Cross\-connect ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: split_horizon_id
                                
                                	Split horizon group ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireData, self).__init__()

                                    self.yang_name = "pseudowire-data"
                                    self.yang_parent_name = "moi"

                                    self.bridge_id = YLeaf(YType.uint32, "bridge-id")

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.pseuodo_wire_connect_id = YLeaf(YType.uint32, "pseuodo-wire-connect-id")

                                    self.split_horizon_id = YLeaf(YType.uint32, "split-horizon-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bridge_id",
                                                    "cross_connect_id",
                                                    "ipv4_next_hop",
                                                    "out_interface",
                                                    "out_label",
                                                    "path_flags_decode",
                                                    "pseuodo_wire_connect_id",
                                                    "split_horizon_id",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bridge_id.is_set or
                                        self.cross_connect_id.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.path_flags_decode.is_set or
                                        self.pseuodo_wire_connect_id.is_set or
                                        self.split_horizon_id.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bridge_id.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.pseuodo_wire_connect_id.yfilter != YFilter.not_set or
                                        self.split_horizon_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bridge_id.is_set or self.bridge_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bridge_id.get_name_leafdata())
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.pseuodo_wire_connect_id.is_set or self.pseuodo_wire_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pseuodo_wire_connect_id.get_name_leafdata())
                                    if (self.split_horizon_id.is_set or self.split_horizon_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.split_horizon_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bridge-id" or name == "cross-connect-id" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pseuodo-wire-connect-id" or name == "split-horizon-id" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bridge-id"):
                                        self.bridge_id = value
                                        self.bridge_id.value_namespace = name_space
                                        self.bridge_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pseuodo-wire-connect-id"):
                                        self.pseuodo_wire_connect_id = value
                                        self.pseuodo_wire_connect_id.value_namespace = name_space
                                        self.pseuodo_wire_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "split-horizon-id"):
                                        self.split_horizon_id = value
                                        self.split_horizon_id.value_namespace = name_space
                                        self.split_horizon_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class IpSubData(Entity):
                                """
                                ip sub data
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	VRF table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.IpSubData, self).__init__()

                                    self.yang_name = "ip-sub-data"
                                    self.yang_parent_name = "moi"

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("out_interface",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.out_interface.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ip-sub-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "out-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class PseudowireHeadEndData(Entity):
                                """
                                pseudowire head end data
                                
                                .. attribute:: control_word
                                
                                	Is control word present
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: imposition
                                
                                	Is PWHE IMposition
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: pw_list_id
                                
                                	Pseudo\-wire List Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: pwhe_interface
                                
                                	Pseudo\-wire Head\-end interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: vctype
                                
                                	Virtual Circuit Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__init__()

                                    self.yang_name = "pseudowire-head-end-data"
                                    self.yang_parent_name = "moi"

                                    self.control_word = YLeaf(YType.int32, "control-word")

                                    self.imposition = YLeaf(YType.int32, "imposition")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.pw_list_id = YLeaf(YType.uint16, "pw-list-id")

                                    self.pwhe_interface = YLeaf(YType.str, "pwhe-interface")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.vctype = YLeaf(YType.uint8, "vctype")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("control_word",
                                                    "imposition",
                                                    "ipv4_next_hop",
                                                    "out_interface",
                                                    "out_label",
                                                    "path_flags_decode",
                                                    "pw_list_id",
                                                    "pwhe_interface",
                                                    "table_id",
                                                    "table_name",
                                                    "vctype") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.control_word.is_set or
                                        self.imposition.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.path_flags_decode.is_set or
                                        self.pw_list_id.is_set or
                                        self.pwhe_interface.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.vctype.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.control_word.yfilter != YFilter.not_set or
                                        self.imposition.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.pw_list_id.yfilter != YFilter.not_set or
                                        self.pwhe_interface.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.vctype.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-head-end-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.control_word.is_set or self.control_word.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.control_word.get_name_leafdata())
                                    if (self.imposition.is_set or self.imposition.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.imposition.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.pw_list_id.is_set or self.pw_list_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pw_list_id.get_name_leafdata())
                                    if (self.pwhe_interface.is_set or self.pwhe_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_interface.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.vctype.is_set or self.vctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vctype.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "control-word" or name == "imposition" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pw-list-id" or name == "pwhe-interface" or name == "table-id" or name == "table-name" or name == "vctype"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "control-word"):
                                        self.control_word = value
                                        self.control_word.value_namespace = name_space
                                        self.control_word.value_namespace_prefix = name_space_prefix
                                    if(value_path == "imposition"):
                                        self.imposition = value
                                        self.imposition.value_namespace = name_space
                                        self.imposition.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pw-list-id"):
                                        self.pw_list_id = value
                                        self.pw_list_id.value_namespace = name_space
                                        self.pw_list_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pwhe-interface"):
                                        self.pwhe_interface = value
                                        self.pwhe_interface.value_namespace = name_space
                                        self.pwhe_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vctype"):
                                        self.vctype = value
                                        self.vctype.value_namespace = name_space
                                        self.vctype.value_namespace_prefix = name_space_prefix


                            class PwListData(Entity):
                                """
                                pw list data
                                
                                .. attribute:: l2_interface
                                
                                	Pseudo\-wire Layer 2 interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: l3_interface
                                
                                	Pseudo\-wire Layer 3 interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PwListData, self).__init__()

                                    self.yang_name = "pw-list-data"
                                    self.yang_parent_name = "moi"

                                    self.l2_interface = YLeaf(YType.str, "l2-interface")

                                    self.l3_interface = YLeaf(YType.str, "l3-interface")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("l2_interface",
                                                    "l3_interface",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.l2_interface.is_set or
                                        self.l3_interface.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.l2_interface.yfilter != YFilter.not_set or
                                        self.l3_interface.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pw-list-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.l2_interface.is_set or self.l2_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.l2_interface.get_name_leafdata())
                                    if (self.l3_interface.is_set or self.l3_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.l3_interface.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "l2-interface" or name == "l3-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "l2-interface"):
                                        self.l2_interface = value
                                        self.l2_interface.value_namespace = name_space
                                        self.l2_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "l3-interface"):
                                        self.l3_interface = value
                                        self.l3_interface.value_namespace = name_space
                                        self.l3_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class Stackv4Data(Entity):
                                """
                                stackv4 data
                                
                                .. attribute:: inner_stack
                                
                                	Inner stack
                                	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack>`
                                
                                .. attribute:: nexthop
                                
                                	Nexthop
                                	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.Nexthop>`
                                
                                .. attribute:: owner_application_type
                                
                                	Owner application type
                                	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data, self).__init__()

                                    self.yang_name = "stackv4-data"
                                    self.yang_parent_name = "moi"

                                    self.owner_application_type = YLeaf(YType.enumeration, "owner-application-type")

                                    self.inner_stack = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                    self.inner_stack.parent = self
                                    self._children_name_map["inner_stack"] = "inner-stack"
                                    self._children_yang_names.add("inner-stack")

                                    self.nexthop = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                    self.nexthop.parent = self
                                    self._children_name_map["nexthop"] = "nexthop"
                                    self._children_yang_names.add("nexthop")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("owner_application_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)


                                class Nexthop(Entity):
                                    """
                                    Nexthop
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: load_metric
                                    
                                    	Routing path's load metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: local_label
                                    
                                    	TE backup path local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_interface_parent
                                    
                                    	Outgoing Interface's parent
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__init__()

                                        self.yang_name = "nexthop"
                                        self.yang_parent_name = "stackv4-data"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.load_metric = YLeaf(YType.uint32, "load-metric")

                                        self.local_label = YLeaf(YType.uint32, "local-label")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv4_next_hop",
                                                        "load_metric",
                                                        "local_label",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_interface_parent",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.load_metric.is_set or
                                            self.local_label.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_interface_parent.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.load_metric.yfilter != YFilter.not_set or
                                            self.local_label.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_interface_parent.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nexthop" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/stackv4-data/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_metric.get_name_leafdata())
                                        if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_label.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-metric"):
                                            self.load_metric = value
                                            self.load_metric.value_namespace = name_space
                                            self.load_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-label"):
                                            self.local_label = value
                                            self.local_label.value_namespace = name_space
                                            self.local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface-parent"):
                                            self.out_interface_parent = value
                                            self.out_interface_parent.value_namespace = name_space
                                            self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix


                                class InnerStack(Entity):
                                    """
                                    Inner stack
                                    
                                    .. attribute:: label
                                    
                                    	Info related to outgoing labels
                                    	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Remote nexthop addresses
                                    	**type**\:  list of str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: num_lbls
                                    
                                    	Depth of inner label stack
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: num_nexthops
                                    
                                    	Number of remote nexthop addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__init__()

                                        self.yang_name = "inner-stack"
                                        self.yang_parent_name = "stackv4-data"

                                        self.nexthop = YLeafList(YType.str, "nexthop")

                                        self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                        self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                        self.label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nexthop",
                                                        "num_lbls",
                                                        "num_nexthops") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)


                                    class Label(Entity):
                                        """
                                        Info related to outgoing labels
                                        
                                        .. attribute:: outgoing_label
                                        
                                        	Remote Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: outgoing_label_str
                                        
                                        	Remote Label string
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__init__()

                                            self.yang_name = "label"
                                            self.yang_parent_name = "inner-stack"

                                            self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                            self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("outgoing_label",
                                                            "outgoing_label_str") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.outgoing_label.is_set or
                                                self.outgoing_label_str.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.outgoing_label.yfilter != YFilter.not_set or
                                                self.outgoing_label_str.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/stackv4-data/inner-stack/%s" % self.get_segment_path()
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                            if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "outgoing-label"):
                                                self.outgoing_label = value
                                                self.outgoing_label.value_namespace = name_space
                                                self.outgoing_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "outgoing-label-str"):
                                                self.outgoing_label_str = value
                                                self.outgoing_label_str.value_namespace = name_space
                                                self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.label:
                                            if (c.has_data()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return (
                                            self.num_lbls.is_set or
                                            self.num_nexthops.is_set)

                                    def has_operation(self):
                                        for c in self.label:
                                            if (c.has_operation()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nexthop.yfilter != YFilter.not_set or
                                            self.num_lbls.yfilter != YFilter.not_set or
                                            self.num_nexthops.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inner-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/stackv4-data/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                        if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                        leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "label"):
                                            for c in self.label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nexthop"):
                                            self.nexthop.append(value)
                                        if(value_path == "num-lbls"):
                                            self.num_lbls = value
                                            self.num_lbls.value_namespace = name_space
                                            self.num_lbls.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-nexthops"):
                                            self.num_nexthops = value
                                            self.num_nexthops.value_namespace = name_space
                                            self.num_nexthops.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.owner_application_type.is_set or
                                        (self.inner_stack is not None and self.inner_stack.has_data()) or
                                        (self.nexthop is not None and self.nexthop.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.owner_application_type.yfilter != YFilter.not_set or
                                        (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                        (self.nexthop is not None and self.nexthop.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "stackv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.owner_application_type.is_set or self.owner_application_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.owner_application_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "inner-stack"):
                                        if (self.inner_stack is None):
                                            self.inner_stack = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                            self.inner_stack.parent = self
                                            self._children_name_map["inner_stack"] = "inner-stack"
                                        return self.inner_stack

                                    if (child_yang_name == "nexthop"):
                                        if (self.nexthop is None):
                                            self.nexthop = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                            self.nexthop.parent = self
                                            self._children_name_map["nexthop"] = "nexthop"
                                        return self.nexthop

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "inner-stack" or name == "nexthop" or name == "owner-application-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "owner-application-type"):
                                        self.owner_application_type = value
                                        self.owner_application_type.value_namespace = name_space
                                        self.owner_application_type.value_namespace_prefix = name_space_prefix


                            class Stackv6Data(Entity):
                                """
                                stackv6 data
                                
                                .. attribute:: inner_stack
                                
                                	Inner stack
                                	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack>`
                                
                                .. attribute:: nexthop
                                
                                	Nexthop
                                	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.Nexthop>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data, self).__init__()

                                    self.yang_name = "stackv6-data"
                                    self.yang_parent_name = "moi"

                                    self.inner_stack = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                    self.inner_stack.parent = self
                                    self._children_name_map["inner_stack"] = "inner-stack"
                                    self._children_yang_names.add("inner-stack")

                                    self.nexthop = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                    self.nexthop.parent = self
                                    self._children_name_map["nexthop"] = "nexthop"
                                    self._children_yang_names.add("nexthop")


                                class Nexthop(Entity):
                                    """
                                    Nexthop
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv6_next_hop
                                    
                                    	IPv6 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__init__()

                                        self.yang_name = "nexthop"
                                        self.yang_parent_name = "stackv6-data"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv6_next_hop",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv6_next_hop.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv6_next_hop.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nexthop" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/stackv6-data/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6-next-hop"):
                                            self.ipv6_next_hop = value
                                            self.ipv6_next_hop.value_namespace = name_space
                                            self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class InnerStack(Entity):
                                    """
                                    Inner stack
                                    
                                    .. attribute:: label
                                    
                                    	Info related to outgoing labels
                                    	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Remote nexthop addresses
                                    	**type**\:  list of str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: num_lbls
                                    
                                    	Depth of inner label stack
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: num_nexthops
                                    
                                    	Number of remote nexthop addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__init__()

                                        self.yang_name = "inner-stack"
                                        self.yang_parent_name = "stackv6-data"

                                        self.nexthop = YLeafList(YType.str, "nexthop")

                                        self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                        self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                        self.label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nexthop",
                                                        "num_lbls",
                                                        "num_nexthops") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)


                                    class Label(Entity):
                                        """
                                        Info related to outgoing labels
                                        
                                        .. attribute:: outgoing_label
                                        
                                        	Remote Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: outgoing_label_str
                                        
                                        	Remote Label string
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__init__()

                                            self.yang_name = "label"
                                            self.yang_parent_name = "inner-stack"

                                            self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                            self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("outgoing_label",
                                                            "outgoing_label_str") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.outgoing_label.is_set or
                                                self.outgoing_label_str.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.outgoing_label.yfilter != YFilter.not_set or
                                                self.outgoing_label_str.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/stackv6-data/inner-stack/%s" % self.get_segment_path()
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                            if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "outgoing-label"):
                                                self.outgoing_label = value
                                                self.outgoing_label.value_namespace = name_space
                                                self.outgoing_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "outgoing-label-str"):
                                                self.outgoing_label_str = value
                                                self.outgoing_label_str.value_namespace = name_space
                                                self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.label:
                                            if (c.has_data()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return (
                                            self.num_lbls.is_set or
                                            self.num_nexthops.is_set)

                                    def has_operation(self):
                                        for c in self.label:
                                            if (c.has_operation()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nexthop.yfilter != YFilter.not_set or
                                            self.num_lbls.yfilter != YFilter.not_set or
                                            self.num_nexthops.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inner-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/stackv6-data/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                        if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                        leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "label"):
                                            for c in self.label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nexthop"):
                                            self.nexthop.append(value)
                                        if(value_path == "num-lbls"):
                                            self.num_lbls = value
                                            self.num_lbls.value_namespace = name_space
                                            self.num_lbls.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-nexthops"):
                                            self.num_nexthops = value
                                            self.num_nexthops.value_namespace = name_space
                                            self.num_nexthops.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.inner_stack is not None and self.inner_stack.has_data()) or
                                        (self.nexthop is not None and self.nexthop.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                        (self.nexthop is not None and self.nexthop.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "stackv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "inner-stack"):
                                        if (self.inner_stack is None):
                                            self.inner_stack = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                            self.inner_stack.parent = self
                                            self._children_name_map["inner_stack"] = "inner-stack"
                                        return self.inner_stack

                                    if (child_yang_name == "nexthop"):
                                        if (self.nexthop is None):
                                            self.nexthop = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                            self.nexthop.parent = self
                                            self._children_name_map["nexthop"] = "nexthop"
                                        return self.nexthop

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "inner-stack" or name == "nexthop"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class TeHeadData(Entity):
                                """
                                te head data
                                
                                .. attribute:: flags_decode
                                
                                	Flags decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_fwd_class
                                
                                	Tunnel forwarding class
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: tunnel_load_metric
                                
                                	Tunnel Load metric
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_local_label
                                
                                	Tunnel local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_local_label_str
                                
                                	Tunnel local label stringified
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.TeHeadData, self).__init__()

                                    self.yang_name = "te-head-data"
                                    self.yang_parent_name = "moi"

                                    self.flags_decode = YLeaf(YType.str, "flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.tunnel_fwd_class = YLeaf(YType.uint8, "tunnel-fwd-class")

                                    self.tunnel_load_metric = YLeaf(YType.uint32, "tunnel-load-metric")

                                    self.tunnel_local_label = YLeaf(YType.uint32, "tunnel-local-label")

                                    self.tunnel_local_label_str = YLeaf(YType.str, "tunnel-local-label-str")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("flags_decode",
                                                    "table_id",
                                                    "table_name",
                                                    "tunnel_fwd_class",
                                                    "tunnel_load_metric",
                                                    "tunnel_local_label",
                                                    "tunnel_local_label_str") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.tunnel_fwd_class.is_set or
                                        self.tunnel_load_metric.is_set or
                                        self.tunnel_local_label.is_set or
                                        self.tunnel_local_label_str.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.tunnel_fwd_class.yfilter != YFilter.not_set or
                                        self.tunnel_load_metric.yfilter != YFilter.not_set or
                                        self.tunnel_local_label.yfilter != YFilter.not_set or
                                        self.tunnel_local_label_str.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-head-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.flags_decode.is_set or self.flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.tunnel_fwd_class.is_set or self.tunnel_fwd_class.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_fwd_class.get_name_leafdata())
                                    if (self.tunnel_load_metric.is_set or self.tunnel_load_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_load_metric.get_name_leafdata())
                                    if (self.tunnel_local_label.is_set or self.tunnel_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_local_label.get_name_leafdata())
                                    if (self.tunnel_local_label_str.is_set or self.tunnel_local_label_str.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_local_label_str.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-fwd-class" or name == "tunnel-load-metric" or name == "tunnel-local-label" or name == "tunnel-local-label-str"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "flags-decode"):
                                        self.flags_decode = value
                                        self.flags_decode.value_namespace = name_space
                                        self.flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-fwd-class"):
                                        self.tunnel_fwd_class = value
                                        self.tunnel_fwd_class.value_namespace = name_space
                                        self.tunnel_fwd_class.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-load-metric"):
                                        self.tunnel_load_metric = value
                                        self.tunnel_load_metric.value_namespace = name_space
                                        self.tunnel_load_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-local-label"):
                                        self.tunnel_local_label = value
                                        self.tunnel_local_label.value_namespace = name_space
                                        self.tunnel_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-local-label-str"):
                                        self.tunnel_local_label_str = value
                                        self.tunnel_local_label_str.value_namespace = name_space
                                        self.tunnel_local_label_str.value_namespace_prefix = name_space_prefix


                            class DmtcData(Entity):
                                """
                                dmtc data
                                
                                .. attribute:: dmtc_ext_ifh
                                
                                	DMTC External Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.DmtcData, self).__init__()

                                    self.yang_name = "dmtc-data"
                                    self.yang_parent_name = "moi"

                                    self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.dmtc_ext_ifh.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "dmtc-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/moi/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-ext-ifh"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dmtc-ext-ifh"):
                                        self.dmtc_ext_ifh = value
                                        self.dmtc_ext_ifh.value_namespace = name_space
                                        self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.moi_type.is_set or
                                    (self.dmtc_data is not None and self.dmtc_data.has_data()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_data()) or
                                    (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_data()) or
                                    (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_data()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                    (self.stackv4_data is not None and self.stackv4_data.has_data()) or
                                    (self.stackv6_data is not None and self.stackv6_data.has_data()) or
                                    (self.te_head_data is not None and self.te_head_data.has_data()) or
                                    (self.tev4_data is not None and self.tev4_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.moi_type.yfilter != YFilter.not_set or
                                    (self.dmtc_data is not None and self.dmtc_data.has_operation()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_operation()) or
                                    (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_operation()) or
                                    (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_operation()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                    (self.stackv4_data is not None and self.stackv4_data.has_operation()) or
                                    (self.stackv6_data is not None and self.stackv6_data.has_operation()) or
                                    (self.te_head_data is not None and self.te_head_data.has_operation()) or
                                    (self.tev4_data is not None and self.tev4_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "moi" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/moi-array/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.moi_type.is_set or self.moi_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.moi_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "dmtc-data"):
                                    if (self.dmtc_data is None):
                                        self.dmtc_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.DmtcData()
                                        self.dmtc_data.parent = self
                                        self._children_name_map["dmtc_data"] = "dmtc-data"
                                    return self.dmtc_data

                                if (child_yang_name == "ip-sub-data"):
                                    if (self.ip_sub_data is None):
                                        self.ip_sub_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.IpSubData()
                                        self.ip_sub_data.parent = self
                                        self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    return self.ip_sub_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "pop-and-lookup-ipv4"):
                                    if (self.pop_and_lookup_ipv4 is None):
                                        self.pop_and_lookup_ipv4 = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                        self.pop_and_lookup_ipv4.parent = self
                                        self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                    return self.pop_and_lookup_ipv4

                                if (child_yang_name == "pop-and-lookup-ipv6"):
                                    if (self.pop_and_lookup_ipv6 is None):
                                        self.pop_and_lookup_ipv6 = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                        self.pop_and_lookup_ipv6.parent = self
                                        self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                    return self.pop_and_lookup_ipv6

                                if (child_yang_name == "pop-and-lookup-tp"):
                                    if (self.pop_and_lookup_tp is None):
                                        self.pop_and_lookup_tp = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PopAndLookupTp()
                                        self.pop_and_lookup_tp.parent = self
                                        self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                    return self.pop_and_lookup_tp

                                if (child_yang_name == "pseudowire-data"):
                                    if (self.pseudowire_data is None):
                                        self.pseudowire_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireData()
                                        self.pseudowire_data.parent = self
                                        self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    return self.pseudowire_data

                                if (child_yang_name == "pseudowire-head-end-data"):
                                    if (self.pseudowire_head_end_data is None):
                                        self.pseudowire_head_end_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                        self.pseudowire_head_end_data.parent = self
                                        self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    return self.pseudowire_head_end_data

                                if (child_yang_name == "pw-list-data"):
                                    if (self.pw_list_data is None):
                                        self.pw_list_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.PwListData()
                                        self.pw_list_data.parent = self
                                        self._children_name_map["pw_list_data"] = "pw-list-data"
                                    return self.pw_list_data

                                if (child_yang_name == "stackv4-data"):
                                    if (self.stackv4_data is None):
                                        self.stackv4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv4Data()
                                        self.stackv4_data.parent = self
                                        self._children_name_map["stackv4_data"] = "stackv4-data"
                                    return self.stackv4_data

                                if (child_yang_name == "stackv6-data"):
                                    if (self.stackv6_data is None):
                                        self.stackv6_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Stackv6Data()
                                        self.stackv6_data.parent = self
                                        self._children_name_map["stackv6_data"] = "stackv6-data"
                                    return self.stackv6_data

                                if (child_yang_name == "te-head-data"):
                                    if (self.te_head_data is None):
                                        self.te_head_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.TeHeadData()
                                        self.te_head_data.parent = self
                                        self._children_name_map["te_head_data"] = "te-head-data"
                                    return self.te_head_data

                                if (child_yang_name == "tev4-data"):
                                    if (self.tev4_data is None):
                                        self.tev4_data = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi.Tev4Data()
                                        self.tev4_data.parent = self
                                        self._children_name_map["tev4_data"] = "tev4-data"
                                    return self.tev4_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-data" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv6-data" or name == "pop-and-lookup-ipv4" or name == "pop-and-lookup-ipv6" or name == "pop-and-lookup-tp" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "pw-list-data" or name == "stackv4-data" or name == "stackv6-data" or name == "te-head-data" or name == "tev4-data" or name == "moi-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "moi-type"):
                                    self.moi_type = value
                                    self.moi_type.value_namespace = name_space
                                    self.moi_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.moi is not None and self.moi.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.moi is not None and self.moi.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "moi-array" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/mois/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "moi"):
                                if (self.moi is None):
                                    self.moi = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray.Moi()
                                    self.moi.parent = self
                                    self._children_name_map["moi"] = "moi"
                                return self.moi

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "moi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        for c in self.moi_array:
                            if (c.has_data()):
                                return True
                        return (self.application_resource is not None and self.application_resource.has_data())

                    def has_operation(self):
                        for c in self.moi_array:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.application_resource is not None and self.application_resource.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "mois" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/rewrite-ipv4/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application-resource"):
                            if (self.application_resource is None):
                                self.application_resource = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.ApplicationResource()
                                self.application_resource.parent = self
                                self._children_name_map["application_resource"] = "application-resource"
                            return self.application_resource

                        if (child_yang_name == "moi-array"):
                            for c in self.moi_array:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois.MoiArray()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.moi_array.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-resource" or name == "moi-array"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    for c in self.associated_fpi:
                        if (c.has_data()):
                            return True
                    for c in self.mois:
                        if (c.has_data()):
                            return True
                    for c in self.v4_rpf:
                        if (c.has_data()):
                            return True
                    for c in self.v6_rpf:
                        if (c.has_data()):
                            return True
                    return (
                        self.bcdl_priority.is_set or
                        self.lsd_queue.is_set or
                        self.prefix.is_set or
                        self.prefix_length.is_set or
                        self.priority_updated.is_set or
                        self.rewrite_version.is_set or
                        self.rsi_table_id.is_set or
                        self.rsi_table_name.is_set or
                        self.rw_install_age.is_set or
                        self.rw_install_time.is_set or
                        self.rw_updated.is_set or
                        (self.fpi_key is not None and self.fpi_key.has_data()) or
                        (self.rewrite_id is not None and self.rewrite_id.has_data()))

                def has_operation(self):
                    for c in self.associated_fpi:
                        if (c.has_operation()):
                            return True
                    for c in self.mois:
                        if (c.has_operation()):
                            return True
                    for c in self.v4_rpf:
                        if (c.has_operation()):
                            return True
                    for c in self.v6_rpf:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.bcdl_priority.yfilter != YFilter.not_set or
                        self.lsd_queue.yfilter != YFilter.not_set or
                        self.prefix.yfilter != YFilter.not_set or
                        self.prefix_length.yfilter != YFilter.not_set or
                        self.priority_updated.yfilter != YFilter.not_set or
                        self.rewrite_version.yfilter != YFilter.not_set or
                        self.rsi_table_id.yfilter != YFilter.not_set or
                        self.rsi_table_name.yfilter != YFilter.not_set or
                        self.rw_install_age.yfilter != YFilter.not_set or
                        self.rw_install_time.yfilter != YFilter.not_set or
                        self.rw_updated.yfilter != YFilter.not_set or
                        (self.fpi_key is not None and self.fpi_key.has_operation()) or
                        (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "rewrite-ipv4" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-ipv4s/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.bcdl_priority.is_set or self.bcdl_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bcdl_priority.get_name_leafdata())
                    if (self.lsd_queue.is_set or self.lsd_queue.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsd_queue.get_name_leafdata())
                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prefix.get_name_leafdata())
                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                    if (self.priority_updated.is_set or self.priority_updated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.priority_updated.get_name_leafdata())
                    if (self.rewrite_version.is_set or self.rewrite_version.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rewrite_version.get_name_leafdata())
                    if (self.rsi_table_id.is_set or self.rsi_table_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rsi_table_id.get_name_leafdata())
                    if (self.rsi_table_name.is_set or self.rsi_table_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rsi_table_name.get_name_leafdata())
                    if (self.rw_install_age.is_set or self.rw_install_age.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rw_install_age.get_name_leafdata())
                    if (self.rw_install_time.is_set or self.rw_install_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rw_install_time.get_name_leafdata())
                    if (self.rw_updated.is_set or self.rw_updated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rw_updated.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "associated-fpi"):
                        for c in self.associated_fpi:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.AssociatedFpi()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.associated_fpi.append(c)
                        return c

                    if (child_yang_name == "fpi-key"):
                        if (self.fpi_key is None):
                            self.fpi_key = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.FpiKey()
                            self.fpi_key.parent = self
                            self._children_name_map["fpi_key"] = "fpi-key"
                        return self.fpi_key

                    if (child_yang_name == "mois"):
                        for c in self.mois:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.Mois()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.mois.append(c)
                        return c

                    if (child_yang_name == "rewrite-id"):
                        if (self.rewrite_id is None):
                            self.rewrite_id = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.RewriteId()
                            self.rewrite_id.parent = self
                            self._children_name_map["rewrite_id"] = "rewrite-id"
                        return self.rewrite_id

                    if (child_yang_name == "v4-rpf"):
                        for c in self.v4_rpf:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.V4Rpf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.v4_rpf.append(c)
                        return c

                    if (child_yang_name == "v6-rpf"):
                        for c in self.v6_rpf:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4.V6Rpf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.v6_rpf.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "associated-fpi" or name == "fpi-key" or name == "mois" or name == "rewrite-id" or name == "v4-rpf" or name == "v6-rpf" or name == "bcdl-priority" or name == "lsd-queue" or name == "prefix" or name == "prefix-length" or name == "priority-updated" or name == "rewrite-version" or name == "rsi-table-id" or name == "rsi-table-name" or name == "rw-install-age" or name == "rw-install-time" or name == "rw-updated"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "bcdl-priority"):
                        self.bcdl_priority = value
                        self.bcdl_priority.value_namespace = name_space
                        self.bcdl_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsd-queue"):
                        self.lsd_queue = value
                        self.lsd_queue.value_namespace = name_space
                        self.lsd_queue.value_namespace_prefix = name_space_prefix
                    if(value_path == "prefix"):
                        self.prefix = value
                        self.prefix.value_namespace = name_space
                        self.prefix.value_namespace_prefix = name_space_prefix
                    if(value_path == "prefix-length"):
                        self.prefix_length = value
                        self.prefix_length.value_namespace = name_space
                        self.prefix_length.value_namespace_prefix = name_space_prefix
                    if(value_path == "priority-updated"):
                        self.priority_updated = value
                        self.priority_updated.value_namespace = name_space
                        self.priority_updated.value_namespace_prefix = name_space_prefix
                    if(value_path == "rewrite-version"):
                        self.rewrite_version = value
                        self.rewrite_version.value_namespace = name_space
                        self.rewrite_version.value_namespace_prefix = name_space_prefix
                    if(value_path == "rsi-table-id"):
                        self.rsi_table_id = value
                        self.rsi_table_id.value_namespace = name_space
                        self.rsi_table_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "rsi-table-name"):
                        self.rsi_table_name = value
                        self.rsi_table_name.value_namespace = name_space
                        self.rsi_table_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "rw-install-age"):
                        self.rw_install_age = value
                        self.rw_install_age.value_namespace = name_space
                        self.rw_install_age.value_namespace_prefix = name_space_prefix
                    if(value_path == "rw-install-time"):
                        self.rw_install_time = value
                        self.rw_install_time.value_namespace = name_space
                        self.rw_install_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "rw-updated"):
                        self.rw_updated = value
                        self.rw_updated.value_namespace = name_space
                        self.rw_updated.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.rewrite_ipv4:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.rewrite_ipv4:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "rewrite-ipv4s" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "rewrite-ipv4"):
                    for c in self.rewrite_ipv4:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsd.Rewrite.RewriteIpv4S.RewriteIpv4()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.rewrite_ipv4.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "rewrite-ipv4"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class RewriteTes(Entity):
            """
            Table of Traffic Engineering Rewrites
            
            .. attribute:: rewrite_te
            
            	FPI rewrite for TE
            	**type**\: list of    :py:class:`RewriteTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.Rewrite.RewriteTes, self).__init__()

                self.yang_name = "rewrite-tes"
                self.yang_parent_name = "rewrite"

                self.rewrite_te = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.Rewrite.RewriteTes, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.Rewrite.RewriteTes, self).__setattr__(name, value)


            class RewriteTe(Entity):
                """
                FPI rewrite for TE
                
                .. attribute:: interface_name  <key>
                
                	Tunnel interface
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: associated_fpi
                
                	Associated FPI
                	**type**\: list of    :py:class:`AssociatedFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi>`
                
                .. attribute:: bcdl_priority
                
                	BCDL Priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: fpi_key
                
                	fpi key
                	**type**\:   :py:class:`FpiKey <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey>`
                
                .. attribute:: lsd_queue
                
                	LSD queue
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: mois
                
                	Mois
                	**type**\: list of    :py:class:`Mois <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois>`
                
                .. attribute:: priority_updated
                
                	Is rewrite's BCDL priority updated
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: rewrite_id
                
                	Rewrite ID
                	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId>`
                
                .. attribute:: rewrite_version
                
                	Rewrite version
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: rw_install_age
                
                	Rewrite install age
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: rw_install_time
                
                	Rewrite install timestamp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: rw_updated
                
                	Is rewrite ever updated
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: v4_rpf
                
                	IPv4 RPF neighbors
                	**type**\: list of    :py:class:`V4Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.V4Rpf>`
                
                .. attribute:: v6_rpf
                
                	IPv6 RPF neighbors
                	**type**\: list of    :py:class:`V6Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.V6Rpf>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe, self).__init__()

                    self.yang_name = "rewrite-te"
                    self.yang_parent_name = "rewrite-tes"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.bcdl_priority = YLeaf(YType.uint8, "bcdl-priority")

                    self.lsd_queue = YLeaf(YType.uint8, "lsd-queue")

                    self.priority_updated = YLeaf(YType.int32, "priority-updated")

                    self.rewrite_version = YLeaf(YType.uint64, "rewrite-version")

                    self.rw_install_age = YLeaf(YType.uint64, "rw-install-age")

                    self.rw_install_time = YLeaf(YType.uint64, "rw-install-time")

                    self.rw_updated = YLeaf(YType.int32, "rw-updated")

                    self.fpi_key = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey()
                    self.fpi_key.parent = self
                    self._children_name_map["fpi_key"] = "fpi-key"
                    self._children_yang_names.add("fpi-key")

                    self.rewrite_id = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId()
                    self.rewrite_id.parent = self
                    self._children_name_map["rewrite_id"] = "rewrite-id"
                    self._children_yang_names.add("rewrite-id")

                    self.associated_fpi = YList(self)
                    self.mois = YList(self)
                    self.v4_rpf = YList(self)
                    self.v6_rpf = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "bcdl_priority",
                                    "lsd_queue",
                                    "priority_updated",
                                    "rewrite_version",
                                    "rw_install_age",
                                    "rw_install_time",
                                    "rw_updated") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe, self).__setattr__(name, value)


                class FpiKey(Entity):
                    """
                    fpi key
                    
                    .. attribute:: application_owner
                    
                    	Application owner instance
                    	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.ApplicationOwner>`
                    
                    .. attribute:: fpi
                    
                    	FPI
                    	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey, self).__init__()

                        self.yang_name = "fpi-key"
                        self.yang_parent_name = "rewrite-te"

                        self.fpi = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi()
                        self.fpi.parent = self
                        self._children_name_map["fpi"] = "fpi"
                        self._children_yang_names.add("fpi")

                        self.application_owner = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey, self).__setattr__(name, value)


                    class Fpi(Entity):
                        """
                        FPI
                        
                        .. attribute:: dmtc_ext_intf_data
                        
                        	dmtc ext intf data
                        	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.DmtcExtIntfData>`
                        
                        .. attribute:: fpi_type
                        
                        	FPIType
                        	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                        
                        .. attribute:: ipv4_data
                        
                        	ipv4 data
                        	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv4Data>`
                        
                        .. attribute:: ipv6_data
                        
                        	ipv6 data
                        	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv6Data>`
                        
                        .. attribute:: label_data
                        
                        	label data
                        	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.LabelData>`
                        
                        .. attribute:: pw_list_data
                        
                        	pw list data
                        	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.PwListData>`
                        
                        .. attribute:: te_data
                        
                        	te data
                        	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.TeData>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi, self).__init__()

                            self.yang_name = "fpi"
                            self.yang_parent_name = "fpi-key"

                            self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                            self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.DmtcExtIntfData()
                            self.dmtc_ext_intf_data.parent = self
                            self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                            self._children_yang_names.add("dmtc-ext-intf-data")

                            self.ipv4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv4Data()
                            self.ipv4_data.parent = self
                            self._children_name_map["ipv4_data"] = "ipv4-data"
                            self._children_yang_names.add("ipv4-data")

                            self.ipv6_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv6Data()
                            self.ipv6_data.parent = self
                            self._children_name_map["ipv6_data"] = "ipv6-data"
                            self._children_yang_names.add("ipv6-data")

                            self.label_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.LabelData()
                            self.label_data.parent = self
                            self._children_name_map["label_data"] = "label-data"
                            self._children_yang_names.add("label-data")

                            self.pw_list_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.PwListData()
                            self.pw_list_data.parent = self
                            self._children_name_map["pw_list_data"] = "pw-list-data"
                            self._children_yang_names.add("pw-list-data")

                            self.te_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.TeData()
                            self.te_data.parent = self
                            self._children_name_map["te_data"] = "te-data"
                            self._children_yang_names.add("te-data")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fpi_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi, self).__setattr__(name, value)


                        class LabelData(Entity):
                            """
                            label data
                            
                            .. attribute:: elc
                            
                            	ELC
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: label
                            
                            	Label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.LabelData, self).__init__()

                                self.yang_name = "label-data"
                                self.yang_parent_name = "fpi"

                                self.elc = YLeaf(YType.int32, "elc")

                                self.label = YLeaf(YType.uint32, "label")

                                self.security_id = YLeaf(YType.uint32, "security-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("elc",
                                                "label",
                                                "security_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.LabelData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.LabelData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.elc.is_set or
                                    self.label.is_set or
                                    self.security_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.elc.yfilter != YFilter.not_set or
                                    self.label.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.elc.get_name_leafdata())
                                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label.get_name_leafdata())
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "elc" or name == "label" or name == "security-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "elc"):
                                    self.elc = value
                                    self.elc.value_namespace = name_space
                                    self.elc.value_namespace_prefix = name_space_prefix
                                if(value_path == "label"):
                                    self.label = value
                                    self.label.value_namespace = name_space
                                    self.label.value_namespace_prefix = name_space_prefix
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix


                        class TeData(Entity):
                            """
                            te data
                            
                            .. attribute:: local_label
                            
                            	Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_interface
                            
                            	Tunnel interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.TeData, self).__init__()

                                self.yang_name = "te-data"
                                self.yang_parent_name = "fpi"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label",
                                                "tunnel_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.TeData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.TeData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.local_label.is_set or
                                    self.tunnel_interface.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.tunnel_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label" or name == "tunnel-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface"):
                                    self.tunnel_interface = value
                                    self.tunnel_interface.value_namespace = name_space
                                    self.tunnel_interface.value_namespace_prefix = name_space_prefix


                        class Ipv4Data(Entity):
                            """
                            ipv4 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: sr_local_label
                            
                            	SR related Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv4Data, self).__init__()

                                self.yang_name = "ipv4-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "sr_local_label",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.sr_local_label.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.sr_local_label.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "sr-local-label"):
                                    self.sr_local_label = value
                                    self.sr_local_label.value_namespace = name_space
                                    self.sr_local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class Ipv6Data(Entity):
                            """
                            ipv6 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_len
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: router_flags
                            
                            	Route flags
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv6Data, self).__init__()

                                self.yang_name = "ipv6-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                self.router_flags = YLeaf(YType.uint32, "router-flags")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_len",
                                                "router_flags",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_len.is_set or
                                    self.router_flags.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_len.yfilter != YFilter.not_set or
                                    self.router_flags.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv6-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.router_flags.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-len"):
                                    self.prefix_len = value
                                    self.prefix_len.value_namespace = name_space
                                    self.prefix_len.value_namespace_prefix = name_space_prefix
                                if(value_path == "router-flags"):
                                    self.router_flags = value
                                    self.router_flags.value_namespace = name_space
                                    self.router_flags.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class PwListData(Entity):
                            """
                            pw list data
                            
                            .. attribute:: pwhe_list_id
                            
                            	Pseudowire List Identifier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.PwListData, self).__init__()

                                self.yang_name = "pw-list-data"
                                self.yang_parent_name = "fpi"

                                self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("pwhe_list_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.PwListData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.PwListData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.pwhe_list_id.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.pwhe_list_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pw-list-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "pwhe-list-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "pwhe-list-id"):
                                    self.pwhe_list_id = value
                                    self.pwhe_list_id.value_namespace = name_space
                                    self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                        class DmtcExtIntfData(Entity):
                            """
                            dmtc ext intf data
                            
                            .. attribute:: dmtc_ext_ifh
                            
                            	DMTC External Interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.DmtcExtIntfData, self).__init__()

                                self.yang_name = "dmtc-ext-intf-data"
                                self.yang_parent_name = "fpi"

                                self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.dmtc_ext_ifh.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "dmtc-ext-intf-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-ifh"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "dmtc-ext-ifh"):
                                    self.dmtc_ext_ifh = value
                                    self.dmtc_ext_ifh.value_namespace = name_space
                                    self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fpi_type.is_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                (self.label_data is not None and self.label_data.has_data()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                (self.te_data is not None and self.te_data.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fpi_type.yfilter != YFilter.not_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                (self.label_data is not None and self.label_data.has_operation()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                (self.te_data is not None and self.te_data.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fpi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fpi_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "dmtc-ext-intf-data"):
                                if (self.dmtc_ext_intf_data is None):
                                    self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.DmtcExtIntfData()
                                    self.dmtc_ext_intf_data.parent = self
                                    self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                return self.dmtc_ext_intf_data

                            if (child_yang_name == "ipv4-data"):
                                if (self.ipv4_data is None):
                                    self.ipv4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                return self.ipv4_data

                            if (child_yang_name == "ipv6-data"):
                                if (self.ipv6_data is None):
                                    self.ipv6_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                return self.ipv6_data

                            if (child_yang_name == "label-data"):
                                if (self.label_data is None):
                                    self.label_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.LabelData()
                                    self.label_data.parent = self
                                    self._children_name_map["label_data"] = "label-data"
                                return self.label_data

                            if (child_yang_name == "pw-list-data"):
                                if (self.pw_list_data is None):
                                    self.pw_list_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.PwListData()
                                    self.pw_list_data.parent = self
                                    self._children_name_map["pw_list_data"] = "pw-list-data"
                                return self.pw_list_data

                            if (child_yang_name == "te-data"):
                                if (self.te_data is None):
                                    self.te_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi.TeData()
                                    self.te_data.parent = self
                                    self._children_name_map["te_data"] = "te-data"
                                return self.te_data

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fpi-type"):
                                self.fpi_type = value
                                self.fpi_type.value_namespace = name_space
                                self.fpi_type.value_namespace_prefix = name_space_prefix


                    class ApplicationOwner(Entity):
                        """
                        Application owner instance
                        
                        .. attribute:: application_instance
                        
                        	Application instance Name
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        .. attribute:: resource_state
                        
                        	Application resource state
                        	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.ApplicationOwner, self).__init__()

                            self.yang_name = "application-owner"
                            self.yang_parent_name = "fpi-key"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                            self.resource_state = YLeaf(YType.enumeration, "resource-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type",
                                            "resource_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.ApplicationOwner, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.ApplicationOwner, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set or
                                self.resource_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set or
                                self.resource_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application-owner" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())
                            if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resource_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "resource-state"):
                                self.resource_state = value
                                self.resource_state.value_namespace = name_space
                                self.resource_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.application_owner:
                            if (c.has_data()):
                                return True
                        return (self.fpi is not None and self.fpi.has_data())

                    def has_operation(self):
                        for c in self.application_owner:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.fpi is not None and self.fpi.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "fpi-key" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application-owner"):
                            for c in self.application_owner:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.ApplicationOwner()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.application_owner.append(c)
                            return c

                        if (child_yang_name == "fpi"):
                            if (self.fpi is None):
                                self.fpi = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey.Fpi()
                                self.fpi.parent = self
                                self._children_name_map["fpi"] = "fpi"
                            return self.fpi

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-owner" or name == "fpi"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class RewriteId(Entity):
                    """
                    Rewrite ID
                    
                    .. attribute:: rewrite_id
                    
                    	Rewrite ID
                    	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId, self).__init__()

                        self.yang_name = "rewrite-id"
                        self.yang_parent_name = "rewrite-te"

                        self.rewrite_id = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId()
                        self.rewrite_id.parent = self
                        self._children_name_map["rewrite_id"] = "rewrite-id"
                        self._children_yang_names.add("rewrite-id")


                    class RewriteId(Entity):
                        """
                        Rewrite ID
                        
                        .. attribute:: label_context
                        
                        	Label context
                        	**type**\:   :py:class:`LabelContext <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext>`
                        
                        .. attribute:: local_label_rewrite
                        
                        	Local label rewrite information
                        	**type**\:   :py:class:`LocalLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LocalLabelRewrite>`
                        
                        .. attribute:: rewrite_id_type
                        
                        	RewriteIDType
                        	**type**\:   :py:class:`MgmtLsdRwId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdRwId>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId, self).__init__()

                            self.yang_name = "rewrite-id"
                            self.yang_parent_name = "rewrite-id"

                            self.rewrite_id_type = YLeaf(YType.enumeration, "rewrite-id-type")

                            self.label_context = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext()
                            self.label_context.parent = self
                            self._children_name_map["label_context"] = "label-context"
                            self._children_yang_names.add("label-context")

                            self.local_label_rewrite = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LocalLabelRewrite()
                            self.local_label_rewrite.parent = self
                            self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                            self._children_yang_names.add("local-label-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("rewrite_id_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId, self).__setattr__(name, value)


                        class LabelContext(Entity):
                            """
                            Label context
                            
                            .. attribute:: cev4l3vpn_data
                            
                            	L3VPN CEv4 label context
                            	**type**\:   :py:class:`Cev4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev4L3VpnData>`
                            
                            .. attribute:: cev6l3vpn_data
                            
                            	L3VPN CEv6 label context
                            	**type**\:   :py:class:`Cev6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev6L3VpnData>`
                            
                            .. attribute:: evpn_data
                            
                            	EVPN context
                            	**type**\:   :py:class:`EvpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.EvpnData>`
                            
                            .. attribute:: generic_routing_encapsulation
                            
                            	Generic routing encapsulation context
                            	**type**\:   :py:class:`GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation>`
                            
                            .. attribute:: ip_sub_data
                            
                            	IP Subscriber context
                            	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.IpSubData>`
                            
                            .. attribute:: ipv4_data
                            
                            	IPv4 label context
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4Data>`
                            
                            .. attribute:: ipv4blb_data
                            
                            	BFD BLB label context
                            	**type**\:   :py:class:`Ipv4BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4BlbData>`
                            
                            .. attribute:: ipv4l3vpn_data
                            
                            	L3VPN IPv4 label context
                            	**type**\:   :py:class:`Ipv4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData>`
                            
                            .. attribute:: ipv6_data
                            
                            	IPv6 label context
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6Data>`
                            
                            .. attribute:: ipv6_generic_routing_encapsulation
                            
                            	Generic routing encapsulation context
                            	**type**\:   :py:class:`Ipv6GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation>`
                            
                            .. attribute:: ipv6blb_data
                            
                            	BFD BLB label context
                            	**type**\:   :py:class:`Ipv6BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6BlbData>`
                            
                            .. attribute:: ipv6l3vpn_data
                            
                            	L3VPN IPv6 label context
                            	**type**\:   :py:class:`Ipv6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData>`
                            
                            .. attribute:: label_block_data
                            
                            	Label block context
                            	**type**\:   :py:class:`LabelBlockData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockData>`
                            
                            .. attribute:: label_block_srgb_data
                            
                            	Label block SRGB context
                            	**type**\:   :py:class:`LabelBlockSrgbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData>`
                            
                            .. attribute:: label_context_type
                            
                            	LabelContextType
                            	**type**\:   :py:class:`MgmtLsdLblCtx <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLblCtx>`
                            
                            .. attribute:: mld_pv4_data
                            
                            	MLDPv4 LSM\-ID context
                            	**type**\:   :py:class:`MldPv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.MldPv4Data>`
                            
                            .. attribute:: next_hop_set_l3vpn
                            
                            	L3VPN NH SET label context
                            	**type**\:   :py:class:`NextHopSetL3Vpn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn>`
                            
                            .. attribute:: pi_mi_pmsi_data
                            
                            	PIM I\-PMSI label conext
                            	**type**\:   :py:class:`PiMiPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMiPmsiData>`
                            
                            .. attribute:: pi_ms_pmsi_data
                            
                            	PIM S\-PMSI label conext
                            	**type**\:   :py:class:`PiMsPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMsPmsiData>`
                            
                            .. attribute:: pseudowire_data
                            
                            	Pseudowire label context
                            	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireData>`
                            
                            .. attribute:: pseudowire_head_end_data
                            
                            	Pseudowire Head\-end label context
                            	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData>`
                            
                            .. attribute:: sr_adj_segment_ipv4
                            
                            	SR Adj Segment ipv4 context
                            	**type**\:   :py:class:`SrAdjSegmentIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4>`
                            
                            .. attribute:: sr_adj_segment_ipv6
                            
                            	SR Adj Segment ipv6 context
                            	**type**\:   :py:class:`SrAdjSegmentIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6>`
                            
                            .. attribute:: sr_prefix_segment
                            
                            	SR Prefix Segment context
                            	**type**\:   :py:class:`SrPrefixSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrPrefixSegment>`
                            
                            .. attribute:: te_binding
                            
                            	MPLS TE tunnel binding context
                            	**type**\:   :py:class:`TeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TeBinding>`
                            
                            .. attribute:: tev4_data
                            
                            	TEv4 label context
                            	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4Data>`
                            
                            .. attribute:: tev4p2mp_data
                            
                            	TEv4 P2MP context
                            	**type**\:   :py:class:`Tev4P2MpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4P2MpData>`
                            
                            .. attribute:: tp_data
                            
                            	TP context
                            	**type**\:   :py:class:`TpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TpData>`
                            
                            .. attribute:: vrf_l3vpn_data
                            
                            	L3VPN VRF label context
                            	**type**\:   :py:class:`VrfL3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.VrfL3VpnData>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext, self).__init__()

                                self.yang_name = "label-context"
                                self.yang_parent_name = "rewrite-id"

                                self.label_context_type = YLeaf(YType.enumeration, "label-context-type")

                                self.cev4l3vpn_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                self.cev4l3vpn_data.parent = self
                                self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                self._children_yang_names.add("cev4l3vpn-data")

                                self.cev6l3vpn_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                self.cev6l3vpn_data.parent = self
                                self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                self._children_yang_names.add("cev6l3vpn-data")

                                self.evpn_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.EvpnData()
                                self.evpn_data.parent = self
                                self._children_name_map["evpn_data"] = "evpn-data"
                                self._children_yang_names.add("evpn-data")

                                self.generic_routing_encapsulation = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                self.generic_routing_encapsulation.parent = self
                                self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                self._children_yang_names.add("generic-routing-encapsulation")

                                self.ip_sub_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.IpSubData()
                                self.ip_sub_data.parent = self
                                self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                self._children_yang_names.add("ip-sub-data")

                                self.ipv4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv4blb_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                self.ipv4blb_data.parent = self
                                self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                self._children_yang_names.add("ipv4blb-data")

                                self.ipv4l3vpn_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                self.ipv4l3vpn_data.parent = self
                                self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                self._children_yang_names.add("ipv4l3vpn-data")

                                self.ipv6_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.ipv6_generic_routing_encapsulation = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                self.ipv6_generic_routing_encapsulation.parent = self
                                self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                self._children_yang_names.add("ipv6-generic-routing-encapsulation")

                                self.ipv6blb_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                self.ipv6blb_data.parent = self
                                self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                self._children_yang_names.add("ipv6blb-data")

                                self.ipv6l3vpn_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                self.ipv6l3vpn_data.parent = self
                                self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                self._children_yang_names.add("ipv6l3vpn-data")

                                self.label_block_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                self.label_block_data.parent = self
                                self._children_name_map["label_block_data"] = "label-block-data"
                                self._children_yang_names.add("label-block-data")

                                self.label_block_srgb_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                self.label_block_srgb_data.parent = self
                                self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                self._children_yang_names.add("label-block-srgb-data")

                                self.mld_pv4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                self.mld_pv4_data.parent = self
                                self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                self._children_yang_names.add("mld-pv4-data")

                                self.next_hop_set_l3vpn = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                self.next_hop_set_l3vpn.parent = self
                                self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                self._children_yang_names.add("next-hop-set-l3vpn")

                                self.pi_mi_pmsi_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                self.pi_mi_pmsi_data.parent = self
                                self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                self._children_yang_names.add("pi-mi-pmsi-data")

                                self.pi_ms_pmsi_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                self.pi_ms_pmsi_data.parent = self
                                self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                self._children_yang_names.add("pi-ms-pmsi-data")

                                self.pseudowire_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireData()
                                self.pseudowire_data.parent = self
                                self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                self._children_yang_names.add("pseudowire-data")

                                self.pseudowire_head_end_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                self.pseudowire_head_end_data.parent = self
                                self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                self._children_yang_names.add("pseudowire-head-end-data")

                                self.sr_adj_segment_ipv4 = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                self.sr_adj_segment_ipv4.parent = self
                                self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                self._children_yang_names.add("sr-adj-segment-ipv4")

                                self.sr_adj_segment_ipv6 = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                self.sr_adj_segment_ipv6.parent = self
                                self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                self._children_yang_names.add("sr-adj-segment-ipv6")

                                self.sr_prefix_segment = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                self.sr_prefix_segment.parent = self
                                self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                self._children_yang_names.add("sr-prefix-segment")

                                self.te_binding = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TeBinding()
                                self.te_binding.parent = self
                                self._children_name_map["te_binding"] = "te-binding"
                                self._children_yang_names.add("te-binding")

                                self.tev4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4Data()
                                self.tev4_data.parent = self
                                self._children_name_map["tev4_data"] = "tev4-data"
                                self._children_yang_names.add("tev4-data")

                                self.tev4p2mp_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                self.tev4p2mp_data.parent = self
                                self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                self._children_yang_names.add("tev4p2mp-data")

                                self.tp_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TpData()
                                self.tp_data.parent = self
                                self._children_name_map["tp_data"] = "tp-data"
                                self._children_yang_names.add("tp-data")

                                self.vrf_l3vpn_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                self.vrf_l3vpn_data.parent = self
                                self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                self._children_yang_names.add("vrf-l3vpn-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_context_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)


                            class Ipv4Data(Entity):
                                """
                                IPv4 label context
                                
                                .. attribute:: prefix
                                
                                	IPv4 prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	IPv4 prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf_name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                	**length:** 0..33
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.vrf_name = YLeaf(YType.str, "vrf-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "security_id",
                                                    "table_id",
                                                    "vrf_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set or
                                        self.vrf_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.vrf_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-name"):
                                        self.vrf_name = value
                                        self.vrf_name.value_namespace = name_space
                                        self.vrf_name.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                IPv6 label context
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf_name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                	**length:** 0..33
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.vrf_name = YLeaf(YType.str, "vrf-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "security_id",
                                                    "table_id",
                                                    "vrf_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set or
                                        self.vrf_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.vrf_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-name"):
                                        self.vrf_name = value
                                        self.vrf_name.value_namespace = name_space
                                        self.vrf_name.value_namespace_prefix = name_space_prefix


                            class Tev4Data(Entity):
                                """
                                TEv4 label context
                                
                                .. attribute:: is_srte
                                
                                	Is this an SRTE head tunnel
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_dest
                                
                                	Tunnel destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_id_extension
                                
                                	Extended tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_lsp_id
                                
                                	Tunnel LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_source
                                
                                	Tunnel source
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4Data, self).__init__()

                                    self.yang_name = "tev4-data"
                                    self.yang_parent_name = "label-context"

                                    self.is_srte = YLeaf(YType.int32, "is-srte")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.tunnel_dest = YLeaf(YType.str, "tunnel-dest")

                                    self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                    self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                    self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                    self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_srte",
                                                    "table_id",
                                                    "tunnel_dest",
                                                    "tunnel_id",
                                                    "tunnel_id_extension",
                                                    "tunnel_lsp_id",
                                                    "tunnel_source") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_srte.is_set or
                                        self.table_id.is_set or
                                        self.tunnel_dest.is_set or
                                        self.tunnel_id.is_set or
                                        self.tunnel_id_extension.is_set or
                                        self.tunnel_lsp_id.is_set or
                                        self.tunnel_source.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_srte.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.tunnel_dest.yfilter != YFilter.not_set or
                                        self.tunnel_id.yfilter != YFilter.not_set or
                                        self.tunnel_id_extension.yfilter != YFilter.not_set or
                                        self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                        self.tunnel_source.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tev4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_srte.is_set or self.is_srte.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_srte.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.tunnel_dest.is_set or self.tunnel_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_dest.get_name_leafdata())
                                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                    if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                    if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                    if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-srte" or name == "table-id" or name == "tunnel-dest" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-srte"):
                                        self.is_srte = value
                                        self.is_srte.value_namespace = name_space
                                        self.is_srte.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-dest"):
                                        self.tunnel_dest = value
                                        self.tunnel_dest.value_namespace = name_space
                                        self.tunnel_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id"):
                                        self.tunnel_id = value
                                        self.tunnel_id.value_namespace = name_space
                                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id-extension"):
                                        self.tunnel_id_extension = value
                                        self.tunnel_id_extension.value_namespace = name_space
                                        self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-lsp-id"):
                                        self.tunnel_lsp_id = value
                                        self.tunnel_lsp_id.value_namespace = name_space
                                        self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-source"):
                                        self.tunnel_source = value
                                        self.tunnel_source.value_namespace = name_space
                                        self.tunnel_source.value_namespace_prefix = name_space_prefix


                            class Ipv4L3VpnData(Entity):
                                """
                                L3VPN IPv4 label context
                                
                                .. attribute:: prefix
                                
                                	IPv4 prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: route_distinguisher
                                
                                	Route distinguisher
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__init__()

                                    self.yang_name = "ipv4l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "route_distinguisher") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.route_distinguisher.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.route_distinguisher.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-distinguisher"):
                                        self.route_distinguisher = value
                                        self.route_distinguisher.value_namespace = name_space
                                        self.route_distinguisher.value_namespace_prefix = name_space_prefix


                            class Ipv6L3VpnData(Entity):
                                """
                                L3VPN IPv6 label context
                                
                                .. attribute:: prefix
                                
                                	IPv6 prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: route_distinguisher
                                
                                	Route distinguisher
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__init__()

                                    self.yang_name = "ipv6l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "route_distinguisher") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.route_distinguisher.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.route_distinguisher.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-distinguisher"):
                                        self.route_distinguisher = value
                                        self.route_distinguisher.value_namespace = name_space
                                        self.route_distinguisher.value_namespace_prefix = name_space_prefix


                            class VrfL3VpnData(Entity):
                                """
                                L3VPN VRF label context
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__init__()

                                    self.yang_name = "vrf-l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("security_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.security_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf-l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "security-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class Cev4L3VpnData(Entity):
                                """
                                L3VPN CEv4 label context
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__init__()

                                    self.yang_name = "cev4l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_next_hop",
                                                    "security_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ipv4_next_hop.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "cev4l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-next-hop" or name == "security-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class Cev6L3VpnData(Entity):
                                """
                                L3VPN CEv6 label context
                                
                                .. attribute:: ipv6_next_hop
                                
                                	IPv6 nexthop
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__init__()

                                    self.yang_name = "cev6l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv6_next_hop",
                                                    "security_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ipv6_next_hop.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv6_next_hop.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "cev6l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv6-next-hop" or name == "security-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv6-next-hop"):
                                        self.ipv6_next_hop = value
                                        self.ipv6_next_hop.value_namespace = name_space
                                        self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class PseudowireData(Entity):
                                """
                                Pseudowire label context
                                
                                .. attribute:: prefix
                                
                                	Address prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: pseudowire_id
                                
                                	Pseudo\-wire ID
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: remote_l2_router_id
                                
                                	Remote L2 Router ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: subinterface
                                
                                	Subinterface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireData, self).__init__()

                                    self.yang_name = "pseudowire-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.pseudowire_id = YLeaf(YType.uint64, "pseudowire-id")

                                    self.remote_l2_router_id = YLeaf(YType.uint32, "remote-l2-router-id")

                                    self.subinterface = YLeaf(YType.str, "subinterface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "pseudowire_id",
                                                    "remote_l2_router_id",
                                                    "subinterface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.pseudowire_id.is_set or
                                        self.remote_l2_router_id.is_set or
                                        self.subinterface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.pseudowire_id.yfilter != YFilter.not_set or
                                        self.remote_l2_router_id.yfilter != YFilter.not_set or
                                        self.subinterface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pseudowire_id.get_name_leafdata())
                                    if (self.remote_l2_router_id.is_set or self.remote_l2_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.remote_l2_router_id.get_name_leafdata())
                                    if (self.subinterface.is_set or self.subinterface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.subinterface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "pseudowire-id" or name == "remote-l2-router-id" or name == "subinterface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pseudowire-id"):
                                        self.pseudowire_id = value
                                        self.pseudowire_id.value_namespace = name_space
                                        self.pseudowire_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "remote-l2-router-id"):
                                        self.remote_l2_router_id = value
                                        self.remote_l2_router_id.value_namespace = name_space
                                        self.remote_l2_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "subinterface"):
                                        self.subinterface = value
                                        self.subinterface.value_namespace = name_space
                                        self.subinterface.value_namespace_prefix = name_space_prefix


                            class LabelBlockData(Entity):
                                """
                                Label block context
                                
                                .. attribute:: edge_id
                                
                                	Edge ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: offset
                                
                                	Offset
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: service
                                
                                	Service
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: size
                                
                                	Number of labels
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vpn_id
                                
                                	VPN ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__init__()

                                    self.yang_name = "label-block-data"
                                    self.yang_parent_name = "label-context"

                                    self.edge_id = YLeaf(YType.uint16, "edge-id")

                                    self.offset = YLeaf(YType.uint32, "offset")

                                    self.service = YLeaf(YType.uint8, "service")

                                    self.size = YLeaf(YType.uint32, "size")

                                    self.vpn_id = YLeaf(YType.uint16, "vpn-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("edge_id",
                                                    "offset",
                                                    "service",
                                                    "size",
                                                    "vpn_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.edge_id.is_set or
                                        self.offset.is_set or
                                        self.service.is_set or
                                        self.size.is_set or
                                        self.vpn_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.edge_id.yfilter != YFilter.not_set or
                                        self.offset.yfilter != YFilter.not_set or
                                        self.service.yfilter != YFilter.not_set or
                                        self.size.yfilter != YFilter.not_set or
                                        self.vpn_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-block-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.edge_id.is_set or self.edge_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.edge_id.get_name_leafdata())
                                    if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.offset.get_name_leafdata())
                                    if (self.service.is_set or self.service.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service.get_name_leafdata())
                                    if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.size.get_name_leafdata())
                                    if (self.vpn_id.is_set or self.vpn_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vpn_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "edge-id" or name == "offset" or name == "service" or name == "size" or name == "vpn-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "edge-id"):
                                        self.edge_id = value
                                        self.edge_id.value_namespace = name_space
                                        self.edge_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "offset"):
                                        self.offset = value
                                        self.offset.value_namespace = name_space
                                        self.offset.value_namespace_prefix = name_space_prefix
                                    if(value_path == "service"):
                                        self.service = value
                                        self.service.value_namespace = name_space
                                        self.service.value_namespace_prefix = name_space_prefix
                                    if(value_path == "size"):
                                        self.size = value
                                        self.size.value_namespace = name_space
                                        self.size.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vpn-id"):
                                        self.vpn_id = value
                                        self.vpn_id.value_namespace = name_space
                                        self.vpn_id.value_namespace_prefix = name_space_prefix


                            class IpSubData(Entity):
                                """
                                IP Subscriber context
                                
                                .. attribute:: parent_interface
                                
                                	Parent interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: table_id
                                
                                	Table Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.IpSubData, self).__init__()

                                    self.yang_name = "ip-sub-data"
                                    self.yang_parent_name = "label-context"

                                    self.parent_interface = YLeaf(YType.str, "parent-interface")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("parent_interface",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.parent_interface.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.parent_interface.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ip-sub-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.parent_interface.is_set or self.parent_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "parent-interface" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "parent-interface"):
                                        self.parent_interface = value
                                        self.parent_interface.value_namespace = name_space
                                        self.parent_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class Tev4P2MpData(Entity):
                                """
                                TEv4 P2MP context
                                
                                .. attribute:: p2mp_id
                                
                                	Point to multipoint ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: previous_hop
                                
                                	Previous hop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_id_extension
                                
                                	Tunnel ID extension
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_lsp_id
                                
                                	Tunnel LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_source
                                
                                	Tunnel source
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__init__()

                                    self.yang_name = "tev4p2mp-data"
                                    self.yang_parent_name = "label-context"

                                    self.p2mp_id = YLeaf(YType.uint32, "p2mp-id")

                                    self.previous_hop = YLeaf(YType.str, "previous-hop")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                    self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                    self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                    self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("p2mp_id",
                                                    "previous_hop",
                                                    "table_id",
                                                    "tunnel_id",
                                                    "tunnel_id_extension",
                                                    "tunnel_lsp_id",
                                                    "tunnel_source") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.p2mp_id.is_set or
                                        self.previous_hop.is_set or
                                        self.table_id.is_set or
                                        self.tunnel_id.is_set or
                                        self.tunnel_id_extension.is_set or
                                        self.tunnel_lsp_id.is_set or
                                        self.tunnel_source.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.p2mp_id.yfilter != YFilter.not_set or
                                        self.previous_hop.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.tunnel_id.yfilter != YFilter.not_set or
                                        self.tunnel_id_extension.yfilter != YFilter.not_set or
                                        self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                        self.tunnel_source.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tev4p2mp-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                                    if (self.previous_hop.is_set or self.previous_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.previous_hop.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                    if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                    if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                    if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "p2mp-id" or name == "previous-hop" or name == "table-id" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "p2mp-id"):
                                        self.p2mp_id = value
                                        self.p2mp_id.value_namespace = name_space
                                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "previous-hop"):
                                        self.previous_hop = value
                                        self.previous_hop.value_namespace = name_space
                                        self.previous_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id"):
                                        self.tunnel_id = value
                                        self.tunnel_id.value_namespace = name_space
                                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id-extension"):
                                        self.tunnel_id_extension = value
                                        self.tunnel_id_extension.value_namespace = name_space
                                        self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-lsp-id"):
                                        self.tunnel_lsp_id = value
                                        self.tunnel_lsp_id.value_namespace = name_space
                                        self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-source"):
                                        self.tunnel_source = value
                                        self.tunnel_source.value_namespace = name_space
                                        self.tunnel_source.value_namespace_prefix = name_space_prefix


                            class MldPv4Data(Entity):
                                """
                                MLDPv4 LSM\-ID context
                                
                                .. attribute:: lsm_id
                                
                                	LSM ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: peer_label_space_id
                                
                                	Peer Label Space Id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: peer_lsrid
                                
                                	Peer LSR Id
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: type
                                
                                	LSM ID Type
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__init__()

                                    self.yang_name = "mld-pv4-data"
                                    self.yang_parent_name = "label-context"

                                    self.lsm_id = YLeaf(YType.uint32, "lsm-id")

                                    self.peer_label_space_id = YLeaf(YType.uint16, "peer-label-space-id")

                                    self.peer_lsrid = YLeaf(YType.str, "peer-lsrid")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("lsm_id",
                                                    "peer_label_space_id",
                                                    "peer_lsrid",
                                                    "table_id",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.lsm_id.is_set or
                                        self.peer_label_space_id.is_set or
                                        self.peer_lsrid.is_set or
                                        self.table_id.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.lsm_id.yfilter != YFilter.not_set or
                                        self.peer_label_space_id.yfilter != YFilter.not_set or
                                        self.peer_lsrid.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "mld-pv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.lsm_id.is_set or self.lsm_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsm_id.get_name_leafdata())
                                    if (self.peer_label_space_id.is_set or self.peer_label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_label_space_id.get_name_leafdata())
                                    if (self.peer_lsrid.is_set or self.peer_lsrid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_lsrid.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "lsm-id" or name == "peer-label-space-id" or name == "peer-lsrid" or name == "table-id" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "lsm-id"):
                                        self.lsm_id = value
                                        self.lsm_id.value_namespace = name_space
                                        self.lsm_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-label-space-id"):
                                        self.peer_label_space_id = value
                                        self.peer_label_space_id.value_namespace = name_space
                                        self.peer_label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-lsrid"):
                                        self.peer_lsrid = value
                                        self.peer_lsrid.value_namespace = name_space
                                        self.peer_lsrid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class PseudowireHeadEndData(Entity):
                                """
                                Pseudowire Head\-end label context
                                
                                .. attribute:: pwhe_intf
                                
                                	Pseudo\-wire Head\-end interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__init__()

                                    self.yang_name = "pseudowire-head-end-data"
                                    self.yang_parent_name = "label-context"

                                    self.pwhe_intf = YLeaf(YType.str, "pwhe-intf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("pwhe_intf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.pwhe_intf.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.pwhe_intf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-head-end-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.pwhe_intf.is_set or self.pwhe_intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_intf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "pwhe-intf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "pwhe-intf"):
                                        self.pwhe_intf = value
                                        self.pwhe_intf.value_namespace = name_space
                                        self.pwhe_intf.value_namespace_prefix = name_space_prefix


                            class TpData(Entity):
                                """
                                TP context
                                
                                .. attribute:: dest_global_id
                                
                                	TP destination global ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: dest_node_id
                                
                                	TP destination node ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: dest_tunnel_id
                                
                                	TP destination tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsp_id
                                
                                	TP LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: source_global_id
                                
                                	TP source global ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: source_node_id
                                
                                	TP source node ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: source_tunnel_id
                                
                                	TP source tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TpData, self).__init__()

                                    self.yang_name = "tp-data"
                                    self.yang_parent_name = "label-context"

                                    self.dest_global_id = YLeaf(YType.uint32, "dest-global-id")

                                    self.dest_node_id = YLeaf(YType.str, "dest-node-id")

                                    self.dest_tunnel_id = YLeaf(YType.uint16, "dest-tunnel-id")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                    self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                                    self.source_node_id = YLeaf(YType.str, "source-node-id")

                                    self.source_tunnel_id = YLeaf(YType.uint16, "source-tunnel-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dest_global_id",
                                                    "dest_node_id",
                                                    "dest_tunnel_id",
                                                    "lsp_id",
                                                    "source_global_id",
                                                    "source_node_id",
                                                    "source_tunnel_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.dest_global_id.is_set or
                                        self.dest_node_id.is_set or
                                        self.dest_tunnel_id.is_set or
                                        self.lsp_id.is_set or
                                        self.source_global_id.is_set or
                                        self.source_node_id.is_set or
                                        self.source_tunnel_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dest_global_id.yfilter != YFilter.not_set or
                                        self.dest_node_id.yfilter != YFilter.not_set or
                                        self.dest_tunnel_id.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set or
                                        self.source_global_id.yfilter != YFilter.not_set or
                                        self.source_node_id.yfilter != YFilter.not_set or
                                        self.source_tunnel_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tp-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dest_global_id.is_set or self.dest_global_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dest_global_id.get_name_leafdata())
                                    if (self.dest_node_id.is_set or self.dest_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dest_node_id.get_name_leafdata())
                                    if (self.dest_tunnel_id.is_set or self.dest_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dest_tunnel_id.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                                    if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_global_id.get_name_leafdata())
                                    if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_node_id.get_name_leafdata())
                                    if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dest-global-id" or name == "dest-node-id" or name == "dest-tunnel-id" or name == "lsp-id" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dest-global-id"):
                                        self.dest_global_id = value
                                        self.dest_global_id.value_namespace = name_space
                                        self.dest_global_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dest-node-id"):
                                        self.dest_node_id = value
                                        self.dest_node_id.value_namespace = name_space
                                        self.dest_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dest-tunnel-id"):
                                        self.dest_tunnel_id = value
                                        self.dest_tunnel_id.value_namespace = name_space
                                        self.dest_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-global-id"):
                                        self.source_global_id = value
                                        self.source_global_id.value_namespace = name_space
                                        self.source_global_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-node-id"):
                                        self.source_node_id = value
                                        self.source_node_id.value_namespace = name_space
                                        self.source_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-tunnel-id"):
                                        self.source_tunnel_id = value
                                        self.source_tunnel_id.value_namespace = name_space
                                        self.source_tunnel_id.value_namespace_prefix = name_space_prefix


                            class GenericRoutingEncapsulation(Entity):
                                """
                                Generic routing encapsulation context
                                
                                .. attribute:: gre_interface
                                
                                	Generic routing encapsulation interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__init__()

                                    self.yang_name = "generic-routing-encapsulation"
                                    self.yang_parent_name = "label-context"

                                    self.gre_interface = YLeaf(YType.str, "gre-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("gre_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.gre_interface.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.gre_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "generic-routing-encapsulation" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.gre_interface.is_set or self.gre_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gre_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "gre-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "gre-interface"):
                                        self.gre_interface = value
                                        self.gre_interface.value_namespace = name_space
                                        self.gre_interface.value_namespace_prefix = name_space_prefix


                            class Ipv6GenericRoutingEncapsulation(Entity):
                                """
                                Generic routing encapsulation context
                                
                                .. attribute:: greipv6_interface
                                
                                	Generic routing encapsulation IPv6 interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__init__()

                                    self.yang_name = "ipv6-generic-routing-encapsulation"
                                    self.yang_parent_name = "label-context"

                                    self.greipv6_interface = YLeaf(YType.str, "greipv6-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("greipv6_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.greipv6_interface.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.greipv6_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-generic-routing-encapsulation" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.greipv6_interface.is_set or self.greipv6_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.greipv6_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "greipv6-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "greipv6-interface"):
                                        self.greipv6_interface = value
                                        self.greipv6_interface.value_namespace = name_space
                                        self.greipv6_interface.value_namespace_prefix = name_space_prefix


                            class EvpnData(Entity):
                                """
                                EVPN context
                                
                                .. attribute:: ethernet_segment
                                
                                	Ethernet Segment ID
                                	**type**\:  str
                                
                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                
                                .. attribute:: evpn_id
                                
                                	EVPN ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: evpn_tag
                                
                                	EVPN TAG
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.EvpnData, self).__init__()

                                    self.yang_name = "evpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.ethernet_segment = YLeaf(YType.str, "ethernet-segment")

                                    self.evpn_id = YLeaf(YType.uint32, "evpn-id")

                                    self.evpn_tag = YLeaf(YType.uint32, "evpn-tag")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ethernet_segment",
                                                    "evpn_id",
                                                    "evpn_tag") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ethernet_segment.is_set or
                                        self.evpn_id.is_set or
                                        self.evpn_tag.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ethernet_segment.yfilter != YFilter.not_set or
                                        self.evpn_id.yfilter != YFilter.not_set or
                                        self.evpn_tag.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "evpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ethernet_segment.is_set or self.ethernet_segment.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ethernet_segment.get_name_leafdata())
                                    if (self.evpn_id.is_set or self.evpn_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.evpn_id.get_name_leafdata())
                                    if (self.evpn_tag.is_set or self.evpn_tag.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.evpn_tag.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ethernet-segment" or name == "evpn-id" or name == "evpn-tag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ethernet-segment"):
                                        self.ethernet_segment = value
                                        self.ethernet_segment.value_namespace = name_space
                                        self.ethernet_segment.value_namespace_prefix = name_space_prefix
                                    if(value_path == "evpn-id"):
                                        self.evpn_id = value
                                        self.evpn_id.value_namespace = name_space
                                        self.evpn_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "evpn-tag"):
                                        self.evpn_tag = value
                                        self.evpn_tag.value_namespace = name_space
                                        self.evpn_tag.value_namespace_prefix = name_space_prefix


                            class Ipv4BlbData(Entity):
                                """
                                BFD BLB label context
                                
                                .. attribute:: blb_intf
                                
                                	BFD BLB interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: prefix
                                
                                	IPv4 prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__init__()

                                    self.yang_name = "ipv4blb-data"
                                    self.yang_parent_name = "label-context"

                                    self.blb_intf = YLeaf(YType.str, "blb-intf")

                                    self.prefix = YLeaf(YType.str, "prefix")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("blb_intf",
                                                    "prefix") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.blb_intf.is_set or
                                        self.prefix.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.blb_intf.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4blb-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "blb-intf" or name == "prefix"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "blb-intf"):
                                        self.blb_intf = value
                                        self.blb_intf.value_namespace = name_space
                                        self.blb_intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix


                            class Ipv6BlbData(Entity):
                                """
                                BFD BLB label context
                                
                                .. attribute:: blb_intf
                                
                                	BFD BLB interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: prefix
                                
                                	IPv6 prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__init__()

                                    self.yang_name = "ipv6blb-data"
                                    self.yang_parent_name = "label-context"

                                    self.blb_intf = YLeaf(YType.str, "blb-intf")

                                    self.prefix = YLeaf(YType.str, "prefix")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("blb_intf",
                                                    "prefix") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.blb_intf.is_set or
                                        self.prefix.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.blb_intf.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6blb-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "blb-intf" or name == "prefix"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "blb-intf"):
                                        self.blb_intf = value
                                        self.blb_intf.value_namespace = name_space
                                        self.blb_intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix


                            class PiMiPmsiData(Entity):
                                """
                                PIM I\-PMSI label conext
                                
                                .. attribute:: head
                                
                                	Head
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: v6
                                
                                	PIM6
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: vrf_id
                                
                                	VRF ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__init__()

                                    self.yang_name = "pi-mi-pmsi-data"
                                    self.yang_parent_name = "label-context"

                                    self.head = YLeaf(YType.int32, "head")

                                    self.v6 = YLeaf(YType.int32, "v6")

                                    self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("head",
                                                    "v6",
                                                    "vrf_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.head.is_set or
                                        self.v6.is_set or
                                        self.vrf_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.head.yfilter != YFilter.not_set or
                                        self.v6.yfilter != YFilter.not_set or
                                        self.vrf_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pi-mi-pmsi-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.head.get_name_leafdata())
                                    if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.v6.get_name_leafdata())
                                    if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "head" or name == "v6" or name == "vrf-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "head"):
                                        self.head = value
                                        self.head.value_namespace = name_space
                                        self.head.value_namespace_prefix = name_space_prefix
                                    if(value_path == "v6"):
                                        self.v6 = value
                                        self.v6.value_namespace = name_space
                                        self.v6.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-id"):
                                        self.vrf_id = value
                                        self.vrf_id.value_namespace = name_space
                                        self.vrf_id.value_namespace_prefix = name_space_prefix


                            class PiMsPmsiData(Entity):
                                """
                                PIM S\-PMSI label conext
                                
                                .. attribute:: head
                                
                                	Head
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: hli
                                
                                	Head LSM\-ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: seg
                                
                                	Segmented Multicast
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: source
                                
                                	Originating Router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: v6
                                
                                	PIM6
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: vrf_id
                                
                                	VRF ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__init__()

                                    self.yang_name = "pi-ms-pmsi-data"
                                    self.yang_parent_name = "label-context"

                                    self.head = YLeaf(YType.int32, "head")

                                    self.hli = YLeaf(YType.uint32, "hli")

                                    self.seg = YLeaf(YType.int32, "seg")

                                    self.source = YLeaf(YType.str, "source")

                                    self.v6 = YLeaf(YType.int32, "v6")

                                    self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("head",
                                                    "hli",
                                                    "seg",
                                                    "source",
                                                    "v6",
                                                    "vrf_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.head.is_set or
                                        self.hli.is_set or
                                        self.seg.is_set or
                                        self.source.is_set or
                                        self.v6.is_set or
                                        self.vrf_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.head.yfilter != YFilter.not_set or
                                        self.hli.yfilter != YFilter.not_set or
                                        self.seg.yfilter != YFilter.not_set or
                                        self.source.yfilter != YFilter.not_set or
                                        self.v6.yfilter != YFilter.not_set or
                                        self.vrf_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pi-ms-pmsi-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.head.get_name_leafdata())
                                    if (self.hli.is_set or self.hli.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hli.get_name_leafdata())
                                    if (self.seg.is_set or self.seg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.seg.get_name_leafdata())
                                    if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source.get_name_leafdata())
                                    if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.v6.get_name_leafdata())
                                    if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "head" or name == "hli" or name == "seg" or name == "source" or name == "v6" or name == "vrf-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "head"):
                                        self.head = value
                                        self.head.value_namespace = name_space
                                        self.head.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hli"):
                                        self.hli = value
                                        self.hli.value_namespace = name_space
                                        self.hli.value_namespace_prefix = name_space_prefix
                                    if(value_path == "seg"):
                                        self.seg = value
                                        self.seg.value_namespace = name_space
                                        self.seg.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source"):
                                        self.source = value
                                        self.source.value_namespace = name_space
                                        self.source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "v6"):
                                        self.v6 = value
                                        self.v6.value_namespace = name_space
                                        self.v6.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-id"):
                                        self.vrf_id = value
                                        self.vrf_id.value_namespace = name_space
                                        self.vrf_id.value_namespace_prefix = name_space_prefix


                            class NextHopSetL3Vpn(Entity):
                                """
                                L3VPN NH SET label context
                                
                                .. attribute:: next_hop_set_id
                                
                                	Next Hop Set ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__init__()

                                    self.yang_name = "next-hop-set-l3vpn"
                                    self.yang_parent_name = "label-context"

                                    self.next_hop_set_id = YLeaf(YType.uint32, "next-hop-set-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_set_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.next_hop_set_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_set_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "next-hop-set-l3vpn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_set_id.is_set or self.next_hop_set_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_set_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "next-hop-set-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-set-id"):
                                        self.next_hop_set_id = value
                                        self.next_hop_set_id.value_namespace = name_space
                                        self.next_hop_set_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class SrPrefixSegment(Entity):
                                """
                                SR Prefix Segment context
                                
                                .. attribute:: segment_id
                                
                                	Prefix Segment ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__init__()

                                    self.yang_name = "sr-prefix-segment"
                                    self.yang_parent_name = "label-context"

                                    self.segment_id = YLeaf(YType.uint32, "segment-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("segment_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.segment_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.segment_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-prefix-segment" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.segment_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "segment-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "segment-id"):
                                        self.segment_id = value
                                        self.segment_id.value_namespace = name_space
                                        self.segment_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class SrAdjSegmentIpv4(Entity):
                                """
                                SR Adj Segment ipv4 context
                                
                                .. attribute:: addr
                                
                                	Adjacency nexthop IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: index
                                
                                	Adjacency index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: intf
                                
                                	Adjacency interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: type
                                
                                	Adjacency type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__init__()

                                    self.yang_name = "sr-adj-segment-ipv4"
                                    self.yang_parent_name = "label-context"

                                    self.addr = YLeaf(YType.str, "addr")

                                    self.index = YLeaf(YType.uint32, "index")

                                    self.intf = YLeaf(YType.str, "intf")

                                    self.type = YLeaf(YType.uint32, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("addr",
                                                    "index",
                                                    "intf",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.addr.is_set or
                                        self.index.is_set or
                                        self.intf.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.addr.yfilter != YFilter.not_set or
                                        self.index.yfilter != YFilter.not_set or
                                        self.intf.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-adj-segment-ipv4" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.addr.get_name_leafdata())
                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.index.get_name_leafdata())
                                    if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intf.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "addr"):
                                        self.addr = value
                                        self.addr.value_namespace = name_space
                                        self.addr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "index"):
                                        self.index = value
                                        self.index.value_namespace = name_space
                                        self.index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intf"):
                                        self.intf = value
                                        self.intf.value_namespace = name_space
                                        self.intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class SrAdjSegmentIpv6(Entity):
                                """
                                SR Adj Segment ipv6 context
                                
                                .. attribute:: addr
                                
                                	Adjacency nexthop IPv6 address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: index
                                
                                	Adjacency index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: intf
                                
                                	Adjacency interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: type
                                
                                	Adjacency type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__init__()

                                    self.yang_name = "sr-adj-segment-ipv6"
                                    self.yang_parent_name = "label-context"

                                    self.addr = YLeaf(YType.str, "addr")

                                    self.index = YLeaf(YType.uint32, "index")

                                    self.intf = YLeaf(YType.str, "intf")

                                    self.type = YLeaf(YType.uint32, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("addr",
                                                    "index",
                                                    "intf",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.addr.is_set or
                                        self.index.is_set or
                                        self.intf.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.addr.yfilter != YFilter.not_set or
                                        self.index.yfilter != YFilter.not_set or
                                        self.intf.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-adj-segment-ipv6" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.addr.get_name_leafdata())
                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.index.get_name_leafdata())
                                    if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intf.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "addr"):
                                        self.addr = value
                                        self.addr.value_namespace = name_space
                                        self.addr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "index"):
                                        self.index = value
                                        self.index.value_namespace = name_space
                                        self.index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intf"):
                                        self.intf = value
                                        self.intf.value_namespace = name_space
                                        self.intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class LabelBlockSrgbData(Entity):
                                """
                                Label block SRGB context
                                
                                .. attribute:: offset
                                
                                	Offset
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: size
                                
                                	Number of labels
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: start_label
                                
                                	Start Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__init__()

                                    self.yang_name = "label-block-srgb-data"
                                    self.yang_parent_name = "label-context"

                                    self.offset = YLeaf(YType.uint32, "offset")

                                    self.size = YLeaf(YType.uint32, "size")

                                    self.start_label = YLeaf(YType.uint32, "start-label")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("offset",
                                                    "size",
                                                    "start_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.offset.is_set or
                                        self.size.is_set or
                                        self.start_label.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.offset.yfilter != YFilter.not_set or
                                        self.size.yfilter != YFilter.not_set or
                                        self.start_label.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-block-srgb-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.offset.get_name_leafdata())
                                    if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.size.get_name_leafdata())
                                    if (self.start_label.is_set or self.start_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.start_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "offset" or name == "size" or name == "start-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "offset"):
                                        self.offset = value
                                        self.offset.value_namespace = name_space
                                        self.offset.value_namespace_prefix = name_space_prefix
                                    if(value_path == "size"):
                                        self.size = value
                                        self.size.value_namespace = name_space
                                        self.size.value_namespace_prefix = name_space_prefix
                                    if(value_path == "start-label"):
                                        self.start_label = value
                                        self.start_label.value_namespace = name_space
                                        self.start_label.value_namespace_prefix = name_space_prefix


                            class TeBinding(Entity):
                                """
                                MPLS TE tunnel binding context
                                
                                .. attribute:: te_identifier
                                
                                	MPLS Traffic Engineering Tunnel or Group ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: te_type
                                
                                	Type of identifier for the binding
                                	**type**\:   :py:class:`MgmtLsdTeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdTeBinding>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TeBinding, self).__init__()

                                    self.yang_name = "te-binding"
                                    self.yang_parent_name = "label-context"

                                    self.te_identifier = YLeaf(YType.uint32, "te-identifier")

                                    self.te_type = YLeaf(YType.enumeration, "te-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("te_identifier",
                                                    "te_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.te_identifier.is_set or
                                        self.te_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.te_identifier.yfilter != YFilter.not_set or
                                        self.te_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-binding" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.te_identifier.is_set or self.te_identifier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_identifier.get_name_leafdata())
                                    if (self.te_type.is_set or self.te_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "te-identifier" or name == "te-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "te-identifier"):
                                        self.te_identifier = value
                                        self.te_identifier.value_namespace = name_space
                                        self.te_identifier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "te-type"):
                                        self.te_type = value
                                        self.te_type.value_namespace = name_space
                                        self.te_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.label_context_type.is_set or
                                    (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_data()) or
                                    (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_data()) or
                                    (self.evpn_data is not None and self.evpn_data.has_data()) or
                                    (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_data()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv4blb_data is not None and self.ipv4blb_data.has_data()) or
                                    (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_data()) or
                                    (self.ipv6blb_data is not None and self.ipv6blb_data.has_data()) or
                                    (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_data()) or
                                    (self.label_block_data is not None and self.label_block_data.has_data()) or
                                    (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_data()) or
                                    (self.mld_pv4_data is not None and self.mld_pv4_data.has_data()) or
                                    (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_data()) or
                                    (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_data()) or
                                    (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_data()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                    (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_data()) or
                                    (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_data()) or
                                    (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_data()) or
                                    (self.te_binding is not None and self.te_binding.has_data()) or
                                    (self.tev4_data is not None and self.tev4_data.has_data()) or
                                    (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_data()) or
                                    (self.tp_data is not None and self.tp_data.has_data()) or
                                    (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_context_type.yfilter != YFilter.not_set or
                                    (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_operation()) or
                                    (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_operation()) or
                                    (self.evpn_data is not None and self.evpn_data.has_operation()) or
                                    (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_operation()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv4blb_data is not None and self.ipv4blb_data.has_operation()) or
                                    (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_operation()) or
                                    (self.ipv6blb_data is not None and self.ipv6blb_data.has_operation()) or
                                    (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_operation()) or
                                    (self.label_block_data is not None and self.label_block_data.has_operation()) or
                                    (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_operation()) or
                                    (self.mld_pv4_data is not None and self.mld_pv4_data.has_operation()) or
                                    (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_operation()) or
                                    (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_operation()) or
                                    (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_operation()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                    (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_operation()) or
                                    (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_operation()) or
                                    (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_operation()) or
                                    (self.te_binding is not None and self.te_binding.has_operation()) or
                                    (self.tev4_data is not None and self.tev4_data.has_operation()) or
                                    (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_operation()) or
                                    (self.tp_data is not None and self.tp_data.has_operation()) or
                                    (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-context" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_context_type.is_set or self.label_context_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_context_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "cev4l3vpn-data"):
                                    if (self.cev4l3vpn_data is None):
                                        self.cev4l3vpn_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                        self.cev4l3vpn_data.parent = self
                                        self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                    return self.cev4l3vpn_data

                                if (child_yang_name == "cev6l3vpn-data"):
                                    if (self.cev6l3vpn_data is None):
                                        self.cev6l3vpn_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                        self.cev6l3vpn_data.parent = self
                                        self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                    return self.cev6l3vpn_data

                                if (child_yang_name == "evpn-data"):
                                    if (self.evpn_data is None):
                                        self.evpn_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.EvpnData()
                                        self.evpn_data.parent = self
                                        self._children_name_map["evpn_data"] = "evpn-data"
                                    return self.evpn_data

                                if (child_yang_name == "generic-routing-encapsulation"):
                                    if (self.generic_routing_encapsulation is None):
                                        self.generic_routing_encapsulation = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                        self.generic_routing_encapsulation.parent = self
                                        self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                    return self.generic_routing_encapsulation

                                if (child_yang_name == "ip-sub-data"):
                                    if (self.ip_sub_data is None):
                                        self.ip_sub_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.IpSubData()
                                        self.ip_sub_data.parent = self
                                        self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    return self.ip_sub_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv4blb-data"):
                                    if (self.ipv4blb_data is None):
                                        self.ipv4blb_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                        self.ipv4blb_data.parent = self
                                        self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                    return self.ipv4blb_data

                                if (child_yang_name == "ipv4l3vpn-data"):
                                    if (self.ipv4l3vpn_data is None):
                                        self.ipv4l3vpn_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                        self.ipv4l3vpn_data.parent = self
                                        self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                    return self.ipv4l3vpn_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "ipv6-generic-routing-encapsulation"):
                                    if (self.ipv6_generic_routing_encapsulation is None):
                                        self.ipv6_generic_routing_encapsulation = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                        self.ipv6_generic_routing_encapsulation.parent = self
                                        self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                    return self.ipv6_generic_routing_encapsulation

                                if (child_yang_name == "ipv6blb-data"):
                                    if (self.ipv6blb_data is None):
                                        self.ipv6blb_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                        self.ipv6blb_data.parent = self
                                        self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                    return self.ipv6blb_data

                                if (child_yang_name == "ipv6l3vpn-data"):
                                    if (self.ipv6l3vpn_data is None):
                                        self.ipv6l3vpn_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                        self.ipv6l3vpn_data.parent = self
                                        self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                    return self.ipv6l3vpn_data

                                if (child_yang_name == "label-block-data"):
                                    if (self.label_block_data is None):
                                        self.label_block_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                        self.label_block_data.parent = self
                                        self._children_name_map["label_block_data"] = "label-block-data"
                                    return self.label_block_data

                                if (child_yang_name == "label-block-srgb-data"):
                                    if (self.label_block_srgb_data is None):
                                        self.label_block_srgb_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                        self.label_block_srgb_data.parent = self
                                        self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                    return self.label_block_srgb_data

                                if (child_yang_name == "mld-pv4-data"):
                                    if (self.mld_pv4_data is None):
                                        self.mld_pv4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                        self.mld_pv4_data.parent = self
                                        self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                    return self.mld_pv4_data

                                if (child_yang_name == "next-hop-set-l3vpn"):
                                    if (self.next_hop_set_l3vpn is None):
                                        self.next_hop_set_l3vpn = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                        self.next_hop_set_l3vpn.parent = self
                                        self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                    return self.next_hop_set_l3vpn

                                if (child_yang_name == "pi-mi-pmsi-data"):
                                    if (self.pi_mi_pmsi_data is None):
                                        self.pi_mi_pmsi_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                        self.pi_mi_pmsi_data.parent = self
                                        self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                    return self.pi_mi_pmsi_data

                                if (child_yang_name == "pi-ms-pmsi-data"):
                                    if (self.pi_ms_pmsi_data is None):
                                        self.pi_ms_pmsi_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                        self.pi_ms_pmsi_data.parent = self
                                        self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                    return self.pi_ms_pmsi_data

                                if (child_yang_name == "pseudowire-data"):
                                    if (self.pseudowire_data is None):
                                        self.pseudowire_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireData()
                                        self.pseudowire_data.parent = self
                                        self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    return self.pseudowire_data

                                if (child_yang_name == "pseudowire-head-end-data"):
                                    if (self.pseudowire_head_end_data is None):
                                        self.pseudowire_head_end_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                        self.pseudowire_head_end_data.parent = self
                                        self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    return self.pseudowire_head_end_data

                                if (child_yang_name == "sr-adj-segment-ipv4"):
                                    if (self.sr_adj_segment_ipv4 is None):
                                        self.sr_adj_segment_ipv4 = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                        self.sr_adj_segment_ipv4.parent = self
                                        self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                    return self.sr_adj_segment_ipv4

                                if (child_yang_name == "sr-adj-segment-ipv6"):
                                    if (self.sr_adj_segment_ipv6 is None):
                                        self.sr_adj_segment_ipv6 = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                        self.sr_adj_segment_ipv6.parent = self
                                        self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                    return self.sr_adj_segment_ipv6

                                if (child_yang_name == "sr-prefix-segment"):
                                    if (self.sr_prefix_segment is None):
                                        self.sr_prefix_segment = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                        self.sr_prefix_segment.parent = self
                                        self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                    return self.sr_prefix_segment

                                if (child_yang_name == "te-binding"):
                                    if (self.te_binding is None):
                                        self.te_binding = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TeBinding()
                                        self.te_binding.parent = self
                                        self._children_name_map["te_binding"] = "te-binding"
                                    return self.te_binding

                                if (child_yang_name == "tev4-data"):
                                    if (self.tev4_data is None):
                                        self.tev4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4Data()
                                        self.tev4_data.parent = self
                                        self._children_name_map["tev4_data"] = "tev4-data"
                                    return self.tev4_data

                                if (child_yang_name == "tev4p2mp-data"):
                                    if (self.tev4p2mp_data is None):
                                        self.tev4p2mp_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                        self.tev4p2mp_data.parent = self
                                        self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                    return self.tev4p2mp_data

                                if (child_yang_name == "tp-data"):
                                    if (self.tp_data is None):
                                        self.tp_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.TpData()
                                        self.tp_data.parent = self
                                        self._children_name_map["tp_data"] = "tp-data"
                                    return self.tp_data

                                if (child_yang_name == "vrf-l3vpn-data"):
                                    if (self.vrf_l3vpn_data is None):
                                        self.vrf_l3vpn_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                        self.vrf_l3vpn_data.parent = self
                                        self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                    return self.vrf_l3vpn_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "cev4l3vpn-data" or name == "cev6l3vpn-data" or name == "evpn-data" or name == "generic-routing-encapsulation" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv4blb-data" or name == "ipv4l3vpn-data" or name == "ipv6-data" or name == "ipv6-generic-routing-encapsulation" or name == "ipv6blb-data" or name == "ipv6l3vpn-data" or name == "label-block-data" or name == "label-block-srgb-data" or name == "mld-pv4-data" or name == "next-hop-set-l3vpn" or name == "pi-mi-pmsi-data" or name == "pi-ms-pmsi-data" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "sr-adj-segment-ipv4" or name == "sr-adj-segment-ipv6" or name == "sr-prefix-segment" or name == "te-binding" or name == "tev4-data" or name == "tev4p2mp-data" or name == "tp-data" or name == "vrf-l3vpn-data" or name == "label-context-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-context-type"):
                                    self.label_context_type = value
                                    self.label_context_type.value_namespace = name_space
                                    self.label_context_type.value_namespace_prefix = name_space_prefix


                        class LocalLabelRewrite(Entity):
                            """
                            Local label rewrite information
                            
                            .. attribute:: label_data
                            
                            	label data
                            	**type**\:  list of int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LocalLabelRewrite, self).__init__()

                                self.yang_name = "local-label-rewrite"
                                self.yang_parent_name = "rewrite-id"

                                self.label_data = YLeafList(YType.uint32, "label-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_data") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)

                            def has_data(self):
                                for leaf in self.label_data.getYLeafs():
                                    if (leaf.yfilter != YFilter.not_set):
                                        return True
                                return False

                            def has_operation(self):
                                for leaf in self.label_data.getYLeafs():
                                    if (leaf.is_set):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_data.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "local-label-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                leaf_name_data.extend(self.label_data.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "label-data"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-data"):
                                    self.label_data.append(value)

                        def has_data(self):
                            return (
                                self.rewrite_id_type.is_set or
                                (self.label_context is not None and self.label_context.has_data()) or
                                (self.local_label_rewrite is not None and self.local_label_rewrite.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.rewrite_id_type.yfilter != YFilter.not_set or
                                (self.label_context is not None and self.label_context.has_operation()) or
                                (self.local_label_rewrite is not None and self.local_label_rewrite.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rewrite-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.rewrite_id_type.is_set or self.rewrite_id_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rewrite_id_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "label-context"):
                                if (self.label_context is None):
                                    self.label_context = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LabelContext()
                                    self.label_context.parent = self
                                    self._children_name_map["label_context"] = "label-context"
                                return self.label_context

                            if (child_yang_name == "local-label-rewrite"):
                                if (self.local_label_rewrite is None):
                                    self.local_label_rewrite = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId.LocalLabelRewrite()
                                    self.local_label_rewrite.parent = self
                                    self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                                return self.local_label_rewrite

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "label-context" or name == "local-label-rewrite" or name == "rewrite-id-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "rewrite-id-type"):
                                self.rewrite_id_type = value
                                self.rewrite_id_type.value_namespace = name_space
                                self.rewrite_id_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (self.rewrite_id is not None and self.rewrite_id.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rewrite-id" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "rewrite-id"):
                            if (self.rewrite_id is None):
                                self.rewrite_id = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId.RewriteId()
                                self.rewrite_id.parent = self
                                self._children_name_map["rewrite_id"] = "rewrite-id"
                            return self.rewrite_id

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "rewrite-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class AssociatedFpi(Entity):
                    """
                    Associated FPI
                    
                    .. attribute:: application_owner
                    
                    	Application owner instance
                    	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.ApplicationOwner>`
                    
                    .. attribute:: fpi
                    
                    	FPI
                    	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi, self).__init__()

                        self.yang_name = "associated-fpi"
                        self.yang_parent_name = "rewrite-te"

                        self.fpi = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi()
                        self.fpi.parent = self
                        self._children_name_map["fpi"] = "fpi"
                        self._children_yang_names.add("fpi")

                        self.application_owner = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi, self).__setattr__(name, value)


                    class Fpi(Entity):
                        """
                        FPI
                        
                        .. attribute:: dmtc_ext_intf_data
                        
                        	dmtc ext intf data
                        	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.DmtcExtIntfData>`
                        
                        .. attribute:: fpi_type
                        
                        	FPIType
                        	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                        
                        .. attribute:: ipv4_data
                        
                        	ipv4 data
                        	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv4Data>`
                        
                        .. attribute:: ipv6_data
                        
                        	ipv6 data
                        	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv6Data>`
                        
                        .. attribute:: label_data
                        
                        	label data
                        	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.LabelData>`
                        
                        .. attribute:: pw_list_data
                        
                        	pw list data
                        	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.PwListData>`
                        
                        .. attribute:: te_data
                        
                        	te data
                        	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.TeData>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi, self).__init__()

                            self.yang_name = "fpi"
                            self.yang_parent_name = "associated-fpi"

                            self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                            self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.DmtcExtIntfData()
                            self.dmtc_ext_intf_data.parent = self
                            self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                            self._children_yang_names.add("dmtc-ext-intf-data")

                            self.ipv4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv4Data()
                            self.ipv4_data.parent = self
                            self._children_name_map["ipv4_data"] = "ipv4-data"
                            self._children_yang_names.add("ipv4-data")

                            self.ipv6_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv6Data()
                            self.ipv6_data.parent = self
                            self._children_name_map["ipv6_data"] = "ipv6-data"
                            self._children_yang_names.add("ipv6-data")

                            self.label_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.LabelData()
                            self.label_data.parent = self
                            self._children_name_map["label_data"] = "label-data"
                            self._children_yang_names.add("label-data")

                            self.pw_list_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.PwListData()
                            self.pw_list_data.parent = self
                            self._children_name_map["pw_list_data"] = "pw-list-data"
                            self._children_yang_names.add("pw-list-data")

                            self.te_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.TeData()
                            self.te_data.parent = self
                            self._children_name_map["te_data"] = "te-data"
                            self._children_yang_names.add("te-data")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fpi_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi, self).__setattr__(name, value)


                        class LabelData(Entity):
                            """
                            label data
                            
                            .. attribute:: elc
                            
                            	ELC
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: label
                            
                            	Label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.LabelData, self).__init__()

                                self.yang_name = "label-data"
                                self.yang_parent_name = "fpi"

                                self.elc = YLeaf(YType.int32, "elc")

                                self.label = YLeaf(YType.uint32, "label")

                                self.security_id = YLeaf(YType.uint32, "security-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("elc",
                                                "label",
                                                "security_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.elc.is_set or
                                    self.label.is_set or
                                    self.security_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.elc.yfilter != YFilter.not_set or
                                    self.label.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.elc.get_name_leafdata())
                                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label.get_name_leafdata())
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "elc" or name == "label" or name == "security-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "elc"):
                                    self.elc = value
                                    self.elc.value_namespace = name_space
                                    self.elc.value_namespace_prefix = name_space_prefix
                                if(value_path == "label"):
                                    self.label = value
                                    self.label.value_namespace = name_space
                                    self.label.value_namespace_prefix = name_space_prefix
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix


                        class TeData(Entity):
                            """
                            te data
                            
                            .. attribute:: local_label
                            
                            	Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_interface
                            
                            	Tunnel interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.TeData, self).__init__()

                                self.yang_name = "te-data"
                                self.yang_parent_name = "fpi"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label",
                                                "tunnel_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.local_label.is_set or
                                    self.tunnel_interface.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.tunnel_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label" or name == "tunnel-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface"):
                                    self.tunnel_interface = value
                                    self.tunnel_interface.value_namespace = name_space
                                    self.tunnel_interface.value_namespace_prefix = name_space_prefix


                        class Ipv4Data(Entity):
                            """
                            ipv4 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: sr_local_label
                            
                            	SR related Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv4Data, self).__init__()

                                self.yang_name = "ipv4-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "sr_local_label",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.sr_local_label.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.sr_local_label.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "sr-local-label"):
                                    self.sr_local_label = value
                                    self.sr_local_label.value_namespace = name_space
                                    self.sr_local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class Ipv6Data(Entity):
                            """
                            ipv6 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_len
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: router_flags
                            
                            	Route flags
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv6Data, self).__init__()

                                self.yang_name = "ipv6-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                self.router_flags = YLeaf(YType.uint32, "router-flags")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_len",
                                                "router_flags",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_len.is_set or
                                    self.router_flags.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_len.yfilter != YFilter.not_set or
                                    self.router_flags.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv6-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.router_flags.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-len"):
                                    self.prefix_len = value
                                    self.prefix_len.value_namespace = name_space
                                    self.prefix_len.value_namespace_prefix = name_space_prefix
                                if(value_path == "router-flags"):
                                    self.router_flags = value
                                    self.router_flags.value_namespace = name_space
                                    self.router_flags.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class PwListData(Entity):
                            """
                            pw list data
                            
                            .. attribute:: pwhe_list_id
                            
                            	Pseudowire List Identifier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.PwListData, self).__init__()

                                self.yang_name = "pw-list-data"
                                self.yang_parent_name = "fpi"

                                self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("pwhe_list_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.pwhe_list_id.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.pwhe_list_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pw-list-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "pwhe-list-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "pwhe-list-id"):
                                    self.pwhe_list_id = value
                                    self.pwhe_list_id.value_namespace = name_space
                                    self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                        class DmtcExtIntfData(Entity):
                            """
                            dmtc ext intf data
                            
                            .. attribute:: dmtc_ext_ifh
                            
                            	DMTC External Interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.DmtcExtIntfData, self).__init__()

                                self.yang_name = "dmtc-ext-intf-data"
                                self.yang_parent_name = "fpi"

                                self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.dmtc_ext_ifh.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "dmtc-ext-intf-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-ifh"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "dmtc-ext-ifh"):
                                    self.dmtc_ext_ifh = value
                                    self.dmtc_ext_ifh.value_namespace = name_space
                                    self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fpi_type.is_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                (self.label_data is not None and self.label_data.has_data()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                (self.te_data is not None and self.te_data.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fpi_type.yfilter != YFilter.not_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                (self.label_data is not None and self.label_data.has_operation()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                (self.te_data is not None and self.te_data.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fpi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fpi_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "dmtc-ext-intf-data"):
                                if (self.dmtc_ext_intf_data is None):
                                    self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.DmtcExtIntfData()
                                    self.dmtc_ext_intf_data.parent = self
                                    self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                return self.dmtc_ext_intf_data

                            if (child_yang_name == "ipv4-data"):
                                if (self.ipv4_data is None):
                                    self.ipv4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                return self.ipv4_data

                            if (child_yang_name == "ipv6-data"):
                                if (self.ipv6_data is None):
                                    self.ipv6_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                return self.ipv6_data

                            if (child_yang_name == "label-data"):
                                if (self.label_data is None):
                                    self.label_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.LabelData()
                                    self.label_data.parent = self
                                    self._children_name_map["label_data"] = "label-data"
                                return self.label_data

                            if (child_yang_name == "pw-list-data"):
                                if (self.pw_list_data is None):
                                    self.pw_list_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.PwListData()
                                    self.pw_list_data.parent = self
                                    self._children_name_map["pw_list_data"] = "pw-list-data"
                                return self.pw_list_data

                            if (child_yang_name == "te-data"):
                                if (self.te_data is None):
                                    self.te_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi.TeData()
                                    self.te_data.parent = self
                                    self._children_name_map["te_data"] = "te-data"
                                return self.te_data

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fpi-type"):
                                self.fpi_type = value
                                self.fpi_type.value_namespace = name_space
                                self.fpi_type.value_namespace_prefix = name_space_prefix


                    class ApplicationOwner(Entity):
                        """
                        Application owner instance
                        
                        .. attribute:: application_instance
                        
                        	Application instance Name
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        .. attribute:: resource_state
                        
                        	Application resource state
                        	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.ApplicationOwner, self).__init__()

                            self.yang_name = "application-owner"
                            self.yang_parent_name = "associated-fpi"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                            self.resource_state = YLeaf(YType.enumeration, "resource-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type",
                                            "resource_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set or
                                self.resource_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set or
                                self.resource_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application-owner" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())
                            if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resource_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "resource-state"):
                                self.resource_state = value
                                self.resource_state.value_namespace = name_space
                                self.resource_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.application_owner:
                            if (c.has_data()):
                                return True
                        return (self.fpi is not None and self.fpi.has_data())

                    def has_operation(self):
                        for c in self.application_owner:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.fpi is not None and self.fpi.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "associated-fpi" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application-owner"):
                            for c in self.application_owner:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.ApplicationOwner()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.application_owner.append(c)
                            return c

                        if (child_yang_name == "fpi"):
                            if (self.fpi is None):
                                self.fpi = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi.Fpi()
                                self.fpi.parent = self
                                self._children_name_map["fpi"] = "fpi"
                            return self.fpi

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-owner" or name == "fpi"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class V4Rpf(Entity):
                    """
                    IPv4 RPF neighbors
                    
                    .. attribute:: table_id
                    
                    	Table ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: v4_rpf_neighbor
                    
                    	V4 RPF Neighbor
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.V4Rpf, self).__init__()

                        self.yang_name = "v4-rpf"
                        self.yang_parent_name = "rewrite-te"

                        self.table_id = YLeaf(YType.uint32, "table-id")

                        self.v4_rpf_neighbor = YLeaf(YType.str, "v4-rpf-neighbor")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("table_id",
                                        "v4_rpf_neighbor") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.V4Rpf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.V4Rpf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.table_id.is_set or
                            self.v4_rpf_neighbor.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.table_id.yfilter != YFilter.not_set or
                            self.v4_rpf_neighbor.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "v4-rpf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.table_id.get_name_leafdata())
                        if (self.v4_rpf_neighbor.is_set or self.v4_rpf_neighbor.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.v4_rpf_neighbor.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "table-id" or name == "v4-rpf-neighbor"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "table-id"):
                            self.table_id = value
                            self.table_id.value_namespace = name_space
                            self.table_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "v4-rpf-neighbor"):
                            self.v4_rpf_neighbor = value
                            self.v4_rpf_neighbor.value_namespace = name_space
                            self.v4_rpf_neighbor.value_namespace_prefix = name_space_prefix


                class V6Rpf(Entity):
                    """
                    IPv6 RPF neighbors
                    
                    .. attribute:: table_id
                    
                    	Table ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: v6_rpf_neighbor
                    
                    	V6 RPF Neighbor
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.V6Rpf, self).__init__()

                        self.yang_name = "v6-rpf"
                        self.yang_parent_name = "rewrite-te"

                        self.table_id = YLeaf(YType.uint32, "table-id")

                        self.v6_rpf_neighbor = YLeaf(YType.str, "v6-rpf-neighbor")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("table_id",
                                        "v6_rpf_neighbor") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.V6Rpf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.V6Rpf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.table_id.is_set or
                            self.v6_rpf_neighbor.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.table_id.yfilter != YFilter.not_set or
                            self.v6_rpf_neighbor.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "v6-rpf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.table_id.get_name_leafdata())
                        if (self.v6_rpf_neighbor.is_set or self.v6_rpf_neighbor.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.v6_rpf_neighbor.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "table-id" or name == "v6-rpf-neighbor"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "table-id"):
                            self.table_id = value
                            self.table_id.value_namespace = name_space
                            self.table_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "v6-rpf-neighbor"):
                            self.v6_rpf_neighbor = value
                            self.v6_rpf_neighbor.value_namespace = name_space
                            self.v6_rpf_neighbor.value_namespace_prefix = name_space_prefix


                class Mois(Entity):
                    """
                    Mois
                    
                    .. attribute:: application_resource
                    
                    	Application state
                    	**type**\:   :py:class:`ApplicationResource <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.ApplicationResource>`
                    
                    .. attribute:: moi_array
                    
                    	moi array
                    	**type**\: list of    :py:class:`MoiArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois, self).__init__()

                        self.yang_name = "mois"
                        self.yang_parent_name = "rewrite-te"

                        self.application_resource = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.ApplicationResource()
                        self.application_resource.parent = self
                        self._children_name_map["application_resource"] = "application-resource"
                        self._children_yang_names.add("application-resource")

                        self.moi_array = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois, self).__setattr__(name, value)


                    class ApplicationResource(Entity):
                        """
                        Application state
                        
                        .. attribute:: application_instance
                        
                        	Application instance Name
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        .. attribute:: resource_state
                        
                        	Application resource state
                        	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.ApplicationResource, self).__init__()

                            self.yang_name = "application-resource"
                            self.yang_parent_name = "mois"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                            self.resource_state = YLeaf(YType.enumeration, "resource-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type",
                                            "resource_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.ApplicationResource, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.ApplicationResource, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set or
                                self.resource_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set or
                                self.resource_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application-resource" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())
                            if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resource_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "resource-state"):
                                self.resource_state = value
                                self.resource_state.value_namespace = name_space
                                self.resource_state.value_namespace_prefix = name_space_prefix


                    class MoiArray(Entity):
                        """
                        moi array
                        
                        .. attribute:: moi
                        
                        	Moi
                        	**type**\:   :py:class:`Moi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray, self).__init__()

                            self.yang_name = "moi-array"
                            self.yang_parent_name = "mois"

                            self.moi = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi()
                            self.moi.parent = self
                            self._children_name_map["moi"] = "moi"
                            self._children_yang_names.add("moi")


                        class Moi(Entity):
                            """
                            Moi
                            
                            .. attribute:: dmtc_data
                            
                            	dmtc data
                            	**type**\:   :py:class:`DmtcData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.DmtcData>`
                            
                            .. attribute:: ip_sub_data
                            
                            	ip sub data
                            	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.IpSubData>`
                            
                            .. attribute:: ipv4_data
                            
                            	ipv4 data
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv4Data>`
                            
                            .. attribute:: ipv6_data
                            
                            	ipv6 data
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv6Data>`
                            
                            .. attribute:: moi_type
                            
                            	MoiType
                            	**type**\:   :py:class:`MgmtLsdMoi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdMoi>`
                            
                            .. attribute:: pop_and_lookup_ipv4
                            
                            	pop and lookup ipv4
                            	**type**\:   :py:class:`PopAndLookupIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv4>`
                            
                            .. attribute:: pop_and_lookup_ipv6
                            
                            	pop and lookup ipv6
                            	**type**\:   :py:class:`PopAndLookupIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv6>`
                            
                            .. attribute:: pop_and_lookup_tp
                            
                            	pop and lookup tp
                            	**type**\:   :py:class:`PopAndLookupTp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupTp>`
                            
                            .. attribute:: pseudowire_data
                            
                            	pseudowire data
                            	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireData>`
                            
                            .. attribute:: pseudowire_head_end_data
                            
                            	pseudowire head end data
                            	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireHeadEndData>`
                            
                            .. attribute:: pw_list_data
                            
                            	pw list data
                            	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PwListData>`
                            
                            .. attribute:: stackv4_data
                            
                            	stackv4 data
                            	**type**\:   :py:class:`Stackv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data>`
                            
                            .. attribute:: stackv6_data
                            
                            	stackv6 data
                            	**type**\:   :py:class:`Stackv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data>`
                            
                            .. attribute:: te_head_data
                            
                            	te head data
                            	**type**\:   :py:class:`TeHeadData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.TeHeadData>`
                            
                            .. attribute:: tev4_data
                            
                            	tev4 data
                            	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Tev4Data>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi, self).__init__()

                                self.yang_name = "moi"
                                self.yang_parent_name = "moi-array"

                                self.moi_type = YLeaf(YType.enumeration, "moi-type")

                                self.dmtc_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.DmtcData()
                                self.dmtc_data.parent = self
                                self._children_name_map["dmtc_data"] = "dmtc-data"
                                self._children_yang_names.add("dmtc-data")

                                self.ip_sub_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.IpSubData()
                                self.ip_sub_data.parent = self
                                self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                self._children_yang_names.add("ip-sub-data")

                                self.ipv4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv6_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.pop_and_lookup_ipv4 = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                self.pop_and_lookup_ipv4.parent = self
                                self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                self._children_yang_names.add("pop-and-lookup-ipv4")

                                self.pop_and_lookup_ipv6 = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                self.pop_and_lookup_ipv6.parent = self
                                self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                self._children_yang_names.add("pop-and-lookup-ipv6")

                                self.pop_and_lookup_tp = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupTp()
                                self.pop_and_lookup_tp.parent = self
                                self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                self._children_yang_names.add("pop-and-lookup-tp")

                                self.pseudowire_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireData()
                                self.pseudowire_data.parent = self
                                self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                self._children_yang_names.add("pseudowire-data")

                                self.pseudowire_head_end_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                self.pseudowire_head_end_data.parent = self
                                self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                self._children_yang_names.add("pseudowire-head-end-data")

                                self.pw_list_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PwListData()
                                self.pw_list_data.parent = self
                                self._children_name_map["pw_list_data"] = "pw-list-data"
                                self._children_yang_names.add("pw-list-data")

                                self.stackv4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data()
                                self.stackv4_data.parent = self
                                self._children_name_map["stackv4_data"] = "stackv4-data"
                                self._children_yang_names.add("stackv4-data")

                                self.stackv6_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data()
                                self.stackv6_data.parent = self
                                self._children_name_map["stackv6_data"] = "stackv6-data"
                                self._children_yang_names.add("stackv6-data")

                                self.te_head_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.TeHeadData()
                                self.te_head_data.parent = self
                                self._children_name_map["te_head_data"] = "te-head-data"
                                self._children_yang_names.add("te-head-data")

                                self.tev4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Tev4Data()
                                self.tev4_data.parent = self
                                self._children_name_map["tev4_data"] = "tev4-data"
                                self._children_yang_names.add("tev4-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("moi_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi, self).__setattr__(name, value)


                            class PopAndLookupIpv4(Entity):
                                """
                                pop and lookup ipv4
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__init__()

                                    self.yang_name = "pop-and-lookup-ipv4"
                                    self.yang_parent_name = "moi"

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pop-and-lookup-ipv4" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class PopAndLookupTp(Entity):
                                """
                                pop and lookup tp
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupTp, self).__init__()

                                    self.yang_name = "pop-and-lookup-tp"
                                    self.yang_parent_name = "moi"

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("out_label",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.out_label.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pop-and-lookup-tp" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "out-label" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class PopAndLookupIpv6(Entity):
                                """
                                pop and lookup ipv6
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__init__()

                                    self.yang_name = "pop-and-lookup-ipv6"
                                    self.yang_parent_name = "moi"

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pop-and-lookup-ipv6" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class Ipv4Data(Entity):
                                """
                                ipv4 data
                                
                                .. attribute:: backup_path_id
                                
                                	Routing path backup id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: load_metric
                                
                                	Routing path's load metric
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: local_label
                                
                                	TE backup path local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: next_hop_id
                                
                                	Next hop ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_interface
                                
                                	Outgoing Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_interface_parent
                                
                                	Outgoing Interface's parent
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_label_name
                                
                                	Outgoing label name
                                	**type**\:  str
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: path_id
                                
                                	Routing path id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "moi"

                                    self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.load_metric = YLeaf(YType.uint32, "load-metric")

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.out_label_name = YLeaf(YType.str, "out-label-name")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.path_id = YLeaf(YType.uint8, "path-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_path_id",
                                                    "ipv4_next_hop",
                                                    "load_metric",
                                                    "local_label",
                                                    "next_hop_id",
                                                    "out_interface",
                                                    "out_interface_parent",
                                                    "out_label",
                                                    "out_label_name",
                                                    "path_flags_decode",
                                                    "path_id",
                                                    "table_id",
                                                    "table_name",
                                                    "tunnel_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_path_id.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.load_metric.is_set or
                                        self.local_label.is_set or
                                        self.next_hop_id.is_set or
                                        self.out_interface.is_set or
                                        self.out_interface_parent.is_set or
                                        self.out_label.is_set or
                                        self.out_label_name.is_set or
                                        self.path_flags_decode.is_set or
                                        self.path_id.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.tunnel_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_path_id.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.load_metric.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.next_hop_id.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_interface_parent.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.out_label_name.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.path_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.tunnel_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.load_metric.get_name_leafdata())
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-path-id"):
                                        self.backup_path_id = value
                                        self.backup_path_id.value_namespace = name_space
                                        self.backup_path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "load-metric"):
                                        self.load_metric = value
                                        self.load_metric.value_namespace = name_space
                                        self.load_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "next-hop-id"):
                                        self.next_hop_id = value
                                        self.next_hop_id.value_namespace = name_space
                                        self.next_hop_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface-parent"):
                                        self.out_interface_parent = value
                                        self.out_interface_parent.value_namespace = name_space
                                        self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label-name"):
                                        self.out_label_name = value
                                        self.out_label_name.value_namespace = name_space
                                        self.out_label_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-id"):
                                        self.path_id = value
                                        self.path_id.value_namespace = name_space
                                        self.path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id"):
                                        self.tunnel_id = value
                                        self.tunnel_id.value_namespace = name_space
                                        self.tunnel_id.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                ipv6 data
                                
                                .. attribute:: backup_path_id
                                
                                	Routing path backup id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv6_next_hop
                                
                                	IPv6 nexthop
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: next_hop_id
                                
                                	Next hop ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_label_name
                                
                                	Outgoing label name
                                	**type**\:  str
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: path_id
                                
                                	Routing path id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "moi"

                                    self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                    self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                    self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.out_label_name = YLeaf(YType.str, "out-label-name")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.path_id = YLeaf(YType.uint8, "path-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_path_id",
                                                    "ipv6_next_hop",
                                                    "next_hop_id",
                                                    "out_interface",
                                                    "out_label",
                                                    "out_label_name",
                                                    "path_flags_decode",
                                                    "path_id",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_path_id.is_set or
                                        self.ipv6_next_hop.is_set or
                                        self.next_hop_id.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.out_label_name.is_set or
                                        self.path_flags_decode.is_set or
                                        self.path_id.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_path_id.yfilter != YFilter.not_set or
                                        self.ipv6_next_hop.yfilter != YFilter.not_set or
                                        self.next_hop_id.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.out_label_name.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.path_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                    if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                    if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-path-id"):
                                        self.backup_path_id = value
                                        self.backup_path_id.value_namespace = name_space
                                        self.backup_path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6-next-hop"):
                                        self.ipv6_next_hop = value
                                        self.ipv6_next_hop.value_namespace = name_space
                                        self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "next-hop-id"):
                                        self.next_hop_id = value
                                        self.next_hop_id.value_namespace = name_space
                                        self.next_hop_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label-name"):
                                        self.out_label_name = value
                                        self.out_label_name.value_namespace = name_space
                                        self.out_label_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-id"):
                                        self.path_id = value
                                        self.path_id.value_namespace = name_space
                                        self.path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class Tev4Data(Entity):
                                """
                                tev4 data
                                
                                .. attribute:: backup_interface
                                
                                	Backup interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: backup_ipv4_next_hop
                                
                                	Backup IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: backup_local_label
                                
                                	Backup local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: data_out_parent_interface
                                
                                	Outgoing data parent interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: merge_point_label
                                
                                	Merge point label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_label_name
                                
                                	Outgoing label name
                                	**type**\:  str
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_class
                                
                                	Tunnel class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_interface
                                
                                	Tunnel interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: tunnel_weight
                                
                                	Tunnel weight
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Tev4Data, self).__init__()

                                    self.yang_name = "tev4-data"
                                    self.yang_parent_name = "moi"

                                    self.backup_interface = YLeaf(YType.str, "backup-interface")

                                    self.backup_ipv4_next_hop = YLeaf(YType.str, "backup-ipv4-next-hop")

                                    self.backup_local_label = YLeaf(YType.uint32, "backup-local-label")

                                    self.data_out_parent_interface = YLeaf(YType.str, "data-out-parent-interface")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.merge_point_label = YLeaf(YType.uint32, "merge-point-label")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.out_label_name = YLeaf(YType.str, "out-label-name")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.tunnel_class = YLeaf(YType.uint32, "tunnel-class")

                                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                    self.tunnel_weight = YLeaf(YType.uint32, "tunnel-weight")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_interface",
                                                    "backup_ipv4_next_hop",
                                                    "backup_local_label",
                                                    "data_out_parent_interface",
                                                    "ipv4_next_hop",
                                                    "merge_point_label",
                                                    "out_interface",
                                                    "out_label",
                                                    "out_label_name",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name",
                                                    "tunnel_class",
                                                    "tunnel_interface",
                                                    "tunnel_weight") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_interface.is_set or
                                        self.backup_ipv4_next_hop.is_set or
                                        self.backup_local_label.is_set or
                                        self.data_out_parent_interface.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.merge_point_label.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.out_label_name.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.tunnel_class.is_set or
                                        self.tunnel_interface.is_set or
                                        self.tunnel_weight.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_interface.yfilter != YFilter.not_set or
                                        self.backup_ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.backup_local_label.yfilter != YFilter.not_set or
                                        self.data_out_parent_interface.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.merge_point_label.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.out_label_name.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.tunnel_class.yfilter != YFilter.not_set or
                                        self.tunnel_interface.yfilter != YFilter.not_set or
                                        self.tunnel_weight.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tev4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_interface.is_set or self.backup_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_interface.get_name_leafdata())
                                    if (self.backup_ipv4_next_hop.is_set or self.backup_ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_ipv4_next_hop.get_name_leafdata())
                                    if (self.backup_local_label.is_set or self.backup_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_local_label.get_name_leafdata())
                                    if (self.data_out_parent_interface.is_set or self.data_out_parent_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.data_out_parent_interface.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.merge_point_label.is_set or self.merge_point_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.merge_point_label.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.tunnel_class.is_set or self.tunnel_class.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_class.get_name_leafdata())
                                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())
                                    if (self.tunnel_weight.is_set or self.tunnel_weight.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_weight.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-interface" or name == "backup-ipv4-next-hop" or name == "backup-local-label" or name == "data-out-parent-interface" or name == "ipv4-next-hop" or name == "merge-point-label" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-class" or name == "tunnel-interface" or name == "tunnel-weight"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-interface"):
                                        self.backup_interface = value
                                        self.backup_interface.value_namespace = name_space
                                        self.backup_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-ipv4-next-hop"):
                                        self.backup_ipv4_next_hop = value
                                        self.backup_ipv4_next_hop.value_namespace = name_space
                                        self.backup_ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-local-label"):
                                        self.backup_local_label = value
                                        self.backup_local_label.value_namespace = name_space
                                        self.backup_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "data-out-parent-interface"):
                                        self.data_out_parent_interface = value
                                        self.data_out_parent_interface.value_namespace = name_space
                                        self.data_out_parent_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "merge-point-label"):
                                        self.merge_point_label = value
                                        self.merge_point_label.value_namespace = name_space
                                        self.merge_point_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label-name"):
                                        self.out_label_name = value
                                        self.out_label_name.value_namespace = name_space
                                        self.out_label_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-class"):
                                        self.tunnel_class = value
                                        self.tunnel_class.value_namespace = name_space
                                        self.tunnel_class.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface"):
                                        self.tunnel_interface = value
                                        self.tunnel_interface.value_namespace = name_space
                                        self.tunnel_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-weight"):
                                        self.tunnel_weight = value
                                        self.tunnel_weight.value_namespace = name_space
                                        self.tunnel_weight.value_namespace_prefix = name_space_prefix


                            class PseudowireData(Entity):
                                """
                                pseudowire data
                                
                                .. attribute:: bridge_id
                                
                                	Bridge ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross\-connect ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: pseuodo_wire_connect_id
                                
                                	PseudoWire Cross\-connect ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: split_horizon_id
                                
                                	Split horizon group ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireData, self).__init__()

                                    self.yang_name = "pseudowire-data"
                                    self.yang_parent_name = "moi"

                                    self.bridge_id = YLeaf(YType.uint32, "bridge-id")

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.pseuodo_wire_connect_id = YLeaf(YType.uint32, "pseuodo-wire-connect-id")

                                    self.split_horizon_id = YLeaf(YType.uint32, "split-horizon-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bridge_id",
                                                    "cross_connect_id",
                                                    "ipv4_next_hop",
                                                    "out_interface",
                                                    "out_label",
                                                    "path_flags_decode",
                                                    "pseuodo_wire_connect_id",
                                                    "split_horizon_id",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bridge_id.is_set or
                                        self.cross_connect_id.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.path_flags_decode.is_set or
                                        self.pseuodo_wire_connect_id.is_set or
                                        self.split_horizon_id.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bridge_id.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.pseuodo_wire_connect_id.yfilter != YFilter.not_set or
                                        self.split_horizon_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bridge_id.is_set or self.bridge_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bridge_id.get_name_leafdata())
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.pseuodo_wire_connect_id.is_set or self.pseuodo_wire_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pseuodo_wire_connect_id.get_name_leafdata())
                                    if (self.split_horizon_id.is_set or self.split_horizon_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.split_horizon_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bridge-id" or name == "cross-connect-id" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pseuodo-wire-connect-id" or name == "split-horizon-id" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bridge-id"):
                                        self.bridge_id = value
                                        self.bridge_id.value_namespace = name_space
                                        self.bridge_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pseuodo-wire-connect-id"):
                                        self.pseuodo_wire_connect_id = value
                                        self.pseuodo_wire_connect_id.value_namespace = name_space
                                        self.pseuodo_wire_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "split-horizon-id"):
                                        self.split_horizon_id = value
                                        self.split_horizon_id.value_namespace = name_space
                                        self.split_horizon_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class IpSubData(Entity):
                                """
                                ip sub data
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	VRF table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.IpSubData, self).__init__()

                                    self.yang_name = "ip-sub-data"
                                    self.yang_parent_name = "moi"

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("out_interface",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.out_interface.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ip-sub-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "out-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class PseudowireHeadEndData(Entity):
                                """
                                pseudowire head end data
                                
                                .. attribute:: control_word
                                
                                	Is control word present
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: imposition
                                
                                	Is PWHE IMposition
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: pw_list_id
                                
                                	Pseudo\-wire List Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: pwhe_interface
                                
                                	Pseudo\-wire Head\-end interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: vctype
                                
                                	Virtual Circuit Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__init__()

                                    self.yang_name = "pseudowire-head-end-data"
                                    self.yang_parent_name = "moi"

                                    self.control_word = YLeaf(YType.int32, "control-word")

                                    self.imposition = YLeaf(YType.int32, "imposition")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.pw_list_id = YLeaf(YType.uint16, "pw-list-id")

                                    self.pwhe_interface = YLeaf(YType.str, "pwhe-interface")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.vctype = YLeaf(YType.uint8, "vctype")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("control_word",
                                                    "imposition",
                                                    "ipv4_next_hop",
                                                    "out_interface",
                                                    "out_label",
                                                    "path_flags_decode",
                                                    "pw_list_id",
                                                    "pwhe_interface",
                                                    "table_id",
                                                    "table_name",
                                                    "vctype") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.control_word.is_set or
                                        self.imposition.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.path_flags_decode.is_set or
                                        self.pw_list_id.is_set or
                                        self.pwhe_interface.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.vctype.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.control_word.yfilter != YFilter.not_set or
                                        self.imposition.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.pw_list_id.yfilter != YFilter.not_set or
                                        self.pwhe_interface.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.vctype.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-head-end-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.control_word.is_set or self.control_word.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.control_word.get_name_leafdata())
                                    if (self.imposition.is_set or self.imposition.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.imposition.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.pw_list_id.is_set or self.pw_list_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pw_list_id.get_name_leafdata())
                                    if (self.pwhe_interface.is_set or self.pwhe_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_interface.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.vctype.is_set or self.vctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vctype.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "control-word" or name == "imposition" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pw-list-id" or name == "pwhe-interface" or name == "table-id" or name == "table-name" or name == "vctype"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "control-word"):
                                        self.control_word = value
                                        self.control_word.value_namespace = name_space
                                        self.control_word.value_namespace_prefix = name_space_prefix
                                    if(value_path == "imposition"):
                                        self.imposition = value
                                        self.imposition.value_namespace = name_space
                                        self.imposition.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pw-list-id"):
                                        self.pw_list_id = value
                                        self.pw_list_id.value_namespace = name_space
                                        self.pw_list_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pwhe-interface"):
                                        self.pwhe_interface = value
                                        self.pwhe_interface.value_namespace = name_space
                                        self.pwhe_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vctype"):
                                        self.vctype = value
                                        self.vctype.value_namespace = name_space
                                        self.vctype.value_namespace_prefix = name_space_prefix


                            class PwListData(Entity):
                                """
                                pw list data
                                
                                .. attribute:: l2_interface
                                
                                	Pseudo\-wire Layer 2 interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: l3_interface
                                
                                	Pseudo\-wire Layer 3 interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PwListData, self).__init__()

                                    self.yang_name = "pw-list-data"
                                    self.yang_parent_name = "moi"

                                    self.l2_interface = YLeaf(YType.str, "l2-interface")

                                    self.l3_interface = YLeaf(YType.str, "l3-interface")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("l2_interface",
                                                    "l3_interface",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.l2_interface.is_set or
                                        self.l3_interface.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.l2_interface.yfilter != YFilter.not_set or
                                        self.l3_interface.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pw-list-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.l2_interface.is_set or self.l2_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.l2_interface.get_name_leafdata())
                                    if (self.l3_interface.is_set or self.l3_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.l3_interface.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "l2-interface" or name == "l3-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "l2-interface"):
                                        self.l2_interface = value
                                        self.l2_interface.value_namespace = name_space
                                        self.l2_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "l3-interface"):
                                        self.l3_interface = value
                                        self.l3_interface.value_namespace = name_space
                                        self.l3_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class Stackv4Data(Entity):
                                """
                                stackv4 data
                                
                                .. attribute:: inner_stack
                                
                                	Inner stack
                                	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack>`
                                
                                .. attribute:: nexthop
                                
                                	Nexthop
                                	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.Nexthop>`
                                
                                .. attribute:: owner_application_type
                                
                                	Owner application type
                                	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data, self).__init__()

                                    self.yang_name = "stackv4-data"
                                    self.yang_parent_name = "moi"

                                    self.owner_application_type = YLeaf(YType.enumeration, "owner-application-type")

                                    self.inner_stack = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                    self.inner_stack.parent = self
                                    self._children_name_map["inner_stack"] = "inner-stack"
                                    self._children_yang_names.add("inner-stack")

                                    self.nexthop = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                    self.nexthop.parent = self
                                    self._children_name_map["nexthop"] = "nexthop"
                                    self._children_yang_names.add("nexthop")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("owner_application_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)


                                class Nexthop(Entity):
                                    """
                                    Nexthop
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: load_metric
                                    
                                    	Routing path's load metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: local_label
                                    
                                    	TE backup path local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_interface_parent
                                    
                                    	Outgoing Interface's parent
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__init__()

                                        self.yang_name = "nexthop"
                                        self.yang_parent_name = "stackv4-data"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.load_metric = YLeaf(YType.uint32, "load-metric")

                                        self.local_label = YLeaf(YType.uint32, "local-label")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv4_next_hop",
                                                        "load_metric",
                                                        "local_label",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_interface_parent",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.load_metric.is_set or
                                            self.local_label.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_interface_parent.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.load_metric.yfilter != YFilter.not_set or
                                            self.local_label.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_interface_parent.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nexthop" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_metric.get_name_leafdata())
                                        if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_label.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-metric"):
                                            self.load_metric = value
                                            self.load_metric.value_namespace = name_space
                                            self.load_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-label"):
                                            self.local_label = value
                                            self.local_label.value_namespace = name_space
                                            self.local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface-parent"):
                                            self.out_interface_parent = value
                                            self.out_interface_parent.value_namespace = name_space
                                            self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix


                                class InnerStack(Entity):
                                    """
                                    Inner stack
                                    
                                    .. attribute:: label
                                    
                                    	Info related to outgoing labels
                                    	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Remote nexthop addresses
                                    	**type**\:  list of str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: num_lbls
                                    
                                    	Depth of inner label stack
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: num_nexthops
                                    
                                    	Number of remote nexthop addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__init__()

                                        self.yang_name = "inner-stack"
                                        self.yang_parent_name = "stackv4-data"

                                        self.nexthop = YLeafList(YType.str, "nexthop")

                                        self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                        self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                        self.label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nexthop",
                                                        "num_lbls",
                                                        "num_nexthops") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)


                                    class Label(Entity):
                                        """
                                        Info related to outgoing labels
                                        
                                        .. attribute:: outgoing_label
                                        
                                        	Remote Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: outgoing_label_str
                                        
                                        	Remote Label string
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__init__()

                                            self.yang_name = "label"
                                            self.yang_parent_name = "inner-stack"

                                            self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                            self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("outgoing_label",
                                                            "outgoing_label_str") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.outgoing_label.is_set or
                                                self.outgoing_label_str.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.outgoing_label.yfilter != YFilter.not_set or
                                                self.outgoing_label_str.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                            if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "outgoing-label"):
                                                self.outgoing_label = value
                                                self.outgoing_label.value_namespace = name_space
                                                self.outgoing_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "outgoing-label-str"):
                                                self.outgoing_label_str = value
                                                self.outgoing_label_str.value_namespace = name_space
                                                self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.label:
                                            if (c.has_data()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return (
                                            self.num_lbls.is_set or
                                            self.num_nexthops.is_set)

                                    def has_operation(self):
                                        for c in self.label:
                                            if (c.has_operation()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nexthop.yfilter != YFilter.not_set or
                                            self.num_lbls.yfilter != YFilter.not_set or
                                            self.num_nexthops.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inner-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                        if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                        leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "label"):
                                            for c in self.label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nexthop"):
                                            self.nexthop.append(value)
                                        if(value_path == "num-lbls"):
                                            self.num_lbls = value
                                            self.num_lbls.value_namespace = name_space
                                            self.num_lbls.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-nexthops"):
                                            self.num_nexthops = value
                                            self.num_nexthops.value_namespace = name_space
                                            self.num_nexthops.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.owner_application_type.is_set or
                                        (self.inner_stack is not None and self.inner_stack.has_data()) or
                                        (self.nexthop is not None and self.nexthop.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.owner_application_type.yfilter != YFilter.not_set or
                                        (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                        (self.nexthop is not None and self.nexthop.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "stackv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.owner_application_type.is_set or self.owner_application_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.owner_application_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "inner-stack"):
                                        if (self.inner_stack is None):
                                            self.inner_stack = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                            self.inner_stack.parent = self
                                            self._children_name_map["inner_stack"] = "inner-stack"
                                        return self.inner_stack

                                    if (child_yang_name == "nexthop"):
                                        if (self.nexthop is None):
                                            self.nexthop = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                            self.nexthop.parent = self
                                            self._children_name_map["nexthop"] = "nexthop"
                                        return self.nexthop

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "inner-stack" or name == "nexthop" or name == "owner-application-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "owner-application-type"):
                                        self.owner_application_type = value
                                        self.owner_application_type.value_namespace = name_space
                                        self.owner_application_type.value_namespace_prefix = name_space_prefix


                            class Stackv6Data(Entity):
                                """
                                stackv6 data
                                
                                .. attribute:: inner_stack
                                
                                	Inner stack
                                	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack>`
                                
                                .. attribute:: nexthop
                                
                                	Nexthop
                                	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.Nexthop>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data, self).__init__()

                                    self.yang_name = "stackv6-data"
                                    self.yang_parent_name = "moi"

                                    self.inner_stack = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                    self.inner_stack.parent = self
                                    self._children_name_map["inner_stack"] = "inner-stack"
                                    self._children_yang_names.add("inner-stack")

                                    self.nexthop = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                    self.nexthop.parent = self
                                    self._children_name_map["nexthop"] = "nexthop"
                                    self._children_yang_names.add("nexthop")


                                class Nexthop(Entity):
                                    """
                                    Nexthop
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv6_next_hop
                                    
                                    	IPv6 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__init__()

                                        self.yang_name = "nexthop"
                                        self.yang_parent_name = "stackv6-data"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv6_next_hop",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv6_next_hop.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv6_next_hop.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nexthop" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6-next-hop"):
                                            self.ipv6_next_hop = value
                                            self.ipv6_next_hop.value_namespace = name_space
                                            self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class InnerStack(Entity):
                                    """
                                    Inner stack
                                    
                                    .. attribute:: label
                                    
                                    	Info related to outgoing labels
                                    	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Remote nexthop addresses
                                    	**type**\:  list of str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: num_lbls
                                    
                                    	Depth of inner label stack
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: num_nexthops
                                    
                                    	Number of remote nexthop addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__init__()

                                        self.yang_name = "inner-stack"
                                        self.yang_parent_name = "stackv6-data"

                                        self.nexthop = YLeafList(YType.str, "nexthop")

                                        self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                        self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                        self.label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nexthop",
                                                        "num_lbls",
                                                        "num_nexthops") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)


                                    class Label(Entity):
                                        """
                                        Info related to outgoing labels
                                        
                                        .. attribute:: outgoing_label
                                        
                                        	Remote Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: outgoing_label_str
                                        
                                        	Remote Label string
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__init__()

                                            self.yang_name = "label"
                                            self.yang_parent_name = "inner-stack"

                                            self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                            self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("outgoing_label",
                                                            "outgoing_label_str") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.outgoing_label.is_set or
                                                self.outgoing_label_str.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.outgoing_label.yfilter != YFilter.not_set or
                                                self.outgoing_label_str.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                            if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "outgoing-label"):
                                                self.outgoing_label = value
                                                self.outgoing_label.value_namespace = name_space
                                                self.outgoing_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "outgoing-label-str"):
                                                self.outgoing_label_str = value
                                                self.outgoing_label_str.value_namespace = name_space
                                                self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.label:
                                            if (c.has_data()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return (
                                            self.num_lbls.is_set or
                                            self.num_nexthops.is_set)

                                    def has_operation(self):
                                        for c in self.label:
                                            if (c.has_operation()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nexthop.yfilter != YFilter.not_set or
                                            self.num_lbls.yfilter != YFilter.not_set or
                                            self.num_nexthops.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inner-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                        if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                        leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "label"):
                                            for c in self.label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nexthop"):
                                            self.nexthop.append(value)
                                        if(value_path == "num-lbls"):
                                            self.num_lbls = value
                                            self.num_lbls.value_namespace = name_space
                                            self.num_lbls.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-nexthops"):
                                            self.num_nexthops = value
                                            self.num_nexthops.value_namespace = name_space
                                            self.num_nexthops.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.inner_stack is not None and self.inner_stack.has_data()) or
                                        (self.nexthop is not None and self.nexthop.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                        (self.nexthop is not None and self.nexthop.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "stackv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "inner-stack"):
                                        if (self.inner_stack is None):
                                            self.inner_stack = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                            self.inner_stack.parent = self
                                            self._children_name_map["inner_stack"] = "inner-stack"
                                        return self.inner_stack

                                    if (child_yang_name == "nexthop"):
                                        if (self.nexthop is None):
                                            self.nexthop = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                            self.nexthop.parent = self
                                            self._children_name_map["nexthop"] = "nexthop"
                                        return self.nexthop

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "inner-stack" or name == "nexthop"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class TeHeadData(Entity):
                                """
                                te head data
                                
                                .. attribute:: flags_decode
                                
                                	Flags decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_fwd_class
                                
                                	Tunnel forwarding class
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: tunnel_load_metric
                                
                                	Tunnel Load metric
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_local_label
                                
                                	Tunnel local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_local_label_str
                                
                                	Tunnel local label stringified
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.TeHeadData, self).__init__()

                                    self.yang_name = "te-head-data"
                                    self.yang_parent_name = "moi"

                                    self.flags_decode = YLeaf(YType.str, "flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.tunnel_fwd_class = YLeaf(YType.uint8, "tunnel-fwd-class")

                                    self.tunnel_load_metric = YLeaf(YType.uint32, "tunnel-load-metric")

                                    self.tunnel_local_label = YLeaf(YType.uint32, "tunnel-local-label")

                                    self.tunnel_local_label_str = YLeaf(YType.str, "tunnel-local-label-str")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("flags_decode",
                                                    "table_id",
                                                    "table_name",
                                                    "tunnel_fwd_class",
                                                    "tunnel_load_metric",
                                                    "tunnel_local_label",
                                                    "tunnel_local_label_str") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.tunnel_fwd_class.is_set or
                                        self.tunnel_load_metric.is_set or
                                        self.tunnel_local_label.is_set or
                                        self.tunnel_local_label_str.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.tunnel_fwd_class.yfilter != YFilter.not_set or
                                        self.tunnel_load_metric.yfilter != YFilter.not_set or
                                        self.tunnel_local_label.yfilter != YFilter.not_set or
                                        self.tunnel_local_label_str.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-head-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.flags_decode.is_set or self.flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.tunnel_fwd_class.is_set or self.tunnel_fwd_class.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_fwd_class.get_name_leafdata())
                                    if (self.tunnel_load_metric.is_set or self.tunnel_load_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_load_metric.get_name_leafdata())
                                    if (self.tunnel_local_label.is_set or self.tunnel_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_local_label.get_name_leafdata())
                                    if (self.tunnel_local_label_str.is_set or self.tunnel_local_label_str.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_local_label_str.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-fwd-class" or name == "tunnel-load-metric" or name == "tunnel-local-label" or name == "tunnel-local-label-str"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "flags-decode"):
                                        self.flags_decode = value
                                        self.flags_decode.value_namespace = name_space
                                        self.flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-fwd-class"):
                                        self.tunnel_fwd_class = value
                                        self.tunnel_fwd_class.value_namespace = name_space
                                        self.tunnel_fwd_class.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-load-metric"):
                                        self.tunnel_load_metric = value
                                        self.tunnel_load_metric.value_namespace = name_space
                                        self.tunnel_load_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-local-label"):
                                        self.tunnel_local_label = value
                                        self.tunnel_local_label.value_namespace = name_space
                                        self.tunnel_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-local-label-str"):
                                        self.tunnel_local_label_str = value
                                        self.tunnel_local_label_str.value_namespace = name_space
                                        self.tunnel_local_label_str.value_namespace_prefix = name_space_prefix


                            class DmtcData(Entity):
                                """
                                dmtc data
                                
                                .. attribute:: dmtc_ext_ifh
                                
                                	DMTC External Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.DmtcData, self).__init__()

                                    self.yang_name = "dmtc-data"
                                    self.yang_parent_name = "moi"

                                    self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.dmtc_ext_ifh.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "dmtc-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-ext-ifh"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dmtc-ext-ifh"):
                                        self.dmtc_ext_ifh = value
                                        self.dmtc_ext_ifh.value_namespace = name_space
                                        self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.moi_type.is_set or
                                    (self.dmtc_data is not None and self.dmtc_data.has_data()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_data()) or
                                    (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_data()) or
                                    (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_data()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                    (self.stackv4_data is not None and self.stackv4_data.has_data()) or
                                    (self.stackv6_data is not None and self.stackv6_data.has_data()) or
                                    (self.te_head_data is not None and self.te_head_data.has_data()) or
                                    (self.tev4_data is not None and self.tev4_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.moi_type.yfilter != YFilter.not_set or
                                    (self.dmtc_data is not None and self.dmtc_data.has_operation()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_operation()) or
                                    (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_operation()) or
                                    (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_operation()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                    (self.stackv4_data is not None and self.stackv4_data.has_operation()) or
                                    (self.stackv6_data is not None and self.stackv6_data.has_operation()) or
                                    (self.te_head_data is not None and self.te_head_data.has_operation()) or
                                    (self.tev4_data is not None and self.tev4_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "moi" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.moi_type.is_set or self.moi_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.moi_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "dmtc-data"):
                                    if (self.dmtc_data is None):
                                        self.dmtc_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.DmtcData()
                                        self.dmtc_data.parent = self
                                        self._children_name_map["dmtc_data"] = "dmtc-data"
                                    return self.dmtc_data

                                if (child_yang_name == "ip-sub-data"):
                                    if (self.ip_sub_data is None):
                                        self.ip_sub_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.IpSubData()
                                        self.ip_sub_data.parent = self
                                        self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    return self.ip_sub_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "pop-and-lookup-ipv4"):
                                    if (self.pop_and_lookup_ipv4 is None):
                                        self.pop_and_lookup_ipv4 = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                        self.pop_and_lookup_ipv4.parent = self
                                        self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                    return self.pop_and_lookup_ipv4

                                if (child_yang_name == "pop-and-lookup-ipv6"):
                                    if (self.pop_and_lookup_ipv6 is None):
                                        self.pop_and_lookup_ipv6 = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                        self.pop_and_lookup_ipv6.parent = self
                                        self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                    return self.pop_and_lookup_ipv6

                                if (child_yang_name == "pop-and-lookup-tp"):
                                    if (self.pop_and_lookup_tp is None):
                                        self.pop_and_lookup_tp = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PopAndLookupTp()
                                        self.pop_and_lookup_tp.parent = self
                                        self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                    return self.pop_and_lookup_tp

                                if (child_yang_name == "pseudowire-data"):
                                    if (self.pseudowire_data is None):
                                        self.pseudowire_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireData()
                                        self.pseudowire_data.parent = self
                                        self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    return self.pseudowire_data

                                if (child_yang_name == "pseudowire-head-end-data"):
                                    if (self.pseudowire_head_end_data is None):
                                        self.pseudowire_head_end_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                        self.pseudowire_head_end_data.parent = self
                                        self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    return self.pseudowire_head_end_data

                                if (child_yang_name == "pw-list-data"):
                                    if (self.pw_list_data is None):
                                        self.pw_list_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.PwListData()
                                        self.pw_list_data.parent = self
                                        self._children_name_map["pw_list_data"] = "pw-list-data"
                                    return self.pw_list_data

                                if (child_yang_name == "stackv4-data"):
                                    if (self.stackv4_data is None):
                                        self.stackv4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv4Data()
                                        self.stackv4_data.parent = self
                                        self._children_name_map["stackv4_data"] = "stackv4-data"
                                    return self.stackv4_data

                                if (child_yang_name == "stackv6-data"):
                                    if (self.stackv6_data is None):
                                        self.stackv6_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Stackv6Data()
                                        self.stackv6_data.parent = self
                                        self._children_name_map["stackv6_data"] = "stackv6-data"
                                    return self.stackv6_data

                                if (child_yang_name == "te-head-data"):
                                    if (self.te_head_data is None):
                                        self.te_head_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.TeHeadData()
                                        self.te_head_data.parent = self
                                        self._children_name_map["te_head_data"] = "te-head-data"
                                    return self.te_head_data

                                if (child_yang_name == "tev4-data"):
                                    if (self.tev4_data is None):
                                        self.tev4_data = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi.Tev4Data()
                                        self.tev4_data.parent = self
                                        self._children_name_map["tev4_data"] = "tev4-data"
                                    return self.tev4_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-data" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv6-data" or name == "pop-and-lookup-ipv4" or name == "pop-and-lookup-ipv6" or name == "pop-and-lookup-tp" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "pw-list-data" or name == "stackv4-data" or name == "stackv6-data" or name == "te-head-data" or name == "tev4-data" or name == "moi-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "moi-type"):
                                    self.moi_type = value
                                    self.moi_type.value_namespace = name_space
                                    self.moi_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.moi is not None and self.moi.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.moi is not None and self.moi.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "moi-array" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "moi"):
                                if (self.moi is None):
                                    self.moi = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray.Moi()
                                    self.moi.parent = self
                                    self._children_name_map["moi"] = "moi"
                                return self.moi

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "moi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        for c in self.moi_array:
                            if (c.has_data()):
                                return True
                        return (self.application_resource is not None and self.application_resource.has_data())

                    def has_operation(self):
                        for c in self.moi_array:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.application_resource is not None and self.application_resource.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "mois" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application-resource"):
                            if (self.application_resource is None):
                                self.application_resource = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.ApplicationResource()
                                self.application_resource.parent = self
                                self._children_name_map["application_resource"] = "application-resource"
                            return self.application_resource

                        if (child_yang_name == "moi-array"):
                            for c in self.moi_array:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois.MoiArray()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.moi_array.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-resource" or name == "moi-array"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    for c in self.associated_fpi:
                        if (c.has_data()):
                            return True
                    for c in self.mois:
                        if (c.has_data()):
                            return True
                    for c in self.v4_rpf:
                        if (c.has_data()):
                            return True
                    for c in self.v6_rpf:
                        if (c.has_data()):
                            return True
                    return (
                        self.interface_name.is_set or
                        self.bcdl_priority.is_set or
                        self.lsd_queue.is_set or
                        self.priority_updated.is_set or
                        self.rewrite_version.is_set or
                        self.rw_install_age.is_set or
                        self.rw_install_time.is_set or
                        self.rw_updated.is_set or
                        (self.fpi_key is not None and self.fpi_key.has_data()) or
                        (self.rewrite_id is not None and self.rewrite_id.has_data()))

                def has_operation(self):
                    for c in self.associated_fpi:
                        if (c.has_operation()):
                            return True
                    for c in self.mois:
                        if (c.has_operation()):
                            return True
                    for c in self.v4_rpf:
                        if (c.has_operation()):
                            return True
                    for c in self.v6_rpf:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.bcdl_priority.yfilter != YFilter.not_set or
                        self.lsd_queue.yfilter != YFilter.not_set or
                        self.priority_updated.yfilter != YFilter.not_set or
                        self.rewrite_version.yfilter != YFilter.not_set or
                        self.rw_install_age.yfilter != YFilter.not_set or
                        self.rw_install_time.yfilter != YFilter.not_set or
                        self.rw_updated.yfilter != YFilter.not_set or
                        (self.fpi_key is not None and self.fpi_key.has_operation()) or
                        (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "rewrite-te" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-tes/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.bcdl_priority.is_set or self.bcdl_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bcdl_priority.get_name_leafdata())
                    if (self.lsd_queue.is_set or self.lsd_queue.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsd_queue.get_name_leafdata())
                    if (self.priority_updated.is_set or self.priority_updated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.priority_updated.get_name_leafdata())
                    if (self.rewrite_version.is_set or self.rewrite_version.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rewrite_version.get_name_leafdata())
                    if (self.rw_install_age.is_set or self.rw_install_age.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rw_install_age.get_name_leafdata())
                    if (self.rw_install_time.is_set or self.rw_install_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rw_install_time.get_name_leafdata())
                    if (self.rw_updated.is_set or self.rw_updated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rw_updated.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "associated-fpi"):
                        for c in self.associated_fpi:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewriteTes.RewriteTe.AssociatedFpi()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.associated_fpi.append(c)
                        return c

                    if (child_yang_name == "fpi-key"):
                        if (self.fpi_key is None):
                            self.fpi_key = MplsLsd.Rewrite.RewriteTes.RewriteTe.FpiKey()
                            self.fpi_key.parent = self
                            self._children_name_map["fpi_key"] = "fpi-key"
                        return self.fpi_key

                    if (child_yang_name == "mois"):
                        for c in self.mois:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewriteTes.RewriteTe.Mois()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.mois.append(c)
                        return c

                    if (child_yang_name == "rewrite-id"):
                        if (self.rewrite_id is None):
                            self.rewrite_id = MplsLsd.Rewrite.RewriteTes.RewriteTe.RewriteId()
                            self.rewrite_id.parent = self
                            self._children_name_map["rewrite_id"] = "rewrite-id"
                        return self.rewrite_id

                    if (child_yang_name == "v4-rpf"):
                        for c in self.v4_rpf:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewriteTes.RewriteTe.V4Rpf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.v4_rpf.append(c)
                        return c

                    if (child_yang_name == "v6-rpf"):
                        for c in self.v6_rpf:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewriteTes.RewriteTe.V6Rpf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.v6_rpf.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "associated-fpi" or name == "fpi-key" or name == "mois" or name == "rewrite-id" or name == "v4-rpf" or name == "v6-rpf" or name == "interface-name" or name == "bcdl-priority" or name == "lsd-queue" or name == "priority-updated" or name == "rewrite-version" or name == "rw-install-age" or name == "rw-install-time" or name == "rw-updated"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "bcdl-priority"):
                        self.bcdl_priority = value
                        self.bcdl_priority.value_namespace = name_space
                        self.bcdl_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsd-queue"):
                        self.lsd_queue = value
                        self.lsd_queue.value_namespace = name_space
                        self.lsd_queue.value_namespace_prefix = name_space_prefix
                    if(value_path == "priority-updated"):
                        self.priority_updated = value
                        self.priority_updated.value_namespace = name_space
                        self.priority_updated.value_namespace_prefix = name_space_prefix
                    if(value_path == "rewrite-version"):
                        self.rewrite_version = value
                        self.rewrite_version.value_namespace = name_space
                        self.rewrite_version.value_namespace_prefix = name_space_prefix
                    if(value_path == "rw-install-age"):
                        self.rw_install_age = value
                        self.rw_install_age.value_namespace = name_space
                        self.rw_install_age.value_namespace_prefix = name_space_prefix
                    if(value_path == "rw-install-time"):
                        self.rw_install_time = value
                        self.rw_install_time.value_namespace = name_space
                        self.rw_install_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "rw-updated"):
                        self.rw_updated = value
                        self.rw_updated.value_namespace = name_space
                        self.rw_updated.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.rewrite_te:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.rewrite_te:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "rewrite-tes" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "rewrite-te"):
                    for c in self.rewrite_te:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsd.Rewrite.RewriteTes.RewriteTe()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.rewrite_te.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "rewrite-te"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class RewriteLabels(Entity):
            """
            Table of Rewrites
            
            .. attribute:: rewrite_label
            
            	FPI rewrite for label
            	**type**\: list of    :py:class:`RewriteLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.Rewrite.RewriteLabels, self).__init__()

                self.yang_name = "rewrite-labels"
                self.yang_parent_name = "rewrite"

                self.rewrite_label = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.Rewrite.RewriteLabels, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.Rewrite.RewriteLabels, self).__setattr__(name, value)


            class RewriteLabel(Entity):
                """
                FPI rewrite for label
                
                .. attribute:: label_id  <key>
                
                	Label value
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: associated_fpi
                
                	Associated FPI
                	**type**\: list of    :py:class:`AssociatedFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi>`
                
                .. attribute:: bcdl_priority
                
                	BCDL Priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: fpi_key
                
                	fpi key
                	**type**\:   :py:class:`FpiKey <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey>`
                
                .. attribute:: lsd_queue
                
                	LSD queue
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: mois
                
                	Mois
                	**type**\: list of    :py:class:`Mois <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois>`
                
                .. attribute:: priority_updated
                
                	Is rewrite's BCDL priority updated
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: rewrite_id
                
                	Rewrite ID
                	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId>`
                
                .. attribute:: rewrite_version
                
                	Rewrite version
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: rw_install_age
                
                	Rewrite install age
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: rw_install_time
                
                	Rewrite install timestamp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: rw_updated
                
                	Is rewrite ever updated
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: v4_rpf
                
                	IPv4 RPF neighbors
                	**type**\: list of    :py:class:`V4Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.V4Rpf>`
                
                .. attribute:: v6_rpf
                
                	IPv6 RPF neighbors
                	**type**\: list of    :py:class:`V6Rpf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.V6Rpf>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel, self).__init__()

                    self.yang_name = "rewrite-label"
                    self.yang_parent_name = "rewrite-labels"

                    self.label_id = YLeaf(YType.int32, "label-id")

                    self.bcdl_priority = YLeaf(YType.uint8, "bcdl-priority")

                    self.lsd_queue = YLeaf(YType.uint8, "lsd-queue")

                    self.priority_updated = YLeaf(YType.int32, "priority-updated")

                    self.rewrite_version = YLeaf(YType.uint64, "rewrite-version")

                    self.rw_install_age = YLeaf(YType.uint64, "rw-install-age")

                    self.rw_install_time = YLeaf(YType.uint64, "rw-install-time")

                    self.rw_updated = YLeaf(YType.int32, "rw-updated")

                    self.fpi_key = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey()
                    self.fpi_key.parent = self
                    self._children_name_map["fpi_key"] = "fpi-key"
                    self._children_yang_names.add("fpi-key")

                    self.rewrite_id = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId()
                    self.rewrite_id.parent = self
                    self._children_name_map["rewrite_id"] = "rewrite-id"
                    self._children_yang_names.add("rewrite-id")

                    self.associated_fpi = YList(self)
                    self.mois = YList(self)
                    self.v4_rpf = YList(self)
                    self.v6_rpf = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("label_id",
                                    "bcdl_priority",
                                    "lsd_queue",
                                    "priority_updated",
                                    "rewrite_version",
                                    "rw_install_age",
                                    "rw_install_time",
                                    "rw_updated") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel, self).__setattr__(name, value)


                class FpiKey(Entity):
                    """
                    fpi key
                    
                    .. attribute:: application_owner
                    
                    	Application owner instance
                    	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.ApplicationOwner>`
                    
                    .. attribute:: fpi
                    
                    	FPI
                    	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey, self).__init__()

                        self.yang_name = "fpi-key"
                        self.yang_parent_name = "rewrite-label"

                        self.fpi = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi()
                        self.fpi.parent = self
                        self._children_name_map["fpi"] = "fpi"
                        self._children_yang_names.add("fpi")

                        self.application_owner = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey, self).__setattr__(name, value)


                    class Fpi(Entity):
                        """
                        FPI
                        
                        .. attribute:: dmtc_ext_intf_data
                        
                        	dmtc ext intf data
                        	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.DmtcExtIntfData>`
                        
                        .. attribute:: fpi_type
                        
                        	FPIType
                        	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                        
                        .. attribute:: ipv4_data
                        
                        	ipv4 data
                        	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv4Data>`
                        
                        .. attribute:: ipv6_data
                        
                        	ipv6 data
                        	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv6Data>`
                        
                        .. attribute:: label_data
                        
                        	label data
                        	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.LabelData>`
                        
                        .. attribute:: pw_list_data
                        
                        	pw list data
                        	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.PwListData>`
                        
                        .. attribute:: te_data
                        
                        	te data
                        	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.TeData>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi, self).__init__()

                            self.yang_name = "fpi"
                            self.yang_parent_name = "fpi-key"

                            self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                            self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.DmtcExtIntfData()
                            self.dmtc_ext_intf_data.parent = self
                            self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                            self._children_yang_names.add("dmtc-ext-intf-data")

                            self.ipv4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv4Data()
                            self.ipv4_data.parent = self
                            self._children_name_map["ipv4_data"] = "ipv4-data"
                            self._children_yang_names.add("ipv4-data")

                            self.ipv6_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv6Data()
                            self.ipv6_data.parent = self
                            self._children_name_map["ipv6_data"] = "ipv6-data"
                            self._children_yang_names.add("ipv6-data")

                            self.label_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.LabelData()
                            self.label_data.parent = self
                            self._children_name_map["label_data"] = "label-data"
                            self._children_yang_names.add("label-data")

                            self.pw_list_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.PwListData()
                            self.pw_list_data.parent = self
                            self._children_name_map["pw_list_data"] = "pw-list-data"
                            self._children_yang_names.add("pw-list-data")

                            self.te_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.TeData()
                            self.te_data.parent = self
                            self._children_name_map["te_data"] = "te-data"
                            self._children_yang_names.add("te-data")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fpi_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi, self).__setattr__(name, value)


                        class LabelData(Entity):
                            """
                            label data
                            
                            .. attribute:: elc
                            
                            	ELC
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: label
                            
                            	Label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.LabelData, self).__init__()

                                self.yang_name = "label-data"
                                self.yang_parent_name = "fpi"

                                self.elc = YLeaf(YType.int32, "elc")

                                self.label = YLeaf(YType.uint32, "label")

                                self.security_id = YLeaf(YType.uint32, "security-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("elc",
                                                "label",
                                                "security_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.LabelData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.LabelData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.elc.is_set or
                                    self.label.is_set or
                                    self.security_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.elc.yfilter != YFilter.not_set or
                                    self.label.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.elc.get_name_leafdata())
                                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label.get_name_leafdata())
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "elc" or name == "label" or name == "security-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "elc"):
                                    self.elc = value
                                    self.elc.value_namespace = name_space
                                    self.elc.value_namespace_prefix = name_space_prefix
                                if(value_path == "label"):
                                    self.label = value
                                    self.label.value_namespace = name_space
                                    self.label.value_namespace_prefix = name_space_prefix
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix


                        class TeData(Entity):
                            """
                            te data
                            
                            .. attribute:: local_label
                            
                            	Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_interface
                            
                            	Tunnel interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.TeData, self).__init__()

                                self.yang_name = "te-data"
                                self.yang_parent_name = "fpi"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label",
                                                "tunnel_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.TeData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.TeData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.local_label.is_set or
                                    self.tunnel_interface.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.tunnel_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label" or name == "tunnel-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface"):
                                    self.tunnel_interface = value
                                    self.tunnel_interface.value_namespace = name_space
                                    self.tunnel_interface.value_namespace_prefix = name_space_prefix


                        class Ipv4Data(Entity):
                            """
                            ipv4 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: sr_local_label
                            
                            	SR related Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv4Data, self).__init__()

                                self.yang_name = "ipv4-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "sr_local_label",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv4Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.sr_local_label.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.sr_local_label.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "sr-local-label"):
                                    self.sr_local_label = value
                                    self.sr_local_label.value_namespace = name_space
                                    self.sr_local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class Ipv6Data(Entity):
                            """
                            ipv6 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_len
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: router_flags
                            
                            	Route flags
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv6Data, self).__init__()

                                self.yang_name = "ipv6-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                self.router_flags = YLeaf(YType.uint32, "router-flags")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_len",
                                                "router_flags",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv6Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_len.is_set or
                                    self.router_flags.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_len.yfilter != YFilter.not_set or
                                    self.router_flags.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv6-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.router_flags.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-len"):
                                    self.prefix_len = value
                                    self.prefix_len.value_namespace = name_space
                                    self.prefix_len.value_namespace_prefix = name_space_prefix
                                if(value_path == "router-flags"):
                                    self.router_flags = value
                                    self.router_flags.value_namespace = name_space
                                    self.router_flags.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class PwListData(Entity):
                            """
                            pw list data
                            
                            .. attribute:: pwhe_list_id
                            
                            	Pseudowire List Identifier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.PwListData, self).__init__()

                                self.yang_name = "pw-list-data"
                                self.yang_parent_name = "fpi"

                                self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("pwhe_list_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.PwListData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.PwListData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.pwhe_list_id.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.pwhe_list_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pw-list-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "pwhe-list-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "pwhe-list-id"):
                                    self.pwhe_list_id = value
                                    self.pwhe_list_id.value_namespace = name_space
                                    self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                        class DmtcExtIntfData(Entity):
                            """
                            dmtc ext intf data
                            
                            .. attribute:: dmtc_ext_ifh
                            
                            	DMTC External Interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.DmtcExtIntfData, self).__init__()

                                self.yang_name = "dmtc-ext-intf-data"
                                self.yang_parent_name = "fpi"

                                self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.dmtc_ext_ifh.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "dmtc-ext-intf-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-ifh"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "dmtc-ext-ifh"):
                                    self.dmtc_ext_ifh = value
                                    self.dmtc_ext_ifh.value_namespace = name_space
                                    self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fpi_type.is_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                (self.label_data is not None and self.label_data.has_data()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                (self.te_data is not None and self.te_data.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fpi_type.yfilter != YFilter.not_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                (self.label_data is not None and self.label_data.has_operation()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                (self.te_data is not None and self.te_data.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fpi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fpi_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "dmtc-ext-intf-data"):
                                if (self.dmtc_ext_intf_data is None):
                                    self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.DmtcExtIntfData()
                                    self.dmtc_ext_intf_data.parent = self
                                    self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                return self.dmtc_ext_intf_data

                            if (child_yang_name == "ipv4-data"):
                                if (self.ipv4_data is None):
                                    self.ipv4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                return self.ipv4_data

                            if (child_yang_name == "ipv6-data"):
                                if (self.ipv6_data is None):
                                    self.ipv6_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                return self.ipv6_data

                            if (child_yang_name == "label-data"):
                                if (self.label_data is None):
                                    self.label_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.LabelData()
                                    self.label_data.parent = self
                                    self._children_name_map["label_data"] = "label-data"
                                return self.label_data

                            if (child_yang_name == "pw-list-data"):
                                if (self.pw_list_data is None):
                                    self.pw_list_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.PwListData()
                                    self.pw_list_data.parent = self
                                    self._children_name_map["pw_list_data"] = "pw-list-data"
                                return self.pw_list_data

                            if (child_yang_name == "te-data"):
                                if (self.te_data is None):
                                    self.te_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi.TeData()
                                    self.te_data.parent = self
                                    self._children_name_map["te_data"] = "te-data"
                                return self.te_data

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fpi-type"):
                                self.fpi_type = value
                                self.fpi_type.value_namespace = name_space
                                self.fpi_type.value_namespace_prefix = name_space_prefix


                    class ApplicationOwner(Entity):
                        """
                        Application owner instance
                        
                        .. attribute:: application_instance
                        
                        	Application instance Name
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        .. attribute:: resource_state
                        
                        	Application resource state
                        	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.ApplicationOwner, self).__init__()

                            self.yang_name = "application-owner"
                            self.yang_parent_name = "fpi-key"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                            self.resource_state = YLeaf(YType.enumeration, "resource-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type",
                                            "resource_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.ApplicationOwner, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.ApplicationOwner, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set or
                                self.resource_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set or
                                self.resource_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application-owner" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())
                            if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resource_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "resource-state"):
                                self.resource_state = value
                                self.resource_state.value_namespace = name_space
                                self.resource_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.application_owner:
                            if (c.has_data()):
                                return True
                        return (self.fpi is not None and self.fpi.has_data())

                    def has_operation(self):
                        for c in self.application_owner:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.fpi is not None and self.fpi.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "fpi-key" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application-owner"):
                            for c in self.application_owner:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.ApplicationOwner()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.application_owner.append(c)
                            return c

                        if (child_yang_name == "fpi"):
                            if (self.fpi is None):
                                self.fpi = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey.Fpi()
                                self.fpi.parent = self
                                self._children_name_map["fpi"] = "fpi"
                            return self.fpi

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-owner" or name == "fpi"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class RewriteId(Entity):
                    """
                    Rewrite ID
                    
                    .. attribute:: rewrite_id
                    
                    	Rewrite ID
                    	**type**\:   :py:class:`RewriteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId, self).__init__()

                        self.yang_name = "rewrite-id"
                        self.yang_parent_name = "rewrite-label"

                        self.rewrite_id = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId()
                        self.rewrite_id.parent = self
                        self._children_name_map["rewrite_id"] = "rewrite-id"
                        self._children_yang_names.add("rewrite-id")


                    class RewriteId(Entity):
                        """
                        Rewrite ID
                        
                        .. attribute:: label_context
                        
                        	Label context
                        	**type**\:   :py:class:`LabelContext <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext>`
                        
                        .. attribute:: local_label_rewrite
                        
                        	Local label rewrite information
                        	**type**\:   :py:class:`LocalLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LocalLabelRewrite>`
                        
                        .. attribute:: rewrite_id_type
                        
                        	RewriteIDType
                        	**type**\:   :py:class:`MgmtLsdRwId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdRwId>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId, self).__init__()

                            self.yang_name = "rewrite-id"
                            self.yang_parent_name = "rewrite-id"

                            self.rewrite_id_type = YLeaf(YType.enumeration, "rewrite-id-type")

                            self.label_context = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext()
                            self.label_context.parent = self
                            self._children_name_map["label_context"] = "label-context"
                            self._children_yang_names.add("label-context")

                            self.local_label_rewrite = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LocalLabelRewrite()
                            self.local_label_rewrite.parent = self
                            self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                            self._children_yang_names.add("local-label-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("rewrite_id_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId, self).__setattr__(name, value)


                        class LabelContext(Entity):
                            """
                            Label context
                            
                            .. attribute:: cev4l3vpn_data
                            
                            	L3VPN CEv4 label context
                            	**type**\:   :py:class:`Cev4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev4L3VpnData>`
                            
                            .. attribute:: cev6l3vpn_data
                            
                            	L3VPN CEv6 label context
                            	**type**\:   :py:class:`Cev6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev6L3VpnData>`
                            
                            .. attribute:: evpn_data
                            
                            	EVPN context
                            	**type**\:   :py:class:`EvpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.EvpnData>`
                            
                            .. attribute:: generic_routing_encapsulation
                            
                            	Generic routing encapsulation context
                            	**type**\:   :py:class:`GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation>`
                            
                            .. attribute:: ip_sub_data
                            
                            	IP Subscriber context
                            	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.IpSubData>`
                            
                            .. attribute:: ipv4_data
                            
                            	IPv4 label context
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4Data>`
                            
                            .. attribute:: ipv4blb_data
                            
                            	BFD BLB label context
                            	**type**\:   :py:class:`Ipv4BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4BlbData>`
                            
                            .. attribute:: ipv4l3vpn_data
                            
                            	L3VPN IPv4 label context
                            	**type**\:   :py:class:`Ipv4L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData>`
                            
                            .. attribute:: ipv6_data
                            
                            	IPv6 label context
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6Data>`
                            
                            .. attribute:: ipv6_generic_routing_encapsulation
                            
                            	Generic routing encapsulation context
                            	**type**\:   :py:class:`Ipv6GenericRoutingEncapsulation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation>`
                            
                            .. attribute:: ipv6blb_data
                            
                            	BFD BLB label context
                            	**type**\:   :py:class:`Ipv6BlbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6BlbData>`
                            
                            .. attribute:: ipv6l3vpn_data
                            
                            	L3VPN IPv6 label context
                            	**type**\:   :py:class:`Ipv6L3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData>`
                            
                            .. attribute:: label_block_data
                            
                            	Label block context
                            	**type**\:   :py:class:`LabelBlockData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockData>`
                            
                            .. attribute:: label_block_srgb_data
                            
                            	Label block SRGB context
                            	**type**\:   :py:class:`LabelBlockSrgbData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData>`
                            
                            .. attribute:: label_context_type
                            
                            	LabelContextType
                            	**type**\:   :py:class:`MgmtLsdLblCtx <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdLblCtx>`
                            
                            .. attribute:: mld_pv4_data
                            
                            	MLDPv4 LSM\-ID context
                            	**type**\:   :py:class:`MldPv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.MldPv4Data>`
                            
                            .. attribute:: next_hop_set_l3vpn
                            
                            	L3VPN NH SET label context
                            	**type**\:   :py:class:`NextHopSetL3Vpn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn>`
                            
                            .. attribute:: pi_mi_pmsi_data
                            
                            	PIM I\-PMSI label conext
                            	**type**\:   :py:class:`PiMiPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMiPmsiData>`
                            
                            .. attribute:: pi_ms_pmsi_data
                            
                            	PIM S\-PMSI label conext
                            	**type**\:   :py:class:`PiMsPmsiData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMsPmsiData>`
                            
                            .. attribute:: pseudowire_data
                            
                            	Pseudowire label context
                            	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireData>`
                            
                            .. attribute:: pseudowire_head_end_data
                            
                            	Pseudowire Head\-end label context
                            	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData>`
                            
                            .. attribute:: sr_adj_segment_ipv4
                            
                            	SR Adj Segment ipv4 context
                            	**type**\:   :py:class:`SrAdjSegmentIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4>`
                            
                            .. attribute:: sr_adj_segment_ipv6
                            
                            	SR Adj Segment ipv6 context
                            	**type**\:   :py:class:`SrAdjSegmentIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6>`
                            
                            .. attribute:: sr_prefix_segment
                            
                            	SR Prefix Segment context
                            	**type**\:   :py:class:`SrPrefixSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrPrefixSegment>`
                            
                            .. attribute:: te_binding
                            
                            	MPLS TE tunnel binding context
                            	**type**\:   :py:class:`TeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TeBinding>`
                            
                            .. attribute:: tev4_data
                            
                            	TEv4 label context
                            	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4Data>`
                            
                            .. attribute:: tev4p2mp_data
                            
                            	TEv4 P2MP context
                            	**type**\:   :py:class:`Tev4P2MpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4P2MpData>`
                            
                            .. attribute:: tp_data
                            
                            	TP context
                            	**type**\:   :py:class:`TpData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TpData>`
                            
                            .. attribute:: vrf_l3vpn_data
                            
                            	L3VPN VRF label context
                            	**type**\:   :py:class:`VrfL3VpnData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.VrfL3VpnData>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext, self).__init__()

                                self.yang_name = "label-context"
                                self.yang_parent_name = "rewrite-id"

                                self.label_context_type = YLeaf(YType.enumeration, "label-context-type")

                                self.cev4l3vpn_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                self.cev4l3vpn_data.parent = self
                                self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                self._children_yang_names.add("cev4l3vpn-data")

                                self.cev6l3vpn_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                self.cev6l3vpn_data.parent = self
                                self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                self._children_yang_names.add("cev6l3vpn-data")

                                self.evpn_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.EvpnData()
                                self.evpn_data.parent = self
                                self._children_name_map["evpn_data"] = "evpn-data"
                                self._children_yang_names.add("evpn-data")

                                self.generic_routing_encapsulation = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                self.generic_routing_encapsulation.parent = self
                                self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                self._children_yang_names.add("generic-routing-encapsulation")

                                self.ip_sub_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.IpSubData()
                                self.ip_sub_data.parent = self
                                self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                self._children_yang_names.add("ip-sub-data")

                                self.ipv4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv4blb_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                self.ipv4blb_data.parent = self
                                self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                self._children_yang_names.add("ipv4blb-data")

                                self.ipv4l3vpn_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                self.ipv4l3vpn_data.parent = self
                                self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                self._children_yang_names.add("ipv4l3vpn-data")

                                self.ipv6_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.ipv6_generic_routing_encapsulation = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                self.ipv6_generic_routing_encapsulation.parent = self
                                self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                self._children_yang_names.add("ipv6-generic-routing-encapsulation")

                                self.ipv6blb_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                self.ipv6blb_data.parent = self
                                self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                self._children_yang_names.add("ipv6blb-data")

                                self.ipv6l3vpn_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                self.ipv6l3vpn_data.parent = self
                                self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                self._children_yang_names.add("ipv6l3vpn-data")

                                self.label_block_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                self.label_block_data.parent = self
                                self._children_name_map["label_block_data"] = "label-block-data"
                                self._children_yang_names.add("label-block-data")

                                self.label_block_srgb_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                self.label_block_srgb_data.parent = self
                                self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                self._children_yang_names.add("label-block-srgb-data")

                                self.mld_pv4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                self.mld_pv4_data.parent = self
                                self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                self._children_yang_names.add("mld-pv4-data")

                                self.next_hop_set_l3vpn = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                self.next_hop_set_l3vpn.parent = self
                                self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                self._children_yang_names.add("next-hop-set-l3vpn")

                                self.pi_mi_pmsi_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                self.pi_mi_pmsi_data.parent = self
                                self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                self._children_yang_names.add("pi-mi-pmsi-data")

                                self.pi_ms_pmsi_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                self.pi_ms_pmsi_data.parent = self
                                self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                self._children_yang_names.add("pi-ms-pmsi-data")

                                self.pseudowire_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireData()
                                self.pseudowire_data.parent = self
                                self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                self._children_yang_names.add("pseudowire-data")

                                self.pseudowire_head_end_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                self.pseudowire_head_end_data.parent = self
                                self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                self._children_yang_names.add("pseudowire-head-end-data")

                                self.sr_adj_segment_ipv4 = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                self.sr_adj_segment_ipv4.parent = self
                                self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                self._children_yang_names.add("sr-adj-segment-ipv4")

                                self.sr_adj_segment_ipv6 = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                self.sr_adj_segment_ipv6.parent = self
                                self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                self._children_yang_names.add("sr-adj-segment-ipv6")

                                self.sr_prefix_segment = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                self.sr_prefix_segment.parent = self
                                self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                self._children_yang_names.add("sr-prefix-segment")

                                self.te_binding = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TeBinding()
                                self.te_binding.parent = self
                                self._children_name_map["te_binding"] = "te-binding"
                                self._children_yang_names.add("te-binding")

                                self.tev4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4Data()
                                self.tev4_data.parent = self
                                self._children_name_map["tev4_data"] = "tev4-data"
                                self._children_yang_names.add("tev4-data")

                                self.tev4p2mp_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                self.tev4p2mp_data.parent = self
                                self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                self._children_yang_names.add("tev4p2mp-data")

                                self.tp_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TpData()
                                self.tp_data.parent = self
                                self._children_name_map["tp_data"] = "tp-data"
                                self._children_yang_names.add("tp-data")

                                self.vrf_l3vpn_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                self.vrf_l3vpn_data.parent = self
                                self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                self._children_yang_names.add("vrf-l3vpn-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_context_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext, self).__setattr__(name, value)


                            class Ipv4Data(Entity):
                                """
                                IPv4 label context
                                
                                .. attribute:: prefix
                                
                                	IPv4 prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	IPv4 prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf_name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                	**length:** 0..33
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.vrf_name = YLeaf(YType.str, "vrf-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "security_id",
                                                    "table_id",
                                                    "vrf_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set or
                                        self.vrf_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.vrf_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-name"):
                                        self.vrf_name = value
                                        self.vrf_name.value_namespace = name_space
                                        self.vrf_name.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                IPv6 label context
                                
                                .. attribute:: prefix
                                
                                	Prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf_name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                	**length:** 0..33
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.vrf_name = YLeaf(YType.str, "vrf-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "security_id",
                                                    "table_id",
                                                    "vrf_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set or
                                        self.vrf_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.vrf_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "security-id" or name == "table-id" or name == "vrf-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-name"):
                                        self.vrf_name = value
                                        self.vrf_name.value_namespace = name_space
                                        self.vrf_name.value_namespace_prefix = name_space_prefix


                            class Tev4Data(Entity):
                                """
                                TEv4 label context
                                
                                .. attribute:: is_srte
                                
                                	Is this an SRTE head tunnel
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_dest
                                
                                	Tunnel destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_id_extension
                                
                                	Extended tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_lsp_id
                                
                                	Tunnel LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_source
                                
                                	Tunnel source
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4Data, self).__init__()

                                    self.yang_name = "tev4-data"
                                    self.yang_parent_name = "label-context"

                                    self.is_srte = YLeaf(YType.int32, "is-srte")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.tunnel_dest = YLeaf(YType.str, "tunnel-dest")

                                    self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                    self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                    self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                    self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_srte",
                                                    "table_id",
                                                    "tunnel_dest",
                                                    "tunnel_id",
                                                    "tunnel_id_extension",
                                                    "tunnel_lsp_id",
                                                    "tunnel_source") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_srte.is_set or
                                        self.table_id.is_set or
                                        self.tunnel_dest.is_set or
                                        self.tunnel_id.is_set or
                                        self.tunnel_id_extension.is_set or
                                        self.tunnel_lsp_id.is_set or
                                        self.tunnel_source.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_srte.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.tunnel_dest.yfilter != YFilter.not_set or
                                        self.tunnel_id.yfilter != YFilter.not_set or
                                        self.tunnel_id_extension.yfilter != YFilter.not_set or
                                        self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                        self.tunnel_source.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tev4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_srte.is_set or self.is_srte.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_srte.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.tunnel_dest.is_set or self.tunnel_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_dest.get_name_leafdata())
                                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                    if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                    if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                    if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-srte" or name == "table-id" or name == "tunnel-dest" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-srte"):
                                        self.is_srte = value
                                        self.is_srte.value_namespace = name_space
                                        self.is_srte.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-dest"):
                                        self.tunnel_dest = value
                                        self.tunnel_dest.value_namespace = name_space
                                        self.tunnel_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id"):
                                        self.tunnel_id = value
                                        self.tunnel_id.value_namespace = name_space
                                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id-extension"):
                                        self.tunnel_id_extension = value
                                        self.tunnel_id_extension.value_namespace = name_space
                                        self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-lsp-id"):
                                        self.tunnel_lsp_id = value
                                        self.tunnel_lsp_id.value_namespace = name_space
                                        self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-source"):
                                        self.tunnel_source = value
                                        self.tunnel_source.value_namespace = name_space
                                        self.tunnel_source.value_namespace_prefix = name_space_prefix


                            class Ipv4L3VpnData(Entity):
                                """
                                L3VPN IPv4 label context
                                
                                .. attribute:: prefix
                                
                                	IPv4 prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: route_distinguisher
                                
                                	Route distinguisher
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__init__()

                                    self.yang_name = "ipv4l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "route_distinguisher") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.route_distinguisher.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.route_distinguisher.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-distinguisher"):
                                        self.route_distinguisher = value
                                        self.route_distinguisher.value_namespace = name_space
                                        self.route_distinguisher.value_namespace_prefix = name_space_prefix


                            class Ipv6L3VpnData(Entity):
                                """
                                L3VPN IPv6 label context
                                
                                .. attribute:: prefix
                                
                                	IPv6 prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: route_distinguisher
                                
                                	Route distinguisher
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__init__()

                                    self.yang_name = "ipv6l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.route_distinguisher = YLeaf(YType.uint64, "route-distinguisher")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "route_distinguisher") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.route_distinguisher.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.route_distinguisher.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.route_distinguisher.is_set or self.route_distinguisher.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.route_distinguisher.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "prefix-length" or name == "route-distinguisher"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "route-distinguisher"):
                                        self.route_distinguisher = value
                                        self.route_distinguisher.value_namespace = name_space
                                        self.route_distinguisher.value_namespace_prefix = name_space_prefix


                            class VrfL3VpnData(Entity):
                                """
                                L3VPN VRF label context
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__init__()

                                    self.yang_name = "vrf-l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("security_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.VrfL3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.security_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf-l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "security-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class Cev4L3VpnData(Entity):
                                """
                                L3VPN CEv4 label context
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__init__()

                                    self.yang_name = "cev4l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_next_hop",
                                                    "security_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev4L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ipv4_next_hop.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "cev4l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-next-hop" or name == "security-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class Cev6L3VpnData(Entity):
                                """
                                L3VPN CEv6 label context
                                
                                .. attribute:: ipv6_next_hop
                                
                                	IPv6 nexthop
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: security_id
                                
                                	Security ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__init__()

                                    self.yang_name = "cev6l3vpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                    self.security_id = YLeaf(YType.uint32, "security-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv6_next_hop",
                                                    "security_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev6L3VpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ipv6_next_hop.is_set or
                                        self.security_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv6_next_hop.yfilter != YFilter.not_set or
                                        self.security_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "cev6l3vpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                    if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.security_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv6-next-hop" or name == "security-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv6-next-hop"):
                                        self.ipv6_next_hop = value
                                        self.ipv6_next_hop.value_namespace = name_space
                                        self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "security-id"):
                                        self.security_id = value
                                        self.security_id.value_namespace = name_space
                                        self.security_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class PseudowireData(Entity):
                                """
                                Pseudowire label context
                                
                                .. attribute:: prefix
                                
                                	Address prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: pseudowire_id
                                
                                	Pseudo\-wire ID
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: remote_l2_router_id
                                
                                	Remote L2 Router ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: subinterface
                                
                                	Subinterface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireData, self).__init__()

                                    self.yang_name = "pseudowire-data"
                                    self.yang_parent_name = "label-context"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.pseudowire_id = YLeaf(YType.uint64, "pseudowire-id")

                                    self.remote_l2_router_id = YLeaf(YType.uint32, "remote-l2-router-id")

                                    self.subinterface = YLeaf(YType.str, "subinterface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "pseudowire_id",
                                                    "remote_l2_router_id",
                                                    "subinterface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.prefix.is_set or
                                        self.pseudowire_id.is_set or
                                        self.remote_l2_router_id.is_set or
                                        self.subinterface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.pseudowire_id.yfilter != YFilter.not_set or
                                        self.remote_l2_router_id.yfilter != YFilter.not_set or
                                        self.subinterface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pseudowire_id.get_name_leafdata())
                                    if (self.remote_l2_router_id.is_set or self.remote_l2_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.remote_l2_router_id.get_name_leafdata())
                                    if (self.subinterface.is_set or self.subinterface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.subinterface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prefix" or name == "pseudowire-id" or name == "remote-l2-router-id" or name == "subinterface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pseudowire-id"):
                                        self.pseudowire_id = value
                                        self.pseudowire_id.value_namespace = name_space
                                        self.pseudowire_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "remote-l2-router-id"):
                                        self.remote_l2_router_id = value
                                        self.remote_l2_router_id.value_namespace = name_space
                                        self.remote_l2_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "subinterface"):
                                        self.subinterface = value
                                        self.subinterface.value_namespace = name_space
                                        self.subinterface.value_namespace_prefix = name_space_prefix


                            class LabelBlockData(Entity):
                                """
                                Label block context
                                
                                .. attribute:: edge_id
                                
                                	Edge ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: offset
                                
                                	Offset
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: service
                                
                                	Service
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: size
                                
                                	Number of labels
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vpn_id
                                
                                	VPN ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__init__()

                                    self.yang_name = "label-block-data"
                                    self.yang_parent_name = "label-context"

                                    self.edge_id = YLeaf(YType.uint16, "edge-id")

                                    self.offset = YLeaf(YType.uint32, "offset")

                                    self.service = YLeaf(YType.uint8, "service")

                                    self.size = YLeaf(YType.uint32, "size")

                                    self.vpn_id = YLeaf(YType.uint16, "vpn-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("edge_id",
                                                    "offset",
                                                    "service",
                                                    "size",
                                                    "vpn_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.edge_id.is_set or
                                        self.offset.is_set or
                                        self.service.is_set or
                                        self.size.is_set or
                                        self.vpn_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.edge_id.yfilter != YFilter.not_set or
                                        self.offset.yfilter != YFilter.not_set or
                                        self.service.yfilter != YFilter.not_set or
                                        self.size.yfilter != YFilter.not_set or
                                        self.vpn_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-block-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.edge_id.is_set or self.edge_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.edge_id.get_name_leafdata())
                                    if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.offset.get_name_leafdata())
                                    if (self.service.is_set or self.service.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service.get_name_leafdata())
                                    if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.size.get_name_leafdata())
                                    if (self.vpn_id.is_set or self.vpn_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vpn_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "edge-id" or name == "offset" or name == "service" or name == "size" or name == "vpn-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "edge-id"):
                                        self.edge_id = value
                                        self.edge_id.value_namespace = name_space
                                        self.edge_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "offset"):
                                        self.offset = value
                                        self.offset.value_namespace = name_space
                                        self.offset.value_namespace_prefix = name_space_prefix
                                    if(value_path == "service"):
                                        self.service = value
                                        self.service.value_namespace = name_space
                                        self.service.value_namespace_prefix = name_space_prefix
                                    if(value_path == "size"):
                                        self.size = value
                                        self.size.value_namespace = name_space
                                        self.size.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vpn-id"):
                                        self.vpn_id = value
                                        self.vpn_id.value_namespace = name_space
                                        self.vpn_id.value_namespace_prefix = name_space_prefix


                            class IpSubData(Entity):
                                """
                                IP Subscriber context
                                
                                .. attribute:: parent_interface
                                
                                	Parent interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: table_id
                                
                                	Table Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.IpSubData, self).__init__()

                                    self.yang_name = "ip-sub-data"
                                    self.yang_parent_name = "label-context"

                                    self.parent_interface = YLeaf(YType.str, "parent-interface")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("parent_interface",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.IpSubData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.parent_interface.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.parent_interface.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ip-sub-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.parent_interface.is_set or self.parent_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "parent-interface" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "parent-interface"):
                                        self.parent_interface = value
                                        self.parent_interface.value_namespace = name_space
                                        self.parent_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class Tev4P2MpData(Entity):
                                """
                                TEv4 P2MP context
                                
                                .. attribute:: p2mp_id
                                
                                	Point to multipoint ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: previous_hop
                                
                                	Previous hop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_id_extension
                                
                                	Tunnel ID extension
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_lsp_id
                                
                                	Tunnel LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_source
                                
                                	Tunnel source
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__init__()

                                    self.yang_name = "tev4p2mp-data"
                                    self.yang_parent_name = "label-context"

                                    self.p2mp_id = YLeaf(YType.uint32, "p2mp-id")

                                    self.previous_hop = YLeaf(YType.str, "previous-hop")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                                    self.tunnel_id_extension = YLeaf(YType.uint32, "tunnel-id-extension")

                                    self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                                    self.tunnel_source = YLeaf(YType.str, "tunnel-source")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("p2mp_id",
                                                    "previous_hop",
                                                    "table_id",
                                                    "tunnel_id",
                                                    "tunnel_id_extension",
                                                    "tunnel_lsp_id",
                                                    "tunnel_source") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4P2MpData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.p2mp_id.is_set or
                                        self.previous_hop.is_set or
                                        self.table_id.is_set or
                                        self.tunnel_id.is_set or
                                        self.tunnel_id_extension.is_set or
                                        self.tunnel_lsp_id.is_set or
                                        self.tunnel_source.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.p2mp_id.yfilter != YFilter.not_set or
                                        self.previous_hop.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.tunnel_id.yfilter != YFilter.not_set or
                                        self.tunnel_id_extension.yfilter != YFilter.not_set or
                                        self.tunnel_lsp_id.yfilter != YFilter.not_set or
                                        self.tunnel_source.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tev4p2mp-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                                    if (self.previous_hop.is_set or self.previous_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.previous_hop.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                    if (self.tunnel_id_extension.is_set or self.tunnel_id_extension.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id_extension.get_name_leafdata())
                                    if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                                    if (self.tunnel_source.is_set or self.tunnel_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_source.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "p2mp-id" or name == "previous-hop" or name == "table-id" or name == "tunnel-id" or name == "tunnel-id-extension" or name == "tunnel-lsp-id" or name == "tunnel-source"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "p2mp-id"):
                                        self.p2mp_id = value
                                        self.p2mp_id.value_namespace = name_space
                                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "previous-hop"):
                                        self.previous_hop = value
                                        self.previous_hop.value_namespace = name_space
                                        self.previous_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id"):
                                        self.tunnel_id = value
                                        self.tunnel_id.value_namespace = name_space
                                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id-extension"):
                                        self.tunnel_id_extension = value
                                        self.tunnel_id_extension.value_namespace = name_space
                                        self.tunnel_id_extension.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-lsp-id"):
                                        self.tunnel_lsp_id = value
                                        self.tunnel_lsp_id.value_namespace = name_space
                                        self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-source"):
                                        self.tunnel_source = value
                                        self.tunnel_source.value_namespace = name_space
                                        self.tunnel_source.value_namespace_prefix = name_space_prefix


                            class MldPv4Data(Entity):
                                """
                                MLDPv4 LSM\-ID context
                                
                                .. attribute:: lsm_id
                                
                                	LSM ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: peer_label_space_id
                                
                                	Peer Label Space Id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: peer_lsrid
                                
                                	Peer LSR Id
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: type
                                
                                	LSM ID Type
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__init__()

                                    self.yang_name = "mld-pv4-data"
                                    self.yang_parent_name = "label-context"

                                    self.lsm_id = YLeaf(YType.uint32, "lsm-id")

                                    self.peer_label_space_id = YLeaf(YType.uint16, "peer-label-space-id")

                                    self.peer_lsrid = YLeaf(YType.str, "peer-lsrid")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("lsm_id",
                                                    "peer_label_space_id",
                                                    "peer_lsrid",
                                                    "table_id",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.MldPv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.lsm_id.is_set or
                                        self.peer_label_space_id.is_set or
                                        self.peer_lsrid.is_set or
                                        self.table_id.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.lsm_id.yfilter != YFilter.not_set or
                                        self.peer_label_space_id.yfilter != YFilter.not_set or
                                        self.peer_lsrid.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "mld-pv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.lsm_id.is_set or self.lsm_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsm_id.get_name_leafdata())
                                    if (self.peer_label_space_id.is_set or self.peer_label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_label_space_id.get_name_leafdata())
                                    if (self.peer_lsrid.is_set or self.peer_lsrid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_lsrid.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "lsm-id" or name == "peer-label-space-id" or name == "peer-lsrid" or name == "table-id" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "lsm-id"):
                                        self.lsm_id = value
                                        self.lsm_id.value_namespace = name_space
                                        self.lsm_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-label-space-id"):
                                        self.peer_label_space_id = value
                                        self.peer_label_space_id.value_namespace = name_space
                                        self.peer_label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-lsrid"):
                                        self.peer_lsrid = value
                                        self.peer_lsrid.value_namespace = name_space
                                        self.peer_lsrid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class PseudowireHeadEndData(Entity):
                                """
                                Pseudowire Head\-end label context
                                
                                .. attribute:: pwhe_intf
                                
                                	Pseudo\-wire Head\-end interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__init__()

                                    self.yang_name = "pseudowire-head-end-data"
                                    self.yang_parent_name = "label-context"

                                    self.pwhe_intf = YLeaf(YType.str, "pwhe-intf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("pwhe_intf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.pwhe_intf.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.pwhe_intf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-head-end-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.pwhe_intf.is_set or self.pwhe_intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_intf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "pwhe-intf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "pwhe-intf"):
                                        self.pwhe_intf = value
                                        self.pwhe_intf.value_namespace = name_space
                                        self.pwhe_intf.value_namespace_prefix = name_space_prefix


                            class TpData(Entity):
                                """
                                TP context
                                
                                .. attribute:: dest_global_id
                                
                                	TP destination global ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: dest_node_id
                                
                                	TP destination node ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: dest_tunnel_id
                                
                                	TP destination tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsp_id
                                
                                	TP LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: source_global_id
                                
                                	TP source global ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: source_node_id
                                
                                	TP source node ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: source_tunnel_id
                                
                                	TP source tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TpData, self).__init__()

                                    self.yang_name = "tp-data"
                                    self.yang_parent_name = "label-context"

                                    self.dest_global_id = YLeaf(YType.uint32, "dest-global-id")

                                    self.dest_node_id = YLeaf(YType.str, "dest-node-id")

                                    self.dest_tunnel_id = YLeaf(YType.uint16, "dest-tunnel-id")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                    self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                                    self.source_node_id = YLeaf(YType.str, "source-node-id")

                                    self.source_tunnel_id = YLeaf(YType.uint16, "source-tunnel-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dest_global_id",
                                                    "dest_node_id",
                                                    "dest_tunnel_id",
                                                    "lsp_id",
                                                    "source_global_id",
                                                    "source_node_id",
                                                    "source_tunnel_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TpData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.dest_global_id.is_set or
                                        self.dest_node_id.is_set or
                                        self.dest_tunnel_id.is_set or
                                        self.lsp_id.is_set or
                                        self.source_global_id.is_set or
                                        self.source_node_id.is_set or
                                        self.source_tunnel_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dest_global_id.yfilter != YFilter.not_set or
                                        self.dest_node_id.yfilter != YFilter.not_set or
                                        self.dest_tunnel_id.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set or
                                        self.source_global_id.yfilter != YFilter.not_set or
                                        self.source_node_id.yfilter != YFilter.not_set or
                                        self.source_tunnel_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tp-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dest_global_id.is_set or self.dest_global_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dest_global_id.get_name_leafdata())
                                    if (self.dest_node_id.is_set or self.dest_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dest_node_id.get_name_leafdata())
                                    if (self.dest_tunnel_id.is_set or self.dest_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dest_tunnel_id.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                                    if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_global_id.get_name_leafdata())
                                    if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_node_id.get_name_leafdata())
                                    if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dest-global-id" or name == "dest-node-id" or name == "dest-tunnel-id" or name == "lsp-id" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dest-global-id"):
                                        self.dest_global_id = value
                                        self.dest_global_id.value_namespace = name_space
                                        self.dest_global_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dest-node-id"):
                                        self.dest_node_id = value
                                        self.dest_node_id.value_namespace = name_space
                                        self.dest_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dest-tunnel-id"):
                                        self.dest_tunnel_id = value
                                        self.dest_tunnel_id.value_namespace = name_space
                                        self.dest_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-global-id"):
                                        self.source_global_id = value
                                        self.source_global_id.value_namespace = name_space
                                        self.source_global_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-node-id"):
                                        self.source_node_id = value
                                        self.source_node_id.value_namespace = name_space
                                        self.source_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-tunnel-id"):
                                        self.source_tunnel_id = value
                                        self.source_tunnel_id.value_namespace = name_space
                                        self.source_tunnel_id.value_namespace_prefix = name_space_prefix


                            class GenericRoutingEncapsulation(Entity):
                                """
                                Generic routing encapsulation context
                                
                                .. attribute:: gre_interface
                                
                                	Generic routing encapsulation interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__init__()

                                    self.yang_name = "generic-routing-encapsulation"
                                    self.yang_parent_name = "label-context"

                                    self.gre_interface = YLeaf(YType.str, "gre-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("gre_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.gre_interface.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.gre_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "generic-routing-encapsulation" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.gre_interface.is_set or self.gre_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gre_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "gre-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "gre-interface"):
                                        self.gre_interface = value
                                        self.gre_interface.value_namespace = name_space
                                        self.gre_interface.value_namespace_prefix = name_space_prefix


                            class Ipv6GenericRoutingEncapsulation(Entity):
                                """
                                Generic routing encapsulation context
                                
                                .. attribute:: greipv6_interface
                                
                                	Generic routing encapsulation IPv6 interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__init__()

                                    self.yang_name = "ipv6-generic-routing-encapsulation"
                                    self.yang_parent_name = "label-context"

                                    self.greipv6_interface = YLeaf(YType.str, "greipv6-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("greipv6_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.greipv6_interface.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.greipv6_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-generic-routing-encapsulation" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.greipv6_interface.is_set or self.greipv6_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.greipv6_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "greipv6-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "greipv6-interface"):
                                        self.greipv6_interface = value
                                        self.greipv6_interface.value_namespace = name_space
                                        self.greipv6_interface.value_namespace_prefix = name_space_prefix


                            class EvpnData(Entity):
                                """
                                EVPN context
                                
                                .. attribute:: ethernet_segment
                                
                                	Ethernet Segment ID
                                	**type**\:  str
                                
                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                
                                .. attribute:: evpn_id
                                
                                	EVPN ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: evpn_tag
                                
                                	EVPN TAG
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.EvpnData, self).__init__()

                                    self.yang_name = "evpn-data"
                                    self.yang_parent_name = "label-context"

                                    self.ethernet_segment = YLeaf(YType.str, "ethernet-segment")

                                    self.evpn_id = YLeaf(YType.uint32, "evpn-id")

                                    self.evpn_tag = YLeaf(YType.uint32, "evpn-tag")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ethernet_segment",
                                                    "evpn_id",
                                                    "evpn_tag") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.EvpnData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ethernet_segment.is_set or
                                        self.evpn_id.is_set or
                                        self.evpn_tag.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ethernet_segment.yfilter != YFilter.not_set or
                                        self.evpn_id.yfilter != YFilter.not_set or
                                        self.evpn_tag.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "evpn-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ethernet_segment.is_set or self.ethernet_segment.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ethernet_segment.get_name_leafdata())
                                    if (self.evpn_id.is_set or self.evpn_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.evpn_id.get_name_leafdata())
                                    if (self.evpn_tag.is_set or self.evpn_tag.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.evpn_tag.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ethernet-segment" or name == "evpn-id" or name == "evpn-tag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ethernet-segment"):
                                        self.ethernet_segment = value
                                        self.ethernet_segment.value_namespace = name_space
                                        self.ethernet_segment.value_namespace_prefix = name_space_prefix
                                    if(value_path == "evpn-id"):
                                        self.evpn_id = value
                                        self.evpn_id.value_namespace = name_space
                                        self.evpn_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "evpn-tag"):
                                        self.evpn_tag = value
                                        self.evpn_tag.value_namespace = name_space
                                        self.evpn_tag.value_namespace_prefix = name_space_prefix


                            class Ipv4BlbData(Entity):
                                """
                                BFD BLB label context
                                
                                .. attribute:: blb_intf
                                
                                	BFD BLB interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: prefix
                                
                                	IPv4 prefix
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__init__()

                                    self.yang_name = "ipv4blb-data"
                                    self.yang_parent_name = "label-context"

                                    self.blb_intf = YLeaf(YType.str, "blb-intf")

                                    self.prefix = YLeaf(YType.str, "prefix")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("blb_intf",
                                                    "prefix") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4BlbData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.blb_intf.is_set or
                                        self.prefix.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.blb_intf.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4blb-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "blb-intf" or name == "prefix"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "blb-intf"):
                                        self.blb_intf = value
                                        self.blb_intf.value_namespace = name_space
                                        self.blb_intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix


                            class Ipv6BlbData(Entity):
                                """
                                BFD BLB label context
                                
                                .. attribute:: blb_intf
                                
                                	BFD BLB interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: prefix
                                
                                	IPv6 prefix
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__init__()

                                    self.yang_name = "ipv6blb-data"
                                    self.yang_parent_name = "label-context"

                                    self.blb_intf = YLeaf(YType.str, "blb-intf")

                                    self.prefix = YLeaf(YType.str, "prefix")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("blb_intf",
                                                    "prefix") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6BlbData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.blb_intf.is_set or
                                        self.prefix.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.blb_intf.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6blb-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.blb_intf.is_set or self.blb_intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.blb_intf.get_name_leafdata())
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "blb-intf" or name == "prefix"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "blb-intf"):
                                        self.blb_intf = value
                                        self.blb_intf.value_namespace = name_space
                                        self.blb_intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix


                            class PiMiPmsiData(Entity):
                                """
                                PIM I\-PMSI label conext
                                
                                .. attribute:: head
                                
                                	Head
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: v6
                                
                                	PIM6
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: vrf_id
                                
                                	VRF ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__init__()

                                    self.yang_name = "pi-mi-pmsi-data"
                                    self.yang_parent_name = "label-context"

                                    self.head = YLeaf(YType.int32, "head")

                                    self.v6 = YLeaf(YType.int32, "v6")

                                    self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("head",
                                                    "v6",
                                                    "vrf_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMiPmsiData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.head.is_set or
                                        self.v6.is_set or
                                        self.vrf_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.head.yfilter != YFilter.not_set or
                                        self.v6.yfilter != YFilter.not_set or
                                        self.vrf_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pi-mi-pmsi-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.head.get_name_leafdata())
                                    if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.v6.get_name_leafdata())
                                    if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "head" or name == "v6" or name == "vrf-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "head"):
                                        self.head = value
                                        self.head.value_namespace = name_space
                                        self.head.value_namespace_prefix = name_space_prefix
                                    if(value_path == "v6"):
                                        self.v6 = value
                                        self.v6.value_namespace = name_space
                                        self.v6.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-id"):
                                        self.vrf_id = value
                                        self.vrf_id.value_namespace = name_space
                                        self.vrf_id.value_namespace_prefix = name_space_prefix


                            class PiMsPmsiData(Entity):
                                """
                                PIM S\-PMSI label conext
                                
                                .. attribute:: head
                                
                                	Head
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: hli
                                
                                	Head LSM\-ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: seg
                                
                                	Segmented Multicast
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: source
                                
                                	Originating Router
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: v6
                                
                                	PIM6
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: vrf_id
                                
                                	VRF ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__init__()

                                    self.yang_name = "pi-ms-pmsi-data"
                                    self.yang_parent_name = "label-context"

                                    self.head = YLeaf(YType.int32, "head")

                                    self.hli = YLeaf(YType.uint32, "hli")

                                    self.seg = YLeaf(YType.int32, "seg")

                                    self.source = YLeaf(YType.str, "source")

                                    self.v6 = YLeaf(YType.int32, "v6")

                                    self.vrf_id = YLeaf(YType.uint32, "vrf-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("head",
                                                    "hli",
                                                    "seg",
                                                    "source",
                                                    "v6",
                                                    "vrf_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMsPmsiData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.head.is_set or
                                        self.hli.is_set or
                                        self.seg.is_set or
                                        self.source.is_set or
                                        self.v6.is_set or
                                        self.vrf_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.head.yfilter != YFilter.not_set or
                                        self.hli.yfilter != YFilter.not_set or
                                        self.seg.yfilter != YFilter.not_set or
                                        self.source.yfilter != YFilter.not_set or
                                        self.v6.yfilter != YFilter.not_set or
                                        self.vrf_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pi-ms-pmsi-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.head.is_set or self.head.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.head.get_name_leafdata())
                                    if (self.hli.is_set or self.hli.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hli.get_name_leafdata())
                                    if (self.seg.is_set or self.seg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.seg.get_name_leafdata())
                                    if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source.get_name_leafdata())
                                    if (self.v6.is_set or self.v6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.v6.get_name_leafdata())
                                    if (self.vrf_id.is_set or self.vrf_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vrf_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "head" or name == "hli" or name == "seg" or name == "source" or name == "v6" or name == "vrf-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "head"):
                                        self.head = value
                                        self.head.value_namespace = name_space
                                        self.head.value_namespace_prefix = name_space_prefix
                                    if(value_path == "hli"):
                                        self.hli = value
                                        self.hli.value_namespace = name_space
                                        self.hli.value_namespace_prefix = name_space_prefix
                                    if(value_path == "seg"):
                                        self.seg = value
                                        self.seg.value_namespace = name_space
                                        self.seg.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source"):
                                        self.source = value
                                        self.source.value_namespace = name_space
                                        self.source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "v6"):
                                        self.v6 = value
                                        self.v6.value_namespace = name_space
                                        self.v6.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vrf-id"):
                                        self.vrf_id = value
                                        self.vrf_id.value_namespace = name_space
                                        self.vrf_id.value_namespace_prefix = name_space_prefix


                            class NextHopSetL3Vpn(Entity):
                                """
                                L3VPN NH SET label context
                                
                                .. attribute:: next_hop_set_id
                                
                                	Next Hop Set ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__init__()

                                    self.yang_name = "next-hop-set-l3vpn"
                                    self.yang_parent_name = "label-context"

                                    self.next_hop_set_id = YLeaf(YType.uint32, "next-hop-set-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_set_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.next_hop_set_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_set_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "next-hop-set-l3vpn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_set_id.is_set or self.next_hop_set_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_set_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "next-hop-set-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-set-id"):
                                        self.next_hop_set_id = value
                                        self.next_hop_set_id.value_namespace = name_space
                                        self.next_hop_set_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class SrPrefixSegment(Entity):
                                """
                                SR Prefix Segment context
                                
                                .. attribute:: segment_id
                                
                                	Prefix Segment ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__init__()

                                    self.yang_name = "sr-prefix-segment"
                                    self.yang_parent_name = "label-context"

                                    self.segment_id = YLeaf(YType.uint32, "segment-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("segment_id",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrPrefixSegment, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.segment_id.is_set or
                                        self.table_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.segment_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-prefix-segment" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.segment_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "segment-id" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "segment-id"):
                                        self.segment_id = value
                                        self.segment_id.value_namespace = name_space
                                        self.segment_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix


                            class SrAdjSegmentIpv4(Entity):
                                """
                                SR Adj Segment ipv4 context
                                
                                .. attribute:: addr
                                
                                	Adjacency nexthop IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: index
                                
                                	Adjacency index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: intf
                                
                                	Adjacency interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: type
                                
                                	Adjacency type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__init__()

                                    self.yang_name = "sr-adj-segment-ipv4"
                                    self.yang_parent_name = "label-context"

                                    self.addr = YLeaf(YType.str, "addr")

                                    self.index = YLeaf(YType.uint32, "index")

                                    self.intf = YLeaf(YType.str, "intf")

                                    self.type = YLeaf(YType.uint32, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("addr",
                                                    "index",
                                                    "intf",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.addr.is_set or
                                        self.index.is_set or
                                        self.intf.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.addr.yfilter != YFilter.not_set or
                                        self.index.yfilter != YFilter.not_set or
                                        self.intf.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-adj-segment-ipv4" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.addr.get_name_leafdata())
                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.index.get_name_leafdata())
                                    if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intf.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "addr"):
                                        self.addr = value
                                        self.addr.value_namespace = name_space
                                        self.addr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "index"):
                                        self.index = value
                                        self.index.value_namespace = name_space
                                        self.index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intf"):
                                        self.intf = value
                                        self.intf.value_namespace = name_space
                                        self.intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class SrAdjSegmentIpv6(Entity):
                                """
                                SR Adj Segment ipv6 context
                                
                                .. attribute:: addr
                                
                                	Adjacency nexthop IPv6 address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: index
                                
                                	Adjacency index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: intf
                                
                                	Adjacency interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: type
                                
                                	Adjacency type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__init__()

                                    self.yang_name = "sr-adj-segment-ipv6"
                                    self.yang_parent_name = "label-context"

                                    self.addr = YLeaf(YType.str, "addr")

                                    self.index = YLeaf(YType.uint32, "index")

                                    self.intf = YLeaf(YType.str, "intf")

                                    self.type = YLeaf(YType.uint32, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("addr",
                                                    "index",
                                                    "intf",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.addr.is_set or
                                        self.index.is_set or
                                        self.intf.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.addr.yfilter != YFilter.not_set or
                                        self.index.yfilter != YFilter.not_set or
                                        self.intf.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-adj-segment-ipv6" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.addr.is_set or self.addr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.addr.get_name_leafdata())
                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.index.get_name_leafdata())
                                    if (self.intf.is_set or self.intf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intf.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "addr" or name == "index" or name == "intf" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "addr"):
                                        self.addr = value
                                        self.addr.value_namespace = name_space
                                        self.addr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "index"):
                                        self.index = value
                                        self.index.value_namespace = name_space
                                        self.index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intf"):
                                        self.intf = value
                                        self.intf.value_namespace = name_space
                                        self.intf.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class LabelBlockSrgbData(Entity):
                                """
                                Label block SRGB context
                                
                                .. attribute:: offset
                                
                                	Offset
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: size
                                
                                	Number of labels
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: start_label
                                
                                	Start Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__init__()

                                    self.yang_name = "label-block-srgb-data"
                                    self.yang_parent_name = "label-context"

                                    self.offset = YLeaf(YType.uint32, "offset")

                                    self.size = YLeaf(YType.uint32, "size")

                                    self.start_label = YLeaf(YType.uint32, "start-label")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("offset",
                                                    "size",
                                                    "start_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.offset.is_set or
                                        self.size.is_set or
                                        self.start_label.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.offset.yfilter != YFilter.not_set or
                                        self.size.yfilter != YFilter.not_set or
                                        self.start_label.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-block-srgb-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.offset.is_set or self.offset.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.offset.get_name_leafdata())
                                    if (self.size.is_set or self.size.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.size.get_name_leafdata())
                                    if (self.start_label.is_set or self.start_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.start_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "offset" or name == "size" or name == "start-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "offset"):
                                        self.offset = value
                                        self.offset.value_namespace = name_space
                                        self.offset.value_namespace_prefix = name_space_prefix
                                    if(value_path == "size"):
                                        self.size = value
                                        self.size.value_namespace = name_space
                                        self.size.value_namespace_prefix = name_space_prefix
                                    if(value_path == "start-label"):
                                        self.start_label = value
                                        self.start_label.value_namespace = name_space
                                        self.start_label.value_namespace_prefix = name_space_prefix


                            class TeBinding(Entity):
                                """
                                MPLS TE tunnel binding context
                                
                                .. attribute:: te_identifier
                                
                                	MPLS Traffic Engineering Tunnel or Group ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: te_type
                                
                                	Type of identifier for the binding
                                	**type**\:   :py:class:`MgmtLsdTeBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdTeBinding>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TeBinding, self).__init__()

                                    self.yang_name = "te-binding"
                                    self.yang_parent_name = "label-context"

                                    self.te_identifier = YLeaf(YType.uint32, "te-identifier")

                                    self.te_type = YLeaf(YType.enumeration, "te-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("te_identifier",
                                                    "te_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TeBinding, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.te_identifier.is_set or
                                        self.te_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.te_identifier.yfilter != YFilter.not_set or
                                        self.te_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-binding" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.te_identifier.is_set or self.te_identifier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_identifier.get_name_leafdata())
                                    if (self.te_type.is_set or self.te_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "te-identifier" or name == "te-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "te-identifier"):
                                        self.te_identifier = value
                                        self.te_identifier.value_namespace = name_space
                                        self.te_identifier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "te-type"):
                                        self.te_type = value
                                        self.te_type.value_namespace = name_space
                                        self.te_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.label_context_type.is_set or
                                    (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_data()) or
                                    (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_data()) or
                                    (self.evpn_data is not None and self.evpn_data.has_data()) or
                                    (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_data()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv4blb_data is not None and self.ipv4blb_data.has_data()) or
                                    (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_data()) or
                                    (self.ipv6blb_data is not None and self.ipv6blb_data.has_data()) or
                                    (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_data()) or
                                    (self.label_block_data is not None and self.label_block_data.has_data()) or
                                    (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_data()) or
                                    (self.mld_pv4_data is not None and self.mld_pv4_data.has_data()) or
                                    (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_data()) or
                                    (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_data()) or
                                    (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_data()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                    (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_data()) or
                                    (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_data()) or
                                    (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_data()) or
                                    (self.te_binding is not None and self.te_binding.has_data()) or
                                    (self.tev4_data is not None and self.tev4_data.has_data()) or
                                    (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_data()) or
                                    (self.tp_data is not None and self.tp_data.has_data()) or
                                    (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_context_type.yfilter != YFilter.not_set or
                                    (self.cev4l3vpn_data is not None and self.cev4l3vpn_data.has_operation()) or
                                    (self.cev6l3vpn_data is not None and self.cev6l3vpn_data.has_operation()) or
                                    (self.evpn_data is not None and self.evpn_data.has_operation()) or
                                    (self.generic_routing_encapsulation is not None and self.generic_routing_encapsulation.has_operation()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv4blb_data is not None and self.ipv4blb_data.has_operation()) or
                                    (self.ipv4l3vpn_data is not None and self.ipv4l3vpn_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.ipv6_generic_routing_encapsulation is not None and self.ipv6_generic_routing_encapsulation.has_operation()) or
                                    (self.ipv6blb_data is not None and self.ipv6blb_data.has_operation()) or
                                    (self.ipv6l3vpn_data is not None and self.ipv6l3vpn_data.has_operation()) or
                                    (self.label_block_data is not None and self.label_block_data.has_operation()) or
                                    (self.label_block_srgb_data is not None and self.label_block_srgb_data.has_operation()) or
                                    (self.mld_pv4_data is not None and self.mld_pv4_data.has_operation()) or
                                    (self.next_hop_set_l3vpn is not None and self.next_hop_set_l3vpn.has_operation()) or
                                    (self.pi_mi_pmsi_data is not None and self.pi_mi_pmsi_data.has_operation()) or
                                    (self.pi_ms_pmsi_data is not None and self.pi_ms_pmsi_data.has_operation()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                    (self.sr_adj_segment_ipv4 is not None and self.sr_adj_segment_ipv4.has_operation()) or
                                    (self.sr_adj_segment_ipv6 is not None and self.sr_adj_segment_ipv6.has_operation()) or
                                    (self.sr_prefix_segment is not None and self.sr_prefix_segment.has_operation()) or
                                    (self.te_binding is not None and self.te_binding.has_operation()) or
                                    (self.tev4_data is not None and self.tev4_data.has_operation()) or
                                    (self.tev4p2mp_data is not None and self.tev4p2mp_data.has_operation()) or
                                    (self.tp_data is not None and self.tp_data.has_operation()) or
                                    (self.vrf_l3vpn_data is not None and self.vrf_l3vpn_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-context" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_context_type.is_set or self.label_context_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_context_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "cev4l3vpn-data"):
                                    if (self.cev4l3vpn_data is None):
                                        self.cev4l3vpn_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev4L3VpnData()
                                        self.cev4l3vpn_data.parent = self
                                        self._children_name_map["cev4l3vpn_data"] = "cev4l3vpn-data"
                                    return self.cev4l3vpn_data

                                if (child_yang_name == "cev6l3vpn-data"):
                                    if (self.cev6l3vpn_data is None):
                                        self.cev6l3vpn_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Cev6L3VpnData()
                                        self.cev6l3vpn_data.parent = self
                                        self._children_name_map["cev6l3vpn_data"] = "cev6l3vpn-data"
                                    return self.cev6l3vpn_data

                                if (child_yang_name == "evpn-data"):
                                    if (self.evpn_data is None):
                                        self.evpn_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.EvpnData()
                                        self.evpn_data.parent = self
                                        self._children_name_map["evpn_data"] = "evpn-data"
                                    return self.evpn_data

                                if (child_yang_name == "generic-routing-encapsulation"):
                                    if (self.generic_routing_encapsulation is None):
                                        self.generic_routing_encapsulation = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.GenericRoutingEncapsulation()
                                        self.generic_routing_encapsulation.parent = self
                                        self._children_name_map["generic_routing_encapsulation"] = "generic-routing-encapsulation"
                                    return self.generic_routing_encapsulation

                                if (child_yang_name == "ip-sub-data"):
                                    if (self.ip_sub_data is None):
                                        self.ip_sub_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.IpSubData()
                                        self.ip_sub_data.parent = self
                                        self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    return self.ip_sub_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv4blb-data"):
                                    if (self.ipv4blb_data is None):
                                        self.ipv4blb_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4BlbData()
                                        self.ipv4blb_data.parent = self
                                        self._children_name_map["ipv4blb_data"] = "ipv4blb-data"
                                    return self.ipv4blb_data

                                if (child_yang_name == "ipv4l3vpn-data"):
                                    if (self.ipv4l3vpn_data is None):
                                        self.ipv4l3vpn_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv4L3VpnData()
                                        self.ipv4l3vpn_data.parent = self
                                        self._children_name_map["ipv4l3vpn_data"] = "ipv4l3vpn-data"
                                    return self.ipv4l3vpn_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "ipv6-generic-routing-encapsulation"):
                                    if (self.ipv6_generic_routing_encapsulation is None):
                                        self.ipv6_generic_routing_encapsulation = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6GenericRoutingEncapsulation()
                                        self.ipv6_generic_routing_encapsulation.parent = self
                                        self._children_name_map["ipv6_generic_routing_encapsulation"] = "ipv6-generic-routing-encapsulation"
                                    return self.ipv6_generic_routing_encapsulation

                                if (child_yang_name == "ipv6blb-data"):
                                    if (self.ipv6blb_data is None):
                                        self.ipv6blb_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6BlbData()
                                        self.ipv6blb_data.parent = self
                                        self._children_name_map["ipv6blb_data"] = "ipv6blb-data"
                                    return self.ipv6blb_data

                                if (child_yang_name == "ipv6l3vpn-data"):
                                    if (self.ipv6l3vpn_data is None):
                                        self.ipv6l3vpn_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Ipv6L3VpnData()
                                        self.ipv6l3vpn_data.parent = self
                                        self._children_name_map["ipv6l3vpn_data"] = "ipv6l3vpn-data"
                                    return self.ipv6l3vpn_data

                                if (child_yang_name == "label-block-data"):
                                    if (self.label_block_data is None):
                                        self.label_block_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockData()
                                        self.label_block_data.parent = self
                                        self._children_name_map["label_block_data"] = "label-block-data"
                                    return self.label_block_data

                                if (child_yang_name == "label-block-srgb-data"):
                                    if (self.label_block_srgb_data is None):
                                        self.label_block_srgb_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.LabelBlockSrgbData()
                                        self.label_block_srgb_data.parent = self
                                        self._children_name_map["label_block_srgb_data"] = "label-block-srgb-data"
                                    return self.label_block_srgb_data

                                if (child_yang_name == "mld-pv4-data"):
                                    if (self.mld_pv4_data is None):
                                        self.mld_pv4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.MldPv4Data()
                                        self.mld_pv4_data.parent = self
                                        self._children_name_map["mld_pv4_data"] = "mld-pv4-data"
                                    return self.mld_pv4_data

                                if (child_yang_name == "next-hop-set-l3vpn"):
                                    if (self.next_hop_set_l3vpn is None):
                                        self.next_hop_set_l3vpn = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.NextHopSetL3Vpn()
                                        self.next_hop_set_l3vpn.parent = self
                                        self._children_name_map["next_hop_set_l3vpn"] = "next-hop-set-l3vpn"
                                    return self.next_hop_set_l3vpn

                                if (child_yang_name == "pi-mi-pmsi-data"):
                                    if (self.pi_mi_pmsi_data is None):
                                        self.pi_mi_pmsi_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMiPmsiData()
                                        self.pi_mi_pmsi_data.parent = self
                                        self._children_name_map["pi_mi_pmsi_data"] = "pi-mi-pmsi-data"
                                    return self.pi_mi_pmsi_data

                                if (child_yang_name == "pi-ms-pmsi-data"):
                                    if (self.pi_ms_pmsi_data is None):
                                        self.pi_ms_pmsi_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PiMsPmsiData()
                                        self.pi_ms_pmsi_data.parent = self
                                        self._children_name_map["pi_ms_pmsi_data"] = "pi-ms-pmsi-data"
                                    return self.pi_ms_pmsi_data

                                if (child_yang_name == "pseudowire-data"):
                                    if (self.pseudowire_data is None):
                                        self.pseudowire_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireData()
                                        self.pseudowire_data.parent = self
                                        self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    return self.pseudowire_data

                                if (child_yang_name == "pseudowire-head-end-data"):
                                    if (self.pseudowire_head_end_data is None):
                                        self.pseudowire_head_end_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.PseudowireHeadEndData()
                                        self.pseudowire_head_end_data.parent = self
                                        self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    return self.pseudowire_head_end_data

                                if (child_yang_name == "sr-adj-segment-ipv4"):
                                    if (self.sr_adj_segment_ipv4 is None):
                                        self.sr_adj_segment_ipv4 = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv4()
                                        self.sr_adj_segment_ipv4.parent = self
                                        self._children_name_map["sr_adj_segment_ipv4"] = "sr-adj-segment-ipv4"
                                    return self.sr_adj_segment_ipv4

                                if (child_yang_name == "sr-adj-segment-ipv6"):
                                    if (self.sr_adj_segment_ipv6 is None):
                                        self.sr_adj_segment_ipv6 = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrAdjSegmentIpv6()
                                        self.sr_adj_segment_ipv6.parent = self
                                        self._children_name_map["sr_adj_segment_ipv6"] = "sr-adj-segment-ipv6"
                                    return self.sr_adj_segment_ipv6

                                if (child_yang_name == "sr-prefix-segment"):
                                    if (self.sr_prefix_segment is None):
                                        self.sr_prefix_segment = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.SrPrefixSegment()
                                        self.sr_prefix_segment.parent = self
                                        self._children_name_map["sr_prefix_segment"] = "sr-prefix-segment"
                                    return self.sr_prefix_segment

                                if (child_yang_name == "te-binding"):
                                    if (self.te_binding is None):
                                        self.te_binding = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TeBinding()
                                        self.te_binding.parent = self
                                        self._children_name_map["te_binding"] = "te-binding"
                                    return self.te_binding

                                if (child_yang_name == "tev4-data"):
                                    if (self.tev4_data is None):
                                        self.tev4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4Data()
                                        self.tev4_data.parent = self
                                        self._children_name_map["tev4_data"] = "tev4-data"
                                    return self.tev4_data

                                if (child_yang_name == "tev4p2mp-data"):
                                    if (self.tev4p2mp_data is None):
                                        self.tev4p2mp_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.Tev4P2MpData()
                                        self.tev4p2mp_data.parent = self
                                        self._children_name_map["tev4p2mp_data"] = "tev4p2mp-data"
                                    return self.tev4p2mp_data

                                if (child_yang_name == "tp-data"):
                                    if (self.tp_data is None):
                                        self.tp_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.TpData()
                                        self.tp_data.parent = self
                                        self._children_name_map["tp_data"] = "tp-data"
                                    return self.tp_data

                                if (child_yang_name == "vrf-l3vpn-data"):
                                    if (self.vrf_l3vpn_data is None):
                                        self.vrf_l3vpn_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext.VrfL3VpnData()
                                        self.vrf_l3vpn_data.parent = self
                                        self._children_name_map["vrf_l3vpn_data"] = "vrf-l3vpn-data"
                                    return self.vrf_l3vpn_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "cev4l3vpn-data" or name == "cev6l3vpn-data" or name == "evpn-data" or name == "generic-routing-encapsulation" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv4blb-data" or name == "ipv4l3vpn-data" or name == "ipv6-data" or name == "ipv6-generic-routing-encapsulation" or name == "ipv6blb-data" or name == "ipv6l3vpn-data" or name == "label-block-data" or name == "label-block-srgb-data" or name == "mld-pv4-data" or name == "next-hop-set-l3vpn" or name == "pi-mi-pmsi-data" or name == "pi-ms-pmsi-data" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "sr-adj-segment-ipv4" or name == "sr-adj-segment-ipv6" or name == "sr-prefix-segment" or name == "te-binding" or name == "tev4-data" or name == "tev4p2mp-data" or name == "tp-data" or name == "vrf-l3vpn-data" or name == "label-context-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-context-type"):
                                    self.label_context_type = value
                                    self.label_context_type.value_namespace = name_space
                                    self.label_context_type.value_namespace_prefix = name_space_prefix


                        class LocalLabelRewrite(Entity):
                            """
                            Local label rewrite information
                            
                            .. attribute:: label_data
                            
                            	label data
                            	**type**\:  list of int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LocalLabelRewrite, self).__init__()

                                self.yang_name = "local-label-rewrite"
                                self.yang_parent_name = "rewrite-id"

                                self.label_data = YLeafList(YType.uint32, "label-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_data") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LocalLabelRewrite, self).__setattr__(name, value)

                            def has_data(self):
                                for leaf in self.label_data.getYLeafs():
                                    if (leaf.yfilter != YFilter.not_set):
                                        return True
                                return False

                            def has_operation(self):
                                for leaf in self.label_data.getYLeafs():
                                    if (leaf.is_set):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_data.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "local-label-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                leaf_name_data.extend(self.label_data.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "label-data"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-data"):
                                    self.label_data.append(value)

                        def has_data(self):
                            return (
                                self.rewrite_id_type.is_set or
                                (self.label_context is not None and self.label_context.has_data()) or
                                (self.local_label_rewrite is not None and self.local_label_rewrite.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.rewrite_id_type.yfilter != YFilter.not_set or
                                (self.label_context is not None and self.label_context.has_operation()) or
                                (self.local_label_rewrite is not None and self.local_label_rewrite.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rewrite-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.rewrite_id_type.is_set or self.rewrite_id_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rewrite_id_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "label-context"):
                                if (self.label_context is None):
                                    self.label_context = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LabelContext()
                                    self.label_context.parent = self
                                    self._children_name_map["label_context"] = "label-context"
                                return self.label_context

                            if (child_yang_name == "local-label-rewrite"):
                                if (self.local_label_rewrite is None):
                                    self.local_label_rewrite = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId.LocalLabelRewrite()
                                    self.local_label_rewrite.parent = self
                                    self._children_name_map["local_label_rewrite"] = "local-label-rewrite"
                                return self.local_label_rewrite

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "label-context" or name == "local-label-rewrite" or name == "rewrite-id-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "rewrite-id-type"):
                                self.rewrite_id_type = value
                                self.rewrite_id_type.value_namespace = name_space
                                self.rewrite_id_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (self.rewrite_id is not None and self.rewrite_id.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rewrite-id" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "rewrite-id"):
                            if (self.rewrite_id is None):
                                self.rewrite_id = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId.RewriteId()
                                self.rewrite_id.parent = self
                                self._children_name_map["rewrite_id"] = "rewrite-id"
                            return self.rewrite_id

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "rewrite-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class AssociatedFpi(Entity):
                    """
                    Associated FPI
                    
                    .. attribute:: application_owner
                    
                    	Application owner instance
                    	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.ApplicationOwner>`
                    
                    .. attribute:: fpi
                    
                    	FPI
                    	**type**\:   :py:class:`Fpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi, self).__init__()

                        self.yang_name = "associated-fpi"
                        self.yang_parent_name = "rewrite-label"

                        self.fpi = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi()
                        self.fpi.parent = self
                        self._children_name_map["fpi"] = "fpi"
                        self._children_yang_names.add("fpi")

                        self.application_owner = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi, self).__setattr__(name, value)


                    class Fpi(Entity):
                        """
                        FPI
                        
                        .. attribute:: dmtc_ext_intf_data
                        
                        	dmtc ext intf data
                        	**type**\:   :py:class:`DmtcExtIntfData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.DmtcExtIntfData>`
                        
                        .. attribute:: fpi_type
                        
                        	FPIType
                        	**type**\:   :py:class:`MgmtLsdFpi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdFpi>`
                        
                        .. attribute:: ipv4_data
                        
                        	ipv4 data
                        	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv4Data>`
                        
                        .. attribute:: ipv6_data
                        
                        	ipv6 data
                        	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv6Data>`
                        
                        .. attribute:: label_data
                        
                        	label data
                        	**type**\:   :py:class:`LabelData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.LabelData>`
                        
                        .. attribute:: pw_list_data
                        
                        	pw list data
                        	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.PwListData>`
                        
                        .. attribute:: te_data
                        
                        	te data
                        	**type**\:   :py:class:`TeData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.TeData>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi, self).__init__()

                            self.yang_name = "fpi"
                            self.yang_parent_name = "associated-fpi"

                            self.fpi_type = YLeaf(YType.enumeration, "fpi-type")

                            self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.DmtcExtIntfData()
                            self.dmtc_ext_intf_data.parent = self
                            self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                            self._children_yang_names.add("dmtc-ext-intf-data")

                            self.ipv4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv4Data()
                            self.ipv4_data.parent = self
                            self._children_name_map["ipv4_data"] = "ipv4-data"
                            self._children_yang_names.add("ipv4-data")

                            self.ipv6_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv6Data()
                            self.ipv6_data.parent = self
                            self._children_name_map["ipv6_data"] = "ipv6-data"
                            self._children_yang_names.add("ipv6-data")

                            self.label_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.LabelData()
                            self.label_data.parent = self
                            self._children_name_map["label_data"] = "label-data"
                            self._children_yang_names.add("label-data")

                            self.pw_list_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.PwListData()
                            self.pw_list_data.parent = self
                            self._children_name_map["pw_list_data"] = "pw-list-data"
                            self._children_yang_names.add("pw-list-data")

                            self.te_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.TeData()
                            self.te_data.parent = self
                            self._children_name_map["te_data"] = "te-data"
                            self._children_yang_names.add("te-data")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fpi_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi, self).__setattr__(name, value)


                        class LabelData(Entity):
                            """
                            label data
                            
                            .. attribute:: elc
                            
                            	ELC
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: label
                            
                            	Label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: security_id
                            
                            	Security ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.LabelData, self).__init__()

                                self.yang_name = "label-data"
                                self.yang_parent_name = "fpi"

                                self.elc = YLeaf(YType.int32, "elc")

                                self.label = YLeaf(YType.uint32, "label")

                                self.security_id = YLeaf(YType.uint32, "security-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("elc",
                                                "label",
                                                "security_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.LabelData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.elc.is_set or
                                    self.label.is_set or
                                    self.security_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.elc.yfilter != YFilter.not_set or
                                    self.label.yfilter != YFilter.not_set or
                                    self.security_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.elc.is_set or self.elc.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.elc.get_name_leafdata())
                                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label.get_name_leafdata())
                                if (self.security_id.is_set or self.security_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.security_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "elc" or name == "label" or name == "security-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "elc"):
                                    self.elc = value
                                    self.elc.value_namespace = name_space
                                    self.elc.value_namespace_prefix = name_space_prefix
                                if(value_path == "label"):
                                    self.label = value
                                    self.label.value_namespace = name_space
                                    self.label.value_namespace_prefix = name_space_prefix
                                if(value_path == "security-id"):
                                    self.security_id = value
                                    self.security_id.value_namespace = name_space
                                    self.security_id.value_namespace_prefix = name_space_prefix


                        class TeData(Entity):
                            """
                            te data
                            
                            .. attribute:: local_label
                            
                            	Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_interface
                            
                            	Tunnel interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.TeData, self).__init__()

                                self.yang_name = "te-data"
                                self.yang_parent_name = "fpi"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label",
                                                "tunnel_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.TeData, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.local_label.is_set or
                                    self.tunnel_interface.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.tunnel_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label" or name == "tunnel-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface"):
                                    self.tunnel_interface = value
                                    self.tunnel_interface.value_namespace = name_space
                                    self.tunnel_interface.value_namespace_prefix = name_space_prefix


                        class Ipv4Data(Entity):
                            """
                            ipv4 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_length
                            
                            	Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: sr_local_label
                            
                            	SR related Local label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv4Data, self).__init__()

                                self.yang_name = "ipv4-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_length",
                                                "sr_local_label",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv4Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_length.is_set or
                                    self.sr_local_label.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set or
                                    self.sr_local_label.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-length" or name == "sr-local-label" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "sr-local-label"):
                                    self.sr_local_label = value
                                    self.sr_local_label.value_namespace = name_space
                                    self.sr_local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class Ipv6Data(Entity):
                            """
                            ipv6 data
                            
                            .. attribute:: prefix
                            
                            	Prefix
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: prefix_len
                            
                            	Prefix length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: router_flags
                            
                            	Route flags
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: table_id
                            
                            	Table ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: version
                            
                            	Version
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv6Data, self).__init__()

                                self.yang_name = "ipv6-data"
                                self.yang_parent_name = "fpi"

                                self.prefix = YLeaf(YType.str, "prefix")

                                self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                self.router_flags = YLeaf(YType.uint32, "router-flags")

                                self.table_id = YLeaf(YType.uint32, "table-id")

                                self.version = YLeaf(YType.uint32, "version")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("prefix",
                                                "prefix_len",
                                                "router_flags",
                                                "table_id",
                                                "version") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv6Data, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.prefix.is_set or
                                    self.prefix_len.is_set or
                                    self.router_flags.is_set or
                                    self.table_id.is_set or
                                    self.version.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.prefix.yfilter != YFilter.not_set or
                                    self.prefix_len.yfilter != YFilter.not_set or
                                    self.router_flags.yfilter != YFilter.not_set or
                                    self.table_id.yfilter != YFilter.not_set or
                                    self.version.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv6-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix.get_name_leafdata())
                                if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_len.get_name_leafdata())
                                if (self.router_flags.is_set or self.router_flags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.router_flags.get_name_leafdata())
                                if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.table_id.get_name_leafdata())
                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.version.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "prefix" or name == "prefix-len" or name == "router-flags" or name == "table-id" or name == "version"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "prefix"):
                                    self.prefix = value
                                    self.prefix.value_namespace = name_space
                                    self.prefix.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-len"):
                                    self.prefix_len = value
                                    self.prefix_len.value_namespace = name_space
                                    self.prefix_len.value_namespace_prefix = name_space_prefix
                                if(value_path == "router-flags"):
                                    self.router_flags = value
                                    self.router_flags.value_namespace = name_space
                                    self.router_flags.value_namespace_prefix = name_space_prefix
                                if(value_path == "table-id"):
                                    self.table_id = value
                                    self.table_id.value_namespace = name_space
                                    self.table_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "version"):
                                    self.version = value
                                    self.version.value_namespace = name_space
                                    self.version.value_namespace_prefix = name_space_prefix


                        class PwListData(Entity):
                            """
                            pw list data
                            
                            .. attribute:: pwhe_list_id
                            
                            	Pseudowire List Identifier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.PwListData, self).__init__()

                                self.yang_name = "pw-list-data"
                                self.yang_parent_name = "fpi"

                                self.pwhe_list_id = YLeaf(YType.uint16, "pwhe-list-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("pwhe_list_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.PwListData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.pwhe_list_id.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.pwhe_list_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "pw-list-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.pwhe_list_id.is_set or self.pwhe_list_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pwhe_list_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "pwhe-list-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "pwhe-list-id"):
                                    self.pwhe_list_id = value
                                    self.pwhe_list_id.value_namespace = name_space
                                    self.pwhe_list_id.value_namespace_prefix = name_space_prefix


                        class DmtcExtIntfData(Entity):
                            """
                            dmtc ext intf data
                            
                            .. attribute:: dmtc_ext_ifh
                            
                            	DMTC External Interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.DmtcExtIntfData, self).__init__()

                                self.yang_name = "dmtc-ext-intf-data"
                                self.yang_parent_name = "fpi"

                                self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.DmtcExtIntfData, self).__setattr__(name, value)

                            def has_data(self):
                                return self.dmtc_ext_ifh.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "dmtc-ext-intf-data" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-ext-ifh"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "dmtc-ext-ifh"):
                                    self.dmtc_ext_ifh = value
                                    self.dmtc_ext_ifh.value_namespace = name_space
                                    self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fpi_type.is_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_data()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                (self.label_data is not None and self.label_data.has_data()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                (self.te_data is not None and self.te_data.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fpi_type.yfilter != YFilter.not_set or
                                (self.dmtc_ext_intf_data is not None and self.dmtc_ext_intf_data.has_operation()) or
                                (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                (self.label_data is not None and self.label_data.has_operation()) or
                                (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                (self.te_data is not None and self.te_data.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fpi" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fpi_type.is_set or self.fpi_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fpi_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "dmtc-ext-intf-data"):
                                if (self.dmtc_ext_intf_data is None):
                                    self.dmtc_ext_intf_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.DmtcExtIntfData()
                                    self.dmtc_ext_intf_data.parent = self
                                    self._children_name_map["dmtc_ext_intf_data"] = "dmtc-ext-intf-data"
                                return self.dmtc_ext_intf_data

                            if (child_yang_name == "ipv4-data"):
                                if (self.ipv4_data is None):
                                    self.ipv4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv4Data()
                                    self.ipv4_data.parent = self
                                    self._children_name_map["ipv4_data"] = "ipv4-data"
                                return self.ipv4_data

                            if (child_yang_name == "ipv6-data"):
                                if (self.ipv6_data is None):
                                    self.ipv6_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.Ipv6Data()
                                    self.ipv6_data.parent = self
                                    self._children_name_map["ipv6_data"] = "ipv6-data"
                                return self.ipv6_data

                            if (child_yang_name == "label-data"):
                                if (self.label_data is None):
                                    self.label_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.LabelData()
                                    self.label_data.parent = self
                                    self._children_name_map["label_data"] = "label-data"
                                return self.label_data

                            if (child_yang_name == "pw-list-data"):
                                if (self.pw_list_data is None):
                                    self.pw_list_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.PwListData()
                                    self.pw_list_data.parent = self
                                    self._children_name_map["pw_list_data"] = "pw-list-data"
                                return self.pw_list_data

                            if (child_yang_name == "te-data"):
                                if (self.te_data is None):
                                    self.te_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi.TeData()
                                    self.te_data.parent = self
                                    self._children_name_map["te_data"] = "te-data"
                                return self.te_data

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "dmtc-ext-intf-data" or name == "ipv4-data" or name == "ipv6-data" or name == "label-data" or name == "pw-list-data" or name == "te-data" or name == "fpi-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fpi-type"):
                                self.fpi_type = value
                                self.fpi_type.value_namespace = name_space
                                self.fpi_type.value_namespace_prefix = name_space_prefix


                    class ApplicationOwner(Entity):
                        """
                        Application owner instance
                        
                        .. attribute:: application_instance
                        
                        	Application instance Name
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        .. attribute:: resource_state
                        
                        	Application resource state
                        	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.ApplicationOwner, self).__init__()

                            self.yang_name = "application-owner"
                            self.yang_parent_name = "associated-fpi"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                            self.resource_state = YLeaf(YType.enumeration, "resource-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type",
                                            "resource_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.ApplicationOwner, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set or
                                self.resource_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set or
                                self.resource_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application-owner" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())
                            if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resource_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "resource-state"):
                                self.resource_state = value
                                self.resource_state.value_namespace = name_space
                                self.resource_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.application_owner:
                            if (c.has_data()):
                                return True
                        return (self.fpi is not None and self.fpi.has_data())

                    def has_operation(self):
                        for c in self.application_owner:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.fpi is not None and self.fpi.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "associated-fpi" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application-owner"):
                            for c in self.application_owner:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.ApplicationOwner()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.application_owner.append(c)
                            return c

                        if (child_yang_name == "fpi"):
                            if (self.fpi is None):
                                self.fpi = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi.Fpi()
                                self.fpi.parent = self
                                self._children_name_map["fpi"] = "fpi"
                            return self.fpi

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-owner" or name == "fpi"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class V4Rpf(Entity):
                    """
                    IPv4 RPF neighbors
                    
                    .. attribute:: table_id
                    
                    	Table ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: v4_rpf_neighbor
                    
                    	V4 RPF Neighbor
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.V4Rpf, self).__init__()

                        self.yang_name = "v4-rpf"
                        self.yang_parent_name = "rewrite-label"

                        self.table_id = YLeaf(YType.uint32, "table-id")

                        self.v4_rpf_neighbor = YLeaf(YType.str, "v4-rpf-neighbor")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("table_id",
                                        "v4_rpf_neighbor") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.V4Rpf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.V4Rpf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.table_id.is_set or
                            self.v4_rpf_neighbor.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.table_id.yfilter != YFilter.not_set or
                            self.v4_rpf_neighbor.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "v4-rpf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.table_id.get_name_leafdata())
                        if (self.v4_rpf_neighbor.is_set or self.v4_rpf_neighbor.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.v4_rpf_neighbor.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "table-id" or name == "v4-rpf-neighbor"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "table-id"):
                            self.table_id = value
                            self.table_id.value_namespace = name_space
                            self.table_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "v4-rpf-neighbor"):
                            self.v4_rpf_neighbor = value
                            self.v4_rpf_neighbor.value_namespace = name_space
                            self.v4_rpf_neighbor.value_namespace_prefix = name_space_prefix


                class V6Rpf(Entity):
                    """
                    IPv6 RPF neighbors
                    
                    .. attribute:: table_id
                    
                    	Table ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: v6_rpf_neighbor
                    
                    	V6 RPF Neighbor
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.V6Rpf, self).__init__()

                        self.yang_name = "v6-rpf"
                        self.yang_parent_name = "rewrite-label"

                        self.table_id = YLeaf(YType.uint32, "table-id")

                        self.v6_rpf_neighbor = YLeaf(YType.str, "v6-rpf-neighbor")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("table_id",
                                        "v6_rpf_neighbor") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.V6Rpf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.V6Rpf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.table_id.is_set or
                            self.v6_rpf_neighbor.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.table_id.yfilter != YFilter.not_set or
                            self.v6_rpf_neighbor.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "v6-rpf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.table_id.get_name_leafdata())
                        if (self.v6_rpf_neighbor.is_set or self.v6_rpf_neighbor.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.v6_rpf_neighbor.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "table-id" or name == "v6-rpf-neighbor"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "table-id"):
                            self.table_id = value
                            self.table_id.value_namespace = name_space
                            self.table_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "v6-rpf-neighbor"):
                            self.v6_rpf_neighbor = value
                            self.v6_rpf_neighbor.value_namespace = name_space
                            self.v6_rpf_neighbor.value_namespace_prefix = name_space_prefix


                class Mois(Entity):
                    """
                    Mois
                    
                    .. attribute:: application_resource
                    
                    	Application state
                    	**type**\:   :py:class:`ApplicationResource <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.ApplicationResource>`
                    
                    .. attribute:: moi_array
                    
                    	moi array
                    	**type**\: list of    :py:class:`MoiArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray>`
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois, self).__init__()

                        self.yang_name = "mois"
                        self.yang_parent_name = "rewrite-label"

                        self.application_resource = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.ApplicationResource()
                        self.application_resource.parent = self
                        self._children_name_map["application_resource"] = "application-resource"
                        self._children_yang_names.add("application-resource")

                        self.moi_array = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois, self).__setattr__(name, value)


                    class ApplicationResource(Entity):
                        """
                        Application state
                        
                        .. attribute:: application_instance
                        
                        	Application instance Name
                        	**type**\:  str
                        
                        .. attribute:: application_name
                        
                        	Application name
                        	**type**\:  str
                        
                        .. attribute:: application_role_primary
                        
                        	Primary/Backup role
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: application_type
                        
                        	Application type
                        	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                        
                        .. attribute:: resource_state
                        
                        	Application resource state
                        	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.ApplicationResource, self).__init__()

                            self.yang_name = "application-resource"
                            self.yang_parent_name = "mois"

                            self.application_instance = YLeaf(YType.str, "application-instance")

                            self.application_name = YLeaf(YType.str, "application-name")

                            self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                            self.application_type = YLeaf(YType.enumeration, "application-type")

                            self.resource_state = YLeaf(YType.enumeration, "resource-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_instance",
                                            "application_name",
                                            "application_role_primary",
                                            "application_type",
                                            "resource_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.ApplicationResource, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.ApplicationResource, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_instance.is_set or
                                self.application_name.is_set or
                                self.application_role_primary.is_set or
                                self.application_type.is_set or
                                self.resource_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_instance.yfilter != YFilter.not_set or
                                self.application_name.yfilter != YFilter.not_set or
                                self.application_role_primary.yfilter != YFilter.not_set or
                                self.application_type.yfilter != YFilter.not_set or
                                self.resource_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "application-resource" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_instance.get_name_leafdata())
                            if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_name.get_name_leafdata())
                            if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                            if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_type.get_name_leafdata())
                            if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resource_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-instance"):
                                self.application_instance = value
                                self.application_instance.value_namespace = name_space
                                self.application_instance.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-name"):
                                self.application_name = value
                                self.application_name.value_namespace = name_space
                                self.application_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-role-primary"):
                                self.application_role_primary = value
                                self.application_role_primary.value_namespace = name_space
                                self.application_role_primary.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-type"):
                                self.application_type = value
                                self.application_type.value_namespace = name_space
                                self.application_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "resource-state"):
                                self.resource_state = value
                                self.resource_state.value_namespace = name_space
                                self.resource_state.value_namespace_prefix = name_space_prefix


                    class MoiArray(Entity):
                        """
                        moi array
                        
                        .. attribute:: moi
                        
                        	Moi
                        	**type**\:   :py:class:`Moi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi>`
                        
                        

                        """

                        _prefix = 'mpls-lsd-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray, self).__init__()

                            self.yang_name = "moi-array"
                            self.yang_parent_name = "mois"

                            self.moi = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi()
                            self.moi.parent = self
                            self._children_name_map["moi"] = "moi"
                            self._children_yang_names.add("moi")


                        class Moi(Entity):
                            """
                            Moi
                            
                            .. attribute:: dmtc_data
                            
                            	dmtc data
                            	**type**\:   :py:class:`DmtcData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.DmtcData>`
                            
                            .. attribute:: ip_sub_data
                            
                            	ip sub data
                            	**type**\:   :py:class:`IpSubData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.IpSubData>`
                            
                            .. attribute:: ipv4_data
                            
                            	ipv4 data
                            	**type**\:   :py:class:`Ipv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv4Data>`
                            
                            .. attribute:: ipv6_data
                            
                            	ipv6 data
                            	**type**\:   :py:class:`Ipv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv6Data>`
                            
                            .. attribute:: moi_type
                            
                            	MoiType
                            	**type**\:   :py:class:`MgmtLsdMoi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdMoi>`
                            
                            .. attribute:: pop_and_lookup_ipv4
                            
                            	pop and lookup ipv4
                            	**type**\:   :py:class:`PopAndLookupIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv4>`
                            
                            .. attribute:: pop_and_lookup_ipv6
                            
                            	pop and lookup ipv6
                            	**type**\:   :py:class:`PopAndLookupIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv6>`
                            
                            .. attribute:: pop_and_lookup_tp
                            
                            	pop and lookup tp
                            	**type**\:   :py:class:`PopAndLookupTp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupTp>`
                            
                            .. attribute:: pseudowire_data
                            
                            	pseudowire data
                            	**type**\:   :py:class:`PseudowireData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireData>`
                            
                            .. attribute:: pseudowire_head_end_data
                            
                            	pseudowire head end data
                            	**type**\:   :py:class:`PseudowireHeadEndData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireHeadEndData>`
                            
                            .. attribute:: pw_list_data
                            
                            	pw list data
                            	**type**\:   :py:class:`PwListData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PwListData>`
                            
                            .. attribute:: stackv4_data
                            
                            	stackv4 data
                            	**type**\:   :py:class:`Stackv4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data>`
                            
                            .. attribute:: stackv6_data
                            
                            	stackv6 data
                            	**type**\:   :py:class:`Stackv6Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data>`
                            
                            .. attribute:: te_head_data
                            
                            	te head data
                            	**type**\:   :py:class:`TeHeadData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.TeHeadData>`
                            
                            .. attribute:: tev4_data
                            
                            	tev4 data
                            	**type**\:   :py:class:`Tev4Data <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Tev4Data>`
                            
                            

                            """

                            _prefix = 'mpls-lsd-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi, self).__init__()

                                self.yang_name = "moi"
                                self.yang_parent_name = "moi-array"

                                self.moi_type = YLeaf(YType.enumeration, "moi-type")

                                self.dmtc_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.DmtcData()
                                self.dmtc_data.parent = self
                                self._children_name_map["dmtc_data"] = "dmtc-data"
                                self._children_yang_names.add("dmtc-data")

                                self.ip_sub_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.IpSubData()
                                self.ip_sub_data.parent = self
                                self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                self._children_yang_names.add("ip-sub-data")

                                self.ipv4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv4Data()
                                self.ipv4_data.parent = self
                                self._children_name_map["ipv4_data"] = "ipv4-data"
                                self._children_yang_names.add("ipv4-data")

                                self.ipv6_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv6Data()
                                self.ipv6_data.parent = self
                                self._children_name_map["ipv6_data"] = "ipv6-data"
                                self._children_yang_names.add("ipv6-data")

                                self.pop_and_lookup_ipv4 = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                self.pop_and_lookup_ipv4.parent = self
                                self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                self._children_yang_names.add("pop-and-lookup-ipv4")

                                self.pop_and_lookup_ipv6 = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                self.pop_and_lookup_ipv6.parent = self
                                self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                self._children_yang_names.add("pop-and-lookup-ipv6")

                                self.pop_and_lookup_tp = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupTp()
                                self.pop_and_lookup_tp.parent = self
                                self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                self._children_yang_names.add("pop-and-lookup-tp")

                                self.pseudowire_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireData()
                                self.pseudowire_data.parent = self
                                self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                self._children_yang_names.add("pseudowire-data")

                                self.pseudowire_head_end_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                self.pseudowire_head_end_data.parent = self
                                self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                self._children_yang_names.add("pseudowire-head-end-data")

                                self.pw_list_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PwListData()
                                self.pw_list_data.parent = self
                                self._children_name_map["pw_list_data"] = "pw-list-data"
                                self._children_yang_names.add("pw-list-data")

                                self.stackv4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data()
                                self.stackv4_data.parent = self
                                self._children_name_map["stackv4_data"] = "stackv4-data"
                                self._children_yang_names.add("stackv4-data")

                                self.stackv6_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data()
                                self.stackv6_data.parent = self
                                self._children_name_map["stackv6_data"] = "stackv6-data"
                                self._children_yang_names.add("stackv6-data")

                                self.te_head_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.TeHeadData()
                                self.te_head_data.parent = self
                                self._children_name_map["te_head_data"] = "te-head-data"
                                self._children_yang_names.add("te-head-data")

                                self.tev4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Tev4Data()
                                self.tev4_data.parent = self
                                self._children_name_map["tev4_data"] = "tev4-data"
                                self._children_yang_names.add("tev4-data")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("moi_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi, self).__setattr__(name, value)


                            class PopAndLookupIpv4(Entity):
                                """
                                pop and lookup ipv4
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__init__()

                                    self.yang_name = "pop-and-lookup-ipv4"
                                    self.yang_parent_name = "moi"

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv4, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pop-and-lookup-ipv4" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class PopAndLookupTp(Entity):
                                """
                                pop and lookup tp
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupTp, self).__init__()

                                    self.yang_name = "pop-and-lookup-tp"
                                    self.yang_parent_name = "moi"

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("out_label",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupTp, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.out_label.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pop-and-lookup-tp" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "out-label" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class PopAndLookupIpv6(Entity):
                                """
                                pop and lookup ipv6
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__init__()

                                    self.yang_name = "pop-and-lookup-ipv6"
                                    self.yang_parent_name = "moi"

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv6, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pop-and-lookup-ipv6" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class Ipv4Data(Entity):
                                """
                                ipv4 data
                                
                                .. attribute:: backup_path_id
                                
                                	Routing path backup id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: load_metric
                                
                                	Routing path's load metric
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: local_label
                                
                                	TE backup path local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: next_hop_id
                                
                                	Next hop ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_interface
                                
                                	Outgoing Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_interface_parent
                                
                                	Outgoing Interface's parent
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_label_name
                                
                                	Outgoing label name
                                	**type**\:  str
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: path_id
                                
                                	Routing path id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv4Data, self).__init__()

                                    self.yang_name = "ipv4-data"
                                    self.yang_parent_name = "moi"

                                    self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.load_metric = YLeaf(YType.uint32, "load-metric")

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.out_label_name = YLeaf(YType.str, "out-label-name")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.path_id = YLeaf(YType.uint8, "path-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_path_id",
                                                    "ipv4_next_hop",
                                                    "load_metric",
                                                    "local_label",
                                                    "next_hop_id",
                                                    "out_interface",
                                                    "out_interface_parent",
                                                    "out_label",
                                                    "out_label_name",
                                                    "path_flags_decode",
                                                    "path_id",
                                                    "table_id",
                                                    "table_name",
                                                    "tunnel_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_path_id.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.load_metric.is_set or
                                        self.local_label.is_set or
                                        self.next_hop_id.is_set or
                                        self.out_interface.is_set or
                                        self.out_interface_parent.is_set or
                                        self.out_label.is_set or
                                        self.out_label_name.is_set or
                                        self.path_flags_decode.is_set or
                                        self.path_id.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.tunnel_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_path_id.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.load_metric.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.next_hop_id.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_interface_parent.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.out_label_name.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.path_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.tunnel_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.load_metric.get_name_leafdata())
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-path-id"):
                                        self.backup_path_id = value
                                        self.backup_path_id.value_namespace = name_space
                                        self.backup_path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "load-metric"):
                                        self.load_metric = value
                                        self.load_metric.value_namespace = name_space
                                        self.load_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "next-hop-id"):
                                        self.next_hop_id = value
                                        self.next_hop_id.value_namespace = name_space
                                        self.next_hop_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface-parent"):
                                        self.out_interface_parent = value
                                        self.out_interface_parent.value_namespace = name_space
                                        self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label-name"):
                                        self.out_label_name = value
                                        self.out_label_name.value_namespace = name_space
                                        self.out_label_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-id"):
                                        self.path_id = value
                                        self.path_id.value_namespace = name_space
                                        self.path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-id"):
                                        self.tunnel_id = value
                                        self.tunnel_id.value_namespace = name_space
                                        self.tunnel_id.value_namespace_prefix = name_space_prefix


                            class Ipv6Data(Entity):
                                """
                                ipv6 data
                                
                                .. attribute:: backup_path_id
                                
                                	Routing path backup id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv6_next_hop
                                
                                	IPv6 nexthop
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: next_hop_id
                                
                                	Next hop ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_label_name
                                
                                	Outgoing label name
                                	**type**\:  str
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: path_id
                                
                                	Routing path id
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv6Data, self).__init__()

                                    self.yang_name = "ipv6-data"
                                    self.yang_parent_name = "moi"

                                    self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                    self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                    self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.out_label_name = YLeaf(YType.str, "out-label-name")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.path_id = YLeaf(YType.uint8, "path-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_path_id",
                                                    "ipv6_next_hop",
                                                    "next_hop_id",
                                                    "out_interface",
                                                    "out_label",
                                                    "out_label_name",
                                                    "path_flags_decode",
                                                    "path_id",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv6Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_path_id.is_set or
                                        self.ipv6_next_hop.is_set or
                                        self.next_hop_id.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.out_label_name.is_set or
                                        self.path_flags_decode.is_set or
                                        self.path_id.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_path_id.yfilter != YFilter.not_set or
                                        self.ipv6_next_hop.yfilter != YFilter.not_set or
                                        self.next_hop_id.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.out_label_name.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.path_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                    if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                    if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-path-id"):
                                        self.backup_path_id = value
                                        self.backup_path_id.value_namespace = name_space
                                        self.backup_path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6-next-hop"):
                                        self.ipv6_next_hop = value
                                        self.ipv6_next_hop.value_namespace = name_space
                                        self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "next-hop-id"):
                                        self.next_hop_id = value
                                        self.next_hop_id.value_namespace = name_space
                                        self.next_hop_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label-name"):
                                        self.out_label_name = value
                                        self.out_label_name.value_namespace = name_space
                                        self.out_label_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-id"):
                                        self.path_id = value
                                        self.path_id.value_namespace = name_space
                                        self.path_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class Tev4Data(Entity):
                                """
                                tev4 data
                                
                                .. attribute:: backup_interface
                                
                                	Backup interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: backup_ipv4_next_hop
                                
                                	Backup IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: backup_local_label
                                
                                	Backup local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: data_out_parent_interface
                                
                                	Outgoing data parent interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: merge_point_label
                                
                                	Merge point label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: out_label_name
                                
                                	Outgoing label name
                                	**type**\:  str
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_class
                                
                                	Tunnel class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_interface
                                
                                	Tunnel interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: tunnel_weight
                                
                                	Tunnel weight
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Tev4Data, self).__init__()

                                    self.yang_name = "tev4-data"
                                    self.yang_parent_name = "moi"

                                    self.backup_interface = YLeaf(YType.str, "backup-interface")

                                    self.backup_ipv4_next_hop = YLeaf(YType.str, "backup-ipv4-next-hop")

                                    self.backup_local_label = YLeaf(YType.uint32, "backup-local-label")

                                    self.data_out_parent_interface = YLeaf(YType.str, "data-out-parent-interface")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.merge_point_label = YLeaf(YType.uint32, "merge-point-label")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.out_label_name = YLeaf(YType.str, "out-label-name")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.tunnel_class = YLeaf(YType.uint32, "tunnel-class")

                                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                                    self.tunnel_weight = YLeaf(YType.uint32, "tunnel-weight")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("backup_interface",
                                                    "backup_ipv4_next_hop",
                                                    "backup_local_label",
                                                    "data_out_parent_interface",
                                                    "ipv4_next_hop",
                                                    "merge_point_label",
                                                    "out_interface",
                                                    "out_label",
                                                    "out_label_name",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name",
                                                    "tunnel_class",
                                                    "tunnel_interface",
                                                    "tunnel_weight") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Tev4Data, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.backup_interface.is_set or
                                        self.backup_ipv4_next_hop.is_set or
                                        self.backup_local_label.is_set or
                                        self.data_out_parent_interface.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.merge_point_label.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.out_label_name.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.tunnel_class.is_set or
                                        self.tunnel_interface.is_set or
                                        self.tunnel_weight.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.backup_interface.yfilter != YFilter.not_set or
                                        self.backup_ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.backup_local_label.yfilter != YFilter.not_set or
                                        self.data_out_parent_interface.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.merge_point_label.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.out_label_name.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.tunnel_class.yfilter != YFilter.not_set or
                                        self.tunnel_interface.yfilter != YFilter.not_set or
                                        self.tunnel_weight.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tev4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.backup_interface.is_set or self.backup_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_interface.get_name_leafdata())
                                    if (self.backup_ipv4_next_hop.is_set or self.backup_ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_ipv4_next_hop.get_name_leafdata())
                                    if (self.backup_local_label.is_set or self.backup_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.backup_local_label.get_name_leafdata())
                                    if (self.data_out_parent_interface.is_set or self.data_out_parent_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.data_out_parent_interface.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.merge_point_label.is_set or self.merge_point_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.merge_point_label.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.tunnel_class.is_set or self.tunnel_class.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_class.get_name_leafdata())
                                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())
                                    if (self.tunnel_weight.is_set or self.tunnel_weight.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_weight.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "backup-interface" or name == "backup-ipv4-next-hop" or name == "backup-local-label" or name == "data-out-parent-interface" or name == "ipv4-next-hop" or name == "merge-point-label" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-class" or name == "tunnel-interface" or name == "tunnel-weight"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "backup-interface"):
                                        self.backup_interface = value
                                        self.backup_interface.value_namespace = name_space
                                        self.backup_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-ipv4-next-hop"):
                                        self.backup_ipv4_next_hop = value
                                        self.backup_ipv4_next_hop.value_namespace = name_space
                                        self.backup_ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "backup-local-label"):
                                        self.backup_local_label = value
                                        self.backup_local_label.value_namespace = name_space
                                        self.backup_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "data-out-parent-interface"):
                                        self.data_out_parent_interface = value
                                        self.data_out_parent_interface.value_namespace = name_space
                                        self.data_out_parent_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "merge-point-label"):
                                        self.merge_point_label = value
                                        self.merge_point_label.value_namespace = name_space
                                        self.merge_point_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label-name"):
                                        self.out_label_name = value
                                        self.out_label_name.value_namespace = name_space
                                        self.out_label_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-class"):
                                        self.tunnel_class = value
                                        self.tunnel_class.value_namespace = name_space
                                        self.tunnel_class.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface"):
                                        self.tunnel_interface = value
                                        self.tunnel_interface.value_namespace = name_space
                                        self.tunnel_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-weight"):
                                        self.tunnel_weight = value
                                        self.tunnel_weight.value_namespace = name_space
                                        self.tunnel_weight.value_namespace_prefix = name_space_prefix


                            class PseudowireData(Entity):
                                """
                                pseudowire data
                                
                                .. attribute:: bridge_id
                                
                                	Bridge ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross\-connect ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: pseuodo_wire_connect_id
                                
                                	PseudoWire Cross\-connect ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: split_horizon_id
                                
                                	Split horizon group ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireData, self).__init__()

                                    self.yang_name = "pseudowire-data"
                                    self.yang_parent_name = "moi"

                                    self.bridge_id = YLeaf(YType.uint32, "bridge-id")

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.pseuodo_wire_connect_id = YLeaf(YType.uint32, "pseuodo-wire-connect-id")

                                    self.split_horizon_id = YLeaf(YType.uint32, "split-horizon-id")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bridge_id",
                                                    "cross_connect_id",
                                                    "ipv4_next_hop",
                                                    "out_interface",
                                                    "out_label",
                                                    "path_flags_decode",
                                                    "pseuodo_wire_connect_id",
                                                    "split_horizon_id",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bridge_id.is_set or
                                        self.cross_connect_id.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.path_flags_decode.is_set or
                                        self.pseuodo_wire_connect_id.is_set or
                                        self.split_horizon_id.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bridge_id.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.pseuodo_wire_connect_id.yfilter != YFilter.not_set or
                                        self.split_horizon_id.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bridge_id.is_set or self.bridge_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bridge_id.get_name_leafdata())
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.pseuodo_wire_connect_id.is_set or self.pseuodo_wire_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pseuodo_wire_connect_id.get_name_leafdata())
                                    if (self.split_horizon_id.is_set or self.split_horizon_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.split_horizon_id.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bridge-id" or name == "cross-connect-id" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pseuodo-wire-connect-id" or name == "split-horizon-id" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bridge-id"):
                                        self.bridge_id = value
                                        self.bridge_id.value_namespace = name_space
                                        self.bridge_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pseuodo-wire-connect-id"):
                                        self.pseuodo_wire_connect_id = value
                                        self.pseuodo_wire_connect_id.value_namespace = name_space
                                        self.pseuodo_wire_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "split-horizon-id"):
                                        self.split_horizon_id = value
                                        self.split_horizon_id.value_namespace = name_space
                                        self.split_horizon_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class IpSubData(Entity):
                                """
                                ip sub data
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	VRF table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.IpSubData, self).__init__()

                                    self.yang_name = "ip-sub-data"
                                    self.yang_parent_name = "moi"

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("out_interface",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.IpSubData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.out_interface.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ip-sub-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "out-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class PseudowireHeadEndData(Entity):
                                """
                                pseudowire head end data
                                
                                .. attribute:: control_word
                                
                                	Is control word present
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: imposition
                                
                                	Is PWHE IMposition
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: ipv4_next_hop
                                
                                	IPv4 nexthop
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_interface
                                
                                	Outgoing interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: out_label
                                
                                	Outgoing Label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: pw_list_id
                                
                                	Pseudo\-wire List Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: pwhe_interface
                                
                                	Pseudo\-wire Head\-end interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: vctype
                                
                                	Virtual Circuit Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__init__()

                                    self.yang_name = "pseudowire-head-end-data"
                                    self.yang_parent_name = "moi"

                                    self.control_word = YLeaf(YType.int32, "control-word")

                                    self.imposition = YLeaf(YType.int32, "imposition")

                                    self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                    self.out_interface = YLeaf(YType.str, "out-interface")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.pw_list_id = YLeaf(YType.uint16, "pw-list-id")

                                    self.pwhe_interface = YLeaf(YType.str, "pwhe-interface")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.vctype = YLeaf(YType.uint8, "vctype")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("control_word",
                                                    "imposition",
                                                    "ipv4_next_hop",
                                                    "out_interface",
                                                    "out_label",
                                                    "path_flags_decode",
                                                    "pw_list_id",
                                                    "pwhe_interface",
                                                    "table_id",
                                                    "table_name",
                                                    "vctype") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireHeadEndData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.control_word.is_set or
                                        self.imposition.is_set or
                                        self.ipv4_next_hop.is_set or
                                        self.out_interface.is_set or
                                        self.out_label.is_set or
                                        self.path_flags_decode.is_set or
                                        self.pw_list_id.is_set or
                                        self.pwhe_interface.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.vctype.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.control_word.yfilter != YFilter.not_set or
                                        self.imposition.yfilter != YFilter.not_set or
                                        self.ipv4_next_hop.yfilter != YFilter.not_set or
                                        self.out_interface.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.pw_list_id.yfilter != YFilter.not_set or
                                        self.pwhe_interface.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.vctype.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pseudowire-head-end-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.control_word.is_set or self.control_word.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.control_word.get_name_leafdata())
                                    if (self.imposition.is_set or self.imposition.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.imposition.get_name_leafdata())
                                    if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                    if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_interface.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.pw_list_id.is_set or self.pw_list_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pw_list_id.get_name_leafdata())
                                    if (self.pwhe_interface.is_set or self.pwhe_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pwhe_interface.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.vctype.is_set or self.vctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.vctype.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "control-word" or name == "imposition" or name == "ipv4-next-hop" or name == "out-interface" or name == "out-label" or name == "path-flags-decode" or name == "pw-list-id" or name == "pwhe-interface" or name == "table-id" or name == "table-name" or name == "vctype"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "control-word"):
                                        self.control_word = value
                                        self.control_word.value_namespace = name_space
                                        self.control_word.value_namespace_prefix = name_space_prefix
                                    if(value_path == "imposition"):
                                        self.imposition = value
                                        self.imposition.value_namespace = name_space
                                        self.imposition.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4-next-hop"):
                                        self.ipv4_next_hop = value
                                        self.ipv4_next_hop.value_namespace = name_space
                                        self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-interface"):
                                        self.out_interface = value
                                        self.out_interface.value_namespace = name_space
                                        self.out_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pw-list-id"):
                                        self.pw_list_id = value
                                        self.pw_list_id.value_namespace = name_space
                                        self.pw_list_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pwhe-interface"):
                                        self.pwhe_interface = value
                                        self.pwhe_interface.value_namespace = name_space
                                        self.pwhe_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "vctype"):
                                        self.vctype = value
                                        self.vctype.value_namespace = name_space
                                        self.vctype.value_namespace_prefix = name_space_prefix


                            class PwListData(Entity):
                                """
                                pw list data
                                
                                .. attribute:: l2_interface
                                
                                	Pseudo\-wire Layer 2 interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: l3_interface
                                
                                	Pseudo\-wire Layer 3 interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: path_flags_decode
                                
                                	Path flag decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PwListData, self).__init__()

                                    self.yang_name = "pw-list-data"
                                    self.yang_parent_name = "moi"

                                    self.l2_interface = YLeaf(YType.str, "l2-interface")

                                    self.l3_interface = YLeaf(YType.str, "l3-interface")

                                    self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("l2_interface",
                                                    "l3_interface",
                                                    "path_flags_decode",
                                                    "table_id",
                                                    "table_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PwListData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.l2_interface.is_set or
                                        self.l3_interface.is_set or
                                        self.path_flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.l2_interface.yfilter != YFilter.not_set or
                                        self.l3_interface.yfilter != YFilter.not_set or
                                        self.path_flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "pw-list-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.l2_interface.is_set or self.l2_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.l2_interface.get_name_leafdata())
                                    if (self.l3_interface.is_set or self.l3_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.l3_interface.get_name_leafdata())
                                    if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "l2-interface" or name == "l3-interface" or name == "path-flags-decode" or name == "table-id" or name == "table-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "l2-interface"):
                                        self.l2_interface = value
                                        self.l2_interface.value_namespace = name_space
                                        self.l2_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "l3-interface"):
                                        self.l3_interface = value
                                        self.l3_interface.value_namespace = name_space
                                        self.l3_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-flags-decode"):
                                        self.path_flags_decode = value
                                        self.path_flags_decode.value_namespace = name_space
                                        self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix


                            class Stackv4Data(Entity):
                                """
                                stackv4 data
                                
                                .. attribute:: inner_stack
                                
                                	Inner stack
                                	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack>`
                                
                                .. attribute:: nexthop
                                
                                	Nexthop
                                	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.Nexthop>`
                                
                                .. attribute:: owner_application_type
                                
                                	Owner application type
                                	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data, self).__init__()

                                    self.yang_name = "stackv4-data"
                                    self.yang_parent_name = "moi"

                                    self.owner_application_type = YLeaf(YType.enumeration, "owner-application-type")

                                    self.inner_stack = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                    self.inner_stack.parent = self
                                    self._children_name_map["inner_stack"] = "inner-stack"
                                    self._children_yang_names.add("inner-stack")

                                    self.nexthop = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                    self.nexthop.parent = self
                                    self._children_name_map["nexthop"] = "nexthop"
                                    self._children_yang_names.add("nexthop")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("owner_application_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data, self).__setattr__(name, value)


                                class Nexthop(Entity):
                                    """
                                    Nexthop
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4_next_hop
                                    
                                    	IPv4 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: load_metric
                                    
                                    	Routing path's load metric
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: local_label
                                    
                                    	TE backup path local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing Interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_interface_parent
                                    
                                    	Outgoing Interface's parent
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__init__()

                                        self.yang_name = "nexthop"
                                        self.yang_parent_name = "stackv4-data"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv4_next_hop = YLeaf(YType.str, "ipv4-next-hop")

                                        self.load_metric = YLeaf(YType.uint32, "load-metric")

                                        self.local_label = YLeaf(YType.uint32, "local-label")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_interface_parent = YLeaf(YType.str, "out-interface-parent")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                        self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv4_next_hop",
                                                        "load_metric",
                                                        "local_label",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_interface_parent",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name",
                                                        "tunnel_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.Nexthop, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv4_next_hop.is_set or
                                            self.load_metric.is_set or
                                            self.local_label.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_interface_parent.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set or
                                            self.tunnel_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv4_next_hop.yfilter != YFilter.not_set or
                                            self.load_metric.yfilter != YFilter.not_set or
                                            self.local_label.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_interface_parent.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set or
                                            self.tunnel_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nexthop" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv4_next_hop.is_set or self.ipv4_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4_next_hop.get_name_leafdata())
                                        if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_metric.get_name_leafdata())
                                        if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_label.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_interface_parent.is_set or self.out_interface_parent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface_parent.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())
                                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv4-next-hop" or name == "load-metric" or name == "local-label" or name == "next-hop-id" or name == "out-interface" or name == "out-interface-parent" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name" or name == "tunnel-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4-next-hop"):
                                            self.ipv4_next_hop = value
                                            self.ipv4_next_hop.value_namespace = name_space
                                            self.ipv4_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-metric"):
                                            self.load_metric = value
                                            self.load_metric.value_namespace = name_space
                                            self.load_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-label"):
                                            self.local_label = value
                                            self.local_label.value_namespace = name_space
                                            self.local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface-parent"):
                                            self.out_interface_parent = value
                                            self.out_interface_parent.value_namespace = name_space
                                            self.out_interface_parent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tunnel-id"):
                                            self.tunnel_id = value
                                            self.tunnel_id.value_namespace = name_space
                                            self.tunnel_id.value_namespace_prefix = name_space_prefix


                                class InnerStack(Entity):
                                    """
                                    Inner stack
                                    
                                    .. attribute:: label
                                    
                                    	Info related to outgoing labels
                                    	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Remote nexthop addresses
                                    	**type**\:  list of str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: num_lbls
                                    
                                    	Depth of inner label stack
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: num_nexthops
                                    
                                    	Number of remote nexthop addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__init__()

                                        self.yang_name = "inner-stack"
                                        self.yang_parent_name = "stackv4-data"

                                        self.nexthop = YLeafList(YType.str, "nexthop")

                                        self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                        self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                        self.label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nexthop",
                                                        "num_lbls",
                                                        "num_nexthops") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack, self).__setattr__(name, value)


                                    class Label(Entity):
                                        """
                                        Info related to outgoing labels
                                        
                                        .. attribute:: outgoing_label
                                        
                                        	Remote Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: outgoing_label_str
                                        
                                        	Remote Label string
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__init__()

                                            self.yang_name = "label"
                                            self.yang_parent_name = "inner-stack"

                                            self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                            self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("outgoing_label",
                                                            "outgoing_label_str") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.outgoing_label.is_set or
                                                self.outgoing_label_str.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.outgoing_label.yfilter != YFilter.not_set or
                                                self.outgoing_label_str.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                            if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "outgoing-label"):
                                                self.outgoing_label = value
                                                self.outgoing_label.value_namespace = name_space
                                                self.outgoing_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "outgoing-label-str"):
                                                self.outgoing_label_str = value
                                                self.outgoing_label_str.value_namespace = name_space
                                                self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.label:
                                            if (c.has_data()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return (
                                            self.num_lbls.is_set or
                                            self.num_nexthops.is_set)

                                    def has_operation(self):
                                        for c in self.label:
                                            if (c.has_operation()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nexthop.yfilter != YFilter.not_set or
                                            self.num_lbls.yfilter != YFilter.not_set or
                                            self.num_nexthops.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inner-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                        if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                        leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "label"):
                                            for c in self.label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack.Label()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nexthop"):
                                            self.nexthop.append(value)
                                        if(value_path == "num-lbls"):
                                            self.num_lbls = value
                                            self.num_lbls.value_namespace = name_space
                                            self.num_lbls.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-nexthops"):
                                            self.num_nexthops = value
                                            self.num_nexthops.value_namespace = name_space
                                            self.num_nexthops.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.owner_application_type.is_set or
                                        (self.inner_stack is not None and self.inner_stack.has_data()) or
                                        (self.nexthop is not None and self.nexthop.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.owner_application_type.yfilter != YFilter.not_set or
                                        (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                        (self.nexthop is not None and self.nexthop.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "stackv4-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.owner_application_type.is_set or self.owner_application_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.owner_application_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "inner-stack"):
                                        if (self.inner_stack is None):
                                            self.inner_stack = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.InnerStack()
                                            self.inner_stack.parent = self
                                            self._children_name_map["inner_stack"] = "inner-stack"
                                        return self.inner_stack

                                    if (child_yang_name == "nexthop"):
                                        if (self.nexthop is None):
                                            self.nexthop = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data.Nexthop()
                                            self.nexthop.parent = self
                                            self._children_name_map["nexthop"] = "nexthop"
                                        return self.nexthop

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "inner-stack" or name == "nexthop" or name == "owner-application-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "owner-application-type"):
                                        self.owner_application_type = value
                                        self.owner_application_type.value_namespace = name_space
                                        self.owner_application_type.value_namespace_prefix = name_space_prefix


                            class Stackv6Data(Entity):
                                """
                                stackv6 data
                                
                                .. attribute:: inner_stack
                                
                                	Inner stack
                                	**type**\:   :py:class:`InnerStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack>`
                                
                                .. attribute:: nexthop
                                
                                	Nexthop
                                	**type**\:   :py:class:`Nexthop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.Nexthop>`
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data, self).__init__()

                                    self.yang_name = "stackv6-data"
                                    self.yang_parent_name = "moi"

                                    self.inner_stack = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                    self.inner_stack.parent = self
                                    self._children_name_map["inner_stack"] = "inner-stack"
                                    self._children_yang_names.add("inner-stack")

                                    self.nexthop = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                    self.nexthop.parent = self
                                    self._children_name_map["nexthop"] = "nexthop"
                                    self._children_yang_names.add("nexthop")


                                class Nexthop(Entity):
                                    """
                                    Nexthop
                                    
                                    .. attribute:: backup_path_id
                                    
                                    	Routing path backup id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv6_next_hop
                                    
                                    	IPv6 nexthop
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: next_hop_id
                                    
                                    	Next hop ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_interface
                                    
                                    	Outgoing interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: out_label
                                    
                                    	Outgoing label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: out_label_name
                                    
                                    	Outgoing label name
                                    	**type**\:  str
                                    
                                    .. attribute:: path_flags_decode
                                    
                                    	Path flag decoded string
                                    	**type**\:  str
                                    
                                    .. attribute:: path_id
                                    
                                    	Routing path id
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: table_name
                                    
                                    	VRF table name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__init__()

                                        self.yang_name = "nexthop"
                                        self.yang_parent_name = "stackv6-data"

                                        self.backup_path_id = YLeaf(YType.uint8, "backup-path-id")

                                        self.ipv6_next_hop = YLeaf(YType.str, "ipv6-next-hop")

                                        self.next_hop_id = YLeaf(YType.uint32, "next-hop-id")

                                        self.out_interface = YLeaf(YType.str, "out-interface")

                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                        self.out_label_name = YLeaf(YType.str, "out-label-name")

                                        self.path_flags_decode = YLeaf(YType.str, "path-flags-decode")

                                        self.path_id = YLeaf(YType.uint8, "path-id")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.table_name = YLeaf(YType.str, "table-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_path_id",
                                                        "ipv6_next_hop",
                                                        "next_hop_id",
                                                        "out_interface",
                                                        "out_label",
                                                        "out_label_name",
                                                        "path_flags_decode",
                                                        "path_id",
                                                        "table_id",
                                                        "table_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.Nexthop, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_path_id.is_set or
                                            self.ipv6_next_hop.is_set or
                                            self.next_hop_id.is_set or
                                            self.out_interface.is_set or
                                            self.out_label.is_set or
                                            self.out_label_name.is_set or
                                            self.path_flags_decode.is_set or
                                            self.path_id.is_set or
                                            self.table_id.is_set or
                                            self.table_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_path_id.yfilter != YFilter.not_set or
                                            self.ipv6_next_hop.yfilter != YFilter.not_set or
                                            self.next_hop_id.yfilter != YFilter.not_set or
                                            self.out_interface.yfilter != YFilter.not_set or
                                            self.out_label.yfilter != YFilter.not_set or
                                            self.out_label_name.yfilter != YFilter.not_set or
                                            self.path_flags_decode.yfilter != YFilter.not_set or
                                            self.path_id.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            self.table_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nexthop" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                                        if (self.ipv6_next_hop.is_set or self.ipv6_next_hop.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6_next_hop.get_name_leafdata())
                                        if (self.next_hop_id.is_set or self.next_hop_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hop_id.get_name_leafdata())
                                        if (self.out_interface.is_set or self.out_interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_interface.get_name_leafdata())
                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                        if (self.out_label_name.is_set or self.out_label_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.out_label_name.get_name_leafdata())
                                        if (self.path_flags_decode.is_set or self.path_flags_decode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_flags_decode.get_name_leafdata())
                                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_id.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())
                                        if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-path-id" or name == "ipv6-next-hop" or name == "next-hop-id" or name == "out-interface" or name == "out-label" or name == "out-label-name" or name == "path-flags-decode" or name == "path-id" or name == "table-id" or name == "table-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-path-id"):
                                            self.backup_path_id = value
                                            self.backup_path_id.value_namespace = name_space
                                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6-next-hop"):
                                            self.ipv6_next_hop = value
                                            self.ipv6_next_hop.value_namespace = name_space
                                            self.ipv6_next_hop.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hop-id"):
                                            self.next_hop_id = value
                                            self.next_hop_id.value_namespace = name_space
                                            self.next_hop_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-interface"):
                                            self.out_interface = value
                                            self.out_interface.value_namespace = name_space
                                            self.out_interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label"):
                                            self.out_label = value
                                            self.out_label.value_namespace = name_space
                                            self.out_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "out-label-name"):
                                            self.out_label_name = value
                                            self.out_label_name.value_namespace = name_space
                                            self.out_label_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-flags-decode"):
                                            self.path_flags_decode = value
                                            self.path_flags_decode.value_namespace = name_space
                                            self.path_flags_decode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-id"):
                                            self.path_id = value
                                            self.path_id.value_namespace = name_space
                                            self.path_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-name"):
                                            self.table_name = value
                                            self.table_name.value_namespace = name_space
                                            self.table_name.value_namespace_prefix = name_space_prefix


                                class InnerStack(Entity):
                                    """
                                    Inner stack
                                    
                                    .. attribute:: label
                                    
                                    	Info related to outgoing labels
                                    	**type**\: list of    :py:class:`Label <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label>`
                                    
                                    .. attribute:: nexthop
                                    
                                    	Remote nexthop addresses
                                    	**type**\:  list of str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: num_lbls
                                    
                                    	Depth of inner label stack
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: num_nexthops
                                    
                                    	Number of remote nexthop addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-lsd-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__init__()

                                        self.yang_name = "inner-stack"
                                        self.yang_parent_name = "stackv6-data"

                                        self.nexthop = YLeafList(YType.str, "nexthop")

                                        self.num_lbls = YLeaf(YType.uint8, "num-lbls")

                                        self.num_nexthops = YLeaf(YType.uint8, "num-nexthops")

                                        self.label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("nexthop",
                                                        "num_lbls",
                                                        "num_nexthops") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack, self).__setattr__(name, value)


                                    class Label(Entity):
                                        """
                                        Info related to outgoing labels
                                        
                                        .. attribute:: outgoing_label
                                        
                                        	Remote Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: outgoing_label_str
                                        
                                        	Remote Label string
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-lsd-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__init__()

                                            self.yang_name = "label"
                                            self.yang_parent_name = "inner-stack"

                                            self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                                            self.outgoing_label_str = YLeaf(YType.str, "outgoing-label-str")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("outgoing_label",
                                                            "outgoing_label_str") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.outgoing_label.is_set or
                                                self.outgoing_label_str.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.outgoing_label.yfilter != YFilter.not_set or
                                                self.outgoing_label_str.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                                            if (self.outgoing_label_str.is_set or self.outgoing_label_str.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.outgoing_label_str.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "outgoing-label" or name == "outgoing-label-str"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "outgoing-label"):
                                                self.outgoing_label = value
                                                self.outgoing_label.value_namespace = name_space
                                                self.outgoing_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "outgoing-label-str"):
                                                self.outgoing_label_str = value
                                                self.outgoing_label_str.value_namespace = name_space
                                                self.outgoing_label_str.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.label:
                                            if (c.has_data()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.yfilter != YFilter.not_set):
                                                return True
                                        return (
                                            self.num_lbls.is_set or
                                            self.num_nexthops.is_set)

                                    def has_operation(self):
                                        for c in self.label:
                                            if (c.has_operation()):
                                                return True
                                        for leaf in self.nexthop.getYLeafs():
                                            if (leaf.is_set):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.nexthop.yfilter != YFilter.not_set or
                                            self.num_lbls.yfilter != YFilter.not_set or
                                            self.num_nexthops.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "inner-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_lbls.is_set or self.num_lbls.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbls.get_name_leafdata())
                                        if (self.num_nexthops.is_set or self.num_nexthops.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_nexthops.get_name_leafdata())

                                        leaf_name_data.extend(self.nexthop.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "label"):
                                            for c in self.label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack.Label()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label" or name == "nexthop" or name == "num-lbls" or name == "num-nexthops"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "nexthop"):
                                            self.nexthop.append(value)
                                        if(value_path == "num-lbls"):
                                            self.num_lbls = value
                                            self.num_lbls.value_namespace = name_space
                                            self.num_lbls.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-nexthops"):
                                            self.num_nexthops = value
                                            self.num_nexthops.value_namespace = name_space
                                            self.num_nexthops.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.inner_stack is not None and self.inner_stack.has_data()) or
                                        (self.nexthop is not None and self.nexthop.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.inner_stack is not None and self.inner_stack.has_operation()) or
                                        (self.nexthop is not None and self.nexthop.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "stackv6-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "inner-stack"):
                                        if (self.inner_stack is None):
                                            self.inner_stack = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.InnerStack()
                                            self.inner_stack.parent = self
                                            self._children_name_map["inner_stack"] = "inner-stack"
                                        return self.inner_stack

                                    if (child_yang_name == "nexthop"):
                                        if (self.nexthop is None):
                                            self.nexthop = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data.Nexthop()
                                            self.nexthop.parent = self
                                            self._children_name_map["nexthop"] = "nexthop"
                                        return self.nexthop

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "inner-stack" or name == "nexthop"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class TeHeadData(Entity):
                                """
                                te head data
                                
                                .. attribute:: flags_decode
                                
                                	Flags decoded string
                                	**type**\:  str
                                
                                .. attribute:: table_id
                                
                                	Table ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: table_name
                                
                                	VRF table name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_fwd_class
                                
                                	Tunnel forwarding class
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: tunnel_load_metric
                                
                                	Tunnel Load metric
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_local_label
                                
                                	Tunnel local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tunnel_local_label_str
                                
                                	Tunnel local label stringified
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.TeHeadData, self).__init__()

                                    self.yang_name = "te-head-data"
                                    self.yang_parent_name = "moi"

                                    self.flags_decode = YLeaf(YType.str, "flags-decode")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.table_name = YLeaf(YType.str, "table-name")

                                    self.tunnel_fwd_class = YLeaf(YType.uint8, "tunnel-fwd-class")

                                    self.tunnel_load_metric = YLeaf(YType.uint32, "tunnel-load-metric")

                                    self.tunnel_local_label = YLeaf(YType.uint32, "tunnel-local-label")

                                    self.tunnel_local_label_str = YLeaf(YType.str, "tunnel-local-label-str")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("flags_decode",
                                                    "table_id",
                                                    "table_name",
                                                    "tunnel_fwd_class",
                                                    "tunnel_load_metric",
                                                    "tunnel_local_label",
                                                    "tunnel_local_label_str") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.TeHeadData, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.flags_decode.is_set or
                                        self.table_id.is_set or
                                        self.table_name.is_set or
                                        self.tunnel_fwd_class.is_set or
                                        self.tunnel_load_metric.is_set or
                                        self.tunnel_local_label.is_set or
                                        self.tunnel_local_label_str.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.flags_decode.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        self.table_name.yfilter != YFilter.not_set or
                                        self.tunnel_fwd_class.yfilter != YFilter.not_set or
                                        self.tunnel_load_metric.yfilter != YFilter.not_set or
                                        self.tunnel_local_label.yfilter != YFilter.not_set or
                                        self.tunnel_local_label_str.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-head-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.flags_decode.is_set or self.flags_decode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.flags_decode.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                    if (self.table_name.is_set or self.table_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_name.get_name_leafdata())
                                    if (self.tunnel_fwd_class.is_set or self.tunnel_fwd_class.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_fwd_class.get_name_leafdata())
                                    if (self.tunnel_load_metric.is_set or self.tunnel_load_metric.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_load_metric.get_name_leafdata())
                                    if (self.tunnel_local_label.is_set or self.tunnel_local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_local_label.get_name_leafdata())
                                    if (self.tunnel_local_label_str.is_set or self.tunnel_local_label_str.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_local_label_str.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags-decode" or name == "table-id" or name == "table-name" or name == "tunnel-fwd-class" or name == "tunnel-load-metric" or name == "tunnel-local-label" or name == "tunnel-local-label-str"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "flags-decode"):
                                        self.flags_decode = value
                                        self.flags_decode.value_namespace = name_space
                                        self.flags_decode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-name"):
                                        self.table_name = value
                                        self.table_name.value_namespace = name_space
                                        self.table_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-fwd-class"):
                                        self.tunnel_fwd_class = value
                                        self.tunnel_fwd_class.value_namespace = name_space
                                        self.tunnel_fwd_class.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-load-metric"):
                                        self.tunnel_load_metric = value
                                        self.tunnel_load_metric.value_namespace = name_space
                                        self.tunnel_load_metric.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-local-label"):
                                        self.tunnel_local_label = value
                                        self.tunnel_local_label.value_namespace = name_space
                                        self.tunnel_local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-local-label-str"):
                                        self.tunnel_local_label_str = value
                                        self.tunnel_local_label_str.value_namespace = name_space
                                        self.tunnel_local_label_str.value_namespace_prefix = name_space_prefix


                            class DmtcData(Entity):
                                """
                                dmtc data
                                
                                .. attribute:: dmtc_ext_ifh
                                
                                	DMTC External Interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-lsd-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.DmtcData, self).__init__()

                                    self.yang_name = "dmtc-data"
                                    self.yang_parent_name = "moi"

                                    self.dmtc_ext_ifh = YLeaf(YType.str, "dmtc-ext-ifh")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("dmtc_ext_ifh") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.DmtcData, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.dmtc_ext_ifh.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.dmtc_ext_ifh.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "dmtc-data" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.dmtc_ext_ifh.is_set or self.dmtc_ext_ifh.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dmtc_ext_ifh.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "dmtc-ext-ifh"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "dmtc-ext-ifh"):
                                        self.dmtc_ext_ifh = value
                                        self.dmtc_ext_ifh.value_namespace = name_space
                                        self.dmtc_ext_ifh.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.moi_type.is_set or
                                    (self.dmtc_data is not None and self.dmtc_data.has_data()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_data()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_data()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_data()) or
                                    (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_data()) or
                                    (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_data()) or
                                    (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_data()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_data()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_data()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_data()) or
                                    (self.stackv4_data is not None and self.stackv4_data.has_data()) or
                                    (self.stackv6_data is not None and self.stackv6_data.has_data()) or
                                    (self.te_head_data is not None and self.te_head_data.has_data()) or
                                    (self.tev4_data is not None and self.tev4_data.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.moi_type.yfilter != YFilter.not_set or
                                    (self.dmtc_data is not None and self.dmtc_data.has_operation()) or
                                    (self.ip_sub_data is not None and self.ip_sub_data.has_operation()) or
                                    (self.ipv4_data is not None and self.ipv4_data.has_operation()) or
                                    (self.ipv6_data is not None and self.ipv6_data.has_operation()) or
                                    (self.pop_and_lookup_ipv4 is not None and self.pop_and_lookup_ipv4.has_operation()) or
                                    (self.pop_and_lookup_ipv6 is not None and self.pop_and_lookup_ipv6.has_operation()) or
                                    (self.pop_and_lookup_tp is not None and self.pop_and_lookup_tp.has_operation()) or
                                    (self.pseudowire_data is not None and self.pseudowire_data.has_operation()) or
                                    (self.pseudowire_head_end_data is not None and self.pseudowire_head_end_data.has_operation()) or
                                    (self.pw_list_data is not None and self.pw_list_data.has_operation()) or
                                    (self.stackv4_data is not None and self.stackv4_data.has_operation()) or
                                    (self.stackv6_data is not None and self.stackv6_data.has_operation()) or
                                    (self.te_head_data is not None and self.te_head_data.has_operation()) or
                                    (self.tev4_data is not None and self.tev4_data.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "moi" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.moi_type.is_set or self.moi_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.moi_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "dmtc-data"):
                                    if (self.dmtc_data is None):
                                        self.dmtc_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.DmtcData()
                                        self.dmtc_data.parent = self
                                        self._children_name_map["dmtc_data"] = "dmtc-data"
                                    return self.dmtc_data

                                if (child_yang_name == "ip-sub-data"):
                                    if (self.ip_sub_data is None):
                                        self.ip_sub_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.IpSubData()
                                        self.ip_sub_data.parent = self
                                        self._children_name_map["ip_sub_data"] = "ip-sub-data"
                                    return self.ip_sub_data

                                if (child_yang_name == "ipv4-data"):
                                    if (self.ipv4_data is None):
                                        self.ipv4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv4Data()
                                        self.ipv4_data.parent = self
                                        self._children_name_map["ipv4_data"] = "ipv4-data"
                                    return self.ipv4_data

                                if (child_yang_name == "ipv6-data"):
                                    if (self.ipv6_data is None):
                                        self.ipv6_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Ipv6Data()
                                        self.ipv6_data.parent = self
                                        self._children_name_map["ipv6_data"] = "ipv6-data"
                                    return self.ipv6_data

                                if (child_yang_name == "pop-and-lookup-ipv4"):
                                    if (self.pop_and_lookup_ipv4 is None):
                                        self.pop_and_lookup_ipv4 = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv4()
                                        self.pop_and_lookup_ipv4.parent = self
                                        self._children_name_map["pop_and_lookup_ipv4"] = "pop-and-lookup-ipv4"
                                    return self.pop_and_lookup_ipv4

                                if (child_yang_name == "pop-and-lookup-ipv6"):
                                    if (self.pop_and_lookup_ipv6 is None):
                                        self.pop_and_lookup_ipv6 = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupIpv6()
                                        self.pop_and_lookup_ipv6.parent = self
                                        self._children_name_map["pop_and_lookup_ipv6"] = "pop-and-lookup-ipv6"
                                    return self.pop_and_lookup_ipv6

                                if (child_yang_name == "pop-and-lookup-tp"):
                                    if (self.pop_and_lookup_tp is None):
                                        self.pop_and_lookup_tp = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PopAndLookupTp()
                                        self.pop_and_lookup_tp.parent = self
                                        self._children_name_map["pop_and_lookup_tp"] = "pop-and-lookup-tp"
                                    return self.pop_and_lookup_tp

                                if (child_yang_name == "pseudowire-data"):
                                    if (self.pseudowire_data is None):
                                        self.pseudowire_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireData()
                                        self.pseudowire_data.parent = self
                                        self._children_name_map["pseudowire_data"] = "pseudowire-data"
                                    return self.pseudowire_data

                                if (child_yang_name == "pseudowire-head-end-data"):
                                    if (self.pseudowire_head_end_data is None):
                                        self.pseudowire_head_end_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PseudowireHeadEndData()
                                        self.pseudowire_head_end_data.parent = self
                                        self._children_name_map["pseudowire_head_end_data"] = "pseudowire-head-end-data"
                                    return self.pseudowire_head_end_data

                                if (child_yang_name == "pw-list-data"):
                                    if (self.pw_list_data is None):
                                        self.pw_list_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.PwListData()
                                        self.pw_list_data.parent = self
                                        self._children_name_map["pw_list_data"] = "pw-list-data"
                                    return self.pw_list_data

                                if (child_yang_name == "stackv4-data"):
                                    if (self.stackv4_data is None):
                                        self.stackv4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv4Data()
                                        self.stackv4_data.parent = self
                                        self._children_name_map["stackv4_data"] = "stackv4-data"
                                    return self.stackv4_data

                                if (child_yang_name == "stackv6-data"):
                                    if (self.stackv6_data is None):
                                        self.stackv6_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Stackv6Data()
                                        self.stackv6_data.parent = self
                                        self._children_name_map["stackv6_data"] = "stackv6-data"
                                    return self.stackv6_data

                                if (child_yang_name == "te-head-data"):
                                    if (self.te_head_data is None):
                                        self.te_head_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.TeHeadData()
                                        self.te_head_data.parent = self
                                        self._children_name_map["te_head_data"] = "te-head-data"
                                    return self.te_head_data

                                if (child_yang_name == "tev4-data"):
                                    if (self.tev4_data is None):
                                        self.tev4_data = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi.Tev4Data()
                                        self.tev4_data.parent = self
                                        self._children_name_map["tev4_data"] = "tev4-data"
                                    return self.tev4_data

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "dmtc-data" or name == "ip-sub-data" or name == "ipv4-data" or name == "ipv6-data" or name == "pop-and-lookup-ipv4" or name == "pop-and-lookup-ipv6" or name == "pop-and-lookup-tp" or name == "pseudowire-data" or name == "pseudowire-head-end-data" or name == "pw-list-data" or name == "stackv4-data" or name == "stackv6-data" or name == "te-head-data" or name == "tev4-data" or name == "moi-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "moi-type"):
                                    self.moi_type = value
                                    self.moi_type.value_namespace = name_space
                                    self.moi_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.moi is not None and self.moi.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.moi is not None and self.moi.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "moi-array" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "moi"):
                                if (self.moi is None):
                                    self.moi = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray.Moi()
                                    self.moi.parent = self
                                    self._children_name_map["moi"] = "moi"
                                return self.moi

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "moi"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        for c in self.moi_array:
                            if (c.has_data()):
                                return True
                        return (self.application_resource is not None and self.application_resource.has_data())

                    def has_operation(self):
                        for c in self.moi_array:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.application_resource is not None and self.application_resource.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "mois" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "application-resource"):
                            if (self.application_resource is None):
                                self.application_resource = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.ApplicationResource()
                                self.application_resource.parent = self
                                self._children_name_map["application_resource"] = "application-resource"
                            return self.application_resource

                        if (child_yang_name == "moi-array"):
                            for c in self.moi_array:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois.MoiArray()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.moi_array.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "application-resource" or name == "moi-array"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    for c in self.associated_fpi:
                        if (c.has_data()):
                            return True
                    for c in self.mois:
                        if (c.has_data()):
                            return True
                    for c in self.v4_rpf:
                        if (c.has_data()):
                            return True
                    for c in self.v6_rpf:
                        if (c.has_data()):
                            return True
                    return (
                        self.label_id.is_set or
                        self.bcdl_priority.is_set or
                        self.lsd_queue.is_set or
                        self.priority_updated.is_set or
                        self.rewrite_version.is_set or
                        self.rw_install_age.is_set or
                        self.rw_install_time.is_set or
                        self.rw_updated.is_set or
                        (self.fpi_key is not None and self.fpi_key.has_data()) or
                        (self.rewrite_id is not None and self.rewrite_id.has_data()))

                def has_operation(self):
                    for c in self.associated_fpi:
                        if (c.has_operation()):
                            return True
                    for c in self.mois:
                        if (c.has_operation()):
                            return True
                    for c in self.v4_rpf:
                        if (c.has_operation()):
                            return True
                    for c in self.v6_rpf:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.label_id.yfilter != YFilter.not_set or
                        self.bcdl_priority.yfilter != YFilter.not_set or
                        self.lsd_queue.yfilter != YFilter.not_set or
                        self.priority_updated.yfilter != YFilter.not_set or
                        self.rewrite_version.yfilter != YFilter.not_set or
                        self.rw_install_age.yfilter != YFilter.not_set or
                        self.rw_install_time.yfilter != YFilter.not_set or
                        self.rw_updated.yfilter != YFilter.not_set or
                        (self.fpi_key is not None and self.fpi_key.has_operation()) or
                        (self.rewrite_id is not None and self.rewrite_id.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "rewrite-label" + "[label-id='" + self.label_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/rewrite-labels/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.label_id.is_set or self.label_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.label_id.get_name_leafdata())
                    if (self.bcdl_priority.is_set or self.bcdl_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bcdl_priority.get_name_leafdata())
                    if (self.lsd_queue.is_set or self.lsd_queue.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsd_queue.get_name_leafdata())
                    if (self.priority_updated.is_set or self.priority_updated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.priority_updated.get_name_leafdata())
                    if (self.rewrite_version.is_set or self.rewrite_version.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rewrite_version.get_name_leafdata())
                    if (self.rw_install_age.is_set or self.rw_install_age.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rw_install_age.get_name_leafdata())
                    if (self.rw_install_time.is_set or self.rw_install_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rw_install_time.get_name_leafdata())
                    if (self.rw_updated.is_set or self.rw_updated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rw_updated.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "associated-fpi"):
                        for c in self.associated_fpi:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.AssociatedFpi()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.associated_fpi.append(c)
                        return c

                    if (child_yang_name == "fpi-key"):
                        if (self.fpi_key is None):
                            self.fpi_key = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.FpiKey()
                            self.fpi_key.parent = self
                            self._children_name_map["fpi_key"] = "fpi-key"
                        return self.fpi_key

                    if (child_yang_name == "mois"):
                        for c in self.mois:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.Mois()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.mois.append(c)
                        return c

                    if (child_yang_name == "rewrite-id"):
                        if (self.rewrite_id is None):
                            self.rewrite_id = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.RewriteId()
                            self.rewrite_id.parent = self
                            self._children_name_map["rewrite_id"] = "rewrite-id"
                        return self.rewrite_id

                    if (child_yang_name == "v4-rpf"):
                        for c in self.v4_rpf:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.V4Rpf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.v4_rpf.append(c)
                        return c

                    if (child_yang_name == "v6-rpf"):
                        for c in self.v6_rpf:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLsd.Rewrite.RewriteLabels.RewriteLabel.V6Rpf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.v6_rpf.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "associated-fpi" or name == "fpi-key" or name == "mois" or name == "rewrite-id" or name == "v4-rpf" or name == "v6-rpf" or name == "label-id" or name == "bcdl-priority" or name == "lsd-queue" or name == "priority-updated" or name == "rewrite-version" or name == "rw-install-age" or name == "rw-install-time" or name == "rw-updated"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "label-id"):
                        self.label_id = value
                        self.label_id.value_namespace = name_space
                        self.label_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "bcdl-priority"):
                        self.bcdl_priority = value
                        self.bcdl_priority.value_namespace = name_space
                        self.bcdl_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsd-queue"):
                        self.lsd_queue = value
                        self.lsd_queue.value_namespace = name_space
                        self.lsd_queue.value_namespace_prefix = name_space_prefix
                    if(value_path == "priority-updated"):
                        self.priority_updated = value
                        self.priority_updated.value_namespace = name_space
                        self.priority_updated.value_namespace_prefix = name_space_prefix
                    if(value_path == "rewrite-version"):
                        self.rewrite_version = value
                        self.rewrite_version.value_namespace = name_space
                        self.rewrite_version.value_namespace_prefix = name_space_prefix
                    if(value_path == "rw-install-age"):
                        self.rw_install_age = value
                        self.rw_install_age.value_namespace = name_space
                        self.rw_install_age.value_namespace_prefix = name_space_prefix
                    if(value_path == "rw-install-time"):
                        self.rw_install_time = value
                        self.rw_install_time.value_namespace = name_space
                        self.rw_install_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "rw-updated"):
                        self.rw_updated = value
                        self.rw_updated.value_namespace = name_space
                        self.rw_updated.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.rewrite_label:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.rewrite_label:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "rewrite-labels" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "rewrite-label"):
                    for c in self.rewrite_label:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsd.Rewrite.RewriteLabels.RewriteLabel()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.rewrite_label.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "rewrite-label"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.rewrite_ipv4s is not None and self.rewrite_ipv4s.has_data()) or
                (self.rewrite_labels is not None and self.rewrite_labels.has_data()) or
                (self.rewrite_pws is not None and self.rewrite_pws.has_data()) or
                (self.rewrite_tes is not None and self.rewrite_tes.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.rewrite_ipv4s is not None and self.rewrite_ipv4s.has_operation()) or
                (self.rewrite_labels is not None and self.rewrite_labels.has_operation()) or
                (self.rewrite_pws is not None and self.rewrite_pws.has_operation()) or
                (self.rewrite_tes is not None and self.rewrite_tes.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "rewrite" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "rewrite-ipv4s"):
                if (self.rewrite_ipv4s is None):
                    self.rewrite_ipv4s = MplsLsd.Rewrite.RewriteIpv4S()
                    self.rewrite_ipv4s.parent = self
                    self._children_name_map["rewrite_ipv4s"] = "rewrite-ipv4s"
                return self.rewrite_ipv4s

            if (child_yang_name == "rewrite-labels"):
                if (self.rewrite_labels is None):
                    self.rewrite_labels = MplsLsd.Rewrite.RewriteLabels()
                    self.rewrite_labels.parent = self
                    self._children_name_map["rewrite_labels"] = "rewrite-labels"
                return self.rewrite_labels

            if (child_yang_name == "rewrite-pws"):
                if (self.rewrite_pws is None):
                    self.rewrite_pws = MplsLsd.Rewrite.RewritePws()
                    self.rewrite_pws.parent = self
                    self._children_name_map["rewrite_pws"] = "rewrite-pws"
                return self.rewrite_pws

            if (child_yang_name == "rewrite-tes"):
                if (self.rewrite_tes is None):
                    self.rewrite_tes = MplsLsd.Rewrite.RewriteTes()
                    self.rewrite_tes.parent = self
                    self._children_name_map["rewrite_tes"] = "rewrite-tes"
                return self.rewrite_tes

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "rewrite-ipv4s" or name == "rewrite-labels" or name == "rewrite-pws" or name == "rewrite-tes"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class RewriteSummary(Entity):
        """
        Rewrite Summary 
        
        .. attribute:: ipv4_paths
        
        	Count for IPv4 paths
        	**type**\:   :py:class:`Ipv4Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.RewriteSummary.Ipv4Paths>`
        
        .. attribute:: ipv6_paths
        
        	Count for IPv6 paths
        	**type**\:   :py:class:`Ipv6Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.RewriteSummary.Ipv6Paths>`
        
        .. attribute:: num_dmtctefpi
        
        	Number of DMTC FPI
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: num_ipv4fpi
        
        	Number of IPv4 FPI
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: num_ipv6fpi
        
        	Number of IPv6 FPI
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: num_label_fpi
        
        	Number of label FPI
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: num_pw_list_tefpi
        
        	Number of PW List FPI
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: num_rewrite
        
        	Number of rewrites
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: num_rewrite_rpf_neighbors
        
        	Number of rewrites with RPF Neighbors
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: num_tefpi
        
        	Number of TE FPI
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: total_dmtc_intf
        
        	Total number of DMTC External Interfaces
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: total_forwad_update_message
        
        	Total number of forward update messages
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: total_forward_update
        
        	Total number of forward updates
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: total_ip_sub_paths
        
        	Total number of IP Subscriber paths
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: total_ipv4rpf_neighbors
        
        	Total number of IPv4 RPF Neighbors
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: total_ipv6rpf_neighbors
        
        	Total number of IPv6 RPF Neighbors
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: total_paths
        
        	Total paths
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: total_pw_paths
        
        	Total number of Pseudo\-wire paths
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: total_t_ev4_paths
        
        	Total number of Traffic Eng IPv4 paths
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: total_te_head_paths
        
        	Total number of Traffic Eng Head paths
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: vrf_name_xr
        
        	VRF Name
        	**type**\:  str
        
        

        """

        _prefix = 'mpls-lsd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLsd.RewriteSummary, self).__init__()

            self.yang_name = "rewrite-summary"
            self.yang_parent_name = "mpls-lsd"

            self.num_dmtctefpi = YLeaf(YType.uint32, "num-dmtctefpi")

            self.num_ipv4fpi = YLeaf(YType.uint32, "num-ipv4fpi")

            self.num_ipv6fpi = YLeaf(YType.uint32, "num-ipv6fpi")

            self.num_label_fpi = YLeaf(YType.uint32, "num-label-fpi")

            self.num_pw_list_tefpi = YLeaf(YType.uint32, "num-pw-list-tefpi")

            self.num_rewrite = YLeaf(YType.uint32, "num-rewrite")

            self.num_rewrite_rpf_neighbors = YLeaf(YType.uint32, "num-rewrite-rpf-neighbors")

            self.num_tefpi = YLeaf(YType.uint32, "num-tefpi")

            self.total_dmtc_intf = YLeaf(YType.uint32, "total-dmtc-intf")

            self.total_forwad_update_message = YLeaf(YType.uint32, "total-forwad-update-message")

            self.total_forward_update = YLeaf(YType.uint32, "total-forward-update")

            self.total_ip_sub_paths = YLeaf(YType.uint32, "total-ip-sub-paths")

            self.total_ipv4rpf_neighbors = YLeaf(YType.uint32, "total-ipv4rpf-neighbors")

            self.total_ipv6rpf_neighbors = YLeaf(YType.uint32, "total-ipv6rpf-neighbors")

            self.total_paths = YLeaf(YType.uint32, "total-paths")

            self.total_pw_paths = YLeaf(YType.uint32, "total-pw-paths")

            self.total_t_ev4_paths = YLeaf(YType.uint32, "total-t-ev4-paths")

            self.total_te_head_paths = YLeaf(YType.uint32, "total-te-head-paths")

            self.vrf_name_xr = YLeaf(YType.str, "vrf-name-xr")

            self.ipv4_paths = MplsLsd.RewriteSummary.Ipv4Paths()
            self.ipv4_paths.parent = self
            self._children_name_map["ipv4_paths"] = "ipv4-paths"
            self._children_yang_names.add("ipv4-paths")

            self.ipv6_paths = MplsLsd.RewriteSummary.Ipv6Paths()
            self.ipv6_paths.parent = self
            self._children_name_map["ipv6_paths"] = "ipv6-paths"
            self._children_yang_names.add("ipv6-paths")

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("num_dmtctefpi",
                            "num_ipv4fpi",
                            "num_ipv6fpi",
                            "num_label_fpi",
                            "num_pw_list_tefpi",
                            "num_rewrite",
                            "num_rewrite_rpf_neighbors",
                            "num_tefpi",
                            "total_dmtc_intf",
                            "total_forwad_update_message",
                            "total_forward_update",
                            "total_ip_sub_paths",
                            "total_ipv4rpf_neighbors",
                            "total_ipv6rpf_neighbors",
                            "total_paths",
                            "total_pw_paths",
                            "total_t_ev4_paths",
                            "total_te_head_paths",
                            "vrf_name_xr") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLsd.RewriteSummary, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLsd.RewriteSummary, self).__setattr__(name, value)


        class Ipv4Paths(Entity):
            """
            Count for IPv4 paths
            
            .. attribute:: total_backup_paths
            
            	Total number of non\-primary backup paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_paths
            
            	Total number of IP paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_pop_lkup_paths
            
            	Total number of Pop\-and\-Lookup paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_protected_paths
            
            	Total number of protected paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_remote_backup_paths
            
            	Total number of remote backup paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.RewriteSummary.Ipv4Paths, self).__init__()

                self.yang_name = "ipv4-paths"
                self.yang_parent_name = "rewrite-summary"

                self.total_backup_paths = YLeaf(YType.uint32, "total-backup-paths")

                self.total_paths = YLeaf(YType.uint32, "total-paths")

                self.total_pop_lkup_paths = YLeaf(YType.uint32, "total-pop-lkup-paths")

                self.total_protected_paths = YLeaf(YType.uint32, "total-protected-paths")

                self.total_remote_backup_paths = YLeaf(YType.uint32, "total-remote-backup-paths")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("total_backup_paths",
                                "total_paths",
                                "total_pop_lkup_paths",
                                "total_protected_paths",
                                "total_remote_backup_paths") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.RewriteSummary.Ipv4Paths, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.RewriteSummary.Ipv4Paths, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.total_backup_paths.is_set or
                    self.total_paths.is_set or
                    self.total_pop_lkup_paths.is_set or
                    self.total_protected_paths.is_set or
                    self.total_remote_backup_paths.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.total_backup_paths.yfilter != YFilter.not_set or
                    self.total_paths.yfilter != YFilter.not_set or
                    self.total_pop_lkup_paths.yfilter != YFilter.not_set or
                    self.total_protected_paths.yfilter != YFilter.not_set or
                    self.total_remote_backup_paths.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "ipv4-paths" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite-summary/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.total_backup_paths.is_set or self.total_backup_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_backup_paths.get_name_leafdata())
                if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_paths.get_name_leafdata())
                if (self.total_pop_lkup_paths.is_set or self.total_pop_lkup_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_pop_lkup_paths.get_name_leafdata())
                if (self.total_protected_paths.is_set or self.total_protected_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_protected_paths.get_name_leafdata())
                if (self.total_remote_backup_paths.is_set or self.total_remote_backup_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_remote_backup_paths.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "total-backup-paths" or name == "total-paths" or name == "total-pop-lkup-paths" or name == "total-protected-paths" or name == "total-remote-backup-paths"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "total-backup-paths"):
                    self.total_backup_paths = value
                    self.total_backup_paths.value_namespace = name_space
                    self.total_backup_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-paths"):
                    self.total_paths = value
                    self.total_paths.value_namespace = name_space
                    self.total_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-pop-lkup-paths"):
                    self.total_pop_lkup_paths = value
                    self.total_pop_lkup_paths.value_namespace = name_space
                    self.total_pop_lkup_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-protected-paths"):
                    self.total_protected_paths = value
                    self.total_protected_paths.value_namespace = name_space
                    self.total_protected_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-remote-backup-paths"):
                    self.total_remote_backup_paths = value
                    self.total_remote_backup_paths.value_namespace = name_space
                    self.total_remote_backup_paths.value_namespace_prefix = name_space_prefix


        class Ipv6Paths(Entity):
            """
            Count for IPv6 paths
            
            .. attribute:: total_backup_paths
            
            	Total number of non\-primary backup paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_paths
            
            	Total number of IP paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_pop_lkup_paths
            
            	Total number of Pop\-and\-Lookup paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_protected_paths
            
            	Total number of protected paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_remote_backup_paths
            
            	Total number of remote backup paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.RewriteSummary.Ipv6Paths, self).__init__()

                self.yang_name = "ipv6-paths"
                self.yang_parent_name = "rewrite-summary"

                self.total_backup_paths = YLeaf(YType.uint32, "total-backup-paths")

                self.total_paths = YLeaf(YType.uint32, "total-paths")

                self.total_pop_lkup_paths = YLeaf(YType.uint32, "total-pop-lkup-paths")

                self.total_protected_paths = YLeaf(YType.uint32, "total-protected-paths")

                self.total_remote_backup_paths = YLeaf(YType.uint32, "total-remote-backup-paths")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("total_backup_paths",
                                "total_paths",
                                "total_pop_lkup_paths",
                                "total_protected_paths",
                                "total_remote_backup_paths") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.RewriteSummary.Ipv6Paths, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.RewriteSummary.Ipv6Paths, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.total_backup_paths.is_set or
                    self.total_paths.is_set or
                    self.total_pop_lkup_paths.is_set or
                    self.total_protected_paths.is_set or
                    self.total_remote_backup_paths.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.total_backup_paths.yfilter != YFilter.not_set or
                    self.total_paths.yfilter != YFilter.not_set or
                    self.total_pop_lkup_paths.yfilter != YFilter.not_set or
                    self.total_protected_paths.yfilter != YFilter.not_set or
                    self.total_remote_backup_paths.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "ipv6-paths" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite-summary/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.total_backup_paths.is_set or self.total_backup_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_backup_paths.get_name_leafdata())
                if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_paths.get_name_leafdata())
                if (self.total_pop_lkup_paths.is_set or self.total_pop_lkup_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_pop_lkup_paths.get_name_leafdata())
                if (self.total_protected_paths.is_set or self.total_protected_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_protected_paths.get_name_leafdata())
                if (self.total_remote_backup_paths.is_set or self.total_remote_backup_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_remote_backup_paths.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "total-backup-paths" or name == "total-paths" or name == "total-pop-lkup-paths" or name == "total-protected-paths" or name == "total-remote-backup-paths"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "total-backup-paths"):
                    self.total_backup_paths = value
                    self.total_backup_paths.value_namespace = name_space
                    self.total_backup_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-paths"):
                    self.total_paths = value
                    self.total_paths.value_namespace = name_space
                    self.total_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-pop-lkup-paths"):
                    self.total_pop_lkup_paths = value
                    self.total_pop_lkup_paths.value_namespace = name_space
                    self.total_pop_lkup_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-protected-paths"):
                    self.total_protected_paths = value
                    self.total_protected_paths.value_namespace = name_space
                    self.total_protected_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-remote-backup-paths"):
                    self.total_remote_backup_paths = value
                    self.total_remote_backup_paths.value_namespace = name_space
                    self.total_remote_backup_paths.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                self.num_dmtctefpi.is_set or
                self.num_ipv4fpi.is_set or
                self.num_ipv6fpi.is_set or
                self.num_label_fpi.is_set or
                self.num_pw_list_tefpi.is_set or
                self.num_rewrite.is_set or
                self.num_rewrite_rpf_neighbors.is_set or
                self.num_tefpi.is_set or
                self.total_dmtc_intf.is_set or
                self.total_forwad_update_message.is_set or
                self.total_forward_update.is_set or
                self.total_ip_sub_paths.is_set or
                self.total_ipv4rpf_neighbors.is_set or
                self.total_ipv6rpf_neighbors.is_set or
                self.total_paths.is_set or
                self.total_pw_paths.is_set or
                self.total_t_ev4_paths.is_set or
                self.total_te_head_paths.is_set or
                self.vrf_name_xr.is_set or
                (self.ipv4_paths is not None and self.ipv4_paths.has_data()) or
                (self.ipv6_paths is not None and self.ipv6_paths.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                self.num_dmtctefpi.yfilter != YFilter.not_set or
                self.num_ipv4fpi.yfilter != YFilter.not_set or
                self.num_ipv6fpi.yfilter != YFilter.not_set or
                self.num_label_fpi.yfilter != YFilter.not_set or
                self.num_pw_list_tefpi.yfilter != YFilter.not_set or
                self.num_rewrite.yfilter != YFilter.not_set or
                self.num_rewrite_rpf_neighbors.yfilter != YFilter.not_set or
                self.num_tefpi.yfilter != YFilter.not_set or
                self.total_dmtc_intf.yfilter != YFilter.not_set or
                self.total_forwad_update_message.yfilter != YFilter.not_set or
                self.total_forward_update.yfilter != YFilter.not_set or
                self.total_ip_sub_paths.yfilter != YFilter.not_set or
                self.total_ipv4rpf_neighbors.yfilter != YFilter.not_set or
                self.total_ipv6rpf_neighbors.yfilter != YFilter.not_set or
                self.total_paths.yfilter != YFilter.not_set or
                self.total_pw_paths.yfilter != YFilter.not_set or
                self.total_t_ev4_paths.yfilter != YFilter.not_set or
                self.total_te_head_paths.yfilter != YFilter.not_set or
                self.vrf_name_xr.yfilter != YFilter.not_set or
                (self.ipv4_paths is not None and self.ipv4_paths.has_operation()) or
                (self.ipv6_paths is not None and self.ipv6_paths.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "rewrite-summary" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.num_dmtctefpi.is_set or self.num_dmtctefpi.yfilter != YFilter.not_set):
                leaf_name_data.append(self.num_dmtctefpi.get_name_leafdata())
            if (self.num_ipv4fpi.is_set or self.num_ipv4fpi.yfilter != YFilter.not_set):
                leaf_name_data.append(self.num_ipv4fpi.get_name_leafdata())
            if (self.num_ipv6fpi.is_set or self.num_ipv6fpi.yfilter != YFilter.not_set):
                leaf_name_data.append(self.num_ipv6fpi.get_name_leafdata())
            if (self.num_label_fpi.is_set or self.num_label_fpi.yfilter != YFilter.not_set):
                leaf_name_data.append(self.num_label_fpi.get_name_leafdata())
            if (self.num_pw_list_tefpi.is_set or self.num_pw_list_tefpi.yfilter != YFilter.not_set):
                leaf_name_data.append(self.num_pw_list_tefpi.get_name_leafdata())
            if (self.num_rewrite.is_set or self.num_rewrite.yfilter != YFilter.not_set):
                leaf_name_data.append(self.num_rewrite.get_name_leafdata())
            if (self.num_rewrite_rpf_neighbors.is_set or self.num_rewrite_rpf_neighbors.yfilter != YFilter.not_set):
                leaf_name_data.append(self.num_rewrite_rpf_neighbors.get_name_leafdata())
            if (self.num_tefpi.is_set or self.num_tefpi.yfilter != YFilter.not_set):
                leaf_name_data.append(self.num_tefpi.get_name_leafdata())
            if (self.total_dmtc_intf.is_set or self.total_dmtc_intf.yfilter != YFilter.not_set):
                leaf_name_data.append(self.total_dmtc_intf.get_name_leafdata())
            if (self.total_forwad_update_message.is_set or self.total_forwad_update_message.yfilter != YFilter.not_set):
                leaf_name_data.append(self.total_forwad_update_message.get_name_leafdata())
            if (self.total_forward_update.is_set or self.total_forward_update.yfilter != YFilter.not_set):
                leaf_name_data.append(self.total_forward_update.get_name_leafdata())
            if (self.total_ip_sub_paths.is_set or self.total_ip_sub_paths.yfilter != YFilter.not_set):
                leaf_name_data.append(self.total_ip_sub_paths.get_name_leafdata())
            if (self.total_ipv4rpf_neighbors.is_set or self.total_ipv4rpf_neighbors.yfilter != YFilter.not_set):
                leaf_name_data.append(self.total_ipv4rpf_neighbors.get_name_leafdata())
            if (self.total_ipv6rpf_neighbors.is_set or self.total_ipv6rpf_neighbors.yfilter != YFilter.not_set):
                leaf_name_data.append(self.total_ipv6rpf_neighbors.get_name_leafdata())
            if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                leaf_name_data.append(self.total_paths.get_name_leafdata())
            if (self.total_pw_paths.is_set or self.total_pw_paths.yfilter != YFilter.not_set):
                leaf_name_data.append(self.total_pw_paths.get_name_leafdata())
            if (self.total_t_ev4_paths.is_set or self.total_t_ev4_paths.yfilter != YFilter.not_set):
                leaf_name_data.append(self.total_t_ev4_paths.get_name_leafdata())
            if (self.total_te_head_paths.is_set or self.total_te_head_paths.yfilter != YFilter.not_set):
                leaf_name_data.append(self.total_te_head_paths.get_name_leafdata())
            if (self.vrf_name_xr.is_set or self.vrf_name_xr.yfilter != YFilter.not_set):
                leaf_name_data.append(self.vrf_name_xr.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "ipv4-paths"):
                if (self.ipv4_paths is None):
                    self.ipv4_paths = MplsLsd.RewriteSummary.Ipv4Paths()
                    self.ipv4_paths.parent = self
                    self._children_name_map["ipv4_paths"] = "ipv4-paths"
                return self.ipv4_paths

            if (child_yang_name == "ipv6-paths"):
                if (self.ipv6_paths is None):
                    self.ipv6_paths = MplsLsd.RewriteSummary.Ipv6Paths()
                    self.ipv6_paths.parent = self
                    self._children_name_map["ipv6_paths"] = "ipv6-paths"
                return self.ipv6_paths

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "ipv4-paths" or name == "ipv6-paths" or name == "num-dmtctefpi" or name == "num-ipv4fpi" or name == "num-ipv6fpi" or name == "num-label-fpi" or name == "num-pw-list-tefpi" or name == "num-rewrite" or name == "num-rewrite-rpf-neighbors" or name == "num-tefpi" or name == "total-dmtc-intf" or name == "total-forwad-update-message" or name == "total-forward-update" or name == "total-ip-sub-paths" or name == "total-ipv4rpf-neighbors" or name == "total-ipv6rpf-neighbors" or name == "total-paths" or name == "total-pw-paths" or name == "total-t-ev4-paths" or name == "total-te-head-paths" or name == "vrf-name-xr"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "num-dmtctefpi"):
                self.num_dmtctefpi = value
                self.num_dmtctefpi.value_namespace = name_space
                self.num_dmtctefpi.value_namespace_prefix = name_space_prefix
            if(value_path == "num-ipv4fpi"):
                self.num_ipv4fpi = value
                self.num_ipv4fpi.value_namespace = name_space
                self.num_ipv4fpi.value_namespace_prefix = name_space_prefix
            if(value_path == "num-ipv6fpi"):
                self.num_ipv6fpi = value
                self.num_ipv6fpi.value_namespace = name_space
                self.num_ipv6fpi.value_namespace_prefix = name_space_prefix
            if(value_path == "num-label-fpi"):
                self.num_label_fpi = value
                self.num_label_fpi.value_namespace = name_space
                self.num_label_fpi.value_namespace_prefix = name_space_prefix
            if(value_path == "num-pw-list-tefpi"):
                self.num_pw_list_tefpi = value
                self.num_pw_list_tefpi.value_namespace = name_space
                self.num_pw_list_tefpi.value_namespace_prefix = name_space_prefix
            if(value_path == "num-rewrite"):
                self.num_rewrite = value
                self.num_rewrite.value_namespace = name_space
                self.num_rewrite.value_namespace_prefix = name_space_prefix
            if(value_path == "num-rewrite-rpf-neighbors"):
                self.num_rewrite_rpf_neighbors = value
                self.num_rewrite_rpf_neighbors.value_namespace = name_space
                self.num_rewrite_rpf_neighbors.value_namespace_prefix = name_space_prefix
            if(value_path == "num-tefpi"):
                self.num_tefpi = value
                self.num_tefpi.value_namespace = name_space
                self.num_tefpi.value_namespace_prefix = name_space_prefix
            if(value_path == "total-dmtc-intf"):
                self.total_dmtc_intf = value
                self.total_dmtc_intf.value_namespace = name_space
                self.total_dmtc_intf.value_namespace_prefix = name_space_prefix
            if(value_path == "total-forwad-update-message"):
                self.total_forwad_update_message = value
                self.total_forwad_update_message.value_namespace = name_space
                self.total_forwad_update_message.value_namespace_prefix = name_space_prefix
            if(value_path == "total-forward-update"):
                self.total_forward_update = value
                self.total_forward_update.value_namespace = name_space
                self.total_forward_update.value_namespace_prefix = name_space_prefix
            if(value_path == "total-ip-sub-paths"):
                self.total_ip_sub_paths = value
                self.total_ip_sub_paths.value_namespace = name_space
                self.total_ip_sub_paths.value_namespace_prefix = name_space_prefix
            if(value_path == "total-ipv4rpf-neighbors"):
                self.total_ipv4rpf_neighbors = value
                self.total_ipv4rpf_neighbors.value_namespace = name_space
                self.total_ipv4rpf_neighbors.value_namespace_prefix = name_space_prefix
            if(value_path == "total-ipv6rpf-neighbors"):
                self.total_ipv6rpf_neighbors = value
                self.total_ipv6rpf_neighbors.value_namespace = name_space
                self.total_ipv6rpf_neighbors.value_namespace_prefix = name_space_prefix
            if(value_path == "total-paths"):
                self.total_paths = value
                self.total_paths.value_namespace = name_space
                self.total_paths.value_namespace_prefix = name_space_prefix
            if(value_path == "total-pw-paths"):
                self.total_pw_paths = value
                self.total_pw_paths.value_namespace = name_space
                self.total_pw_paths.value_namespace_prefix = name_space_prefix
            if(value_path == "total-t-ev4-paths"):
                self.total_t_ev4_paths = value
                self.total_t_ev4_paths.value_namespace = name_space
                self.total_t_ev4_paths.value_namespace_prefix = name_space_prefix
            if(value_path == "total-te-head-paths"):
                self.total_te_head_paths = value
                self.total_te_head_paths.value_namespace = name_space
                self.total_te_head_paths.value_namespace_prefix = name_space_prefix
            if(value_path == "vrf-name-xr"):
                self.vrf_name_xr = value
                self.vrf_name_xr.value_namespace = name_space
                self.vrf_name_xr.value_namespace_prefix = name_space_prefix


    class Applications(Entity):
        """
        Table of MPLS applications using LSD
        
        .. attribute:: application
        
        	Data for MPLS application using LSD
        	**type**\: list of    :py:class:`Application <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Applications.Application>`
        
        

        """

        _prefix = 'mpls-lsd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLsd.Applications, self).__init__()

            self.yang_name = "applications"
            self.yang_parent_name = "mpls-lsd"

            self.application = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLsd.Applications, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLsd.Applications, self).__setattr__(name, value)


        class Application(Entity):
            """
            Data for MPLS application using LSD
            
            .. attribute:: application_name  <key>
            
            	Application Instance name in the form of '<app\_type\_name>[\:<instance>]'
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: app_disconnect_time
            
            	App disconnect ts
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: app_flow_controlled
            
            	App flow control status
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: app_reg_time
            
            	App reg ts
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: application_instance
            
            	client\-app instance
            	**type**\:  str
            
            .. attribute:: application_name_xr
            
            	Application name
            	**type**\:  str
            
            .. attribute:: application_role_primary
            
            	Primary/Backup role
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: application_state
            
            	Application state
            	**type**\:   :py:class:`MgmtLsdAppState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppState>`
            
            .. attribute:: application_statistics
            
            	Application Statistics
            	**type**\:   :py:class:`ApplicationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Applications.Application.ApplicationStatistics>`
            
            .. attribute:: application_type
            
            	Application type
            	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
            
            .. attribute:: flow_ctrl_clr_time
            
            	Flow Ctrl Clr ts
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: flow_ctrl_time
            
            	Flow Ctrl ts
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: go_act_ts
            
            	App go active timestamp
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: node_id
            
            	Node ID where application is/was running
            	**type**\:  str
            
            	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
            
            .. attribute:: recovery_time_elapsed_seconds
            
            	Recovery time [secs] elapsed if client is timing out
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: recovery_time_register_seconds
            
            	Recovery time [secs] specified at registration or set explicitly
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: recovery_time_remaining_seconds
            
            	Recovery time [secs] remaining if client is timing out
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.Applications.Application, self).__init__()

                self.yang_name = "application"
                self.yang_parent_name = "applications"

                self.application_name = YLeaf(YType.str, "application-name")

                self.app_disconnect_time = YLeaf(YType.uint64, "app-disconnect-time")

                self.app_flow_controlled = YLeaf(YType.int32, "app-flow-controlled")

                self.app_reg_time = YLeaf(YType.uint64, "app-reg-time")

                self.application_instance = YLeaf(YType.str, "application-instance")

                self.application_name_xr = YLeaf(YType.str, "application-name-xr")

                self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                self.application_state = YLeaf(YType.enumeration, "application-state")

                self.application_type = YLeaf(YType.enumeration, "application-type")

                self.flow_ctrl_clr_time = YLeaf(YType.uint64, "flow-ctrl-clr-time")

                self.flow_ctrl_time = YLeaf(YType.uint64, "flow-ctrl-time")

                self.go_act_ts = YLeaf(YType.uint64, "go-act-ts")

                self.node_id = YLeaf(YType.str, "node-id")

                self.recovery_time_elapsed_seconds = YLeaf(YType.uint32, "recovery-time-elapsed-seconds")

                self.recovery_time_register_seconds = YLeaf(YType.uint32, "recovery-time-register-seconds")

                self.recovery_time_remaining_seconds = YLeaf(YType.uint32, "recovery-time-remaining-seconds")

                self.application_statistics = MplsLsd.Applications.Application.ApplicationStatistics()
                self.application_statistics.parent = self
                self._children_name_map["application_statistics"] = "application-statistics"
                self._children_yang_names.add("application-statistics")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("application_name",
                                "app_disconnect_time",
                                "app_flow_controlled",
                                "app_reg_time",
                                "application_instance",
                                "application_name_xr",
                                "application_role_primary",
                                "application_state",
                                "application_type",
                                "flow_ctrl_clr_time",
                                "flow_ctrl_time",
                                "go_act_ts",
                                "node_id",
                                "recovery_time_elapsed_seconds",
                                "recovery_time_register_seconds",
                                "recovery_time_remaining_seconds") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.Applications.Application, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.Applications.Application, self).__setattr__(name, value)


            class ApplicationStatistics(Entity):
                """
                Application Statistics
                
                .. attribute:: connect_count
                
                	Connect count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: connected
                
                	Connected statistics
                	**type**\:   :py:class:`Connected <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Applications.Application.ApplicationStatistics.Connected>`
                
                .. attribute:: interface_enable
                
                	Number of interface enabled
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: interface_enable_pending
                
                	Number of interface enable pending
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: label_context_count
                
                	Label context count
                	**type**\:  list of int
                
                	**range:** 0..4294967295
                
                .. attribute:: label_context_pending_count
                
                	Label context pending count
                	**type**\:  list of int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.Applications.Application.ApplicationStatistics, self).__init__()

                    self.yang_name = "application-statistics"
                    self.yang_parent_name = "application"

                    self.connect_count = YLeaf(YType.uint32, "connect-count")

                    self.interface_enable = YLeaf(YType.uint32, "interface-enable")

                    self.interface_enable_pending = YLeaf(YType.uint32, "interface-enable-pending")

                    self.label_context_count = YLeafList(YType.uint32, "label-context-count")

                    self.label_context_pending_count = YLeafList(YType.uint32, "label-context-pending-count")

                    self.connected = MplsLsd.Applications.Application.ApplicationStatistics.Connected()
                    self.connected.parent = self
                    self._children_name_map["connected"] = "connected"
                    self._children_yang_names.add("connected")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("connect_count",
                                    "interface_enable",
                                    "interface_enable_pending",
                                    "label_context_count",
                                    "label_context_pending_count") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.Applications.Application.ApplicationStatistics, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.Applications.Application.ApplicationStatistics, self).__setattr__(name, value)


                class Connected(Entity):
                    """
                    Connected statistics
                    
                    .. attribute:: error_msg_count
                    
                    	Error count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: oor_label_count
                    
                    	Label OOR count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: operation_msg_count
                    
                    	Operation count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rt_set_msg_count
                    
                    	RT set count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-lsd-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLsd.Applications.Application.ApplicationStatistics.Connected, self).__init__()

                        self.yang_name = "connected"
                        self.yang_parent_name = "application-statistics"

                        self.error_msg_count = YLeaf(YType.uint32, "error-msg-count")

                        self.oor_label_count = YLeaf(YType.uint32, "oor-label-count")

                        self.operation_msg_count = YLeaf(YType.uint32, "operation-msg-count")

                        self.rt_set_msg_count = YLeaf(YType.uint32, "rt-set-msg-count")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("error_msg_count",
                                        "oor_label_count",
                                        "operation_msg_count",
                                        "rt_set_msg_count") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLsd.Applications.Application.ApplicationStatistics.Connected, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLsd.Applications.Application.ApplicationStatistics.Connected, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.error_msg_count.is_set or
                            self.oor_label_count.is_set or
                            self.operation_msg_count.is_set or
                            self.rt_set_msg_count.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.error_msg_count.yfilter != YFilter.not_set or
                            self.oor_label_count.yfilter != YFilter.not_set or
                            self.operation_msg_count.yfilter != YFilter.not_set or
                            self.rt_set_msg_count.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "connected" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.error_msg_count.is_set or self.error_msg_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.error_msg_count.get_name_leafdata())
                        if (self.oor_label_count.is_set or self.oor_label_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.oor_label_count.get_name_leafdata())
                        if (self.operation_msg_count.is_set or self.operation_msg_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.operation_msg_count.get_name_leafdata())
                        if (self.rt_set_msg_count.is_set or self.rt_set_msg_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rt_set_msg_count.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "error-msg-count" or name == "oor-label-count" or name == "operation-msg-count" or name == "rt-set-msg-count"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "error-msg-count"):
                            self.error_msg_count = value
                            self.error_msg_count.value_namespace = name_space
                            self.error_msg_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "oor-label-count"):
                            self.oor_label_count = value
                            self.oor_label_count.value_namespace = name_space
                            self.oor_label_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "operation-msg-count"):
                            self.operation_msg_count = value
                            self.operation_msg_count.value_namespace = name_space
                            self.operation_msg_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "rt-set-msg-count"):
                            self.rt_set_msg_count = value
                            self.rt_set_msg_count.value_namespace = name_space
                            self.rt_set_msg_count.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for leaf in self.label_context_count.getYLeafs():
                        if (leaf.yfilter != YFilter.not_set):
                            return True
                    for leaf in self.label_context_pending_count.getYLeafs():
                        if (leaf.yfilter != YFilter.not_set):
                            return True
                    return (
                        self.connect_count.is_set or
                        self.interface_enable.is_set or
                        self.interface_enable_pending.is_set or
                        (self.connected is not None and self.connected.has_data()))

                def has_operation(self):
                    for leaf in self.label_context_count.getYLeafs():
                        if (leaf.is_set):
                            return True
                    for leaf in self.label_context_pending_count.getYLeafs():
                        if (leaf.is_set):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.connect_count.yfilter != YFilter.not_set or
                        self.interface_enable.yfilter != YFilter.not_set or
                        self.interface_enable_pending.yfilter != YFilter.not_set or
                        self.label_context_count.yfilter != YFilter.not_set or
                        self.label_context_pending_count.yfilter != YFilter.not_set or
                        (self.connected is not None and self.connected.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "application-statistics" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.connect_count.is_set or self.connect_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.connect_count.get_name_leafdata())
                    if (self.interface_enable.is_set or self.interface_enable.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_enable.get_name_leafdata())
                    if (self.interface_enable_pending.is_set or self.interface_enable_pending.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_enable_pending.get_name_leafdata())

                    leaf_name_data.extend(self.label_context_count.get_name_leafdata())

                    leaf_name_data.extend(self.label_context_pending_count.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "connected"):
                        if (self.connected is None):
                            self.connected = MplsLsd.Applications.Application.ApplicationStatistics.Connected()
                            self.connected.parent = self
                            self._children_name_map["connected"] = "connected"
                        return self.connected

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "connected" or name == "connect-count" or name == "interface-enable" or name == "interface-enable-pending" or name == "label-context-count" or name == "label-context-pending-count"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "connect-count"):
                        self.connect_count = value
                        self.connect_count.value_namespace = name_space
                        self.connect_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-enable"):
                        self.interface_enable = value
                        self.interface_enable.value_namespace = name_space
                        self.interface_enable.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-enable-pending"):
                        self.interface_enable_pending = value
                        self.interface_enable_pending.value_namespace = name_space
                        self.interface_enable_pending.value_namespace_prefix = name_space_prefix
                    if(value_path == "label-context-count"):
                        self.label_context_count.append(value)
                    if(value_path == "label-context-pending-count"):
                        self.label_context_pending_count.append(value)

            def has_data(self):
                return (
                    self.application_name.is_set or
                    self.app_disconnect_time.is_set or
                    self.app_flow_controlled.is_set or
                    self.app_reg_time.is_set or
                    self.application_instance.is_set or
                    self.application_name_xr.is_set or
                    self.application_role_primary.is_set or
                    self.application_state.is_set or
                    self.application_type.is_set or
                    self.flow_ctrl_clr_time.is_set or
                    self.flow_ctrl_time.is_set or
                    self.go_act_ts.is_set or
                    self.node_id.is_set or
                    self.recovery_time_elapsed_seconds.is_set or
                    self.recovery_time_register_seconds.is_set or
                    self.recovery_time_remaining_seconds.is_set or
                    (self.application_statistics is not None and self.application_statistics.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.application_name.yfilter != YFilter.not_set or
                    self.app_disconnect_time.yfilter != YFilter.not_set or
                    self.app_flow_controlled.yfilter != YFilter.not_set or
                    self.app_reg_time.yfilter != YFilter.not_set or
                    self.application_instance.yfilter != YFilter.not_set or
                    self.application_name_xr.yfilter != YFilter.not_set or
                    self.application_role_primary.yfilter != YFilter.not_set or
                    self.application_state.yfilter != YFilter.not_set or
                    self.application_type.yfilter != YFilter.not_set or
                    self.flow_ctrl_clr_time.yfilter != YFilter.not_set or
                    self.flow_ctrl_time.yfilter != YFilter.not_set or
                    self.go_act_ts.yfilter != YFilter.not_set or
                    self.node_id.yfilter != YFilter.not_set or
                    self.recovery_time_elapsed_seconds.yfilter != YFilter.not_set or
                    self.recovery_time_register_seconds.yfilter != YFilter.not_set or
                    self.recovery_time_remaining_seconds.yfilter != YFilter.not_set or
                    (self.application_statistics is not None and self.application_statistics.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "application" + "[application-name='" + self.application_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/applications/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_name.get_name_leafdata())
                if (self.app_disconnect_time.is_set or self.app_disconnect_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.app_disconnect_time.get_name_leafdata())
                if (self.app_flow_controlled.is_set or self.app_flow_controlled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.app_flow_controlled.get_name_leafdata())
                if (self.app_reg_time.is_set or self.app_reg_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.app_reg_time.get_name_leafdata())
                if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_instance.get_name_leafdata())
                if (self.application_name_xr.is_set or self.application_name_xr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_name_xr.get_name_leafdata())
                if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                if (self.application_state.is_set or self.application_state.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_state.get_name_leafdata())
                if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_type.get_name_leafdata())
                if (self.flow_ctrl_clr_time.is_set or self.flow_ctrl_clr_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.flow_ctrl_clr_time.get_name_leafdata())
                if (self.flow_ctrl_time.is_set or self.flow_ctrl_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.flow_ctrl_time.get_name_leafdata())
                if (self.go_act_ts.is_set or self.go_act_ts.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.go_act_ts.get_name_leafdata())
                if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_id.get_name_leafdata())
                if (self.recovery_time_elapsed_seconds.is_set or self.recovery_time_elapsed_seconds.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.recovery_time_elapsed_seconds.get_name_leafdata())
                if (self.recovery_time_register_seconds.is_set or self.recovery_time_register_seconds.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.recovery_time_register_seconds.get_name_leafdata())
                if (self.recovery_time_remaining_seconds.is_set or self.recovery_time_remaining_seconds.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.recovery_time_remaining_seconds.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "application-statistics"):
                    if (self.application_statistics is None):
                        self.application_statistics = MplsLsd.Applications.Application.ApplicationStatistics()
                        self.application_statistics.parent = self
                        self._children_name_map["application_statistics"] = "application-statistics"
                    return self.application_statistics

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "application-statistics" or name == "application-name" or name == "app-disconnect-time" or name == "app-flow-controlled" or name == "app-reg-time" or name == "application-instance" or name == "application-name-xr" or name == "application-role-primary" or name == "application-state" or name == "application-type" or name == "flow-ctrl-clr-time" or name == "flow-ctrl-time" or name == "go-act-ts" or name == "node-id" or name == "recovery-time-elapsed-seconds" or name == "recovery-time-register-seconds" or name == "recovery-time-remaining-seconds"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "application-name"):
                    self.application_name = value
                    self.application_name.value_namespace = name_space
                    self.application_name.value_namespace_prefix = name_space_prefix
                if(value_path == "app-disconnect-time"):
                    self.app_disconnect_time = value
                    self.app_disconnect_time.value_namespace = name_space
                    self.app_disconnect_time.value_namespace_prefix = name_space_prefix
                if(value_path == "app-flow-controlled"):
                    self.app_flow_controlled = value
                    self.app_flow_controlled.value_namespace = name_space
                    self.app_flow_controlled.value_namespace_prefix = name_space_prefix
                if(value_path == "app-reg-time"):
                    self.app_reg_time = value
                    self.app_reg_time.value_namespace = name_space
                    self.app_reg_time.value_namespace_prefix = name_space_prefix
                if(value_path == "application-instance"):
                    self.application_instance = value
                    self.application_instance.value_namespace = name_space
                    self.application_instance.value_namespace_prefix = name_space_prefix
                if(value_path == "application-name-xr"):
                    self.application_name_xr = value
                    self.application_name_xr.value_namespace = name_space
                    self.application_name_xr.value_namespace_prefix = name_space_prefix
                if(value_path == "application-role-primary"):
                    self.application_role_primary = value
                    self.application_role_primary.value_namespace = name_space
                    self.application_role_primary.value_namespace_prefix = name_space_prefix
                if(value_path == "application-state"):
                    self.application_state = value
                    self.application_state.value_namespace = name_space
                    self.application_state.value_namespace_prefix = name_space_prefix
                if(value_path == "application-type"):
                    self.application_type = value
                    self.application_type.value_namespace = name_space
                    self.application_type.value_namespace_prefix = name_space_prefix
                if(value_path == "flow-ctrl-clr-time"):
                    self.flow_ctrl_clr_time = value
                    self.flow_ctrl_clr_time.value_namespace = name_space
                    self.flow_ctrl_clr_time.value_namespace_prefix = name_space_prefix
                if(value_path == "flow-ctrl-time"):
                    self.flow_ctrl_time = value
                    self.flow_ctrl_time.value_namespace = name_space
                    self.flow_ctrl_time.value_namespace_prefix = name_space_prefix
                if(value_path == "go-act-ts"):
                    self.go_act_ts = value
                    self.go_act_ts.value_namespace = name_space
                    self.go_act_ts.value_namespace_prefix = name_space_prefix
                if(value_path == "node-id"):
                    self.node_id = value
                    self.node_id.value_namespace = name_space
                    self.node_id.value_namespace_prefix = name_space_prefix
                if(value_path == "recovery-time-elapsed-seconds"):
                    self.recovery_time_elapsed_seconds = value
                    self.recovery_time_elapsed_seconds.value_namespace = name_space
                    self.recovery_time_elapsed_seconds.value_namespace_prefix = name_space_prefix
                if(value_path == "recovery-time-register-seconds"):
                    self.recovery_time_register_seconds = value
                    self.recovery_time_register_seconds.value_namespace = name_space
                    self.recovery_time_register_seconds.value_namespace_prefix = name_space_prefix
                if(value_path == "recovery-time-remaining-seconds"):
                    self.recovery_time_remaining_seconds = value
                    self.recovery_time_remaining_seconds.value_namespace = name_space
                    self.recovery_time_remaining_seconds.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.application:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.application:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "applications" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "application"):
                for c in self.application:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLsd.Applications.Application()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.application.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "application"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class LabelSummaryVrfs(Entity):
        """
        Dynamic label range summary by VRF
        
        .. attribute:: label_summary_vrf
        
        	Dynamic label range summary by VRF
        	**type**\: list of    :py:class:`LabelSummaryVrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.LabelSummaryVrfs.LabelSummaryVrf>`
        
        

        """

        _prefix = 'mpls-lsd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLsd.LabelSummaryVrfs, self).__init__()

            self.yang_name = "label-summary-vrfs"
            self.yang_parent_name = "mpls-lsd"

            self.label_summary_vrf = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLsd.LabelSummaryVrfs, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLsd.LabelSummaryVrfs, self).__setattr__(name, value)


        class LabelSummaryVrf(Entity):
            """
            Dynamic label range summary by VRF
            
            .. attribute:: vrf_name  <key>
            
            	VRF name
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: owner_count
            
            	Owner counts
            	**type**\: list of    :py:class:`OwnerCount <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.LabelSummaryVrfs.LabelSummaryVrf.OwnerCount>`
            
            .. attribute:: rsi_connected
            
            	Rsi connected
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: total_labels
            
            	Total labels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: vrf_name_xr
            
            	VRF Name
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.LabelSummaryVrfs.LabelSummaryVrf, self).__init__()

                self.yang_name = "label-summary-vrf"
                self.yang_parent_name = "label-summary-vrfs"

                self.vrf_name = YLeaf(YType.str, "vrf-name")

                self.rsi_connected = YLeaf(YType.int32, "rsi-connected")

                self.total_labels = YLeaf(YType.uint32, "total-labels")

                self.vrf_name_xr = YLeaf(YType.str, "vrf-name-xr")

                self.owner_count = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("vrf_name",
                                "rsi_connected",
                                "total_labels",
                                "vrf_name_xr") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.LabelSummaryVrfs.LabelSummaryVrf, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.LabelSummaryVrfs.LabelSummaryVrf, self).__setattr__(name, value)


            class OwnerCount(Entity):
                """
                Owner counts
                
                .. attribute:: application_instance
                
                	client\-app identifier
                	**type**\:  str
                
                .. attribute:: application_name
                
                	Application name
                	**type**\:  str
                
                .. attribute:: application_role_primary
                
                	Primary/Backup role
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: application_type
                
                	Application type
                	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                
                .. attribute:: number_of_labels
                
                	Number of labels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.LabelSummaryVrfs.LabelSummaryVrf.OwnerCount, self).__init__()

                    self.yang_name = "owner-count"
                    self.yang_parent_name = "label-summary-vrf"

                    self.application_instance = YLeaf(YType.str, "application-instance")

                    self.application_name = YLeaf(YType.str, "application-name")

                    self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                    self.application_type = YLeaf(YType.enumeration, "application-type")

                    self.number_of_labels = YLeaf(YType.uint32, "number-of-labels")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("application_instance",
                                    "application_name",
                                    "application_role_primary",
                                    "application_type",
                                    "number_of_labels") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.LabelSummaryVrfs.LabelSummaryVrf.OwnerCount, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.LabelSummaryVrfs.LabelSummaryVrf.OwnerCount, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.application_instance.is_set or
                        self.application_name.is_set or
                        self.application_role_primary.is_set or
                        self.application_type.is_set or
                        self.number_of_labels.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.application_instance.yfilter != YFilter.not_set or
                        self.application_name.yfilter != YFilter.not_set or
                        self.application_role_primary.yfilter != YFilter.not_set or
                        self.application_type.yfilter != YFilter.not_set or
                        self.number_of_labels.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "owner-count" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_instance.get_name_leafdata())
                    if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_name.get_name_leafdata())
                    if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                    if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_type.get_name_leafdata())
                    if (self.number_of_labels.is_set or self.number_of_labels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_labels.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "number-of-labels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "application-instance"):
                        self.application_instance = value
                        self.application_instance.value_namespace = name_space
                        self.application_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-name"):
                        self.application_name = value
                        self.application_name.value_namespace = name_space
                        self.application_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-role-primary"):
                        self.application_role_primary = value
                        self.application_role_primary.value_namespace = name_space
                        self.application_role_primary.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-type"):
                        self.application_type = value
                        self.application_type.value_namespace = name_space
                        self.application_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-labels"):
                        self.number_of_labels = value
                        self.number_of_labels.value_namespace = name_space
                        self.number_of_labels.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.owner_count:
                    if (c.has_data()):
                        return True
                return (
                    self.vrf_name.is_set or
                    self.rsi_connected.is_set or
                    self.total_labels.is_set or
                    self.vrf_name_xr.is_set)

            def has_operation(self):
                for c in self.owner_count:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.vrf_name.yfilter != YFilter.not_set or
                    self.rsi_connected.yfilter != YFilter.not_set or
                    self.total_labels.yfilter != YFilter.not_set or
                    self.vrf_name_xr.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "label-summary-vrf" + "[vrf-name='" + self.vrf_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/label-summary-vrfs/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.vrf_name.get_name_leafdata())
                if (self.rsi_connected.is_set or self.rsi_connected.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rsi_connected.get_name_leafdata())
                if (self.total_labels.is_set or self.total_labels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_labels.get_name_leafdata())
                if (self.vrf_name_xr.is_set or self.vrf_name_xr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.vrf_name_xr.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "owner-count"):
                    for c in self.owner_count:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsd.LabelSummaryVrfs.LabelSummaryVrf.OwnerCount()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.owner_count.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "owner-count" or name == "vrf-name" or name == "rsi-connected" or name == "total-labels" or name == "vrf-name-xr"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "vrf-name"):
                    self.vrf_name = value
                    self.vrf_name.value_namespace = name_space
                    self.vrf_name.value_namespace_prefix = name_space_prefix
                if(value_path == "rsi-connected"):
                    self.rsi_connected = value
                    self.rsi_connected.value_namespace = name_space
                    self.rsi_connected.value_namespace_prefix = name_space_prefix
                if(value_path == "total-labels"):
                    self.total_labels = value
                    self.total_labels.value_namespace = name_space
                    self.total_labels.value_namespace_prefix = name_space_prefix
                if(value_path == "vrf-name-xr"):
                    self.vrf_name_xr = value
                    self.vrf_name_xr.value_namespace = name_space
                    self.vrf_name_xr.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.label_summary_vrf:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.label_summary_vrf:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "label-summary-vrfs" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "label-summary-vrf"):
                for c in self.label_summary_vrf:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLsd.LabelSummaryVrfs.LabelSummaryVrf()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.label_summary_vrf.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "label-summary-vrf"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class LabelRange(Entity):
        """
        Label range
        
        .. attribute:: max_dynamic_label_value
        
        	Maximum dynamic label value
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: max_static_label_value
        
        	Maximum static label value
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: min_dynamic_label_value
        
        	Minimum dynamic label value
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: min_static_label_value
        
        	Minimum static label value
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        

        """

        _prefix = 'mpls-lsd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLsd.LabelRange, self).__init__()

            self.yang_name = "label-range"
            self.yang_parent_name = "mpls-lsd"

            self.max_dynamic_label_value = YLeaf(YType.uint32, "max-dynamic-label-value")

            self.max_static_label_value = YLeaf(YType.uint32, "max-static-label-value")

            self.min_dynamic_label_value = YLeaf(YType.uint32, "min-dynamic-label-value")

            self.min_static_label_value = YLeaf(YType.uint32, "min-static-label-value")

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("max_dynamic_label_value",
                            "max_static_label_value",
                            "min_dynamic_label_value",
                            "min_static_label_value") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLsd.LabelRange, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLsd.LabelRange, self).__setattr__(name, value)

        def has_data(self):
            return (
                self.max_dynamic_label_value.is_set or
                self.max_static_label_value.is_set or
                self.min_dynamic_label_value.is_set or
                self.min_static_label_value.is_set)

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                self.max_dynamic_label_value.yfilter != YFilter.not_set or
                self.max_static_label_value.yfilter != YFilter.not_set or
                self.min_dynamic_label_value.yfilter != YFilter.not_set or
                self.min_static_label_value.yfilter != YFilter.not_set)

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "label-range" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.max_dynamic_label_value.is_set or self.max_dynamic_label_value.yfilter != YFilter.not_set):
                leaf_name_data.append(self.max_dynamic_label_value.get_name_leafdata())
            if (self.max_static_label_value.is_set or self.max_static_label_value.yfilter != YFilter.not_set):
                leaf_name_data.append(self.max_static_label_value.get_name_leafdata())
            if (self.min_dynamic_label_value.is_set or self.min_dynamic_label_value.yfilter != YFilter.not_set):
                leaf_name_data.append(self.min_dynamic_label_value.get_name_leafdata())
            if (self.min_static_label_value.is_set or self.min_static_label_value.yfilter != YFilter.not_set):
                leaf_name_data.append(self.min_static_label_value.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "max-dynamic-label-value" or name == "max-static-label-value" or name == "min-dynamic-label-value" or name == "min-static-label-value"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "max-dynamic-label-value"):
                self.max_dynamic_label_value = value
                self.max_dynamic_label_value.value_namespace = name_space
                self.max_dynamic_label_value.value_namespace_prefix = name_space_prefix
            if(value_path == "max-static-label-value"):
                self.max_static_label_value = value
                self.max_static_label_value.value_namespace = name_space
                self.max_static_label_value.value_namespace_prefix = name_space_prefix
            if(value_path == "min-dynamic-label-value"):
                self.min_dynamic_label_value = value
                self.min_dynamic_label_value.value_namespace = name_space
                self.min_dynamic_label_value.value_namespace_prefix = name_space_prefix
            if(value_path == "min-static-label-value"):
                self.min_static_label_value = value
                self.min_static_label_value.value_namespace = name_space
                self.min_static_label_value.value_namespace_prefix = name_space_prefix


    class RewriteSummaryVrfs(Entity):
        """
        Rewrite Summary by VRF
        
        .. attribute:: rewrite_summary_vrf
        
        	Rewrite summary by VRF VRF\-name
        	**type**\: list of    :py:class:`RewriteSummaryVrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf>`
        
        

        """

        _prefix = 'mpls-lsd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLsd.RewriteSummaryVrfs, self).__init__()

            self.yang_name = "rewrite-summary-vrfs"
            self.yang_parent_name = "mpls-lsd"

            self.rewrite_summary_vrf = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLsd.RewriteSummaryVrfs, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLsd.RewriteSummaryVrfs, self).__setattr__(name, value)


        class RewriteSummaryVrf(Entity):
            """
            Rewrite summary by VRF VRF\-name
            
            .. attribute:: vrf_name  <key>
            
            	VRF name
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: ipv4_paths
            
            	Count for IPv4 paths
            	**type**\:   :py:class:`Ipv4Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv4Paths>`
            
            .. attribute:: ipv6_paths
            
            	Count for IPv6 paths
            	**type**\:   :py:class:`Ipv6Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv6Paths>`
            
            .. attribute:: num_dmtctefpi
            
            	Number of DMTC FPI
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_ipv4fpi
            
            	Number of IPv4 FPI
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_ipv6fpi
            
            	Number of IPv6 FPI
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_label_fpi
            
            	Number of label FPI
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_pw_list_tefpi
            
            	Number of PW List FPI
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_rewrite
            
            	Number of rewrites
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_rewrite_rpf_neighbors
            
            	Number of rewrites with RPF Neighbors
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: num_tefpi
            
            	Number of TE FPI
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_dmtc_intf
            
            	Total number of DMTC External Interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_forwad_update_message
            
            	Total number of forward update messages
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_forward_update
            
            	Total number of forward updates
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_ip_sub_paths
            
            	Total number of IP Subscriber paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_ipv4rpf_neighbors
            
            	Total number of IPv4 RPF Neighbors
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_ipv6rpf_neighbors
            
            	Total number of IPv6 RPF Neighbors
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_paths
            
            	Total paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_pw_paths
            
            	Total number of Pseudo\-wire paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_t_ev4_paths
            
            	Total number of Traffic Eng IPv4 paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_te_head_paths
            
            	Total number of Traffic Eng Head paths
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: vrf_name_xr
            
            	VRF Name
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf, self).__init__()

                self.yang_name = "rewrite-summary-vrf"
                self.yang_parent_name = "rewrite-summary-vrfs"

                self.vrf_name = YLeaf(YType.str, "vrf-name")

                self.num_dmtctefpi = YLeaf(YType.uint32, "num-dmtctefpi")

                self.num_ipv4fpi = YLeaf(YType.uint32, "num-ipv4fpi")

                self.num_ipv6fpi = YLeaf(YType.uint32, "num-ipv6fpi")

                self.num_label_fpi = YLeaf(YType.uint32, "num-label-fpi")

                self.num_pw_list_tefpi = YLeaf(YType.uint32, "num-pw-list-tefpi")

                self.num_rewrite = YLeaf(YType.uint32, "num-rewrite")

                self.num_rewrite_rpf_neighbors = YLeaf(YType.uint32, "num-rewrite-rpf-neighbors")

                self.num_tefpi = YLeaf(YType.uint32, "num-tefpi")

                self.total_dmtc_intf = YLeaf(YType.uint32, "total-dmtc-intf")

                self.total_forwad_update_message = YLeaf(YType.uint32, "total-forwad-update-message")

                self.total_forward_update = YLeaf(YType.uint32, "total-forward-update")

                self.total_ip_sub_paths = YLeaf(YType.uint32, "total-ip-sub-paths")

                self.total_ipv4rpf_neighbors = YLeaf(YType.uint32, "total-ipv4rpf-neighbors")

                self.total_ipv6rpf_neighbors = YLeaf(YType.uint32, "total-ipv6rpf-neighbors")

                self.total_paths = YLeaf(YType.uint32, "total-paths")

                self.total_pw_paths = YLeaf(YType.uint32, "total-pw-paths")

                self.total_t_ev4_paths = YLeaf(YType.uint32, "total-t-ev4-paths")

                self.total_te_head_paths = YLeaf(YType.uint32, "total-te-head-paths")

                self.vrf_name_xr = YLeaf(YType.str, "vrf-name-xr")

                self.ipv4_paths = MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv4Paths()
                self.ipv4_paths.parent = self
                self._children_name_map["ipv4_paths"] = "ipv4-paths"
                self._children_yang_names.add("ipv4-paths")

                self.ipv6_paths = MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv6Paths()
                self.ipv6_paths.parent = self
                self._children_name_map["ipv6_paths"] = "ipv6-paths"
                self._children_yang_names.add("ipv6-paths")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("vrf_name",
                                "num_dmtctefpi",
                                "num_ipv4fpi",
                                "num_ipv6fpi",
                                "num_label_fpi",
                                "num_pw_list_tefpi",
                                "num_rewrite",
                                "num_rewrite_rpf_neighbors",
                                "num_tefpi",
                                "total_dmtc_intf",
                                "total_forwad_update_message",
                                "total_forward_update",
                                "total_ip_sub_paths",
                                "total_ipv4rpf_neighbors",
                                "total_ipv6rpf_neighbors",
                                "total_paths",
                                "total_pw_paths",
                                "total_t_ev4_paths",
                                "total_te_head_paths",
                                "vrf_name_xr") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf, self).__setattr__(name, value)


            class Ipv4Paths(Entity):
                """
                Count for IPv4 paths
                
                .. attribute:: total_backup_paths
                
                	Total number of non\-primary backup paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_paths
                
                	Total number of IP paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_pop_lkup_paths
                
                	Total number of Pop\-and\-Lookup paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_protected_paths
                
                	Total number of protected paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_remote_backup_paths
                
                	Total number of remote backup paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv4Paths, self).__init__()

                    self.yang_name = "ipv4-paths"
                    self.yang_parent_name = "rewrite-summary-vrf"

                    self.total_backup_paths = YLeaf(YType.uint32, "total-backup-paths")

                    self.total_paths = YLeaf(YType.uint32, "total-paths")

                    self.total_pop_lkup_paths = YLeaf(YType.uint32, "total-pop-lkup-paths")

                    self.total_protected_paths = YLeaf(YType.uint32, "total-protected-paths")

                    self.total_remote_backup_paths = YLeaf(YType.uint32, "total-remote-backup-paths")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("total_backup_paths",
                                    "total_paths",
                                    "total_pop_lkup_paths",
                                    "total_protected_paths",
                                    "total_remote_backup_paths") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv4Paths, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv4Paths, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.total_backup_paths.is_set or
                        self.total_paths.is_set or
                        self.total_pop_lkup_paths.is_set or
                        self.total_protected_paths.is_set or
                        self.total_remote_backup_paths.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.total_backup_paths.yfilter != YFilter.not_set or
                        self.total_paths.yfilter != YFilter.not_set or
                        self.total_pop_lkup_paths.yfilter != YFilter.not_set or
                        self.total_protected_paths.yfilter != YFilter.not_set or
                        self.total_remote_backup_paths.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "ipv4-paths" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.total_backup_paths.is_set or self.total_backup_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_backup_paths.get_name_leafdata())
                    if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_paths.get_name_leafdata())
                    if (self.total_pop_lkup_paths.is_set or self.total_pop_lkup_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_pop_lkup_paths.get_name_leafdata())
                    if (self.total_protected_paths.is_set or self.total_protected_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_protected_paths.get_name_leafdata())
                    if (self.total_remote_backup_paths.is_set or self.total_remote_backup_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_remote_backup_paths.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "total-backup-paths" or name == "total-paths" or name == "total-pop-lkup-paths" or name == "total-protected-paths" or name == "total-remote-backup-paths"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "total-backup-paths"):
                        self.total_backup_paths = value
                        self.total_backup_paths.value_namespace = name_space
                        self.total_backup_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-paths"):
                        self.total_paths = value
                        self.total_paths.value_namespace = name_space
                        self.total_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-pop-lkup-paths"):
                        self.total_pop_lkup_paths = value
                        self.total_pop_lkup_paths.value_namespace = name_space
                        self.total_pop_lkup_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-protected-paths"):
                        self.total_protected_paths = value
                        self.total_protected_paths.value_namespace = name_space
                        self.total_protected_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-remote-backup-paths"):
                        self.total_remote_backup_paths = value
                        self.total_remote_backup_paths.value_namespace = name_space
                        self.total_remote_backup_paths.value_namespace_prefix = name_space_prefix


            class Ipv6Paths(Entity):
                """
                Count for IPv6 paths
                
                .. attribute:: total_backup_paths
                
                	Total number of non\-primary backup paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_paths
                
                	Total number of IP paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_pop_lkup_paths
                
                	Total number of Pop\-and\-Lookup paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_protected_paths
                
                	Total number of protected paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_remote_backup_paths
                
                	Total number of remote backup paths
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv6Paths, self).__init__()

                    self.yang_name = "ipv6-paths"
                    self.yang_parent_name = "rewrite-summary-vrf"

                    self.total_backup_paths = YLeaf(YType.uint32, "total-backup-paths")

                    self.total_paths = YLeaf(YType.uint32, "total-paths")

                    self.total_pop_lkup_paths = YLeaf(YType.uint32, "total-pop-lkup-paths")

                    self.total_protected_paths = YLeaf(YType.uint32, "total-protected-paths")

                    self.total_remote_backup_paths = YLeaf(YType.uint32, "total-remote-backup-paths")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("total_backup_paths",
                                    "total_paths",
                                    "total_pop_lkup_paths",
                                    "total_protected_paths",
                                    "total_remote_backup_paths") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv6Paths, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv6Paths, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.total_backup_paths.is_set or
                        self.total_paths.is_set or
                        self.total_pop_lkup_paths.is_set or
                        self.total_protected_paths.is_set or
                        self.total_remote_backup_paths.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.total_backup_paths.yfilter != YFilter.not_set or
                        self.total_paths.yfilter != YFilter.not_set or
                        self.total_pop_lkup_paths.yfilter != YFilter.not_set or
                        self.total_protected_paths.yfilter != YFilter.not_set or
                        self.total_remote_backup_paths.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "ipv6-paths" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.total_backup_paths.is_set or self.total_backup_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_backup_paths.get_name_leafdata())
                    if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_paths.get_name_leafdata())
                    if (self.total_pop_lkup_paths.is_set or self.total_pop_lkup_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_pop_lkup_paths.get_name_leafdata())
                    if (self.total_protected_paths.is_set or self.total_protected_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_protected_paths.get_name_leafdata())
                    if (self.total_remote_backup_paths.is_set or self.total_remote_backup_paths.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_remote_backup_paths.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "total-backup-paths" or name == "total-paths" or name == "total-pop-lkup-paths" or name == "total-protected-paths" or name == "total-remote-backup-paths"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "total-backup-paths"):
                        self.total_backup_paths = value
                        self.total_backup_paths.value_namespace = name_space
                        self.total_backup_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-paths"):
                        self.total_paths = value
                        self.total_paths.value_namespace = name_space
                        self.total_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-pop-lkup-paths"):
                        self.total_pop_lkup_paths = value
                        self.total_pop_lkup_paths.value_namespace = name_space
                        self.total_pop_lkup_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-protected-paths"):
                        self.total_protected_paths = value
                        self.total_protected_paths.value_namespace = name_space
                        self.total_protected_paths.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-remote-backup-paths"):
                        self.total_remote_backup_paths = value
                        self.total_remote_backup_paths.value_namespace = name_space
                        self.total_remote_backup_paths.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.vrf_name.is_set or
                    self.num_dmtctefpi.is_set or
                    self.num_ipv4fpi.is_set or
                    self.num_ipv6fpi.is_set or
                    self.num_label_fpi.is_set or
                    self.num_pw_list_tefpi.is_set or
                    self.num_rewrite.is_set or
                    self.num_rewrite_rpf_neighbors.is_set or
                    self.num_tefpi.is_set or
                    self.total_dmtc_intf.is_set or
                    self.total_forwad_update_message.is_set or
                    self.total_forward_update.is_set or
                    self.total_ip_sub_paths.is_set or
                    self.total_ipv4rpf_neighbors.is_set or
                    self.total_ipv6rpf_neighbors.is_set or
                    self.total_paths.is_set or
                    self.total_pw_paths.is_set or
                    self.total_t_ev4_paths.is_set or
                    self.total_te_head_paths.is_set or
                    self.vrf_name_xr.is_set or
                    (self.ipv4_paths is not None and self.ipv4_paths.has_data()) or
                    (self.ipv6_paths is not None and self.ipv6_paths.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.vrf_name.yfilter != YFilter.not_set or
                    self.num_dmtctefpi.yfilter != YFilter.not_set or
                    self.num_ipv4fpi.yfilter != YFilter.not_set or
                    self.num_ipv6fpi.yfilter != YFilter.not_set or
                    self.num_label_fpi.yfilter != YFilter.not_set or
                    self.num_pw_list_tefpi.yfilter != YFilter.not_set or
                    self.num_rewrite.yfilter != YFilter.not_set or
                    self.num_rewrite_rpf_neighbors.yfilter != YFilter.not_set or
                    self.num_tefpi.yfilter != YFilter.not_set or
                    self.total_dmtc_intf.yfilter != YFilter.not_set or
                    self.total_forwad_update_message.yfilter != YFilter.not_set or
                    self.total_forward_update.yfilter != YFilter.not_set or
                    self.total_ip_sub_paths.yfilter != YFilter.not_set or
                    self.total_ipv4rpf_neighbors.yfilter != YFilter.not_set or
                    self.total_ipv6rpf_neighbors.yfilter != YFilter.not_set or
                    self.total_paths.yfilter != YFilter.not_set or
                    self.total_pw_paths.yfilter != YFilter.not_set or
                    self.total_t_ev4_paths.yfilter != YFilter.not_set or
                    self.total_te_head_paths.yfilter != YFilter.not_set or
                    self.vrf_name_xr.yfilter != YFilter.not_set or
                    (self.ipv4_paths is not None and self.ipv4_paths.has_operation()) or
                    (self.ipv6_paths is not None and self.ipv6_paths.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "rewrite-summary-vrf" + "[vrf-name='" + self.vrf_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/rewrite-summary-vrfs/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.vrf_name.get_name_leafdata())
                if (self.num_dmtctefpi.is_set or self.num_dmtctefpi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_dmtctefpi.get_name_leafdata())
                if (self.num_ipv4fpi.is_set or self.num_ipv4fpi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_ipv4fpi.get_name_leafdata())
                if (self.num_ipv6fpi.is_set or self.num_ipv6fpi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_ipv6fpi.get_name_leafdata())
                if (self.num_label_fpi.is_set or self.num_label_fpi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_label_fpi.get_name_leafdata())
                if (self.num_pw_list_tefpi.is_set or self.num_pw_list_tefpi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_pw_list_tefpi.get_name_leafdata())
                if (self.num_rewrite.is_set or self.num_rewrite.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_rewrite.get_name_leafdata())
                if (self.num_rewrite_rpf_neighbors.is_set or self.num_rewrite_rpf_neighbors.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_rewrite_rpf_neighbors.get_name_leafdata())
                if (self.num_tefpi.is_set or self.num_tefpi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.num_tefpi.get_name_leafdata())
                if (self.total_dmtc_intf.is_set or self.total_dmtc_intf.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_dmtc_intf.get_name_leafdata())
                if (self.total_forwad_update_message.is_set or self.total_forwad_update_message.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_forwad_update_message.get_name_leafdata())
                if (self.total_forward_update.is_set or self.total_forward_update.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_forward_update.get_name_leafdata())
                if (self.total_ip_sub_paths.is_set or self.total_ip_sub_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_ip_sub_paths.get_name_leafdata())
                if (self.total_ipv4rpf_neighbors.is_set or self.total_ipv4rpf_neighbors.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_ipv4rpf_neighbors.get_name_leafdata())
                if (self.total_ipv6rpf_neighbors.is_set or self.total_ipv6rpf_neighbors.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_ipv6rpf_neighbors.get_name_leafdata())
                if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_paths.get_name_leafdata())
                if (self.total_pw_paths.is_set or self.total_pw_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_pw_paths.get_name_leafdata())
                if (self.total_t_ev4_paths.is_set or self.total_t_ev4_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_t_ev4_paths.get_name_leafdata())
                if (self.total_te_head_paths.is_set or self.total_te_head_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_te_head_paths.get_name_leafdata())
                if (self.vrf_name_xr.is_set or self.vrf_name_xr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.vrf_name_xr.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "ipv4-paths"):
                    if (self.ipv4_paths is None):
                        self.ipv4_paths = MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv4Paths()
                        self.ipv4_paths.parent = self
                        self._children_name_map["ipv4_paths"] = "ipv4-paths"
                    return self.ipv4_paths

                if (child_yang_name == "ipv6-paths"):
                    if (self.ipv6_paths is None):
                        self.ipv6_paths = MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf.Ipv6Paths()
                        self.ipv6_paths.parent = self
                        self._children_name_map["ipv6_paths"] = "ipv6-paths"
                    return self.ipv6_paths

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "ipv4-paths" or name == "ipv6-paths" or name == "vrf-name" or name == "num-dmtctefpi" or name == "num-ipv4fpi" or name == "num-ipv6fpi" or name == "num-label-fpi" or name == "num-pw-list-tefpi" or name == "num-rewrite" or name == "num-rewrite-rpf-neighbors" or name == "num-tefpi" or name == "total-dmtc-intf" or name == "total-forwad-update-message" or name == "total-forward-update" or name == "total-ip-sub-paths" or name == "total-ipv4rpf-neighbors" or name == "total-ipv6rpf-neighbors" or name == "total-paths" or name == "total-pw-paths" or name == "total-t-ev4-paths" or name == "total-te-head-paths" or name == "vrf-name-xr"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "vrf-name"):
                    self.vrf_name = value
                    self.vrf_name.value_namespace = name_space
                    self.vrf_name.value_namespace_prefix = name_space_prefix
                if(value_path == "num-dmtctefpi"):
                    self.num_dmtctefpi = value
                    self.num_dmtctefpi.value_namespace = name_space
                    self.num_dmtctefpi.value_namespace_prefix = name_space_prefix
                if(value_path == "num-ipv4fpi"):
                    self.num_ipv4fpi = value
                    self.num_ipv4fpi.value_namespace = name_space
                    self.num_ipv4fpi.value_namespace_prefix = name_space_prefix
                if(value_path == "num-ipv6fpi"):
                    self.num_ipv6fpi = value
                    self.num_ipv6fpi.value_namespace = name_space
                    self.num_ipv6fpi.value_namespace_prefix = name_space_prefix
                if(value_path == "num-label-fpi"):
                    self.num_label_fpi = value
                    self.num_label_fpi.value_namespace = name_space
                    self.num_label_fpi.value_namespace_prefix = name_space_prefix
                if(value_path == "num-pw-list-tefpi"):
                    self.num_pw_list_tefpi = value
                    self.num_pw_list_tefpi.value_namespace = name_space
                    self.num_pw_list_tefpi.value_namespace_prefix = name_space_prefix
                if(value_path == "num-rewrite"):
                    self.num_rewrite = value
                    self.num_rewrite.value_namespace = name_space
                    self.num_rewrite.value_namespace_prefix = name_space_prefix
                if(value_path == "num-rewrite-rpf-neighbors"):
                    self.num_rewrite_rpf_neighbors = value
                    self.num_rewrite_rpf_neighbors.value_namespace = name_space
                    self.num_rewrite_rpf_neighbors.value_namespace_prefix = name_space_prefix
                if(value_path == "num-tefpi"):
                    self.num_tefpi = value
                    self.num_tefpi.value_namespace = name_space
                    self.num_tefpi.value_namespace_prefix = name_space_prefix
                if(value_path == "total-dmtc-intf"):
                    self.total_dmtc_intf = value
                    self.total_dmtc_intf.value_namespace = name_space
                    self.total_dmtc_intf.value_namespace_prefix = name_space_prefix
                if(value_path == "total-forwad-update-message"):
                    self.total_forwad_update_message = value
                    self.total_forwad_update_message.value_namespace = name_space
                    self.total_forwad_update_message.value_namespace_prefix = name_space_prefix
                if(value_path == "total-forward-update"):
                    self.total_forward_update = value
                    self.total_forward_update.value_namespace = name_space
                    self.total_forward_update.value_namespace_prefix = name_space_prefix
                if(value_path == "total-ip-sub-paths"):
                    self.total_ip_sub_paths = value
                    self.total_ip_sub_paths.value_namespace = name_space
                    self.total_ip_sub_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-ipv4rpf-neighbors"):
                    self.total_ipv4rpf_neighbors = value
                    self.total_ipv4rpf_neighbors.value_namespace = name_space
                    self.total_ipv4rpf_neighbors.value_namespace_prefix = name_space_prefix
                if(value_path == "total-ipv6rpf-neighbors"):
                    self.total_ipv6rpf_neighbors = value
                    self.total_ipv6rpf_neighbors.value_namespace = name_space
                    self.total_ipv6rpf_neighbors.value_namespace_prefix = name_space_prefix
                if(value_path == "total-paths"):
                    self.total_paths = value
                    self.total_paths.value_namespace = name_space
                    self.total_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-pw-paths"):
                    self.total_pw_paths = value
                    self.total_pw_paths.value_namespace = name_space
                    self.total_pw_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-t-ev4-paths"):
                    self.total_t_ev4_paths = value
                    self.total_t_ev4_paths.value_namespace = name_space
                    self.total_t_ev4_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "total-te-head-paths"):
                    self.total_te_head_paths = value
                    self.total_te_head_paths.value_namespace = name_space
                    self.total_te_head_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "vrf-name-xr"):
                    self.vrf_name_xr = value
                    self.vrf_name_xr.value_namespace = name_space
                    self.vrf_name_xr.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.rewrite_summary_vrf:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.rewrite_summary_vrf:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "rewrite-summary-vrfs" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "rewrite-summary-vrf"):
                for c in self.rewrite_summary_vrf:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLsd.RewriteSummaryVrfs.RewriteSummaryVrf()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.rewrite_summary_vrf.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "rewrite-summary-vrf"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Interfaces(Entity):
        """
        Table of MPLS interfaces
        
        .. attribute:: interface
        
        	Data for MPLS interface
        	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Interfaces.Interface>`
        
        

        """

        _prefix = 'mpls-lsd-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLsd.Interfaces, self).__init__()

            self.yang_name = "interfaces"
            self.yang_parent_name = "mpls-lsd"

            self.interface = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLsd.Interfaces, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLsd.Interfaces, self).__setattr__(name, value)


        class Interface(Entity):
            """
            Data for MPLS interface
            
            .. attribute:: interface_name  <key>
            
            	Interface
            	**type**\:  str
            
            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
            
            .. attribute:: application_owner
            
            	Application Owner
            	**type**\: list of    :py:class:`ApplicationOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MplsLsd.Interfaces.Interface.ApplicationOwner>`
            
            .. attribute:: interface
            
            	Interface
            	**type**\:  str
            
            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
            
            .. attribute:: interface_state
            
            	Interface state
            	**type**\:   :py:class:`MgmtLsdIntfState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdIntfState>`
            
            

            """

            _prefix = 'mpls-lsd-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLsd.Interfaces.Interface, self).__init__()

                self.yang_name = "interface"
                self.yang_parent_name = "interfaces"

                self.interface_name = YLeaf(YType.str, "interface-name")

                self.interface = YLeaf(YType.str, "interface")

                self.interface_state = YLeaf(YType.enumeration, "interface-state")

                self.application_owner = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("interface_name",
                                "interface",
                                "interface_state") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLsd.Interfaces.Interface, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLsd.Interfaces.Interface, self).__setattr__(name, value)


            class ApplicationOwner(Entity):
                """
                Application Owner
                
                .. attribute:: application_instance
                
                	Application instance Name
                	**type**\:  str
                
                .. attribute:: application_name
                
                	Application name
                	**type**\:  str
                
                .. attribute:: application_role_primary
                
                	Primary/Backup role
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: application_type
                
                	Application type
                	**type**\:   :py:class:`MgmtLsdApp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdApp>`
                
                .. attribute:: resource_state
                
                	Application resource state
                	**type**\:   :py:class:`MgmtLsdAppRsrcState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_lsd_oper.MgmtLsdAppRsrcState>`
                
                

                """

                _prefix = 'mpls-lsd-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLsd.Interfaces.Interface.ApplicationOwner, self).__init__()

                    self.yang_name = "application-owner"
                    self.yang_parent_name = "interface"

                    self.application_instance = YLeaf(YType.str, "application-instance")

                    self.application_name = YLeaf(YType.str, "application-name")

                    self.application_role_primary = YLeaf(YType.int32, "application-role-primary")

                    self.application_type = YLeaf(YType.enumeration, "application-type")

                    self.resource_state = YLeaf(YType.enumeration, "resource-state")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("application_instance",
                                    "application_name",
                                    "application_role_primary",
                                    "application_type",
                                    "resource_state") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLsd.Interfaces.Interface.ApplicationOwner, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLsd.Interfaces.Interface.ApplicationOwner, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.application_instance.is_set or
                        self.application_name.is_set or
                        self.application_role_primary.is_set or
                        self.application_type.is_set or
                        self.resource_state.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.application_instance.yfilter != YFilter.not_set or
                        self.application_name.yfilter != YFilter.not_set or
                        self.application_role_primary.yfilter != YFilter.not_set or
                        self.application_type.yfilter != YFilter.not_set or
                        self.resource_state.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "application-owner" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.application_instance.is_set or self.application_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_instance.get_name_leafdata())
                    if (self.application_name.is_set or self.application_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_name.get_name_leafdata())
                    if (self.application_role_primary.is_set or self.application_role_primary.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_role_primary.get_name_leafdata())
                    if (self.application_type.is_set or self.application_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.application_type.get_name_leafdata())
                    if (self.resource_state.is_set or self.resource_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.resource_state.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "application-instance" or name == "application-name" or name == "application-role-primary" or name == "application-type" or name == "resource-state"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "application-instance"):
                        self.application_instance = value
                        self.application_instance.value_namespace = name_space
                        self.application_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-name"):
                        self.application_name = value
                        self.application_name.value_namespace = name_space
                        self.application_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-role-primary"):
                        self.application_role_primary = value
                        self.application_role_primary.value_namespace = name_space
                        self.application_role_primary.value_namespace_prefix = name_space_prefix
                    if(value_path == "application-type"):
                        self.application_type = value
                        self.application_type.value_namespace = name_space
                        self.application_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "resource-state"):
                        self.resource_state = value
                        self.resource_state.value_namespace = name_space
                        self.resource_state.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.application_owner:
                    if (c.has_data()):
                        return True
                return (
                    self.interface_name.is_set or
                    self.interface.is_set or
                    self.interface_state.is_set)

            def has_operation(self):
                for c in self.application_owner:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.interface_name.yfilter != YFilter.not_set or
                    self.interface.yfilter != YFilter.not_set or
                    self.interface_state.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/interfaces/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface.get_name_leafdata())
                if (self.interface_state.is_set or self.interface_state.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface_state.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "application-owner"):
                    for c in self.application_owner:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLsd.Interfaces.Interface.ApplicationOwner()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.application_owner.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "application-owner" or name == "interface-name" or name == "interface" or name == "interface-state"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "interface-name"):
                    self.interface_name = value
                    self.interface_name.value_namespace = name_space
                    self.interface_name.value_namespace_prefix = name_space_prefix
                if(value_path == "interface"):
                    self.interface = value
                    self.interface.value_namespace = name_space
                    self.interface.value_namespace_prefix = name_space_prefix
                if(value_path == "interface-state"):
                    self.interface_state = value
                    self.interface_state.value_namespace = name_space
                    self.interface_state.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.interface:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.interface:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "interfaces" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "interface"):
                for c in self.interface:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLsd.Interfaces.Interface()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.interface.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "interface"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass

    def has_data(self):
        return (
            (self.applications is not None and self.applications.has_data()) or
            (self.clients is not None and self.clients.has_data()) or
            (self.frr_database is not None and self.frr_database.has_data()) or
            (self.interfaces is not None and self.interfaces.has_data()) or
            (self.label_range is not None and self.label_range.has_data()) or
            (self.label_summary is not None and self.label_summary.has_data()) or
            (self.label_summary_vrfs is not None and self.label_summary_vrfs.has_data()) or
            (self.labels is not None and self.labels.has_data()) or
            (self.rewrite is not None and self.rewrite.has_data()) or
            (self.rewrite_summary is not None and self.rewrite_summary.has_data()) or
            (self.rewrite_summary_vrfs is not None and self.rewrite_summary_vrfs.has_data()))

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.applications is not None and self.applications.has_operation()) or
            (self.clients is not None and self.clients.has_operation()) or
            (self.frr_database is not None and self.frr_database.has_operation()) or
            (self.interfaces is not None and self.interfaces.has_operation()) or
            (self.label_range is not None and self.label_range.has_operation()) or
            (self.label_summary is not None and self.label_summary.has_operation()) or
            (self.label_summary_vrfs is not None and self.label_summary_vrfs.has_operation()) or
            (self.labels is not None and self.labels.has_operation()) or
            (self.rewrite is not None and self.rewrite.has_operation()) or
            (self.rewrite_summary is not None and self.rewrite_summary.has_operation()) or
            (self.rewrite_summary_vrfs is not None and self.rewrite_summary_vrfs.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-mpls-lsd-oper:mpls-lsd" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "applications"):
            if (self.applications is None):
                self.applications = MplsLsd.Applications()
                self.applications.parent = self
                self._children_name_map["applications"] = "applications"
            return self.applications

        if (child_yang_name == "clients"):
            if (self.clients is None):
                self.clients = MplsLsd.Clients()
                self.clients.parent = self
                self._children_name_map["clients"] = "clients"
            return self.clients

        if (child_yang_name == "frr-database"):
            if (self.frr_database is None):
                self.frr_database = MplsLsd.FrrDatabase()
                self.frr_database.parent = self
                self._children_name_map["frr_database"] = "frr-database"
            return self.frr_database

        if (child_yang_name == "interfaces"):
            if (self.interfaces is None):
                self.interfaces = MplsLsd.Interfaces()
                self.interfaces.parent = self
                self._children_name_map["interfaces"] = "interfaces"
            return self.interfaces

        if (child_yang_name == "label-range"):
            if (self.label_range is None):
                self.label_range = MplsLsd.LabelRange()
                self.label_range.parent = self
                self._children_name_map["label_range"] = "label-range"
            return self.label_range

        if (child_yang_name == "label-summary"):
            if (self.label_summary is None):
                self.label_summary = MplsLsd.LabelSummary()
                self.label_summary.parent = self
                self._children_name_map["label_summary"] = "label-summary"
            return self.label_summary

        if (child_yang_name == "label-summary-vrfs"):
            if (self.label_summary_vrfs is None):
                self.label_summary_vrfs = MplsLsd.LabelSummaryVrfs()
                self.label_summary_vrfs.parent = self
                self._children_name_map["label_summary_vrfs"] = "label-summary-vrfs"
            return self.label_summary_vrfs

        if (child_yang_name == "labels"):
            if (self.labels is None):
                self.labels = MplsLsd.Labels()
                self.labels.parent = self
                self._children_name_map["labels"] = "labels"
            return self.labels

        if (child_yang_name == "rewrite"):
            if (self.rewrite is None):
                self.rewrite = MplsLsd.Rewrite()
                self.rewrite.parent = self
                self._children_name_map["rewrite"] = "rewrite"
            return self.rewrite

        if (child_yang_name == "rewrite-summary"):
            if (self.rewrite_summary is None):
                self.rewrite_summary = MplsLsd.RewriteSummary()
                self.rewrite_summary.parent = self
                self._children_name_map["rewrite_summary"] = "rewrite-summary"
            return self.rewrite_summary

        if (child_yang_name == "rewrite-summary-vrfs"):
            if (self.rewrite_summary_vrfs is None):
                self.rewrite_summary_vrfs = MplsLsd.RewriteSummaryVrfs()
                self.rewrite_summary_vrfs.parent = self
                self._children_name_map["rewrite_summary_vrfs"] = "rewrite-summary-vrfs"
            return self.rewrite_summary_vrfs

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "applications" or name == "clients" or name == "frr-database" or name == "interfaces" or name == "label-range" or name == "label-summary" or name == "label-summary-vrfs" or name == "labels" or name == "rewrite" or name == "rewrite-summary" or name == "rewrite-summary-vrfs"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = MplsLsd()
        return self._top_entity

